METALWALLS
==========

[![Documentation](https://img.shields.io/badge/docs-latest-brightgreen.svg)](https://gitlab.com/ampere2/metalwalls/-/wikis/home)
[![DOI](https://joss.theoj.org/papers/10.21105/joss.02373/status.svg)](https://doi.org/10.21105/joss.02373)
[![Repository](https://img.shields.io/badge/Zenodo-10.5281/zenodo.4912611-blue)](https://doi.org/10.5281/zenodo.4912611)

MetalWalls (MW) is a molecular dynamics code dedicated to the modelling of electrochemical systems. Its main originality is the inclusion of a series of methods allowing to apply a constant potential within the electrode materials.

**Extended documentation is provided in the [WIKI](https://gitlab.com/ampere2/metalwalls/-/wikis/home) section of the gitlab project.**
Details of the implemented force fields, thermodynamic ensembles and models, a description of the installation process and of input and output files, and guidelines for developers are given in detail.

In the following we reproduce installation instructions. To report bugs or contact the developpers, please raise an issue on the [Gitlab page](https://gitlab.com/ampere2/metalwalls/-/wikis/home).

# Reference

[A. Marin-Laflèche, M. Haefele, L. Scalfi, A. Coretti, T. Dufils, G. Jeanmairet, S. Reed, A. Serva, R. Berthin, C. Bacon, S. Bonella, B. Rotenberg, P.A. Madden, and M. Salanne. MetalWalls: A Classical Molecular Dynamics Software Dedicated to the Simulation of Electrochemical Systems. Journal of Open Source Software, 5, 2373, DOI:10.21105/joss.02373 (2020)](https://dx.doi.org/10.21105/joss.02373)

# Compiling

MW requires a Fortran compiler and the LAPACK library. The installation is based on a Makefile. A few machine dependent variables must be defined in the file *./config.mk* prior to invoking the `make` utility. The structure of the *config.mk* file is as follow:

```make
# Compilation options
F90 := fortran-compiler
F90FLAGS := compilation-flags
FPPFLAGS := preprocessor-flags
LDFLAGS := linker-flags
F2PY := path-to-f2py
F90WRAP := path-to-f90wrap
FCOMPILER := f2py-option (intel, intelem, gnu95...)
J := flag-to-specify-modfiles-output-dir (gnu: -J, intel: -module )

# Path to pFUnit (Unit testing Framework) -- optional
PFUNIT := path-to-pfunit
```

Some examples are provided for common use cases in the *./computers/* directory.
For example to compile MW on a Linux machine with the GNU compiler one can use the following parameters.
Here we assume that the MPI compiler wrapper is in the PATH of the user.

```make
# Compilation options
F90 := mpif90
F90FLAGS := -O2 -g
FPPFLAGS := -cpp
LDFLAGS := -llapack
F2PY := f2py
F90WRAP := f90wrap
FCOMPILER := gnu95
J := -J
# Path to pFUnit (Unit testing Framework)
PFUNIT := /opt/pfunit/pfunit-parallel
```

On a typical cluster with Intel Skylake processors and with Intel compiler
```make
# Compilation options
F90 := mpiifort
F90STDFLAGS := -g
F90OPTFLAGS := -O2 -xCORE-AVX512 -align array64byte
F90REPORTFLAGS :=
F90FLAGS := $(F90STDFLAGS) $(F90OPTFLAGS) $(F90REPORTFLAGS)
FPPFLAGS := -fpp
LDFLAGS := -mkl=cluster
F2PY := f2py
F90WRAP := f90wrap
FCOMPILER := intelem
J := -module
# Path to pFUnit (Unit testing Framework)
PFUNIT := $(ALL_CCCHOME)/opt/pfunit/pfunit-parallel
```

On a typical cluster with Nvidia V100 GPUs and pgfortran compiler
```make
# Compilation options
F90 := pgfortran
F90FLAGS := -fast -Mvect -m64 -Minfo=ccff -Mpreprocess -g
F90FLAGS := -tp=px -Minfo=ccff -Mpreprocess
F90FLAGS += -acc -ta=tesla:managed -Minline
F90FLAGS += -Minfo=accel,inline
FPPFLAGS := -DMW_SERIAL
LDFLAGS := -llapack -lblas
J := -module
```
**Warning** Continuous integration tests are not run on GPUs so you should always check the calculation on a CPU architecture before starting production.

Some internal flags can be defined in `F90FLAGS` to activate certain features:

- `-DMW_USE_PLUMED` to compile with the Plumed library
- `-DMW_SERIAL` to compile in serial mode
- `-DMW_CI` to allow unit tests

Note that on GPUs `-DMW_SERIAL` is enforced since the parallelization is made with OpenACC.

The Makefile is located in the root directory. The command to compile the code is simply `make`. It will create the object files in a dedicated build directory and produce the *mw* executable in the root directory.


# PLUMED

MW can be run with the PLUMED biased-MD library. To achieve this use the option `-DMW_USE_PLUMED` to be specified in the `FPPFLAGS` of the *./config.mk* file. PLUMED should be installed and compiled externally to MW, using the procedure on the [PLUMED website](https://www.plumed.org/). To then link PLUMED to MW, from the root directory of the code `./` type:
```bash
plumed patch --new mw2
plumed patch --patch --shared --engine mw2
```
See the `./example/plumed/` directory for an example of a MW run coupled to PLUMED.


# Python interface

It is possible (but not necessary) to compile MW as a python library using **f2py** and **f90wrap**. For this, you should define the variables F2PY, F90WRAP and FCOMPILER in the *./config.mk*, add the flag `-fPIC` to the `F90FLAGS` and use the command `make python`. Please be aware that this compiler flag may cause a decrease in the performance. For more information, see the [python interface page](https://gitlab.com/ampere2/metalwalls/-/wikis/python-interface).


# Testing
Two test suites are available in the *./tests/* folder, one that includes unit tests to check individual subroutines and another regression tests that run the code as a whole. Both suites are independent and can be run separately.
For user purposes, we recommend to only use regression tests.

## Regression tests

To run the regression test suite, you will need a working python interpreter with the **numpy** package installed.

Regression tests are reference test cases against which the code is compared.
To run the regression tests, type the command in the *./tests/* directory:

```bash
python regression_tests.py
```

To run a reduced version of the tests one can use:

```bash
python regression_tests.py -r
```

To only run a subset of the tests one can use:

```bash
python regression_tests.py -s <subset>
```

To run tests that use the python interface, one can specify the path to the python executable using:

```bash
python regression_tests.py -s python_interface -py path-to-python
```

The various tests subsets are:
* *nist*: energy comparison for the NIST validation case
* *benchmark*: forces, energies and charges comparison with LAMMPS for several systems
* *tosi_fumi*: comparison of forces, energies and stress tensor with PIM results for a NaCl system
* *pim*: comparison with PIM results
* *aim*: comparison with PIMAIM results
* *dihedrals*: comparison with reference data
* *matrix_inversion*: comparison of matrix, forces, energies, dipoles and charges with reference data
* *maze*: comparison of dipoles and electrodes calculated with MaZe method and with the conjugate gradient and matrix inversion method  
* *charge_neutrality*: comparison of charge calculation with conjugate gradient with symmetric and asymmetric potential difference
* *non_neutral*: comparison of matrix, forces, energies and charges with reference data for non neutral electrolyte
* *plumed*: plumed test
* *external_field*: comparison with reference data
* *thomas_fermi*: comparison with reference data
* *python_interface*: *nist* test case run with the python interface
* *steele*: comparison with reference data
* *piston*: comparison with reference data
* *four_site_model*: comparison with reference data
* *efg*: comparison with reference data
* *unwrap*: comparison with reference data
* *dip_plus_elec*: comparison of simultaneous calculation of dipoles and electrodes using conjugate gradient with reference data
* *dump_per_species*: comparison with reference data

## Unit tests

Unit tests aim at validating individual components of the code, we stress that they are used to monitor the code by developpers but are recommended for normal users.

In order to properly run the unit test suite you will need to install pFunit (the unit test framework).
To install pFUnit, download the version 3.3 from the [project page on Github](https://github.com/Goddard-Fortran-Ecosystem/pFUnit/releases/tag/3.3.3)
and follow the installation instructions in the *README.md* which we briefly reproduce here for a *bash* example. It is necessary to compile the MPI enabled version of pFUnit.

```bash
wget https://github.com/Goddard-Fortran-Ecosystem/pFUnit/archive/3.3.3.tar.gz
tar -zxvf 3.3.3.tar.gz
cd pFUnit-3.3.3/
export F90=gfortran
export F90_VENDOR=GNU
export MPIF90=mpif90
make tests MPI=YES
make install INSTALL_DIR=/path-to-pfunit/pfunit-parallel
```

To run the tests, MW has to be compiled with the compiling option `-DMW_CI`, to be specified in the *config.mk* file.
To launch the tests, do

```bash
make
make check
```
which will compile and run the unit tests. The `make check` command is a shortcut for

```bash
make mw_tests
cd tests/pFUnit
../../mw_tests
```

On batch processing system it is required to build the *mw_tests*
executable and create the appropriate job submission script.

# Running MW

## Running

Running a MW simulation requires two input files: a configuration file, *runtime.inpt*, and a data file, *data.inpt*.
Their format is described in the [system configuration page](https://gitlab.com/ampere2/metalwalls/-/wikis/system-configuration) and the [data input file page](https://gitlab.com/ampere2/metalwalls/-/wikis/data-input-file-format).
In a folder with the *data.inpt* and *runtime.inpt* files, run the executable with an MPI wrapper, for example:

```bash
mpirun -np 4 ./mw
```
Different flags can tune the executable behavior:

```bash
  -h, --help                 show a help message
  -v, --version              show program version number and exit
      --output-rank=VALUE    enables output on some of the ranks
                             possible VALUE are:
                               root     - only rank 0 performs output (default)
                               all      - all mpi processes perform output
                               r1[,r2]* - comma separated list of rank ids which perform output
```

## Restarting

The MW-generated restart files have the same format as the data files so one only has to rename them *data.inpt* and run the simulation again.
Be careful to the velocity creation keyword in the system configuration file *runtime.inpt*.

If you are running simulations using the Mass-Zero method (*maze*) with matrix inversion, the computed matrix can be given as input *maze_matrix.inpt*. Similarly, if you are using the *matrix_inversion* algorithm, the computed matrix can be given as input *hessian_matrix.inpt*. When restarting the simulation, these matrices will be read instead of computed from scratch.

# Funding

The development of MW has received support from:
* [EoCoE](http://www.eocoe.eu), a project funded by the European Union Contracts No. H2020-EINFRA-2015-1-676629 and H2020-INFRAEDI-2018-824158.
* European Research Council (ERC) under the European Union’s Horizon 2020 research and innovation programme (Grant Agreement No. 771294).
* French National Research Agency (Labex STORE-EX, Grant No. ANR-10-LABX-0076).

Full irene documentation
=========================
https://www-tgcc.ccc.cea.fr/docs/

Environment
===========
* Current project name on irene: **gen7725**
To be mentionned in job scripts and for data modules
* Current Fortan compiler
* Current MPI librairy

File systems
============
4 file systems @TGCC:
* home: small, backed up => source,  software and small data
* work: large and performant, **no back up** => target file system for MW production
* store: huge and slow (tapes), archiving system => pack regularly run results in tarball to limit the number of files there in order to back up data
* scratch: very large and performant, periodic remove of non used files => not relevant for MW production   

```
module switch dfldatadir/gen7725
```
sets for each of these file systems, environment variables for private and shared spaces. For instance, for the work file system:
* ALL_CCCWORKDIR points to the shared space /ccc/work/cont003/gen7725/gen7725 associated to project gen7725
* CCCWORKDIR points to the private space /ccc/work/cont003/gen7725/haefemat of user haefemat associated to project gen7725
=> good practise to load the correct module and use these env variables in your scripts

Testing Metalwalls
==================
In MW git project root directory
```
make mw_tests # compiles the unitary tests 
cp -r tests $CCCWORKDIR 
cd $CCCWORKDIR/tests
ccc_msub $OLDPWD/computers/irene/job_check
```
Check ouptut and error files generated by the job scheduler to check if everything run fine

Job scripts
===========
* job_check: runs the MW tests suite 
* job_prod: typical production run job

Before running on a platform it is a good idea to benchmark: 
* compilers
* MPI libraries
* perform a scaling 

fetch_time_compile_MPI.sh
=========================
Run the code in the same conditions but compiled with a another compiler or MPI lib. This script fetches the total time for each execution. It can be modified easily.



setup_scaling.sh 
================
* creates a set of directories
* hardlinks intput data
* copy the standard job script

After modifying the job script to run on a different amount of resources, launch all jobs.

fetch_time_scaling.sh
=====================
Similarly to fetch_time_compile_MPI.sh, it retrieves runtime from all runs and put th result in res.out file

compute_scalability.py
=====================
Python script that will open res.out and generate a new file with speedups and parallel efficiency computed

SPC/E Water Reference Calculations - 10 angstrom cutoff
=======================================================

In this section, we provide sample configurations of SPC/E Water
molecules[1] and report the various energy and force calculations for
those configurations, where the coulombic contributions are computed
using the traditional Ewald Summation Method[2]. These sample
configurations and reference calculations can be used to validate the
energy and force routines for an existing or new molecular simulation
code. 

The details of the model is dicussed at length on the NIST website:

https://www.nist.gov/mml/csd/chemical-informatics-research-group/spce-water-reference-calculations-10%C3%A5-cutoff

Four sample configurations of SPC/E molecules are available for
download as a [gzipped tarball archive]
(https://www.nist.gov/file/30636). This archive contains five files:
the four sample configuration files and one metadata file that
explains the format of the sample configurations. These configurations
should be converted to the configuration file format native to a
user's simulation software.


# Getting the data

wget https://www.nist.gov/sites/default/files/documents/mml/csd/informatics_research/spce_sample_configurations-tar.gz
cp spce_sample_configurations-tar.gz spce_sample_configurations.tar.gz
tar xzf spce_sample_configurations.tar.gz

The archive contains 5 files:
 
  1 - metadata.README : describes the file format
  2 - spce_sample_config_periodic#.txt : text files containing a single configuration of SPC/E Molecules

Conversion to MW units:
-----------------------

distance: 1 ua       = 0.52917721067 angstrom
          1 angstrom = 1.88972612546 ua

The script nist2mw.py generates the appropriate inputs for Metalwalls. To run it simply:
python nist2mw.py <number>

with <number> being 1, 2, 3 or 4 depending on the case you are treating


 

! Module to control output from simulations
!
! Different output files contain
!  - trajectories: ions position and velocities
!  - electrode charges: integral charge on each electrode atoms
!  - forces: forces on ions
!  - dipoles: dipoles on ions
!  - efg: efg on ions
!  - radius: radius of ions (delta,epsilon)
!  - energies: energy breakdown (total, kinetic, potential) + temperature
!  - pressure: internal pressure + pressure tensor of the system
!  - stress tensor: stress tensor of the system
!  - box parameters: volume + lengths of the box (NPT runs)
!  - polarization: total volumic polarization of the cell
module MW_output
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   use MW_ion, only: MW_ion_t
   use MW_electrode, only: MW_electrode_t
   use MW_external_field, only: MW_external_field_t
   use MW_diagnostic, only: MW_diagnostic_t
   implicit none
   private

   ! Macro for PGI compiler support
#if defined(__PGI)
#define SIGN_SUPPRESS
#define SIGN_PLUS
#else
#define SIGN_SUPPRESS , sign="suppress"
#define SIGN_PLUS , sign="PLUS"
#endif

   ! Public subroutines
   ! ------------------
   public :: close_all
   public :: trajectories_set_dump_frequency
   public :: trajectories_setup
   public :: trajectories_dump
   public :: xyz_set_dump_frequency
   public :: xyz_setup
   public :: xyz_dump
   public :: pdb_set_dump_frequency
   public :: pdb_setup
   public :: pdb_dump
   public :: lammps_set_dump_frequency
   public :: lammps_setup
   public :: lammps_dump
   public :: charges_set_dump_frequency
   public :: charges_setup
   public :: charges_dump
   public :: total_charges_set_dump_frequency
   public :: total_charges_setup
   public :: total_charges_dump
   public :: forces_set_dump_frequency
   public :: forces_setup
   public :: forces_dump
   public :: elec_forces_set_dump_frequency
   public :: elec_forces_setup
   public :: elec_forces_dump
   public :: dipoles_set_dump_frequency
   public :: dipoles_setup
   public :: dipoles_dump
   public :: efg_set_dump_frequency
   public :: efg_setup
   public :: efg_dump
   public :: radius_set_dump_frequency
   public :: radius_setup
   public :: radius_dump
   public :: potential_shift_set_dump_frequency
   public :: potential_shift_setup
   public :: potential_shift_dump
   public :: energies_set_dump_frequency
   public :: energies_setup
   public :: energies_dump
   public :: restart_setup
   public :: restart_set_dump_frequency
   public :: temperature_set_dump_frequency
   public :: temperature_setup
   public :: temperature_dump
   public :: pressure_set_dump_frequency
   public :: pressure_setup
   public :: pressure_dump
   public :: stress_tensor_set_dump_frequency
   public :: stress_tensor_setup
   public :: stress_tensor_dump
   public :: box_set_dump_frequency
   public :: box_setup
   public :: box_dump
   public :: polarization_set_dump_frequency
   public :: polarization_setup
   public :: polarization_dump
   public :: step_set_dump_frequency
   public :: diagnostic_set_dump_frequency
   public :: diagnostic_setup
   public :: diagnostic_dump

   ! Public type
   ! -----------
   public :: MW_output_t

   type MW_output_t
      ! Trajectories (positions and velocities)
      character(64) :: trajectories_file_name = ""
      integer :: trajectories_file_unit = 0
      integer :: trajectories_dump_frequency = 0

      ! Trajectories with xyz format (positions)
      character(64) :: xyz_file_name = ""
      integer :: xyz_file_unit = 0
      integer :: xyz_dump_frequency = 0

      ! Trajectories with pdb format (positions and charges)
      character(64) :: pdb_file_name = ""
      integer :: pdb_file_unit = 0
      integer :: pdb_dump_frequency = 0

      ! Trajectories with lammps format (positions and charges)
      character(64) :: lammps_file_name = ""
      integer :: lammps_file_unit = 0
      integer :: lammps_dump_frequency = 0

      ! Charges on electrode atoms
      character(64) :: charges_file_name = ""
      integer :: charges_file_unit = 0
      integer :: charges_dump_frequency = 0

      ! Total Charges on electrodes
      character(64) :: total_charges_file_name = ""
      integer :: total_charges_file_unit = 0
      integer :: total_charges_dump_frequency = 0

      ! Forces on ions
      character(64) :: forces_file_name = ""
      integer :: forces_file_unit = 0
      integer :: forces_dump_frequency = 0

      ! Forces on electrodes
      character(64) :: elec_forces_file_name = ""
      integer :: elec_forces_file_unit = 0
      integer :: elec_forces_dump_frequency = 0

      ! Dipoles on ions
      character(64) :: dipoles_file_name = ""
      integer :: dipoles_file_unit = 0
      integer :: dipoles_dump_frequency = 0

      ! Electric field gradient on ions
      character(64) :: efg_file_name = ""
      integer :: efg_file_unit = 0
      integer :: efg_dump_frequency = 0

      ! Radius of ions
      character(64) :: radius_file_name = ""
      integer :: radius_file_unit = 0
      integer :: radius_dump_frequency = 0

      ! Energies of the system
      character(64) :: energies_file_name = ""
      integer :: energies_file_unit = 0
      character(64) :: energies_detailed_file_name = ""
      integer :: energies_detailed_file_unit = 0
      integer :: energies_dump_frequency = 0

      ! Temperature
      character(64) :: temperature_file_name = ""
      integer :: temperature_file_unit = 0
      integer :: temperature_dump_frequency = 0

      ! Pressure
      character(64) :: pressure_file_name = ""
      integer :: pressure_file_unit = 0
      integer :: pressure_dump_frequency = 0

      ! Stress tensor
      character(64) :: stress_tensor_file_name = ""
      integer :: stress_tensor_file_unit = 0
      integer :: stress_tensor_dump_frequency = 0

      ! Box parameters
      character(64) :: box_file_name = ""
      integer :: box_file_unit = 0
      integer :: box_dump_frequency = 0

      ! Restart
      character(64) :: restart_file_name = ""
      integer :: restart_dump_frequency = 0

      ! Step (in run.out)
      integer :: step_dump_frequency = 0

      ! Polarization of the cell
      character(64) :: polarization_file_name = ""
      integer :: polarization_file_unit = 0
      integer :: polarization_dump_frequency = 0

      ! diagnostics
      character(64) :: number_density_file_name = ""
      character(64) :: charge_density_file_name = ""
      integer :: diagnostic_dump_frequency = 0

      !Dump and read back matrix for maze with electrode charges
      character(64) :: matrix_file_name = ""
      integer :: matrix_file_unit

      ! Potential shift for simulations at enforced neutrality
      character(64) :: potential_shift_file_name = ""
      integer :: potential_shift_file_unit = 0
      integer :: potential_shift_dump_frequency = 0

   end type MW_output_t

contains

   ! ================================================================================
   ! Close all output files
   subroutine close_all(this)
      use MW_errors, only: MW_errors_close_error => close_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: funit
      logical :: lopen
      integer :: ierr

      funit = this%trajectories_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%xyz_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%pdb_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%lammps_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%charges_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%total_charges_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%forces_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%elec_forces_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%dipoles_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%efg_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%radius_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%energies_detailed_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%energies_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%polarization_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%potential_shift_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%temperature_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%pressure_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%stress_tensor_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%box_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

      funit = this%matrix_file_unit
      if (funit > 0) then
         inquire(unit=funit, opened=lopen)
         if (lopen) then
            close(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_output_close", "output.f90", &
                     funit, ierr)
            end if
         end if
      end if

   end subroutine close_all


   ! ================================================================================
   ! Set dump frequency for trajectories
   subroutine trajectories_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%trajectories_dump_frequency = dump_frequency
   end subroutine trajectories_set_dump_frequency

   ! ================================================================================
   ! Open trajectories output file
   subroutine trajectories_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%trajectories_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("trajectories_",i6.6,".out")') rank
         else
            fname = "trajectories.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%trajectories_file_name = fname
         this%trajectories_file_unit = funit

         write(funit, '("# Trajectories of mobile particles in atomic unit")')
         write(funit, '("# -----------------------------------------------")')
         write(funit, '("# Length:   1 au = 0.052917721067 nm")')
         write(funit, '("# Velocity: 1 au = 2.1876912633e6 m.s^-1")')
         write(funit, '("# ",a21,5(1x,a23))') &
               "         x          ", &
               "           y           ", &
               "           z           ", &
               "           vx          ", &
               "           vy          ", &
               "           vz          "
      end if

   end subroutine trajectories_setup

   ! ================================================================================
   ! Dump trajectories to output file
   subroutine trajectories_dump(this, istep, ions, xyz_ions, velocity_ions)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(in) :: xyz_ions(:,:)
      real(wp), intent(in) :: velocity_ions(:,:)

      ! Local
      ! -----
      integer :: funit
      integer :: iion, itype, offset, i

      funit = this%trajectories_file_unit

      write(funit, '("# step ",i8)' SIGN_SUPPRESS) istep

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%dump_trajectories .and. ions(itype)%mobile) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(6(es23.15E3,:,1x))') &
                     xyz_ions(iion,1), xyz_ions(iion,2), xyz_ions(iion,3), &
                     velocity_ions(iion, 1), velocity_ions(iion, 2), velocity_ions(iion, 3)
            end do
         end if
      end do

   end subroutine trajectories_dump

   ! ================================================================================
   ! Set dump frequency for xyz trajectories
   subroutine xyz_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%xyz_dump_frequency = dump_frequency
   end subroutine xyz_set_dump_frequency

   ! ================================================================================
   ! Open xyz trajectory output file
   subroutine xyz_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%xyz_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("trajectories_",i6.6,".xyz")') rank
         else
            fname = "trajectories.xyz"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%xyz_file_name = fname
         this%xyz_file_unit = funit
      end if

   end subroutine xyz_setup

   ! ================================================================================
   ! Dump xyz trajectories to output file
   subroutine xyz_dump(this, istep, ions, electrodes, xyz_ions, xyz_atoms, num_ions, num_atoms)
      use MW_constants, only: bohr2angstrom
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep, num_ions, num_atoms
      type(MW_ion_t), intent(in) :: ions(:)
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: xyz_ions(:,:), xyz_atoms(:,:)

      ! Local
      ! -----
      integer :: funit
      integer :: iion, iatom, itype, offset, i
      integer :: total_ions_atoms

      funit = this%xyz_file_unit

      total_ions_atoms = 0
      do itype = 1, size(ions,1)
         if (ions(itype)%dump_xyz) then
            total_ions_atoms = total_ions_atoms + ions(itype)%count
         end if
      end do
      do itype = 1, size(electrodes,1)
         if (electrodes(itype)%dump_xyz) then
            total_ions_atoms = total_ions_atoms + electrodes(itype)%count
         end if
      end do

      write(funit, '(i8)' SIGN_SUPPRESS) total_ions_atoms
      write(funit, '("# step ",i8)' SIGN_SUPPRESS) istep

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%dump_xyz) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(A8,6(es23.15E3,:,1x))') ions(itype)%name, xyz_ions(iion, :)*bohr2angstrom
            end do
         end if
      end do

      do itype = 1, size(electrodes,1)
         offset = electrodes(itype)%offset
         if (electrodes(itype)%dump_xyz) then
            do i = 1, electrodes(itype)%count
               iatom = offset + i
               write(funit, '(A8,6(es23.15E3,:,1x))') electrodes(itype)%name, xyz_atoms(iatom, :)*bohr2angstrom
            end do
         end if
      end do

   end subroutine xyz_dump

   ! ================================================================================
   ! Set dump frequency for pdb trajectories
   subroutine pdb_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%pdb_dump_frequency = dump_frequency
   end subroutine pdb_set_dump_frequency

   ! ================================================================================
   ! Open pdb trajectory output file
   subroutine pdb_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%pdb_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("trajectories_",i6.6,".pdb")') rank
         else
            fname = "trajectories.pdb"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%pdb_file_name = fname
         this%pdb_file_unit = funit
      end if

   end subroutine pdb_setup

   ! ================================================================================
   ! Dump pdb trajectories to output file
   subroutine pdb_dump(this, ions, electrodes, xyz_ions, xyz_atoms, q_elec, box, molecules)
      use MW_constants, only: bohr2angstrom
      use MW_box, only: MW_box_t
      use MW_molecule, only: MW_molecule_t
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      type(MW_ion_t), intent(in) :: ions(:)
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: xyz_ions(:,:), xyz_atoms(:,:)
      type(MW_box_t), intent(in) :: box
      real(wp), intent(in) :: q_elec(:)
      type(MW_molecule_t), intent(in) :: molecules(:)

      ! Local
      ! -----
      integer :: funit
      integer :: ierr
      integer :: iion, iatom, itype, imol, isite, offset, i, c_atoms, c_mol, c_mol_type
      logical, allocatable :: in_molecule(:)

      funit = this%pdb_file_unit

      write(funit, '("CRYST1",3f9.3,"  90.00  90.00  90.00 P 1           1")' SIGN_SUPPRESS) &
                box%length(1)*bohr2angstrom, box%length(2)*bohr2angstrom, &
                box%length(3)*bohr2angstrom

      allocate(in_molecule(size(ions,1)), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("pdb_dump", "output.f90",ierr)
      end if

      in_molecule(:) = .false.
      c_atoms = 1
      c_mol_type = 1

      ! Loop on ion types in molecules
      do imol = 1, size(molecules)
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            in_molecule(itype) = .true.
            c_mol = c_mol_type

            offset = ions(itype)%offset
            if (ions(itype)%dump_pdb) then
               do i = 1, ions(itype)%count
                  iion = offset + i
                  write(funit, '("ATOM  ",i5,1X,A4,6X,i4,4X,3f8.3,6X,f6.2)' SIGN_SUPPRESS) &
                       c_atoms, ions(itype)%name, c_mol, xyz_ions(iion,:)*bohr2angstrom, &
                       ions(itype)%charge
                  c_atoms = c_atoms + 1
                  c_mol = c_mol + 1
               end do
            end if
         end do
         c_mol_type = c_mol
      end do

      ! Loop on ion types not in molecules
      do itype = 1, size(ions,1)
         if (in_molecule(itype)) CYCLE ! skip if in molecule
         offset = ions(itype)%offset
         if (ions(itype)%dump_pdb) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '("ATOM  ",i5,1X,A4,6X,i4,4X,3f8.3,6X,f6.2)' SIGN_SUPPRESS) &
                    c_atoms, ions(itype)%name, 0, xyz_ions(iion, :)*bohr2angstrom, &
                    ions(itype)%charge
               c_atoms = c_atoms + 1
            end do
         end if
      end do

      ! Loop on electrodes
      do itype = 1, size(electrodes,1)
         offset = electrodes(itype)%offset
         if (electrodes(itype)%dump_pdb) then
            do i = 1, electrodes(itype)%count
               iatom = offset + i
               write(funit, '("ATOM  ",i5,1X,A4,6X,i4,4X,3f8.3,6X,es6.0E1)' SIGN_SUPPRESS) &
                    c_atoms, electrodes(itype)%name, c_mol_type, xyz_atoms(iatom, :)*bohr2angstrom, &
                    q_elec(iatom)
               c_atoms = c_atoms + 1
            end do
         end if
         c_mol_type = c_mol_type + 1
      end do

      write(funit, '("END")')

   end subroutine pdb_dump

   ! ================================================================================
   ! Set dump frequency for lammps trajectories
   subroutine lammps_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%lammps_dump_frequency = dump_frequency
   end subroutine lammps_set_dump_frequency

   ! ================================================================================
   ! Open lammps trajectory output file
   subroutine lammps_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%lammps_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("trajectories_",i6.6,".lammpstrj")') rank
         else
            fname = "trajectories.lammpstrj"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%lammps_file_name = fname
         this%lammps_file_unit = funit
      end if

   end subroutine lammps_setup

   ! ================================================================================
   ! Dump lammps trajectories to output file
   subroutine lammps_dump(this, istep, ions, electrodes, xyz_ions, xyz_atoms, num_ions, num_atoms, &
             q_elec, box, molecules)
      use MW_constants, only: bohr2angstrom
      use MW_box, only: MW_box_t
      use MW_molecule, only: MW_molecule_t
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep, num_ions, num_atoms
      type(MW_ion_t), intent(in) :: ions(:)
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: xyz_ions(:,:), xyz_atoms(:,:)
      type(MW_box_t), intent(in) :: box
      real(wp), intent(in) :: q_elec(:)
      type(MW_molecule_t), intent(in) :: molecules(:)

      ! Local
      ! -----
      integer :: funit
      integer :: ierr
      integer :: iion, iatom, itype, imol, isite, offset, i, c_atoms, c_mol, c_mol_type
      integer :: total_ions_atoms
      logical, allocatable :: in_molecule(:)

      funit = this%lammps_file_unit

      total_ions_atoms = 0
      do itype = 1, size(ions,1)
         if (ions(itype)%dump_lammps) then
            total_ions_atoms = total_ions_atoms + ions(itype)%count
         end if
      end do
      do itype = 1, size(electrodes,1)
         if (electrodes(itype)%dump_lammps) then
            total_ions_atoms = total_ions_atoms + electrodes(itype)%count
         end if
      end do

      write(funit, '("ITEM: TIMESTEP")')
      write(funit, '(i8)' SIGN_SUPPRESS) istep
      write(funit, '("ITEM: NUMBER OF ATOMS")')
      write(funit, '(i8)' SIGN_SUPPRESS) total_ions_atoms
      write(funit, '("ITEM: BOX BOUNDS")')
      write(funit, '(2f9.3)' SIGN_SUPPRESS) 0.0, box%length(1)*bohr2angstrom
      write(funit, '(2f9.3)' SIGN_SUPPRESS) 0.0, box%length(2)*bohr2angstrom
      write(funit, '(2f9.3)' SIGN_SUPPRESS) 0.0, box%length(3)*bohr2angstrom
      write(funit, '("ITEM: ATOMS element id molid x y z q vx vy vz")')

      allocate(in_molecule(size(ions,1)), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("lammps_dump", "output.f90",ierr)
      end if

      in_molecule(:) = .false.
      c_atoms = 1
      c_mol_type = 1

      ! Loop on ion types in molecules
      do imol = 1, size(molecules)
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            in_molecule(itype) = .true.
            c_mol = c_mol_type

            offset = ions(itype)%offset
            if (ions(itype)%dump_lammps) then
               do i = 1, ions(itype)%count
                  iion = offset + i
                  write(funit, '(A8,6X,i8,6X,i8,6X,3f9.3,6X,4f9.3)' SIGN_SUPPRESS) &
                       ions(itype)%name, c_atoms, c_mol, xyz_ions(iion,:)*bohr2angstrom, &
                       ions(itype)%charge, 0.0, 0.0, 0.0
                  c_atoms = c_atoms + 1
                  c_mol = c_mol + 1
               end do
            end if
         end do
         c_mol_type = c_mol
      end do

      ! Loop on ion types not in molecules
      do itype = 1, size(ions,1)
         if (in_molecule(itype)) CYCLE ! skip if in molecule
         offset = ions(itype)%offset
         if (ions(itype)%dump_lammps) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(A8,6X,i8,6X,i8,6X,3f9.3,6X,4f9.3)' SIGN_SUPPRESS) &
                    ions(itype)%name, c_atoms, 0, xyz_ions(iion, :)*bohr2angstrom, &
                    ions(itype)%charge, 0.0, 0.0, 0.0
               c_atoms = c_atoms + 1
            end do
         end if
      end do

      ! Loop on electrodes
      do itype = 1, size(electrodes,1)
         offset = electrodes(itype)%offset
         if (electrodes(itype)%dump_lammps) then
            do i = 1, electrodes(itype)%count
               iatom = offset + i
               write(funit, '(A8,6X,i8,6X,i8,6X,3f9.3,6X,f9.3,es15.3E3,2f9.3)' SIGN_SUPPRESS) &
                    electrodes(itype)%name, c_atoms, c_mol_type, xyz_atoms(iatom, :)*bohr2angstrom, &
                    0.0, q_elec(iatom), 0.0, 0.0
               c_atoms = c_atoms + 1
            end do
         end if
         c_mol_type = c_mol_type + 1
      end do

   end subroutine lammps_dump

   ! ================================================================================
   ! Set dump frequency for charges
   subroutine charges_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%charges_dump_frequency = dump_frequency
   end subroutine charges_set_dump_frequency

   ! ================================================================================
   ! Open charges output file
   subroutine charges_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%charges_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("charges_",i6.6,".out")') rank
         else
            fname = "charges.out"
         end if
         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%charges_file_name = fname
         this%charges_file_unit = funit

         write(funit, '("# Electrode atom charges in atomic unit")')
         write(funit, '("# -------------------------------------")')
         write(funit, '("# Charge:   1 au = 1.602176565e-19 C = 1 e")')
      end if

   end subroutine charges_setup

   ! ================================================================================
   ! Dump charges to output file
   subroutine charges_dump(this, istep, electrodes, q_elec)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: q_elec(:)

      ! Local
      ! -----
      integer :: funit
      integer :: iatom, itype, offset, i

      funit = this%charges_file_unit
      write(funit, '("# step ",i8)' SIGN_SUPPRESS) istep

      do itype = 1, size(electrodes,1)
         offset = electrodes(itype)%offset
         do i = 1, electrodes(itype)%count
            iatom = offset+i
            write(funit, '(1(es23.15E3,:,1x))') q_elec(iatom)
         end do
      end do

   end subroutine charges_dump

   ! ================================================================================
   ! Set dump frequency for charges
   subroutine total_charges_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%total_charges_dump_frequency = dump_frequency
   end subroutine total_charges_set_dump_frequency

   ! ================================================================================
   ! Open charges output file
   subroutine total_charges_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%total_charges_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("total_charges_",i6.6,".out")') rank
         else
            fname = "total_charges.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%total_charges_file_name = fname
         this%total_charges_file_unit = funit

         write(funit, '("# Total charges on electrodes in atomic unit")')
         write(funit, '("# ------------------------------------------")')
         write(funit, '("# Charge:   1 au = 1.602176565e-19 C = 1 e")')
      end if

   end subroutine total_charges_setup

   ! ================================================================================
   ! Dump charges to output file
   subroutine total_charges_dump(this, istep, electrodes, q_elec)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: q_elec(:)

      ! Local
      ! -----
      integer :: funit
      integer :: iatom, itype, offset, i
      real(wp) :: total_charges(100) ! max 100 electrodes!

      funit = this%total_charges_file_unit
      if (size(electrodes,1) > 0) then
         total_charges(:) = 0.0_wp
         do itype = 1, size(electrodes,1)
            offset = electrodes(itype)%offset
            do i = 1, electrodes(itype)%count
               iatom = offset+i
               total_charges(itype) = total_charges(itype) + q_elec(iatom)
            end do
         end do
         write(funit, '(i8, 100(1x, es23.15E3))') istep, &
               (total_charges(itype), itype = 1, size(electrodes,1))
      end if

   end subroutine total_charges_dump

   ! ================================================================================
   ! Set dump frequency for forces
   subroutine forces_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%forces_dump_frequency = dump_frequency
   end subroutine forces_set_dump_frequency

   ! ================================================================================
   ! Open forces output file
   subroutine forces_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%forces_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("forces_",i6.6,".out")') rank
         else
            fname = "forces.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%forces_file_name = fname
         this%forces_file_unit = funit

         write(funit, '("# Forces on mobile particles in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Force:   1 au = 8.2387225e-8 N = 51.421 eV/angstrom")')
         write(funit, '("#",a22,23(1x,a23))') &
               "       fx_total        ", "       fy_total        ", "       fz_total        ",&
               "      fx_coulomb       ", "      fy_coulomb       ", "      fz_coulomb       ",&
               "     fx_coulomb_lr     ", "     fy_coulomb_lr     ", "     fz_coulomb_lr     ",&
               "     fx_coulomb_k0     ", "     fy_coulomb_k0     ", "     fz_coulomb_k0     ",&
               "     fx_coulomb_sr     ", "     fy_coulomb_sr     ", "     fz_coulomb_sr     ",&
               "     fx_coulomb_mol    ", "     fy_coulomb_mol    ", "     fz_coulomb_mol    ",&
               "    fx_van_der_Waals   ", "    fy_van_der_Waals   ", "    fz_van_der_Waals   ",&
               "   fx_intramolecular   ", "   fy_intramolecular   ", "   fz_intramolecular   "
      end if

   end subroutine forces_setup

   ! ================================================================================
   ! Dump forces to output file
   subroutine forces_dump(this, step, ions, forces_ions, coulomb_forces_ions, &
         intermolecular_forces_ions, intramolecular_forces_ions)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_ion_t), intent(in) :: ions(:) !< ion types parameters
      real(wp), intent(in) :: forces_ions(:,:) !< forces on ions
      real(wp), intent(in) :: coulomb_forces_ions(:,:,:) !< Coulomb forces on ions
      real(wp), intent(in) :: intermolecular_forces_ions(:,:) !< Intermolecular forces on ions
      real(wp), intent(in) :: intramolecular_forces_ions(:,:) !< Intramolecular forces on ions

      ! Local
      ! -----
      integer :: funit
      integer :: iion, itype, offset, i

      funit = this%forces_file_unit

      write(funit, '("# step ",i8)' SIGN_SUPPRESS) step

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%mobile) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(24(es23.15E3,:,1x))') &
                     forces_ions(iion, 1), forces_ions(iion, 2), forces_ions(iion, 3), &
                     coulomb_forces_ions(iion, 1, 1), coulomb_forces_ions(iion, 2, 1), coulomb_forces_ions(iion, 3, 1), &
                     coulomb_forces_ions(iion, 1, 2), coulomb_forces_ions(iion, 2, 2), coulomb_forces_ions(iion, 3, 2), &
                     coulomb_forces_ions(iion, 1, 3), coulomb_forces_ions(iion, 2, 3), coulomb_forces_ions(iion, 3, 3), &
                     coulomb_forces_ions(iion, 1, 4), coulomb_forces_ions(iion, 2, 4), coulomb_forces_ions(iion, 3, 4), &
                     coulomb_forces_ions(iion, 1, 5), coulomb_forces_ions(iion, 2, 5), coulomb_forces_ions(iion, 3, 5), &
                     intermolecular_forces_ions(iion, 1), intermolecular_forces_ions(iion, 2), &
                     intermolecular_forces_ions(iion, 3), &
                     intramolecular_forces_ions(iion, 1), intramolecular_forces_ions(iion, 2), &
                     intramolecular_forces_ions(iion, 3)
            end do
         end if
      end do
   end subroutine forces_dump

   ! ================================================================================
   ! Set dump frequency for elec_forces
   subroutine elec_forces_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%elec_forces_dump_frequency = dump_frequency
   end subroutine elec_forces_set_dump_frequency

   ! ================================================================================
   ! Open forces output file
   subroutine elec_forces_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%elec_forces_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("electrodes_forces_",i6.6,".out")') rank
         else
            fname = "electrode_forces.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%elec_forces_file_name = fname
         this%elec_forces_file_unit = funit

         write(funit, '("# Total force on electrodes and pressure in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Force:   1 au = 8.2387225e-8 N = 51.421 eV/angstrom")')
         write(funit, '("# Pressure:   1 bar = 3.3988273773641905e-09 ua")')
         write(funit, '("#",a22,23(1x,a23))') &
               "      fx_total        ", &
               "       fy_total        ", &
               "       fz_total        ", &
               "     fx_coulomb_sr     ", &
               "     fy_coulomb_sr     ", &
               "     fz_coulomb_sr     ", &
               "     fx_coulomb_k0     ", &
               "     fy_coulomb_k0     ", &
               "     fz_coulomb_k0     ", &
               "     fx_coulomb_lr     ", &
               "     fy_coulomb_lr     ", &
               "     fz_coulomb_lr     ", &
               "   fx_lennard_jones    ", &
               "   fy_lennard_jones    ", &
               "   fz_lennard_jones    ", &
               "     fx_fumi_tosi      ", &
               "     fy_fumi_tosi      ", &
               "     fz_fumi_tosi      ", &
               "        fx_xft         ", &
               "        fy_xft         ", &
               "        fz_xft         ", &
               "        pressure       ", &
               "       velocity_z      ", &
               "         com_z         "
      end if

   end subroutine elec_forces_setup

   ! ================================================================================
   ! Dump forces to output file
   subroutine elec_forces_dump(this, step, electrodes, area)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_electrode_t), intent(in) :: electrodes(:) !< ion types parameters
      real(wp), intent(in) :: area

      ! Local
      ! -----
      integer :: funit
      integer :: itype

      funit = this%elec_forces_file_unit

      write(funit, '("# step ",i8)' SIGN_SUPPRESS) step

      do itype = 1, size(electrodes,1)
         write(funit, '(21(es23.15E3,:,1x))') electrodes(itype)%force_ions(1, 1), &
               electrodes(itype)%force_ions(2, 1), &
               electrodes(itype)%force_ions(3, 1), &
               electrodes(itype)%force_ions(1, 2) + electrodes(itype)%force_ions(1, 3), &
               electrodes(itype)%force_ions(2, 2) + electrodes(itype)%force_ions(2, 3), &
               electrodes(itype)%force_ions(3, 2) + electrodes(itype)%force_ions(3, 3), &
               electrodes(itype)%force_ions(1, 4) + electrodes(itype)%force_ions(1, 5), &
               electrodes(itype)%force_ions(2, 4) + electrodes(itype)%force_ions(2, 5), &
               electrodes(itype)%force_ions(3, 4) + electrodes(itype)%force_ions(3, 5), &
               electrodes(itype)%force_ions(1, 6), &
               electrodes(itype)%force_ions(2, 6), &
               electrodes(itype)%force_ions(3, 6), &
               electrodes(itype)%force_ions(1, 7), &
               electrodes(itype)%force_ions(2, 7), &
               electrodes(itype)%force_ions(3, 7), &
               electrodes(itype)%force_ions(1, 8), &
               electrodes(itype)%force_ions(2, 8), &
               electrodes(itype)%force_ions(3, 8), &
               electrodes(itype)%force_ions(3, 1) / area, &
               electrodes(itype)%velocity, electrodes(itype)%comz
      end do
   end subroutine elec_forces_dump

   ! ================================================================================
   ! Set dump frequency for dipoles
   subroutine dipoles_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%dipoles_dump_frequency = dump_frequency
   end subroutine dipoles_set_dump_frequency

   ! ================================================================================
   ! Open dipoles output file
   subroutine dipoles_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%dipoles_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("dipoles_",i6.6,".out")') rank
         else
            fname = "dipoles.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%dipoles_file_name = fname
         this%dipoles_file_unit = funit

         write(funit, '("# Dipoles on mobile particles in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Dipole:   1 au = 2.541746 D")')
         write(funit, '("#",a22,2(1x,a23))') &
               "      mux         ", "       muy         ", "       muz         "
      end if

   end subroutine dipoles_setup

   ! ================================================================================
   ! Dump dipoles to output file
   subroutine dipoles_dump(this, step, ions, dipoles_ions)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_ion_t), intent(in) :: ions(:) !< ion types parameters
      real(wp), intent(in) :: dipoles_ions(:,:) !< dipoles on ions

      ! Local
      ! -----
      integer :: funit
      integer :: iion, itype, offset, i

      funit = this%dipoles_file_unit
      write(funit, '("# step ",i8)' SIGN_SUPPRESS) step

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%mobile) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(3(es23.15E3,:,1x))') &
                     dipoles_ions(iion, 1), dipoles_ions(iion, 2), dipoles_ions(iion, 3)
            end do
         end if
      end do
   end subroutine dipoles_dump

   ! ================================================================================
   ! Set dump frequency for the electric field gradient
   subroutine efg_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%efg_dump_frequency = dump_frequency
   end subroutine efg_set_dump_frequency

   ! ================================================================================
   ! Open the electric field gradient output file
   subroutine efg_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%efg_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("efg_",i6.6,".out")') rank
         else
            fname = "efg.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%efg_file_name = fname
         this%efg_file_unit = funit

         write(funit, '("# Electric field gradient on specified ion types in atomic units")')
         write(funit, '("# ------------------------------------------------------")')
         write(funit, '("# Electric field gradient:   1 au = 9.717362E21 SI")')
         write(funit, '("#",a22,5(1x,a23))') &
               "      xx         ", "       xy         ", "       xz         ", &
               "       yy         ", "       yz         ", "       zz         "
      end if

   end subroutine efg_setup

   ! ================================================================================
   ! Dump dipoles to output file
   subroutine efg_dump(this, step, ions, efg_ions)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_ion_t), intent(in) :: ions(:) !< ion types parameters
      real(wp), intent(in) :: efg_ions(:,:) !< dipoles on ions

      ! Local
      ! -----
      integer :: funit
      integer :: iion, itype, offset, i

      funit = this%efg_file_unit
      write(funit, '("# step ",i8)' SIGN_SUPPRESS) step

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%dump_efg) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(6(es23.15E3,:,1x))') &
                     efg_ions(iion, 1), efg_ions(iion, 2), efg_ions(iion, 3), &
                     efg_ions(iion, 4), efg_ions(iion, 5), efg_ions(iion, 6)
            end do
         end if
      end do
   end subroutine efg_dump

   ! ================================================================================
   ! Set dump frequency for radius
   subroutine radius_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%radius_dump_frequency = dump_frequency
   end subroutine radius_set_dump_frequency

   ! ================================================================================
   ! Open radius output file
   subroutine radius_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%radius_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("radius_",i6.6,".out")') rank
         else
            fname = "radius.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%radius_file_name = fname
         this%radius_file_unit = funit

         write(funit, '("# Radius of mobile particles in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Radius:   1 au = 0.529177 angstrom")')
         write(funit, '("#",a22,4(1x,a23))') &
               "    delta         ", "  epsilonx         ", "  epsilony         ", "  epsilonz         "
      end if

   end subroutine radius_setup

   ! ================================================================================
   ! Dump radius to output file
   subroutine radius_dump(this, step, ions, deltas_ions,epsilons_ions)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_ion_t), intent(in) :: ions(:) !< ion types parameters
      real(wp), intent(in) :: deltas_ions(:) !< deltas of ions
      real(wp), intent(in) :: epsilons_ions(:,:) !< epsilons of ions

      ! Local
      ! -----
      integer :: funit
      integer :: iion, itype, offset, i

      funit = this%radius_file_unit
      write(funit, '("# step ",i8)' SIGN_SUPPRESS) step

      do itype = 1, size(ions,1)
         offset = ions(itype)%offset
         if (ions(itype)%mobile) then
            do i = 1, ions(itype)%count
               iion = offset + i
               write(funit, '(4(es23.15E3,:,1x))') &
                     deltas_ions(iion),epsilons_ions(iion, 1), epsilons_ions(iion, 2), epsilons_ions(iion, 3)
            end do
         end if
      end do
   end subroutine radius_dump

   ! ================================================================================
   ! Set dump frequency for potential shift
   subroutine potential_shift_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%potential_shift_dump_frequency = dump_frequency
   end subroutine potential_shift_set_dump_frequency

   ! ================================================================================
   ! Open potential shift output file
   subroutine potential_shift_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%potential_shift_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("potential_shift_",i6.6,".out")') rank
         else
            fname = "potential_shift.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_PLUS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%potential_shift_file_name = fname
         this%potential_shift_file_unit = funit

         write(funit, '("# Potential shift of the electrodes in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Potential:   1 au = 27.2113834 V")')
      end if

   end subroutine potential_shift_setup

   ! ================================================================================
   ! Dump potential shift to output file
   subroutine potential_shift_dump(this, istep, ki)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: ki

      ! Local
      ! -----
      integer :: funit

      funit = this%potential_shift_file_unit
      write(funit, '(i9,1x,es23.15E3)') istep, ki
   end subroutine potential_shift_dump

   ! ================================================================================
   ! Set dump frequency for energies
   subroutine energies_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%energies_dump_frequency = dump_frequency
   end subroutine energies_set_dump_frequency

   ! ================================================================================
   ! Open energies output file
   subroutine energies_setup(this, energies_to_dump, energy_terms_to_dump, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      use MW_lookup_table, only: MW_lut_t, lut_get, CHARLENGTH
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      character(CHARLENGTH), intent(in) :: energies_to_dump(:)     !< energy of the system
      integer, intent(in) :: energy_terms_to_dump
      integer, intent(in), optional :: rank    !< mpi rank energy_num_terms

      ! Local
      ! -----
      integer :: funit, detailed_funit
      character(64) :: fname, detailed_fname
      integer :: ierr, term
      character(256) :: errmsg
      character(len=:), allocatable :: energy_label
      character(9) :: step_str       = "# step   "
      character(25) :: hamilt_str    = "      Hamiltonian        "
      character(25) :: tot_str       = "      Total energy       "
      character(25) :: kin_str       = "     Kinetic energy      "
      character(25) :: pot_str       = "    Potential energy     "
      character(25) :: coul_str      = "     Coulomb energy      "
      character(25) :: intra_mol_str = " Intramolecular energy   "
      character(25) :: inter_mol_str = "  van_der_Waals energy   "
      character(25) :: thermo_str    = "   Thermostat energy     "
      character(25) :: baro_str      = "     Barostat energy     "
      character(25) :: coul_lr_str   = "   Coulomb LR energy     "
      character(25) :: coul_k0_str   = "  Coulomb keq0 energy    "
      character(25) :: coul_sr_str   = "   Coulomb SR energy     "
      character(25) :: coul_self_str = "  Coulomb self energy    "
      character(25) :: coul_mol_str  = " Coulomb molecule energy "
      character(25) :: harm_bond_str = "  Harmonic bond energy   "
      character(25) :: harm_ang_str  = " Harmonic angle energy   "
      character(25) :: dihedrals_str = "    Dihedrals energy     "
      character(25) :: ft_str        = "    Fumi-Tosi energy     "
      character(25) :: ft_mol_str    = "Fumi-Tosi molecule energy"
      character(25) :: xft_str       = "         XFT energy      "
      character(25) :: xft_mol_str   = "   XFT molecule energy   "
      character(25) :: lj_str        = "  Lennard-Jones energy   "
      character(25) :: lj_cut_str    = "    L-J cutoff energy    "
      character(25) :: daim_str      = "       DAIM energy       "
      character(25) :: daim_self_str = "     DAIM self energy    "
      character(25) :: piston_str    = "       Piston work       "
      character(25) :: plumed_str    = "       Plumed bias       "
      character(25) :: tf_str        = "   Thomas-Fermi energy   "
      character(25) :: ext_field_str = "  External field energy  "
      character(25) :: steele_str    = "      Steele energy      "

      if (this%energies_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("energies_",i6.6,".out")') rank
            write(detailed_fname, '("energies_breakdown_",i6.6,".out")') rank
         else
            fname = "energies.out"
            detailed_fname = "energies_breakdown.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED", status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_energies", "output.f90", fname, ierr)
         end if

         this%energies_file_name = fname
         this%energies_file_unit = funit

         call MW_fileunit_get_new_unit(detailed_funit)
         open(unit=detailed_funit, file=detailed_fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED", status="REPLACE", &
               iostat=ierr, iomsg=errmsg)
         if (ierr /= 0) then
            print *, errmsg
            call MW_errors_open_error("MW_output_energies_setup", "output.f90", detailed_fname, ierr)
         end if

         this%energies_detailed_file_name = detailed_fname
         this%energies_detailed_file_unit = detailed_funit

         ! Header
         ! ------
         write(funit, '("# Energy in atomic unit (1 Eh = 2625.499640 kJ/mol)")')
         write(funit, '("# -------------------------------------------------")')
         write(funit, '("#",a7,6(1x,a23))') " step  ", &
               "     Hamiltonian       ", &
               "     Total energy      ", &
               "    Kinetic energy     ", &
               "   Potential energy    ", &
               "Thermostat/barostat en.", &
               " External field energy "

         write(detailed_funit, '("# Energy in atomic unit (1 Eh = 2625.499640 kJ/mol)")')
         write(detailed_funit, '("# -------------------------------------------------")')

         energy_label = step_str
         do term = 1, energy_terms_to_dump
            if(energies_to_dump(term) == "Hamiltonian") energy_label = energy_label // hamilt_str
            if(energies_to_dump(term) == "Kinetic") energy_label = energy_label // kin_str
            if(energies_to_dump(term) == "Potential") energy_label = energy_label // pot_str
            if(energies_to_dump(term) == "Intramolecular") energy_label = energy_label // intra_mol_str
            if(energies_to_dump(term) == "van_der_Waals") energy_label = energy_label // inter_mol_str
            if(energies_to_dump(term) == "Total") energy_label = energy_label // tot_str
            if(energies_to_dump(term) == "Thermostat") energy_label = energy_label // thermo_str
            if(energies_to_dump(term) == "Barostat") energy_label = energy_label // baro_str
            if(energies_to_dump(term) == "Coulomb") energy_label = energy_label // coul_str
            if(energies_to_dump(term) == "Coulomb_lr") energy_label = energy_label // coul_lr_str
            if(energies_to_dump(term) == "Coulomb_keq0") energy_label = energy_label // coul_k0_str
            if(energies_to_dump(term) == "Coulomb_sr") energy_label = energy_label // coul_sr_str
            if(energies_to_dump(term) == "Coulomb_self") energy_label = energy_label // coul_self_str
            if(energies_to_dump(term) == "Coulomb_molecule") energy_label = energy_label // coul_mol_str
            if(energies_to_dump(term) == "Harmonic_bond") energy_label = energy_label // harm_bond_str
            if(energies_to_dump(term) == "Harmonic_angle") energy_label = energy_label // harm_ang_str
            if(energies_to_dump(term) == "Dihedrals") energy_label = energy_label // dihedrals_str
            if(energies_to_dump(term) == "Fumi-Tosi") energy_label = energy_label // ft_str
            if(energies_to_dump(term) == "Fumi-Tosi_molecule") energy_label = energy_label // ft_mol_str
            if(energies_to_dump(term) == "XFT") energy_label = energy_label // xft_str
            if(energies_to_dump(term) == "XFT_molecule") energy_label = energy_label // xft_mol_str
            if(energies_to_dump(term) == "Lennard-Jones") energy_label = energy_label // lj_str
            if(energies_to_dump(term) == "Lennard-Jones_cutoff") energy_label = energy_label // lj_cut_str
            if(energies_to_dump(term) == "DAIM") energy_label = energy_label // daim_str
            if(energies_to_dump(term) == "DAIM_self") energy_label = energy_label //daim_self_str
            if(energies_to_dump(term) == "Piston_work") energy_label = energy_label // piston_str
            if(energies_to_dump(term) == "Plumed_bias") energy_label = energy_label // plumed_str
            if(energies_to_dump(term) == "Thomas_Fermi") energy_label = energy_label // tf_str
            if(energies_to_dump(term) == "External_field") energy_label = energy_label // ext_field_str
            if(energies_to_dump(term) == "Steele") energy_label = energy_label // steele_str
         end do

         write(detailed_funit, "(a)") trim(energy_label)
      end if
   end subroutine energies_setup

   subroutine append_value(energy, key, str_to_append)
      use MW_lookup_table, only: MW_lut_t, lut_get
      implicit none
      ! Parameters
      ! ----------
      type(MW_lut_t), intent(in) :: energy     !< energy of the system
      character(len=*), intent(in) :: key
      character(len=:), intent(inout), allocatable :: str_to_append

      character(25) :: value_str

      write(value_str,'(1x,es24.15e3)') lut_get(energy, key)
      str_to_append = str_to_append//value_str
   end subroutine append_value

   ! ================================================================================
   ! Dump energy to output file
   subroutine energies_dump(this, step, energy, energies_to_dump, energy_terms_to_dump)
      use MW_lookup_table, only: MW_lut_t, lut_get, CHARLENGTH
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: step
      type(MW_lut_t), intent(in) :: energy     !< energy of the system
      character(CHARLENGTH), intent(in) :: energies_to_dump(:)     !< energy of the system
      integer, intent(in) :: energy_terms_to_dump

      ! Local
      ! -----
      integer :: funit, detailed_funit
      character(len=:), allocatable :: energy_values
      character(7) :: step_str
      integer :: term

      funit = this%energies_file_unit
      detailed_funit = this%energies_detailed_file_unit
      if(lut_get(energy, "Barostat").ne.0.0_wp)then
         write(funit,'(i8,6(1x,es23.15e3))') step, lut_get(energy, "Hamiltonian"), &
                                                   lut_get(energy, "Total"), &
                                                   lut_get(energy, "Kinetic"), &
                                                   lut_get(energy, "Potential"), &
                                                   lut_get(energy, "Barostat"), &
                                                   lut_get(energy, "External_field")
         write(step_str,'(i7)') step
      else
         write(funit,'(i8,6(1x,es23.15e3))') step, lut_get(energy, "Hamiltonian"), &
                                                   lut_get(energy, "Total"), &
                                                   lut_get(energy, "Kinetic"), &
                                                   lut_get(energy, "Potential"), &
                                                   lut_get(energy, "Thermostat"), &
                                                   lut_get(energy, "External_field")
         write(step_str,'(i7)') step
      endif

      energy_values = step_str
      do term = 1, energy_terms_to_dump
         call append_value(energy, energies_to_dump(term), energy_values)
      end do

      write(detailed_funit, "(a)") energy_values
   end subroutine energies_dump

   ! ================================================================================
   ! setup restart output file name
   subroutine restart_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      character(64) :: fname

      if (present(rank)) then
         write(fname, '("restart_",i6.6)') rank
      else
         fname = "restart"
      end if

      this%restart_file_name = fname

   end subroutine restart_setup

   ! ================================================================================
   ! Set dump frequency for restart
   subroutine restart_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%restart_dump_frequency = dump_frequency
   end subroutine restart_set_dump_frequency

   ! ================================================================================
   ! Set dump frequency for temperature
   subroutine temperature_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%temperature_dump_frequency = dump_frequency
   end subroutine temperature_set_dump_frequency

   ! ================================================================================
   ! Open temperature output file
   subroutine temperature_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%temperature_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("temperature_",i6.6,".out")') rank
         else
            fname = "temperature.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%temperature_file_name = fname
         this%temperature_file_unit = funit

         write(funit, '("# Temperature in K")')
         write(funit, '("# ----------------")')
         write(funit, '("# step temperature (K)")')
      end if

   end subroutine temperature_setup

   ! ================================================================================
   ! Dump temperature to output file
   subroutine temperature_dump(this, istep, temperature)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: temperature

      ! Local
      ! -----
      integer :: funit
      funit = this%temperature_file_unit
      write(funit, '(i9,1x,es23.15E3)') istep, temperature
   end subroutine temperature_dump

      ! ================================================================================
   ! Set dump frequency for pressure
   subroutine pressure_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%pressure_dump_frequency = dump_frequency
   end subroutine pressure_set_dump_frequency

   ! ================================================================================
   ! Open pressure output file
   subroutine pressure_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%pressure_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("pressure_",i6.6,".out")') rank
         else
            fname = "pressure.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%pressure_file_name = fname
         this%pressure_file_unit = funit

         write(funit, '("# Pressure of the system")')
         write(funit, '("# ----------------")')
         write(funit, '("# Pressure:   1 bar = 3.3988273773641905e-09 ua")')
         write(funit, '("#",a7,8(1x,a23))') " step  ", &
               "    Total pressure     ", &
               "     xx component      ", &
               "     yy component      ", &
               "     zz component      ", &
               "     xy component      ", &
               "     xz component      ", &
               "     yz component      ", &
               "     LR correction     "

      end if

   end subroutine pressure_setup

   ! ================================================================================
   ! Dump pressure to output file
   subroutine pressure_dump(this, istep, pressure,pressure_tensor,pressure_tail_correction)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: pressure,pressure_tail_correction
      real(wp), intent(in) :: pressure_tensor(3,3)

      ! Local
      ! -----
      integer :: funit
      funit = this%pressure_file_unit

      write(funit,'(i8,8(1x,es23.15e3))') istep, pressure, &
                                               pressure_tensor(1,1), &
                                               pressure_tensor(2,2), &
                                               pressure_tensor(3,3), &
                                               pressure_tensor(1,2), &
                                               pressure_tensor(1,3), &
                                               pressure_tensor(2,3), &
                                               pressure_tail_correction


   end subroutine pressure_dump

   ! ================================================================================
   ! Set dump frequency for stress_tensor
   subroutine stress_tensor_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%stress_tensor_dump_frequency = dump_frequency
   end subroutine stress_tensor_set_dump_frequency

   ! ================================================================================
   ! Open stress_tensor output file
   subroutine stress_tensor_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%stress_tensor_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("stress_tensor_",i6.6,".out")') rank
         else
            fname = "stress_tensor.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%stress_tensor_file_name = fname
         this%stress_tensor_file_unit = funit

         write(funit, '("# Stress tensor of the system")')
         write(funit, '("# ----------------")')
         write(funit, '("# Pressure:   1 bar = 3.3988273773641905e-09 ua")')
         write(funit, '("#",a7,6(1x,a23))') " step  ", &
               "     xx component      ", &
               "     yy component      ", &
               "     zz component      ", &
               "     xy component      ", &
               "     xz component      ", &
               "     yz component      "

      end if

   end subroutine stress_tensor_setup

   ! ================================================================================
   ! Dump stress_tensor to output file
   subroutine stress_tensor_dump(this, istep, stress_tensor)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: stress_tensor(3,3)

      ! Local
      ! -----
      integer :: funit
      funit = this%stress_tensor_file_unit

      write(funit,'(i8,6(1x,es23.15e3))') istep, stress_tensor(1,1), &
                                               stress_tensor(2,2), &
                                               stress_tensor(3,3), &
                                               stress_tensor(1,2), &
                                               stress_tensor(1,3), &
                                               stress_tensor(2,3)


   end subroutine stress_tensor_dump
   ! ================================================================================


     ! ================================================================================
   ! Set dump frequency for box parameters
   subroutine box_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%box_dump_frequency = dump_frequency
   end subroutine box_set_dump_frequency

   ! ================================================================================
   ! Open pressure output file
   subroutine box_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%box_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("box_parameters_",i6.6,".out")') rank
         else
            fname = "box_parameters.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%box_file_name = fname
         this%box_file_unit = funit

         write(funit, '("# Box parameters of the system")')
         write(funit, '("# ----------------------------")')
         write(funit, '("# Length:   1 au = 0.052917721067 nm")')
         write(funit, '("# Volume:   1 ua = 1.48184711276e-4 nm**3")')
         write(funit, '("#",a7,4(1x,a23))') " step  ", &
               "       length(1)       ", &
               "       length(2)       ", &
               "       length(3)       ", &
               "        volume         "

      end if

   end subroutine box_setup

   ! ================================================================================
   ! Dump pressure to output file
   subroutine box_dump(this, istep, volume, length)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: volume
      real(wp), intent(in) :: length(3)

      ! Local
      ! -----
      integer :: funit
      funit = this%box_file_unit

      write(funit,'(i8,4(1x,es23.15e3))') istep, length(1), length(2), length(3), volume


   end subroutine box_dump

   ! Set dump frequency for step
   subroutine step_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%step_dump_frequency = dump_frequency
   end subroutine step_set_dump_frequency

   ! ================================================================================
   ! Set dump frequency for polarization
   subroutine polarization_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%polarization_dump_frequency = dump_frequency
   end subroutine polarization_set_dump_frequency

   ! ================================================================================
   ! Open polarization output file
   subroutine polarization_setup(this, rank)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank
      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr

      if (this%polarization_dump_frequency > 0) then
         if (present(rank)) then
            write(fname, '("polarization_",i6.6,".out")') rank
         else
            fname = "polarization.out"
         end if

         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED", sign="PLUS", status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("MW_output_frequencies_setup", "output.f90", fname, ierr)
         end if

         this%polarization_file_name = fname
         this%polarization_file_unit = funit

         write(funit, '("# Polarization of the simulation cell in atomic unit")')
         write(funit, '("# -----------------------------------------")')
         write(funit, '("# Polarization:   1 au =  57.214 765 75 C/m2")')
      endif

   end subroutine polarization_setup

   ! ================================================================================
   ! Dump polarization to output file
   subroutine polarization_dump(this, istep, polarization_field)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this !< output structure
      integer, intent(in) :: istep
      real(wp), intent(in) :: polarization_field(:)
      ! Local
      ! -----
      integer :: funit

      funit = this%polarization_file_unit
      write(funit,'(i8,3(1x,es23.15e3))') istep, polarization_field(:)
   end subroutine polarization_dump

   ! ================================================================================
   ! setup diagnostic output file name
   subroutine diagnostic_setup(this, rank)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in), optional :: rank    !< mpi rank

      ! Local
      ! -----
      character(64) :: fname

      if (present(rank)) then
         write(fname, '("density_",i6.6,".out")') rank
      else
         fname = "density.out"
      end if

      this%number_density_file_name = fname

      if (present(rank)) then
         write(fname, '("charge_density_",i6.6,".out")') rank
      else
         fname = "charge_density.out"
      end if

      this%charge_density_file_name = fname

   end subroutine diagnostic_setup

   ! ================================================================================
   ! Set dump frequency for diagnostic
   subroutine diagnostic_set_dump_frequency(this, dump_frequency)
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(inout) :: this !< output structure
      integer, intent(in) :: dump_frequency    !< dump frequency
      this%diagnostic_dump_frequency = dump_frequency
   end subroutine diagnostic_set_dump_frequency

   ! --------------------------------------------------------------------------------
   ! Average density histograms
   subroutine diagnostic_dump(this, diagnostic, vol_factor, species_names)
      use MW_fileunit, only:  MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_output_t), intent(in) :: this
      type(MW_diagnostic_t), intent(in) :: diagnostic
      real(wp), intent(in) :: vol_factor
      character(PARTICLE_NAME_LEN), intent(in) :: species_names(:)

      ! Local
      ! -----
      integer :: funit
      character(64) :: fname
      integer :: ierr, ibin, ispecies
      real(wp) :: norm_factor, zbin
      integer :: num_species

      num_species = size(species_names)
      if (diagnostic%num_density_samples > 0) then
         norm_factor = 1.0_wp / (vol_factor * real(diagnostic%num_density_samples) * diagnostic%bin_width)
      else
         norm_factor = 0.0_wp
      end if


      fname = this%number_density_file_name
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
            position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
            iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_output_density_dump", "output.f90", fname, ierr)
      end if

      write(funit, '("# Number density")')
      write(funit, '("# ------------------")')
      write(funit, '("# Average over ",i10," steps.")') diagnostic%num_density_samples

      write(funit, '(100a13)') "# z (au)     ", "total        ", (species_names(ispecies),ispecies=1,num_species)

      ! write out densities
      do ibin = 1, diagnostic%num_bins
         zbin = diagnostic%zmin + (real(ibin,wp) - 0.5_wp) * diagnostic%bin_width
         write(funit, '(100f13.9)') zbin, &
               (diagnostic%number_density(ispecies,ibin)*norm_factor, ispecies=0, num_species)
      end do

      close(funit)

      fname = this%charge_density_file_name
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
            position="REWIND", form="FORMATTED" SIGN_SUPPRESS, status="REPLACE", &
            iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_output_density_dump", "output.f90", fname, ierr)
      end if

      write(funit, '("# Charge density")')
      write(funit, '("# ------------------")')
      write(funit, '("# Average over ",i10," steps.")') diagnostic%num_density_samples

      write(funit, '(100a13)') "# z (au)     ", "total        ", &
            (species_names(ispecies),ispecies=1,num_species)

      ! write out densities
      do ibin = 1, diagnostic%num_bins
         zbin = (real(ibin,wp) - 0.5_wp) * diagnostic%bin_width
         write(funit, '(100f13.9)') zbin, &
               (diagnostic%charge_density(ispecies,ibin)*norm_factor, ispecies=0,num_species)
      end do

      close(funit)
   end subroutine diagnostic_dump

end module MW_output

!> Define an electrode from the user point of view
module MW_electrode_parameters
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   use MW_species_parameters, only: SPECIES_NAME_LENGTH
   use MW_species, only: MW_species_t, &
         MW_species_identify => identify, &
         MW_species_set_electrode => set_electrode
   use MW_errors, only: MW_errors_runtime_error => runtime_error
   use MW_configuration_line, only: MW_configuration_line_t, &
         MW_configuration_line_seek_next_data => seek_next_data, &
         MW_configuration_line_get_word => get_word, &
         max_word_length
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_electrode_parameters_t

   ! Public subroutines
   ! ------------------
   public :: read_parameters
   public :: void_type
   public :: print_type
   public :: set_offsets
   public :: set_species_index
   public :: set_index

   integer, parameter, public :: ELECTRODE_NAME_LENGTH = PARTICLE_NAME_LEN

   type MW_electrode_parameters_t
      character(ELECTRODE_NAME_LENGTH) :: name = "" !< name of this electrode
      integer                          :: index = 0 !< index of this electrode
      character(SPECIES_NAME_LENGTH)   :: species_name = ""
      integer                          :: species_index = 0  !< Species type used to fill this electrode
      integer                          :: count = 0    !< number of atoms in this electrode (same as species%count
      integer                          :: offset = 0   !< offset in charge data array for this electrode
      real(wp)                         :: potential = 0.0_wp   !< potential applied to this electrode
      logical                          :: piston = .false. !< 1 if npt-piston simulation
      real(wp)                         :: pressure = 0.0_wp !< pressure if npt-piston
      real(wp)                         :: thomas_fermi_length
      real(wp)                         :: voronoi_volume
   end type MW_electrode_parameters_t

contains

   !================================================================================
   !> Void an electrode data structure
   subroutine void_type(this)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      this%name = ""
      this%index = 0
      this%species_name = ""
      this%species_index = 0
      this%count = 0
      this%offset = 0
      this%potential = 0.0_wp
      this%piston = .false.
      this%pressure = 0.0_wp
      this%thomas_fermi_length = 0.0_wp
      this%voronoi_volume = 0.0_wp
   end subroutine void_type

   !================================================================================
   !> Print an electrode data structure
   subroutine print_type(this, ounit)
      implicit none
      type(MW_electrode_parameters_t), intent(in) :: this
      integer,              intent(in) :: ounit

      write(ounit,'("|electrode| name: ",a16)') this%name
      write(ounit,'("|electrode| species: ",a8," (",i3,")")') this%species_name, this%species_index
      write(ounit,'("|electrode| count: ",i8," offset: ", i8)') this%count, this%offset
      write(ounit,'("|electrode| potential: ",es12.5)') this%potential
      if (this%piston) then
         write(ounit,'("|electrode| npt-piston at pressure: ",es12.5)') this%pressure
      end if

   end subroutine print_type

   ! ================================================================================
   !> Set the name of the electrode
   subroutine set_name(this, name)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      character(len=*),                intent(in)    :: name
      this%name = name
   end subroutine set_name

   ! ================================================================================
   !> Set the index of the electrode
   subroutine set_index(this, index)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      integer, intent(in) :: index
      this%index = index
   end subroutine set_index

   ! ================================================================================
   !> Set the species type name for the electrode
   subroutine set_species_name(this, species_name)
      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_parameters_t), intent(inout) :: this
      character(*),                    intent(in)    :: species_name       !< name of the species

      this%species_name = species_name
   end subroutine set_species_name

   ! ================================================================================
   !> Set the species type index for the electrode
   subroutine set_species_index(this, species)
      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_parameters_t), intent(inout) :: this
      type(MW_species_t),              intent(inout) :: species(:) !< array of species

      ! Local
      ! -----
      integer :: species_index
      character(256) :: errmsg

      call MW_species_identify(this%species_name, species, species_index)
      if (species_index > 0) then
         this%species_index = species_index
         call MW_species_set_electrode(species(species_index), this%name, this%index)
      else
         write(errmsg,'("Unknown species name,",a8,", for electrode ",a8)') &
               this%species_name, this%name
         call MW_errors_runtime_error("set_species","electrode_parameters.f90", &
               errmsg)
      end if

   end subroutine set_species_index

   ! ================================================================================
   !> Set the species type for the electrode
   subroutine set_potential(this, potential)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      real(wp),                        intent(in)    :: potential
      this%potential = potential
   end subroutine set_potential

   ! ================================================================================
   !> Set the pressure for the electrode
   subroutine set_pressure(this, pressure, direction)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      real(wp),                        intent(in)    :: pressure, direction
      this%piston = .true.
      this%pressure = direction * pressure
   end subroutine set_pressure

   ! ================================================================================
   !> Set offsets for a list of electrodes
   subroutine set_offsets(electrodes)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: electrodes(:)

      integer :: i, n, offset
      n = size(electrodes,1)
      offset = 0
      do i = 1, n
         electrodes(i)%offset = offset
         offset = offset + electrodes(i)%count
      end do
   end subroutine set_offsets

   ! ================================================================================
   !> Set the thomas_fermi length of the electrode
   subroutine set_thomas_fermi_length(this, thomas_fermi_length)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      real(wp), intent(in) :: thomas_fermi_length
      this%thomas_fermi_length = thomas_fermi_length
   end subroutine set_thomas_fermi_length

   ! ================================================================================
   !> Set the voronoi volume of the electrode atoms
   subroutine set_voronoi_volume(this, voronoi_volume)
      implicit none
      type(MW_electrode_parameters_t), intent(inout) :: this
      real(wp), intent(in) :: voronoi_volume
      this%voronoi_volume = voronoi_volume
   end subroutine set_voronoi_volume

   !================================================================================
   !> Read electrode parameters from runtime.inpt
   !!
   !! Block format:
   !! -------------
   !! electrode_type *block*
   !!   name *string*
   !!   species *string*
   !!   potential *real*
   !!   piston *real* *int*
   !!
   !! Parameters
   !! ----------
   !! funit : integer
   !!    handle to the runtime input file
   !!
   !! line_num : integer
   !!    current line number in the runtime input file
   subroutine read_parameters(this, funit, line_num, compute_force)
      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_parameters_t), intent(inout) :: this
      integer, intent(in) :: funit
      integer, intent(inout) :: line_num
      logical, intent(inout) :: compute_force

      ! Local
      ! -----
      type(MW_configuration_line_t) :: config_line
      character(max_word_length) :: keyword
      character(ELECTRODE_NAME_LENGTH) :: name
      character(SPECIES_NAME_LENGTH) :: species
      real(wp) :: potential, pressure, direction, thomas_fermi_length, voronoi_volume
      integer :: name_defined, species_defined, potential_defined, piston_defined
      integer :: thomas_fermi_length_defined, voronoi_volume_defined
      character(256) :: errmsg

      ! Void data structure
      call void_type(this)

      ! Set default values
      name = "****"
      species = "****"
      potential = 0.0_wp
      pressure = 0.0_wp
      direction = 1.0_wp
      thomas_fermi_length = 0.0_wp
      voronoi_volume = 0.0_wp

      ! Flag each section as undefined (line number will be stored)
      name_defined = 0
      species_defined = 0
      potential_defined = 0
      piston_defined = 0
      thomas_fermi_length_defined = 0
      voronoi_volume_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("name")
            if (name_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |name|. First definition at line ",i4,".")') &
                     line_num, name_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            name_defined = line_num

            ! Read name parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for name parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, name)

         case("species")
            if (species_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |species|. First definition at line ",i4,".")') &
                     line_num, species_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            species_defined = line_num

            ! Read species name parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for species parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, species)

         case("potential")
            if (potential_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |potential|. First definition at line ",i4,".")') &
                     line_num, potential_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            potential_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for potential parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, potential)

         case("piston")
            if (piston_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |piston|. First definition at line ",i4,".")') &
                     line_num, piston_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            piston_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for potential parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, pressure)
            call MW_configuration_line_get_word(config_line, 3, direction)

         case("thomas_fermi_length")
            if (thomas_fermi_length_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |thomas_fermi_length|. First definition at line ",i4,".")') &
                     line_num, thomas_fermi_length_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            thomas_fermi_length_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for Thomas-Fermi length at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, thomas_fermi_length)

         case("voronoi_volume")
            if (voronoi_volume_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |voronoi_volume|. First definition at line ",i4,".")') &
                     line_num, voronoi_volume_defined
               call MW_errors_runtime_error("read_parameters", "electrode_parameters.f90", errmsg)
            end if
            voronoi_volume_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for Voronoi volume at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","electrode_parameters.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, voronoi_volume)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop

         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      call set_name(this, name)
      call set_species_name(this, species)
      call set_potential(this, potential)
      if (piston_defined > 0) then
         call set_pressure(this, pressure, direction)
         compute_force = .true.
      end if
      call set_thomas_fermi_length(this, thomas_fermi_length)
      call set_voronoi_volume(this, voronoi_volume)

   end subroutine read_parameters

end module MW_electrode_parameters

! Module to compute long-range part of electrostatic (Coulomb) potential
module MW_coulomb_lr
   use MW_kinds, only: wp
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_constants, only: twopi, block_vector_size
   use MW_electrode, only: MW_electrode_t
   use MW_molecule, only: MW_molecule_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: diag_gradQelec_potential !diag[grad_Q [grad_Q [U^lr_QQ]]]
   public :: gradQelec_potential !grad_Q [grad_Q [U^lr_QQ]]
   public :: qmelt2Qelec_potential !grad_Q [U^lr_qQ]
   public :: Qelec2Qelec_potential !grad_Q [U^lr_QQ]
   public :: melt_efg !-grad_r grad_r [(U^lr_qq)]
   public :: melt_forces !-grad_r [(U^lr_qq) + (U^lr_QQ) + (U^lr_qQ)]
   public :: energy !(U^lr_qq) + (U^lr_QQ) + (U^lr_qQ)

contains

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine diag_gradQelec_potential(localwork, ewald, box, &
         electrodes, diag_gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(inout) :: ewald      !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box        !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: diag_gradQ_V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: volfactor
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky
      real(wp) :: cos_kxkykz_i, sin_kxkykz_i
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      ! Precompute some factors
      ! -----------------------
      num_elec_types = size(electrodes,1)

      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), diag_gradQ_V(:))

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp / box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz_i, sin_kxkykz_i, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m), wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n), wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then
                  Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                        (exp(alphaconst * knorm2) / knorm2)
                  !$acc loop vector
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz_i = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz_i = sin_kxky * cos_kz + cos_kxky * sin_kz

                     !Non-parallelized loop over all particles
                     !$acc atomic update
                     diag_gradQ_V(i) = diag_gradQ_V(i) + Sk_alpha * (cos_kxkykz_i*cos_kxkykz_i + sin_kxkykz_i*sin_kxkykz_i) ! the term in parenthesis is 1!
                  end do
                  !$acc end loop
               end if
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data
  end subroutine diag_gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine gradQelec_potential(localwork, ewald, box, electrodes, gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(inout) :: ewald      !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box        !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: gradQ_V(:,:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i, j, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: volfactor
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky
      real(wp) :: cos_kxkykz_i, sin_kxkykz_i, cos_kxkykz_j, sin_kxkykz_j
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      ! Precompute some factors
      ! -----------------------
      num_elec_types = size(electrodes,1)

      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), gradQ_V(:,:))

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp / box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz_i, sin_kxkykz_i, &
            !$acc         cos_kxkykz_j, sin_kxkykz_j, i)

            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m), wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n), wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then
                  Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                        (exp(alphaconst * knorm2) / knorm2)
                  !$acc loop vector
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz_i = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz_i = sin_kxky * cos_kz + cos_kxky * sin_kz
                     !Non-parallelized loop over all particles
                     do j = 1,i

                        cos_kx = ewald%cos_kx_elec(j,l)
                        sin_kx = ewald%sin_kx_elec(j,l)
                        cos_ky = ewald%cos_ky_elec(j,mabs)
                        sin_ky = ewald%sin_ky_elec(j,mabs) * sign_m
                        cos_kz = ewald%cos_kz_elec(j,nabs)
                        sin_kz = ewald%sin_kz_elec(j,nabs) * sign_n

                        cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                        sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                        cos_kxkykz_j = cos_kxky * cos_kz - sin_kxky * sin_kz
                        sin_kxkykz_j = sin_kxky * cos_kz + cos_kxky * sin_kz

                        !$acc atomic update
                        gradQ_V(j,i) = gradQ_V(j,i) + Sk_alpha * (cos_kxkykz_i*cos_kxkykz_j + sin_kxkykz_i*sin_kxkykz_j)
                     end do
                  end do
                  !$acc end loop
               end if
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data
   end subroutine gradQelec_potential

   !================================================================================
   ! Compute the long-range Coulomb potential felt by each electrode
   ! atoms due to all melt ions
   subroutine qmelt2Qelec_potential(localwork, ewald, box, &
                   ions, electrodes, V, type_ions)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork  !< Local work assignment
      type(MW_ewald_t), intent(inout)  :: ewald      !< Ewald summation parameters
      type(MW_box_t),   intent(in)     :: box        !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      integer, intent(in) :: type_ions(:)      ! Ions type

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: num_ions, num_elec_atoms
      integer :: i, j, jtype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qj !< ion charge
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: volfactor
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: sk_cos, sk_sin
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      num_ions = 0
      if (num_ion_types > 0) then
         num_ions = ions(num_ion_types)%offset+ions(num_ion_types)%count
      end if
      num_elec_atoms = 0
      if (num_elec_types > 0) then
         num_elec_atoms = electrodes(num_elec_types)%offset+electrodes(num_elec_types)%count
      end if

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)

      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      volfactor = 2.0_wp / box%area(3)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_pbc = ewald%num_pbc

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), V(:))

      ! Initiliaze potential to 0
      ! -------------------------
      !$acc kernels
      V(:) = 0.0_wp
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes in the exectude globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank

      ! Setup cache blocking parameters
      num_blocks = (num_ions-1)/block_vector_size + 1
      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_ions)

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
         !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
         !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp) * twopi) * box_lengthx_rec
            ! ky = m * twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m), wp)
            ky = (real(m,wp) * twopi) * box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n), wp)
            kz = ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then

               sk_cos = 0.0_wp
               sk_sin = 0.0_wp
               !$acc loop vector reduction(+: sk_cos, sk_sin)
               do j = istart_block, iend_block
                  jtype = type_ions(j)
                  qj = ions(jtype)%charge

                  cos_kx = ewald%cos_kx_ions(j,l)
                  sin_kx = ewald%sin_kx_ions(j,l)
                  cos_ky = ewald%cos_ky_ions(j,mabs)
                  sin_ky = ewald%sin_ky_ions(j,mabs) * sign_m
                  cos_kz = ewald%cos_kz_ions(j,nabs)
                  sin_kz = ewald%sin_kz_ions(j,nabs) * sign_n

                  cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                  sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                  cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                  sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                  sk_cos = sk_cos + qj*cos_kxkykz
                  sk_sin = sk_sin + qj*sin_kxkykz
               end do
               !$acc end loop
               ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
               ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin

            end if
         end do
         !$acc end loop
         !$acc end parallel
      end do

      ! Setup cache blocking parameters
      num_blocks = (num_elec_atoms-1)/block_vector_size + 1
      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_elec_atoms)

         num_modes = localwork%ewald_num_mode_local
         l = localwork%ewald_kstart_x
         m = localwork%ewald_kstart_y
         n = localwork%ewald_kstart_z

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
         !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
         !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp) * twopi) * box_lengthx_rec
            ! ky = m * twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m), wp)
            ky = (real(m,wp) * twopi) * box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n), wp)
            kz = sign_n*ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then

               Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                     (exp(alphaconst*knorm2) / knorm2)
               !$acc loop vector
               do i = istart_block, iend_block

                  cos_kx = ewald%cos_kx_elec(i,l)
                  sin_kx = ewald%sin_kx_elec(i,l)
                  cos_ky = ewald%cos_ky_elec(i,mabs)
                  sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                  cos_kz = ewald%cos_kz_elec(i,nabs)
                  sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                  cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                  sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                  cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                  sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz
                  !$acc atomic update
                  V(i) = V(i) + Sk_alpha * (cos_kxkykz*ewald%Sk_cos(imode) &
                        + sin_kxkykz*ewald%Sk_sin(imode))
               end do
               !$acc end loop
            end if
         end do
         !$acc end loop
         !$acc end parallel
      end do
      !$acc end data
   end subroutine qmelt2Qelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine Qelec2Qelec_potential(localwork, ewald, box, &
         electrodes, q_elec, V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(inout) :: ewald      !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box        !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: q_elec(:)       !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i, j, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: volfactor
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: sk_cos, sk_sin
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      ! Precompute some factors
      ! -----------------------
      num_elec_types = size(electrodes,1)

      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), q_elec(:), V(:))

      !$acc kernels
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp / box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m), wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n), wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  sk_cos = 0.0_wp
                  sk_sin = 0.0_wp
                  !$acc loop vector reduction(+: sk_cos, sk_sin)
                  do j = istart_block, iend_block

                     cos_kx = ewald%cos_kx_elec(j,l)
                     sin_kx = ewald%sin_kx_elec(j,l)
                     cos_ky = ewald%cos_ky_elec(j,mabs)
                     sin_ky = ewald%sin_ky_elec(j,mabs) * sign_m
                     cos_kz = ewald%cos_kz_elec(j,nabs)
                     sin_kz = ewald%sin_kz_elec(j,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                     Sk_cos = Sk_cos + q_elec(j)*cos_kxkykz
                     Sk_sin = Sk_sin + q_elec(j)*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin
               end if
            end do
            !$acc end loop
            !$acc end parallel
         end do
      end do

      ! Setup cache blocking parameters
      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m), wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n), wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then
                  Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                        (exp(alphaconst * knorm2) / knorm2)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz
                     !$acc atomic update
                     V(i) = V(i) + Sk_alpha * (cos_kxkykz*ewald%Sk_cos(imode) + sin_kxkykz*ewald%Sk_sin(imode))
                  end do
                  !$acc end loop
               end if
            end do
            !$acc end loop
            !$acc end parallel
         end do
      end do
      !$acc end data
   end subroutine Qelec2Qelec_potential

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(localwork, ewald, box, ions, &
         electrodes, q_elec, force,stress_tensor, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)         !< ions parameters
      type(MW_electrode_t), intent(inout) :: electrodes(:)   !< electrodes parameters
      real(wp),             intent(in) :: q_elec(:)       !< Electrode atoms charge
      logical,              intent(in) :: compute_force       !< compute electrode force

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< Coulomb force on ions
      real(wp), intent(inout) :: stress_tensor(:,:) !< Coulomb force contribution to the stress tensor

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: sk_cos, sk_sin
      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc
      real(wp) :: stfac1,stfac2
      real(wp) :: loc_stress_tensor_xx, loc_stress_tensor_yy, loc_stress_tensor_zz
      real(wp) :: loc_stress_tensor_xy, loc_stress_tensor_xz, loc_stress_tensor_yz

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      loc_stress_tensor_xx = 0.0_wp
      loc_stress_tensor_yy = 0.0_wp
      loc_stress_tensor_zz = 0.0_wp
      loc_stress_tensor_xy = 0.0_wp
      loc_stress_tensor_xz = 0.0_wp
      loc_stress_tensor_yz = 0.0_wp

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = - 1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), q_elec(:), force(:,:), &
      !$acc        electrodes, electrodes%force_ions) &
      !$acc copy(loc_stress_tensor_xx,loc_stress_tensor_yy,loc_stress_tensor_zz, &
      !$acc           loc_stress_tensor_xy,loc_stress_tensor_xz,loc_stress_tensor_yz)

      !$acc kernels
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp / box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  sk_cos = 0.0_wp
                  sk_sin = 0.0_wp
                  !$acc loop vector reduction(+: sk_cos, sk_sin)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                     sk_cos = sk_cos + qi*cos_kxkykz
                     sk_sin = sk_sin + qi*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin

               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count

         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then
                  sk_cos = 0.0_wp
                  sk_sin = 0.0_wp
                  ! Atoms contribution to structure factor
                  !$acc loop vector reduction(+: sk_cos, sk_sin)
                  do i = istart_block, iend_block
                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                     sk_cos = sk_cos + q_elec(i)*cos_kxkykz
                     sk_sin = sk_sin + q_elec(i)*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp) * twopi) * box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp) * twopi) * box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n * ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz                       !xkk
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                        (exp(alphaconst*knorm2) / knorm2)          ! akk*8pi/V

                  !$acc loop vector
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs) * sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs) * sign_n

                     cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                     sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                     cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                     sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                     ! force
                     !$acc atomic update
                     force(i,1) = force(i,1) + qi * kx * Sk_alpha * &
                          (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                     !$acc atomic update
                     force(i,2) = force(i,2) + qi * ky * Sk_alpha * &
                          (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                     !$acc atomic update
                     force(i,3) = force(i,3) + qi * kz * Sk_alpha * &
                          (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))

                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      ! Setup cache blocking parameters
      !$acc parallel
      !$acc loop gang &
      !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
      !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
      !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i) reduction(+:loc_stress_tensor_xx,&
      !$acc                       loc_stress_tensor_yy,loc_stress_tensor_zz, &
      !$acc                       loc_stress_tensor_xy,loc_stress_tensor_xz, &
      !$acc                       loc_stress_tensor_yz)
      do imode = 1, num_modes
         call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
         ! kx = l * twopi / box%length(1)
         kx = (real(l,wp) * twopi) * box_lengthx_rec
         ! ky = m * twopi / box%length(2)
         mabs = abs(m)
         sign_m = real(sign(1,m),wp)
         ky = (real(m,wp) * twopi) * box_lengthy_rec
         ! kz = zpoint(n)
         nabs = abs(n)
         sign_n = real(sign(1,n),wp)
         kz = sign_n * ewald%zpoint(nabs)

         ! Norm square of the k-mode vector
         knorm2 = kx*kx + ky*ky + kz*kz                       !xkk
         if (knorm2 <= ewald%knorm2_max) then

            Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                  (exp(alphaconst*knorm2) / knorm2)          ! akk*8pi/V

            stfac1 = (4.0_wp*alphasq+knorm2)/(4.0_wp*alphasq*knorm2)
            stfac2 = Sk_alpha * (ewald%Sk_cos(imode)**2.0+ewald%Sk_sin(imode)**2.0)/2.0_wp

            loc_stress_tensor_xx=loc_stress_tensor_xx+ &
                     (1.0_wp-2.0_wp * kx * kx * stfac1)*stfac2
            loc_stress_tensor_yy=loc_stress_tensor_yy+ &
                     (1.0_wp-2.0_wp * ky * ky * stfac1)*stfac2
            loc_stress_tensor_zz=loc_stress_tensor_zz+ &
                     (1.0_wp-2.0_wp * kz * kz * stfac1)*stfac2
            loc_stress_tensor_xy=loc_stress_tensor_xy+ &
                     (-2.0_wp * kx * ky * stfac1)*stfac2
            loc_stress_tensor_xz=loc_stress_tensor_xz+ &
                     (-2.0_wp * kx * kz * stfac1)*stfac2
            loc_stress_tensor_yz=loc_stress_tensor_yz+ &
                     (-2.0_wp * ky * kz * stfac1)*stfac2
         end if
      end do ! imode
      !$acc end loop
      !$acc end parallel

      ! Setup cache blocking parameters
      if (compute_force) then
         do itype = 1, num_elec_types
            num_blocks = 0
            if (electrodes(itype)%count > 0) then
               num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
            end if
            iend_type = electrodes(itype)%offset + electrodes(itype)%count
            do iblock = 1, num_blocks
               istart_block = (iblock-1)*block_vector_size + electrodes(itype)%offset + 1
               iend_block = min(istart_block+block_vector_size-1,iend_type)

               !$acc parallel
               !$acc loop gang &
               !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
               !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
               !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i)
               do imode = 1, num_modes
                  call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
                  ! kx = l * twopi / box%length(1)
                  kx = (real(l,wp) * twopi) * box_lengthx_rec
                  ! ky = m * twopi / box%length(2)
                  mabs = abs(m)
                  sign_m = real(sign(1,m),wp)
                  ky = (real(m,wp) * twopi) * box_lengthy_rec
                  ! kz = zpoint(n)
                  nabs = abs(n)
                  sign_n = real(sign(1,n),wp)
                  kz = sign_n * ewald%zpoint(nabs)

                  ! Norm square of the k-mode vector
                  knorm2 = kx*kx + ky*ky + kz*kz
                  if (knorm2 <= ewald%knorm2_max) then

                     Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                           (exp(alphaconst*knorm2) / knorm2)

                     !$acc loop vector
                     do i = istart_block, iend_block

                        cos_kx = ewald%cos_kx_elec(i,l)
                        sin_kx = ewald%sin_kx_elec(i,l)
                        cos_ky = ewald%cos_ky_elec(i,mabs)
                        sin_ky = ewald%sin_ky_elec(i,mabs) * sign_m
                        cos_kz = ewald%cos_kz_elec(i,nabs)
                        sin_kz = ewald%sin_kz_elec(i,nabs) * sign_n

                        cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                        sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                        cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                        sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                        ! force
                        electrodes(itype)%force_ions(1,6) = electrodes(itype)%force_ions(1,6) + q_elec(i) * kx * Sk_alpha * &
                             (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                        electrodes(itype)%force_ions(2,6) = electrodes(itype)%force_ions(2,6) + q_elec(i) * ky * Sk_alpha * &
                             (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                        electrodes(itype)%force_ions(3,6) = electrodes(itype)%force_ions(3,6) + q_elec(i) * kz * Sk_alpha * &
                             (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))

                     end do ! ni
                     !$acc end loop
                  end if
               end do ! imode
               !$acc end loop
               !$acc end parallel
            end do
         end do
      end if

      !$acc end data
      stress_tensor(1,1) = loc_stress_tensor_xx
      stress_tensor(2,2) = loc_stress_tensor_yy
      stress_tensor(3,3) = loc_stress_tensor_zz
      stress_tensor(1,2) = loc_stress_tensor_xy
      stress_tensor(1,3) = loc_stress_tensor_xz
      stress_tensor(2,3) = loc_stress_tensor_yz

   end subroutine melt_forces

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   subroutine energy(localwork, ewald, box, ions, &
         electrodes, q_elec, h)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald           !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)         !< ions parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrodes parameters
      real(wp),             intent(in) :: q_elec(:)       !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h !< energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, itype, iion
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_cos, Sk_sin, Sk_alpha , Sk_cos_type, Sk_sin_type !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      integer :: imode, num_modes, mode_offset
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = - 1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset


      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, ions(:), electrodes(:), &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        q_elec(:)) copy(h)

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 1.0_wp / box%area(3)

      !$acc parallel
      !$acc loop gang &
      !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
      !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
      !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i, qi, Sk_alpha) &
      !$acc reduction(+:h)

      do imode = 1, num_modes
         call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
         ! kx = l * twopi / box%length(1)
         kx = (real(l,wp) * twopi) * box_lengthx_rec
         ! ky = m * twopi / box%length(2)
         mabs = abs(m)
         sign_m = real(sign(1,m),wp)
         ky = (real(m,wp) * twopi) * box_lengthy_rec
         ! kz = zpoint(n)
         nabs = abs(n)
         sign_n = real(sign(1,n),wp)
         kz = sign_n * ewald%zpoint(nabs)

         ! Norm square of the k-mode vector
         knorm2 = kx*kx + ky*ky + kz*kz
         if (knorm2 <= ewald%knorm2_max) then

            Sk_cos = 0.0_wp
            Sk_sin = 0.0_wp

            ! Ions contribution to structure factor
            !$acc loop seq
            do itype = 1, num_ion_types
               qi = ions(itype)%charge
               Sk_cos_type = 0.0_wp
               Sk_sin_type = 0.0_wp
               !$acc loop vector reduction(+: Sk_cos_type, Sk_sin_type)
               do i = 1, ions(itype)%count
                  iion = ions(itype)%offset + i
                  cos_kx = ewald%cos_kx_ions(iion,l)
                  sin_kx = ewald%sin_kx_ions(iion,l)
                  cos_ky = ewald%cos_ky_ions(iion,mabs)
                  sin_ky = ewald%sin_ky_ions(iion,mabs) * sign_m
                  cos_kz = ewald%cos_kz_ions(iion,nabs)
                  sin_kz = ewald%sin_kz_ions(iion,nabs) * sign_n

                  cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                  sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                  cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                  sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                  Sk_cos_type = Sk_cos_type + qi*cos_kxkykz
                  Sk_sin_type = Sk_sin_type + qi*sin_kxkykz
               end do
               !$acc end loop
               Sk_cos = Sk_cos + Sk_cos_type
               Sk_sin = Sk_sin + Sk_sin_type
            end do
            !$acc end loop

            ! Atoms contribution to structure factor
            !$acc loop seq
            do itype = 1, num_elec_types
               Sk_cos_type = 0.0_wp
               Sk_sin_type = 0.0_wp
               !$acc loop vector reduction(+: Sk_cos_type, Sk_sin_type)
               do i = 1, electrodes(itype)%count
                  iion = electrodes(itype)%offset + i
                  cos_kx = ewald%cos_kx_elec(iion,l)
                  sin_kx = ewald%sin_kx_elec(iion,l)
                  cos_ky = ewald%cos_ky_elec(iion,mabs)
                  sin_ky = ewald%sin_ky_elec(iion,mabs) * sign_m
                  cos_kz = ewald%cos_kz_elec(iion,nabs)
                  sin_kz = ewald%sin_kz_elec(iion,nabs) * sign_n

                  cos_kxky = cos_kx * cos_ky - sin_kx * sin_ky
                  sin_kxky = sin_kx * cos_ky + cos_kx * sin_ky

                  cos_kxkykz = cos_kxky * cos_kz - sin_kxky * sin_kz
                  sin_kxkykz = sin_kxky * cos_kz + cos_kxky * sin_kz

                  Sk_cos_type = Sk_cos_type + q_elec(iion)*cos_kxkykz
                  Sk_sin_type = Sk_sin_type + q_elec(iion)*sin_kxkykz
               end do
               !$acc end loop
               Sk_cos = Sk_cos + Sk_cos_type
               Sk_sin = Sk_sin + Sk_sin_type
            end do
            !$acc end loop
            Sk_alpha = 2.0_wp * volfactor * ewald%zweight(nabs) * &
                  (exp(alphaconst*knorm2) / knorm2)
            h = h + Sk_alpha * (Sk_cos*Sk_cos + Sk_sin*Sk_sin)
         end if
      end do ! imode
      !$acc end loop
      !$acc end parallel
      !$acc end data
   end subroutine energy

   !=========================================================================================
   ! Compute the electric field gradient felt by each melt ion due to other melt ions charges
   subroutine melt_efg(localwork, ewald, box, ions, efg)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: efg(:,:)        !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: i, itype
      logical :: itype_needs_efg
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: sk_cos, sk_sin
      real(wp) :: efg_imode

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ion_types = size(ions,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      ! Zero the arrays for sums of sin and cos before the computation.
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Ions: cache thu sums over sin and cos.
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            ! Each processor works on its part of modes in parallel.
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  sk_cos = 0.0_wp
                  sk_sin = 0.0_wp
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     sk_cos = sk_cos + qi*cos_kxkykz
                     sk_sin = sk_sin + qi*sin_kxkykz
                  end do
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin

               end if
            end do ! imode
         end do
      end do

      ! Compute the contribution to the electric field gradient on ion positions.
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         itype_needs_efg = ions(itype)%dump_efg

         ! Run the computation for selected ion types only
         if (itype_needs_efg) then
            num_blocks = 0
            if (ions(itype)%count > 0) then
               num_blocks = (ions(itype)%count-1)/block_vector_size + 1
            end if
            iend_type = ions(itype)%offset + ions(itype)%count
            do iblock = 1, num_blocks
               istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
               iend_block = min(istart_block+block_vector_size-1,iend_type)

               do imode = 1, num_modes
                  call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
                  ! kx = l * twopi / box%length(1)
                  kx = (real(l,wp)*twopi)*box_lengthx_rec
                  ! ky = m*twopi / box%length(2)
                  mabs = abs(m)
                  sign_m = real(sign(1,m),wp)
                  ky = (real(m,wp)*twopi)*box_lengthy_rec
                  ! kz = zpoint(n)
                  nabs = abs(n)
                  sign_n = real(sign(1,n),wp)
                  kz = sign_n*ewald%zpoint(nabs)

                  ! Norm square of the k-mode vector
                  knorm2 = kx*kx + ky*ky + kz*kz
                  if (knorm2 <= ewald%knorm2_max) then

                     Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                     do i = istart_block, iend_block
                        cos_kx = ewald%cos_kx_ions(i,l)
                        sin_kx = ewald%sin_kx_ions(i,l)
                        cos_ky = ewald%cos_ky_ions(i,mabs)
                        sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                        cos_kz = ewald%cos_kz_ions(i,nabs)
                        sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                        cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                        sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                        cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                        sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                        ! The efg prefactor for a fixed k-vector
                        efg_imode = Sk_alpha*(sin_kxkykz*ewald%Sk_sin(imode) + &
                                              cos_kxkykz*ewald%Sk_cos(imode))

                        ! Electric field gradient components
                        efg(i,1) = efg(i,1) + kx*kx*efg_imode ! xx
                        efg(i,2) = efg(i,2) + kx*ky*efg_imode ! xy
                        efg(i,3) = efg(i,3) + kx*kz*efg_imode ! xz
                        efg(i,4) = efg(i,4) + ky*ky*efg_imode ! yy
                        efg(i,5) = efg(i,5) + ky*kz*efg_imode ! yz
                        efg(i,6) = efg(i,6) + kz*kz*efg_imode ! zz

                     end do ! ni
                  end if
               end do ! imode
            end do
         end if ! itype_needs_efg
      end do

   end subroutine melt_efg

   include 'update_kmode_index.inc'

end module MW_coulomb_lr

! Module defining Ewald summation parameters
module MW_ewald
   use MW_kinds, only: wp
   implicit none
   private

   ! Public types
   ! ------------
   public :: MW_ewald_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: define_zscale
   public :: define_kpoints
   public :: redefine_kpoints
   public :: define_Skcossin
   public :: define_Skmucossin
   public :: redefine_Skcossin
   public :: redefine_Skmucossin
   public :: void_type
   public :: print_type
   public :: setup_cossin_ions
   public :: setup_cossin_elec
   public :: update_kmode_index
   public :: set_num_pbc

   !> Ewald summation parameters
   type MW_ewald_t
      real(wp) :: alpha         !< numerical parameter which split computation between
      !! long range and short range contribution

      integer :: num_pbc = 0 !< number of periodic boundary conditions

      ! Real space summation parameters
      real(wp) :: rtol    !< Tolerance on real space summation terms
      real(wp) :: rcut    !< cut-off distance for real space summation
      real(wp) :: rcutsq  !< cut-off distance (squared) for real space summation
      logical, allocatable :: sr_interaction_ion2ion(:,:) !< Flag if 2 particle types interact via short range interactions
      logical, allocatable :: sr_interaction_atom2atom(:,:) !< Flag if 2 particle types interact via short range interactions
      logical, allocatable :: sr_interaction_ion2atom(:,:) !< Flag if 2 particle types interact via short range interactions
      logical, allocatable :: sr_interaction_atom2ion(:,:) !< Flag if 2 particle types interact via short range interactions

      ! Reciprocal space summation parameters
      real(wp) :: ktol
      integer  :: kmax_x
      integer  :: kmax_y
      integer  :: kmax_z
      real(wp) :: knorm2_max
      real(wp) :: zscale_weight = 1.0_wp
      real(wp) :: zscale_range  = 1.0_wp


      ! Z integral parameter (quadrature must be symmetric around 0)
      real(wp), allocatable :: zpoint(:)
      real(wp), allocatable :: zweight(:)

      ! cos and sin for reciprocal summation
      real(wp), allocatable :: cos_kx_ions(:,:)
      real(wp), allocatable :: cos_ky_ions(:,:)
      real(wp), allocatable :: cos_kz_ions(:,:)

      real(wp), allocatable :: sin_kx_ions(:,:)
      real(wp), allocatable :: sin_ky_ions(:,:)
      real(wp), allocatable :: sin_kz_ions(:,:)

      real(wp), allocatable :: cos_kx_elec(:,:)
      real(wp), allocatable :: cos_ky_elec(:,:)
      real(wp), allocatable :: cos_kz_elec(:,:)

      real(wp), allocatable :: sin_kx_elec(:,:)
      real(wp), allocatable :: sin_ky_elec(:,:)
      real(wp), allocatable :: sin_kz_elec(:,:)

      real(wp), allocatable :: Sk_cos(:)
      real(wp), allocatable :: Sk_sin(:)
      real(wp), allocatable :: Skmux_cos(:)
      real(wp), allocatable :: Skmux_sin(:)
      real(wp), allocatable :: Skmuy_cos(:)
      real(wp), allocatable :: Skmuy_sin(:)
      real(wp), allocatable :: Skmuz_cos(:)
      real(wp), allocatable :: Skmuz_sin(:)

   end type MW_ewald_t

contains

   !================================================================================
   ! Define ewald parameters
   subroutine define_type(this, rtol, rcut, ktol)
      use MW_kinds, only: wp
      implicit none

      ! Parameters in
      ! -------------
      real(wp),       intent(in) :: rtol      !< Short-range precision on summation terms
      real(wp),       intent(in) :: rcut      !< Short-range cutoff
      real(wp),       intent(in) :: ktol      !< Long-range summation precision

      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(inout) :: this

      ! Local
      ! -----
      real(wp) :: alpha

      ! summation gaussian parameters
      call compute_alpha(rcut, rtol, alpha)
      this%alpha = alpha

      ! Real space summation parameters
      this%rtol = rtol
      this%rcut = rcut
      this%rcutsq = rcut * rcut

      ! Reciprocal space summation parameters
      this%ktol = ktol

   end subroutine define_type

   !================================================================================
   ! Define ewald parameters in z-direction for 2DPBC
   subroutine define_zscale(this, zscale_range, zscale_weight)
      use MW_kinds, only: wp
      implicit none

      ! Parameters in
      ! -------------
      real(wp),       intent(in) :: zscale_range    !< Scaling factor for range on integral cut-off
      real(wp),       intent(in) :: zscale_weight   !< Scaling factor for integral weights

      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(inout) :: this

      this%zscale_range = zscale_range
      this%zscale_weight = zscale_weight

   end subroutine define_zscale

   !================================================================================
   ! Define reciprocal space parameters
   subroutine define_kpoints(this, num_pbc, box, num_ions, num_atoms)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      use MW_constants, only: twopi
      use MW_box, only: MW_box_t
      implicit none

      ! Parameters in
      ! -------------
      integer,        intent(in) :: num_pbc   !< number of periodic boundary conditions
      type(MW_box_t), intent(in) :: box       !< simulation box
      integer,        intent(in) :: num_ions  !< number of ions in the system
      integer,        intent(in) :: num_atoms !< number of electrode atoms in the system

      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: i, ios
      real(wp) :: rkmin, rkmax
      real(wp) :: dh
      integer :: kmax_z

      ! Choose rkmax such that truncature error < ktol
      !
      ! since
      ! error < 8 \sum_{kmax_x}^{\infty} \sum_{kmax_y}^{\infty} \int_{kmax_z}^{infty} \frac{e^{-(|k|^2| + u^2)/(4\alpha^2)}}{|k|^2 + u^2} du
      ! error < 8 * 4 * \pi \int_{rkmax}^{\infty} e^{-r^2/(4\alpha^2)} dr
      ! error < 32 * \pi * \frac{\sqrt{\pi}}{2} * 2 * \alpha \erfc{rkmax/(2\alpha)}
      !
      ! we choose rkmax such that
      ! exp(-|kcut|^2/(4*alpha^2)) = epsilon
      !
      rkmax = sqrt(-log(this%ktol)*4.0_wp*this%alpha*this%alpha)

      this%kmax_x = floor(rkmax*box%length(1)/(twopi))
      this%kmax_y = floor(rkmax*box%length(2)/(twopi))
      this%knorm2_max = rkmax*rkmax

      select case (num_pbc)
      case(2)
         rkmin = this%zscale_weight * twopi / box%length(3)
         rkmax = this%zscale_range * sqrt(-log(this%ktol))*2.0_wp*this%alpha / rkmin
         kmax_z = floor(rkmax)
      case(3)
         kmax_z = floor(rkmax*box%length(3)/(twopi))
      case default
         kmax_z = 0
      end select
      this%kmax_z = kmax_z

      allocate(this%zpoint(0:kmax_z), this%zweight(0:kmax_z), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("define_kpoints", "ewald.f90", ios)
      end if

      select case (num_pbc)
      case(2)
         dh   = this%zscale_weight * twopi / box%length(3)
      case(3)
         dh   = twopi / box%length(3)
      case default
         dh = 0.0_wp
      end select

      do i = 0, kmax_z
         this%zpoint(i) = real(i,wp)*dh
         this%zweight(i) = dh
      end do

      allocate(this%cos_kx_ions(num_ions,0:this%kmax_x),&
           this%cos_ky_ions(num_ions,0:this%kmax_y),    &
           this%cos_kz_ions(num_ions,0:this%kmax_z),    &
           this%sin_kx_ions(num_ions,0:this%kmax_x),    &
           this%sin_ky_ions(num_ions,0:this%kmax_y),    &
           this%sin_kz_ions(num_ions,0:this%kmax_z),    &
           this%cos_kx_elec(num_atoms,0:this%kmax_x),   &
           this%cos_ky_elec(num_atoms,0:this%kmax_y),   &
           this%cos_kz_elec(num_atoms,0:this%kmax_z),   &
           this%sin_kx_elec(num_atoms,0:this%kmax_x),   &
           this%sin_ky_elec(num_atoms,0:this%kmax_y),   &
           this%sin_kz_elec(num_atoms,0:this%kmax_z), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("define_kpoints", "ewald.f90", ios)
      end if

      this%cos_kx_ions(:,:) = 0.0_wp
      this%cos_ky_ions(:,:) = 0.0_wp
      this%cos_kz_ions(:,:) = 0.0_wp

      this%sin_kx_ions(:,:) = 0.0_wp
      this%sin_ky_ions(:,:) = 0.0_wp
      this%sin_kz_ions(:,:) = 0.0_wp

      this%cos_kx_elec(:,:) = 0.0_wp
      this%cos_ky_elec(:,:) = 0.0_wp
      this%cos_kz_elec(:,:) = 0.0_wp

      this%sin_kx_elec(:,:) = 0.0_wp
      this%sin_ky_elec(:,:) = 0.0_wp
      this%sin_kz_elec(:,:) = 0.0_wp

   end subroutine define_kpoints

    !================================================================================
   ! Define reciprocal space parameters
   subroutine redefine_kpoints(this, box, num_ions)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_parameter_error => parameter_error
      use MW_constants, only: twopi
      use MW_box, only: MW_box_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_box_t), intent(in) :: box       !< simulation box
      integer,        intent(in) :: num_ions  !< number of ions in the system

      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: i, ios
      real(wp) :: rkmax
      real(wp) :: dh

      ! Choose rkmax such that truncature error < ktol
      !
      ! since
      ! error < 8 \sum_{kmax_x}^{\infty} \sum_{kmax_y}^{\infty} \int_{kmax_z}^{infty} \frac{e^{-(|k|^2| + u^2)/(4\alpha^2)}}{|k|^2 + u^2} du
      ! error < 8 * 4 * \pi \int_{rkmax}^{\infty} e^{-r^2/(4\alpha^2)} dr
      ! error < 32 * \pi * \frac{\sqrt{\pi}}{2} * 2 * \alpha \erfc{rkmax/(2\alpha)}
      !
      ! we choose rkmax such that
      ! exp(-|kcut|^2/(4*alpha^2)) = epsilon
      !
      rkmax = sqrt(-log(this%ktol)*4.0_wp*this%alpha*this%alpha)

      this%kmax_x = floor(rkmax*box%length(1)/(twopi))
      this%kmax_y = floor(rkmax*box%length(2)/(twopi))
      this%kmax_z = floor(rkmax*box%length(3)/(twopi))
      this%knorm2_max = rkmax*rkmax

      deallocate(this%zpoint, this%zweight, stat=ios)
      if (ios /= 0) then
         call MW_errors_deallocate_error("redefine_kpoints", "ewald.f90", ios)
      end if

      allocate(this%zpoint(0:this%kmax_z), this%zweight(0:this%kmax_z), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("redefine_kpoints", "ewald.f90", ios)
      end if

      dh   = twopi / box%length(3)

      do i = 0, this%kmax_z
         this%zpoint(i) = real(i,wp)*dh
         this%zweight(i) = dh
      end do

      deallocate(this%cos_kx_ions, this%cos_ky_ions, this%cos_kz_ions, &
                 this%sin_kx_ions, this%sin_ky_ions, this%sin_kz_ions, & 
                 this%cos_kx_elec, this%cos_ky_elec, this%cos_kz_elec, &
                 this%sin_kx_elec, this%sin_ky_elec, this%sin_kz_elec, & 
                 stat=ios)
      if (ios /= 0) then
         call MW_errors_deallocate_error("redefine_kpoints", "ewald.f90", ios)
      end if

      allocate(this%cos_kx_ions(num_ions,0:this%kmax_x),&
           this%cos_ky_ions(num_ions,0:this%kmax_y),    &
           this%cos_kz_ions(num_ions,0:this%kmax_z),    &
           this%sin_kx_ions(num_ions,0:this%kmax_x),    &
           this%sin_ky_ions(num_ions,0:this%kmax_y),    &
           this%sin_kz_ions(num_ions,0:this%kmax_z),    &
           this%cos_kx_elec(0,0:this%kmax_x),   &
           this%cos_ky_elec(0,0:this%kmax_y),   &
           this%cos_kz_elec(0,0:this%kmax_z),   &
           this%sin_kx_elec(0,0:this%kmax_x),   &
           this%sin_ky_elec(0,0:this%kmax_y),   &
           this%sin_kz_elec(0,0:this%kmax_z), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("redefine_kpoints", "ewald.f90", ios)
      end if

      this%cos_kx_ions(:,:) = 0.0_wp
      this%cos_ky_ions(:,:) = 0.0_wp
      this%cos_kz_ions(:,:) = 0.0_wp

      this%sin_kx_ions(:,:) = 0.0_wp
      this%sin_ky_ions(:,:) = 0.0_wp
      this%sin_kz_ions(:,:) = 0.0_wp

      this%cos_kx_elec(:,:) = 0.0_wp
      this%cos_ky_elec(:,:) = 0.0_wp
      this%cos_kz_elec(:,:) = 0.0_wp

      this%sin_kx_elec(:,:) = 0.0_wp
      this%sin_ky_elec(:,:) = 0.0_wp
      this%sin_kz_elec(:,:) = 0.0_wp

   end subroutine redefine_kpoints  

   !================================================================================
   ! Allocate sk cos/sin arrays
   subroutine define_Skcossin(this, num_modes)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameter
      ! --------
      type(MW_ewald_t), intent(inout) :: this
      integer, intent(in) :: num_modes

      ! Local
      ! -----
      integer :: ios
      allocate(this%Sk_cos(num_modes), this%Sk_sin(num_modes), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("define_Skcossin", "ewald.f90", ios)
      end if
      this%Sk_cos(:) = 0.0_wp
      this%Sk_sin(:) = 0.0_wp
   end subroutine define_Skcossin

   !================================================================================
   ! Allocate sk cos/sin arrays
   subroutine define_Skmucossin(this, num_modes)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameter
      ! --------
      type(MW_ewald_t), intent(inout) :: this
      integer, intent(in) :: num_modes

      ! Local
      ! -----
      integer :: ios
      allocate(this%Skmux_cos(num_modes), this%Skmux_sin(num_modes), stat=ios)
      allocate(this%Skmuy_cos(num_modes), this%Skmuy_sin(num_modes), stat=ios)
      allocate(this%Skmuz_cos(num_modes), this%Skmuz_sin(num_modes), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("define_Skmucossin", "ewald.f90", ios)
      end if
      this%Skmux_cos(:) = 0.0_wp
      this%Skmux_sin(:) = 0.0_wp
      this%Skmuy_cos(:) = 0.0_wp
      this%Skmuy_sin(:) = 0.0_wp
      this%Skmuz_cos(:) = 0.0_wp
      this%Skmuz_sin(:) = 0.0_wp
   end subroutine define_Skmucossin

   !================================================================================
   ! Allocate sk cos/sin arrays
   subroutine redefine_Skcossin(this, num_modes)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameter
      ! --------
      type(MW_ewald_t), intent(inout) :: this
      integer, intent(in) :: num_modes

      ! Local
      ! -----
      integer :: ios

      deallocate(this%Sk_cos, this%Sk_sin, stat=ios)
      if (ios /= 0) then
         call MW_errors_deallocate_error("redefine_Skcossin", "ewald.f90", ios)
      end if
      allocate(this%Sk_cos(num_modes), this%Sk_sin(num_modes), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("redefine_Skcossin", "ewald.f90", ios)
      end if
      this%Sk_cos(:) = 0.0_wp
      this%Sk_sin(:) = 0.0_wp
   end subroutine redefine_Skcossin

   !================================================================================
   ! Allocate sk cos/sin arrays
   subroutine redefine_Skmucossin(this, num_modes)
      use MW_kinds, only: wp
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameter
      ! --------
      type(MW_ewald_t), intent(inout) :: this
      integer, intent(in) :: num_modes

      ! Local
      ! -----
      integer :: ios

      deallocate(this%Skmux_cos, this%Skmux_sin, stat=ios)
      deallocate(this%Skmuy_cos, this%Skmuy_sin, stat=ios)
      deallocate(this%Skmuz_cos, this%Skmuz_sin, stat=ios)
      if (ios /= 0) then
         call MW_errors_deallocate_error("redefine_Skmucossin", "ewald.f90", ios)
      end if
      allocate(this%Skmux_cos(num_modes), this%Skmux_sin(num_modes), stat=ios)
      allocate(this%Skmuy_cos(num_modes), this%Skmuy_sin(num_modes), stat=ios)
      allocate(this%Skmuz_cos(num_modes), this%Skmuz_sin(num_modes), stat=ios)
      if (ios /= 0) then
         call MW_errors_allocate_error("define_Skmucossin", "ewald.f90", ios)
      end if
      this%Skmux_cos(:) = 0.0_wp
      this%Skmux_sin(:) = 0.0_wp
      this%Skmuy_cos(:) = 0.0_wp
      this%Skmuy_sin(:) = 0.0_wp
      this%Skmuz_cos(:) = 0.0_wp
      this%Skmuz_sin(:) = 0.0_wp
   end subroutine redefine_Skmucossin   

   !================================================================================
   ! Void ewald parameters
   subroutine void_type(this)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(inout) :: this

      ! Local
      ! ----
      integer :: ios

      this%alpha = 0.0_wp
      this%rcut = 0.0_wp
      this%rcutsq = 0.0_wp
      this%ktol = 0.0_wp
      this%kmax_x = 0
      this%kmax_y = 0
      this%kmax_z = 0
      this%knorm2_max = 0.0_wp

      if (allocated(this%sr_interaction_ion2ion)) then
         deallocate(this%sr_interaction_ion2ion, &
               this%sr_interaction_atom2atom, &
               this%sr_interaction_ion2atom, &
               this%sr_interaction_atom2ion, stat=ios)
         if (ios /= 0) then
            call MW_errors_deallocate_error("void_type", "ewald.f90", ios)
         end if
      end if

      if (allocated(this%zpoint)) then
         deallocate(this%zpoint, this%zweight, stat=ios)
         if (ios /= 0) then
            call MW_errors_deallocate_error("void_type", "ewald.f90", ios)
         end if
      end if

      if (allocated(this%cos_kx_ions)) then
         deallocate(this%cos_kx_ions, this%cos_ky_ions, this%cos_kz_ions, &
              this%sin_kx_ions, this%sin_ky_ions, this%sin_kz_ions, &
               this%cos_kx_elec, this%cos_ky_elec, this%cos_kz_elec,&
               this%sin_kx_elec, this%sin_ky_elec, this%sin_kz_elec, stat=ios)
         if (ios /= 0) then
            call MW_errors_deallocate_error("void_type", "ewald.f90", ios)
         end if
      end if

      if (allocated(this%Sk_cos)) then
         deallocate(this%Sk_cos, this%Sk_sin, stat=ios)
         if (ios /= 0) then
            call MW_errors_deallocate_error("void_type", "ewald.f90", ios)
         end if
      end if
      if (allocated(this%Skmux_cos)) then
         deallocate(this%Skmux_cos, this%Skmux_sin, stat=ios)
         deallocate(this%Skmuy_cos, this%Skmuy_sin, stat=ios)
         deallocate(this%Skmuz_cos, this%Skmuz_sin, stat=ios)
         if (ios /= 0) then
            call MW_errors_deallocate_error("void_type", "ewald.f90", ios)
         end if
      end if
   end subroutine void_type

   !================================================================================
   ! Print ewald parameters
   subroutine print_type(this, ounit)
      implicit none
      ! Parameters out
      ! --------------
      type(MW_ewald_t), intent(in) :: this
      integer,          intent(in) :: ounit

      integer :: itype, jtype
      write(ounit,'("|ewald| alpha:                                ", es12.5)') this%alpha
      write(ounit,'("|ewald| real space summation tolerance:       ", es12.5)') this%rtol
      write(ounit,'("|ewald| real space cut-off distance:          ", es12.5)') this%rcut
      write(ounit,'("|ewald| erfc(alpha*|rcut|)/|rcut|:            ", es12.5)') &
            erfc(this%alpha*this%rcut)/this%rcut
      write(ounit,'("|ewald| exp(-alpha^2*|rcut|^2)/|rcut|:        ", es12.5)') &
            exp(-this%alpha*this%alpha*this%rcut*this%rcut)/this%rcut
      write(ounit,'("|ewald| reciprocal space summation tolerance:       ", es12.5)') this%ktol
      write(ounit,'("|ewald| reciprocal space cut-off distance |kcut|^2: ", es12.5)') sqrt(this%knorm2_max)
      write(ounit,'("|ewald| exp(-|kcut|^2/(4*alpha^2))/|kcut|^2:        ", es12.5)') &
            exp(-this%knorm2_max/(4.0_wp*this%alpha*this%alpha))/this%knorm2_max
      write(ounit,'("|ewald| reciprocal space image count (kmax):  ",3(i12,1x))') this%kmax_x, this%kmax_y, this%kmax_z
      write(ounit,'("|ewald| Z integral points:                    ",i12)') 2*this%kmax_z + 1
      write(ounit,'("|ewald| Z integral range:                     ",2(es12.5,1x))') &
            -this%zpoint(this%kmax_z) - 0.5_wp*this%zweight(0), &
            +this%zpoint(this%kmax_z) + 0.5_wp*this%zweight(0)
      write(ounit,'("|ewald| Z integral weights:                   ",es12.5)') this%zweight(0)
      write(ounit,'("|ewald| Short-Range interaction matrices:")')

      write(ounit,'("|ewald| ion <-> ion ")')
      do itype = 1, size(this%sr_interaction_ion2ion,2)
         write(ounit, '("|ewald| ")', advance='no')
         do jtype = 1, size(this%sr_interaction_ion2ion,1)
            if (this%sr_interaction_ion2ion(jtype,itype)) then
               write(ounit, '(1a,1x)', advance='no') 'X'
            else
               write(ounit, '(1a,1x)', advance='no') 'O'
            end if
         end do
         write(ounit, *)
      end do

      write(ounit,'("|ewald| electrode <-> electrode ")')
      do itype = 1, size(this%sr_interaction_atom2atom,2)
         write(ounit, '("|ewald| ")', advance='no')
         do jtype = 1, size(this%sr_interaction_atom2atom,1)
            if (this%sr_interaction_atom2atom(jtype,itype)) then
               write(ounit, '(1a,1x)', advance='no') 'X'
            else
               write(ounit, '(1a,1x)', advance='no') 'O'
            end if
         end do
         write(ounit, *)
      end do

      write(ounit,'("|ewald| electrolyte -> electrode ")')
      do itype = 1, size(this%sr_interaction_ion2atom,2)
         write(ounit, '("|ewald| ")', advance='no')
         do jtype = 1, size(this%sr_interaction_ion2atom,1)
            if (this%sr_interaction_ion2atom(jtype,itype)) then
               write(ounit, '(1a,1x)', advance='no') 'X'
            else
               write(ounit, '(1a,1x)', advance='no') 'O'
            end if
         end do
         write(ounit, *)
      end do

      write(ounit,'("|ewald| electrode -> electrolyte ")')
      do itype = 1, size(this%sr_interaction_atom2ion,2)
         write(ounit, '("|ewald| ")', advance='no')
         do jtype = 1, size(this%sr_interaction_atom2ion,1)
            if (this%sr_interaction_atom2ion(jtype,itype)) then
               write(ounit, '(1a,1x)', advance='no') 'X'
            else
               write(ounit, '(1a,1x)', advance='no') 'O'
            end if
         end do
         write(ounit, *)
      end do

   end subroutine print_type

   !================================================================================
   ! Setup cos and sin for Ewald summation
   subroutine setup_cossin_ions(this, box, xyz_ions)
      use MW_constants, only: twopi
      use MW_box, only: MW_box_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_ewald_t), intent(inout) :: this
      type(MW_box_t), intent(in) :: box
      real(wp), intent(in) :: xyz_ions(:,:)

      ! Locals
      ! ------
      integer :: i, k
      integer :: num_ions
      real(wp) :: knorm

      num_ions = size(xyz_ions,1)

      !$acc data &
      !$acc present(xyz_ions(:,:), this, this%zpoint(0:), &
      !$acc         this%cos_kx_ions(:,0:), this%sin_kx_ions(:,0:), &
      !$acc         this%cos_ky_ions(:,0:), this%sin_ky_ions(:,0:), &
      !$acc         this%cos_kz_ions(:,0:), this%sin_kz_ions(:,0:))      

      knorm = twopi / box%length(1)
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_x
         do i = 1, num_ions
            this%cos_kx_ions(i,k) = cos(real(k,wp)*knorm*xyz_ions(i,1))
            this%sin_kx_ions(i,k) = sin(real(k,wp)*knorm*xyz_ions(i,1))
         end do
      end do
      !$acc end parallel loop 

      knorm = twopi / box%length(2)
      ! Setup for kx >= 2 using trigonometric rule
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_y
         do i = 1, num_ions
            this%cos_ky_ions(i,k) = cos(real(k,wp)*knorm*xyz_ions(i,2))
            this%sin_ky_ions(i,k) = sin(real(k,wp)*knorm*xyz_ions(i,2))
         end do
      end do
      !$acc end parallel loop 

      ! Setup for kz
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_z
         do i = 1, num_ions
            this%cos_kz_ions(i,k) = cos(this%zpoint(k)*xyz_ions(i,3))
            this%sin_kz_ions(i,k) = sin(this%zpoint(k)*xyz_ions(i,3))
         end do
      end do
      !$acc end parallel loop 

      !$acc update host(this%cos_kx_ions(:,0:), this%sin_kx_ions(:,0:), &
      !$acc             this%cos_ky_ions(:,0:), this%sin_ky_ions(:,0:), &
      !$acc             this%cos_kz_ions(:,0:), this%sin_kz_ions(:,0:))      

      !$acc end data 

   end subroutine setup_cossin_ions

   !================================================================================
   ! Setup cos and sin for Ewald summation
   subroutine setup_cossin_elec(this, box, xyz_elec)
      use MW_constants, only: twopi
      use MW_box, only: MW_box_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_ewald_t), intent(inout) :: this
      type(MW_box_t), intent(in) :: box
      real(wp), intent(in) :: xyz_elec(:,:)

      ! Locals
      ! ------
      integer :: i, k
      integer :: num_elec
      real(wp) :: knorm

      num_elec = size(xyz_elec,1)

 
      !$acc data &
      !$acc present(xyz_elec(:,:), this, this%zpoint(0:), &
      !$acc         this%cos_kx_elec(:,0:), this%sin_kx_elec(:,0:), &
      !$acc         this%cos_ky_elec(:,0:), this%sin_ky_elec(:,0:), &
      !$acc         this%cos_kz_elec(:,0:), this%sin_kz_elec(:,0:))      

 
      knorm = twopi / box%length(1)
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_x
         do i = 1, num_elec
            this%cos_kx_elec(i,k) = cos(real(k,wp)*knorm*xyz_elec(i,1))
            this%sin_kx_elec(i,k) = sin(real(k,wp)*knorm*xyz_elec(i,1))
         end do
      end do
      !$acc end parallel loop 
 
      knorm = twopi / box%length(2)
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_y
         do i = 1, num_elec
            this%cos_ky_elec(i,k) = cos(real(k,wp)*knorm*xyz_elec(i,2))
            this%sin_ky_elec(i,k) = sin(real(k,wp)*knorm*xyz_elec(i,2))
         end do
      end do
      !$acc end parallel loop 
 
      !$acc parallel loop collapse(2)
      do k = 0, this%kmax_z
         do i = 1, num_elec
            this%cos_kz_elec(i,k) = cos(this%zpoint(k)*xyz_elec(i,3))
            this%sin_kz_elec(i,k) = sin(this%zpoint(k)*xyz_elec(i,3))
         end do
      end do
      !$acc end parallel loop 

      !$acc update host(this%cos_kx_elec(:,0:), this%sin_kx_elec(:,0:), &
      !$acc             this%cos_ky_elec(:,0:), this%sin_ky_elec(:,0:), &
      !$acc             this%cos_kz_elec(:,0:), this%sin_kz_elec(:,0:))      

      !$acc end data

   end subroutine setup_cossin_elec

   !================================================================================
   ! Set num pbc in the Ewald data structure
   subroutine set_num_pbc(this, num_pbc)
      implicit none
      type(MW_ewald_t), intent(inout) :: this
      integer, intent(in) :: num_pbc
      this%num_pbc = num_pbc
   end subroutine set_num_pbc

   !================================================================================
   ! Determine alpha given rcut and a tolerance parameter
   !
   ! In the short-range part of electrostatic interactions, terms of the order
   ! erfc(alpha*|r|)/|r| appear in the potential calculation
   ! terms of the order erfc(alpha*|r|)/|r|^3 and
   !                    (2*alpha/sqrt(pi))*exp(-alpha^2*|r|^2)/|r|^2 appear in the force
   !
   ! we want to choose alpha such that
   !    erfc(alpha*|rcut|)/|rcut| < epsilon
   !    (2*alpha/sqrt(pi))*exp(-alpha^2*|rcut|^2)/|rcut| < epsilon
   !
   ! For rcut large enough, erfc(alpha*|rcut|)/|rcut| < exp(-alpha^2*|rcut|^2)/|rcut|
   ! hence we compute alpha as
   !
   ! alpha = sqrt(ln(-epsilon*rcut))/rcut
   !
   subroutine compute_alpha(rcut, epsilon, alpha)
      use MW_kinds, only: wp
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: rcut
      real(wp), intent(in) :: epsilon
      real(wp), intent(out) :: alpha

      alpha = sqrt(-log(epsilon*rcut)) / rcut
   end subroutine compute_alpha

   !================================================================================
   include 'update_kmode_index.inc'

end module MW_ewald

module MW_external_field
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   use MW_constants, only: fourpi, eightpi_inv
   implicit none

   private

   ! Public type
   ! -----------
   public :: MW_external_field_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type
   public :: melt_forces
   public :: energy
   public :: Efield_elec_potential
   public :: Dfield_gradQelec_potential
   public :: Dfield_elec_potentialb
   public :: Dfield_elec_potentialA
   public :: field2mumelt_electricfieldb
   public :: field2mumelt_electricfieldA
   public :: elec_polarization
   public :: melt_polarization
   public :: dipole_polarization
   public :: initialize_polarization

   ! Data structure to handle external electric field
   type MW_external_field_t
      integer :: field_type                               ! field type (electric field or displacement)
      real(wp), allocatable :: electric_field(:)           ! electric field
      real(wp), allocatable :: displacement_field(:)       ! field
      logical,  allocatable :: apply_direction(:)          ! apply field in x, y or z?
   end type MW_external_field_t

   integer, parameter, public :: FIELD_TYPE_ELECTRIC = 2
   integer, parameter, public :: FIELD_TYPE_DISPLACEMENT = 3

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, field_type, amplitude, direction)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error

      implicit none
      ! Parameters
      ! ---------_
      type(MW_external_field_t), intent(inout) :: this      !> structure to be defined
      character, intent(in) :: field_type !> field type
      real(wp), intent(in) :: amplitude !> field amplitude
      real(wp), intent(in) :: direction(:) !> field direction

      ! Local
      ! -----
      integer :: ierr, i
      real(wp) :: fvalue

      select case (field_type)
      case("E")
        this%field_type = FIELD_TYPE_ELECTRIC
      case("D")
        this%field_type = FIELD_TYPE_DISPLACEMENT
      case default
         call MW_errors_parameter_error("define_type", "external_field.f90",&
               "type", field_type)
      end select

      allocate(this%electric_field(3), this%displacement_field(3), &
           this%apply_direction(3), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "external_field.f90", ierr)

      this%electric_field(:) = 0.0_wp
      this%displacement_field(:) = 0.0_wp
      this%apply_direction(:) = .false.

      select case(this%field_type)
      case (FIELD_TYPE_ELECTRIC)
         do i = 1, 3
            fvalue = amplitude * direction(i)
            this%electric_field(i) = fvalue
            this%displacement_field(i) = 0.0_wp
            if (abs(direction(i)) > 0.0_wp) then
               this%apply_direction(i) = .true.
            else
               this%apply_direction(i) = .false.
            end if
         end do

      case(FIELD_TYPE_DISPLACEMENT)
         do i = 1, 3
            fvalue = amplitude * direction(i)
            this%electric_field(i) = 0.0_wp
            this%displacement_field(i) = fvalue
            if (abs(direction(i)) > 0.0_wp) then
               this%apply_direction(i) = .true.
            else
               this%apply_direction(i) = .false.
            end if
         end do
      end select

   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_external_field_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%electric_field)) then
         deallocate(this%electric_field, this%displacement_field, &
              this%apply_direction, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "external_field.f90", ierr)
         end if
      end if

      this%field_type = 0
   end subroutine void_type

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, ounit)
      implicit none
      type(MW_external_field_t), intent(in) :: this               ! structure to be printed
      integer,                   intent(in) :: ounit              ! output unit

      write(ounit, '("|external field| Type:                      ",i12)') this%field_type
      write(ounit, '("|external field| Electric Field:            ",3(1x,es12.5))') this%electric_field(:)
      write(ounit, '("|external field| Displacement Field:        ",3(1x,es12.5))') this%displacement_field(:)
      write(ounit, '("|external field| Apply in direction (x,y,z):",3(1x,L12))') this%apply_direction(:)

   end subroutine print_type

   ! ==============================================================================
   ! Compute external field forces felt by melt ions
   subroutine melt_forces(field, box, electrode, ions, xyz_atoms, q_elec, polarization_field, force)
      implicit none
      
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< External field parameters
      type(MW_box_t), intent(in) :: box
      type(MW_electrode_t), intent(in) :: electrode(:)
      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_atoms(:,:)  !< atoms xyz positions
      real(wp),       intent(in) :: q_elec(:)
      real(wp),       intent(inout) :: polarization_field(:,:)
      
      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< force on ions due to external field
      
      ! Locals
      ! ------
      integer :: num_ion_types
      integer :: itype, i, ixyz, iion
      integer :: count_n, offset_n
      real(wp) :: qi
      real(wp) :: Efield(3)
      
      num_ion_types = size(ions,1)
      force(:,:) = 0.0_wp
      Efield(:) = 0.0_wp
      
      select case(field%field_type)
      
      case(FIELD_TYPE_ELECTRIC)
      
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do iion = 1, count_n
            i = iion + offset_n
            do ixyz = 1, 3
               force(i, ixyz) = force(i, ixyz) + qi * field%electric_field(ixyz)
            end do
         end do
      end do
      
      case(FIELD_TYPE_DISPLACEMENT)
      
      call elec_polarization(box, electrode, xyz_atoms, q_elec, polarization_field)
      
      do ixyz = 1,3
         if(field%apply_direction(ixyz)) then
            Efield(ixyz) = field%displacement_field(ixyz) - fourpi * polarization_field(ixyz,1)
         endif
      enddo
      
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do iion = 1, count_n
            i = iion + offset_n
            do ixyz = 1, 3
               force(i, ixyz) = force(i, ixyz) + qi * Efield(ixyz)
            end do
         end do
      end do
      
      end select

   end subroutine melt_forces

   ! ==============================================================================
   ! Compute the interaction energy with the external field
   subroutine energy(field, box, polarization_field, h)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< External field parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters
      real(wp), intent(in) :: polarization_field(:,:)

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to interaction with the external field

      ! Local
      ! -----
      integer :: ixyz

      h = 0.0_wp

      select case(field%field_type)

      case(FIELD_TYPE_ELECTRIC)
      do ixyz = 1, 3
         h = h - (field%electric_field(ixyz) * polarization_field(ixyz,1))
      end do
      h = box%volume * h

      case(FIELD_TYPE_DISPLACEMENT)
      do ixyz = 1, 3
         if (field%apply_direction(ixyz)) then
            h = h - (field%displacement_field(ixyz) - fourpi * polarization_field(ixyz,1))**2
         endif
      end do
      h = box%volume * eightpi_inv * h

      end select

   end subroutine energy

   ! ================================================================================
   ! Compute the potential felt by an electrode atom due to an external electric field
   subroutine Efield_elec_potential(field, electrode, xyz_atoms, V)
      implicit none
     
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(in) :: field      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      real(wp),       intent(in) :: xyz_atoms(:,:)  !< atoms xyz positions
      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: V(:)
     
      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i, ixyz
      integer :: count_n, offset_n
     
      num_elec_types = size(electrode,1)
      V(:) = 0.0_wp
     
      do itype = 1, num_elec_types
         count_n = electrode(itype)%count
         offset_n = electrode(itype)%offset
         do ielec = 1, count_n
            i = ielec + offset_n
            V(i) = 0.0_wp
            do ixyz = 1, 3
               V(i) = V(i) - xyz_atoms(i,ixyz) * field%electric_field(ixyz)
            end do
         end do
      end do

   end subroutine Efield_elec_potential

   ! ================================================================================
   ! Compute the potential felt by an electrode atom due to an external electric displacement
   subroutine Dfield_gradQelec_potential(box, field, electrode, xyz_atoms, q_elec, polarization_field, gradQ_V)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      type(MW_box_t), intent(in) :: box  !< box parameters
      real(wp), intent(in) :: xyz_atoms(:,:)
      real(wp), intent(in) :: q_elec(:)
     
      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: polarization_field(:,:)
      real(wp), intent(inout) :: gradQ_V(:,:)
     
      ! Local
      ! -----
      integer :: num_elec_types
      integer :: ixyz
      integer :: itype, ielec, i, jtype, jelec, j
      integer :: count_n, offset_n, count_m, offset_m
     
      num_elec_types = size(electrode,1)
     
      !call elec_polarization(box, electrode, xyz_atoms, q_elec, polarization_field)
     
      do itype = 1, num_elec_types
         count_n = electrode(itype)%count
         offset_n = electrode(itype)%offset
         do ielec = 1, count_n
            i = ielec + offset_n
            do jtype = 1, num_elec_types
               count_m = electrode(jtype)%count
               offset_m = electrode(jtype)%offset
               do jelec = 1, count_m
                  j = jelec + offset_m
                  do ixyz = 1, 3
                     if(field%apply_direction(ixyz)) then
                        gradQ_V(j,i) = gradQ_V(j,i) + fourpi / box%volume * xyz_atoms(i, ixyz) * xyz_atoms(j, ixyz)
                     end if
                  end do
               end do
            end do
         end do
      end do

   end subroutine Dfield_gradQelec_potential


   ! ================================================================================
   ! Compute the potential felt by an electrode atom due to an external electric displacement
   subroutine Dfield_elec_potentialA(box, field, electrode, xyz_atoms, q_elec, polarization_field, V)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      type(MW_box_t), intent(in) :: box  !< box parameters
      real(wp), intent(in) :: xyz_atoms(:,:)
      real(wp), intent(in) :: q_elec(:)

      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: polarization_field(:,:)
      real(wp), intent(inout) :: V(:)

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i, ixyz
      integer :: count_n, offset_n
      real(wp) :: Efield(3)

      num_elec_types = size(electrode,1)
      V(:) = 0.0_wp
      Efield(:) = 0.0_wp

      call elec_polarization(box, electrode, xyz_atoms, q_elec, polarization_field)

      do ixyz = 1,3
         if(field%apply_direction(ixyz)) then
            Efield(ixyz) = - fourpi * (polarization_field(ixyz,3) + polarization_field(ixyz,4))
         endif
      enddo

      do itype = 1, num_elec_types
         count_n = electrode(itype)%count
         offset_n = electrode(itype)%offset
         do ielec = 1, count_n
            i = ielec + offset_n
            do ixyz = 1, 3
               V(i) = V(i) - xyz_atoms(i, ixyz) * Efield(ixyz)
            end do
         end do
      end do

   end subroutine Dfield_elec_potentialA


   ! ================================================================================
   ! Compute the potential felt by an electrode atom due to an external electric displacement
   subroutine Dfield_elec_potentialb(field, electrode, xyz_atoms, polarization_field, V)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      real(wp), intent(in) :: xyz_atoms(:,:)

      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: polarization_field(:,:)
      real(wp), intent(inout) :: V(:)

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i, ixyz
      integer :: count_n, offset_n
      real(wp) :: Efield(3)

      num_elec_types = size(electrode,1)
      V(:) = 0.0_wp
      Efield(:) = 0.0_wp

      do ixyz = 1,3
         if(field%apply_direction(ixyz)) then
            Efield(ixyz) = field%displacement_field(ixyz) - fourpi * polarization_field(ixyz,2)
         endif
      enddo

      do itype = 1, num_elec_types
         count_n = electrode(itype)%count
         offset_n = electrode(itype)%offset
         do ielec = 1, count_n
            i = ielec + offset_n
            do ixyz = 1, 3
               V(i) = V(i) - xyz_atoms(i, ixyz) * Efield(ixyz)
            end do
         end do
      end do
   end subroutine Dfield_elec_potentialb


   ! ================================================================================
   ! Compute the polarization field for electrode atoms
   ! P(t) = 1/V * sum (q_i(t)*r_i)
   subroutine elec_polarization(box, electrode, xyz_atoms, q_elec, polarization_field)
      implicit none
     
      ! Parameters in
      ! -------------
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      real(wp), intent(in) :: xyz_atoms(:,:)
      real(wp), intent(in) :: q_elec(:)
      ! Parameters out
      ! --------------
       real(wp), intent(inout) :: polarization_field(:,:)
      
      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i, ixyz
      integer :: count_n, offset_n

      num_elec_types = size(electrode,1)
      polarization_field(:,3) = 0.0_wp

      do itype = 1, num_elec_types
         count_n = electrode(itype)%count
         offset_n = electrode(itype)%offset
         do ielec = 1, count_n
            i = ielec + offset_n
            do ixyz = 1, 3
               polarization_field(ixyz,3) = polarization_field(ixyz,3) + q_elec(i) * xyz_atoms(i,ixyz)
            end do
         end do
      end do

      polarization_field(:,3) = polarization_field(:,3) / box%volume
      polarization_field(:,1) = polarization_field(:,2) + polarization_field(:,3) + polarization_field(:,4)

   end subroutine elec_polarization

   ! ================================================================================
   ! Compute the polarization field for melt ions
   ! P(t+dt) = P(t) + 1/V * sum_(qi * delta_i(t+dt))
   ! with delta_i(t+dt) = (r_i(t+dt) - r_i(t)) // without PBC folding
   !
   subroutine melt_polarization(num_pbc, box, ions, xyz_ions_prev, xyz_ions_now, polarization_field)
      implicit none
    
      ! Parameters in
      ! -------------
      integer, intent(in)        :: num_pbc
      type(MW_box_t), intent(in) :: box
      type(MW_ion_t), intent(in) :: ions(:)  !< electrode parameters
      real(wp), intent(in) :: xyz_ions_prev(:,:) !< ions position at previous time step
      real(wp), intent(in) :: xyz_ions_now(:,:)  !< ions position at current time step

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: polarization_field(:,:)

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: itype, iion, i, ixyz
      real(wp) :: dr(3), drnorm2
      real(wp) :: volfactor, qi
      real(wp) :: tmpfield(3)
      integer :: count_n, offset_n

      num_ion_types = size(ions,1)
      volfactor = 1.0_wp / box%volume
      tmpfield(:) = 0.0_wp

      select case(num_pbc)

      case(2)
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do iion = 1, count_n
            i = iion + offset_n

            call minimum_image_displacement_2DPBC(box%length(1), box%length(2), box%length(3), &
                 xyz_ions_prev(i,1), xyz_ions_prev(i,2), xyz_ions_prev(i,3), &
                 xyz_ions_now(i,1), xyz_ions_now(i,2), xyz_ions_now(i,3), &
                 dr(1),dr(2),dr(3), drnorm2)
            do ixyz = 1, 3
               tmpfield(ixyz) = tmpfield(ixyz) + qi*dr(ixyz)
            end do
         end do
      end do

      case(3)
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do iion = 1, count_n
            i = iion + offset_n

            call minimum_image_displacement_3DPBC(box%length(1), box%length(2), box%length(3), &
                 xyz_ions_prev(i,1), xyz_ions_prev(i,2), xyz_ions_prev(i,3), &
                 xyz_ions_now(i,1), xyz_ions_now(i,2), xyz_ions_now(i,3), &
                 dr(1),dr(2),dr(3), drnorm2)
            do ixyz = 1, 3
               tmpfield(ixyz) = tmpfield(ixyz) + qi*dr(ixyz)
            end do
         end do
      end do

      end select

      polarization_field(:,2) = polarization_field(:,2) + volfactor*tmpfield(:)
      polarization_field(:,1) = polarization_field(:,2) + polarization_field(:,3) + polarization_field(:,4)
   end subroutine melt_polarization

   ! ================================================================================
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_displacement_2DPBC.inc'

   ! ================================================================================
   ! Compute the polarization field for the dipoles
   ! P(t)=1/V * sum mui(t)
   !
   subroutine dipole_polarization(box, ions, dipole_ions, polarization_field)
      implicit none
      ! Parameters in
      type(MW_box_t), intent(in) :: box
      type(MW_ion_t), intent(in) :: ions(:)  !< electrode parameters
      real(wp), intent(in) :: dipole_ions(:,:)

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: polarization_field(:,:)

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: itype, iion, i, ixyz
      real(wp) :: volfactor
      integer :: count_n, offset_n

      num_ion_types = size(ions,1)
      volfactor = 1.0_wp / box%volume
      polarization_field(:,4) = 0.0_wp

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         do iion = 1, count_n
            i = iion + offset_n
            do ixyz = 1, 3
               polarization_field(ixyz,4) = polarization_field(ixyz,4) + dipole_ions(i,ixyz)
            end do
         end do
      end do

      polarization_field(:,4) = polarization_field(:,4) / box%volume
      polarization_field(:,1) = polarization_field(:,2) + polarization_field(:,3) + polarization_field(:,4)
   end subroutine dipole_polarization

   ! ================================================================================
   ! Initialze the polarization of the melt ions
   ! P(t=0)=sum qi * ri
   !
   subroutine initialize_polarization(box, xyz_ions, ions, polarization_field)
      implicit none
      ! Parameters in
      type(MW_box_t), intent(in) :: box
      real(wp), intent(in) :: xyz_ions(:,:)
      type(MW_ion_t), intent(in) :: ions(:)  !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: polarization_field(:,:)

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: itype, iion, i, ixyz
      real(wp) :: volfactor, qi
      integer :: count_n, offset_n

      num_ion_types = size(ions,1)
      volfactor = 1.0_wp / box%volume
      polarization_field(:,2) = 0.0_wp

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do iion = 1, count_n
            i = iion + offset_n
            do ixyz = 1, 3
               polarization_field(ixyz,2) = polarization_field(ixyz,2) + qi*xyz_ions(i,ixyz)
            end do
         end do
      end do

      polarization_field(:,2) = polarization_field(:,2) * volfactor
   end subroutine initialize_polarization

   subroutine field2mumelt_electricfieldb(field, ions, polarization_field, electric_field)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(in) :: field      !< Lennard-Jones potential parameters
      type(MW_ion_t), intent(in) :: ions(:)  !< electrode parameters
      real(wp), intent(in) :: polarization_field(:,:)

      ! Parameter out
      ! -------------
      real(wp), intent(out) :: electric_field(:,:)

      ! Local
      ! -----
      integer :: i, itype, ixyz
      electric_field = 0.0_wp

      select case(field%field_type)

      case(FIELD_TYPE_ELECTRIC)
      do itype = 1,size(ions,1)
         do i=ions(itype)%offset+1,ions(itype)%offset+ions(itype)%count
            do ixyz = 1, 3
               electric_field(i,ixyz) = -field%electric_field(ixyz)
            end do
         end do
      end do

      case(FIELD_TYPE_DISPLACEMENT)
      do itype = 1,size(ions,1)
         do i=ions(itype)%offset+1,ions(itype)%offset+ions(itype)%count
            do ixyz = 1, 3
               if (field%apply_direction(ixyz)) then
                  electric_field(i,ixyz) =  -(field%displacement_field(ixyz) - fourpi * polarization_field(ixyz,2))
               end if
            end do
         end do
      end do

      end select
   end subroutine field2mumelt_electricfieldb

   subroutine field2mumelt_electricfieldA(box, field, electrode, xyz_atoms, q_elec, ions, &
          dipole_ions, polarization_field, electric_field)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_external_field_t), intent(inout) :: field      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrode(:)  !< electrode parameters
      type(MW_box_t), intent(in) :: box  !< box parameters
      type(MW_ion_t), intent(in) :: ions(:)  !< electrode parameters
      real(wp), intent(in) :: xyz_atoms(:,:)
      real(wp), intent(in) :: q_elec(:)
      real(wp), intent(in) :: dipole_ions(:,:)

      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: polarization_field(:,:)
      real(wp), intent(out) :: electric_field(:,:)

      ! Local
      ! -----
      integer :: i, itype, ixyz
      electric_field = 0.0_wp

      call elec_polarization(box, electrode, xyz_atoms, q_elec, polarization_field)
      call dipole_polarization(box, ions, dipole_ions, polarization_field)

      do itype = 1,size(ions,1)
         do i=ions(itype)%offset+1,ions(itype)%offset+ions(itype)%count
            do ixyz = 1,3
               if(field%apply_direction(ixyz)) then
                  electric_field(i,ixyz) =  fourpi * (polarization_field(ixyz,3) +polarization_field(ixyz,4))
               end if
            end do
         end do
      end do

    end subroutine field2mumelt_electricfieldA

end module MW_external_field

! Module to compute short range electrostatic potential
module MW_coulomb_sr_pim
   use MW_kinds, only: wp
   use MW_errors, only: MW_errors_allocate_error => allocate_error
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_damping, only: MW_damping_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_multipole_tensors, only: MW_multipole_tensors_tij_ab => tij_ab, &
                                   MW_multipole_tensors_tij_abc => tij_abc
   use MW_localwork, only: MW_localwork_t
   use MW_constants, only: sqrtpi
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: gradQelec_electricfield !grad_Q [grad_mu [U^sr_muQ]]
   public :: gradmumelt_electricfield !grad_mu [grad_mu [U^sr_mumu]]
   public :: mumelt2Qelec_potential !grad_Q [U^sr_muQ]
   public :: qmelt2mumelt_electricfield !-grad_mu [U^sr_qmu]
   public :: mumelt2mumelt_electricfield !-grad_mu [U^sr_mumu]
   public :: Qelec2mumelt_electricfield !-grad_mu [U^sr_muQ]
   public :: melt_efg !-grad_r grad_r [(U^sr_qq) + (U^sr_qmu) + (U^sr_mumu)] 
   public :: melt_forces !-grad_r [(U^sr_qq + U^sr_qmu + U^sr_mumu) + (U^sr_QQ) + (U^sr_qQ + U^sr_muQ)]
   public :: energy !(U^sr_qq + U^sr_qmu + U^sr_mumu) + (U^sr_QQ) + (U^sr_qQ + U^sr_muQ)

contains

   subroutine gradQelec_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, gradQ_efield)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: gradQ_efield(:,:) !< Coulomb force on ions

      select case (num_PBC)
      case(2)
         call gradQelec_electricfield_2DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, gradQ_efield)
      case(3)
         call gradQelec_electricfield_3DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, gradQ_efield)
      end select

   end subroutine gradQelec_electricfield

   !================================================================================
   ! Compute the gradient of the electric field for each ion in the melt with respect
   ! to variations of other dipoles in the melt
   subroutine gradmumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
      gradmu_efield)
      implicit none

      ! Parameters in
      ! -------------
      integer,               intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t),  intent(in)    :: localwork         !< Local work assignment
      type(MW_ewald_t),      intent(in)    :: ewald             !< Ewald summation parameters
      type(MW_box_t),        intent(in)    :: box               !< Simulation box parameters
      type(MW_ion_t),        intent(in)    :: ions(:)           !< ions parameters
      real(wp),              intent(in)    :: xyz_ions(:,:)     !< ions xyz positions

      ! Parameters out
      ! --------------
      real(wp),              intent(inout) :: gradmu_efield(:,:) !< matrix containing the
      ! gradient of the field

      select case (num_PBC)
      case(2)
         call gradmumelt_electricfield_2DPBC(localwork, ewald, box, ions, xyz_ions, &
         gradmu_efield)
      case(3)
         call gradmumelt_electricfield_3DPBC(localwork, ewald, box, ions, xyz_ions, &
         gradmu_efield)
      end select
   end subroutine gradmumelt_electricfield

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   subroutine mumelt2Qelec_potential(num_PBC, localwork, ewald, box, &
              ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters

      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)
      integer,              intent(in)    :: type_electrode_atoms(:)

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: V(:)       !< Coulomb potential

      select case (num_PBC)
      case(2)
         call mumelt2Qelec_potential_2DPBC(localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V)
      case(3)
         call mumelt2Qelec_potential_3DPBC(localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V)
      end select
   end subroutine mumelt2Qelec_potential

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ion
   ! charges
   subroutine qmelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                   type_ions, efield, tt)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      integer,              intent(in)    :: type_ions(:)
      type(MW_damping_t),   intent(in)    :: tt  ! Damping parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      select case (num_PBC)
      case(2)
         call qmelt2mumelt_electricfield_2DPBC(localwork, ewald, box, ions, xyz_ions, &
                 type_ions, efield, tt)
      case(3)
         call qmelt2mumelt_electricfield_3DPBC(localwork, ewald, box, ions, xyz_ions, &
                 type_ions, efield, tt)
      end select

   end subroutine qmelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   subroutine mumelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         efield, dipoles)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)      !< ions dipoles

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      select case (num_PBC)
      case(2)
         call mumelt2mumelt_electricfield_2DPBC(localwork, ewald, box, ions, xyz_ions, &
            efield, dipoles)
      case(3)
         call mumelt2mumelt_electricfield_3DPBC(localwork, ewald, box, ions, xyz_ions, &
            efield, dipoles)
      end select
   end subroutine mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ion
   ! charges
   subroutine Qelec2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      integer,              intent(in)    :: type_electrode_atoms(:)

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      select case (num_PBC)
      case(2)
         call Qelec2mumelt_electricfield_2DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
      case(3)
         call Qelec2mumelt_electricfield_3DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
      end select

   end subroutine Qelec2mumelt_electricfield

   !==============================================================================
   ! Compute the electric field gradient felt by melt ions due to point charges 
   ! and point dipoles of melt ions.
   subroutine melt_efg(num_PBC, localwork, ewald, box, ions, xyz_ions, dipoles, efg)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC        !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork      !< local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)   !< ions dipoles

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efg(:,:) !< the EFG on ions

      select case (num_PBC)
      case(2)
         call melt_efg_pim_2DPBC(localwork, ewald, box, ions, xyz_ions, dipoles, efg)
      case(3)
         call melt_efg_pim_3DPBC(localwork, ewald, box, ions, xyz_ions, dipoles, efg)
      end select

   end subroutine melt_efg

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
      electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor, dipoles, tt)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC         !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald           !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< Ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)   !< Ions xyz positions
      integer,              intent(in)    :: type_ions(:)    !< Ion types
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< Electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< Electrode atoms xyz positions
      integer,              intent(in)    :: type_electrode_atoms(:) !< Electrode atoms types
      real(wp),             intent(in)    :: q_elec(:)       !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)    !< Ions dipoles
      type(MW_damping_t),   intent(in)    :: tt              ! Damping parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: force(:,:) !< Coulomb force on ions
      real(wp),             intent(inout) :: stress_tensor(:,:) !< Coulomb force contribution to stress 

      select case (num_PBC)
      case(2)
         call melt_forces_pim_2DPBC(localwork, ewald, box, ions, xyz_ions, type_ions, &
         electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor, dipoles, tt)
      case(3)
         call melt_forces_pim_3DPBC(localwork, ewald, box, ions, xyz_ions, type_ions, &
         electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor, dipoles, tt)
      end select

   end subroutine melt_forces

   !================================================================================
   ! Compute the Energy due to Coulomb interactions
   subroutine energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, h, dipoles, tt)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)      !< ions dipoles
      type(MW_damping_t),   intent(in)    :: tt  ! Damping parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: h !< Coulomb energy

      select case (num_PBC)
      case(2)
         call energy_pim_2DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h, dipoles, tt)
      case(3)
         call energy_pim_3DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h, dipoles, tt)
      end select
   end subroutine energy

   !Functions=============================

   function gradmumelt_elec_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi) result(gmu_et_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in)   :: drnorm2
      real(wp), intent(in)   :: dx,dy,dz
      real(wp), intent(in)   :: alpha
      real(wp), intent(in)   :: alphasq
      real(wp), intent(in)   :: alphapi

      ! Result
      ! ------
      real(wp), dimension(6) :: gmu_et_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: drnorm3rec, drnorm5rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: gmuet_ij_xx, gmuet_ij_yy, gmuet_ij_zz
      real(wp) :: gmuet_ij_yx, gmuet_ij_zx, gmuet_ij_zy
      real(wp) :: efact1, efact2

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnormrec*drnorm2rec
      drnorm5rec = drnorm3rec*drnorm2rec

      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi

      efact1 = exp_alpha*drnorm + erfc(alpha*drnorm)   ! efact in pimaim
      efact2 = 2.0_wp*alphasq*drnorm2rec*exp_alpha

      gmuet_ij_xx = (+drnorm3rec &
      -3.0_wp*drnorm5rec*dx*dx)*efact1 &
      -dx*dx*efact2
      gmuet_ij_yx = (-3.0_wp*drnorm5rec*dy*dx)*efact1 &
      -dy*dx*efact2
      gmuet_ij_zx = (-3.0_wp*drnorm5rec*dz*dx)*efact1 &
      -dz*dx*efact2

      gmuet_ij_yy = (drnorm3rec &
      -3.0_wp*drnorm5rec*dy*dy)*efact1 &
      -dy*dy*efact2
      gmuet_ij_zy = (-3.0_wp*drnorm5rec*dz*dy)*efact1 &
      -dz*dy*efact2

      gmuet_ij_zz = (drnorm3rec &
      -3.0_wp*drnorm5rec*dz*dz)*efact1 &
      -dz*dz*efact2

      gmu_et_ij(1) = gmuet_ij_xx
      gmu_et_ij(2) = gmuet_ij_yx
      gmu_et_ij(3) = gmuet_ij_zx
      gmu_et_ij(4) = gmuet_ij_yy
      gmu_et_ij(5) = gmuet_ij_zy
      gmu_et_ij(6) = gmuet_ij_zz

   end function gradmumelt_elec_ij

   function pot_mumelt2Qelec_ij(drnorm2, dx, dy, dz, alpha, alphasq, alphapi, &
      eta, etasq, etapi, mux, muy, muz) result(pt_ij)
      implicit none
      !$acc routine seq

      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx, dy, dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: eta
      real(wp), intent(in) :: etasq
      real(wp), intent(in) :: etapi
      real(wp), intent(in) :: mux, muy, muz

      ! Result
      ! ------
      real(wp) :: pt_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: erfc_eta, exp_eta
      real(wp) :: rdotmu
      real(wp) :: pot_ij

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      ! Change erfc to 1-erf because of underflows
      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi
      erfc_eta = erfc(eta*drnorm)*drnormrec
      exp_eta = exp(-etasq*drnorm2)*etapi
      pot_ij =  drnorm2rec * ((erfc_alpha + exp_alpha) - (erfc_eta + exp_eta))
      rdotmu = dx*mux + dy*muy + dz*muz !In the energy this scalar product is computed with the minus

      pt_ij = +pot_ij*rdotmu !The minus from the scalar product is compesated here

   end function pot_mumelt2Qelec_ij

   function elec_qmelt2mumelt_ij(drnorm2, alpha, alphasq, alphapi) &
      result(et_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi

      ! Result
      ! ------
      real(wp) :: et_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: erfc_alpha, exp_alpha

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi

      et_ij = (erfc_alpha + exp_alpha)*drnorm2rec

   end function elec_qmelt2mumelt_ij

   function elec_mumelt2mumelt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, muix, muiy, muiz, mujx, mujy, mujz) &
      result(et_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx,dy,dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: muix,muiy,muiz
      real(wp), intent(in) :: mujx,mujy,mujz

      ! Result
      ! ------
      real(wp),dimension(6) :: et_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: drnorm3rec, drnorm5rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: muidotrij, mujdotrij
      real(wp) :: etqmu_ijx, etqmu_ijy, etqmu_ijz
      real(wp) :: etqmu_jix, etqmu_jiy, etqmu_jiz
      real(wp) :: efact1, efact2

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnormrec*drnorm2rec
      drnorm5rec = drnorm3rec*drnorm2rec

      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi

      muidotrij = -muix*dx - muiy*dy - muiz*dz ! xmuidotrij in pimaim Warning sens vecteur dr
      mujdotrij = -mujx*dx - mujy*dy - mujz*dz ! xmujdotrij in pimaim


      efact1 = exp_alpha*drnorm + erfc(alpha*drnorm)   ! efact in pimaim
      efact2 = 2.0_wp*alphasq*drnorm2rec*exp_alpha

      etqmu_ijx = -(muix*drnorm3rec &
      +3.0_wp*dx*drnorm5rec*muidotrij)*efact1 &
      -dx*muidotrij*efact2
      etqmu_ijy = -(muiy*drnorm3rec &
      +3.0_wp*dy*drnorm5rec*muidotrij)*efact1 &
      -dy*muidotrij*efact2
      etqmu_ijz = -(muiz*drnorm3rec &
      +3.0_wp*dz*drnorm5rec*muidotrij)*efact1 &
      -dz*muidotrij*efact2

      etqmu_jix = -(mujx*drnorm3rec &
      +3.0_wp*dx*drnorm5rec*mujdotrij)*efact1 &
      -dx*mujdotrij*efact2
      etqmu_jiy = -(mujy*drnorm3rec &
      +3.0_wp*dy*drnorm5rec*mujdotrij)*efact1 &
      -dy*mujdotrij*efact2
      etqmu_jiz = -(mujz*drnorm3rec &
      +3.0_wp*dz*drnorm5rec*mujdotrij)*efact1 &
      -dz*mujdotrij*efact2

      et_ij(1) = etqmu_ijx
      et_ij(2) = etqmu_ijy
      et_ij(3) = etqmu_ijz
      et_ij(4) = etqmu_jix
      et_ij(5) = etqmu_jiy
      et_ij(6) = etqmu_jiz

   end function elec_mumelt2mumelt_ij

   function elec_Qelec2mumelt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, eta, etasq, etapi, Q_j) result(et_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx, dy, dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: eta
      real(wp), intent(in) :: etasq
      real(wp), intent(in) :: etapi
      real(wp), intent(in) :: Q_j

      ! Result
      ! ------
      real(wp), dimension(3) :: et_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: erfc_eta, exp_eta
      real(wp) :: eij

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      ! Change erfc to 1-erf because of underflows
      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi
      erfc_eta = erfc(eta*drnorm)*drnormrec
      exp_eta = exp(-etasq*drnorm2)*etapi

      eij = drnorm2rec*((erfc_alpha + exp_alpha) - (erfc_eta + exp_eta))

      et_ij(1) = eij*Q_j*dx
      et_ij(2) = eij*Q_j*dy
      et_ij(3) = eij*Q_j*dz

   end function elec_Qelec2mumelt_ij

   function force_melt2melt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, qi, qj, &
      muix, muiy, muiz, mujx, mujy, mujz, &
      bij, bji, orderij, orderji, cij, cji) &
      result(ft_ij)
      implicit none
      ! Passed in
      ! ---------
      integer,  intent(in) :: orderij, orderji
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx, dy, dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: qi
      real(wp), intent(in) :: qj
      real(wp), intent(in) :: muix, muiy, muiz
      real(wp), intent(in) :: mujx, mujy, mujz
      real(wp), intent(in) :: bij, bji, cij, cji

      ! Result
      ! ------
      real(wp),dimension(3) :: ft_ij

      ! Local
      ! -----
      integer  :: kk
      real(wp) :: drnorm, drnormrec, drnorm2rec, drnorm7rec
      real(wp) :: drnorm3rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: muidotrij, mujdotrij
      real(wp) :: ftqq_ij, ftqq_ijx, ftqq_ijy, ftqq_ijz
      real(wp) :: ftqmu_ijx, ftqmu_ijy, ftqmu_ijz
      real(wp) :: ftqmu_jix, ftqmu_jiy, ftqmu_jiz
      real(wp) :: ftqmusr_ijx, ftqmusr_ijy, ftqmusr_ijz
      real(wp) :: ftqmusr_jix, ftqmusr_jiy, ftqmusr_jiz
      real(wp) :: ftmumu_ijx, ftmumu_ijy, ftmumu_ijz
      real(wp) :: efact1, efact2, efact3
      real(wp) :: qjdotmuix, qjdotmuiy, qjdotmuiz
      real(wp) :: minusqidotmujx, minusqidotmujy, minusqidotmujz
      real(wp) :: qmuengij, qmuengji, qmueng
      real(wp) :: muidotSx, muidotSy, muidotSz, muidotSdotmuj
      real(wp) :: sxx, sxy, sxz, syy, syz, szz
      real(wp) :: txxx, txxy, txyy, txxz, txzz, tyyy, tyyz, tyzz, tzzz, txyz
      real(wp) :: mujdotTdotmuix, mujdotTdotmuiy, mujdotTdotmuiz
      real(wp) :: xf, factorial
      real(wp) :: dampsumfi, dampexpi, dampfunci, dampfuncdiffi, diprfunci
      real(wp) :: dampsumfj, dampexpj, dampfuncj, dampfuncdiffj, diprfuncj
      real(wp) :: bjidrnorm, bijdrnorm

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnormrec*drnorm2rec
      drnorm7rec = drnorm3rec*drnorm2rec*drnorm2rec

      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi

      ftqq_ij = qi*qj*(erfc_alpha + exp_alpha)*drnorm2rec
      ftqq_ijx = -dx*ftqq_ij
      ftqq_ijy = -dy*ftqq_ij
      ftqq_ijz = -dz*ftqq_ij

      muidotrij = -muix*dx - muiy*dy - muiz*dz ! xmuidotrij in pimaim Warning sens vecteur dr
      mujdotrij = -mujx*dx - mujy*dy - mujz*dz ! xmujdotrij in pimaim

      efact1 = exp_alpha*drnorm + erfc(alpha*drnorm)   ! efact in pimaim
      efact2 = 2.0_wp*alphasq*drnorm2rec*exp_alpha
      efact3 = 2.0_wp*efact2*(drnorm2rec + alphasq)

      qmuengij = (qj*muidotrij)*drnorm3rec  !chgdipengij
      qmuengji = -(qi*mujdotrij)*drnorm3rec !chgdipengji
      qmueng = (qmuengij + qmuengji)*efact1   !chgdipeng

      qjdotmuix = qj*muix  ! qdotmuxij in pimaim
      qjdotmuiy = qj*muiy  ! qdotmuyij in pimaim
      qjdotmuiz = qj*muiz  ! qdotmuzij in pimaim

      minusqidotmujx = -qi*mujx ! qdotmuxji in pimaim
      minusqidotmujy = -qi*mujy ! qdotmuyji in pimaim
      minusqidotmujz = -qi*mujz ! qdotmuzji in pimaim

      ftqmu_ijx = (qjdotmuix*drnorm3rec &
      +3.0_wp*dx*drnorm2rec*qmuengij)*efact1 &
      +dx*muidotrij*qj*efact2
      ftqmu_ijy = (qjdotmuiy*drnorm3rec &
      +3.0_wp*dy*drnorm2rec*qmuengij)*efact1 &
      +dy*muidotrij*qj*efact2
      ftqmu_ijz = (qjdotmuiz*drnorm3rec &
      +3.0_wp*dz*drnorm2rec*qmuengij)*efact1 &
      +dz*muidotrij*qj*efact2

      ftqmu_jix = (minusqidotmujx*drnorm3rec &
      +3.0_wp*dx*drnorm2rec*qmuengji)*efact1 &
      -dx*mujdotrij*qi*efact2
      ftqmu_jiy = (minusqidotmujy*drnorm3rec &
      +3.0_wp*dy*drnorm2rec*qmuengji)*efact1 &
      -dy*mujdotrij*qi*efact2
      ftqmu_jiz = (minusqidotmujz*drnorm3rec &
      +3.0_wp*dz*drnorm2rec*qmuengji)*efact1 &
      -dz*mujdotrij*qi*efact2

      dampsumfi = 1.0_wp
      xf = 1.0_wp
      factorial = 1.0_wp
      bjidrnorm = bji*drnorm
      do kk = 1, orderji
         xf = xf*bjidrnorm
         factorial = factorial*float(kk)
         dampsumfi = dampsumfi + (xf/factorial)
      enddo
      dampexpi = dexp(-bji*drnorm)
      dampfunci = -dampsumfi*dampexpi*cji
      dampfuncdiffi = bji*dampexpi*cji*((bjidrnorm)**orderji)/factorial
      diprfunci = qmuengij*drnormrec*(-3.0_wp*dampfunci*drnormrec + dampfuncdiffi)

      ftqmusr_ijx = qjdotmuix*dampfunci*drnorm3rec - dx*diprfunci
      ftqmusr_ijy = qjdotmuiy*dampfunci*drnorm3rec - dy*diprfunci
      ftqmusr_ijz = qjdotmuiz*dampfunci*drnorm3rec - dz*diprfunci

      dampsumfj = 1.0_wp
      xf = 1.0_wp
      factorial = 1.0_wp
      bijdrnorm = bij*drnorm
      do kk = 1, orderij
         xf = xf*bijdrnorm
         factorial = factorial*float(kk)
         dampsumfj = dampsumfj + (xf/factorial)
      enddo
      dampexpj = dexp(-bij*drnorm)
      dampfuncj = -dampsumfj*dampexpj*cij
      dampfuncdiffj = bij*dampexpj*cij*((bijdrnorm)**orderij)/factorial
      diprfuncj = -qmuengji*drnormrec*(-3.0_wp*dampfuncj*drnormrec + dampfuncdiffj)

      ftqmusr_jix = minusqidotmujx*dampfuncj*drnorm3rec + dx*diprfuncj
      ftqmusr_jiy = minusqidotmujy*dampfuncj*drnorm3rec + dy*diprfuncj
      ftqmusr_jiz = minusqidotmujz*dampfuncj*drnorm3rec + dz*diprfuncj

      sxx = 1.0_wp - 3.0_wp*dx*dx*drnorm2rec ! sxx in pimaim
      syy = 1.0_wp - 3.0_wp*dy*dy*drnorm2rec
      szz = 1.0_wp - 3.0_wp*dz*dz*drnorm2rec
      sxy = -3.0_wp*dx*dy*drnorm2rec
      sxz = -3.0_wp*dx*dz*drnorm2rec
      syz = -3.0_wp*dy*dz*drnorm2rec

      muidotSx = muix*sxx + muiy*sxy + muiz*sxz  ! xmuidotT in pimaim
      muidotSy = muix*sxy + muiy*syy + muiz*syz  ! ymuidotT in pimaim
      muidotSz = muix*sxz + muiy*syz + muiz*szz  ! zmuidotT in pimaim

      muidotSdotmuj = muidotSx*mujx + muidotSy*mujy + muidotSz*mujz ! dipdipeng in pimaim

      txxx = -(15.0_wp*dx**3.0    - 9.0_wp*dx*drnorm2)*drnorm7rec
      tyyy = -(15.0_wp*dy**3.0    - 9.0_wp*dy*drnorm2)*drnorm7rec
      tzzz = -(15.0_wp*dz**3.0    - 9.0_wp*dz*drnorm2)*drnorm7rec
      txxy = -(15.0_wp*dy*dx**2.0 - 3.0_wp*dy*drnorm2)*drnorm7rec
      txyy = -(15.0_wp*dx*dy**2.0 - 3.0_wp*dx*drnorm2)*drnorm7rec
      txxz = -(15.0_wp*dz*dx**2.0 - 3.0_wp*dz*drnorm2)*drnorm7rec
      txzz = -(15.0_wp*dx*dz**2.0 - 3.0_wp*dx*drnorm2)*drnorm7rec
      tyyz = -(15.0_wp*dz*dy**2.0 - 3.0_wp*dz*drnorm2)*drnorm7rec
      tyzz = -(15.0_wp*dy*dz**2.0 - 3.0_wp*dy*drnorm2)*drnorm7rec
      txyz = -(15.0_wp*dx*dy*dz                     )*drnorm7rec

      mujdotTdotmuix = (mujx*(muix*txxx + muiy*txxy + muiz*txxz)) &  !fmumux in pimaim
      +(mujy*(muix*txxy + muiy*txyy + muiz*txyz)) &
      +(mujz*(muix*txxz + muiy*txyz + muiz*txzz))
      mujdotTdotmuiy = (mujx*(muix*txxy + muiy*txyy + muiz*txyz)) &  !fmumuy in pimaim
      +(mujy*(muix*txyy + muiy*tyyy + muiz*tyyz)) &
      +(mujz*(muix*txyz + muiy*tyyz + muiz*tyzz))
      mujdotTdotmuiz = (mujx*(muix*txxz + muiy*txyz + muiz*txzz)) &  !fmumuz in pimaim
      +(mujy*(muix*txyz + muiy*tyyz + muiz*tyzz)) &
      +(mujz*(muix*txzz + muiy*tyzz + muiz*tzzz))

      ftmumu_ijx = -mujdotTdotmuix*efact1 - muidotSdotmuj*efact2*dx + muix*mujdotrij*efact2 &
      +mujx*muidotrij*efact2 + muidotrij*mujdotrij*dx*efact3
      ftmumu_ijy = -mujdotTdotmuiy*efact1 - muidotSdotmuj*efact2*dy + muiy*mujdotrij*efact2 &
      +mujy*muidotrij*efact2 + muidotrij*mujdotrij*dy*efact3
      ftmumu_ijz = -mujdotTdotmuiz*efact1 - muidotSdotmuj*efact2*dz + muiz*mujdotrij*efact2 &
      +mujz*muidotrij*efact2 + muidotrij*mujdotrij*dz*efact3

      !     ft_ij(1) = ftqmu_ijx+ftqmu_jix
      !     ft_ij(2) = ftqmu_ijy+ftqmu_jiy
      !     ft_ij(3) = ftqmu_ijz+ftqmu_jiz
      ft_ij(1) = ftqq_ijx + ftqmu_ijx + ftqmu_jix + ftqmusr_ijx + ftqmusr_jix + ftmumu_ijx
      ft_ij(2) = ftqq_ijy + ftqmu_ijy + ftqmu_jiy + ftqmusr_ijy + ftqmusr_jiy + ftmumu_ijy
      ft_ij(3) = ftqq_ijz + ftqmu_ijz + ftqmu_jiz + ftqmusr_ijz + ftqmusr_jiz + ftmumu_ijz

   end function force_melt2melt_ij

   function force_elec2melt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, eta, etasq, etapi, &
      qi, Q_j, muix, muiy, muiz) result(ft_ij)
      implicit none
      !$acc routine seq

      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx, dy, dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: eta
      real(wp), intent(in) :: etasq
      real(wp), intent(in) :: etapi
      real(wp), intent(in) :: qi
      real(wp), intent(in) :: Q_j
      real(wp), intent(in) :: muix, muiy, muiz

      ! Result
      ! ------
      real(wp), dimension(3) :: ft_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: drnorm3rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: erfc_eta, exp_eta
      real(wp) :: fijqq
      real(wp) :: muidotrij
      real(wp) :: efact_alpha_1, efact_alpha_2
      real(wp) :: efact_eta_1, efact_eta_2
      real(wp) :: Qmueng
      real(wp) :: Qjdotmuix, Qjdotmuiy, Qjdotmuiz

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnorm2rec*drnormrec

      ! Change erfc to 1-erf because of underflows
      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi
      erfc_eta = erfc(eta*drnorm)*drnormrec
      exp_eta = exp(-etasq*drnorm2)*etapi

      fijqq = qi*Q_j*drnorm2rec*((erfc_alpha + exp_alpha) - (erfc_eta + exp_eta))

      ft_ij(1) = -fijqq*dx
      ft_ij(2) = -fijqq*dy
      ft_ij(3) = -fijqq*dz

      muidotrij = muix*dx + muiy*dy + muiz*dz ! xmuidotrij in pimaim Warning sens vecteur dr

      efact_alpha_1 = exp_alpha*drnorm + erfc(alpha*drnorm)   ! efact in pimaim
      efact_alpha_2 = 2.0_wp*alphasq*drnorm2rec*exp_alpha

      efact_eta_1 = exp_eta*drnorm + erfc(eta*drnorm)   ! efact in pimaim
      efact_eta_2 = 2.0_wp*etasq*drnorm2rec*exp_eta

      Qmueng = (Q_j*muidotrij)*drnorm3rec  !chgdipengij

      Qjdotmuix = Q_j*muix  ! qdotmuxij in pimaim
      Qjdotmuiy = Q_j*muiy  ! qdotmuyij in pimaim
      Qjdotmuiz = Q_j*muiz  ! qdotmuzij in pimaim

      ft_ij(1) = ft_ij(1) + &
         ((Qjdotmuix*drnorm3rec - 3.0_wp*dx*drnorm2rec*Qmueng)*efact_alpha_1 &
         - dx*muidotrij*Q_j*efact_alpha_2) - &
         ((Qjdotmuix*drnorm3rec - 3.0_wp*dx*drnorm2rec*Qmueng)*efact_eta_1 &
         - dx*muidotrij*Q_j*efact_eta_2)
      ft_ij(2) = ft_ij(2) + &
         ((Qjdotmuiy*drnorm3rec - 3.0_wp*dy*drnorm2rec*Qmueng)*efact_alpha_1 &
         - dy*muidotrij*Q_j*efact_alpha_2) - &
         ((Qjdotmuiy*drnorm3rec - 3.0_wp*dy*drnorm2rec*Qmueng)*efact_eta_1 &
         - dy*muidotrij*Q_j*efact_eta_2)
      ft_ij(3) = ft_ij(3) + &
         ((Qjdotmuiz*drnorm3rec - 3.0_wp*dz*drnorm2rec*Qmueng)*efact_alpha_1 &
         - dz*muidotrij*Q_j*efact_alpha_2) - &
         ((Qjdotmuiz*drnorm3rec - 3.0_wp*dz*drnorm2rec*Qmueng)*efact_eta_1 &
         - dz*muidotrij*Q_j*efact_eta_2)

   end function force_elec2melt_ij

   function energy_melt2melt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, qi, qj, &
      muix, muiy, muiz, mujx, mujy, mujz, &
      bij, bji, orderij, orderji, cij, cji) &
      result(enerij)
      implicit none
      ! Passed in
      ! ---------
      integer,  intent(in) :: orderij, orderji
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx, dy, dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: qi
      real(wp), intent(in) :: qj
      real(wp), intent(in) :: muix, muiy, muiz
      real(wp), intent(in) :: mujx, mujy, mujz
      real(wp), intent(in) :: bij, bji, cij, cji

      ! Result
      ! ------
      real(wp) :: enerij

      ! Local
      ! -----
      integer  :: kk
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: drnorm3rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: muidotrij, mujdotrij
      real(wp) :: efact1, efact2
      real(wp) :: qmuengij, qmuengji, qmueng
      real(wp) :: muidotSx, muidotSy, muidotSz, muidotSdotmuj
      real(wp) :: sxx, sxy, sxz, syy, syz, szz
      real(wp) :: xf, factorial
      real(wp) :: dampsumfi, dampexpi, dampfunci
      real(wp) :: dampsumfj, dampexpj, dampfuncj
      real(wp) :: bjidrnorm, bijdrnorm

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnormrec*drnorm2rec

      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi

      enerij = qi*qj*erfc_alpha

      muidotrij = -muix*dx - muiy*dy - muiz*dz ! xmuidotrij in pimaim Warning sens vecteur dr
      mujdotrij = -mujx*dx - mujy*dy - mujz*dz ! xmujdotrij in pimaim

      efact1 = exp_alpha*drnorm + erfc(alpha*drnorm)   ! efact in pimaim
      efact2 = 2.0_wp*alphasq*drnorm2rec*exp_alpha

      qmuengij = (qj*muidotrij)*drnorm3rec  !chgdipengij
      qmuengji = -(qi*mujdotrij)*drnorm3rec !chgdipengji
      qmueng = (qmuengij + qmuengji)*efact1   !chgdipeng
      enerij = enerij - qmueng

      dampsumfi = 1.0_wp
      xf = 1.0_wp
      factorial = 1.0_wp
      bjidrnorm = bji*drnorm
      do kk = 1, orderji
         xf = xf*bjidrnorm
         factorial = factorial*float(kk)
         dampsumfi = dampsumfi + (xf/factorial)
      enddo
      dampexpi = dexp(-bji*drnorm)
      dampfunci = -dampsumfi*dampexpi*cji*drnorm3rec
      enerij = enerij - qj*muidotrij*dampfunci

      dampsumfj = 1.0_wp
      xf = 1.0_wp
      factorial = 1.0_wp
      bijdrnorm = bij*drnorm
      do kk = 1, orderij
         xf = xf*bijdrnorm
         factorial = factorial*float(kk)
         dampsumfj = dampsumfj + (xf/factorial)
      enddo
      dampexpj = dexp(-bij*drnorm)
      dampfuncj = -dampsumfj*dampexpj*cij*drnorm3rec
      enerij = enerij + qi*mujdotrij*dampfuncj

      sxx = 1.0_wp - 3.0_wp*dx*dx*drnorm2rec ! sxx in pimaim
      syy = 1.0_wp - 3.0_wp*dy*dy*drnorm2rec
      szz = 1.0_wp - 3.0_wp*dz*dz*drnorm2rec
      sxy = -3.0_wp*dx*dy*drnorm2rec
      sxz = -3.0_wp*dx*dz*drnorm2rec
      syz = -3.0_wp*dy*dz*drnorm2rec

      muidotSx = muix*sxx + muiy*sxy + muiz*sxz  ! xmuidotT in pimaim
      muidotSy = muix*sxy + muiy*syy + muiz*syz  ! ymuidotT in pimaim
      muidotSz = muix*sxz + muiy*syz + muiz*szz  ! zmuidotT in pimaim

      muidotSdotmuj = muidotSx*mujx + muidotSy*mujy + muidotSz*mujz ! dipdipeng in pimaim (1st occurence)

      enerij = enerij + muidotSdotmuj*efact1*drnorm3rec - muidotrij*mujdotrij*efact2

   end function energy_melt2melt_ij

   function energy_elec2melt_ij(drnorm2, dx, dy, dz, &
      alpha, alphasq, alphapi, eta, etasq, etapi,&
      qi, Q_j, muix, muiy, muiz) &
      result(enerij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: dx,dy,dz
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: eta
      real(wp), intent(in) :: etasq
      real(wp), intent(in) :: etapi
      real(wp), intent(in) :: qi
      real(wp), intent(in) :: Q_j
      real(wp), intent(in) :: muix,muiy,muiz

      ! Result
      ! ------
      real(wp) :: enerij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: drnorm3rec
      real(wp) :: erfc_alpha, exp_alpha
      real(wp) :: erfc_eta, exp_eta
      real(wp) :: eij
      real(wp) :: muidotrij
      real(wp) :: Qmueng

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec
      drnorm3rec = drnormrec*drnorm2rec

      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      erfc_eta = erfc(eta*drnorm)*drnormrec

      enerij = qi*Q_j*(erfc_alpha - erfc_eta) !energy due to charges qQ

      exp_alpha = exp(-alphasq*drnorm2)*alphapi
      exp_eta = exp(-etasq*drnorm2)*etapi

      eij =  drnorm2rec*((erfc_alpha + exp_alpha) - (erfc_eta + exp_eta))

      muidotrij = muix*dx + muiy*dy + muiz*dz ! xmuidotrij in pimaim Warning sens vecteur dr

      Qmueng =  (Q_j*muidotrij)*eij         !chgdipengij
      enerij = enerij + Qmueng !energy due to dipoles and electrodes charges muQ

   end function energy_elec2melt_ij

   ! ================================================================================
   include 'coulomb_sr_pim_2DPBC.inc'
   include 'coulomb_sr_pim_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_coulomb_sr_pim

! Module to handle reading a configuration file based on key/value pairs
!
module MW_configuration
   use MW_configuration_line, only: MW_configuration_line_t, &
         MW_configuration_line_seek_next_data => seek_next_data, &
         MW_configuration_line_get_word => get_word, &
         max_word_length
   use MW_system, only: MW_system_t
   use MW_errors, only: &
         MW_errors_runtime_error => runtime_error, &
         MW_errors_allocate_error => allocate_error, &
         MW_errors_deallocate_error => deallocate_error
   use MW_kinds, only: wp
   use MW_external_field, only: MW_external_field_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: read_system_parameters
contains

   !================================================================================
   ! Read system parameters from configuration file
   !
   ! File format
   !
   !   num_steps *int*
   !   timestep  *real*
   !   temperature  *real*
   !   box *block*
   !   thermostat *block*
   !   barostat *block*
   !   species *block*
   !   molecules *block*
   !   electrodes *block*
   !   interactions *block*
   !   output *block*
   !   velocity *block*
   !
   subroutine read_system_parameters(system, algorithms, configfile)
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_void_type => void_type
      use MW_system, only: MW_system_t, &
            MW_system_void_parameters => void_parameters, &
            MW_system_check_electrodes => check_electrodes, &
            MW_system_check_polarizability => check_polarizability, &
            MW_system_check_deformability => check_deformability
      use MW_errors, only: MW_errors_open_error => open_error, &
            MW_errors_close_error => close_error, &
            MW_errors_parameter_error => parameter_error, &
            MW_errors_runtime_warning => runtime_warning
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_ion, only: &
            MW_ion_define_type => define_type, &
            MW_ion_void_type => void_type
      use MW_electrode, only: &
            MW_electrode_define_type => define_type, &
            MW_electrode_void_type => void_type
      use MW_molecule, only: &
            MW_molecule_define_type => define_type, &
            MW_molecule_void_type => void_type, &
            MW_molecule_set_index => set_index, &
            MW_molecule_set_sites_index => set_sites_index
      use MW_electrode_parameters, only: MW_electrode_parameters_t, &
            MW_electrode_parameters_set_index => set_index, &
            MW_electrode_parameters_set_species_index => set_species_index
      use MW_species, only: MW_species_t
      use MW_species_parameters, only: CHARGE_TYPE_GAUSSIAN
      use MW_cg, only: MW_cg_allocate_arrays => allocate_arrays
      use MW_thomas_fermi, only: MW_thomas_fermi_t, &
            MW_thomas_fermi_void_type => void_type, &
            MW_thomas_fermi_define_type => define_type
!      use MW_cgaim, only: MW_cgaim_allocate_arrays => allocate_arrays
      use MW_maze, only: MW_maze_set_dimensionality => set_dimensionality, &
            MW_maze_allocate_arrays => allocate_arrays
      use MW_matrix_inversion, only: MW_matrix_inversion_allocate_arrays => allocate_arrays
      use MW_ewald, only: MW_ewald_set_num_pbc => set_num_pbc
      use MW_external_field, only: FIELD_TYPE_ELECTRIC, FIELD_TYPE_DISPLACEMENT
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms
      character(*), intent(in) :: configfile

      ! Local
      ! -----
      integer :: funit, ierr
      integer :: line_num
      character(max_word_length) :: keyword
      integer :: i
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      integer :: temperature_defined, numstep_defined, timestep_defined, numPBC_defined, &
            box_defined, species_defined, molecules_defined, electrodes_defined, &
            interactions_defined, output_defined, thermostat_defined, barostat_defined, &
            velocity_defined, plumed_defined, dipoles_electrodes_defined, &
            external_field_defined
      integer :: charges_defined, charge_neutrality_defined, dipoles_minimization_defined
      integer :: itype, num_elec, num_species, num_ion_types, species_index
      type(MW_species_t), allocatable :: species(:)
      type(MW_electrode_parameters_t), allocatable :: electrodes(:)

      ! Reset all system parameters
      call MW_system_void_parameters(system)
      call MW_algorithms_void_type(algorithms)

      ! Open file
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=configfile, access="SEQUENTIAL", action="READ", &
            position="REWIND", form="FORMATTED", status="OLD", iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("read_system_parameters", "configuration.f90", configfile, ierr)
      end if
      line_num = 0

      ! Flag each section as undefined (line number will be stored)
      temperature_defined = 0
      numstep_defined = 0
      timestep_defined = 0
      numPBC_defined = 0
      box_defined = 0
      thermostat_defined = 0
      barostat_defined = 0
      species_defined = 0
      molecules_defined = 0
      electrodes_defined = 0
      dipoles_electrodes_defined = 0
      interactions_defined = 0
      output_defined = 0
      velocity_defined = 0
      external_field_defined = 0
      plumed_defined = 0

      charges_defined = 0
      charge_neutrality_defined = 0
      dipoles_minimization_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("temperature")
            if (temperature_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |temperature|. First definition at line ",i4,".")') &
                     line_num, temperature_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            temperature_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for temperature parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_system_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, system%temperature)

         case("num_steps")
            if (numstep_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |num_steps|. First definition at line ",i4,".")') &
                     line_num, numstep_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            numstep_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for num_steps parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_system_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, system%num_steps)

         case("timestep")
            if (timestep_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |timestep|. First definition at line ",i4,".")') &
                     line_num, timestep_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            timestep_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for timestep parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_system_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, system%dt)

         case("num_pbc")
            if (numPBC_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |num_pbc|. First definition at line ",i4,".")') &
                     line_num, numPBC_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            numPBC_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for num PBC parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_system_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, system%num_PBC)

         case("box")
            if (box_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |box|. First definition at line ",i4,".")') &
                     line_num, box_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            box_defined = line_num
            call read_box_parameters(system, funit, line_num)

         case("thermostat")
            if (thermostat_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |thermostat|. First definition at line ",i4,".")') &
                     line_num, thermostat_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            thermostat_defined = line_num
            call read_thermostat_parameters(system, funit, line_num)

         case("barostat")
            if (barostat_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |barostat|. First definition at line ",i4,".")') &
                     line_num, barostat_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            barostat_defined = line_num
            call read_barostat_parameters(system, funit, line_num)

#ifdef MW_USE_PLUMED
         case("plumed")
            if (plumed_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |plumed|. First definition at line ",i4,".")') &
               line_num, plumed_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            plumed_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for plumed parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_system_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, system%plumed_file)
            system%plumedlog=.true.
#else
         case("plumed")
            write(errmsg,'("At line ",i4,", definition of |plumed| needs compilation with PLUMED interface.")') line_num
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
#endif

         case("species")
            if (species_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |species|. First definition at line ",i4,".")') &
                     line_num, species_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            species_defined = line_num
            call read_species_parameters(species, algorithms, system%charged_species, system%four_site_model, funit, line_num, &
                  dipoles_minimization_defined)

         case("molecules")
            if (molecules_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |molecules|. First definition at line ",i4,".")') &
                     line_num, molecules_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            ! Molecules must be defined after ions
            if (species_defined == 0) then
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                     "molecules definition block must come after species definition block")
            end if

            molecules_defined = line_num
            call read_molecules_parameters(system, funit, line_num)

         case("electrodes")
            if (electrodes_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |electrodes|. First definition at line ",i4,".")') &
                     line_num, electrodes_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            electrodes_defined = line_num
            call read_electrodes_parameters(electrodes, algorithms, funit, line_num, system%electrode_compute_force, &
                  system%electrode_charge_neutrality, system%global_charge_neutrality, charges_defined, charge_neutrality_defined)

         case("dipoles_and_electrodes")
            if (dipoles_electrodes_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dipoles_and_electrodes|. First definition at line ",i4,".")') &
                     line_num, dipoles_electrodes_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            if (dipoles_minimization_defined > 0) then
               write(errmsg,'("At line ",i4,", |dipoles_minimization| incompatible with |dipoles_and_electrodes| block.")') &
                     dipoles_minimization_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            if (charges_defined > 0) then
               write(errmsg,'("At line ",i4,", |electrode_charges| incompatible with |dipoles_and_electrodes| block.")') &
                     charges_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            if (charge_neutrality_defined > 0) then
               write(errmsg,'("At line ",i4,", |charge_neutrality| incompatible with |dipoles_and_electrodes| block.")') &
                     charge_neutrality_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if

            dipoles_electrodes_defined = line_num
            call read_dipoles_electrodes_parameters(electrodes, algorithms, funit, line_num, &
                  system%electrode_charge_neutrality, system%global_charge_neutrality)

         case("interactions")
            if (interactions_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |interactions|. First definition at line ",i4,".")') &
                     line_num, interactions_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            interactions_defined = line_num

            if (species_defined == 0) then
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                     "interactions definition block must come after species definition block")
            end if
            call read_interactions_parameters(system, species, electrodes, funit, line_num)

         case("output")
            if (output_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |output|. First definition at line ",i4,".")') &
                     line_num, output_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            output_defined = line_num
            call read_output_parameters(system, funit, line_num)

         case("velocity")
            if (velocity_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |velocity|. First definition at line ",i4,".")') &
                     line_num, velocity_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            velocity_defined = line_num
            call read_velocity_parameters(system, funit, line_num)

         case("external_field")
            if (external_field_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |external_field|. First definition at line ",i4,".")') &
                     line_num, external_field_defined
               call MW_errors_runtime_error("read_system_parameters", "configuration.f90", errmsg)
            end if
            external_field_defined = line_num
            call read_external_field_parameters(system%field, funit, line_num)

         case default
            write(errmsg, '("Invalid keyword |",a,"| at line ",i3)') keyword, line_num
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                  errmsg)
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)

      end do keywordLoop

      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("read_system_parameters", "configuration.f90", &
               funit, ierr)
      end if

      ! Define ions and electrodes from species and electrode_parameters
      ! ions = fixed or mobile point charge species
      ! electrodes = fixed gaussian charge species
      ! mobile gaussian charge species are not supported
      ! all gaussian charge species must be mapped to an electrode
      ! point charge species must be defined before gaussian charge species
      num_species = 0
      if (allocated(species)) num_species = size(species,1)
      num_elec = 0
      if (allocated(electrodes)) num_elec = size(electrodes,1)
      num_ion_types = num_species - num_elec

      if (num_ion_types < 0) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "You defined more electrode_type(s) than species_type(s)")
      end if

      ! Define ions
      ! -----------
      if (allocated(system%ions)) then
         do itype = 1, size(system%ions,1)
            call MW_ion_void_type(system%ions(itype))
         end do
         deallocate(system%ions, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_system_parameters", "configuration.f90", ierr)
         end if
      end if
      allocate(system%ions(num_ion_types), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_system_parameters", "configuration.f90", ierr)
      end if
      system%num_ion_types = num_ion_types

      system%num_ions = 0
      system%total_ions_charge = 0.0_wp
      do itype = 1, num_ion_types
         if (species(itype)%charge_type == CHARGE_TYPE_GAUSSIAN) then
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                  "Ion type cannot have a gaussian charge distribution")
         end if
         call MW_ion_define_type(system%ions(itype), &
               species(itype)%name, &
               species(itype)%count, &
               species(itype)%charge, &
               species(itype)%polarizability, &
               species(itype)%selfdaimD, &
               species(itype)%selfdaimbeta, &
               species(itype)%selfdaimzeta, &
               species(itype)%mass, &
               species(itype)%is_mobile, &
               species(itype)%is_fourth_site, &
               species(itype)%dump_efg, &
               species(itype)%dump_lammps, &
               species(itype)%dump_xyz, &
               species(itype)%dump_trajectories, &
               species(itype)%dump_pdb)
         system%ions(itype)%offset = system%num_ions
         system%num_ions = system%num_ions + species(itype)%count
         system%total_ions_charge = system%total_ions_charge + species(itype)%count * species(itype)%charge
         system%efgrun = ((system%efgrun) .or. species(itype)%dump_efg) ! .true. if at least one species needs efg
      end do

      ! check whether we use the polarizable ion model
      call MW_system_check_polarizability(system)
      ! check whether we use the aspherical ion model
      call MW_system_check_deformability(system)

      if (abs(system%total_ions_charge).gt.1.0e-12_wp) then
         write(errmsg,'("The electrolyte is not neutral, has charge ",f5.3)') system%total_ions_charge
         call MW_errors_runtime_warning("read_box_parameters", "configuration.f90", errmsg)
      end if

      ! Define electrodes
      ! -----------------
      if (allocated(system%electrodes)) then
         do itype = 1, size(system%electrodes,1)
            call MW_electrode_void_type(system%electrodes(itype))
         end do
         deallocate(system%electrodes, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_system_parameters", "configuration.f90", ierr)
         end if
      end if
      allocate(system%electrodes(num_elec), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_system_parameters", "configuration.f90", ierr)
      end if

      if (allocated(system%thomas_fermi)) then
         do itype = 1, size(system%thomas_fermi,1)
            call MW_thomas_fermi_void_type(system%thomas_fermi(itype))
         end do
         deallocate(system%thomas_fermi, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_system_parameters", "configuration.f90", ierr)
         end if
      end if
      allocate(system%thomas_fermi(num_elec), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_system_parameters", "configuration.f90", ierr)
      end if

      system%num_elec = num_elec

      system%num_atoms = 0
      do itype = 1, num_elec
         call MW_electrode_parameters_set_index(electrodes(itype), itype)
         call MW_electrode_parameters_set_species_index(electrodes(itype), species)
         species_index = electrodes(itype)%species_index
         if (species_index /= (num_ion_types+itype)) then
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                  "Electrode type species must be specified after electrolyte type species " // &
                  "and in the same order as electrode types")
         end if
         if (species(species_index)%charge_type /= CHARGE_TYPE_GAUSSIAN) then
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                  "Electrode type species must have a gaussian charge distribution")
         end if
         if (species(species_index)%is_mobile) then
            call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                  "Electrode type species must not be mobile.")
         end if

         call MW_electrode_define_type(system%electrodes(itype), &
               species(species_index)%name, &
               species(species_index)%count, &
               species(species_index)%eta, &
               species(species_index)%charge, &
               electrodes(itype)%potential, &
               electrodes(itype)%piston, &
               electrodes(itype)%pressure, &
               species(species_index)%count*species(species_index)%mass, &
               electrodes(itype)%thomas_fermi_length, &
               electrodes(itype)%voronoi_volume, &
               species(species_index)%dump_lammps, &
               species(species_index)%dump_xyz, &
               species(species_index)%dump_trajectories, &
               species(species_index)%dump_pdb)
         if (electrodes(itype)%piston) then
            system%pistonrun = .true.
         end if

         call MW_thomas_fermi_define_type(system%thomas_fermi(itype), &
               electrodes(itype)%thomas_fermi_length, &
               electrodes(itype)%voronoi_volume)
         if (electrodes(itype)%thomas_fermi_length > 1.0e-12_wp) then
            system%tfrun = .true.
         end if

         system%electrodes(itype)%offset = system%num_atoms
         system%num_atoms = system%num_atoms + species(species_index)%count
      end do

      !check whether electrodes minimization is needed
      call MW_system_check_electrodes(algorithms%constant_charge, system)
      !Check if charge neutrality is to be enforced
      !Done directly in read_electrodes_parameters or read_dipoles_electrodes_parameters
      !call check_charge_neutrality(system, algorithms)

      if (abs(system%total_ions_charge).gt.1.0e-12_wp &
            .and. system%electrode_charge_neutrality &
            .and. (.not. system%global_charge_neutrality)) then
         write(errmsg,'("The global system is not neutral (only the electrodes are)")')
         call MW_errors_runtime_warning("read_box_parameters", "configuration.f90", errmsg)
      end if

      ! Set algorithms for charge calculation
      if (system%pimrun.and.system%elecrun) then
         if (algorithms%maze%calc_dip.and.algorithms%maze%calc_elec) then
            system%mazerun = .true.
            call MW_maze_set_dimensionality(algorithms%maze, 3*system%num_ions+system%num_atoms)
            call MW_maze_allocate_arrays(algorithms%maze)
         else if (algorithms%matrix_inversion%calc_dip.and.algorithms%matrix_inversion%calc_elec) then
            call MW_matrix_inversion_allocate_arrays(algorithms%matrix_inversion, 3*system%num_ions+system%num_atoms)
         else
            if (algorithms%constant_charge) then
               call MW_cg_allocate_arrays(algorithms%cg, 3*system%num_ions)
            else
               call MW_cg_allocate_arrays(algorithms%cg, 3*system%num_ions+system%num_atoms)
            end if
         end if
      else if (system%pimrun) then
         if (algorithms%maze%calc_dip) then
            system%mazerun = .true.
            call MW_maze_set_dimensionality(algorithms%maze, 3*system%num_ions)
            call MW_maze_allocate_arrays(algorithms%maze)
         else if (algorithms%matrix_inversion%calc_dip) then
            call MW_matrix_inversion_allocate_arrays(algorithms%matrix_inversion, 3*system%num_ions)
         else
            call MW_cg_allocate_arrays(algorithms%cg, 3*system%num_ions)
         end if
      else if (system%elecrun) then
         if (algorithms%maze%calc_elec) then
            system%mazerun = .true.
            call MW_maze_set_dimensionality(algorithms%maze, system%num_atoms)
            call MW_maze_allocate_arrays(algorithms%maze)
         else if (algorithms%matrix_inversion%calc_elec) then
            call MW_matrix_inversion_allocate_arrays(algorithms%matrix_inversion, system%num_atoms)
         else
            call MW_cg_allocate_arrays(algorithms%cg, system%num_atoms)
         end if
      end if

      call MW_ewald_set_num_pbc(system%ewald, system%num_pbc)

      ! Define molecules
      system%num_molecules = 0
      do i = 1, system%num_molecule_types
         call MW_molecule_set_index(system%molecules(i), i)
         call MW_molecule_set_sites_index(system%molecules(i), species)
         system%num_molecules = system%num_molecules + system%molecules(i)%n
      end do

      if (.not. allocated(system%molecules)) then
         allocate(system%molecules(0), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("read_system_parameters", "configuration.f90", ierr)
         end if
         system%num_molecules = 0
         system%num_molecule_types = 0
      end if

      allocate(system%species_names(num_species))
      do species_index = 1, num_species
         system%species_names(species_index) = species(species_index)%name
      end do

      ! Raise errors for uncompatibilities
      ! Constant charge and charge neutrality cannot be enforced together
      if (algorithms%constant_charge .and. &
          (system%electrode_charge_neutrality.or.system%global_charge_neutrality)) then
          call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                "Charge neutrality is not compatible with constant charges on electrodes")
      end if

      ! MaZe and charge neutrality only works with maze inversion
      if (system%electrode_charge_neutrality .and. &
          algorithms%maze%calc_elec          .and. &
          .not.algorithms%maze%invert) then
          call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
                "Charge neutrality with MaZe algorithm is only compatible with `maze inversion`")
      end if

      ! External fields need charge neutrality
      if ((system%field%field_type.eq.FIELD_TYPE_ELECTRIC      .or.  &
           system%field%field_type.eq.FIELD_TYPE_DISPLACEMENT) .and. &
           .not.system%electrode_charge_neutrality) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use external fields without charge neutrality")
      end if

      ! External fields needs 3D periodic boundary conditions
      if ((system%field%field_type.eq.FIELD_TYPE_ELECTRIC      .or.  &
           system%field%field_type.eq.FIELD_TYPE_DISPLACEMENT) .and. &
           system%num_pbc.ne.3) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use external fields without 3D PBC")
      end if

      ! Dipoles needs 3D periodic boundary conditions
      ! if (system%pimrun .and. system%num_pbc.ne.3) then
      !    call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
      !          "cannot use dipoles without 3D PBC")
      ! end if

      ! Computing forces on electrodes does not support PIM and AIM force fields
      if (system%electrode_compute_force .and. system%pimrun) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use compute_force with pim")
      end if
      if (system%electrode_compute_force .and. system%aimrun) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use compute_force with aim")
      end if

      ! Electrodes should not move with piston if the charges are computed through maze or matrix inversion methods, or for 3D periodic systems
      if (system%pistonrun .and. algorithms%maze%calc_elec) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use piston with maze")
      end if
      if (system%pistonrun .and. algorithms%matrix_inversion%calc_elec) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use piston with matrix_inversion")
      end if
      if (system%pistonrun .and. system%num_pbc > 2) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use piston without 2DPBC")
      end if

      ! External fields are not compatible with Thomas-Fermi
      if ((system%field%field_type.eq.FIELD_TYPE_ELECTRIC      .or.  &
           system%field%field_type.eq.FIELD_TYPE_DISPLACEMENT) .and. &
           system%tfrun) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use external fields with Thomas-Fermi length > 0.0")
      end if

      ! NPT is not compatible with external fields
      if ((system%field%field_type.eq.FIELD_TYPE_ELECTRIC      .or.  &
           system%field%field_type.eq.FIELD_TYPE_DISPLACEMENT) .and. &
           (barostat_defined > 0)) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use NPT with external field")
      end if

      ! NPT is not compatible with electrodes and/or fixed atoms
      if ((electrodes_defined > 0)  .and. &
           (barostat_defined > 0)) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use NPT with electrodes")
      end if

      ! NPT is not compatible with 2D PBCs
      if ((system%num_pbc.ne.3) .and. &
           (barostat_defined > 0)) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use NPT with 2D PBCs")
      end if

      ! Do not compute the efg if its dump frequency is zero
      if (system%output%efg_dump_frequency.eq.0) then
         system%efgrun = .false.
      end if

      ! The efg computation is not compatible with electrodes
      if ((electrodes_defined > 0) .and. (system%efgrun)) then
         call MW_errors_runtime_error("read_system_parameters", "configuration.f90", &
               "cannot use EFG computation with 2D PBCs")
      end if

   end subroutine read_system_parameters

   ! ================================================================================
   ! Read box parameters
   !
   ! box
   !   length a b c
   subroutine read_box_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_box, only: MW_box_define_type => define_type, &
            MW_box_void_type => void_type
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< line number in configuration file

      ! Local
      ! -----
      real(wp) :: a, b, c
      character(256) :: errmsg
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      integer :: length_defined

      ! Void data structure
      call MW_box_void_type(system%box)

      ! Set default values
      a = 0.0_wp
      b = 0.0_wp
      c = 0.0_wp

      ! Flag each section as undefined (line number will be stored)
      length_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("length")
            if (length_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |length|. First definition at line ",i4,".")') &
                     line_num, length_defined
               call MW_errors_runtime_error("read_box_parameters", "configuration.f90", errmsg)
            end if
            length_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 4) then
               write(errmsg,'("Invalid format for box length parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_box_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, a)
            call MW_configuration_line_get_word(config_line, 3, b)
            call MW_configuration_line_get_word(config_line, 4, c)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      ! Define box
      call MW_box_define_type(system%box, a, b, c)

   end subroutine read_box_parameters

   ! ================================================================================
   ! Read thermostat parameters
   !
   ! thermostat *block*
   !   relaxation_time *real*
   !   max_iteration *int*
   !   tolerance *real*
   !   chain_length *int*
   subroutine read_thermostat_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp
      use MW_thermostat, only: MW_thermostat_t, &
            MW_thermostat_void_type => void_type, &
            MW_thermostat_define_type => define_type
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< line number in configuration file

      ! Local
      ! -----
      real(wp) :: relaxation_time, tolerance
      integer :: max_iteration, chain_length
      character(256) :: errmsg
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      integer :: relaxation_time_defined, tolerance_defined, &
            max_iteration_defined, chain_length_defined

      ! Void data structure
      call MW_thermostat_void_type(system%thermostat)

      ! Set default values
      relaxation_time = 4134.1_wp
      tolerance = 1.0e-15_wp
      max_iteration = 50
      chain_length = 5

      ! Flag each section as undefined (line number will be stored)
      relaxation_time_defined = 0
      tolerance_defined = 0
      max_iteration_defined = 0
      chain_length_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("relaxation_time")
            if (relaxation_time_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |relaxation_time|. First definition at line ",i4,".")') &
                     line_num, relaxation_time_defined
               call MW_errors_runtime_error("read_thermostat_parameters", "configuration.f90", errmsg)
            end if
            relaxation_time_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for relaxation_time parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_thermostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, relaxation_time)

         case("max_iteration")
            if (max_iteration_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |max_iteration|. First definition at line ",i4,".")') &
                     line_num, max_iteration_defined
               call MW_errors_runtime_error("read_thermostat_parameters", "configuration.f90", errmsg)
            end if
            max_iteration_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for max_iteration parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_thermostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, max_iteration)

         case("tolerance")
            if (tolerance_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |tolerance|. First definition at line ",i4,".")') &
                     line_num, tolerance_defined
               call MW_errors_runtime_error("read_thermostat_parameters", "configuration.f90", errmsg)
            end if
            tolerance_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for tolerance parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_thermostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, tolerance)

         case("chain_length")
            if (chain_length_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |chain_length|. First definition at line ",i4,".")') &
                     line_num, chain_length_defined
               call MW_errors_runtime_error("read_thermostat_parameters", "configuration.f90", errmsg)
            end if
            chain_length_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for chain_length parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_thermostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, chain_length)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      ! Define box
      call MW_thermostat_define_type(system%thermostat, system%temperature, relaxation_time, &
            max_iteration, tolerance, chain_length)

   end subroutine read_thermostat_parameters

   ! ================================================================================
   ! Read barostat parameters
   !
   ! barostat *block*
   !   pressure *real*
   !   relaxation_time *real*
   !   chain_length *int*
   subroutine read_barostat_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp
      use MW_thermostat, only: MW_thermostat_t, &
            MW_thermostat_void_type => void_type
      use MW_barostat, only: MW_barostat_t, &
            MW_barostat_void_type => void_type, &
            MW_barostat_define_type => define_type
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< line number in configuration file

      ! Local
      ! -----
      real(wp) :: relaxation_time
      real(wp) :: pressure
      integer :: chain_length
      character(256) :: errmsg
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      integer :: pressure_defined, relaxation_time_defined, chain_length_defined

      ! Void data structure
      call MW_barostat_void_type(system%barostat)

      ! Set default values
      pressure = 0.0_wp
      relaxation_time = 20670.5_wp
      chain_length = 5

      ! Flag each section as undefined (line number will be stored)
      pressure_defined = 0
      relaxation_time_defined = 0
      chain_length_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("pressure")
            if (pressure_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |pressure|. First definition at line ",i4,".")') &
                     line_num, pressure_defined
               call MW_errors_runtime_error("read_barostat_parameters", "configuration.f90", errmsg)
            end if
            pressure_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for pressure parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_barostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, pressure)

         case("relaxation_time")
            if (relaxation_time_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |relaxation_time|. First definition at line ",i4,".")') &
                     line_num, relaxation_time_defined
               call MW_errors_runtime_error("read_barostat_parameters", "configuration.f90", errmsg)
            end if
            relaxation_time_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for relaxation_time parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_barostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, relaxation_time)

         case("chain_length")
            if (chain_length_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |chain_length|. First definition at line ",i4,".")') &
                     line_num, chain_length_defined
               call MW_errors_runtime_error("read_barostat_parameters", "configuration.f90", errmsg)
            end if
            chain_length_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for chain_length parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_barostat_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, chain_length)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      ! Define box
      call MW_barostat_define_type(system%barostat, system%thermostat,  &
             pressure, relaxation_time, chain_length)

      ! Void thermostat data structure
      call MW_thermostat_void_type(system%thermostat)

   end subroutine read_barostat_parameters

   ! ================================================================================
   ! Read rescale parameters
   !
   ! velocity *block*
   !   create        *True/false*
   !   com_threshold *threshold*
   !   scale         *method* *period*
   subroutine read_velocity_parameters(system, funit, line_num)
      use MW_velocity, only: RESCALE_METHOD_GLOBAL, RESCALE_METHOD_SPECIES, &
            RESCALE_METHOD_MOLECULES_GLOBAL, RESCALE_METHOD_MOLECULES_INDEPENDENT
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< line number in configuration file

      ! Local
      ! -----
      character(256) :: errmsg
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      integer :: scale_defined, com_reset_defined, create_defined
      integer :: scale_period
      character(max_word_length) :: scale_method
      logical :: create
      real(wp) :: com_threshold

      ! Set default values
      scale_period = 100
      scale_method = "global"
      create = .false.
      com_threshold = 1.0e+6 ! very large so com is not reset

      ! Flag each section as undefined (line number will be stored)
      scale_defined = 0
      com_reset_defined = 0
      create_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("create")
            if (create_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |create|. First definition at line ",i4,".")') &
                     line_num, create_defined
               call MW_errors_runtime_error("read_velocity_parameters", "configuration.f90", errmsg)
            end if
            create_defined = line_num

            ! Read parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for create parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_velocity_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, create)

         case("com_threshold")
            if (com_reset_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |com_reset|. First definition at line ",i4,".")') &
                     line_num, com_reset_defined
               call MW_errors_runtime_error("read_velocity_parameters", "configuration.f90", errmsg)
            end if
            com_reset_defined = line_num

            ! Read parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for com_reset parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_velocity_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, com_threshold)

         case("scale")
            if (scale_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |scale|. First definition at line ",i4,".")') &
                     line_num, scale_defined
               call MW_errors_runtime_error("read_velocity_parameters", "configuration.f90", errmsg)
            end if
            scale_defined = line_num

            ! Read parameters
            if (config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for scale parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_velocity_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, scale_method)
            call MW_configuration_line_get_word(config_line, 3, scale_period)

         case default
            ! Keyword not expected in velocity section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      if (scale_defined > 0) then
         select case(scale_method)
         case("global")
            system%velocity_scale_method = RESCALE_METHOD_GLOBAL
         case("species")
            system%velocity_scale_method = RESCALE_METHOD_SPECIES
         case("molecules_global")
            system%velocity_scale_method = RESCALE_METHOD_MOLECULES_GLOBAL
         case("molecules_independent")
            system%velocity_scale_method = RESCALE_METHOD_MOLECULES_INDEPENDENT
         case default
            write(errmsg,'("Invalid rescale method at line ",i4,": ",a32)') scale_defined, scale_method
            call MW_errors_runtime_error("read_velocity_parameters","configuration.f90", &
                  errmsg)
         end select
         system%velocity_scale = .true.
         system%velocity_scale_period = scale_period
         system%velocity_scale_temperature = system%temperature
      else
         system%velocity_scale = .false.
         system%velocity_scale_method = RESCALE_METHOD_GLOBAL
         system%velocity_scale_period = 0
         system%velocity_scale_temperature = system%temperature
      end if

      system%velocity_com_threshold = com_threshold
      system%velocity_create = create

   end subroutine read_velocity_parameters

   ! ================================================================================
   !> Read species block definition
   !!
   !! species *block list*
   !!   species_type *block*
   !!     name *string*
   !!     count *int*
   !!     mass  *real*
   !!     + charge neutral
   !!     + charge point q (*real*)
   !!     + charge gaussian eta (*real*) [q] (*real*)
   !!     polarizability  *real*
   !!     deformability D(*real*) beta(*real*) zeta(*real*)
   !!     mobile *bool*
   !!     fourth_site_atom
   !!     needs_efg *bool*
   !!
   subroutine read_species_parameters(species, algorithms, charged_species, four_site_model, funit, line_num, &
         dipoles_minimization_defined)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_cg, only: &
            MW_cg_set_max_iterations => set_max_iterations, &
            MW_cg_set_tolerance => set_tolerance, &
            MW_cg_set_charge_neutrality => set_charge_neutrality, &
            MW_cg_set_preconditioner => set_preconditioner, &
            MW_cg_reset_statistics => reset_statistics
      use MW_cgaim, only: &
            MW_cgaim_set_max_iterations => set_max_iterations, &
            MW_cgaim_set_tolerance => set_tolerance, &
            MW_cgaim_reset_statistics => reset_statistics
      use MW_maze, only: &
            MW_maze_set_max_iterations => set_max_iterations, &
            MW_maze_set_tolerance => set_tolerance, &
            MW_maze_select_algorithm => select_algorithm, &
            MW_maze_set_charge_neutrality => set_charge_neutrality, &
            MW_maze_set_write_matrix => set_write_matrix, &
            MW_maze_set_sor_param => set_sor_param, &
            MW_maze_reset_statistics => reset_statistics
      use MW_matrix_inversion, only: &
            MW_matrix_inversion_set_tolerance => set_tolerance, &
            MW_matrix_inversion_set_charge_neutrality => set_charge_neutrality, &
            MW_matrix_inversion_set_write_matrix => set_write_matrix, &
            MW_matrix_inversion_reset_statistics => reset_statistics
      use MW_errors, only: MW_errors_runtime_error => runtime_error, &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate => deallocate_error
      use MW_species, only: MW_species_t, &
            MW_species_read_parameters => read_parameters, &
            MW_species_void_type => void_type
      use MW_algorithms, only: MW_algorithms_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_algorithms_t), intent(inout) :: algorithms
      type(MW_species_t), allocatable, intent(inout) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number
      logical, intent(inout) :: charged_species
      logical, intent(inout) :: four_site_model
      integer, intent(inout) :: dipoles_minimization_defined

      ! Local
      ! -----
      type(MW_configuration_line_t) :: config_line
      character(max_word_length) :: keyword
      integer :: ierr
      character(256) :: errmsg
      integer :: line_start
      integer :: line_last
      integer :: num_species_types, itype
      integer :: max_iteration, max_iterationaim, n_blocks
      real(wp) :: tolerance, toleranceaim, sor_param
      integer :: write_matrix_defined
      type(MW_species_t) :: dummy
      character(max_word_length) :: algorithm, algorithmaim, maze_algorithm, maze_cg_store, maze_cg_prec, cg_preconditioner
      logical :: charge_neutrality, write_matrix, cg_preconditioned

      ! keep line number to be able to come back at beginning of section
      line_start = line_num

      num_species_types = 0
      dipoles_minimization_defined = 0
      write_matrix_defined = 0

      ! Set default values
      algorithm = "cg"
      cg_preconditioned = .false.
      cg_preconditioner = "jacobi"
      algorithms%maze%calc_dip = .false.
      tolerance = 1.0e-12_wp
      max_iteration = 100
      n_blocks = 0
      sor_param = 1.0_wp
      maze_cg_store = "nostore"
      maze_cg_prec = "nopreconditioned"
      charge_neutrality = .false.
      write_matrix = .false.

      algorithmaim = "cg"
      toleranceaim = 1.0e-8_wp
      max_iterationaim = 100

      charged_species = .false.
      four_site_model = .false.

      ! Read once to get num_species_types
      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("species_type")
            call MW_species_read_parameters(dummy, funit, line_num)
            num_species_types = num_species_types + 1

         case("dipoles_minimization")
            if (dipoles_minimization_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dipoles_minimization|. First definition at line ",i4,".")') &
                     line_num, dipoles_minimization_defined
               call MW_errors_runtime_error("read_species_parameters", "configuration.f90", errmsg)
            end if
            dipoles_minimization_defined = line_num

            if ((config_line%num_words < 2) .or. (config_line%num_words > 5)) then
               write(errmsg,'("Invalid format for algorithm parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, algorithm)
            select  case(algorithm)
               case("matrix_inversion")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, tolerance)
                  end if
               case("cg")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, tolerance)
                  end if
                  if (config_line%num_words >= 4) then
                     call MW_configuration_line_get_word(config_line, 4, max_iteration)
                  end if

               case("maze")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, maze_algorithm)
                  else
                     write(errmsg,'("Invalid format for maze algorithm at line ",i4)') line_num
                     call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                           errmsg)
                  end if
                  select case (maze_algorithm)
                     case("inversion")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                     case("iterative_shake")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                        if (config_line%num_words >= 5) then
                           call MW_configuration_line_get_word(config_line, 5, max_iteration)
                        end if
                        if (config_line%num_words >= 6) then
                           call MW_configuration_line_get_word(config_line, 6, n_blocks)
                        end if
                        if (config_line%num_words >= 7) then
                           call MW_configuration_line_get_word(config_line, 7, sor_param)
                        end if
                     case("iterative_cg")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                        if (config_line%num_words >= 5) then
                           call MW_configuration_line_get_word(config_line, 5, max_iteration)
                        end if
                        if (config_line%num_words >= 6) then
                           call MW_configuration_line_get_word(config_line, 6, maze_cg_store)
                        end if
                        if (config_line%num_words >= 7) then
                           call MW_configuration_line_get_word(config_line, 7, maze_cg_prec)
                        end if
                     case default
                        write(errmsg,'("Invalid keyword for maze algorithm at line ",i4)') line_num
                        call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                              errmsg)
                  end select
               case default
                  write(errmsg,'("Invalid keyword for dipoles_minimization algorithm at line ",i4)') line_num
                  call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                        errmsg)
            end select

         case("preconditioner")
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for |preconditioner| parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                     errmsg)
            end if
            cg_preconditioned = .true.

            if (algorithm /= "cg") then
               write(errmsg,'("Invalid |preconditioner| keyword for chosen algorithm at line ",i4)') line_num
               call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, cg_preconditioner)

         case("radius_minimization")

            if ((config_line%num_words < 2) .or. (config_line%num_words > 4)) then
               write(errmsg,'("Invalid format for algorithm parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, algorithmaim)
            if (config_line%num_words >= 3) then
               call MW_configuration_line_get_word(config_line, 3, toleranceaim)
            end if
            if (config_line%num_words >= 4) then
               call MW_configuration_line_get_word(config_line, 4, max_iterationaim)
            end if

         case("write_matrix")

            if (write_matrix_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |write_matrix|. First definition at line ",i4,".")') &
                     line_num, write_matrix_defined
               call MW_errors_runtime_error("read_species_parameters", "configuration.f90", errmsg)
            end if
            write_matrix_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for write_matrix parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, write_matrix)

         case default
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop
      line_last = line_num

      if (allocated(species)) then
         do itype = 1, size(species,1)
            call MW_species_void_type(species(itype))
         end do
         deallocate(species, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_species_parameters", "configuration.f90", ierr)
         end if
      end if
      allocate(species(num_species_types), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_species_parameters", "configuration.f90", ierr)
      end if

      do while (line_num > line_start)
         backspace(funit, iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_runtime_error("read_species_parameters", "configuration.f90", &
                  "An error while backspace back to beginning of |species| section.")
         end if
         line_num = line_num-1
      end do

      ! Read a second time to store the values to get num_ion_types
      do itype = 1, num_species_types
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
         call MW_configuration_line_get_word(config_line, 1, keyword)
         if (keyword /= "species_type") then
            write(errmsg,'("Expected |species_type| keyword in species parameters at line ",i4)') line_num
            call MW_errors_runtime_error("read_species_parameters","configuration.f90", &
                  errmsg)
         end if
         call MW_species_read_parameters(species(itype), funit, line_num)
         if (species(itype)%charge > 0.0_wp) then
            charged_species = .true.
         end if
         if (species(itype)%is_fourth_site) then
            four_site_model = .true.
         end if
      end do
      ! move back to the end of the species block
      do while (line_num < line_last)
         read(funit,*)
         line_num = line_num + 1
      end do

      ! Define algorithm parameters
      select case (algorithm)
      case("cg")
         call MW_cg_set_max_iterations(algorithms%cg, max_iteration)
         call MW_cg_set_tolerance(algorithms%cg, tolerance)
         call MW_cg_set_charge_neutrality(algorithms%cg, charge_neutrality)
         call MW_cg_set_preconditioner(algorithms%cg, cg_preconditioned, cg_preconditioner)
         call MW_cg_reset_statistics(algorithms%cg)
      case("maze")
         algorithms%maze%calc_dip = .true.
         call MW_maze_set_max_iterations(algorithms%maze, max_iteration)
         call MW_maze_set_tolerance(algorithms%maze, tolerance)
         call MW_maze_select_algorithm(algorithms%maze, maze_algorithm, maze_cg_store, maze_cg_prec, n_blocks)
         call MW_maze_set_charge_neutrality(algorithms%maze, charge_neutrality, 1.0_wp)
         call MW_maze_set_write_matrix(algorithms%maze, write_matrix)
         call MW_maze_set_sor_param(algorithms%maze, sor_param)
         call MW_maze_reset_statistics(algorithms%maze)
      case("matrix_inversion")
         algorithms%matrix_inversion%calc_dip = .true.
         call MW_matrix_inversion_set_tolerance(algorithms%matrix_inversion, tolerance)
         call MW_matrix_inversion_set_charge_neutrality(algorithms%matrix_inversion, charge_neutrality)
         call MW_matrix_inversion_set_write_matrix(algorithms%matrix_inversion, write_matrix)
         call MW_matrix_inversion_reset_statistics(algorithms%matrix_inversion)
      case default
         write(errmsg,'("Unknown dipole minimization algorithm ",a)') &
               algorithm
         call MW_errors_runtime_error("read_dipoles_parameters","configuration.f90", &
               errmsg)
      end select
      select case (algorithmaim)
      case("cg")
         call MW_cgaim_set_max_iterations(algorithms%cgaim, max_iterationaim)
         call MW_cgaim_set_tolerance(algorithms%cgaim, toleranceaim)
         call MW_cgaim_reset_statistics(algorithms%cgaim)
      case default
         write(errmsg,'("Unknown radius minimization algorithm ",a)') &
               algorithmaim
         call MW_errors_runtime_error("read_radius_parameters","configuration.f90", &
               errmsg)
      end select

   end subroutine read_species_parameters

   ! ================================================================================
   ! Read molecules block parameters
   !
   ! molecules
   !   molecule_type *block*
   !     name *string*
   !     count *int*
   !     sites *string* [*string* ...]
   !     [constraints *block*
   !        constraint *string* *string* *real*
   !        [constraint *string* *string* *real*
   !         ...]
   !     [constraints_algorithm *string* *parameters depend on algorithm name*]
   !
   subroutine read_molecules_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_molecule, only: MW_molecule_t, &
            MW_molecule_define_type => define_type, &
            MW_molecule_void_type => void_type, &
            MW_molecule_read_parameters => read_parameters
      use MW_errors, only: MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      integer :: ierr
      character(256) :: errmsg
      type(MW_configuration_line_t) :: config_line
      character(max_word_length) :: keyword
      type(MW_molecule_t) :: dummy
      integer :: num_molecule_types
      integer :: imol, itype
      integer :: line_start
      integer :: harmonic_bonds_defined, harmonic_angles_defined, dihedrals_defined

      harmonic_bonds_defined = 0
      harmonic_angles_defined = 0
      dihedrals_defined = 0

      ! Void current values
      if (allocated(system%molecules)) then
         do imol = 1, size(system%molecules,1)
            call MW_molecule_void_type(system%molecules(imol))
         end do
         deallocate(system%molecules, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_molecules_parameters", "configuration.f90", ierr)
         end if
      end if
      num_molecule_types = 0
      line_start = line_num

      ! Read once to get num_molecule_types
      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)
         select case(keyword)

         case("molecule_type")
            call MW_molecule_read_parameters(dummy, funit, line_num)
            num_molecule_types = num_molecule_types + 1
            call MW_molecule_void_type(dummy)
         case default
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      system%num_molecule_types = num_molecule_types
      allocate(system%molecules(num_molecule_types), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_molecules_parameters", "configuration.f90", ierr)
      end if

      do while (line_num > line_start)
         backspace(funit, iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_runtime_error("read_molecules_parameters", "configuration.f90", &
                  "An error while backspace back to beginning of |molecules| section.")
         end if
         line_num = line_num-1
      end do

      ! Read a second time to store the values
      do itype = 1, num_molecule_types
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
         call MW_configuration_line_get_word(config_line, 1, keyword)

         if (keyword /= "molecule_type") then
            write(errmsg,'("Expected |molecule_type| keyword in molecules parameters at line ",i4)') line_num
            call MW_errors_runtime_error("read_molecules_parameters","configuration.f90", &
                  errmsg)
         end if
         call MW_molecule_read_parameters(system%molecules(itype), funit, line_num)
      end do

   end subroutine read_molecules_parameters


   ! ================================================================================
   !> Read electrode parameters
   !! electrodes *block list*
   !!   electrode_type *block*
   !!     name *string*
   !!     species *string*
   !!     potential *real*
   !!     piston *real* *int*
   !!
   !!   electrode_charges *string* *real* *int*
   !!   charge_neutrality *true/false* *global/electrodes* *real*
   !!   compute_force *true/false*
   !!
   subroutine read_electrodes_parameters(electrodes, algorithms, funit, line_num, compute_force, &
         charge_neutrality, global_neutrality, charges_defined, charge_neutrality_defined)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_electrode_parameters, only: MW_electrode_parameters_t, &
            MW_electrode_parameters_void_type => void_type, &
            MW_electrode_parameters_read_parameters => read_parameters
      use MW_cg, only: &
            MW_cg_set_max_iterations => set_max_iterations, &
            MW_cg_set_tolerance => set_tolerance, &
            MW_cg_set_charge_neutrality => set_charge_neutrality, &
            MW_cg_set_preconditioner => set_preconditioner, &
            MW_cg_reset_statistics => reset_statistics
      use MW_maze, only: &
            MW_maze_set_max_iterations => set_max_iterations, &
            MW_maze_set_tolerance => set_tolerance, &
            MW_maze_select_algorithm => select_algorithm, &
            MW_maze_set_charge_neutrality => set_charge_neutrality, &
            MW_maze_set_write_matrix => set_write_matrix, &
            MW_maze_set_sor_param => set_sor_param, &
            MW_maze_reset_statistics => reset_statistics
      use MW_matrix_inversion, only: &
            MW_matrix_inversion_set_tolerance => set_tolerance, &
            MW_matrix_inversion_set_charge_neutrality => set_charge_neutrality, &
            MW_matrix_inversion_set_write_matrix => set_write_matrix, &
            MW_matrix_inversion_reset_statistics => reset_statistics
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_runtime_error => runtime_error
      use MW_algorithms, only: MW_algorithms_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_parameters_t), allocatable, intent(inout) :: electrodes(:)
      type(MW_algorithms_t), intent(inout) :: algorithms
      integer,           intent(in)    :: funit !< configuration file unit
      integer,           intent(inout) :: line_num !< configuration file line number
      logical,           intent(inout) :: compute_force
      logical,           intent(out)   :: global_neutrality
      logical,           intent(out)   :: charge_neutrality
      integer,           intent(out)   :: charges_defined
      integer,           intent(out)   :: charge_neutrality_defined

      ! Locals
      ! ------
      character(256) :: errmsg
      character(max_word_length) :: keyword, global_or_electrodes
      type(MW_configuration_line_t) :: config_line
      integer :: ierr
      integer :: line_last
      integer :: num_elec, ielec
      character(max_word_length) :: algorithm, cg_preconditioner, maze_algorithm, maze_cg_store, maze_cg_prec
      integer :: max_iteration, n_blocks
      real(wp) :: tolerance, sor_param
      integer :: types_defined, preconditioner_defined
      integer :: compute_force_defined, write_matrix_defined
      type(MW_electrode_parameters_t) :: dummy
      logical :: write_matrix, cg_preconditioned, dummy_log
      real(wp) :: uscale
      ierr = 0

      ! Void current values
      if (allocated(electrodes)) then
         do ielec = 1, size(electrodes,1)
            call MW_electrode_parameters_void_type(electrodes(ielec))
         end do
         deallocate(electrodes, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("read_electrodes_parameters", "configuration.f90", ierr)
         end if
      end if
      num_elec = 0

      ! Flag each section as undefined (line number will be stored)
      types_defined = 0
      charges_defined = 0
      preconditioner_defined = 0
      charge_neutrality_defined = 0
      write_matrix_defined = 0
      compute_force_defined = 0

      ! Set default values
      algorithm = "cg"
      cg_preconditioned = .false.
      cg_preconditioner = "jacobi"
      algorithms%maze%calc_elec = .false.
      tolerance = 1.0e-12_wp
      max_iteration = 100
      n_blocks = 0
      sor_param = 1.0_wp
      maze_cg_store = "nostore"
      maze_cg_prec = "nopreconditioned"
      charge_neutrality = .true.
      global_neutrality = .false.
      global_or_electrodes = "global"
      uscale = 1.0_wp
      write_matrix = .false.
      compute_force = .false.

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case (keyword)

         case("electrode_type")
            if (types_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |electrode_type|. First definition at line ",i4,".")') &
                     line_num, types_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            types_defined = line_num

            call MW_electrode_parameters_read_parameters(dummy, funit, line_num, dummy_log)
            num_elec = num_elec + 1

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            keyword = ""
            if (config_line%num_words > 0) call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "electrode_type")
               call MW_electrode_parameters_read_parameters(dummy, funit, line_num, dummy_log)
               num_elec = num_elec + 1

               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               keyword = ""
               if (config_line%num_words > 0) call MW_configuration_line_get_word(config_line, 1, keyword)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do

            ! Backspace 1 record
            backspace(funit)
            line_num = line_num - 1

         case("electrode_charges")
            if (charges_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |electrode_charges|. First definition at line ",i4,".")') &
                     line_num, charges_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            charges_defined = line_num

            if ((config_line%num_words < 2) .or. (config_line%num_words > 7)) then
               write(errmsg,'("Invalid format for algorithm parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, algorithm)
            select  case(algorithm)
               case("constant_charge")
               case("matrix_inversion")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, tolerance)
                  end if
               case("cg")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, tolerance)
                  end if
                  if (config_line%num_words >= 4) then
                     call MW_configuration_line_get_word(config_line, 4, max_iteration)
                  end if

               case("maze")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, maze_algorithm)
                  else
                     write(errmsg,'("Invalid format for maze algorithm at line ",i4)') line_num
                     call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                           errmsg)
                  end if
                  select case (maze_algorithm)
                     case("inversion")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                     case("iterative_shake")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                        if (config_line%num_words >= 5) then
                           call MW_configuration_line_get_word(config_line, 5, max_iteration)
                        end if
                        if (config_line%num_words >= 6) then
                           call MW_configuration_line_get_word(config_line, 6, n_blocks)
                        end if
                        if (config_line%num_words >= 7) then
                           call MW_configuration_line_get_word(config_line, 7, sor_param)
                        end if
                     case("iterative_cg")
                        if (config_line%num_words >= 4) then
                           call MW_configuration_line_get_word(config_line, 4, tolerance)
                        end if
                        if (config_line%num_words >= 5) then
                           call MW_configuration_line_get_word(config_line, 5, max_iteration)
                        end if
                        if (config_line%num_words >= 6) then
                           call MW_configuration_line_get_word(config_line, 6, maze_cg_store)
                        end if
                        if (config_line%num_words >= 7) then
                           call MW_configuration_line_get_word(config_line, 7, maze_cg_prec)
                        end if
                     case default
                        write(errmsg,'("Invalid keyword for maze algorithm at line ",i4)') line_num
                        call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                              errmsg)
                  end select
               case default
                  write(errmsg,'("Invalid keyword for electrode_charges algorithm at line ",i4)') line_num
                  call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                        errmsg)
            end select

         case("preconditioner")
            if (preconditioner_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |preconditioner|. First definition at line ",i4,".")') &
                     line_num, preconditioner_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            preconditioner_defined = line_num

            if (algorithm /= "cg") then
               write(errmsg,'("Invalid |preconditioner| keyword for chosen algorithm at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for |preconditioner| parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            cg_preconditioned = .true.
            call MW_configuration_line_get_word(config_line, 2, cg_preconditioner)

         case("charge_neutrality")
            if (charge_neutrality_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |charge_neutrality|. First definition at line ",i4,".")') &
                     line_num, charge_neutrality_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            charge_neutrality_defined = line_num

            if ((config_line%num_words < 2) .or. (config_line%num_words > 4)) then
               write(errmsg,'("Invalid format for charge_neutrality parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, charge_neutrality)
            if (charge_neutrality) global_neutrality = .true.
            if (config_line%num_words >= 3) then
               call MW_configuration_line_get_word(config_line, 3, global_or_electrodes)
               select case (global_or_electrodes)
               case("global")
                  global_neutrality = .true.
               case("electrodes")
                  global_neutrality = .false.
               case default
                  write(errmsg,'("Invalid keyword for charge_neutrality parameters ",a," at line ",i4)') &
                        global_or_electrodes, line_num
                  call MW_errors_runtime_error("read_electrodes_parameters","configuration.f90", &
                        errmsg)
               end select
            end if
            if (config_line%num_words >= 4) then
               call MW_configuration_line_get_word(config_line, 4, uscale)
            end if

         case("write_matrix")
            if (write_matrix_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |write_matrix|. First definition at line ",i4,".")') &
                     line_num, write_matrix_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            write_matrix_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for write_matrix parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, write_matrix)

         case("compute_force")
            if (compute_force_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |compute_force|. First definition at line ",i4,".")') &
                     line_num, compute_force_defined
               call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
            end if
            compute_force_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for compute_force parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, compute_force)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop
      line_last = line_num

      ! Set up electrode types
      allocate(electrodes(num_elec), stat=ierr) ! allocate even if num_elec = 0!
      if (ierr /= 0) then
         call MW_errors_allocate_error("read_electrodes_parameters","configuration.f90", &
               ierr)
      end if
      if (num_elec > 0) then
         ! Read a second time to store the values
         do while (line_num >= types_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_electrodes_parameters","configuration.f90", &
                     "An error while backspace back to beginning of |electrode| section.")
            end if
            line_num = line_num - 1
         end do

         do ielec = 1, num_elec

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)

            if (keyword /= "electrode_type") then
               write(errmsg,'("Expected |electrode_type| keyword in electrodes parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_electrodes_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_electrode_parameters_read_parameters(electrodes(ielec), funit, line_num, compute_force)
         end do

         ! move back to the end of the electrodes block
         do while (line_num < line_last)
            read(funit,*)
            line_num = line_num + 1
         end do
      end if

      ! Define algorithm parameters
      select case (algorithm)
      case("cg")
         call MW_cg_set_max_iterations(algorithms%cg, max_iteration)
         call MW_cg_set_tolerance(algorithms%cg, tolerance)
         call MW_cg_set_charge_neutrality(algorithms%cg, charge_neutrality)
         call MW_cg_set_preconditioner(algorithms%cg, cg_preconditioned, cg_preconditioner)
         call MW_cg_reset_statistics(algorithms%cg)
      case("constant_charge")
         algorithms%constant_charge = .true.
         if (charge_neutrality_defined>0 .and. charge_neutrality) then
            write(errmsg,'("Charge neutrality cannot be enforced for constant charge electrodes")')
            call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", errmsg)
         end if
         charge_neutrality = .false.
         global_neutrality = .false.
      case("maze")
         algorithms%maze%calc_elec =.true.
         algorithms%maze%constant_constr_grad =.true.
         call MW_maze_set_max_iterations(algorithms%maze, max_iteration)
         call MW_maze_set_tolerance(algorithms%maze, tolerance)
         call MW_maze_select_algorithm(algorithms%maze, maze_algorithm, maze_cg_store, maze_cg_prec, n_blocks)
         call MW_maze_set_charge_neutrality(algorithms%maze, charge_neutrality, uscale)
         call MW_maze_set_write_matrix(algorithms%maze, write_matrix)
         call MW_maze_set_sor_param(algorithms%maze, sor_param)
         call MW_maze_reset_statistics(algorithms%maze)
      case("matrix_inversion")
         algorithms%matrix_inversion%calc_elec =.true.
         algorithms%matrix_inversion%constant_matrix =.true.
         call MW_matrix_inversion_set_tolerance(algorithms%matrix_inversion, tolerance)
         call MW_matrix_inversion_set_charge_neutrality(algorithms%matrix_inversion, charge_neutrality)
         call MW_matrix_inversion_set_write_matrix(algorithms%matrix_inversion, write_matrix)
         call MW_matrix_inversion_reset_statistics(algorithms%matrix_inversion)
      case default
         write(errmsg,'("Unknown charge computation algorithm ",a," at line ",i4)') &
               algorithm, charges_defined
         call MW_errors_runtime_error("read_electrodes_parameters","configuration.f90", &
               errmsg)
      end select

   end subroutine read_electrodes_parameters

   ! ================================================================================
   !> Read dipoles and electrode parameters
   !! dipoles_and_electrodes *block list*
   !!
   !!   algorithm *string* *real* *int*
   !!   preconditioner *string*
   !!   charge_neutrality *true/false* *global/electrodes* *real*
   !!

   subroutine read_dipoles_electrodes_parameters(electrodes, algorithms, funit, line_num, &
         charge_neutrality, global_neutrality)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_electrode_parameters, only: MW_electrode_parameters_t
      use MW_cg, only: &
            MW_cg_set_max_iterations => set_max_iterations, &
            MW_cg_set_tolerance => set_tolerance, &
            MW_cg_set_charge_neutrality => set_charge_neutrality, &
            MW_cg_set_preconditioner => set_preconditioner, &
            MW_cg_reset_statistics => reset_statistics
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error, &
            MW_errors_runtime_error => runtime_error
      use MW_algorithms, only: MW_algorithms_t

      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_parameters_t), allocatable, intent(inout) :: electrodes(:)
      type(MW_algorithms_t), intent(inout) :: algorithms
      integer,           intent(in)    :: funit !< configuration file unit
      integer,           intent(inout) :: line_num !< configuration file line number
      logical,           intent(out)   :: global_neutrality
      logical,           intent(out)   :: charge_neutrality

      ! Locals
      ! ------
      character(256) :: errmsg
      character(max_word_length) :: keyword, global_or_electrodes
      type(MW_configuration_line_t) :: config_line
      integer :: ierr
      integer :: line_last
      integer :: num_elec
      character(max_word_length) :: algorithm, cg_preconditioner
      integer :: max_iteration
      real(wp) :: tolerance
      integer :: algorithm_defined, preconditioner_defined
      integer :: charge_neutrality_defined
      logical :: cg_preconditioned
      ierr = 0

      ! Void current values
      if (.not. allocated(electrodes)) then
         write(errmsg,'("|dipoles_and_electrodes| definition must be after |electrodes|")') &
               line_num, algorithm_defined
         call MW_errors_runtime_error("read_electrodes_parameters", "configuration.f90", errmsg)
      end if
      num_elec = size(electrodes,1)

      ! Flag each section as undefined (line number will be stored)
      algorithm_defined = 0
      preconditioner_defined = 0
      charge_neutrality_defined = 0

      ! Set default values
      algorithm = "cg"
      cg_preconditioned = .false.
      cg_preconditioner = "jacobi"
      algorithms%maze%calc_elec = .false.
      algorithms%maze%calc_dip = .false.
      tolerance = 1.0e-12_wp
      max_iteration = 100
      charge_neutrality = .true.
      global_neutrality = .false.
      global_or_electrodes = "global"

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case (keyword)

         case("algorithm")
            if (algorithm_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |algorithm|. First definition at line ",i4,".")') &
                     line_num, algorithm_defined
               call MW_errors_runtime_error("read_dipoles_electrodes_parameters", "configuration.f90", errmsg)
            end if
            algorithm_defined = line_num

            if ((config_line%num_words < 2) .or. (config_line%num_words > 7)) then
               write(errmsg,'("Invalid format for algorithm parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_dipoles_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, algorithm)
            select case(algorithm)
               case("cg_and_constant_charge")
               case("cg")
                  if (config_line%num_words >= 3) then
                     call MW_configuration_line_get_word(config_line, 3, tolerance)
                  end if
                  if (config_line%num_words >= 4) then
                     call MW_configuration_line_get_word(config_line, 4, max_iteration)
                  end if

               case default
                  write(errmsg,'("Invalid keyword for algorithm at line ",i4)') line_num
                  call MW_errors_runtime_error("read_dipoles_electrode_parameters","configuration.f90", &
                        errmsg)
            end select

         case("preconditioner")
            if (preconditioner_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |preconditioner|. First definition at line ",i4,".")') &
                     line_num, preconditioner_defined
               call MW_errors_runtime_error("read_dipoles_electrodes_parameters", "configuration.f90", errmsg)
            end if
            preconditioner_defined = line_num

            if (algorithm /= "cg" .and. algorithm /= "cg_and_constant_charge") then
               write(errmsg,'("Invalid |preconditioner| keyword for chosen algorithm at line ",i4)') line_num
               call MW_errors_runtime_error("read_dipoles_electrodes_parameters","configuration.f90", &
                     errmsg)
            end if

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for |preconditioner| parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_dipoles_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            cg_preconditioned = .true.
            call MW_configuration_line_get_word(config_line, 2, cg_preconditioner)

         case("charge_neutrality")
            if (charge_neutrality_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |charge_neutrality|. First definition at line ",i4,".")') &
                     line_num, charge_neutrality_defined
               call MW_errors_runtime_error("read_dipoles_electrodes_parameters", "configuration.f90", errmsg)
            end if
            charge_neutrality_defined = line_num

            if ((config_line%num_words < 2) .or. (config_line%num_words > 4)) then
               write(errmsg,'("Invalid format for charge_neutrality parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_dipoles_electrode_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, charge_neutrality)
            if (charge_neutrality) global_neutrality = .true.
            if (config_line%num_words >= 3) then
               call MW_configuration_line_get_word(config_line, 3, global_or_electrodes)
               select case (global_or_electrodes)
               case("global")
                  global_neutrality = .true.
               case("electrodes")
                  global_neutrality = .false.
               case default
                  write(errmsg,'("Invalid keyword for charge_neutrality parameters ",a," at line ",i4)') &
                        global_or_electrodes, line_num
                  call MW_errors_runtime_error("read_dipoles_electrodes_parameters","configuration.f90", &
                        errmsg)
               end select
            end if

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop
      line_last = line_num

      ! Define algorithm parameters
      select case (algorithm)
      case("cg")
         call MW_cg_set_max_iterations(algorithms%cg, max_iteration)
         call MW_cg_set_tolerance(algorithms%cg, tolerance)
         call MW_cg_set_charge_neutrality(algorithms%cg, charge_neutrality)
         call MW_cg_set_preconditioner(algorithms%cg, cg_preconditioned, cg_preconditioner)
         call MW_cg_reset_statistics(algorithms%cg)
      case("cg_and_constant_charge")
         algorithms%constant_charge = .true.
         if (charge_neutrality_defined>0 .and. charge_neutrality) then
            write(errmsg,'("Charge neutrality cannot be enforced for constant charge electrodes")')
            call MW_errors_runtime_error("read_electrode_parameters","configuration.f90", errmsg)
         end if
         charge_neutrality = .false.
         global_neutrality = .false.
         call MW_cg_set_max_iterations(algorithms%cg, max_iteration)
         call MW_cg_set_tolerance(algorithms%cg, tolerance)
         call MW_cg_set_charge_neutrality(algorithms%cg, charge_neutrality)
         call MW_cg_set_preconditioner(algorithms%cg, cg_preconditioned, cg_preconditioner)
         call MW_cg_reset_statistics(algorithms%cg)
      case default
         write(errmsg,'("Unknown dipoles and charge computation algorithm ",a," at line ",i4)') &
               algorithm, algorithm_defined
         call MW_errors_runtime_error("read_dipoles_electrodes_parameters","configuration.f90", &
               errmsg)
      end select

   end subroutine read_dipoles_electrodes_parameters

   ! ==========================================================================================
   ! Read interaction parameters
   ! interactions *block*
   !   coulomb *block*
   !     coulomb_rtol *real*
   !     coulomb_rcut *real*
   !     coulomb_ktol *real*
   !
   !   lennard-jones *block*
   !     lj_rcut *real*
   !     lj_pair *string* *string* *real* *real*
   !     [lj_pair *string* *string* *real* *real*]
   !
   !   fumi-tosi *block*
   !     ft_rcut *real*
   !     ft_pair *string* *string* *real* *real* *real* *real* *real* *real*
   !     [ft_pair *string* *string* *real* *real* *real* *real* *real* *real*]
   !
   !   xft *block*
   !     xft_rcut *real*
   !     xft_pair *string* *string* *real* *real* *real* *real* *int* *real* *real* *real* *real*
   !     [xft_pair *string* *string* *real* *real* *real* *real* *int* *real* *real* *real* *real*]
   !
   !   daim *block*
   !     daim_rcut *real*
   !     daim_pair *string* *string* *real* x10
   !     [daim_pair *string* *string* *real* x10]
   !
   !   damping *block*
   !     tt_pair *string* *string* *real* *int* *real*
   !     [tt_pair *string* *string* *real* *int* *real*]
   !
   !   steele *int*
   !     steele_pair *string* *string* *real* *real* *real*
   !     [steele_pair *string* *string* *real* *real* *real*]

   subroutine read_interactions_parameters(system, species, electrodes, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_species, only: MW_species_t
      use MW_electrode_parameters, only: MW_electrode_parameters_t

      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      type(MW_electrode_parameters_t), allocatable :: electrodes(:)
      integer, intent(in) :: funit
      integer, intent(inout) :: line_num
      ! Locals
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      integer :: coulomb_defined, lj_defined, ft_defined, xft_defined
      integer :: tt_defined, daim_defined, steele_defined
      integer :: num_walls=0

      coulomb_defined = 0
      lj_defined = 0
      daim_defined = 0
      ft_defined = 0
      xft_defined = 0
      tt_defined = 0
      steele_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("coulomb")
            if (coulomb_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |coulomb|. First definition at line ",i4,".")') &
                     line_num, coulomb_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            coulomb_defined = line_num

            ! Read coulomb parameters
            call read_coulomb_parameters(system, funit, line_num)

         case("lennard-jones")
            if (lj_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |lennard-jones|. First definition at line ",i4,".")') &
                     line_num, lj_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            lj_defined = line_num

            ! Read lennard-jones parameters
            call read_lj_parameters(system, species, funit, line_num)

         case("fumi-tosi")
            if (ft_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |fumi-tosi|. First definition at line ",i4,".")') &
                     line_num, ft_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            ft_defined = line_num

            ! Read fumi-tosi parameters
            call read_ft_parameters(system, species, funit, line_num)

         case("xft")
            if (xft_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |xft|. First definition at line ",i4,".")') &
                     line_num, xft_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            xft_defined = line_num

            ! Read xft parameters
            call read_xft_parameters(system, species, funit, line_num)

         case("daim")
            if (daim_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |daim|. First definition at line ",i4,".")') &
                     line_num, daim_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            daim_defined = line_num

            ! Read daim parameters
            call read_daim_parameters(system, species, funit, line_num)

         case("damping")
            if (tt_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |damping|. First definition at line ",i4,".")') &
                     line_num, tt_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            tt_defined = line_num

            ! Read damping parameters
            call read_tt_parameters(system, species, funit, line_num)

         case("steele")
            if (steele_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |steele|. First definition at line ",i4,".")') &
                     line_num, steele_defined
               call MW_errors_runtime_error("read_interactions_parameters", "configuration.f90", errmsg)
            end if
            steele_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid |steele| specification at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_interactions_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, num_walls)

            ! Read steele parameters
            call read_steele_parameters(system, species, electrodes, num_walls, funit, line_num)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_interactions_parameters

   ! ================================================================================
   ! Read Ewald summation parameters for coulomb interactions
   !   coulomb *block*
   !     coulomb_rtol *real*
   !     coulomb_rcut *real*
   !     coulomb_ktol *real*
   !     ewald_zrange *real*
   !     ewald_zscale *real*
   subroutine read_coulomb_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ewald, only: MW_ewald_define_type => define_type, &
            MW_ewald_void_type => void_type, &
            MW_ewald_define_zscale => define_zscale
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer,           intent(in)    :: funit !< configuration file unit
      integer,           intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      real(wp) :: rtol, rcut, ktol, zrange, zweight
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      integer :: rtol_defined, rcut_defined, ktol_defined, zrange_defined, zweight_defined

      call MW_ewald_void_type(system%ewald)

      ! set default
      rtol = 1.0e-15
      ktol = 1.0e-15
      rcut = 0.0_wp
      zrange = 1.0_wp
      zweight = 1.0_wp

      ! Flag for each section definition
      rtol_defined = 0
      rcut_defined = 0
      ktol_defined = 0
      zrange_defined = 0
      zweight_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("coulomb_rtol")
            if (rtol_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |coulomb_rtol|. First definition at line ",i4,".")') &
                     line_num, rtol_defined
               call MW_errors_runtime_error("read_coulomb_parameters", "configuration.f90", errmsg)
            end if
            rtol_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rtol specification for ewald parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_coulomb_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rtol)

         case("coulomb_rcut")
            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |coulomb_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_coulomb_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for ewald parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_coulomb_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)

         case("coulomb_ktol")
            if (ktol_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |coulomb_ktol|. First definition at line ",i4,".")') &
                     line_num, ktol_defined
               call MW_errors_runtime_error("read_coulomb_parameters", "configuration.f90", errmsg)
            end if
            ktol_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid ktol specification for ewald parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_coulomb_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, ktol)

         case("ewald_zrange")
            if (zrange_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |ewald_zrange|. First definition at line ",i4,".")') &
                     line_num, zrange_defined
               call MW_errors_runtime_error("read_coulomb_parameters", "configuration.f90", errmsg)
            end if
            zrange_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid zrange specification for ewald parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_coulomb_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, zrange)

         case("ewald_zweight")
            if (zweight_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |ewald_zweight|. First definition at line ",i4,".")') &
                     line_num, zweight_defined
               call MW_errors_runtime_error("read_coulomb_parameters", "configuration.f90", errmsg)
            end if
            zweight_defined = line_num
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid zweight specification for ewald parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_coulomb_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, zweight)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      call MW_ewald_define_type(system%ewald, rtol, rcut, ktol)
      call MW_ewald_define_zscale(system%ewald, zrange, zweight)
   end subroutine read_coulomb_parameters

   ! ================================================================================
   ! Read lennard-jones potential parameters
   !
   !   lennard-jones *block*
   !     lj_rcut *real*
   !     lj_pair *string* *string* *real* *real*
   !     [lj_pair *string* *string* *real* *real*]
   subroutine read_lj_parameters(system, species, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_lennard_jones, only: MW_lennard_jones_define_type => define_type, &
            MW_lennard_jones_void_type => void_type, &
            MW_lennard_jones_set_rcut => set_rcut, &
            MW_lennard_jones_set_parameters => set_parameters, &
            MW_lennard_jones_lorentz_berthelot_mixing_rule => lorentz_berthelot_mixing_rule
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword, rule
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: itypeA, itypeB
      integer :: num_species
      real(wp) :: rcut, lj_eps, lj_sig
      integer :: rcut_defined

      num_species = size(species,1)

      call MW_lennard_jones_void_type(system%lj)
      call MW_lennard_jones_define_type(system%lj, num_species, 0.0_wp)
      rcut_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("lj_3D_tail_correction")
            system%lj%lj_3D_tail_correction=.true.
            if (system%num_PBC==2) then
              write(errmsg,'("At line ",i4,", setting 3D LJ correction with 2D PBC does not make sense")') &
               line_num
              call MW_errors_runtime_error("read_lj_parameters", "configuration.f90", errmsg)
              stop
            end if

         case("lj_rcut")

            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |lj_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_lj_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for lennard-jones parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)
            call MW_lennard_jones_set_rcut(system%lj, rcut)

         case("lj_pair")
            if (config_line%num_words /= 5) then
               write(errmsg,'("Invalid pair specification for lennard-jones parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)
            call MW_species_identify(siteA, species, itypeA)
            if (itypeA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for lj parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for lj parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, lj_eps)
            call MW_configuration_line_get_word(config_line, 5, lj_sig)

            call MW_lennard_jones_set_parameters(system%lj, itypeA, itypeB, lj_eps, lj_sig)

         case("lj_rule")
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid lj_rule specification for lennard-jones parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, rule)
            select case(rule)
            case("Lorentz_Berthelot")
               call MW_lennard_jones_lorentz_berthelot_mixing_rule(system%lj)

            case default
               write(errmsg,'("Unknown lj_rule specification at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_lj_parameters","configuration.f90", &
                     errmsg)
            end select

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_lj_parameters


   ! ================================================================================
   ! Read fumi-tosi potential parameters
   !
   !   fumi-tosi *block*
   !     ft_rcut *real*
   !     ft_pair *string* *string* *real* *real* *real* *real* *real* *real*
   !     [ft_pair *string* *string* *real* *real* *real* *real* *real* *real*]
   subroutine read_ft_parameters(system, species, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_fumi_tosi, only: MW_fumi_tosi_define_type => define_type, &
            MW_fumi_tosi_void_type => void_type, &
            MW_fumi_tosi_set_rcut => set_rcut, &
            MW_fumi_tosi_set_parameters => set_parameters, &
            MW_fumi_tosi_mixing_rule => mixing_rule
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword, rule
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: itypeA, itypeB
      integer :: num_species
      real(wp) :: rcut, ft_eta, ft_B, ft_C, ft_D, ft_damp_dd, ft_damp_dq
      integer :: rcut_defined

      num_species = size(species,1)

      call MW_fumi_tosi_void_type(system%ft)
      call MW_fumi_tosi_define_type(system%ft, num_species, 0.0_wp)
      rcut_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("ft_3D_pressure_tail_correction")
            system%ft%ft_3D_tail_correction=.true.
            if (system%num_PBC==2) then
              write(errmsg,'("At line ",i4,", setting 3D FT correction with 2D PBC does not make sense")') &
               line_num
              call MW_errors_runtime_error("read_ft_parameters", "configuration.f90", errmsg)
              stop
            end if

         case("ft_rcut")

            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |ft_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_ft_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for fumi-tosi parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)
            call MW_fumi_tosi_set_rcut(system%ft, rcut)

         case("ft_pair")

            if (config_line%num_words /= 9) then
               write(errmsg,'("Invalid pair specification for fumi-tosi parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)
            call MW_species_identify(siteA, species, itypeA)
            if (itypeA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for ft parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end if


            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for ft parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, ft_eta)
            call MW_configuration_line_get_word(config_line, 5, ft_B)
            call MW_configuration_line_get_word(config_line, 6, ft_C)
            call MW_configuration_line_get_word(config_line, 7, ft_D)
            call MW_configuration_line_get_word(config_line, 8, ft_damp_dd)
            call MW_configuration_line_get_word(config_line, 9, ft_damp_dq)

            call MW_fumi_tosi_set_parameters(system%ft, itypeA, itypeB, ft_eta, ft_B, ft_C, ft_D, ft_damp_dd, ft_damp_dq)

         case("ft_rule")
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid ft_rule specification for fumi-tosi parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, rule)
            select case(rule)
            case("Mixing")
               call MW_fumi_tosi_mixing_rule(system%ft)

            case default
               write(errmsg,'("Unknown ft_rule specification at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_ft_parameters","configuration.f90", &
                     errmsg)
            end select

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_ft_parameters

   ! ================================================================================
   ! Read xft potential parameters
   !
   !   xft *block*
   !     xft_rcut *real*
   !     xft_pair *string* *string* *real* *real* *real* *real* *int* *real* *real* *real* *real*
   !     [xft_pair *string* *string* *real* *real* *real* *real* *int* *real* *real* *real* *real*]
   subroutine read_xft_parameters(system, species, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_xft, only: MW_xft_define_type => define_type, &
            MW_xft_void_type => void_type, &
            MW_xft_set_rcut => set_rcut, &
            MW_xft_set_parameters => set_parameters, &
            MW_xft_mixing_rule => mixing_rule
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword, rule
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: itypeA, itypeB
      integer :: num_species
      integer :: xft_n
      real(wp) :: rcut, xft_eta, xft_B, xft_C, xft_D, xft_damp_dd, xft_damp_dq
      real(wp) :: xft_etax,xft_Bx
      integer :: rcut_defined

      num_species = size(species,1)

      call MW_xft_void_type(system%xft)
      call MW_xft_define_type(system%xft, num_species, 0.0_wp)
      rcut_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("xft_3D_pressure_tail_correction")
            system%xft%xft_3D_tail_correction=.true.
            if (system%num_PBC==2) then
              write(errmsg,'("At line ",i4,", setting 3D XFT correction with 2D PBC does not make sense")') &
               line_num
              call MW_errors_runtime_error("read_xft_parameters", "configuration.f90", errmsg)
              stop
            end if

         case("xft_rcut")

            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |xft_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_xft_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for xft parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)
            call MW_xft_set_rcut(system%xft, rcut)

         case("xft_pair")

            if (config_line%num_words /= 12) then
               write(errmsg,'("Invalid pair specification for xft parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)
            call MW_species_identify(siteA, species, itypeA)
            if (itypeA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for xft parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end if


            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for xft parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, xft_eta)
            call MW_configuration_line_get_word(config_line, 5, xft_B)
            call MW_configuration_line_get_word(config_line, 6, xft_n)
            call MW_configuration_line_get_word(config_line, 7, xft_etax)
            call MW_configuration_line_get_word(config_line, 8, xft_Bx)
            call MW_configuration_line_get_word(config_line, 9, xft_C)
            call MW_configuration_line_get_word(config_line, 10, xft_D)
            call MW_configuration_line_get_word(config_line, 11, xft_damp_dd)
            call MW_configuration_line_get_word(config_line, 12, xft_damp_dq)

            call MW_xft_set_parameters(system%xft, itypeA, itypeB, xft_eta, xft_B, &
                   xft_n, xft_etax, xft_Bx, xft_C, xft_D, xft_damp_dd, xft_damp_dq)

         case("xft_rule")
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid xft_rule specification for xft parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, rule)
            select case(rule)
            case("Mixing")
               call MW_xft_mixing_rule(system%xft)

            case default
               write(errmsg,'("Unknown xft_rule specification at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_xft_parameters","configuration.f90", &
                     errmsg)
            end select

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_xft_parameters

   ! ================================================================================
   ! Read daim potential parameters
   !
   !   daim *block*
   !     daim_rcut *real*
   !     daim_pair *string* *string* *real* x10
   !     [daim_pair *string* *string* *real* x10]
   subroutine read_daim_parameters(system, species, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_daim, only: MW_daim_define_type => define_type, &
            MW_daim_void_type => void_type, &
            MW_daim_set_rcut => set_rcut
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: itypeA, itypeB
      integer :: num_species
      real(wp) :: rcut
      real(wp) :: daim_eta1, daim_B1
      real(wp) :: daim_eta2, daim_B2
      real(wp) :: daim_eta3, daim_B3
      real(wp) :: daim_C, daim_D, daim_damp_dd, daim_damp_dq
      integer :: rcut_defined

      num_species = size(species,1)

      call MW_daim_void_type(system%daim)
      call MW_daim_define_type(system%daim, num_species, 0.0_wp)
      rcut_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("daim_3D_pressure_tail_correction")
            system%daim%daim_3D_tail_correction=.true.
            if (system%num_PBC==2) then
              write(errmsg,'("At line ",i4,", setting 3D DAIM correction with 2D PBC does not make sense")') &
               line_num
              call MW_errors_runtime_error("read_daim_parameters", "configuration.f90", errmsg)
              stop
            end if

         case("daim_rcut")

            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |daim_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_daim_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for daim parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_daim_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)
            call MW_daim_set_rcut(system%daim, rcut)

         case("daim_pair")

            if (config_line%num_words /= 13) then
               write(errmsg,'("Invalid pair specification for daim parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_daim_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)
            call MW_species_identify(siteA, species, itypeA)
            if (itypeA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for daim parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_daim_parameters","configuration.f90", &
                     errmsg)
            end if


            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for daim parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_daim_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, daim_eta1)
            call MW_configuration_line_get_word(config_line, 5, daim_eta2)
            call MW_configuration_line_get_word(config_line, 6, daim_eta3)
            call MW_configuration_line_get_word(config_line, 7, daim_B1)
            call MW_configuration_line_get_word(config_line, 8, daim_B2)
            call MW_configuration_line_get_word(config_line, 9, daim_B3)
            call MW_configuration_line_get_word(config_line, 10, daim_C)
            call MW_configuration_line_get_word(config_line, 11, daim_D)
            call MW_configuration_line_get_word(config_line, 12, daim_damp_dd)
            call MW_configuration_line_get_word(config_line, 13, daim_damp_dq)


            system%daim%eta1(itypeA,itypeB) = daim_eta1
            system%daim%eta1(itypeB,itypeA) = daim_eta1

            system%daim%eta2(itypeA,itypeB) = daim_eta2
            system%daim%eta2(itypeB,itypeA) = daim_eta2

            system%daim%eta3(itypeA,itypeB) = daim_eta3
            system%daim%eta3(itypeB,itypeA) = daim_eta3

            system%daim%B1(itypeA,itypeB) = daim_B1
            system%daim%B1(itypeB,itypeA) = daim_B1

            system%daim%B2(itypeA,itypeB) = daim_B2
            system%daim%B2(itypeB,itypeA) = daim_B2

            system%daim%B3(itypeA,itypeB) = daim_B3
            system%daim%B3(itypeB,itypeA) = daim_B3

            system%daim%C(itypeA,itypeB) = daim_C
            system%daim%C(itypeB,itypeA) = daim_C

            system%daim%D(itypeA,itypeB) = daim_D
            system%daim%D(itypeB,itypeA) = daim_D

            system%daim%damp_dd(itypeA,itypeB) = daim_damp_dd
            system%daim%damp_dd(itypeB,itypeA) = daim_damp_dd

            system%daim%damp_dq(itypeA,itypeB) = daim_damp_dq
            system%daim%damp_dq(itypeB,itypeA) = daim_damp_dq

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_daim_parameters

   ! ================================================================================
   ! Read damping potential parameters (tt stands for Tang-Toennies)
   !
   !   damping *block*
   !     tt_pair *string* *string* *real* *int* *real*
   !     [tt_pair *string* *string* *real* *int* *real*]
   !     first atom is the charge that damps, second one carries the dipole which is damped
   subroutine read_tt_parameters(system, species, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_damping, only: MW_damping_define_type => define_type, &
            MW_damping_void_type => void_type
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: itypeA, itypeB
      integer :: num_species
      real(wp) :: tt_b, tt_c, tt_order

      num_species = size(species,1)

      call MW_damping_void_type(system%tt)
      call MW_damping_define_type(system%tt, num_species)

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("tt_pair")

            if (config_line%num_words /= 6) then
               write(errmsg,'("Invalid pair specification for damping parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_tt_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)
            call MW_species_identify(siteA, species, itypeA)
            if (itypeA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for damping parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_tt_parameters","configuration.f90", &
                     errmsg)
            end if


            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for damping parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_tt_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, tt_b)
            call MW_configuration_line_get_word(config_line, 5, tt_order)
            call MW_configuration_line_get_word(config_line, 6, tt_c)

            system%tt%b(itypeA,itypeB) = tt_b

            if (tt_order/int(tt_order) == 1.0_wp) then
               system%tt%order(itypeA,itypeB) = int(tt_order)
            else
               write(errmsg,'("Tang-Tonnies order for pair ",a,"-",a," should be integer at line ",i4)') &
                     siteA, siteB, line_num
               call MW_errors_runtime_error("read_tt_parameters","configuration.f90", &
                     errmsg)
            end if

            system%tt%c(itypeA,itypeB) = tt_c

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_tt_parameters

   ! ================================================================================
   ! Read steele potential parameters
   !
   !   steele *block*
   !     steele_rcut *real*
   !     wall *string* *string* *real* *real* *real* *real*
   !     [wall *string* *string* *real* *real* *real* *real*]
   subroutine read_steele_parameters(system, species, electrodes, num_walls, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_identify => identify
      use MW_electrode, only: MW_electrode_identify => identify
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_steele, only: MW_steele_define_type => define_type, &
            MW_steele_void_type => void_type, &
            MW_steele_set_rcut => set_rcut, &
            MW_steele_set_parameters => set_parameters
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify
      use MW_electrode_parameters, only: MW_electrode_parameters_t
      implicit none

      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_species_t), intent(in) :: species(:)
      type(MW_electrode_parameters_t), allocatable :: electrodes(:)
      integer, intent(in) :: num_walls
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< configuration file line number

      ! Local
      ! -----
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(PARTICLE_NAME_LEN) :: siteA, siteB
      integer :: iwallA, itypeB, i
      integer :: num_species
      real(wp) :: rcut, rho_w, eps_wf, sig_wf, delta_w
      integer :: rcut_defined

      num_species = size(species,1)

      call MW_steele_void_type(system%steele)
      call MW_steele_define_type(system%steele, num_walls, num_species, 0.0_wp)
      rcut_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)
         case("steele_rcut")

            if (rcut_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |steele_rcut|. First definition at line ",i4,".")') &
                     line_num, rcut_defined
               call MW_errors_runtime_error("read_steele_parameters", "configuration.f90", errmsg)
            end if
            rcut_defined = line_num

            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid rcut specification for steele parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_steele_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, rcut)
            call MW_steele_set_rcut(system%steele, rcut)

         case("wall")
            if (config_line%num_words /= 7) then
               write(errmsg,'("Invalid pair specification for steele parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_steele_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 2, siteA)

            iwallA = 0
            do i = 1, size(electrodes, 1)
               if (siteA == electrodes(i)%name) then
                  iwallA = i
                  exit
               end if
            end do

            if (iwallA == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for steele parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_steele_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 3, siteB)
            call MW_species_identify(siteB, species, itypeB)
            if (itypeB == 0) then
               write(errmsg,'("Unknown particle type ",a," in pair specification for steele parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_steele_parameters","configuration.f90", &
                     errmsg)
            end if

            call MW_configuration_line_get_word(config_line, 4, rho_w)
            call MW_configuration_line_get_word(config_line, 5, eps_wf)
            call MW_configuration_line_get_word(config_line, 6, sig_wf)
            call MW_configuration_line_get_word(config_line, 7, delta_w)

            call MW_steele_set_parameters(system%steele, iwallA, itypeB, rho_w, eps_wf, sig_wf, delta_w)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

   end subroutine read_steele_parameters
   ! ================================================================================
   ! Read output parameters
   !
   ! output *block*
   !   default *int*
   !   trajectories *int*
   !   xyz *int*
   !   pdb *int*
   !   lammps *int*
   !   charges *int*
   !   forces *int*
   !   dipoles *int*
   !   radius *int*
   !   restart *int* (alternate)
   !   step    *int*
   !   total_charges *int*
   !   density *int* *int* (*real* *real*)
   subroutine read_output_parameters(system, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_output, only: &
            MW_output_trajectories_set_dump_frequency => trajectories_set_dump_frequency, &
            MW_output_xyz_set_dump_frequency => xyz_set_dump_frequency, &
            MW_output_pdb_set_dump_frequency => pdb_set_dump_frequency, &
            MW_output_lammps_set_dump_frequency => lammps_set_dump_frequency, &
            MW_output_charges_set_dump_frequency => charges_set_dump_frequency, &
            MW_output_forces_set_dump_frequency => forces_set_dump_frequency, &
            MW_output_elec_forces_set_dump_frequency => elec_forces_set_dump_frequency, &
            MW_output_dipoles_set_dump_frequency => dipoles_set_dump_frequency, &
            MW_output_efg_set_dump_frequency => efg_set_dump_frequency, &
            MW_output_radius_set_dump_frequency => radius_set_dump_frequency, &
            MW_output_potential_shift_set_dump_frequency => potential_shift_set_dump_frequency, &
            MW_output_energies_set_dump_frequency => energies_set_dump_frequency, &
            MW_output_restart_set_dump_frequency => restart_set_dump_frequency, &
            MW_output_temperature_set_dump_frequency => temperature_set_dump_frequency, &
            MW_output_pressure_set_dump_frequency => pressure_set_dump_frequency, &
            MW_output_stress_tensor_set_dump_frequency => stress_tensor_set_dump_frequency, &
            MW_output_box_set_dump_frequency => box_set_dump_frequency, &
            MW_output_step_set_dump_frequency => step_set_dump_frequency, &
            MW_output_total_charges_set_dump_frequency => total_charges_set_dump_frequency, &
            MW_output_polarization_set_dump_frequency => polarization_set_dump_frequency, &
            MW_output_diagnostic_set_dump_frequency => diagnostic_set_dump_frequency
      use MW_diagnostic, only: MW_diagnostic_set_num_bins => set_num_bins
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      integer, intent(in) :: funit
      integer, intent(inout) :: line_num

      ! Local
      ! -----
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      character(256) :: errmsg
      character(max_word_length) :: alternate, unwrap
      integer :: default, trajectories, xyz, pdb, lammps, charges, forces, elec_forces, &
            dipoles, efg, radius, potential_shift, energies, &
            restart, temperature, pressure, stress_tensor, box, &
            step, total_charges, density, density_num_bins, polarization
      integer :: default_defined, trajectories_defined, xyz_defined, pdb_defined, lammps_defined, &
            charges_defined, forces_defined, elec_forces_defined, dipoles_defined, efg_defined, &
            radius_defined, potential_shift_defined, energies_defined, restart_defined, &
            temperature_defined, pressure_defined, stress_tensor_defined, box_defined, &
            step_defined, total_charges_defined, density_defined, &
            polarization_defined
      integer :: term
      logical :: density_limits
      real(wp) :: density_min, density_max

      ! Set default values
      default = 0
      trajectories = 0
      xyz = 0
      pdb = 0
      lammps = 0
      charges = 0
      forces = 0
      elec_forces = 0
      dipoles = 0
      efg = 0
      radius = 0
      potential_shift = 0
      energies = 0
      restart = 0
      temperature = 0
      pressure = 0
      stress_tensor = 0
      box = 0
      step = 0
      total_charges = 0
      polarization = 0
      density = 0
      density_num_bins = 1
      density_limits = .false.
      density_min = 0.0_wp
      density_max = 0.0_wp

      ! Flag each section as undefined (line number will be stored)
      default_defined = 0
      trajectories_defined = 0
      xyz_defined = 0
      pdb_defined = 0
      lammps_defined = 0
      charges_defined = 0
      forces_defined = 0
      elec_forces_defined = 0
      dipoles_defined = 0
      efg_defined = 0
      radius_defined = 0
      potential_shift_defined = 0
      energies_defined = 0
      restart_defined = 0
      temperature_defined = 0
      pressure_defined = 0
      stress_tensor_defined = 0
      box_defined = 0
      step_defined = 0
      total_charges_defined = 0
      polarization_defined =0
      density_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("default")
            if (default_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |default|. First definition at line ",i4,".")') &
                     line_num, default_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            default_defined = line_num

            ! Read default parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for default parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, default)

         case("trajectories")
            if (trajectories_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |trajectories|. First definition at line ",i4,".")') &
                     line_num, trajectories_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            trajectories_defined = line_num

            ! Read trajectories parameters
            if (config_line%num_words /= 2 .and. config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for trajectories parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, trajectories)
            if (config_line%num_words == 3) then
               call MW_configuration_line_get_word(config_line, 3, unwrap)
               if (unwrap == "unwrap") then
                  system%trajectories_unwrapped = 1
               else
                  write(errmsg,'("Invalid keyword for trajectories parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if
            end if

         case("xyz")
            if (xyz_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |xyz|. First definition at line ",i4,".")') &
                     line_num, xyz_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            xyz_defined = line_num

            ! Read xyz parameters
            if (config_line%num_words /= 2 .and. config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for xyz parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, xyz)
            if (config_line%num_words == 3) then
               call MW_configuration_line_get_word(config_line, 3, unwrap)
               if (unwrap == "unwrap") then
                  system%xyz_unwrapped = 1
               else
                  write(errmsg,'("Invalid keyword for xyz parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if
            end if

         case("pdb")
            if (pdb_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |pdb|. First definition at line ",i4,".")') &
                     line_num, pdb_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            pdb_defined = line_num

            ! Read pdb parameters
            if (config_line%num_words /= 2 .and. config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for pdb parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, pdb)
            if (config_line%num_words == 3) then
               call MW_configuration_line_get_word(config_line, 3, unwrap)
               if (unwrap == "unwrap") then
                  system%pdb_unwrapped = 1
               else
                  write(errmsg,'("Invalid keyword for pdb parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if
            end if

         case("lammps")
            if (lammps_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |lammps|. First definition at line ",i4,".")') &
                     line_num, lammps_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            lammps_defined = line_num

            ! Read lammps parameters
            if (config_line%num_words /= 2 .and. config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for lammps parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, lammps)
            if (config_line%num_words == 3) then
               call MW_configuration_line_get_word(config_line, 3, unwrap)
               if (unwrap == "unwrap") then
                  system%lammps_unwrapped = 1
               else
                  write(errmsg,'("Invalid keyword for lammps parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if
            end if

         case("temperature")
            if (temperature_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |temperature|. First definition at line ",i4,".")') &
                     line_num, temperature_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            temperature_defined = line_num

            ! Read temperature parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for temperature parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, temperature)

         case("pressure")
            if (pressure_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |pressure|. First definition at line ",i4,".")') &
                     line_num, pressure_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            pressure_defined = line_num

            ! Read pressure parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for pressure parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, pressure)

         case("stress_tensor")
            if (stress_tensor_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |stress_tensor|. First definition at line ",i4,".")') &
                     line_num, stress_tensor_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            stress_tensor_defined = line_num

            ! Read stress_tensor parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for stress_tensor parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, stress_tensor)

         case("box_parameters")
            if (box_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |box_parameters|. First definition at line ",i4,".")') &
                     line_num, box_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            box_defined = line_num

            ! Read pressure parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for pressure parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, box)

         case("charges")
            if (charges_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |charges|. First definition at line ",i4,".")') &
                     line_num, charges_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            charges_defined = line_num

            ! Read charges parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for charges parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, charges)

         case("total_charges")
            if (total_charges_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |total_charges|. First definition at line ",i4,".")') &
                     line_num, total_charges_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            total_charges_defined = line_num

            ! Read total_charges parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for total_charges parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, total_charges)

         case("forces")
            if (forces_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |forces|. First definition at line ",i4,".")') &
                     line_num, forces_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            forces_defined = line_num

            ! Read forces parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for forces parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, forces)

         case("elec_forces")
            if (elec_forces_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |elec_forces|. First definition at line ",i4,".")') &
                     line_num, elec_forces_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            elec_forces_defined = line_num

            ! Read elec_forces parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for elec_forces parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, elec_forces)

         case("dipoles")
            if (dipoles_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dipoles|. First definition at line ",i4,".")') &
                     line_num, dipoles_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            dipoles_defined = line_num

            ! Read dipoles parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for dipoles parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dipoles)

         case("efg")
            if (efg_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |efg|. First definition at line ",i4,".")') &
                     line_num, efg_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            efg_defined = line_num

            ! Read dipoles parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for efg parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, efg)

         case("radius")
            if (radius_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |radius|. First definition at line ",i4,".")') &
                     line_num, radius_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            radius_defined = line_num

            ! Read radius parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for dipoles parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, radius)

         case("potential_shift")
            if (potential_shift_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |potential_shift|. First definition at line ",i4,".")') &
                     line_num, potential_shift_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            potential_shift_defined = line_num

            ! Read potential_shift parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for potential shift parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, potential_shift)

         case("energies")
            if (energies_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |energies|. First definition at line ",i4,".")') &
                     line_num, energies_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            energies_defined = line_num

            ! Read energies parameters
            if (config_line%num_words < 2) then
               write(errmsg,'("Invalid format for energies parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, energies)

            if (config_line%num_words > 2) then
               system%energy_terms_to_dump = config_line%num_words - 2
               if (system%energy_terms_to_dump > size(system%energies_to_dump)) then
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if

               do term = 1, system%energy_terms_to_dump
                  call MW_configuration_line_get_word(config_line, 2+term, system%energies_to_dump(term))
               end do
            end if

         case("restart")
            if (restart_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |restart|. First definition at line ",i4,".")') &
                     line_num, restart_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            restart_defined = line_num

            ! Read restart parameters
            if (config_line%num_words /= 2 .and. config_line%num_words /= 3) then
               write(errmsg,'("Invalid format for restart parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, restart)
            if (config_line%num_words == 3) then
               call MW_configuration_line_get_word(config_line, 3, alternate)
               if (alternate == "alternate") then
                  system%alternate_restart = 1
               else
                  write(errmsg,'("Invalid keyword for restart parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                        errmsg)
               end if
            end if

         case("step")
            if (step_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |step|. First definition at line ",i4,".")') &
                     line_num, step_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            step_defined = line_num

            ! Read step parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for step parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, step)

         case("polarization")
            if (polarization_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |polarization|. First definition at line ",i4,".")') &
                     line_num, polarization_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            polarization_defined = line_num

            ! Read polarization parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for forces parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, polarization)

         case("density")
            if (density_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |density|. First definition at line ",i4,".")') &
                     line_num, density_defined
               call MW_errors_runtime_error("read_output_parameters", "configuration.f90", errmsg)
            end if
            density_defined = line_num

            ! Read density parameters
            if (config_line%num_words /= 3 .and. config_line%num_words /= 5) then
               write(errmsg,'("Invalid format for density parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_output_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, density_num_bins)
            call MW_configuration_line_get_word(config_line, 3, density)
            if (config_line%num_words == 5) then
               density_limits = .true.
               call MW_configuration_line_get_word(config_line, 4, density_min)
               call MW_configuration_line_get_word(config_line, 5, density_max)
            end if

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)

      end do keywordLoop

      ! Set default value if not defined
      if (trajectories_defined == 0) trajectories = default
      call MW_output_trajectories_set_dump_frequency(system%output, trajectories)

      if (xyz_defined == 0) xyz = default
      call MW_output_xyz_set_dump_frequency(system%output, xyz)

      if (pdb_defined == 0) pdb = default
      call MW_output_pdb_set_dump_frequency(system%output, pdb)

      if (lammps_defined == 0) lammps = default
      call MW_output_lammps_set_dump_frequency(system%output, lammps)

      if (charges_defined == 0) charges = default
      call MW_output_charges_set_dump_frequency(system%output, charges)

      if (total_charges_defined == 0) total_charges = default
      call MW_output_total_charges_set_dump_frequency(system%output, total_charges)

      if (forces_defined == 0) forces = default
      call MW_output_forces_set_dump_frequency(system%output, forces)

      if (elec_forces_defined == 0) elec_forces = default
      call MW_output_elec_forces_set_dump_frequency(system%output, elec_forces)

      if (dipoles_defined == 0) dipoles = default
      call MW_output_dipoles_set_dump_frequency(system%output, dipoles)

      if (efg_defined == 0) efg = default
      call MW_output_efg_set_dump_frequency(system%output, efg)

      if (radius_defined == 0) radius = default
      call MW_output_radius_set_dump_frequency(system%output, radius)

      if (potential_shift_defined == 0) potential_shift = default
      call MW_output_potential_shift_set_dump_frequency(system%output, potential_shift)

      if (energies_defined == 0) energies = default
      call MW_output_energies_set_dump_frequency(system%output, energies)

      if (restart_defined == 0) restart = default
      call MW_output_restart_set_dump_frequency(system%output, restart)

      if (temperature_defined == 0) temperature = default
      call MW_output_temperature_set_dump_frequency(system%output, temperature)

      if (pressure_defined == 0) pressure = default
      call MW_output_pressure_set_dump_frequency(system%output, pressure)

      if (stress_tensor_defined == 0) stress_tensor = default
      call MW_output_stress_tensor_set_dump_frequency(system%output, stress_tensor)

      if (box_defined == 0) box = default
      call MW_output_box_set_dump_frequency(system%output, box)

      if (step_defined == 0) step = default
      call MW_output_step_set_dump_frequency(system%output, step)

      if (polarization_defined == 0) polarization = default
      call MW_output_polarization_set_dump_frequency(system%output, polarization)

      if (density_defined == 0) density = default
      call MW_output_diagnostic_set_dump_frequency(system%output, density)
      call MW_diagnostic_set_num_bins(system%diagnostic, density_num_bins, density_limits, density_min, density_max)

      ! Compute and store unwrapped ion coordinates if requested
      if ((system%trajectories_unwrapped == 1) .or. &
          (system%xyz_unwrapped == 1)          .or. &
          (system%pdb_unwrapped == 1)          .or. &
          (system%lammps_unwrapped) == 1) then
         system%store_xyz_ions_unwrapped = .true.
      end if

   end subroutine read_output_parameters

   ! ================================================================================
   ! Read external field parameters
   !
   ! external_field *block*
   !   type *string*
   !   direction *real* *real* *real*
   !   amplitude *real*
   subroutine read_external_field_parameters(field, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_external_field, only: MW_external_field_t, &
            MW_external_field_define_type => define_type, &
            MW_external_field_void_type => void_type

      implicit none
      ! Parameters
      ! ----------
      type(MW_external_field_t), intent(inout) :: field
      integer, intent(in) :: funit !< configuration file unit
      integer, intent(inout) :: line_num !< line number in configuration file

      ! Local
      ! -----
      real(wp) :: amplitude
      real(wp),dimension(3) :: direction
      character(max_word_length) :: field_type
      character(256) :: errmsg
      character(max_word_length) :: keyword
      type(MW_configuration_line_t) :: config_line
      integer :: field_type_defined, field_direction_defined, field_amplitude_defined

      ! Set default values
      field_type = "E"
      direction(:) = 0.0_wp
      amplitude = 0.0_wp

      ! Flag for each section definition
      field_type_defined = 0
      field_direction_defined = 0
      field_amplitude_defined = 0

      call MW_external_field_void_type(field)


      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("type")
            if (field_type_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |field type|. First definition at line ",i4,".")') &
                     line_num, field_type_defined
               call MW_errors_runtime_error("read_external_field_parameters", "configuration.f90", errmsg)
            end if
            field_type_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for field type parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_external_field_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, field_type)


         case("direction")
            if (field_direction_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |field direction|. First definition at line ",i4,".")') &
                     line_num, field_direction_defined
               call MW_errors_runtime_error("read_external_field_parameters", "configuration.f90", errmsg)
            end if
            field_direction_defined = line_num

            ! Read direction parameters
            if (config_line%num_words /= 4) then
               write(errmsg,'("Invalid format for field direction parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_external_field_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, direction(1))
            call MW_configuration_line_get_word(config_line, 3, direction(2))
            call MW_configuration_line_get_word(config_line, 4, direction(3))


         case("amplitude")
            if (field_amplitude_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |field amplitude|. First definition at line ",i4,".")') &
                     line_num, field_amplitude_defined
               call MW_errors_runtime_error("read_external_field_parameters", "configuration.f90", errmsg)
            end if
            field_amplitude_defined = line_num

            ! Read amplitude parameter
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for field amplitude parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_external_field_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, amplitude)


         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop
         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      call MW_external_field_define_type(field, field_type, amplitude, direction)

   end subroutine read_external_field_parameters

   ! ================================================================================

   ! Check whether we are using charge neutrality
   subroutine check_charge_neutrality(system, algorithms)
      use MW_algorithms, only: MW_algorithms_t
      implicit none
      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(in) :: algorithms

      system%electrode_charge_neutrality=.false.
      if (algorithms%maze%calc_elec) then
         system%electrode_charge_neutrality=algorithms%maze%charge_neutrality
      else if (algorithms%matrix_inversion%calc_elec) then
         system%electrode_charge_neutrality=algorithms%matrix_inversion%charge_neutrality
      else if (algorithms%cg%charge_neutrality) then
         system%electrode_charge_neutrality=algorithms%cg%charge_neutrality
      end if

   end subroutine check_charge_neutrality

end module MW_configuration

!> Module used to store algorithm parameters
module MW_algorithms
   use MW_cg, only: MW_cg_t
   use MW_cgaim, only: MW_cgaim_t
   use MW_maze, only: MW_maze_t
   use MW_matrix_inversion, only: MW_matrix_inversion_t
   implicit none
   private

   ! Public type
   public :: MW_algorithms_t

   ! Public subroutine
   public :: void_type
   public :: print_type
   public :: print_statistics

   type MW_algorithms_t
      ! Electrode charge computation algorithms
      ! ---------------------------------------
      type(MW_cg_t) :: cg                                !< CG algorithm parameters
      type(MW_cgaim_t) :: cgaim                          !< CG algorithm parameters
      type(MW_maze_t) :: maze                      !< Massless SHAKE algorithm parameters
      type(MW_matrix_inversion_t) :: matrix_inversion    !< Matrix Inversion
      logical :: constant_charge                         !< T if no constant potential
   end type MW_algorithms_t

contains

   ! ================================================================================
   ! Void algorithms parameters
   subroutine void_type(this)
      use MW_cg, only: MW_cg_void_type => void_type
      use MW_cgaim, only: MW_cgaim_void_type => void_type
      use MW_maze, only: MW_maze_void_type => void_type
      use MW_matrix_inversion, only: MW_matrix_inversion_void_type => void_type
      implicit none
      ! Parameter
      ! ---------
      type(MW_algorithms_t), intent(inout) :: this

      ! CG parameters
      call MW_cg_void_type(this%cg)
      call MW_cgaim_void_type(this%cgaim)
      call MW_maze_void_type(this%maze)
      call MW_matrix_inversion_void_type(this%matrix_inversion)
      this%constant_charge = .false.

   end subroutine void_type

   !================================================================================
   ! Print algorithm parameters
   subroutine print_type(this, ounit, system)
      use MW_cg, only: MW_cg_print_type => print_type
      use MW_cgaim, only: MW_cgaim_print_type => print_type
      use MW_maze, only: MW_maze_print_type => print_type
      use MW_matrix_inversion, only: MW_matrix_inversion_print_type => print_type
      use MW_system, only: MW_system_t

      implicit none
      ! Parameter
      ! ---------
      type(MW_algorithms_t), intent(in) :: this
      type(MW_system_t), intent(in) :: system
      integer, intent(in) :: ounit

      write(ounit, *)
      write(ounit, '("Algorithms parameters:")')
      write(ounit, '("======================")')

      if (system%pimrun.and.system%elecrun) then
         write(ounit, '("Dipoles and Electrode Charges parameters:")')
         write(ounit, '("----------------------")')
         if (this%constant_charge) then
            write(ounit, '("constant charges on electrodes")')
         end if
         if (this%maze%calc_dip.and.this%maze%calc_elec) then
            write(ounit, '("maze")')
            write(ounit, '("-------")')
            call MW_maze_print_type(this%maze, ounit)
         else if (this%matrix_inversion%calc_dip.and.this%matrix_inversion%calc_elec) then
            write(ounit, '("matrix_inversion")')
            write(ounit, '("----------------")')
            call MW_matrix_inversion_print_type(this%matrix_inversion, ounit)
         else
            write(ounit, '("cg")')
            write(ounit, '("--")')
            call MW_cg_print_type(this%cg, ounit)
         end if
         write(ounit,*)
         if (system%aimrun) then
            write(ounit, '("Ion radius parameters:")')
            write(ounit, '("----------------------")')
            write(ounit, '("cgaim")')
            write(ounit, '("-----")')
            call MW_cgaim_print_type(this%cgaim, ounit)
            write(ounit,*)
         end if
      else if (system%pimrun) then
         write(ounit, '("Dipoles parameters:")')
         write(ounit, '("----------------------")')
         if (this%maze%calc_dip) then
            write(ounit, '("maze")')
            write(ounit, '("-------")')
            call MW_maze_print_type(this%maze, ounit)
         else if (this%matrix_inversion%calc_dip) then
            write(ounit, '("matrix_inversion")')
            write(ounit, '("----------------")')
            call MW_matrix_inversion_print_type(this%matrix_inversion, ounit)
         else
            write(ounit, '("cg")')
            write(ounit, '("--")')
            call MW_cg_print_type(this%cg, ounit)
         end if
         write(ounit,*)
            if (system%aimrun) then
            write(ounit, '("Ion radius parameters:")')
            write(ounit, '("----------------------")')
            write(ounit, '("cgaim")')
            write(ounit, '("-----")')
            call MW_cgaim_print_type(this%cgaim, ounit)
            write(ounit,*)
         end if
      else if (system%elecrun) then
         write(ounit, '("Electrodes parameters:")')
         write(ounit, '("----------------------")')
         if (this%constant_charge) then
            write(ounit, '("constant charge")')
         else
            if (this%maze%calc_elec) then
               write(ounit, '("maze")')
               write(ounit, '("-------")')
               call MW_maze_print_type(this%maze, ounit)
            else if (this%matrix_inversion%calc_elec) then
               write(ounit, '("matrix_inversion")')
               write(ounit, '("----------------")')
               call MW_matrix_inversion_print_type(this%matrix_inversion, ounit)
            else
               write(ounit, '("cg")')
               write(ounit, '("-------")')
               call MW_cg_print_type(this%cg, ounit)
            end if
         end if
         write(ounit,*)
      end if

   end subroutine print_type

   !================================================================================
   ! Print algorithm statistics
   subroutine print_statistics(this, ounit, do_output, system)
      use MW_cg, only: MW_cg_print_statistics => print_statistics
      use MW_cgaim, only: MW_cgaim_print_statistics => print_statistics
      use MW_maze, only: MW_maze_print_statistics => print_statistics
      use MW_matrix_inversion, only: MW_matrix_inversion_print_statistics => print_statistics
      use MW_timers, only: TIMER_DIAG_IO, MW_timers_start, MW_timers_stop
      use MW_system, only: MW_system_t

      implicit none
      ! Parameter
      ! ---------
      type(MW_algorithms_t), intent(in) :: this
      type(MW_system_t), intent(in) :: system
      integer, intent(in) :: ounit
      logical, intent(in) :: do_output !< flag if the local process performs output
      call MW_timers_start(TIMER_DIAG_IO)

      if (do_output) then
         if (system%pimrun.and.system%elecrun) then
            if (this%maze%calc_dip.and.this%maze%calc_elec) then
               call MW_maze_print_statistics(this%maze, ounit)
            else if (this%matrix_inversion%calc_dip.and.this%matrix_inversion%calc_elec) then
               call MW_matrix_inversion_print_statistics(this%matrix_inversion, ounit)
            else
               call MW_cg_print_statistics(this%cg, ounit)
            end if
            if (system%aimrun) then
               call MW_cgaim_print_statistics(this%cgaim, ounit)
            end if
         else if (system%pimrun) then
            if (this%maze%calc_dip) then
               call MW_maze_print_statistics(this%maze, ounit)
            else if (this%matrix_inversion%calc_dip) then
               call MW_matrix_inversion_print_statistics(this%matrix_inversion, ounit)
            else
               call MW_cg_print_statistics(this%cg, ounit)
            end if
            if (system%aimrun) then
               call MW_cgaim_print_statistics(this%cgaim, ounit)
            end if
         else if (system%elecrun) then
            if (.not. this%constant_charge) then
               if (this%maze%calc_elec) then
                  call MW_maze_print_statistics(this%maze, ounit)
               else if (this%matrix_inversion%calc_elec) then
                  call MW_matrix_inversion_print_statistics(this%matrix_inversion, ounit)
               else
                  call MW_cg_print_statistics(this%cg, ounit)
               end if
            end if
         end if

      end if

      call MW_timers_stop(TIMER_DIAG_IO)
   end subroutine print_statistics

end module MW_algorithms

module MW_diagnostic
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   use MW_errors, only: &
         MW_errors_allocate_error => allocate_error, &
         MW_errors_deallocate_error => deallocate_error, &
         MW_errors_open_error => open_error
   use MW_ion, only: MW_ion_t
   use MW_electrode, only: MW_electrode_t
   use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
   implicit none
   private

   ! Public Type
   public :: MW_diagnostic_t

   ! Public subroutines
   public :: set_num_bins
   public :: define_type
   public :: void_type
   public :: compute_density

   type MW_diagnostic_t
      ! Density profile along z-axis
      integer :: num_density_samples = 0     !< number of times the density are sampled
      integer :: num_types = 0       !< number of species types
      integer :: num_bins = 0        !< number of bins
      real(wp) :: bin_width = 0.0_wp !< width of a bin
      real(wp) :: zmin = 0.0_wp !< minimum of density profile
      real(wp) :: zmax = 0.0_wp !< maximum of density profile
      real(wp), allocatable :: number_density(:,:) !< number density histogram
      real(wp), allocatable :: charge_density(:,:) !< charge density histogram

   end type MW_diagnostic_t

contains

   subroutine set_num_bins(this, num_bins, limits, zmin, zmax)
      implicit none
      ! Parameters
      ! ----------
      type(MW_diagnostic_t), intent(inout) :: this
      integer, intent(in) :: num_bins              !< number of bins
      real(wp), intent(in) :: zmin, zmax
      logical, intent(in) :: limits
      this%num_bins = num_bins
      if (limits) then
         this%zmin = zmin
         this%zmax = zmax
      end if
   end subroutine set_num_bins

   ! --------------------------------------------------------------------------------
   ! Define data type
   subroutine define_type(this, num_types, z_width)
      implicit none
      ! Parameters
      ! ----------
      type(MW_diagnostic_t), intent(inout) :: this
      integer, intent(in) :: num_types             !< number of species types
      real(wp), intent(in) :: z_width            !< width of a bin

      ! Local
      ! -----
      integer :: ierr
      integer :: num_bins

      num_bins = this%num_bins

      ! 1st dimension starts at 0 to store total sum
      allocate(this%number_density(0:num_types, num_bins), &
            this%charge_density(0:num_types, num_bins), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("allocate_arrays", "diagnostic.f90", ierr)
      end if

      if (this%zmin == 0.0_wp .and. this%zmax == 0.0_wp) then
         this%zmin = 0.0_wp
         this%zmax = z_width
      end if

      this%number_density(:,:) = 0.0_wp
      this%charge_density(:,:) = 0.0_wp
      this%num_bins = num_bins
      this%num_types = num_types
      this%bin_width = (this%zmax - this%zmin) / num_bins
      this%num_density_samples = 0

   end subroutine define_type

   ! --------------------------------------------------------------------------------
   ! Void data type
   subroutine void_type(this)
      implicit none
      ! Parameters
      ! ----------
      type(MW_diagnostic_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      if (allocated(this%number_density)) then
         deallocate(this%number_density, stat=ierr)
         if (ierr /= 0) call MW_errors_deallocate_error("void_type", "diagnostics.f90", ierr)
      end if

      if (allocated(this%charge_density)) then
         deallocate(this%charge_density, stat=ierr)
         if (ierr /= 0) call MW_errors_deallocate_error("void_type", "diagnostics.f90", ierr)
      end if
      this%num_bins = 0
      this%num_types = 0
      this%bin_width = 0.0_wp
      this%zmin = 0.0_wp
      this%zmax = 0.0_wp
      this%num_density_samples = 0

   end subroutine void_type

   ! --------------------------------------------------------------------------------
   ! Compute number and charge density
   subroutine compute_density(this, ions, electrodes, z_ions, z_elec, q_elec)
      implicit none
      ! Parameters
      ! ----------
      type(MW_diagnostic_t), intent(inout) :: this
      type(MW_ion_t), intent(in) :: ions(:)
      type(MW_electrode_t), intent(in) :: electrodes(:)
      real(wp), intent(in) :: z_ions(:)
      real(wp), intent(in) :: z_elec(:)
      real(wp), intent(in) :: q_elec(:)

      ! Local
      ! -----
      integer :: itype, iion, i, offset, ibin
      integer :: num_ion_types, num_elec_types

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)
      do itype = 1, num_ion_types
         offset = ions(itype)%offset
         do iion = 1, ions(itype)%count
            i = iion + offset
            ibin = floor((z_ions(i) - this%zmin) / this%bin_width) + 1
            ibin = min(ibin, this%num_bins)
            ibin = max(ibin, 1)
            this%number_density(0, ibin) = this%number_density(0, ibin) + 1.0_wp
            this%number_density(itype, ibin) = this%number_density(itype, ibin) + 1.0_wp
            this%charge_density(0, ibin) = this%charge_density(0, ibin) + ions(itype)%charge
            this%charge_density(itype, ibin) = this%charge_density(itype, ibin) + ions(itype)%charge
         end do
      end do

      do itype = 1, num_elec_types
         offset = electrodes(itype)%offset
         do iion = 1, electrodes(itype)%count
            i = iion + offset
            ibin = floor((z_elec(i) - this%zmin) / this%bin_width) + 1
            ibin = min(ibin, this%num_bins)
            ibin = max(ibin, 1)
            this%number_density(0, ibin) = this%number_density(0, ibin) + 1.0_wp
            this%number_density(num_ion_types+itype, ibin) = this%number_density(num_ion_types+itype, ibin) + 1.0_wp
            this%charge_density(0, ibin) = this%charge_density(0, ibin) + q_elec(i)
            this%charge_density(num_ion_types+itype, ibin) = this%charge_density(num_ion_types+itype, ibin) + q_elec(i)
         end do
      end do

      this%num_density_samples = this%num_density_samples + 1
   end subroutine compute_density

end module MW_diagnostic

module MW_tools

implicit none
   private

   ! public subroutines
   public :: start_parallel
   public :: start_parallel_python
   public :: parse_command_line
   public :: initialize_output
   public :: read_input_files
   public :: initialize
   public :: setup
   public :: run_step
   public :: step_setup
   public :: step_compute_forces
   public :: step_update_output
   public :: finalize
   public :: finalize_parallel
   public :: compute_lj_energy
   public :: compute_ft_energy
   public :: compute_xft_energy
   public :: modify_charge
   public :: get_electrode_mass
   public :: set_electrode_mass
   public :: sum_electrode_forces

contains

   !================================================================================
   subroutine initialize(system, parallel, algorithms, do_output)
      use MW_parallel, only: MW_parallel_t
      use MW_timers
      use MW_stdio, only: MW_stdout
      use MW_command, only: MW_command_t, ARGUMENT_VALUE_LEN
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_print_type => print_type
      use MW_system, only: MW_system_t, &
            MW_system_print_type => print_type, &
            MW_system_output_setup => output_setup, &
            MW_system_distribute_work => distribute_work, &
            MW_system_setup_sr_interaction => setup_sr_interaction, &
            MW_system_setup_num_dof => setup_num_dof, &
            MW_system_setup_velocities => setup_velocities, &
            MW_system_setup_polarization => setup_polarization
      use MW_four_site_model, only: &
            MW_four_site_model_compute_fourth_site_position => compute_fourth_site_position

      implicit none

      type(MW_parallel_t), intent(inout)   :: parallel
      type(MW_system_t), intent(inout)     :: system
      type(MW_algorithms_t), intent(inout) :: algorithms
      logical, intent(out)                 :: do_output

      ! Local
      type(MW_command_t)            :: parser
      character(ARGUMENT_VALUE_LEN) :: configfile
      character(ARGUMENT_VALUE_LEN) :: datafile
      integer                       :: funit
      logical                       :: output_rank

!      call start_parallel(parallel)
      call MW_timers_initialize()
      call MW_timers_start(TIMER_TOTAL)
      call MW_timers_start(TIMER_INITIALIZATION)
      call parse_command_line(parser, configfile, datafile)
      call initialize_output(funit, parser, parallel, do_output, output_rank)
      call read_input_files(system, algorithms, configfile, datafile)
      call MW_system_distribute_work(system, parallel) ! Distribute computation across parallel processes
      call MW_four_site_model_compute_fourth_site_position(system%num_pbc, &
            system%molecules, system%xyz_ions(:,:,system%xyz_ions_step(1)), &
            system%box, system%ions)
      call MW_system_setup_sr_interaction(system)
      call MW_system_setup_num_dof(system)
      call MW_system_setup_velocities(system)
      call MW_system_setup_polarization(system)


      ! Print system parameters
      if (do_output) then
         call MW_system_print_type(system, MW_stdout)
         call MW_algorithms_print_type(algorithms, MW_stdout, system)
         flush(MW_stdout)
      end if

      ! Setup output files
      if (do_output) then
         if (output_rank) then
            call MW_system_output_setup(system, parallel%comm_rank)
         else
            call MW_system_output_setup(system)
         end if
      end if

      call MW_timers_stop(TIMER_INITIALIZATION)

      ! Initialize data on GPU
      !$acc enter data &
      !$acc copyin(system, system%q_atoms(:,:), system%q_atoms_step(:), system%electrodes(:), system%ions(:), &
      !$acc        system%xyz_atoms(:,:), system%xyz_ions(:,:,:), system%dipoles_ions(:,:,:), &
      !$acc        system%deltas_ions(:,:), system%epsilons_ions(:,:,:), &
      !$acc        system%ewald, system%ewald%zpoint(:), system%ewald%zweight(:), &
      !$acc        system%localwork, system%localwork%molecules_istart(:), system%localwork%molecules_iend(:), &
      !$acc        system%localwork%count_atoms(:), system%localwork%offset_atoms(:), &
      !$acc        algorithms, algorithms%cg, algorithms%matrix_inversion, &
      !$acc        system%thermostat, system%thermostat%v_zeta(:,:)) &
      !$acc create(system%ewald%Sk_cos(:), system%ewald%Sk_sin(:), &
      !$acc        system%ewald%cos_kx_ions(:,0:), system%ewald%sin_kx_ions(:,0:), &
      !$acc        system%ewald%cos_ky_ions(:,0:), system%ewald%sin_ky_ions(:,0:), &
      !$acc        system%ewald%cos_kz_ions(:,0:), system%ewald%sin_kz_ions(:,0:), &
      !$acc        system%ewald%cos_kx_elec(:,0:), system%ewald%sin_kx_elec(:,0:), &
      !$acc        system%ewald%cos_ky_elec(:,0:), system%ewald%sin_ky_elec(:,0:), &
      !$acc        system%ewald%cos_kz_elec(:,0:), system%ewald%sin_kz_elec(:,0:), &
      !$acc        system%coulomb_potential_atoms(:,:), system%forces_ions(:,:,:), &
      !$acc        system%coulomb_forces_ions(:,:,:), system%intermolecular_forces_ions(:,:,:), &
      !$acc        system%intramolecular_forces_ions(:,:,:), system%lj_forces_ions(:,:,:), &
      !$acc        system%ft_forces_ions(:,:,:), system%xft_forces_ions(:,:,:), &
      !$acc        system%daim_forces_ions(:,:,:), system%steele_forces_ions(:), &
      !$acc        system%external_field_forces_ions(:,:,:),  &
      !$acc        system%stress_tensor(:,:), &
      !$acc        system%coulomb_stress_tensor(:,:,:), system%lj_stress_tensor(:,:,:), &      
      !$acc        system%ft_stress_tensor(:,:,:), system%xft_stress_tensor(:,:,:), &      
      !$acc        system%daim_stress_tensor(:,:,:), system%intramolecular_stress_tensor(:,:,:), &      
      !$acc        system%steele_stress_tensor(:,:), &      
      !$acc        algorithms%cg%b(:), algorithms%cg%res(:), algorithms%cg%p(:), &
      !$acc        algorithms%cg%Ad(:), &
      !$acc        algorithms%matrix_inversion%b(:),algorithms%matrix_inversion%A(:,:), &
      !$acc        algorithms%matrix_inversion%Ainv(:,:),algorithms%matrix_inversion%Ax(:), &
      !$acc        algorithms%matrix_inversion%q0(:))
! Manque d et pour cg ?     

   end subroutine initialize

   !================================================================================
   ! Initialization
   ! --------------
   subroutine start_parallel_python(parallel, comm)
      use MW_parallel, only: MW_parallel_t, MW_COMM_WORLD, &
            MW_parallel_initialize_python => initialize_python, &
            MW_parallel_define_type => define_type

      implicit none

      type(MW_parallel_t), intent(inout) :: parallel
      integer, intent(in) :: comm

      call MW_parallel_initialize_python(comm)
      call MW_parallel_define_type(parallel, MW_COMM_WORLD)

   end subroutine start_parallel_python
   !================================================================================
   ! Initialization
   ! --------------
   subroutine start_parallel(parallel)
      use MW_parallel, only: MW_parallel_t, MW_COMM_WORLD, &
            MW_parallel_initialize => initialize, &
            MW_parallel_define_type => define_type

      implicit none

      type(MW_parallel_t), intent(inout) :: parallel

      call MW_parallel_initialize()
      call MW_parallel_define_type(parallel, MW_COMM_WORLD)

   end subroutine start_parallel

   !================================================================================
   ! Parse command line
   ! ------------------
   subroutine parse_command_line(parser, configfile, datafile)
      use MW_command, only: MW_command_t, ARGUMENT_VALUE_LEN, &
            MW_command_setup_parser => setup_parser, &
            MW_command_parse => parse, &
            MW_command_get_option => get_option
      use MW_parallel, only: MW_parallel_finalize => finalize
      use MW_stdio, only: MW_stdout
      use MW_version

      type(MW_command_t), intent(inout) :: parser
      character(ARGUMENT_VALUE_LEN), intent(out) :: configfile
      character(ARGUMENT_VALUE_LEN), intent(out) :: datafile

      ! Local
      logical :: print_help, print_version

      call MW_command_setup_parser(parser)
      call MW_command_parse(parser)

      call MW_command_get_option(parser, "help", print_help)
      if (print_help) then
         call parser%show_help(MW_stdout)
         call MW_parallel_finalize()
         stop
      end if

      call MW_command_get_option(parser, "version", print_version)
      if (print_version) then
         call MW_version_print(MW_stdout)
         call MW_parallel_finalize()
         stop
      end if

      call MW_command_get_option(parser, "input", configfile)
      call MW_command_get_option(parser, "data", datafile)

   end subroutine parse_command_line

   !================================================================================
   subroutine initialize_output(funit, parser, parallel, do_output, output_rank)
      use MW_command, only: MW_command_t, ARGUMENT_VALUE_LEN, &
            MW_command_get_option => get_option
      use MW_parallel, only: MW_parallel_t, &
            MW_parallel_print_type => print_type
      use MW_fileunit, only: &
            MW_fileunit_get_new_unit => get_new_unit
      use MW_stdio, only: MW_stdout, &
            MW_stdio_set_stdout => set_stdout
      use MW_errors, only: &
            MW_errors_open_error => open_error
      use MW_version
      use MW_banner

      implicit none

      type(MW_parallel_t), intent(inout) :: parallel
      type(MW_command_t), intent(inout) :: parser
      integer, intent(out) :: funit
      logical, intent(out) :: do_output, output_rank

      ! Local
      character(ARGUMENT_VALUE_LEN) :: outputfile
      character(ARGUMENT_VALUE_LEN) :: outputrank
      integer :: irank_start, icomma, rank_id
      integer :: ierr

      ! Setup do_output flag for ranks which will output something
      do_output = .false.
      output_rank = .false.
      outputfile = ""
      call MW_command_get_option(parser, "output-rank", outputrank)
      select case(outputrank)
      case("root")
         ! Only rank 0 does output
         if (parallel%comm_rank == 0) do_output = .true.
         output_rank = .false.
      case("all")
         ! All ranks do output
         do_output = .true.
         output_rank = .true.
      case default
         ! Comma separated list of ranks
         irank_start = 1
         icomma = index(outputrank, ",")
         do while (icomma > 0)
            read(outputrank(irank_start:irank_start+icomma-2),*) rank_id
            if (parallel%comm_rank == rank_id) do_output = .true.
            irank_start = irank_start + icomma
            icomma = index(outputrank(irank_start:), ",")
         end do
         if (len_trim(outputrank(irank_start:)) > 0) then
            read(outputrank(irank_start:),*) rank_id
            if (parallel%comm_rank == rank_id) do_output = .true.
         end if
         output_rank = .true.
      end select

      if (do_output) then
         if (output_rank) then
            write(outputfile, '("run_",i6.6,".out")') parallel%comm_rank
         else
            outputfile = "run.out"
         end if
         call MW_fileunit_get_new_unit(funit)
         open(unit=funit, file=outputfile, access="SEQUENTIAL", action="WRITE", &
               position="REWIND", form="FORMATTED", status="REPLACE", &
               iostat=ierr)
         if (ierr /= 0) then
            call MW_errors_open_error("main", "main.f90", outputfile, ierr)
         end if
         call MW_stdio_set_stdout(funit)
      end if

      if (do_output) then
         call MW_banner_print(MW_stdout)
         call MW_version_print(MW_stdout)
         call MW_parallel_print_type(parallel, MW_stdout)
         flush(MW_stdout)
      end if

   end subroutine initialize_output

   !================================================================================
   subroutine read_input_files(system, algorithms, configfile, datafile)
      use MW_command, only: MW_command_t, ARGUMENT_VALUE_LEN
      use MW_algorithms, only: MW_algorithms_t
      use MW_configuration, only: &
            MW_configuration_read_system_parameters => read_system_parameters
      use MW_system, only: MW_system_t, &
            MW_system_read_data => read_data

      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms
      character(ARGUMENT_VALUE_LEN), intent(in) :: configfile
      character(ARGUMENT_VALUE_LEN), intent(in) :: datafile

      integer :: i, itype

      call MW_configuration_read_system_parameters(system, algorithms, configfile)
      call MW_system_read_data(system, datafile)

      if (algorithms%constant_charge) then
         do itype = 1, system%num_elec
            !$acc loop
            do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
               system%q_atoms(i, system%q_atoms_step(2)) = system%q_atoms(i, system%q_atoms_step(1))
            end do
            !$acc end loop
         end do
      end if

   end subroutine read_input_files

   !================================================================================
   subroutine setup(system, parallel, algorithms, do_output, step_output_frequency)
      use MW_timers
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_print_statistics => print_statistics
      use MW_parallel, only: MW_parallel_t
      use MW_stdio, only: MW_stdout
      use MW_system, only: MW_system_t, &
            MW_system_print_step => print_step, &
            MW_system_output_dump => output_dump, &
            MW_system_ewald_setup_cossin_ions => ewald_setup_cossin_ions, &
            MW_system_ewald_setup_cossin_elec => ewald_setup_cossin_elec, &
            MW_system_coulomb_melt_efg => coulomb_melt_efg, &
            MW_system_setup_thermostats_barostats_constraints => setup_thermostats_barostats_constraints, &
            MW_system_ions_forces_compute => ions_forces_compute
      use MW_maze, only: &
            MW_maze_setup_history => setup_history, &
            MW_maze_solve_invert => solve_invert
      use MW_electrode_charge, only: &
            MW_electrode_charge_compute_jacobi_precond => compute_jacobi_precond, &
            MW_electrode_charge_compute => compute
      use MW_dipoles_and_electrodes, only: &
            MW_dipoles_and_electrodes_compute_jacobi_precond => compute_jacobi_precond, &
            MW_dipoles_and_electrodes_compute => compute
      use MW_ions_dipoles, only: &
         MW_ions_dipoles_compute_jacobi_precond => compute_jacobi_precond, &
         MW_ions_dipoles_compute => compute
      use MW_ions_radius, only: &
            MW_ions_radius_compute => compute

#ifdef MW_USE_PLUMED
      use MW_plumed, only : MW_plumed_init => init
#endif

      type(MW_system_t), intent(inout) :: system
      type(MW_parallel_t), intent(inout) :: parallel
      type(MW_algorithms_t), intent(inout) :: algorithms
      integer, intent(out) :: step_output_frequency
      logical, intent(in) :: do_output

      integer :: istep=0

      call MW_timers_start(TIMER_SETUP)
#ifdef MW_USE_PLUMED
      if (system%plumedlog) then
         call MW_plumed_init(system%temperature, system%plumed_file, system%num_ions, &
               system%num_atoms, system%num_ion_types, system%dt, system%ions)
     end if
#endif
      ! pre-compute ewald cos/sin factors
      call MW_system_ewald_setup_cossin_ions(system)
      call MW_system_ewald_setup_cossin_elec(system, istep)

      if (system%pimrun.and.system%elecrun) then ! compute initial dipoles and wall charges
         if (algorithms%maze%calc_dip.and.algorithms%maze%calc_elec) then
            call MW_maze_setup_history(algorithms%maze)
         else
            if (algorithms%cg%preconditioned) then
               call MW_dipoles_and_electrodes_compute_jacobi_precond(system, algorithms)
            end if
            call MW_dipoles_and_electrodes_compute(system, algorithms)
         end if
      else if (system%pimrun) then ! compute initial dipoles

         call MW_timers_start(TIMER_MINMU)
         if (algorithms%maze%calc_dip) then
            call MW_maze_setup_history(algorithms%maze)
            call MW_ions_dipoles_compute(system, algorithms)
         else if (algorithms%matrix_inversion%calc_dip) then
            call MW_ions_dipoles_compute(system, algorithms)
         else
            if (algorithms%cg%preconditioned) then
               call MW_ions_dipoles_compute_jacobi_precond(system, algorithms)
            end if
            call MW_ions_dipoles_compute(system, algorithms)
         end if
         call MW_timers_stop(TIMER_MINMU)

         ! compute initial radius
         if (system%aimrun) then
            call MW_timers_start(TIMER_MINAIM)
            call MW_ions_radius_compute(system, algorithms)
            call MW_timers_stop(TIMER_MINAIM)
         end if
      else if (system%elecrun) then ! compute initial wall charges
         call MW_timers_start(TIMER_MINQ)
         if (algorithms%maze%calc_elec) then
            if (.not.algorithms%maze%CG_nostore) call MW_maze_setup_history(algorithms%maze) !Only sets up history for gradient of constraints
            call MW_electrode_charge_compute(system, algorithms)
         else if (algorithms%matrix_inversion%calc_elec) then
            call MW_electrode_charge_compute(system, algorithms)
         else
            if (algorithms%cg%preconditioned) then
               call MW_electrode_charge_compute_jacobi_precond(system, algorithms)
            end if
            call MW_electrode_charge_compute(system, algorithms)
         end if
         call MW_timers_stop(TIMER_MINQ)
      end if

      ! compute efg
      if (system%efgrun) then
         call MW_system_coulomb_melt_efg(system, system%step)
      end if

      ! compute forces
      call MW_system_ions_forces_compute(system, istep)

      call MW_system_setup_thermostats_barostats_constraints(system)

      call MW_system_print_step(system, istep, MW_stdout, do_output)
      call MW_algorithms_print_statistics(algorithms, MW_stdout, do_output, system)
      call MW_system_output_dump(system, istep, do_output)
      !if (do_output) flush(MW_stdout)

      step_output_frequency = system%output%step_dump_frequency
      call MW_timers_stop(TIMER_SETUP)

   end subroutine setup

   !================================================================================

   subroutine run_step(system, parallel, algorithms, istep, num_steps, do_output, step_output_frequency, pre, post)
      use MW_timers
      use MW_stdio, only: MW_stdout
      use MW_algorithms, only: MW_algorithms_t
      use MW_parallel, only: MW_parallel_t
      use MW_system, only: MW_system_t

      type(MW_system_t), intent(inout) :: system
      type(MW_parallel_t), intent(inout) :: parallel
      type(MW_algorithms_t), intent(inout) :: algorithms
      integer, intent(in) :: step_output_frequency
      logical, intent(in) :: do_output
      integer, intent(in) :: num_steps
      logical, intent(in) :: pre, post
      integer, intent(inout) :: istep

      integer :: step

      if (pre) then
         call MW_timers_start(TIMER_MAIN_LOOP)
      end if

      do step = istep+1, istep+num_steps
         call step_setup(system, algorithms, parallel, step)
         call step_compute_forces(system, parallel, step)
         call step_update_output(system, algorithms, step, do_output, step_output_frequency)
      end do

      if (post) then
         call MW_timers_stop(TIMER_MAIN_LOOP)
         call MW_timers_stop(TIMER_TOTAL)

         if (do_output) then
            call MW_timers_print(MW_stdout)
            !flush(MW_stdout)
         end if
      end if

   end subroutine run_step

   !================================================================================

   subroutine step_setup(system, algorithms, parallel, step)
      use MW_timers
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_print_statistics => print_statistics
      use MW_system, only: MW_system_t, &
            MW_system_ewald_setup_cossin_ions => ewald_setup_cossin_ions, &
            MW_system_ewald_setup_cossin_elec => ewald_setup_cossin_elec, &
            MW_system_coulomb_melt_efg => coulomb_melt_efg, &
            MW_system_update_history => update_history, &
            MW_system_ions_positions_update => ions_positions_update, &
            MW_system_piston_positions_update => piston_positions_update
      use MW_dipoles_and_electrodes, only: &
            MW_dipoles_and_electrodes_compute => compute
      use MW_parallel, only: MW_parallel_t
      use MW_electrode_charge, only: &
            MW_electrode_charge_compute => compute
      use MW_ions_dipoles, only: &
            MW_ions_dipoles_compute => compute
      use MW_ions_radius, only: &
            MW_ions_radius_compute => compute

      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms
      type(MW_parallel_t), intent(inout) :: parallel
      integer, intent(in) :: step

      call MW_timers_start(TIMER_STEP)
      call MW_system_update_history(system)
      call MW_system_ions_positions_update(system,parallel)
      call MW_system_piston_positions_update(system)
      call MW_system_ewald_setup_cossin_ions(system)
      if (system%pimrun.and.system%elecrun) then
         call MW_dipoles_and_electrodes_compute(system, algorithms)
      else if (system%elecrun) then
         call MW_timers_start(TIMER_MINQ)
         call MW_system_ewald_setup_cossin_elec(system, step)
         call MW_electrode_charge_compute(system, algorithms)
         call MW_timers_stop(TIMER_MINQ)
      else if (system%pimrun) then
         call MW_timers_start(TIMER_MINMU)
         call MW_ions_dipoles_compute(system, algorithms)
         call MW_timers_stop(TIMER_MINMU)
         if (system%aimrun) then
            call MW_timers_start(TIMER_MINAIM)
            call MW_ions_radius_compute(system, algorithms)
            call MW_timers_stop(TIMER_MINAIM)
         end if
      end if
      if (system%efgrun) then
         call MW_system_coulomb_melt_efg(system, step)
      end if


   end subroutine step_setup

   !================================================================================

   subroutine step_compute_forces(system, parallel, step)
      use MW_parallel, only: MW_parallel_t
      use MW_system, only: MW_system_t, &
            MW_system_ions_forces_compute => ions_forces_compute

      type(MW_system_t), intent(inout) :: system
      type(MW_parallel_t), intent(inout) :: parallel
      integer, intent(in) :: step

      call MW_system_ions_forces_compute(system, step)

   end subroutine step_compute_forces

   !================================================================================

   subroutine step_update_output(system, algorithms, step, do_output, step_output_frequency)
      use MW_timers
      use MW_stdio, only: MW_stdout
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_print_statistics => print_statistics
      use MW_system, only: MW_system_t, &
            MW_system_print_step => print_step, &
            MW_system_ions_velocities_update => ions_velocities_update, &
            MW_system_piston_velocities_update => piston_velocities_update, &
            MW_system_output_dump => output_dump, &
            MW_system_compute_diagnostics=> compute_diagnostics

      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms
      integer, intent(in) :: step_output_frequency
      logical, intent(in) :: do_output
      integer, intent(in) :: step

      call MW_system_ions_velocities_update(system, step)
      call MW_system_piston_velocities_update(system)
      call MW_timers_stop(TIMER_STEP)

      if ((step_output_frequency > 0) .and. (mod(step, step_output_frequency) == 0)) then
         call MW_system_print_step(system, step, MW_stdout, do_output)
         if ((system%elecrun).or.system%pimrun.or.system%aimrun) then
            call MW_algorithms_print_statistics(algorithms, MW_stdout, do_output, system)
         end if
      end if

      call MW_system_compute_diagnostics(system)
      call MW_system_output_dump(system, step, do_output)
      !if (do_output) flush(MW_stdout)

   end subroutine step_update_output

   !================================================================================

   subroutine finalize(system, parallel, algorithms)
      use MW_algorithms, only: MW_algorithms_t, &
            MW_algorithms_void_type => void_type
      use MW_parallel, only: MW_parallel_t, &
            MW_parallel_finalize => finalize
      use MW_system, only: MW_system_t, &
            MW_system_deallocate_data_arrays => deallocate_data_arrays, &
            MW_system_void_parameters => void_parameters
      use MW_errors, only: MW_errors_close_error => close_error
      use MW_stdio, only: MW_stdout
#ifdef MW_USE_PLUMED
      use MW_plumed, only : MW_plumed_terminate => terminate
#endif

      type(MW_system_t), intent(inout) :: system
      type(MW_parallel_t), intent(inout) :: parallel
      type(MW_algorithms_t), intent(inout) :: algorithms

      integer :: ierr
      logical :: lopen

#ifdef MW_USE_PLUMED
      if (system%plumedlog) then
         call MW_plumed_terminate()
      end if
#endif
      call MW_algorithms_void_type(algorithms)
      call MW_system_deallocate_data_arrays(system)
      call MW_system_void_parameters(system)

      ! Run.out
      if (MW_stdout > 0) then
         inquire(unit=MW_stdout, opened=lopen)
         if (lopen) then
            close(MW_stdout, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_close_error("MW_system_close", "system.f90", &
                     MW_stdout, ierr)
            end if
         end if
      end if

   end subroutine finalize

   !================================================================================

   subroutine finalize_parallel()
      use MW_parallel, only: MW_parallel_finalize => finalize

      call MW_parallel_finalize()

   end subroutine finalize_parallel

   !================================================================================
   subroutine compute_lj_energy(this, lj, h)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t
      use MW_lennard_jones, only: MW_lennard_jones_t, &
            MW_lennard_jones_energy => energy, &
            MW_lennard_jones_fix_molecule_energy => fix_molecule_energy

      implicit none
      type(MW_system_t), intent(in) :: this
      type(MW_lennard_jones_t), intent(in) :: lj

      real(wp), intent(out) :: h(4)       !< Potential energy due to L-J interactions

      ! Local
      integer :: xyz_now

      h(:) = 0.0_wp
      xyz_now = this%xyz_ions_step(1)

      if (this%lj%num_species > 0) then
         call MW_lennard_jones_energy(this%num_pbc, this%localwork, lj, this%box, this%ions, &
               this%xyz_ions(:,:,xyz_now), this%electrodes, this%xyz_atoms, h(1:2), .False.)

         if (this%num_molecule_types > 0) then
            call MW_lennard_jones_fix_molecule_energy(this%num_PBC, this%localwork, lj, &
                  this%molecules, this%box,this%ions, this%xyz_ions(:,:,xyz_now), h(3:4), .False.)
         end if
      end if

   end subroutine compute_lj_energy

   !================================================================================
   subroutine compute_ft_energy(this, ft, h)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t
      use MW_fumi_tosi, only: MW_fumi_tosi_t, &
            MW_fumi_tosi_energy => energy, &
            MW_fumi_tosi_fix_molecule_energy => fix_molecule_energy

      implicit none
      type(MW_system_t), intent(in) :: this
      type(MW_fumi_tosi_t), intent(in) :: ft

      real(wp), intent(out) :: h(2)       !< Potential energy due to L-J interactions

      ! Local
      integer :: xyz_now

      h(:) = 0.0_wp
      xyz_now = this%xyz_ions_step(1)

      if (this%ft%num_species > 0) then
         call MW_fumi_tosi_energy(this%num_PBC, this%localwork, ft, this%box, &
               this%ions, this%xyz_ions(:,:,xyz_now), &
               this%electrodes, this%xyz_atoms, h(1))

         if (this%num_molecule_types > 0) then
            call MW_fumi_tosi_fix_molecule_energy(this%num_PBC, this%localwork, ft, this%molecules, &
                  this%box,this%ions, this%xyz_ions(:,:,xyz_now), h(2))
         end if
      end if

   end subroutine compute_ft_energy

   !================================================================================
   subroutine compute_xft_energy(this, xft, h)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t
      use MW_xft, only: MW_xft_t, &
            MW_xft_energy => energy, &
            MW_xft_fix_molecule_energy => fix_molecule_energy

      implicit none
      type(MW_system_t), intent(in) :: this
      type(MW_xft_t), intent(in) :: xft

      real(wp), intent(out) :: h(2)       !< Potential energy due to XFT interactions

      ! Local
      integer :: xyz_now

      h(:) = 0.0_wp
      xyz_now = this%xyz_ions_step(1)

      if (this%xft%num_species > 0) then
         call MW_xft_energy(this%num_PBC, this%localwork, xft, this%box, &
               this%ions, this%xyz_ions(:,:,xyz_now), &
               this%electrodes, this%xyz_atoms, h(1))

         if (this%num_molecule_types > 0) then
            call MW_xft_fix_molecule_energy(this%num_PBC, this%localwork, xft, this%molecules, &
                  this%box,this%ions, this%xyz_ions(:,:,xyz_now), h(2))
         end if
      end if

   end subroutine compute_xft_energy

   !================================================================================
   subroutine modify_charge(this, itype, charge)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t

      implicit none
      type(MW_system_t), intent(inout) :: this
      integer, intent(in) :: itype
      real(wp), intent(in) :: charge

      this%ions(itype)%charge = charge

   end subroutine

   !================================================================================
   subroutine get_electrode_mass(this, itype, mass)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t

      implicit none
      type(MW_system_t), intent(in) :: this
      integer, intent(in) :: itype
      real(wp), intent(out) :: mass

      mass = this%electrodes(itype)%mass

   end subroutine

   !================================================================================
   subroutine set_electrode_mass(this, itype, mass)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t

      implicit none
      type(MW_system_t), intent(inout) :: this
      integer, intent(in) :: itype
      real(wp), intent(in) :: mass

      this%electrodes(itype)%mass = mass

   end subroutine

   !================================================================================
   subroutine sum_electrode_forces(this, itypes)
      use MW_kinds, only: wp
      use MW_system, only: MW_system_t
      use MW_errors, only: MW_errors_allocate_error => allocate_error

      implicit none
      type(MW_system_t), intent(inout) :: this
      integer, intent(in) :: itypes(:)

      !Local
      real(wp), allocatable :: forces(:, :)
      integer :: num_types, elec, itype, ierr

      num_types = size(itypes)
      allocate(forces(3, size(this%electrodes(1)%force_ions,2)), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("allocate_data_arrays", "electrode.f90", ierr)
      end if
      forces(:,:) = 0.0_wp

      do elec = 1, num_types
         itype = itypes(elec)
         forces(:, :) = forces(:, :) + this%electrodes(itype)%force_ions(:, :)
      end do

      do elec = 1, num_types
         itype = itypes(elec)
         this%electrodes(itype)%force_ions(:, :) = forces(:, :)
      end do

   end subroutine

end module MW_tools

! Module to compute long-range part of electrostatic (Coulomb) potential
module MW_coulomb_lr_pim
   use MW_kinds, only: wp
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_constants, only: twopi, block_vector_size
   use MW_electrode, only: MW_electrode_t
   use MW_molecule, only: MW_molecule_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: gradQelec_electricfield !grad_Q [grad_mu [U^lr_muQ]]
   public :: diag_gradmumelt_electricfield !diag[grad_mu [grad_mu [U^lr_mumu]]]
   public :: gradmumelt_electricfield !grad_mu [grad_mu [U^lr_mumu]]
   public :: mumelt2Qelec_potential !grad_Q [U^lr_muQ]
   public :: qmelt2mumelt_electricfield !-grad_mu [U^lr_qmu]
   public :: mumelt2mumelt_electricfield !-grad_mu [U^lr_mumu]
   public :: Qelec2mumelt_electricfield !-grad_mu [U^lr_muQ]
   public :: melt_efg !-grad_r grad_r [(U^lr_qq) + (U^lr_qmu) + (U^lr_mumu)]
   public :: melt_forces !-grad_r [(U^lr_qq + U^lr_qmu + U^lr_mumu) + (U^lr_QQ) + (U^lr_qQ + U^lr_muQ)]
   public :: energy !(U^lr_qq + U^lr_qmu + U^lr_mumu) + (U^lr_QQ) + (U^lr_qQ + U^lr_muQ)

contains

   subroutine gradQelec_electricfield(localwork, ewald, box, electrodes, &
      gradQ_efield)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrodes parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: gradQ_efield(:,:)      !< Electric field on ions
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters

      ! Local
      ! -----
      integer :: num_ions, num_elec_types
      integer :: i, itype, j, jx, jy, jz
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky
      real(wp) :: cos_kxkykz_i, sin_kxkykz_i, cos_kxkykz_j, sin_kxkykz_j
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ions = size(gradQ_efield,1)/3
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        gradQ_efield(:,:))

      volfactor = 2.0_wp/box%area(3)

      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count

         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz_i, sin_kxkykz_i, jx, jy, jz, cos_kxkykz_j, sin_kxkykz_j, &
            !$acc         i, j)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  ! Atoms contribution to structure factor
                  Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  !$acc loop vector
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz_i = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz_i = sin_kxky*cos_kz + cos_kxky*sin_kz

                     do j = 1, num_ions

                        jx = j
                        jy = j + num_ions
                        jz = j + num_ions*2

                        cos_kx = ewald%cos_kx_ions(j,l)
                        sin_kx = ewald%sin_kx_ions(j,l)
                        cos_ky = ewald%cos_ky_ions(j,mabs)
                        sin_ky = ewald%sin_ky_ions(j,mabs)*sign_m
                        cos_kz = ewald%cos_kz_ions(j,nabs)
                        sin_kz = ewald%sin_kz_ions(j,nabs)*sign_n

                        cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                        sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                        cos_kxkykz_j = cos_kxky*cos_kz - sin_kxky*sin_kz
                        sin_kxkykz_j = sin_kxky*cos_kz + cos_kxky*sin_kz

                        !$acc atomic update
                        gradQ_efield(jx,i) = gradQ_efield(jx,i) + Sk_alpha* &
                              (sin_kxkykz_i*cos_kxkykz_j - cos_kxkykz_i*sin_kxkykz_j)*kx
                        !$acc atomic update
                        gradQ_efield(jy,i) = gradQ_efield(jy,i) + Sk_alpha* &
                              (sin_kxkykz_i*cos_kxkykz_j - cos_kxkykz_i*sin_kxkykz_j)*ky
                        !$acc atomic update
                        gradQ_efield(jz,i) = gradQ_efield(jz,i) + Sk_alpha* &
                              (sin_kxkykz_i*cos_kxkykz_j - cos_kxkykz_i*sin_kxkykz_j)*kz

                     end do
                  end do
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do
      !$acc end data

   end subroutine gradQelec_electricfield

   !================================================================================
   ! Compute the gradient of the electric field for each ion in the melt with respect
   ! to variations of other dipoles in the melt
   subroutine diag_gradmumelt_electricfield(localwork, ewald, box, ions, &
         diag_gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters

      ! Parameters Input/Output
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald              !< Ewald summation parameters
      real(wp),             intent(inout) :: diag_gradmu_efield(:) !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: i, itype, ix, iy, iz
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky
      real(wp) :: cos_kxkykz_i, sin_kxkykz_i
      real(wp) :: coskicoski_p_sinkisinki
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_ions = size(diag_gradmu_efield,1)/3

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Skmux_cos(:), &
      !$acc        ewald%Skmuy_cos(:), ewald%Skmux_sin(:), ewald%Skmuz_cos(:), &
      !$acc        ewald%Skmuy_sin(:), ewald%Skmuz_sin(:))

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz_i, sin_kxkykz_i, i, &
            !$acc         coskicoski_p_sinkisinki)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  !$acc loop vector
                  do i = istart_block, iend_block

                     ix = i
                     iy = i + num_ions
                     iz = i + num_ions*2

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz_i = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz_i = sin_kxky*cos_kz + cos_kxky*sin_kz

                     coskicoski_p_sinkisinki = cos_kxkykz_i*cos_kxkykz_i + sin_kxkykz_i*sin_kxkykz_i ! Again, I think this is 1!

                     !Non-parallelized loop over all particles (not ready for non-polarizable species)

                     !$acc atomic update
                     diag_gradmu_efield(ix) = diag_gradmu_efield(ix) + &
                           Sk_alpha*coskicoski_p_sinkisinki*kx*kx !xx

                     !$acc atomic update
                     diag_gradmu_efield(iy) = diag_gradmu_efield(iy) + &
                           Sk_alpha*coskicoski_p_sinkisinki*ky*ky !yy

                     !$acc atomic update
                     diag_gradmu_efield(iz) = diag_gradmu_efield(iz) + &
                              Sk_alpha*coskicoski_p_sinkisinki*kz*kz !zz
                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      !$acc end data
   end subroutine diag_gradmumelt_electricfield

   !================================================================================
   ! Compute the gradient of the electric field for each ion in the melt with respect
   ! to variations of other dipoles in the melt
   subroutine gradmumelt_electricfield(localwork, ewald, box, ions, &
         gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters

      ! Parameters Input/Output
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald              !< Ewald summation parameters
      real(wp),             intent(inout) :: gradmu_efield(:,:) !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: i, itype, j, ix, iy, iz, jx, jy, jz
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky
      real(wp) :: cos_kxkykz_i, sin_kxkykz_i, cos_kxkykz_j, sin_kxkykz_j
      real(wp) :: coskicoskj_p_sinkisinkj
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_ions = size(gradmu_efield,1)/3

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        gradmu_efield(:,:))

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz_i, sin_kxkykz_i, cos_kxkykz_j, sin_kxkykz_j, i, &
            !$acc         j, ix, iy, iz, jx, jy, jz, coskicoskj_p_sinkisinkj)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  !$acc loop vector
                  do i = istart_block, iend_block

                     ix = i
                     iy = i + num_ions
                     iz = i + num_ions*2

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz_i = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz_i = sin_kxky*cos_kz + cos_kxky*sin_kz

                     !Non-parallelized loop over all particles (not ready for non-polarizable species)
                     do j=1,i

                        jx = j
                        jy = j + num_ions
                        jz = j + num_ions*2

                        cos_kx = ewald%cos_kx_ions(j,l)
                        sin_kx = ewald%sin_kx_ions(j,l)
                        cos_ky = ewald%cos_ky_ions(j,mabs)
                        sin_ky = ewald%sin_ky_ions(j,mabs)*sign_m
                        cos_kz = ewald%cos_kz_ions(j,nabs)
                        sin_kz = ewald%sin_kz_ions(j,nabs)*sign_n

                        cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                        sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                        cos_kxkykz_j = cos_kxky*cos_kz - sin_kxky*sin_kz
                        sin_kxkykz_j = sin_kxky*cos_kz + cos_kxky*sin_kz

                        coskicoskj_p_sinkisinkj = cos_kxkykz_i*cos_kxkykz_j + sin_kxkykz_i*sin_kxkykz_j

                        !$acc atomic update
                        gradmu_efield(jx,ix) = gradmu_efield(jx,ix) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*kx*kx !xx
                        !$acc atomic update
                        gradmu_efield(jy,ix) = gradmu_efield(jy,ix) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*kx*ky !yx
                        !$acc atomic update
                        gradmu_efield(jz,ix) = gradmu_efield(jz,ix) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*kx*kz !zx

                        !$acc atomic update
                        gradmu_efield(jy,iy) = gradmu_efield(jy,iy) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*ky*ky !yy
                        !$acc atomic update
                        gradmu_efield(jz,iy) = gradmu_efield(jz,iy) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*ky*kz !zy

                        !$acc atomic update
                        gradmu_efield(jz,iz) = gradmu_efield(jz,iz) + &
                              Sk_alpha*coskicoskj_p_sinkisinkj*kz*kz !zz
                     end do
                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      !$acc end data
   end subroutine gradmumelt_electricfield

   !================================================================================
   ! Compute the long-range Coulomb potential felt by each electrode
   ! atoms due to all melt ions
   subroutine mumelt2Qelec_potential(localwork, ewald, box, &
      ions, electrodes, dipoles, V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Local work assignment
      type(MW_box_t),       intent(in)    :: box        !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: dipoles(:,:)       !< ions dipoles

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald      !< Ewald summation parameters
      real(wp),             intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: muix, muiy, muiz !< ion charge and dipoles
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: volfactor
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: skmux_cos, skmux_sin
      real(wp) :: skmuy_cos, skmuy_sin
      real(wp) :: skmuz_cos, skmuz_sin
      real(wp) :: kdotmucos, kdotmusin

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block
      integer :: num_pbc
      integer :: num_ions,num_elec_atoms

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      num_ions = 0
      if (num_ion_types > 0) then
         num_ions = ions(num_ion_types)%offset+ions(num_ion_types)%count
      end if
      num_elec_atoms = 0
      if (num_elec_types > 0) then
         num_elec_atoms = electrodes(num_elec_types)%offset+electrodes(num_elec_types)%count
      end if

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      volfactor = 2.0_wp/box%area(3)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_pbc = ewald%num_pbc

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%Skmux_cos(:), ewald%Skmux_sin, &
      !$acc        ewald%Skmuy_cos(:), ewald%Skmuy_sin, &
      !$acc        ewald%Skmuz_cos(:), ewald%Skmuz_sin, &
      !$acc        dipoles(:,:), V(:))

      ! Initiliaze potential to 0
      ! -------------------------
      !$acc kernels
      V(:) = 0.0_wp
      !$acc end kernels

      !$acc kernels
      ewald%Skmux_cos(:) = 0.0_wp
      ewald%Skmux_sin(:) = 0.0_wp
      ewald%Skmuy_cos(:) = 0.0_wp
      ewald%Skmuy_sin(:) = 0.0_wp
      ewald%Skmuz_cos(:) = 0.0_wp
      ewald%Skmuz_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes in the exectude globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank

      ! Setup cache blocking parameters
      num_blocks = (num_ions-1)/block_vector_size + 1
      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_ions)

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
         !$acc         skmux_cos, skmuy_cos, skmuz_cos, skmux_sin, skmuy_sin, skmuz_sin)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp)*twopi)*box_lengthx_rec
            ! ky = m*twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m), wp)
            ky = (real(m,wp)*twopi)*box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n), wp)
            kz = ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then

               !Melt dipoles contribution to structure factor
               skmux_cos = 0.0_wp
               skmux_sin = 0.0_wp
               skmuy_cos = 0.0_wp
               skmuy_sin = 0.0_wp
               skmuz_cos = 0.0_wp
               skmuz_sin = 0.0_wp

               !$acc loop vector reduction(+: skmux_cos, skmuy_cos, skmuz_cos, skmux_sin, skmuy_sin, skmuz_sin) &
               !$acc private(muix, muiy, muiz, &
               !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
               !$acc         cos_kxkykz, sin_kxkykz)
               do i = istart_block, iend_block

                  muix = dipoles(i,1)
                  muiy = dipoles(i,2)
                  muiz = dipoles(i,3)

                  cos_kx = ewald%cos_kx_ions(i,l)
                  sin_kx = ewald%sin_kx_ions(i,l)
                  cos_ky = ewald%cos_ky_ions(i,mabs)
                  sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                  cos_kz = ewald%cos_kz_ions(i,nabs)
                  sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  skmux_cos = skmux_cos + muix*cos_kxkykz
                  skmux_sin = skmux_sin + muix*sin_kxkykz
                  skmuy_cos = skmuy_cos + muiy*cos_kxkykz
                  skmuy_sin = skmuy_sin + muiy*sin_kxkykz
                  skmuz_cos = skmuz_cos + muiz*cos_kxkykz
                  skmuz_sin = skmuz_sin + muiz*sin_kxkykz

               end do
               !$acc end loop

               !Melt dipoles
               ewald%Skmux_cos(imode) = ewald%Skmux_cos(imode) + skmux_cos
               ewald%Skmux_sin(imode) = ewald%Skmux_sin(imode) + skmux_sin
               ewald%Skmuy_cos(imode) = ewald%Skmuy_cos(imode) + skmuy_cos
               ewald%Skmuy_sin(imode) = ewald%Skmuy_sin(imode) + skmuy_sin
               ewald%Skmuz_cos(imode) = ewald%Skmuz_cos(imode) + skmuz_cos
               ewald%Skmuz_sin(imode) = ewald%Skmuz_sin(imode) + skmuz_sin

            end if
         end do
         !$acc end loop
         !$acc end parallel
      end do

      ! Setup cache blocking parameters
      num_blocks = (num_elec_atoms-1)/block_vector_size + 1
      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_elec_atoms)

         num_modes = localwork%ewald_num_mode_local
         l = localwork%ewald_kstart_x
         m = localwork%ewald_kstart_y
         n = localwork%ewald_kstart_z

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp)*twopi)*box_lengthx_rec
            ! ky = m*twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m), wp)
            ky = (real(m,wp)*twopi)*box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n), wp)
            kz = sign_n*ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then

               Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)
               !$acc loop vector &
               !$acc private(cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
               !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i, &
               !$acc         kdotmucos, kdotmusin)
               do i = istart_block, iend_block

                  cos_kx = ewald%cos_kx_elec(i,l)
                  sin_kx = ewald%sin_kx_elec(i,l)
                  cos_ky = ewald%cos_ky_elec(i,mabs)
                  sin_ky = ewald%sin_ky_elec(i,mabs)*sign_m
                  cos_kz = ewald%cos_kz_elec(i,nabs)
                  sin_kz = ewald%sin_kz_elec(i,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  kdotmucos = ewald%Skmux_cos(imode)*kx + ewald%Skmuy_cos(imode)*ky + ewald%Skmuz_cos(imode)*kz   !rdotmuc in pimaim
                  kdotmusin = ewald%Skmux_sin(imode)*kx + ewald%Skmuy_sin(imode)*ky + ewald%Skmuz_sin(imode)*kz   !rdotmus in pimaim

                  !$acc atomic update
                  V(i) = V(i) + Sk_alpha*(sin_kxkykz*kdotmucos - cos_kxkykz*kdotmusin)
               end do
               !$acc end loop
            end if
         end do
         !$acc end loop
         !$acc end parallel
      end do
      !$acc end data
   end subroutine mumelt2Qelec_potential


   !================================================================================
   ! Compute the electric field felt by each melt ions due to other melt ions charges
   subroutine qmelt2mumelt_electricfield(localwork, ewald, box, ions, efield)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: i, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: sk_cos, sk_sin

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ion_types = size(ions,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), efield(:,:))

      !$acc kernels
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      !ions
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  sk_cos = 0.0_wp
                  sk_sin = 0.0_wp
                  !$acc loop vector reduction(+: sk_cos, sk_sin)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     sk_cos = sk_cos + qi*cos_kxkykz
                     sk_sin = sk_sin + qi*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin

               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      !ions2ions
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  !$acc loop vector
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     ! electric field
                     !$acc atomic update
                     efield(i,1) = efield(i,1) +  kx*Sk_alpha*(sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                     !$acc atomic update
                     efield(i,2) = efield(i,2) +  ky*Sk_alpha*(sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                     !$acc atomic update
                     efield(i,3) = efield(i,3) +  kz*Sk_alpha*(sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))

                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      !$acc end data
   end subroutine qmelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions dipoles
   subroutine mumelt2mumelt_electricfield(localwork, ewald, box, ions, efield, dipoles)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters
      real(wp),             intent(in)    :: dipoles(:,:)       !< ions dipoles

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: i, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: skmux_cos, skmux_sin
      real(wp) :: skmuy_cos, skmuy_sin
      real(wp) :: skmuz_cos, skmuz_sin
      real(wp) :: kdotmucos,kdotmusin

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_ions = 0
      do itype = 1, num_ion_types
         num_ions = num_ions+ions(itype)%count
      enddo

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        dipoles(:,:), &
      !$acc        ewald%Skmux_cos(:), &
      !$acc        ewald%Skmuy_cos(:), ewald%Skmux_sin(:), ewald%Skmuz_cos(:), &
      !$acc        ewald%Skmuy_sin(:), ewald%Skmuz_sin(:), &
      !$acc        efield(:,:))

      !$acc kernels
      ewald%Skmux_cos(:) = 0.0_wp
      ewald%Skmux_sin(:) = 0.0_wp
      ewald%Skmuy_cos(:) = 0.0_wp
      ewald%Skmuy_sin(:) = 0.0_wp
      ewald%Skmuz_cos(:) = 0.0_wp
      ewald%Skmuz_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Setup cache blocking parameters
         num_blocks = (num_ions-1)/block_vector_size + 1
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1
            iend_block = min(istart_block+block_vector_size-1,num_ions)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         skmux_cos, skmux_sin, &
            !$acc         skmuy_cos,skmuy_sin, skmuz_cos, skmuz_sin)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  skmux_cos = 0.0_wp
                  skmux_sin = 0.0_wp
                  skmuy_cos = 0.0_wp
                  skmuy_sin = 0.0_wp
                  skmuz_cos = 0.0_wp
                  skmuz_sin = 0.0_wp
                  !$acc loop vector reduction(+: skmux_cos, skmux_sin, &
                  !$acc                skmuy_cos,skmuy_sin,skmuz_cos,skmuz_sin) &
                  !$acc private(cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
                  !$acc         cos_kxkykz, sin_kxkykz)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     skmux_cos = skmux_cos + dipoles(i,1)*cos_kxkykz
                     skmux_sin = skmux_sin + dipoles(i,1)*sin_kxkykz
                     skmuy_cos = skmuy_cos + dipoles(i,2)*cos_kxkykz
                     skmuy_sin = skmuy_sin + dipoles(i,2)*sin_kxkykz
                     skmuz_cos = skmuz_cos + dipoles(i,3)*cos_kxkykz
                     skmuz_sin = skmuz_sin + dipoles(i,3)*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Skmux_cos(imode) = ewald%Skmux_cos(imode) + skmux_cos
                  ewald%Skmux_sin(imode) = ewald%Skmux_sin(imode) + skmux_sin
                  ewald%Skmuy_cos(imode) = ewald%Skmuy_cos(imode) + skmuy_cos
                  ewald%Skmuy_sin(imode) = ewald%Skmuy_sin(imode) + skmuy_sin
                  ewald%Skmuz_cos(imode) = ewald%Skmuz_cos(imode) + skmuz_cos
                  ewald%Skmuz_sin(imode) = ewald%Skmuz_sin(imode) + skmuz_sin

               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do

         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1
            iend_block = min(istart_block+block_vector_size-1,num_ions)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha =  2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  !$acc loop vector &
                  !$acc private(cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
                  !$acc         cos_kxkykz, sin_kxkykz, kdotmucos, kdotmusin)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     kdotmucos = ewald%Skmux_cos(imode)*kx + ewald%Skmuy_cos(imode)*ky + ewald%Skmuz_cos(imode)*kz   !rdotmuc in pimaim
                     kdotmusin = ewald%Skmux_sin(imode)*kx + ewald%Skmuy_sin(imode)*ky + ewald%Skmuz_sin(imode)*kz   !rdotmus in pimaim

                     ! electric field
                     !$acc atomic update
                     efield(i,1)  = efield(i,1) - Sk_alpha * (cos_kxkykz*kdotmucos + sin_kxkykz*kdotmusin)*kx
                     !$acc atomic update
                     efield(i,2)  = efield(i,2) - Sk_alpha * (cos_kxkykz*kdotmucos + sin_kxkykz*kdotmusin)*ky
                     !$acc atomic update
                     efield(i,3)  = efield(i,3) - Sk_alpha * (cos_kxkykz*kdotmucos + sin_kxkykz*kdotmusin)*kz

                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do

      !$acc end data
   end subroutine mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric field felt by each melt ions due to other melt ions charges
   subroutine Qelec2mumelt_electricfield(localwork, ewald, box, ions, &
      electrodes, q_elec, efield)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrodes parameters
      real(wp),             intent(in)    :: q_elec(:)       !< Electrode atoms charge

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: Q_i !< electrode charges
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: sk_cos, sk_sin

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block
      integer :: num_pbc
      integer :: num_ions, num_elec_atoms

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)
      num_ions = 0
      if (num_ion_types > 0) then
         num_ions = ions(num_ion_types)%offset+ions(num_ion_types)%count
      end if
      num_elec_atoms = 0
      if (num_elec_types > 0) then
         num_elec_atoms = electrodes(num_elec_types)%offset+electrodes(num_elec_types)%count
      end if

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), q_elec(:), efield(:,:))

      !$acc kernels
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      !electrodes
      num_blocks = (num_elec_atoms-1)/block_vector_size + 1

      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_elec_atoms)

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
         !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
         !$acc         cos_kxkykz, sin_kxkykz, sk_cos, sk_sin, i, Q_i)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp)*twopi)*box_lengthx_rec
            ! ky = m*twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m),wp)
            ky = (real(m,wp)*twopi)*box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n),wp)
            kz = sign_n*ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then
               sk_cos = 0.0_wp
               sk_sin = 0.0_wp
               ! Atoms contribution to structure factor
               !$acc loop vector reduction(+: sk_cos, sk_sin)
               do i = istart_block, iend_block
                  cos_kx = ewald%cos_kx_elec(i,l)
                  sin_kx = ewald%sin_kx_elec(i,l)
                  cos_ky = ewald%cos_ky_elec(i,mabs)
                  sin_ky = ewald%sin_ky_elec(i,mabs)*sign_m
                  cos_kz = ewald%cos_kz_elec(i,nabs)
                  sin_kz = ewald%sin_kz_elec(i,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  Q_i = q_elec(i)

                  sk_cos = sk_cos + Q_i*cos_kxkykz
                  sk_sin = sk_sin + Q_i*sin_kxkykz
               end do
               !$acc end loop
               ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + sk_cos
               ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + sk_sin
            end if
         end do ! imode
         !$acc end loop
         !$acc end parallel
      end do

      !electric field
      ! Setup cache blocking parameters
      num_blocks = (num_ions-1)/block_vector_size + 1
      do iblock = 1, num_blocks
         istart_block = (iblock-1)*block_vector_size + 1
         iend_block = min(istart_block+block_vector_size-1,num_ions)

         !$acc parallel
         !$acc loop gang &
         !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
         !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
         !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i)
         do imode = 1, num_modes
            call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
            ! kx = l * twopi / box%length(1)
            kx = (real(l,wp)*twopi)*box_lengthx_rec
            ! ky = m*twopi / box%length(2)
            mabs = abs(m)
            sign_m = real(sign(1,m),wp)
            ky = (real(m,wp)*twopi)*box_lengthy_rec
            ! kz = zpoint(n)
            nabs = abs(n)
            sign_n = real(sign(1,n),wp)
            kz = sign_n*ewald%zpoint(nabs)

            ! Norm square of the k-mode vector
            knorm2 = kx*kx + ky*ky + kz*kz
            if (knorm2 <= ewald%knorm2_max) then

               Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

               !$acc loop vector
               do i = istart_block, iend_block

                  cos_kx = ewald%cos_kx_ions(i,l)
                  sin_kx = ewald%sin_kx_ions(i,l)
                  cos_ky = ewald%cos_ky_ions(i,mabs)
                  sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                  cos_kz = ewald%cos_kz_ions(i,nabs)
                  sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  ! electric field
                  !$acc atomic update
                  efield(i,1) = efield(i,1) + kx*Sk_alpha* &
                        (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                  !$acc atomic update
                  efield(i,2) = efield(i,2) + ky*Sk_alpha* &
                        (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                  !$acc atomic update
                  efield(i,3) = efield(i,3) + kz*Sk_alpha* &
                        (sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))

               end do ! ni
               !$acc end loop
            end if
         end do ! imode
         !$acc end loop
         !$acc end parallel
      end do

      !$acc end data
   end subroutine Qelec2mumelt_electricfield

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(localwork, ewald, box, ions, &
      electrodes, q_elec, force, stress_tensor, dipoles)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrodes parameters
      real(wp),             intent(in)    :: q_elec(:)       !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)       !< ions dipoles

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: force(:,:) !< Coulomb force on ions
      real(wp),             intent(inout) :: stress_tensor(:,:) !< Coulomb force contribution to stress

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, itype
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: skq_cos, skq_sin
      real(wp) :: skmux_cos, skmux_sin
      real(wp) :: skmuy_cos, skmuy_sin
      real(wp) :: skmuz_cos, skmuz_sin
      real(wp) :: kdotmucos, kdotmusin
      real(wp) :: kdotmucosxx, kdotmusinxx
      real(wp) :: kdotmucosyy, kdotmusinyy
      real(wp) :: kdotmucoszz, kdotmusinzz
      real(wp) :: kdotmucosxy, kdotmusinxy
      real(wp) :: kdotmucosxz, kdotmusinxz
      real(wp) :: kdotmucosyz, kdotmusinyz
      real(wp) :: fqq, fqmu, fmuq, fmumu, ftot
      real(wp) :: stfac1,stfac2,qcos,qsin
      real(wp) :: loc_stress_tensor_xx, loc_stress_tensor_yy, loc_stress_tensor_zz
      real(wp) :: loc_stress_tensor_xy, loc_stress_tensor_xz, loc_stress_tensor_yz

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc


      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      loc_stress_tensor_xx = 0.0_wp
      loc_stress_tensor_yy = 0.0_wp
      loc_stress_tensor_zz = 0.0_wp
      loc_stress_tensor_xy = 0.0_wp
      loc_stress_tensor_xz = 0.0_wp
      loc_stress_tensor_yz = 0.0_wp

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        ewald%Sk_cos(:), ewald%Sk_sin(:), q_elec(:), force(:,:),dipoles(:,:), &
      !$acc        ewald%Skmux_cos(:), &
      !$acc        ewald%Skmuy_cos(:), ewald%Skmux_sin(:), ewald%Skmuz_cos(:), &
      !$acc        ewald%Skmuy_sin(:), ewald%Skmuz_sin(:)) &
      !$acc      copy(loc_stress_tensor_xx,loc_stress_tensor_yy,loc_stress_tensor_zz, &
      !$acc           loc_stress_tensor_xy,loc_stress_tensor_xz,loc_stress_tensor_yz)

      !$acc kernels
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      ewald%Skmux_cos(:) = 0.0_wp
      ewald%Skmux_sin(:) = 0.0_wp
      ewald%Skmuy_cos(:) = 0.0_wp
      ewald%Skmuy_sin(:) = 0.0_wp
      ewald%Skmuz_cos(:) = 0.0_wp
      ewald%Skmuz_sin(:) = 0.0_wp
      !$acc end kernels

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, skq_cos, skq_sin, skmux_cos, skmux_sin, &
            !$acc         skmuy_cos,skmuy_sin, skmuz_cos, skmuz_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  ! melt charges contribution
                  skq_cos = 0.0_wp
                  skq_sin = 0.0_wp
                  ! melt dipoles contribution
                  skmux_cos = 0.0_wp
                  skmux_sin = 0.0_wp
                  skmuy_cos = 0.0_wp
                  skmuy_sin = 0.0_wp
                  skmuz_cos = 0.0_wp
                  skmuz_sin = 0.0_wp
                  !$acc loop vector reduction(+: skq_cos, skq_sin, skmux_cos, skmux_sin, &
                  !$acc                       skmuy_cos,skmuy_sin,skmuz_cos,skmuz_sin)
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     skq_cos = skq_cos + qi*cos_kxkykz
                     skq_sin = skq_sin + qi*sin_kxkykz

                     skmux_cos = skmux_cos + dipoles(i,1)*cos_kxkykz
                     skmux_sin = skmux_sin + dipoles(i,1)*sin_kxkykz
                     skmuy_cos = skmuy_cos + dipoles(i,2)*cos_kxkykz
                     skmuy_sin = skmuy_sin + dipoles(i,2)*sin_kxkykz
                     skmuz_cos = skmuz_cos + dipoles(i,3)*cos_kxkykz
                     skmuz_sin = skmuz_sin + dipoles(i,3)*sin_kxkykz
                  end do
                  !$acc end loop
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + skq_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + skq_sin

                  ewald%Skmux_cos(imode) = ewald%Skmux_cos(imode) + skmux_cos
                  ewald%Skmux_sin(imode) = ewald%Skmux_sin(imode) + skmux_sin
                  ewald%Skmuy_cos(imode) = ewald%Skmuy_cos(imode) + skmuy_cos
                  ewald%Skmuy_sin(imode) = ewald%Skmuy_sin(imode) + skmuy_sin
                  ewald%Skmuz_cos(imode) = ewald%Skmuz_cos(imode) + skmuz_cos
                  ewald%Skmuz_sin(imode) = ewald%Skmuz_sin(imode) + skmuz_sin

               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      do itype = 1, num_elec_types
         num_blocks = 0
         if (electrodes(itype)%count > 0) then
            num_blocks = (electrodes(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = electrodes(itype)%offset + electrodes(itype)%count

         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + 1 + electrodes(itype)%offset
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
            !$acc         cos_kxkykz, sin_kxkykz, skq_cos, skq_sin, i)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then
                  ! electrode charges contribution
                  skq_cos = 0.0_wp
                  skq_sin = 0.0_wp
                  ! Atoms contribution to structure factor
                  !$acc loop vector reduction(+: skq_cos, skq_sin)
                  do i = istart_block, iend_block
                     cos_kx = ewald%cos_kx_elec(i,l)
                     sin_kx = ewald%sin_kx_elec(i,l)
                     cos_ky = ewald%cos_ky_elec(i,mabs)
                     sin_ky = ewald%sin_ky_elec(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_elec(i,nabs)
                     sin_kz = ewald%sin_kz_elec(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     skq_cos = skq_cos + q_elec(i)*cos_kxkykz
                     skq_sin = skq_sin + q_elec(i)*sin_kxkykz
                  end do
                  !$acc end loop
                  !Sk_cos/sin have inside the contribution of melt and electrodes charges
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + skq_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + skq_sin
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge

         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            !$acc parallel
            !$acc loop gang &
            !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
            !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
            !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i, &
            !$acc         kdotmucos,kdotmusin,fqq,fqmu,fmuq,fmumu)
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m*twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= ewald%knorm2_max) then

                  Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                  kdotmucos = ewald%Skmux_cos(imode)*kx + ewald%Skmuy_cos(imode)*ky + ewald%Skmuz_cos(imode)*kz   !rdotmuc in pimaim
                  kdotmusin = ewald%Skmux_sin(imode)*kx + ewald%Skmuy_sin(imode)*ky + ewald%Skmuz_sin(imode)*kz   !rdotmus in pimaim

                  !$acc loop vector
                  ! Computing forces over melt
                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     ! force on melt
                     !forces on point charges due to other point charges and electrode charges
                     fqq   = qi*Sk_alpha*(sin_kxkykz*ewald%Sk_cos(imode) - cos_kxkykz*ewald%Sk_sin(imode))
                     !forces on point charges due to point dipoles
                     fqmu  = qi*Sk_alpha*(-cos_kxkykz*kdotmucos - sin_kxkykz*kdotmusin)
                     !forces on point dipoles due to point charges and electrode charges
                     fmuq  = (dipoles(i,1)*kx + dipoles(i,2)*ky + dipoles(i,3)*kz)*Sk_alpha* &
                           (cos_kxkykz*ewald%Sk_cos(imode) + sin_kxkykz*ewald%Sk_sin(imode))
                     !forces on point dipoles due to other point dipoles
                     fmumu = (dipoles(i,1)*kx + dipoles(i,2)*ky + dipoles(i,3)*kz)*Sk_alpha* &
                           (-cos_kxkykz*kdotmusin + sin_kxkykz*kdotmucos)
                     ftot  = fqq + fqmu + fmuq + fmumu

                     !$acc atomic update
                     force(i,1) = force(i,1) + ftot*kx
                     !$acc atomic update
                     force(i,2) = force(i,2) + ftot*ky
                     !$acc atomic update
                     force(i,3) = force(i,3) + ftot*kz

                  end do ! ni
                  !$acc end loop
               end if
            end do ! imode
            !$acc end loop
            !$acc end parallel
         end do
      end do

      ! Setup cache blocking parameters
      !$acc parallel
      !$acc loop gang &
      !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, Sk_alpha, &
      !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, &
      !$acc         cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz, i, &
      !$acc         kdotmucos, kdotmusin, kdotmucosxx, kdotmusinxx, kdotmucosxy, kdotmusinxy,&
      !$acc         kdotmucosxz, kdotmusinxz, kdotmucosyy, kdotmusinyy, kdotmucosyz, kdotmusinyz, &
      !$acc         kdotmucoszz, kdotmusinzz, qcos, qsin, stfac1, stfac2) reduction(+:loc_stress_tensor_xx,&
      !$acc                       loc_stress_tensor_yy,loc_stress_tensor_zz, &
      !$acc                       loc_stress_tensor_xy,loc_stress_tensor_xz, &
      !$acc                       loc_stress_tensor_yz)
      do imode = 1, num_modes
         call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
         ! kx = l * twopi / box%length(1)
         kx = (real(l,wp)*twopi)*box_lengthx_rec
         ! ky = m*twopi / box%length(2)
         mabs = abs(m)
         sign_m = real(sign(1,m),wp)
         ky = (real(m,wp)*twopi)*box_lengthy_rec
         ! kz = zpoint(n)
         nabs = abs(n)
         sign_n = real(sign(1,n),wp)
         kz = sign_n*ewald%zpoint(nabs)

         ! Norm square of the k-mode vector
         knorm2 = kx*kx + ky*ky + kz*kz
         if (knorm2 <= ewald%knorm2_max) then

            Sk_alpha = volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)  ! divided by 2 compared to forces

            qcos = ewald%Sk_cos(imode)
            qsin = ewald%Sk_sin(imode)
            kdotmucos = ewald%Skmux_cos(imode)*kx + ewald%Skmuy_cos(imode)*ky + ewald%Skmuz_cos(imode)*kz   !rdotmuc in pimaim
            kdotmusin = ewald%Skmux_sin(imode)*kx + ewald%Skmuy_sin(imode)*ky + ewald%Skmuz_sin(imode)*kz   !rdotmus in pimaim

            kdotmucosxx = ewald%Skmux_cos(imode)*kx
            kdotmusinxx = ewald%Skmux_sin(imode)*kx

            kdotmucosyy = ewald%Skmuy_cos(imode)*ky
            kdotmusinyy = ewald%Skmuy_sin(imode)*ky

            kdotmucoszz = ewald%Skmuz_cos(imode)*kz
            kdotmusinzz = ewald%Skmuz_sin(imode)*kz

            kdotmucosxy = 0.5_wp*(ewald%Skmux_cos(imode)*ky + ewald%Skmuy_cos(imode)*kx)
            kdotmusinxy = 0.5_wp*(ewald%Skmux_sin(imode)*ky + ewald%Skmuy_sin(imode)*kx)

            kdotmucosxz = 0.5_wp*(ewald%Skmux_cos(imode)*kz + ewald%Skmuz_cos(imode)*kx)
            kdotmusinxz = 0.5_wp*(ewald%Skmux_sin(imode)*kz + ewald%Skmuz_sin(imode)*kx)

            kdotmucosyz = 0.5_wp*(ewald%Skmuy_cos(imode)*kz + ewald%Skmuz_cos(imode)*ky)
            kdotmusinyz = 0.5_wp*(ewald%Skmuy_sin(imode)*kz + ewald%Skmuz_sin(imode)*ky)

            ! q q term
            stfac1 = (4.0_wp*alphasq+knorm2)/(4.0_wp*alphasq*knorm2)
            stfac2 = Sk_alpha * (qcos**2.0+qsin**2.0)

            loc_stress_tensor_xx=loc_stress_tensor_xx+ &
                     (1.0_wp-2.0_wp * kx * kx * stfac1)*stfac2
            loc_stress_tensor_yy=loc_stress_tensor_yy+ &
                     (1.0_wp-2.0_wp * ky * ky * stfac1)*stfac2
            loc_stress_tensor_zz=loc_stress_tensor_zz+ &
                     (1.0_wp-2.0_wp * kz * kz * stfac1)*stfac2
            loc_stress_tensor_xy=loc_stress_tensor_xy+ &
                     (-2.0_wp * kx * ky * stfac1)*stfac2
            loc_stress_tensor_xz=loc_stress_tensor_xz+ &
                     (-2.0_wp * kx * kz * stfac1)*stfac2
            loc_stress_tensor_yz=loc_stress_tensor_yz+ &
                     (-2.0_wp * ky * kz * stfac1)*stfac2

            ! q mu term
            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucos - qcos * kdotmusin)

            loc_stress_tensor_xx=loc_stress_tensor_xx+ &
                     (1.0_wp-2.0_wp * kx * kx * stfac1)*stfac2
            loc_stress_tensor_yy=loc_stress_tensor_yy+ &
                     (1.0_wp-2.0_wp * ky * ky * stfac1)*stfac2
            loc_stress_tensor_zz=loc_stress_tensor_zz+ &
                     (1.0_wp-2.0_wp * kz * kz * stfac1)*stfac2
            loc_stress_tensor_xy=loc_stress_tensor_xy+ &
                     (-2.0_wp * kx * ky * stfac1)*stfac2
            loc_stress_tensor_xz=loc_stress_tensor_xz+ &
                     (-2.0_wp * kx * kz * stfac1)*stfac2
            loc_stress_tensor_yz=loc_stress_tensor_yz+ &
                     (-2.0_wp * ky * kz * stfac1)*stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucosxx - qcos * kdotmusinxx)
            loc_stress_tensor_xx=loc_stress_tensor_xx+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucosyy - qcos * kdotmusinyy)
            loc_stress_tensor_yy=loc_stress_tensor_yy+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucoszz - qcos * kdotmusinzz)
            loc_stress_tensor_zz=loc_stress_tensor_zz+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucosxy - qcos * kdotmusinxy)
            loc_stress_tensor_xy=loc_stress_tensor_xy+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucosxz - qcos * kdotmusinxz)
            loc_stress_tensor_xz=loc_stress_tensor_xz+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (qsin * kdotmucosyz - qcos * kdotmusinyz)
            loc_stress_tensor_yz=loc_stress_tensor_yz+stfac2

            ! mu mu term
            stfac2 = Sk_alpha * (kdotmucos**2.0 + kdotmusin**2.0)

            loc_stress_tensor_xx=loc_stress_tensor_xx+ &
                     (1.0_wp-2.0_wp * kx * kx * stfac1)*stfac2
            loc_stress_tensor_yy=loc_stress_tensor_yy+ &
                     (1.0_wp-2.0_wp * ky * ky * stfac1)*stfac2
            loc_stress_tensor_zz=loc_stress_tensor_zz+ &
                     (1.0_wp-2.0_wp * kz * kz * stfac1)*stfac2
            loc_stress_tensor_xy=loc_stress_tensor_xy+ &
                     (-2.0_wp * kx * ky * stfac1)*stfac2
            loc_stress_tensor_xz=loc_stress_tensor_xz+ &
                     (-2.0_wp * kx * kz * stfac1)*stfac2
            loc_stress_tensor_yz=loc_stress_tensor_yz+ &
                     (-2.0_wp * ky * kz * stfac1)*stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucosxx + kdotmusin * kdotmusinxx)
            loc_stress_tensor_xx=loc_stress_tensor_xx+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucosyy + kdotmusin * kdotmusinyy)
            loc_stress_tensor_yy=loc_stress_tensor_yy+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucoszz + kdotmusin * kdotmusinzz)
            loc_stress_tensor_zz=loc_stress_tensor_zz+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucosxy + kdotmusin * kdotmusinxy)
            loc_stress_tensor_xy=loc_stress_tensor_xy+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucosxz + kdotmusin * kdotmusinxz)
            loc_stress_tensor_xz=loc_stress_tensor_xz+stfac2

            stfac2 = 2.0_wp*Sk_alpha * (kdotmucos * kdotmucosyz + kdotmusin * kdotmusinyz)
            loc_stress_tensor_yz=loc_stress_tensor_yz+stfac2

         end if
      end do ! imode
      !$acc end loop
      !$acc end parallel

      !$acc end data
      stress_tensor(1,1) = loc_stress_tensor_xx
      stress_tensor(2,2) = loc_stress_tensor_yy
      stress_tensor(3,3) = loc_stress_tensor_zz
      stress_tensor(1,2) = loc_stress_tensor_xy
      stress_tensor(1,3) = loc_stress_tensor_xz
      stress_tensor(2,3) = loc_stress_tensor_yz

   end subroutine melt_forces

   !=========================================================================================
   ! Compute the electric field gradient felt by each melt ion due to other melt ions charges
   subroutine melt_efg(localwork, ewald, box, ions, dipoles, efg)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters
      real(wp),             intent(in)    :: dipoles(:,:)    !< ions dipoles

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald           !< Ewald summation parameters
      real(wp),             intent(inout) :: efg(:,:)        !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: i, itype
      logical :: itype_needs_efg
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_alpha !< Structure factor coefficients
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: skq_cos, skq_sin
      real(wp) :: skmux_cos, skmuy_cos, skmuz_cos
      real(wp) :: skmux_sin, skmuy_sin, skmuz_sin
      real(wp) :: kdotmusin, kdotmucos
      real(wp) :: efg_imode, efg_q_imode, efg_mu_imode

      integer :: imode, num_modes, mode_offset
      integer :: iblock, num_blocks, istart_block, iend_block, iend_type
      integer :: num_pbc

      num_ion_types = size(ions,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      ! Zero the arrays for sums of sin and cos before the computation.
      ewald%Sk_cos(:) = 0.0_wp
      ewald%Sk_sin(:) = 0.0_wp
      ewald%Skmux_cos(:) = 0.0_wp
      ewald%Skmux_sin(:) = 0.0_wp
      ewald%Skmuy_cos(:) = 0.0_wp
      ewald%Skmuy_sin(:) = 0.0_wp
      ewald%Skmuz_cos(:) = 0.0_wp
      ewald%Skmuz_sin(:) = 0.0_wp

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 2.0_wp/box%area(3)

      ! Ions: cache thu sums over sin and cos.
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         num_blocks = 0
         if (ions(itype)%count > 0) then
            num_blocks = (ions(itype)%count-1)/block_vector_size + 1
         end if
         iend_type = ions(itype)%offset + ions(itype)%count
         do iblock = 1, num_blocks
            istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
            iend_block = min(istart_block+block_vector_size-1,iend_type)

            ! Each processor works on its part of modes in parallel.
            do imode = 1, num_modes
               call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
               ! kx = l * twopi / box%length(1)
               kx = (real(l,wp)*twopi)*box_lengthx_rec
               ! ky = m * twopi / box%length(2)
               mabs = abs(m)
               sign_m = real(sign(1,m),wp)
               ky = (real(m,wp)*twopi)*box_lengthy_rec
               ! kz = zpoint(n)
               nabs = abs(n)
               sign_n = real(sign(1,n),wp)
               kz = sign_n*ewald%zpoint(nabs)

               ! Norm square of the k-mode vector
               knorm2 = kx*kx + ky*ky + kz*kz
               if (knorm2 <= knorm2_max) then

                  ! Ions contribution to structure factor
                  ! melt charges contribution
                  skq_cos = 0.0_wp
                  skq_sin = 0.0_wp
                  ! melt dipoles contribution
                  skmux_cos = 0.0_wp
                  skmux_sin = 0.0_wp
                  skmuy_cos = 0.0_wp
                  skmuy_sin = 0.0_wp
                  skmuz_cos = 0.0_wp
                  skmuz_sin = 0.0_wp

                  do i = istart_block, iend_block

                     cos_kx = ewald%cos_kx_ions(i,l)
                     sin_kx = ewald%sin_kx_ions(i,l)
                     cos_ky = ewald%cos_ky_ions(i,mabs)
                     sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                     cos_kz = ewald%cos_kz_ions(i,nabs)
                     sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                     cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                     sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                     cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                     sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                     skq_cos = skq_cos + qi*cos_kxkykz
                     skq_sin = skq_sin + qi*sin_kxkykz

                     skmux_cos = skmux_cos + dipoles(i,1)*cos_kxkykz
                     skmux_sin = skmux_sin + dipoles(i,1)*sin_kxkykz
                     skmuy_cos = skmuy_cos + dipoles(i,2)*cos_kxkykz
                     skmuy_sin = skmuy_sin + dipoles(i,2)*sin_kxkykz
                     skmuz_cos = skmuz_cos + dipoles(i,3)*cos_kxkykz
                     skmuz_sin = skmuz_sin + dipoles(i,3)*sin_kxkykz
                  end do
                  ewald%Sk_cos(imode) = ewald%Sk_cos(imode) + skq_cos
                  ewald%Sk_sin(imode) = ewald%Sk_sin(imode) + skq_sin

                  ewald%Skmux_cos(imode) = ewald%Skmux_cos(imode) + skmux_cos
                  ewald%Skmux_sin(imode) = ewald%Skmux_sin(imode) + skmux_sin
                  ewald%Skmuy_cos(imode) = ewald%Skmuy_cos(imode) + skmuy_cos
                  ewald%Skmuy_sin(imode) = ewald%Skmuy_sin(imode) + skmuy_sin
                  ewald%Skmuz_cos(imode) = ewald%Skmuz_cos(imode) + skmuz_cos
                  ewald%Skmuz_sin(imode) = ewald%Skmuz_sin(imode) + skmuz_sin

               end if
            end do ! imode
         end do
      end do

      ! Compute the contribution to the electric field gradient on ion positions.
      ! Setup cache blocking parameters
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         itype_needs_efg = ions(itype)%dump_efg

         ! Run the computation for selected ion types only
         if (itype_needs_efg) then
            num_blocks = 0
            if (ions(itype)%count > 0) then
               num_blocks = (ions(itype)%count-1)/block_vector_size + 1
            end if
            iend_type = ions(itype)%offset + ions(itype)%count
            do iblock = 1, num_blocks
               istart_block = (iblock-1)*block_vector_size + ions(itype)%offset + 1
               iend_block = min(istart_block+block_vector_size-1,iend_type)

               do imode = 1, num_modes
                  call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
                  ! kx = l * twopi / box%length(1)
                  kx = (real(l,wp)*twopi)*box_lengthx_rec
                  ! ky = m*twopi / box%length(2)
                  mabs = abs(m)
                  sign_m = real(sign(1,m),wp)
                  ky = (real(m,wp)*twopi)*box_lengthy_rec
                  ! kz = zpoint(n)
                  nabs = abs(n)
                  sign_n = real(sign(1,n),wp)
                  kz = sign_n*ewald%zpoint(nabs)

                  ! Norm square of the k-mode vector
                  knorm2 = kx*kx + ky*ky + kz*kz
                  if (knorm2 <= ewald%knorm2_max) then

                     Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)

                     kdotmucos = ewald%Skmux_cos(imode)*kx + ewald%Skmuy_cos(imode)*ky + ewald%Skmuz_cos(imode)*kz   !rdotmucos
                     kdotmusin = ewald%Skmux_sin(imode)*kx + ewald%Skmuy_sin(imode)*ky + ewald%Skmuz_sin(imode)*kz   !rdotmusin

                     do i = istart_block, iend_block
                        cos_kx = ewald%cos_kx_ions(i,l)
                        sin_kx = ewald%sin_kx_ions(i,l)
                        cos_ky = ewald%cos_ky_ions(i,mabs)
                        sin_ky = ewald%sin_ky_ions(i,mabs)*sign_m
                        cos_kz = ewald%cos_kz_ions(i,nabs)
                        sin_kz = ewald%sin_kz_ions(i,nabs)*sign_n

                        cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                        sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                        cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                        sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                        ! The efg prefactor for a fixed k-vector
                        ! Contribution due to charges
                        efg_q_imode = Sk_alpha*(sin_kxkykz*ewald%Sk_sin(imode) + &
                                                cos_kxkykz*ewald%Sk_cos(imode))

                        ! Contribution due to dipoles
                        efg_mu_imode = Sk_alpha*(sin_kxkykz*kdotmucos - &
                                                 cos_kxkykz*kdotmusin)
                        efg_imode = efg_q_imode + efg_mu_imode

                        ! Electric field gradient components
                        efg(i,1) = efg(i,1) + kx*kx*efg_imode ! xx
                        efg(i,2) = efg(i,2) + kx*ky*efg_imode ! xy
                        efg(i,3) = efg(i,3) + kx*kz*efg_imode ! xz
                        efg(i,4) = efg(i,4) + ky*ky*efg_imode ! yy
                        efg(i,5) = efg(i,5) + ky*kz*efg_imode ! yz
                        efg(i,6) = efg(i,6) + kz*kz*efg_imode ! zz

                     end do ! ni
                  end if
               end do ! imode
            end do
         end if ! itype_needs_efg
      end do

   end subroutine melt_efg

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   subroutine energy(localwork, ewald, box, ions, &
      electrodes, q_elec, h, dipoles)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald           !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)         !< ions parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrodes parameters
      real(wp),             intent(in) :: q_elec(:)       !< Electrode atoms charge
      real(wp),             intent(in) :: dipoles(:,:)    !< ions dipoles

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h !< energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, itype, iion
      integer :: l, m, n, mabs, nabs
      integer :: kmax_x, kmax_y, kmax_z
      real(wp) :: sign_m, sign_n
      real(wp) :: qi
      real(wp) :: kx, ky, kz, knorm2, knorm2_max
      real(wp) :: Sk_cos, Sk_sin, Sk_alpha , Sk_cos_type, Sk_sin_type !< Structure factor coefficients
      real(wp) :: Skmu_cos,Skmu_sin,Skmu_cos_type,Skmu_sin_type
      real(wp) :: kdotmu
      real(wp) :: cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz
      real(wp) :: cos_kxky, sin_kxky, cos_kxkykz, sin_kxkykz
      real(wp) :: volfactor
      real(wp) :: alpha, alphasq, alphaconst
      real(wp) :: box_lengthx_rec, box_lengthy_rec

      integer :: imode, num_modes, mode_offset
      integer :: num_pbc

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphaconst = -1.0_wp/(4.0_wp*alphasq)

      num_pbc = ewald%num_pbc
      box_lengthx_rec = 1.0_wp/box%length(1)
      box_lengthy_rec = 1.0_wp/box%length(2)

      knorm2_max = ewald%knorm2_max
      kmax_x = ewald%kmax_x
      kmax_y = ewald%kmax_y
      kmax_z = ewald%kmax_z

      num_modes = localwork%ewald_num_mode_local
      mode_offset = localwork%ewald_local_mode_offset

      !$acc data &
      !$acc present(ewald, ewald%zpoint, ewald%zweight, ions(:), electrodes(:), &
      !$acc        ewald%cos_kx_elec(:,0:kmax_x), ewald%sin_kx_elec(:,0:kmax_x), &
      !$acc        ewald%cos_ky_elec(:,0:kmax_y), ewald%sin_ky_elec(:,0:kmax_y), &
      !$acc        ewald%cos_kz_elec(:,0:kmax_z), ewald%sin_kz_elec(:,0:kmax_z), &
      !$acc        ewald%cos_kx_ions(:,0:kmax_x), ewald%sin_kx_ions(:,0:kmax_x), &
      !$acc        ewald%cos_ky_ions(:,0:kmax_y), ewald%sin_ky_ions(:,0:kmax_y), &
      !$acc        ewald%cos_kz_ions(:,0:kmax_z), ewald%sin_kz_ions(:,0:kmax_z), &
      !$acc        q_elec(:), dipoles(:,:)) copy(h)

      ! Long range contribution is computed in reciprocal space
      ! -------------------------------------------------------
      ! The sum over k-modes is symmetric
      !   -> we loop only on half of them and mulitply by 2.0
      ! Total number of modes
      !    (2*kmax_x+1)*(2*kmax_y+1)*nz
      ! Num modes executed globally
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
      ! Num modes executed by the local process (approx.)
      !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
      volfactor = 1.0_wp/box%area(3)

      !$acc parallel
      !$acc loop gang &
      !$acc private(imode, l, m, n, kx, ky, kz, mabs, nabs, sign_m, sign_n, knorm2, &
      !$acc         cos_kx, sin_kx, cos_ky, sin_ky, cos_kz, sin_kz, cos_kxky, sin_kxky, &
      !$acc         cos_kxkykz, sin_kxkykz, i, qi, Sk_alpha, &
      !$acc         Sk_cos, Sk_sin, Skmu_cos, Skmu_sin, Sk_cos_type, Sk_sin_type, &
      !$acc         Skmu_cos_type, Skmu_sin_type, kdotmu) &
      !$acc reduction(+:h)
      do imode = 1, num_modes
         call compute_kmode_index(num_pbc, kmax_x, kmax_y, kmax_z, imode+mode_offset, l, m, n)
         ! kx = l * twopi / box%length(1)
         kx = (real(l,wp)*twopi)*box_lengthx_rec
         ! ky = m*twopi / box%length(2)
         mabs = abs(m)
         sign_m = real(sign(1,m),wp)
         ky = (real(m,wp)*twopi)*box_lengthy_rec
         ! kz = zpoint(n)
         nabs = abs(n)
         sign_n = real(sign(1,n),wp)
         kz = sign_n*ewald%zpoint(nabs)

         ! Norm square of the k-mode vector
         knorm2 = kx*kx + ky*ky + kz*kz
         if (knorm2 <= ewald%knorm2_max) then
            !Melt charges
            Sk_cos = 0.0_wp
            Sk_sin = 0.0_wp
            !Melt dipoles
            Skmu_cos = 0.0_wp
            Skmu_sin = 0.0_wp
            ! Melt contribution to structure factor
            !$acc loop seq
            do itype = 1, num_ion_types
               qi = ions(itype)%charge
               Sk_cos_type = 0.0_wp
               Sk_sin_type = 0.0_wp
               Skmu_cos_type = 0.0_wp
               Skmu_sin_type = 0.0_wp
               !$acc loop vector reduction(+: Sk_cos_type, Sk_sin_type, Skmu_cos_type, Skmu_sin_type)
               do i = 1, ions(itype)%count
                  iion = ions(itype)%offset + i
                  cos_kx = ewald%cos_kx_ions(iion,l)
                  sin_kx = ewald%sin_kx_ions(iion,l)
                  cos_ky = ewald%cos_ky_ions(iion,mabs)
                  sin_ky = ewald%sin_ky_ions(iion,mabs)*sign_m
                  cos_kz = ewald%cos_kz_ions(iion,nabs)
                  sin_kz = ewald%sin_kz_ions(iion,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  Sk_cos_type = Sk_cos_type + qi*cos_kxkykz
                  Sk_sin_type = Sk_sin_type + qi*sin_kxkykz

                  kdotmu = dipoles(iion,1)*kx + dipoles(iion,2)*ky + dipoles(iion,3)*kz

                  Skmu_cos_type = Skmu_cos_type + kdotmu*cos_kxkykz
                  Skmu_sin_type = Skmu_sin_type + kdotmu*sin_kxkykz
               end do
               !$acc end loop
               Sk_cos = Sk_cos + Sk_cos_type
               Sk_sin = Sk_sin + Sk_sin_type
               Skmu_cos = Skmu_cos + Skmu_cos_type
               Skmu_sin = Skmu_sin + Skmu_sin_type
            end do
            !$acc end loop

            ! Electrodes contribution to structure factor
            !$acc loop seq
            do itype = 1, num_elec_types
               !Electrode charges
               Sk_cos_type = 0.0_wp
               Sk_sin_type = 0.0_wp
               !$acc loop vector reduction(+: Sk_cos_type, Sk_sin_type)
               do i = 1, electrodes(itype)%count
                  iion = electrodes(itype)%offset + i
                  cos_kx = ewald%cos_kx_elec(iion,l)
                  sin_kx = ewald%sin_kx_elec(iion,l)
                  cos_ky = ewald%cos_ky_elec(iion,mabs)
                  sin_ky = ewald%sin_ky_elec(iion,mabs)*sign_m
                  cos_kz = ewald%cos_kz_elec(iion,nabs)
                  sin_kz = ewald%sin_kz_elec(iion,nabs)*sign_n

                  cos_kxky = cos_kx*cos_ky - sin_kx*sin_ky
                  sin_kxky = sin_kx*cos_ky + cos_kx*sin_ky

                  cos_kxkykz = cos_kxky*cos_kz - sin_kxky*sin_kz
                  sin_kxkykz = sin_kxky*cos_kz + cos_kxky*sin_kz

                  Sk_cos_type = Sk_cos_type + q_elec(iion)*cos_kxkykz
                  Sk_sin_type = Sk_sin_type + q_elec(iion)*sin_kxkykz
               end do
               !$acc end loop
               Sk_cos = Sk_cos + Sk_cos_type
               Sk_sin = Sk_sin + Sk_sin_type
            end do
            !$acc end loop
            Sk_alpha = 2.0_wp*volfactor*ewald%zweight(nabs)*(exp(alphaconst*knorm2)/knorm2)
            !Sk_cos/sin have inside the contribution of melt and electrodes charges
            !E = (q+Q)*(q+Q) + (q+Q)*mu + mu*mu
            h = h + Sk_alpha*(Sk_cos*Sk_cos + Sk_sin*Sk_sin + &
                  2.0_wp*Sk_sin*Skmu_cos - 2.0_wp*Sk_cos*Skmu_sin + &
                  Skmu_cos*Skmu_cos + Skmu_sin*Skmu_sin)
         end if
      end do ! imode
      !$acc end loop
      !$acc end parallel
      !$acc end data
   end subroutine energy

   include 'update_kmode_index.inc'

end module MW_coulomb_lr_pim

!> This module defines a data structure to store process local work assignment
module MW_localwork
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_constants, only: pair_block_size
   implicit none
   private

   ! public types
   public :: MW_localwork_t

   ! public subroutines
   public :: define_type
   public :: void_type
   public :: print_type
   public :: setup_ewald_local_work
   public :: setup_pair_atom2atom_local_work
   public :: setup_pair_ion2ion_local_work
   public :: setup_pair_ion2ion_local_work_ms
   public :: setup_pair_ion2atom_local_work
   public :: setup_pair_ion2atom_local_work_ms
   public :: setup_pair_atom2ion_local_work
   public :: setup_atoms_local_work
   public :: setup_ions_local_work
   public :: setup_molecules_local_work
   public :: update_diag_block_boundaries
   public :: update_tri_block_boundaries
   public :: update_other_block_boundaries

   ! A data structure to hold comm, rank and group for a process
   type MW_localwork_t

      ! Parallel distribution of computation of Ewald reciprocal space sum
      integer :: ewald_num_mode_global = 0
      integer :: ewald_num_mode_local = 0
      integer :: ewald_local_mode_offset = 0
      integer :: ewald_kstart_x = 0
      integer :: ewald_kstart_y = 0
      integer :: ewald_kstart_z = 0

      ! Atom 2 Atom interactions
      ! ------------------------
      ! Parallel distribution of computation of pair interaction
      integer, allocatable :: pair_atom2atom_num_block_diag_local(:)
      integer, allocatable :: pair_atom2atom_num_block_full_local(:,:)
      integer, allocatable :: pair_atom2atom_diag_iblock_offset(:)
      integer, allocatable :: pair_atom2atom_full_iblock_offset(:,:)

      ! Ion 2 Ion interactions
      ! ----------------------
      ! Parallel distribution of computation of pair interaction
      integer, allocatable :: pair_ion2ion_num_block_diag_local(:)
      integer, allocatable :: pair_ion2ion_num_block_full_local(:,:)
      integer, allocatable :: pair_ion2ion_diag_iblock_offset(:)
      integer, allocatable :: pair_ion2ion_full_iblock_offset(:,:)

      integer :: pair_ion2ion_num_block_diag_local_ms
      integer :: pair_ion2ion_num_block_full_local_ms
      integer :: pair_ion2ion_diag_iblock_offset_ms
      integer :: pair_ion2ion_full_iblock_offset_ms

      ! Ion 2 Atoms interactions
      ! ------------------------
      ! Parallel distribution of computation of pair interaction
      integer, allocatable :: pair_ion2atom_num_block_full_local(:,:)
      integer, allocatable :: pair_ion2atom_full_iblock_offset(:,:)

      integer :: pair_ion2atom_num_block_full_local_ms
      integer :: pair_ion2atom_full_iblock_offset_ms

      ! Atom 2 Ion interactions
      ! ------------------------
      ! Parallel distribution of computation of pair interaction
      integer, allocatable :: pair_atom2ion_num_block_full_local(:,:)
      integer, allocatable :: pair_atom2ion_full_iblock_offset(:,:)

      ! Parallel distribution of atoms
      integer :: atoms_num_global = 0
      integer :: atoms_num_local = 0
      integer, allocatable :: offset_atoms(:) !< offset atoms for local work per type
      integer, allocatable :: count_atoms(:)  !< count atoms for local work per type

      ! Parallel distribution of ions
      integer :: ions_num_global = 0
      integer :: ions_num_local = 0
      integer, allocatable :: offset_ions(:) !< offset ions for local work per type
      integer, allocatable :: count_ions(:) !< offset ions for local work per type

      ! Parallel distribution of molecules
      integer :: molecules_num_global = 0
      integer :: molecules_num_local = 0
      integer, allocatable :: molecules_istart(:) !< start index for each molecule type
      integer, allocatable :: molecules_iend(:) !< end index for each molecule type

   end type MW_localwork_t

contains
   !================================================================================
   ! Define a parallel data structure
   subroutine define_type(this)
      implicit none
      type(MW_localwork_t), intent(inout) :: this

      ! Parallel distribution of computation of Ewald reciprocal space sum
      this%ewald_num_mode_global = 0
      this%ewald_num_mode_local = 0
      this%ewald_local_mode_offset = 0
      this%ewald_kstart_x = 0
      this%ewald_kstart_y = 0
      this%ewald_kstart_z = 0

      ! Parallel distribution of atoms
      this%atoms_num_global = 0
      this%atoms_num_local = 0

      ! Parallel distribution of ions
      this%ions_num_global = 0
      this%ions_num_local = 0

      ! Parallel distribution of molecules
      this%molecules_num_global = 0
      this%molecules_num_local = 0

   end subroutine define_type

   !================================================================================
   ! Void a parallel data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_localwork_t), intent(inout) :: this
      integer :: ierr

      if (allocated(this%offset_ions)) then
         deallocate(this%offset_ions, this%count_ions, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      if (allocated(this%molecules_istart)) then
         deallocate(this%molecules_istart, this%molecules_iend, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      if (allocated(this%offset_atoms)) then
         deallocate(this%offset_atoms, this%count_atoms, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      ! Parallel distribution of computation of Ewald reciprocal space sum
      this%ewald_num_mode_global = 0
      this%ewald_num_mode_local = 0
      this%ewald_local_mode_offset = 0
      this%ewald_kstart_x = 0
      this%ewald_kstart_y = 0
      this%ewald_kstart_z = 0

      ! Parallel distribution of computation of pair interaction
      if (allocated(this%pair_atom2atom_diag_iblock_offset)) then
         deallocate(this%pair_atom2atom_diag_iblock_offset, &
               this%pair_atom2atom_full_iblock_offset, &
               this%pair_atom2atom_num_block_diag_local, &
               this%pair_atom2atom_num_block_full_local, &
               stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      if (allocated(this%pair_ion2ion_diag_iblock_offset)) then
         deallocate(this%pair_ion2ion_diag_iblock_offset, &
               this%pair_ion2ion_full_iblock_offset, &
               this%pair_ion2ion_num_block_diag_local, &
               this%pair_ion2ion_num_block_full_local, &
               stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      if (allocated(this%pair_ion2atom_full_iblock_offset)) then
         deallocate(this%pair_ion2atom_full_iblock_offset, &
               this%pair_ion2atom_num_block_full_local, &
               stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      if (allocated(this%pair_atom2ion_full_iblock_offset)) then
         deallocate(this%pair_atom2ion_full_iblock_offset, &
               this%pair_atom2ion_num_block_full_local, &
               stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "localwork.f90", ierr)
         end if
      end if

      ! Parallel distribution of atoms
      this%atoms_num_global = 0
      this%atoms_num_local = 0

      ! Parallel distribution of ions
      this%ions_num_global = 0
      this%ions_num_local = 0

      ! Parallel distribution of molecules
      this%molecules_num_global = 0
      this%molecules_num_local = 0

   end subroutine void_type

   ! ================================================================================
   ! Print type
   subroutine print_type(this, ounit)
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(in) :: this
      integer, intent(in) :: ounit

      ! Local
      ! -----
      integer :: itype, jtype

      write(ounit,'("|localwork| k-modes assignment")')
      write(ounit,'("|localwork|    number of global k-modes: ", i8)') this%ewald_num_mode_global
      write(ounit,'("|localwork|    number of local  k-modes: ", i8)') this%ewald_num_mode_local
      write(ounit,'("|localwork|    offset of local  k-modes: ", i6)') this%ewald_local_mode_offset
      write(ounit,'("|localwork|    start k-mode index      : ", 3(i6,:,", "))') &
            this%ewald_kstart_x, this%ewald_kstart_y, this%ewald_kstart_z
      write(ounit,*)
      write(ounit,'("|localwork| electrode to electrode pair diagonal block assignment:")')
      write(ounit,'("|localwork| itype |  count | offset |")')
      do itype = 1, size(this%pair_atom2atom_num_block_diag_local,1)
         write(ounit,'("|localwork| ",i5," | ",i6," | ",i6," |")') &
              itype, this%pair_atom2atom_num_block_diag_local(itype), &
              this%pair_atom2atom_diag_iblock_offset(itype)
      end do
      write(ounit,*)
      write(ounit,'("|localwork| electrode to electrode pair block assignment:")')
      write(ounit,'("|localwork| itype | jtype |  count | offset |")')
      do itype = 1, size(this%pair_atom2atom_num_block_full_local,2)
         do jtype = 1, size(this%pair_atom2atom_num_block_full_local,1)
            write(ounit,'("|localwork| ",i5," | ",i5," | ",i6," | ",i6," |")') &
                 itype, jtype, this%pair_atom2atom_num_block_full_local(jtype,itype), &
                 this%pair_atom2atom_full_iblock_offset(jtype,itype)
         end do
      end do

      write(ounit,*)
      write(ounit,'("|localwork| electrolyte to electrolyte pair diagonal block assignment:")')
      write(ounit,'("|localwork| itype |  count | offset |")')
      do itype = 1, size(this%pair_ion2ion_num_block_diag_local,1)
         write(ounit,'("|localwork| ",i5," | ",i6," | ",i6," |")') &
              itype, this%pair_ion2ion_num_block_diag_local(itype), &
              this%pair_ion2ion_diag_iblock_offset(itype)
      end do
      write(ounit,*)
      write(ounit,'("|localwork| electrolyte to electrolyte pair block assignment:")')
      write(ounit,'("|localwork| itype | jtype |  count | offset |")')
      do itype = 1, size(this%pair_ion2ion_num_block_full_local,2)
         do jtype = 1, size(this%pair_ion2ion_num_block_full_local,1)
            write(ounit,'("|localwork| ",i5," | ",i5," | ",i6," | ",i6," |")') &
                 itype, jtype, this%pair_ion2ion_num_block_full_local(jtype,itype), &
                 this%pair_ion2ion_full_iblock_offset(jtype,itype)
         end do
      end do

      write(ounit,*)
      write(ounit,'("|localwork| electrode to electrolyte pair block assignment:")')
      write(ounit,'("|localwork| itype | jtype |  count | offset |")')
      do itype = 1, size(this%pair_atom2ion_num_block_full_local,2)
         do jtype = 1, size(this%pair_atom2ion_num_block_full_local,1)
            write(ounit,'("|localwork| ",i5," | ",i5," | ",i6," | ",i6," |")') &
                 itype, jtype, this%pair_atom2ion_num_block_full_local(jtype,itype), &
                 this%pair_atom2ion_full_iblock_offset(jtype,itype)
         end do
      end do

      write(ounit,*)
      write(ounit,'("|localwork| electrolyte to electrode pair block assignment:")')
      write(ounit,'("|localwork| itype | jtype |  count | offset |")')
      do itype = 1, size(this%pair_ion2atom_num_block_full_local,2)
         do jtype = 1, size(this%pair_ion2atom_num_block_full_local,1)
            write(ounit,'("|localwork| ",i5," | ",i5," | ",i6," | ",i6," |")') &
                 itype, jtype, this%pair_ion2atom_num_block_full_local(jtype,itype), &
                 this%pair_ion2atom_full_iblock_offset(jtype,itype)
         end do
      end do

      write(ounit,*)
      write(ounit,'("|localwork| electrode vector assignment")')
      write(ounit,'("|localwork|    number of global electrode atoms: ",i6)') &
            this%atoms_num_global
      write(ounit,'("|localwork|    number of local electrode atoms: ",i6)') &
            this%atoms_num_local
      write(ounit,'("|localwork|    electrode atoms local offset:     ",100(i6,:,", "))') &
            this%offset_atoms
      write(ounit,'("|localwork|    electrode atoms local count:      ",100(i6,:,", "))') &
            this%count_atoms

      write(ounit,*)
      write(ounit,'("|localwork| electrolyte vector assignment")')
      write(ounit,'("|localwork|    number of global electrolyte atoms: ",i6)') &
            this%ions_num_global
      write(ounit,'("|localwork|    number of local electrolyte atoms: ",i6)') &
            this%ions_num_local
      write(ounit,'("|localwork|    electrolyte atoms local offset:     ",100(i6,", ",:))') &
            this%offset_ions
      write(ounit,'("|localwork|    electrolyte atoms local count :     ",100(i6,", ",:))') &
            this%count_ions

      if (size(this%molecules_istart,1) > 0) then
         write(ounit,*)
         write(ounit,'("|localwork| molecules vector assignment")')
         write(ounit,'("|localwork|    number of global molecules: ",i6)') &
               this%molecules_num_global
         write(ounit,'("|localwork|    number of local molecules: ",i6)') &
               this%molecules_num_local
         write(ounit,'("|localwork|    molecules local istart:     ",100(i6,:,", "))') &
               this%molecules_istart
         write(ounit,'("|localwork|    molecules local iend:       ",100(i6,:,", "))') &
               this%molecules_iend
      end if

   end subroutine print_type

   !================================================================================
   ! Setup parallel distribution of work in Ewald reciprocal sum
   ! The sum over k-modes is symmetric
   !   -> we loop only on half of them and mulitply by 2.0
   ! Total number of modes
   !    (2*kmax_x+1)*(2*kmax_y+1)*nz
   ! Num modes in the exectude globally
   !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz
   ! Num modes executed by the local process (approx.)
   !    (2*kmax_x*kmax_y + kmax_x + kmax_y)*nz / num_rank
   subroutine setup_ewald_local_work(this, ewald, num_pbc, box, comm_size, comm_rank)
      use MW_kinds, only: wp
      use MW_constants, only: twopi
      use MW_ewald, only: MW_ewald_t, &
            MW_ewald_update_kmode_index => update_kmode_index
      use MW_box, only: MW_box_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_ewald_t), intent(in) :: ewald
      integer, intent(in) :: num_pbc
      type(MW_box_t), intent(in) :: box
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank
      ! Local
      ! -----
      integer :: imode, l, m, n, kstart_x, kstart_y, kstart_z
      integer :: num_modes_within_cutoff
      integer :: num_modes_global, num_modes_global_within_cutoff
      integer :: num_modes_local, num_modes_local_within_cutoff
      integer :: num_modes_global_before, imode_start
      real(wp) :: box_lengthx_rec, box_lengthy_rec
      real(wp) :: k(3), knorm2

      num_modes_local = 0
      kstart_x = 0
      kstart_y = 0
      kstart_z = 0

      select case (num_pbc)
      case (2)
         num_modes_global = ewald%kmax_x*(2*ewald%kmax_y+1)*(2*ewald%kmax_z+1) + &
              ewald%kmax_y*(2*ewald%kmax_z+1)
      case (3)
         num_modes_global = ewald%kmax_x*(2*ewald%kmax_y+1)*(2*ewald%kmax_z+1) + &
              ewald%kmax_y*(2*ewald%kmax_z+1) + ewald%kmax_z
      case default
         num_modes_global = 0
      end select
      
      box_lengthx_rec = 1.0_wp / box%length(1)
      box_lengthy_rec = 1.0_wp / box%length(2)
      k(:) = 0.0_wp

      ! Loop once through all modes to determine the number of effective modes
      num_modes_within_cutoff = 0

      select case (num_pbc)
      case (2)
         l = 0
         m = 1
         n = -ewald%kmax_z
      case (3)
         l = 0
         m = 0
         n = 1
      case default
         l = 0
         m = 0
         n = 0
      end select

      do imode = 1, num_modes_global
         ! k(1) = l * twopi / box%length(1)
         k(1) = (real(l,wp) * twopi) * box_lengthx_rec
         ! k(2) = m * twopi / box%length(2)
         k(2) = (real(m,wp) * twopi) * box_lengthy_rec
         ! k(3) = zpoint(n)
         k(3) = real(sign(1,n),wp) * ewald%zpoint(abs(n))

         ! Norm square of the k-mode vector
         knorm2 = k(1)*k(1) + k(2)*k(2) + k(3)*k(3)
         if (knorm2 <= ewald%knorm2_max) then
            num_modes_within_cutoff = num_modes_within_cutoff + 1
         end if
         ! Update k-mode parameters
         call MW_ewald_update_kmode_index(ewald, l, m, n)
      end do
      num_modes_global_within_cutoff = num_modes_within_cutoff

      ! Balance computational effort
      num_modes_local_within_cutoff = num_modes_global_within_cutoff / comm_size
      if (comm_rank < mod(num_modes_global_within_cutoff, comm_size)) then
         num_modes_local_within_cutoff = num_modes_local_within_cutoff + 1
      end if

      ! Determine the number of modes to skip before assigning them to this rank
      num_modes_global_before = comm_rank * (num_modes_global_within_cutoff / comm_size) &
            + min(comm_rank, mod(num_modes_global_within_cutoff, comm_size))

      ! Loop a second time to determine kstart_x, kstart_y, kstart_z
      select case (num_pbc)
      case (2)
         l = 0
         m = 1
         n = -ewald%kmax_z
      case (3)
         l = 0
         m = 0
         n = 1
      case default
         l = 0
         m = 0
         n = 0
      end select

      k(:) = 0.0_wp
      num_modes_within_cutoff = 0
      imode_start = 0
      do imode = 1, num_modes_global

         ! k(1) = l * twopi / box%length(1)
         k(1) = (real(l,wp) * twopi) * box_lengthx_rec
         ! k(2) = m * twopi / box%length(2)
         k(2) = (real(m,wp) * twopi) * box_lengthy_rec
         ! k(3) = zpoint(n)
         k(3) = real(sign(1,n),wp) * ewald%zpoint(abs(n))

         ! Norm square of the k-mode vector
         knorm2 = k(1)*k(1) + k(2)*k(2) + k(3)*k(3)
         if (knorm2 <= ewald%knorm2_max) then
            ! Store starting values for (l,m,n) when num_modes_global_before is reached
            if (num_modes_within_cutoff == num_modes_global_before) then
               if (imode_start == 0) then
                  imode_start = imode
                  kstart_x = l
                  kstart_y = m
                  kstart_z = n
               end if
            end if
            num_modes_within_cutoff = num_modes_within_cutoff + 1

            ! Stop searching when enough modes have been accounted for
            if (num_modes_within_cutoff == num_modes_global_before + num_modes_local_within_cutoff) then
               exit
            end if
         end if
         ! Update k-mode parameters
         call MW_ewald_update_kmode_index(ewald, l, m, n)
      end do
      num_modes_local = imode - imode_start + 1

      this%ewald_num_mode_global = num_modes_global
      this%ewald_num_mode_local = num_modes_local
      this%ewald_local_mode_offset = imode_start - 1
      this%ewald_kstart_x = kstart_x
      this%ewald_kstart_y = kstart_y
      this%ewald_kstart_z = kstart_z

   end subroutine setup_ewald_local_work

   !================================================================================
   ! Setup parallel distribution of work in atom 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block
   subroutine setup_pair_atom2atom_local_work(this, electrodes, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_electrode_t), intent(in) :: electrodes(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_types, itype, jtype
      integer :: ierr
      integer :: num_block_rows, num_block_columns
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_types = size(electrodes,1)

      allocate( &
            this%pair_atom2atom_num_block_diag_local(num_types), &
            this%pair_atom2atom_diag_iblock_offset(num_types), &
            this%pair_atom2atom_num_block_full_local(num_types, num_types), &
            this%pair_atom2atom_full_iblock_offset(num_types, num_types), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_pair_atom2atom_local_work", "localwork.f90", ierr)
      end if
      this%pair_atom2atom_num_block_diag_local(:) = 0
      this%pair_atom2atom_diag_iblock_offset(:) = 0
      this%pair_atom2atom_num_block_full_local(:,:) = 0
      this%pair_atom2atom_full_iblock_offset(:,:) = 0

      ! Distribute diagonal blocks
      pseudo_rank = comm_rank
      do itype = 1, num_types
         if (electrodes(itype)%count > 0) then
            num_block_global = (electrodes(itype)%count - 1) / pair_block_size + 1
            num_block_local = num_block_global / comm_size
            rank_cut = mod(num_block_global, comm_size)
            if (pseudo_rank < rank_cut) then
               num_block_local = num_block_local + 1
            end if
            if (num_block_local > 0) then
               iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                     min(pseudo_rank, rank_cut)
            else
               iblock_offset = 0
            end if

            this%pair_atom2atom_num_block_diag_local(itype) = num_block_local
            this%pair_atom2atom_diag_iblock_offset(itype) = iblock_offset
            pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
         end if
      end do

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...

      do itype = 1, num_types
         if (electrodes(itype)%count > 0) then
            num_block_rows = (electrodes(itype)%count - 1) / pair_block_size + 1
            do jtype = 1, itype-1
               if (electrodes(jtype)%count > 0) then
                  num_block_columns = (electrodes(jtype)%count - 1) / pair_block_size + 1
                  num_block_global = num_block_rows * num_block_columns

                  num_block_local = num_block_global / comm_size
                  rank_cut = mod(num_block_global, comm_size)
                  if (pseudo_rank < rank_cut) then
                     num_block_local = num_block_local + 1
                  end if
                  if (num_block_local > 0) then
                     iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                           min(pseudo_rank, rank_cut)
                  else
                     iblock_offset = 0
                  end if

                  this%pair_atom2atom_num_block_full_local(itype,jtype) = num_block_local
                  this%pair_atom2atom_full_iblock_offset(itype,jtype) = iblock_offset
                  pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
               end if
            end do

            num_block_global = num_block_rows * (num_block_rows-1) / 2
            num_block_local = num_block_global / comm_size
            rank_cut = mod(num_block_global, comm_size)
            if (pseudo_rank < rank_cut) then
               num_block_local = num_block_local + 1
            end if
            if (num_block_local > 0) then
               iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                     min(pseudo_rank, rank_cut)
            else
               iblock_offset = 0
            end if

            this%pair_atom2atom_num_block_full_local(itype,itype) = num_block_local
            this%pair_atom2atom_full_iblock_offset(itype,itype) = iblock_offset
            pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
         end if
      end do
   end subroutine setup_pair_atom2atom_local_work

   !================================================================================
   ! Setup parallel distribution of work in atom 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block
   subroutine setup_pair_ion2ion_local_work(this, ions, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_ion_t), intent(in) :: ions(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: num_block_rows, num_block_columns
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_types, itype, jtype
      integer :: ierr
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_types = size(ions,1)

      allocate( &
            this%pair_ion2ion_num_block_diag_local(num_types), &
            this%pair_ion2ion_diag_iblock_offset(num_types), &
            this%pair_ion2ion_num_block_full_local(num_types, num_types), &
            this%pair_ion2ion_full_iblock_offset(num_types, num_types), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_pair_ion2ion_local_work", "localwork.f90", ierr)
      end if
      this%pair_ion2ion_num_block_diag_local(:) = 0
      this%pair_ion2ion_diag_iblock_offset(:) = 0
      this%pair_ion2ion_num_block_full_local(:,:) = 0
      this%pair_ion2ion_full_iblock_offset(:,:) = 0

      ! Distribute diagonal blocks
      pseudo_rank = comm_rank
      do itype = 1, num_types
         if (ions(itype)%count > 0) then
            num_block_global = (ions(itype)%count - 1) / pair_block_size + 1
            num_block_local = num_block_global / comm_size
            rank_cut = mod(num_block_global, comm_size)
            if (pseudo_rank < rank_cut) then
               num_block_local = num_block_local + 1
            end if
            if (num_block_local > 0) then
               iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                     min(pseudo_rank, rank_cut)
            else
               iblock_offset = 0
            end if

            this%pair_ion2ion_num_block_diag_local(itype) = num_block_local
            this%pair_ion2ion_diag_iblock_offset(itype) = iblock_offset
            pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
         end if
      end do

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...

      do itype = 1, num_types
         if (ions(itype)%count > 0) then
            num_block_rows = (ions(itype)%count - 1) / pair_block_size + 1
            do jtype = 1, itype-1
               if (ions(jtype)%count > 0) then
                  num_block_columns = (ions(jtype)%count - 1) / pair_block_size + 1
                  num_block_global = num_block_rows * num_block_columns
                  num_block_local = num_block_global / comm_size
                  rank_cut = mod(num_block_global, comm_size)
                  if (pseudo_rank < rank_cut) then
                     num_block_local = num_block_local + 1
                  end if
                  if (num_block_local > 0) then
                     iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                           min(pseudo_rank, rank_cut)
                  else
                     iblock_offset = 0
                  end if
                  this%pair_ion2ion_num_block_full_local(itype,jtype) = num_block_local
                  this%pair_ion2ion_full_iblock_offset(itype,jtype) = iblock_offset
                  pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
               end if
            end do

            ! Triangle of blocks
            num_block_global = num_block_rows * (num_block_rows-1) / 2
            num_block_local = num_block_global / comm_size
            rank_cut = mod(num_block_global, comm_size)
            if (pseudo_rank < rank_cut) then
               num_block_local = num_block_local + 1
            end if
            if (num_block_local > 0) then
               iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                     min(pseudo_rank, rank_cut)
            else
               iblock_offset = 0
            end if

            this%pair_ion2ion_num_block_full_local(itype,itype) = num_block_local
            this%pair_ion2ion_full_iblock_offset(itype,itype) = iblock_offset
            pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
         end if
      end do

   end subroutine setup_pair_ion2ion_local_work

   !================================================================================
   ! Setup parallel distribution of work in atom 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block
   subroutine setup_pair_ion2ion_local_work_ms(this, ions, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_ion_t), intent(in) :: ions(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: num_block_rows
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_types, itype, num_ions
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_ions = 0
      num_types = size(ions,1)
      do itype = 1, num_types
         num_ions = num_ions+ions(itype)%count
      enddo

      this%pair_ion2ion_num_block_diag_local_ms = 0
      this%pair_ion2ion_diag_iblock_offset_ms = 0
      this%pair_ion2ion_num_block_full_local_ms = 0
      this%pair_ion2ion_full_iblock_offset_ms = 0

      ! Distribute diagonal blocks
      pseudo_rank = comm_rank
      num_block_global = (num_ions - 1) / pair_block_size + 1
      num_block_local = num_block_global / comm_size
      rank_cut = mod(num_block_global, comm_size)
      if (pseudo_rank < rank_cut) then
         num_block_local = num_block_local + 1
      end if
      if (num_block_local > 0) then
         iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
               min(pseudo_rank, rank_cut)
      else
         iblock_offset = 0
      end if

      this%pair_ion2ion_num_block_diag_local_ms = num_block_local
      this%pair_ion2ion_diag_iblock_offset_ms = iblock_offset
      pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...

      num_block_rows = (num_ions - 1) / pair_block_size + 1
      ! Triangle of blocks
      num_block_global = num_block_rows * (num_block_rows-1) / 2
      num_block_local = num_block_global / comm_size
      rank_cut = mod(num_block_global, comm_size)
      if (pseudo_rank < rank_cut) then
         num_block_local = num_block_local + 1
      end if
      if (num_block_local > 0) then
         iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
               min(pseudo_rank, rank_cut)
      else
         iblock_offset = 0
      end if

      this%pair_ion2ion_num_block_full_local_ms = num_block_local
      this%pair_ion2ion_full_iblock_offset_ms = iblock_offset
      pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)

   end subroutine setup_pair_ion2ion_local_work_ms

   !================================================================================
   ! Setup parallel distribution of work in ion 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block
   subroutine setup_pair_ion2atom_local_work(this, electrodes, ions, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_electrode_t), intent(in) :: electrodes(:)
      type(MW_ion_t), intent(in) :: ions(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: num_block_rows, num_block_columns
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_itypes, num_jtypes, itype, jtype
      integer :: ierr
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_itypes = size(electrodes,1)
      num_jtypes = size(ions,1)

      allocate( &
            this%pair_ion2atom_num_block_full_local(num_itypes, num_jtypes), &
            this%pair_ion2atom_full_iblock_offset(num_itypes, num_jtypes), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_pair_ion2atom_local_work", "localwork.f90", ierr)
      end if
      this%pair_ion2atom_num_block_full_local(:,:) = 0
      this%pair_ion2atom_full_iblock_offset(:,:) = 0

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...
      pseudo_rank = comm_rank
      do itype = 1, num_itypes
         if (electrodes(itype)%count > 0) then
            num_block_rows = (electrodes(itype)%count - 1) / pair_block_size + 1
            do jtype = 1, num_jtypes
               if (ions(jtype)%count > 0) then
                  num_block_columns = (ions(jtype)%count - 1) / pair_block_size + 1
                  num_block_global = num_block_rows * num_block_columns

                  num_block_local = num_block_global / comm_size
                  rank_cut = mod(num_block_global, comm_size)
                  if (pseudo_rank < rank_cut) then
                     num_block_local = num_block_local + 1
                  end if
                  if (num_block_local > 0) then
                     iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                           min(pseudo_rank, rank_cut)
                  else
                     iblock_offset = 0
                  end if

                  this%pair_ion2atom_num_block_full_local(itype,jtype) = num_block_local
                  this%pair_ion2atom_full_iblock_offset(itype,jtype) = iblock_offset
                  pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
               end if
            end do
         end if
      end do

   end subroutine setup_pair_ion2atom_local_work

   !================================================================================
   ! Setup parallel distribution of work in ion 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block 
   ! MS modifications for GPUs
   subroutine setup_pair_ion2atom_local_work_ms(this, electrodes, ions, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_electrode_t), intent(in) :: electrodes(:)
      type(MW_ion_t), intent(in) :: ions(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: num_block_rows, num_block_columns
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_itypes, num_jtypes, itype, jtype
      integer :: num_ions, num_elec_atoms
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_itypes = size(electrodes,1)
      num_jtypes = size(ions,1)

      num_elec_atoms = 0
      do itype = 1, num_itypes
         num_elec_atoms = num_elec_atoms + electrodes(itype)%count
      enddo

      num_ions = 0
      do jtype = 1, num_jtypes
         num_ions = num_ions + ions(jtype)%count
      enddo

      this%pair_ion2atom_num_block_full_local_ms = 0
      this%pair_ion2atom_full_iblock_offset_ms = 0

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...
      pseudo_rank = comm_rank
      num_block_rows = (num_elec_atoms - 1) / pair_block_size + 1
      num_block_columns = (num_ions - 1) / pair_block_size + 1
      num_block_global = num_block_rows * num_block_columns

      num_block_local = num_block_global / comm_size
      rank_cut = mod(num_block_global, comm_size)
      if (pseudo_rank < rank_cut) then
         num_block_local = num_block_local + 1
      end if
      if (num_block_local > 0) then
         iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
               min(pseudo_rank, rank_cut)
      else
         iblock_offset = 0
      end if

      this%pair_ion2atom_num_block_full_local_ms = num_block_local
      this%pair_ion2atom_full_iblock_offset_ms = iblock_offset
      pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)

   end subroutine setup_pair_ion2atom_local_work_ms
   !================================================================================
   ! Setup parallel distribution of work in ion 2 atom pair interactions
   !
   ! Interaction are symmetric and the work is divided into block
   subroutine setup_pair_atom2ion_local_work(this, ions, electrodes, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_ion_t), intent(in) :: ions(:)
      type(MW_electrode_t), intent(in) :: electrodes(:)
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Local
      ! -----
      integer :: num_block_global, num_block_local
      integer :: num_block_rows, num_block_columns
      integer :: iblock_offset
      integer :: pseudo_rank, rank_cut
      integer :: num_itypes, num_jtypes, itype, jtype
      integer :: ierr
      num_block_global = 0
      num_block_local = 0
      iblock_offset = 0
      rank_cut = 0

      num_itypes = size(ions,1)
      num_jtypes = size(electrodes,1)

      allocate( &
            this%pair_atom2ion_num_block_full_local(num_itypes, num_jtypes), &
            this%pair_atom2ion_full_iblock_offset(num_itypes, num_jtypes), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_pair_atom2ion_local_work", "localwork.f90", ierr)
      end if
      this%pair_atom2ion_num_block_full_local(:,:) = 0
      this%pair_atom2ion_full_iblock_offset(:,:) = 0

      ! Distribute off-diagonal blocks
      ! Shift rank such that ranks with less diagonal block get more full block
      ! in priority
      !
      ! ...
      ! rank_cut-1 -> size-1
      ! rank_cut   -> 0
      ! rank_cut+1 -> 1
      ! ...
      pseudo_rank = comm_rank
      do itype = 1, num_itypes
         if (ions(itype)%count> 0) then
            num_block_rows = (ions(itype)%count - 1) / pair_block_size + 1

            do jtype = 1, num_jtypes
               if (electrodes(jtype)%count > 0) then
                  num_block_columns = (electrodes(jtype)%count - 1) / pair_block_size + 1
                  num_block_global = num_block_rows * num_block_columns

                  num_block_local = num_block_global / comm_size
                  rank_cut = mod(num_block_global, comm_size)
                  if (pseudo_rank < rank_cut) then
                     num_block_local = num_block_local + 1
                  end if
                  if (num_block_local > 0) then
                     iblock_offset = pseudo_rank * (num_block_global / comm_size) + &
                           min(pseudo_rank, rank_cut)
                  else
                     iblock_offset = 0
                  end if
                  this%pair_atom2ion_num_block_full_local(itype,jtype) = num_block_local
                  this%pair_atom2ion_full_iblock_offset(itype,jtype) = iblock_offset
                  pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
               end if
            end do
         end if
      end do

   end subroutine setup_pair_atom2ion_local_work

   ! ================================================================================
   ! Setup parallel work on ions vector
   !
   subroutine setup_ions_local_work(this, ions, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameter
      ! ---------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_ion_t), intent(in) :: ions(:) !< global ions offset by ion_types
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Locals
      ! ------
      integer :: pseudo_rank, rank_cut
      integer :: num_global, num_local
      integer :: num_itype_global, num_itype_local
      integer :: num_ion_types, itype
      integer :: ierr

      num_ion_types = size(ions,1)

      allocate(this%offset_ions(num_ion_types), this%count_ions(num_ion_types), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_ions_local_work", "localwork.f90", ierr)
      end if
      this%offset_ions(:) = 0
      this%count_ions(:) = 0

      pseudo_rank = comm_rank
      num_global = 0
      num_local = 0
      do itype = 1, num_ion_types
         num_itype_global = ions(itype)%count
         num_itype_local = num_itype_global / comm_size
         rank_cut = mod(num_itype_global, comm_size)
         if (pseudo_rank < rank_cut) then
            num_itype_local = num_itype_local + 1
         end if
         this%count_ions(itype) = num_itype_local
         if (num_itype_local > 0) then
            this%offset_ions(itype) = pseudo_rank * (num_itype_global / comm_size) + &
                  min(pseudo_rank, rank_cut) + ions(itype)%offset
         end if
         num_global = num_global + num_itype_global
         num_local = num_local + num_itype_local
         pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
      end do
      this%ions_num_global = num_global
      this%ions_num_local = num_local

   end subroutine setup_ions_local_work

   ! ================================================================================
   ! Setup parallel work on atoms vector
   !
   subroutine setup_atoms_local_work(this, electrodes, comm_size, comm_rank)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameter
      ! ---------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_electrode_t), intent(in) :: electrodes(:) !< global atoms offset by atom_types
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Locals
      ! ------
      integer :: pseudo_rank, rank_cut
      integer :: num_global, num_local, num_itype_global, num_itype_local
      integer :: num_atom_types, itype
      integer :: ierr

      num_atom_types = size(electrodes,1)

      allocate(this%offset_atoms(num_atom_types), this%count_atoms(num_atom_types), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_atoms_local_work", "localwork.f90", ierr)
      end if
      this%offset_atoms(:) = 0
      this%count_atoms(:) = 0

      pseudo_rank = comm_rank
      num_global = 0
      num_local = 0
      do itype = 1, num_atom_types
         num_itype_global = electrodes(itype)%count
         num_itype_local = num_itype_global / comm_size
         rank_cut = mod(num_itype_global, comm_size)
         if (pseudo_rank < rank_cut) then
            num_itype_local = num_itype_local + 1
         end if
         this%count_atoms(itype) = num_itype_local
         if (num_itype_local > 0) then
            this%offset_atoms(itype) = pseudo_rank * (num_itype_global / comm_size) + &
                  min(pseudo_rank, rank_cut) + electrodes(itype)%offset
         end if
         num_global = num_global + num_itype_global
         num_local = num_local + num_itype_local
         pseudo_rank = mod(pseudo_rank + comm_size - rank_cut, comm_size)
      end do
      this%atoms_num_global = num_global
      this%atoms_num_local = num_local

   end subroutine setup_atoms_local_work

   ! ================================================================================
   ! Setup parallel work on arrays of molecules
   !
   subroutine setup_molecules_local_work(this, molecules, comm_size, comm_rank)
      use MW_molecule, only: MW_molecule_t
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameter
      ! ---------
      type(MW_localwork_t), intent(inout) :: this
      type(MW_molecule_t), intent(in) :: molecules(:) !< Molecule definition
      integer, intent(in) :: comm_size
      integer, intent(in) :: comm_rank

      ! Locals
      ! ------
      integer :: pseudo_rank, rank_cut
      integer :: num_global, num_local, istart, iend
      integer :: num_molecule_types, num_molecules, itype
      integer :: ierr

      num_molecule_types = size(molecules,1)
      num_molecules = 0
      do itype = 1, num_molecule_types
         num_molecules = num_molecules + molecules(itype)%n
      end do

      allocate(this%molecules_istart(num_molecule_types), &
            this%molecules_iend(num_molecule_types), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("setup_molecules_local_work", "localwork.f90", ierr)
      end if
      this%molecules_istart(:) = 0
      this%molecules_iend(:) = 0


      pseudo_rank = comm_rank
      call setup_vector_local_work(comm_size, pseudo_rank, num_molecules, &
         rank_cut, num_global, num_local, istart)

      this%molecules_num_global = num_global
      this%molecules_num_local = num_local

      iend = istart + num_local - 1
      num_molecules = 0
      do itype = 1, num_molecule_types
         this%molecules_istart(itype) = max(1, istart - num_molecules)
         this%molecules_iend(itype) = min(molecules(itype)%n, iend - num_molecules)
         num_molecules = num_molecules + molecules(itype)%n
      end do

   end subroutine setup_molecules_local_work

   ! ================================================================================
   ! Setup parallel distribution of work on 1D vector
   !
   subroutine setup_vector_local_work(comm_size, comm_rank, n, &
         rank_cut, num_global, num_local, istart)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: comm_size         !< parallel size
      integer, intent(in) :: comm_rank         !< parallel rank
      integer, intent(in) :: n            !< Global vector size

      integer, intent(inout) :: rank_cut  !< Index of cutoff rank (rank<rank_cut have 1 more block rank>=rank_cut)
      integer, intent(inout) :: num_global !< Global vector size
      integer, intent(inout) :: num_local  !< Local vector size
      integer, intent(inout) :: istart     !< Beginning of local vector in global vector

      num_global = n
      num_local = n / comm_size
      rank_cut = mod(num_global, comm_size)
      if (comm_rank < rank_cut) then
         num_local = num_local + 1
      end if

      istart = comm_rank*(num_global / comm_size) + min(comm_rank, rank_cut) + 1
   end subroutine setup_vector_local_work

   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_localwork

module MW_ions_radius
   use MW_stdio
   use MW_kinds, only: wp
   use MW_algorithms, only: MW_algorithms_t
   use MW_cgaim, only: MW_cgaim_t
   use MW_system, only: MW_system_t
   use MW_ion, only: MW_ion_t

   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: compute

contains

   !================================================================================
   !> Compute charges on electrode
   !!
   !! The charge is evaluated by minimizing the Coulomb energy of the system
   !!
   !! The energy can be cast into E = Q*AQ - Q*b + c
   !!
   !! where Q  is the vector of charges on the electrodes
   !!       b  is the potential felt by the electrode due to the melt ions
   !!       AQ is the potential felt by the electrode du to other electrode atoms
   !!       c  is the energy due to melt ions interactions
   !!       *  denotes the transpose of a vector/matrix
   !!
   !! By construction A is a matrix symmetric positive definite
   !! The preconditioned conjugate gradient algorithm is used to find a solution to
   !! the system
   !!
!  subroutine compute(system,cgaim, algorithms)
   subroutine compute(system,algorithms)
      use MW_cgaim, only: MW_cgaim_solve => solve
      use MW_ion, only: MW_ion_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_system_t), intent(inout) :: system !< system parameters
!     type(MW_cgaim_t), intent(in) :: cgaim !< system parameters
      type(MW_algorithms_t), intent(inout) :: algorithms !< cg algorithm parameters

      ! Local
      ! -----
      integer :: num,radius_ions_now!,itmax
      real(wp), allocatable, dimension(:)     :: p
!      real(wp) :: tolaim,ftolaim

!     padding=mod(system%num_ions,cache_line_size)
      num=system%num_ions
!     if(padding>0)num=num+cache_line_size+padding

!     num=system%ions(system%num_ion_types)%count
!     write(6,*)size(system%deltas_ions,1)
!     write(6,*)size(system%epsilons_ions,1)
!     write(6,*)size(system%dipoles_ions,1)

      allocate(p(num*4))

!     itmax=cgaim%max_iterations
!     tolaim=cgaim%tol
!     ftolaim=cgaim%tol

      radius_ions_now=system%radius_ions_step(1)

      p(1:num)=system%deltas_ions(1:num,radius_ions_now)
      p(num+1:2*num)=system%epsilons_ions(1:num,1,radius_ions_now)
      p(2*num+1:3*num)=system%epsilons_ions(1:num,2,radius_ions_now)
      p(3*num+1:4*num)=system%epsilons_ions(1:num,3,radius_ions_now)

      call MW_cgaim_solve(algorithms%cgaim,system,p,num)
!     call MW_cgaim_solve(system,p,num,itmax,tolaim,ftolaim)

      system%deltas_ions(1:num,radius_ions_now)=p(1:num)
      system%epsilons_ions(1:num,1,radius_ions_now)=p(num+1:2*num)
      system%epsilons_ions(1:num,2,radius_ions_now)=p(2*num+1:3*num)
      system%epsilons_ions(1:num,3,radius_ions_now)=p(3*num+1:4*num)

   end subroutine compute

   ! ================================================================================

end module MW_ions_radius

!> Define a species type data structure
!!
module MW_species
   use MW_kinds, only: wp
   use MW_species_parameters, only: &
         SPECIES_NAME_LENGTH, &
         CHARGE_TYPE_NEUTRAL, CHARGE_TYPE_POINT, CHARGE_TYPE_GAUSSIAN
   implicit none
   private

   ! public types
   public :: MW_species_t

   ! public subroutines
   public :: void_type
   public :: print_type
   public :: set_molecule
   public :: set_electrode
   public :: identify
   public :: read_parameters
   public :: set_offsets

   ! Species datatype
   type MW_species_t
      character(len=SPECIES_NAME_LENGTH) :: name = ""     !< name
      integer                          :: index = 0       !< index of the species type
      integer                          :: count = 0       !< number of species of this type
      integer                          :: offset = 0      !< Offset in species data arrays

      ! Mobility parameters
      logical                          :: is_mobile = .true. !< does species move or not?

      ! Mobility parameters
      logical                          :: is_fourth_site = .false. 

      ! Mass parameters
      real(wp)                         :: mass = 0.0_wp       !< mass
      real(wp)                         :: mass_rec = 0.0_wp   !< inverse of mass

      ! Electrostatic parameters
      integer  :: charge_type = 0              !< species charge type
      real(wp) :: charge = 0.0_wp              !< electric charge
      real(wp) :: polarizability = 0.0_wp      !< polarizability
      real(wp) :: eta = 0.0_wp                 !< gaussian charge width
      logical  :: has_constant_charge = .true. !< do all species have the same constant charge during the simulation?
                                               !! .false. for species in electrodes with constant potential
      logical  :: is_polarizable = .false.     !< is the species polarizable?
      ! Dumping parameters
      logical  :: dump_efg = .false.           !< is the efg data dumped for this species?
      logical  :: dump_lammps = .true.         !< is the lammps data dumped for this species?
      logical  :: dump_xyz = .true.            !< is the xyz data dumped for this species?
      logical  :: dump_trajectories = .true.   !< is the trajectories data dumped for this species?
      logical  :: dump_pdb = .true.            !< is the pdb data dumped for this species?
      ! Deformation parameters
      real(wp) :: selfdaimD = 0.0_wp
      real(wp) :: selfdaimbeta = 0.0_wp
      real(wp) :: selfdaimzeta = 0.0_wp
      logical  :: is_deformable = .false.     !< is the species deformable?
      ! Species attributes
      logical :: in_molecule = .false.  !< does this species belong to a molecule
      character(len=SPECIES_NAME_LENGTH) :: molecule_name = "" !< name of the molecule it belongs to
      integer :: molecule_index = 0           !< index of the molecule it belongs to

      logical :: in_electrode = .false. !< does this species belong to an electrode
      character(len=SPECIES_NAME_LENGTH) :: electrode_name = "" !< name of the electrode it belongs to
      integer :: electrode_index = 0          !< index of the electrode it belongs to
   end type MW_species_t

contains

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      implicit none
      type(MW_species_t), intent(inout) :: this

      this%name   = ""
      this%count  = 0
      this%offset = 0
      this%is_mobile = .false.
      this%mass = 0.0_wp
      this%mass_rec = 0.0_wp
      this%charge_type = 0
      this%charge = 0.0_wp
      this%polarizability = 0.0_wp
      this%selfdaimD = 0.0_wp
      this%selfdaimbeta = 0.0_wp
      this%selfdaimzeta = 0.0_wp
      this%eta = 0.0_wp
      this%has_constant_charge = .false.
      this%is_polarizable = .false.
      this%is_deformable = .false.
      this%in_molecule = .false.
      this%dump_efg = .false.
      this%dump_lammps = .true.
      this%dump_xyz = .true.
      this%dump_trajectories = .true.
      this%dump_pdb = .true.
      this%molecule_name = ""
      this%molecule_index = 0
      this%in_electrode = .false.
      this%electrode_name = ""
      this%electrode_index = 0

   end subroutine void_type

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, ounit)
      implicit none
      type(MW_species_t), intent(in) :: this          ! structure to be printed
      integer,        intent(in) :: ounit         ! output unit

      write(ounit,'("|species| name: ",a16)') this%name
      write(ounit,'("|species| count: ",i8," offset: ", i8)') this%count, this%offset
      write(ounit,'("|species| mass: ",es12.5)') this%mass
      if (this%is_mobile) then
         write(ounit,'("|species| mobile: ",a3)') "yes"
      else
         write(ounit,'("|species| mobile: ",a3)') " no"
      end if

      select case(this%charge_type)
      case(CHARGE_TYPE_NEUTRAL)
         write(ounit,'("|species| charge type: ",a8)') " neutral"
      case(CHARGE_TYPE_POINT)
         write(ounit,'("|species| charge type: ",a8," charge: ",es12.5)') "   point", this%charge
      case(CHARGE_TYPE_GAUSSIAN)
         write(ounit,'("|species| charge type: ",a8," charge: ",es12.5," eta: ",es12.5)') &
               "gaussian", this%charge, this%eta
      case default
         write(ounit,'("|species| charge type: ???")')
      end select

      if (this%is_polarizable) then
      write(ounit,'("|species| polarizability: ",es12.5)') this%polarizability
      else
         write(ounit,'("|species| species is not polarizable.")')
      end if
      if (this%is_deformable) then
      write(ounit,'("|species| parameters for deformability D: ",es12.5," beta: ",es12.5,"zeta: ",es12.5)') &
           this%selfdaimD,this%selfdaimbeta,this%selfdaimzeta
      else
         write(ounit,'("|species| species is not deformable.")')
      end if


      if (this%in_molecule) then
         write(ounit,'("|species| species belongs to molecule ",a8," (",i3,")")') &
               this%molecule_name, this%molecule_index
      else
         write(ounit,'("|species| species does not belong to any molecule.")')
      end if

      if (this%in_electrode) then
         write(ounit,'("|species| species belongs to electrode ",a8," (",i3,")")') &
               this%electrode_name, this%electrode_index
      else
         write(ounit,'("|species| species does not belong to any electrode.")')
      end if

   end subroutine print_type

   !================================================================================
   ! Search for an species in a list and return the index in the list
   !
   ! The first matching index is returned.
   ! 0 is returned if no match found
   subroutine identify(species_name, species, species_index)
      implicit none
      character(*),                 intent(in)  :: species_name  ! name of species to search
      type(MW_species_t), dimension(:), intent(in)  :: species      ! list of species
      integer,                      intent(out) :: species_index ! index of species in the list

      integer :: i

      species_index = 0
      do i = 1, size(species,1)
         if (species_name == species(i)%name) then
            species_index = i
            exit
         end if
      end do
   end subroutine identify

   !================================================================================
   !> Set the name of the species
   !>
   subroutine set_name(this, name)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      character(len=*),   intent(in)    :: name
      this%name = name
   end subroutine set_name

   !================================================================================
   !> Set the count of the species
   !>
   subroutine set_count(this, count)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      integer, intent(in) :: count !< number of particles of this species type
      this%count = count
   end subroutine set_count

   !================================================================================
   !> Set the mass parameters
   !>
   subroutine set_mass(this, mass)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      real(wp),           intent(in)    :: mass   ! mass values
      this%mass = mass
      if (mass > 0.0_wp) then
         this%mass_rec = 1.0_wp / mass
      else
         this%mass_rec = 0.0_wp
      end if
   end subroutine set_mass

   !================================================================================
   ! Set the mobility attribute of the species
   !
   subroutine set_mobility(this, mobile)
      implicit none
      type(MW_species_t), intent(inout) :: this     ! species
      logical,        intent(in)    :: mobile   ! can this species move?
      this%is_mobile = mobile
   end subroutine set_mobility

   !================================================================================
   ! Set if the atom is a fourth_site atom
   !
   subroutine set_fourth_site(this, fourth_site)
      implicit none
      type(MW_species_t), intent(inout) :: this     ! species
      logical,        intent(in)    :: fourth_site
      this%is_fourth_site = fourth_site
   end subroutine set_fourth_site

   !================================================================================
   ! Set the efg flag for the species
   !
   subroutine set_dump_efg(this, dump_efg)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      logical,        intent(in)    :: dump_efg   ! do we need efg for this species?
      this%dump_efg = dump_efg
   end subroutine set_dump_efg

   !================================================================================
   ! Set the lammps flag for the species
   !
   subroutine set_dump_lammps(this, dump_lammps)
      implicit none
      type(MW_species_t), intent(inout) :: this      ! species
      logical,        intent(in)    :: dump_lammps   ! do we need lammps data for this species?
      this%dump_lammps = dump_lammps
   end subroutine set_dump_lammps

   !================================================================================
   ! Set the xyz flag for the species
   !
   subroutine set_dump_xyz(this, dump_xyz)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      logical,        intent(in)    :: dump_xyz   ! do we need xyz data for this species?
      this%dump_xyz = dump_xyz
   end subroutine set_dump_xyz

   !================================================================================
   ! Set the trajectories flag for the species
   !
   subroutine set_dump_trajectories(this, dump_trajectories)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      logical,        intent(in)    :: dump_trajectories   ! do we need trajectories data for this species?
      this%dump_trajectories = dump_trajectories
   end subroutine set_dump_trajectories

   !================================================================================
   ! Set the pdb flag for the species
   !
   subroutine set_dump_pdb(this, dump_pdb)
      implicit none
      type(MW_species_t), intent(inout) :: this   ! species
      logical,        intent(in)    :: dump_pdb   ! do we need pdb data for this species?
      this%dump_pdb = dump_pdb
   end subroutine set_dump_pdb

   !================================================================================
   ! Set neutral charge type
   !
   subroutine set_charge_neutral(this)
      implicit none
      type(MW_species_t), intent(inout) :: this     ! species
      this%charge_type = CHARGE_TYPE_NEUTRAL
      this%charge = 0.0_wp
      this%eta = 0.0_wp
   end subroutine set_charge_neutral

   !================================================================================
   ! Set point-charge type
   !
   subroutine set_charge_point(this, charge)
      implicit none
      type(MW_species_t), intent(inout) :: this  !< species
      real(wp), intent(in) :: charge             !< charge of the species type
      this%charge_type = CHARGE_TYPE_POINT
      this%charge = charge
      this%eta = 0.0_wp
   end subroutine set_charge_point

   !================================================================================
   ! Set gaussian-charge type
   !
   subroutine set_charge_gaussian(this, charge, eta)
      implicit none
      type(MW_species_t), intent(inout) :: this  !< species
      real(wp), intent(in) :: charge             !< charge of the species type
      real(wp), intent(in) :: eta                !< gaussian width parameter
      this%charge_type = CHARGE_TYPE_GAUSSIAN
      this%charge = charge
      this%eta = eta
   end subroutine set_charge_gaussian

   !================================================================================
   !> Set the polarizability parameters
   !>
   subroutine set_polarizability(this, polarizability)
      implicit none
      type(MW_species_t), intent(inout) :: this             ! species
      real(wp),           intent(in)    :: polarizability   ! polarizability values
      this%polarizability = polarizability
   end subroutine set_polarizability

   !================================================================================
   !> Set the polarizability parameters
   !>
   subroutine set_deformability(this, selfdaimD, selfdaimbeta, selfdaimzeta)
      implicit none
      type(MW_species_t), intent(inout) :: this             ! species
      real(wp),           intent(in)    :: selfdaimD
      real(wp),           intent(in)    :: selfdaimbeta
      real(wp),           intent(in)    :: selfdaimzeta
      this%selfdaimD =selfdaimD
      this%selfdaimbeta =selfdaimbeta
      this%selfdaimzeta =selfdaimzeta
   end subroutine set_deformability

   !================================================================================
   ! Set whether the ion is polarizable
   !
   subroutine set_polarizable(this, polarizable)
      implicit none
      type(MW_species_t), intent(inout) :: this    !< species
      logical,        intent(in)    :: polarizable ! is the species polarizable
      this%is_polarizable = polarizable
   end subroutine set_polarizable

   !================================================================================
   ! Set whether the ion is deformable
   !
   subroutine set_deformable(this, deformable)
      implicit none
      type(MW_species_t), intent(inout) :: this    !< species
      logical,        intent(in)    :: deformable ! is the species deformable
      this%is_deformable = deformable
   end subroutine set_deformable

   !================================================================================
   ! Set molecule, this species belongs to
   !
   subroutine set_molecule(this, molecule_name, molecule_index)
      implicit none
      type(MW_species_t), intent(inout) :: this  !< species
      character(*), intent(in) :: molecule_name !< name of the molecule it belongs to
      integer, intent(in) :: molecule_index     !< index of the molecule it belongs to
      this%in_molecule = .true.
      this%molecule_name  = molecule_name
      this%molecule_index = molecule_index
   end subroutine set_molecule

   !================================================================================
   ! Set electrode, this species belongs to
   !
   subroutine set_electrode(this, electrode_name, electrode_index)
      implicit none
      type(MW_species_t), intent(inout) :: this  !< species
      character(*), intent(in) :: electrode_name !< name of the electrode it belongs to
      integer, intent(in) :: electrode_index     !< index of the electrode it belongs to
      this%in_electrode = .true.
      this%electrode_name = electrode_name
      this%electrode_index = electrode_index
      this%has_constant_charge = .false.
   end subroutine set_electrode

   ! ================================================================================
   !> Set offsets for a list of species
   subroutine set_offsets(species)
      implicit none
      type(MW_species_t), intent(inout) :: species(:)

      integer :: i, n, offset
      n = size(species,1)
      offset = 0
      do i = 1, n
         species(i)%offset = offset
         offset = offset + species(i)%count
      end do
   end subroutine set_offsets

   !================================================================================
   !> Read species parameters from runtime.inpt
   !!
   !! Block format:
   !! -------------
   !! species_type *block*
   !!   name *string*
   !!   count *int*
   !!   mass  *real*
   !!   + charge neutral
   !!   + charge point q (*real*)
   !!   + charge gaussian eta (*real*) [q] (*real*)
   !!   polarizability *real*
   !!   deformability D (*real*) beta (*real*) zeta (*real*)
   !!   mobile *bool*
   !!   fourth_site_atom 
   !!   dump_efg *bool*
   !!   dump_lammps *bool*
   !!   dump_xyz *bool*
   !!   dump_trajectories *bool*
   !!   dum_pdb *bool*
   !!
   !! Parameters
   !! ----------
   !! funit : integer
   !!    handle to the runtime input file
   !!
   !! line_num : integer
   !!    current line number in the runtime input file
   subroutine read_parameters(this, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_constants, only: amu2me
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_species_t), intent(inout) :: this
      integer, intent(in) :: funit
      integer, intent(inout) :: line_num

      ! Local
      ! -----
      type(MW_configuration_line_t) :: config_line
      character(max_word_length) :: keyword
      character(SPECIES_NAME_LENGTH) :: name
      integer :: count
      real(wp) :: mass
      logical :: mobile
      logical :: dump_efg
      logical :: dump_lammps
      logical :: dump_xyz
      logical :: dump_trajectories
      logical :: dump_pdb
      logical :: polarizable
      logical :: deformable
      logical :: fourth_site
      character(8) :: charge_keyword
      integer :: charge_type
      real(wp) :: charge, eta
      real(wp) :: polarizability
      real(wp) :: selfdaimD, selfdaimbeta, selfdaimzeta
      integer :: name_defined, count_defined, charge_defined, mass_defined, mobile_defined
      integer :: polarizability_defined, deformability_defined, fourth_site_defined
      integer :: dump_efg_defined, dump_lammps_defined, dump_xyz_defined, dump_trajectories_defined, dump_pdb_defined
      character(256) :: errmsg

      ! Void data structure
      call void_type(this)

      ! Set default values
      name = "****"
      count = 0
      charge_type = CHARGE_TYPE_NEUTRAL
      charge = 0.0_wp
      polarizability = 0.0_wp
      selfdaimD = 0.0_wp
      selfdaimbeta = 0.0_wp
      selfdaimzeta = 0.0_wp
      polarizable = .false.
      deformable = .false.
      eta = 0.0_wp
      mass = 0.0_wp
      mobile = .true.
      fourth_site = .false.
      dump_efg = .false.
      dump_lammps = .true.
      dump_xyz = .true.
      dump_trajectories = .true.
      dump_pdb = .true.

      ! Flag each section as undefined (line number will be stored)
      name_defined = 0
      count_defined = 0
      charge_defined = 0
      mass_defined = 0
      mobile_defined = 0
      polarizability_defined = 0
      deformability_defined = 0
      fourth_site_defined = 0
      dump_efg_defined = 0
      dump_lammps_defined = 0
      dump_xyz_defined = 0
      dump_trajectories_defined = 0
      dump_pdb_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("name")
            if (name_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |name|. First definition at line ",i4,".")') &
                     line_num, name_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            name_defined = line_num

            ! Read name parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for name parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, name)

         case("count")
            if (count_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |count|. First definition at line ",i4,".")') &
                     line_num, count_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            count_defined = line_num

            ! Read count parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for count parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, count)

         case("charge")
            if (charge_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |charge|. First definition at line ",i4,".")') &
                     line_num, charge_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            charge_defined = line_num

            ! Read charge type keyword parameters
            if (config_line%num_words < 2) then
               write(errmsg,'("Invalid format for charge parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, charge_keyword)

            select case(charge_keyword)
            case ("neutral")
               if (config_line%num_words /= 2) then
                  write(errmsg,'("Invalid format for charge parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_parameters","species.f90", &
                        errmsg)
               end if
               charge_type = CHARGE_TYPE_NEUTRAL
               charge = 0.0_wp
               eta = 0.0_wp

            case("point")
               if (config_line%num_words /= 3) then
                  write(errmsg,'("Invalid format for charge parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_parameters","species.f90", &
                        errmsg)
               end if
               charge_type = CHARGE_TYPE_POINT
               call MW_configuration_line_get_word(config_line, 3, charge)
               eta = 0.0_wp

            case("gaussian")
               if ((config_line%num_words < 3) .or. (config_line%num_words > 4)) then
               end if
               charge_type = CHARGE_TYPE_GAUSSIAN
               if (config_line%num_words == 3) then
                  call MW_configuration_line_get_word(config_line, 3, eta)
                  charge = 0.0_wp
               else if (config_line%num_words == 4) then
                  call MW_configuration_line_get_word(config_line, 3, eta)
                  call MW_configuration_line_get_word(config_line, 4, charge)
               else
                  write(errmsg,'("Invalid format for charge parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_parameters","species.f90", &
                        errmsg)
               end if

            case default
               write(errmsg,'("Invalid format for charge type keyword, ",a8,", at line ",i4)') &
                     charge_keyword, line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end select

         case("mass")
            if (mass_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |mass|. First definition at line ",i4,".")') &
                     line_num, mass_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            mass_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mass parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, mass)

         case("polarizability")
            if (polarizability_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |polarizability|. First definition at line ",i4,".")') &
                     line_num, polarizability_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            polarizability_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for polarizability parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, polarizability)
            if (polarizability > 0.0_wp) then
               polarizable = .true.
            end if

         case("deformability")
            if (deformability_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |deformability|. First definition at line ",i4,".")') &
                     line_num, deformability_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            deformability_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 4) then
               write(errmsg,'("Invalid format for deformability parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, selfdaimD)
            if (selfdaimD > 0.0_wp) then
               deformable = .true.
            end if
            call MW_configuration_line_get_word(config_line, 3, selfdaimbeta)
            call MW_configuration_line_get_word(config_line, 4, selfdaimzeta)

         case("mobile")
            if (mobile_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |mobile|. First definition at line ",i4,".")') &
                     line_num, mobile_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            mobile_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, mobile)

         case("fourth_site_atom")
            if (fourth_site_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |fourth_site_atom|. First definition at line ",i4,".")') &
                     line_num, fourth_site_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            fourth_site_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 1) then
               write(errmsg,'("Invalid format for fourth_site_atom parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            fourth_site = .true.

         case("dump_efg")
            if (dump_efg_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dump_efg|. First definition at line ",i4,".")') &
                     line_num, dump_efg_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            dump_efg_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dump_efg)

         case("dump_lammps")
            if (dump_lammps_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dump_lammps|. First definition at line ",i4,".")') &
                     line_num, dump_lammps_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            dump_lammps_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dump_lammps)

         case("dump_xyz")
            if (dump_xyz_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dump_xyz|. First definition at line ",i4,".")') &
                     line_num, dump_xyz_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            dump_xyz_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dump_xyz)

         case("dump_trajectories")
            if (dump_trajectories_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dump_trajectories|. First definition at line ",i4,".")') &
                     line_num, dump_trajectories_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            dump_trajectories_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dump_trajectories)

         case("dump_pdb")
            if (dump_pdb_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dump_pdb|. First definition at line ",i4,".")') &
                     line_num, dump_pdb_defined
               call MW_errors_runtime_error("read_parameters", "species.f90", errmsg)
            end if
            dump_pdb_defined = line_num

            ! Read length parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for mobile parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_parameters","species.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, dump_pdb)

         case default
            ! Keyword not expected in box section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop

         end select
         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop

      call set_name(this, name)
      call set_count(this, count)
      mass = mass*amu2me ! mass conversion from amu to m_e
      call set_mass(this,mass)
      select case(charge_type)
      case(CHARGE_TYPE_NEUTRAL)
         call set_charge_neutral(this)
      case(CHARGE_TYPE_POINT)
         call set_charge_point(this, charge)
      case(CHARGE_TYPE_GAUSSIAN)
         call set_charge_gaussian(this, charge, eta)
      case default
         call set_charge_neutral(this)
      end select
      call set_polarizable(this,polarizable)
      call set_polarizability(this,polarizability)
      call set_deformable(this,deformable)
      call set_deformability(this,selfdaimD,selfdaimbeta,selfdaimzeta)
      call set_fourth_site(this, fourth_site)
      call set_mobility(this, mobile)
      call set_dump_efg(this, dump_efg)
      call set_dump_lammps(this, dump_lammps)
      call set_dump_xyz(this, dump_xyz)
      call set_dump_trajectories(this, dump_trajectories)
      call set_dump_pdb(this, dump_pdb)
   end subroutine read_parameters

end module MW_species

! Define standard output unit and standard error unit for the whole code
module MW_stdio
   use, intrinsic :: iso_fortran_env, only: output_unit, error_unit
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: set_stdout
   public :: set_stderr

   ! Standard output unit
   integer, public, save :: MW_stdout = output_unit

   ! Standard error  unit
   integer, public, save :: MW_stderr = error_unit

contains

   !================================================================================
   ! Set the standard output unit
   !
   ! Output message will be printed to the file connected to the user specified
   ! file unit (ounit).
   ! By default, if the user does not call this routine, output messages are printed
   ! to the standard output_unit.
   subroutine set_stdout(ounit)
      implicit none
      integer, intent(in) :: ounit
      MW_stdout = ounit
   end subroutine set_stdout

   !================================================================================
   ! Set the standard error unit
   !
   ! Error message will be printed to the file connected to the user specified
   ! file unit (eunit).
   ! By default, if the user does not call this routine, error messages are printed
   ! to the standard error_unit.
   subroutine set_stderr(eunit)
      implicit none
      integer, intent(in) :: eunit
      MW_stderr = eunit
   end subroutine set_stderr

end module MW_stdio

module MW_ions_dipoles
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_parallel, only: MW_COMM_WORLD
   use MW_stdio
   use MW_kinds, only: wp
   use MW_algorithms, only: MW_algorithms_t
   use MW_cg, only: MW_cg_t
   use MW_system, only: MW_system_t
   use MW_ion, only: MW_ion_t
   use MW_external_field, only: MW_external_field_t, &
         FIELD_TYPE_ELECTRIC, FIELD_TYPE_DISPLACEMENT

   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: compute_jacobi_precond
   public :: compute
   public :: predictor

contains

   !================================================================================
   ! Evaluate b, the dipole due to point charges only
   subroutine setup_b(system, algorithms)
      use MW_coulomb, only: &
      MW_coulomb_qmelt2mumelt_electricfield => qmelt2mumelt_electricfield, &
      MW_coulomb_fix_molecule_qmelt2mumelt_electricfield => fix_molecule_qmelt2mumelt_electricfield
      use MW_external_field, only: &
      MW_external_field_field2mumelt_electricfieldb => field2mumelt_electricfieldb
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms

      ! Locals
      ! ------
      integer :: num_ions
      integer :: xyz_now, qatoms_now
      integer :: i, itype, ix, iy, iz
      real(wp) :: alpha
      real(wp), dimension(system%num_ions,3) :: efield, efield2, efield3


      num_ions = system%num_ions
      xyz_now = system%xyz_ions_step(1)
      qatoms_now = system%q_atoms_step(1)

      call MW_coulomb_qmelt2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
              system%ions, system%xyz_ions(:,:,xyz_now), system%type_ions(:), efield, system%tt)

      efield2=0.d0
      if(system%num_molecule_types > 0)then
         call MW_coulomb_fix_molecule_qmelt2mumelt_electricfield(system%num_PBC, system%localwork, &
         system%molecules, system%box, system%ions, system%xyz_ions(:,:,xyz_now), efield2, system%tt)
      endif

      efield3=0.d0
      if (system%field%field_type > 0) then
         call MW_external_field_field2mumelt_electricfieldb(system%field, system%ions,&
         system%polarization_field, efield3)
      endif

      efield=efield+efield2+efield3

      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            if(algorithms%maze%calc_dip) then
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%maze%const_constr(ix) = -efield(i,1)
                  algorithms%maze%const_constr(iy) = -efield(i,2)
                  algorithms%maze%const_constr(iz) = -efield(i,3)
               end do
            else if (algorithms%matrix_inversion%calc_dip) then
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%matrix_inversion%b(ix) = efield(i,1)
                  algorithms%matrix_inversion%b(iy) = efield(i,2)
                  algorithms%matrix_inversion%b(iz) = efield(i,3)
               end do
            else
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%cg%b(ix) = efield(i,1)
                  algorithms%cg%b(iy) = efield(i,2)
                  algorithms%cg%b(iz) = efield(i,3)
               end do
            end if
         end if
      end do

   end subroutine setup_b

   !================================================================================
   ! Compute A*x
   !
   subroutine apply_A(system, x, y)
      use MW_coulomb, only: &
      MW_coulomb_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
      MW_coulomb_fix_molecule_mumelt2mumelt_electricfield => fix_molecule_mumelt2mumelt_electricfield
      use MW_external_field, only: &
      MW_external_field_field2mumelt_electricfieldA => field2mumelt_electricfieldA
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      real(wp), intent(in) :: x(:)
      real(wp), intent(out) :: y(:)

      ! Locals
      ! ------
      integer :: num_ions
      integer :: i,itype,ix,iy,iz
      integer :: q_atoms_now,xyz_now
      real(wp) :: alpha
      real(wp), dimension(system%num_ions,3) :: efield,efield2,efield3
      real(wp), dimension(system%num_ions,3) :: dipoles

      num_ions = system%num_ions

      do i=1,num_ions
         ix = i
         iy = i + num_ions
         iz = i + num_ions*2
         dipoles(i,1) = x(ix)
         dipoles(i,2) = x(iy)
         dipoles(i,3) = x(iz)
      enddo

      q_atoms_now = system%q_atoms_step(1)
      xyz_now = system%xyz_ions_step(1)


      call MW_coulomb_mumelt2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
      system%ions, system%xyz_ions(:,:,xyz_now), efield, dipoles)

      efield2=0.0_wp
      if(system%num_molecule_types > 0) then
         call MW_coulomb_fix_molecule_mumelt2mumelt_electricfield(system%num_PBC, system%localwork, &
         system%molecules, system%box, system%ions, system%xyz_ions(:,:,xyz_now), efield2, dipoles)
      endif

      efield3=0.0_wp
      if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
         call MW_external_field_field2mumelt_electricfieldA(system%box, system%field, system%electrodes, &
         system%xyz_atoms, system%q_atoms(:,q_atoms_now), system%ions, &
         system%dipoles_ions(:,:,1), system%polarization_field, efield3)
         !Are we sure this is system%dipoles and not dipoles?
         !We are minimizing over dipoles and they change at each iteration and we are not updating the system variable.
      endif

      efield=efield+efield2+efield3
      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               y(ix) = -efield(i,1) + dipoles(i,1)/alpha
               y(iy) = -efield(i,2) + dipoles(i,2)/alpha
               y(iz) = -efield(i,3) + dipoles(i,3)/alpha
            enddo
         end if
      end do

   end subroutine apply_A

   subroutine compute_hessian(system, hessian)
      use MW_coulomb, only: &
         MW_coulomb_gradmumelt_electricfield => gradmumelt_electricfield, &
         MW_coulomb_fix_molecule_gradmumelt_electricfield => fix_molecule_gradmumelt_electricfield
      use MW_errors, only: &
         MW_errors_allocate_error => allocate_error
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_system_t),  intent(inout) :: system
      real(wp), intent(out) :: hessian(:,:)

      !Locals
      !------
      integer  :: num_ions
      integer  :: xyz_now
      integer  :: i, itype, j, ix, iy, iz, jx, jy, jz
      real(wp) :: alpha
      real(wp), allocatable :: fix_mol_hessian(:,:)
      integer :: ierr

      allocate(fix_mol_hessian(3*system%num_ions,3*system%num_ions), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("compute_hessian", "ions_dipoles.F90", ierr)
      end if

      num_ions = system%num_ions
      xyz_now = system%xyz_ions_step(1)

      call MW_coulomb_gradmumelt_electricfield(system%num_PBC, system%localwork, system%ewald, &
      system%box, system%ions, system%xyz_ions(:,:,xyz_now), hessian(:,:))
      fix_mol_hessian(:,:) = 0.0_wp
      if(system%num_molecule_types > 0) then
         call MW_coulomb_fix_molecule_gradmumelt_electricfield(system%num_PBC, system%localwork, &
         system%molecules, system%box, &
         system%ions, system%xyz_ions(:,:,xyz_now), fix_mol_hessian(:,:))
      endif
      hessian(:,:) = hessian(:,:) + fix_mol_hessian(:,:)
      ! Computing polarization energy term in gradient of constraints for dipoles
      ! Not included in MW_coulomb_melt_gradmu_electricfield
      do itype = 1, size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            do i = system%ions(itype)%offset+1, system%ions(itype)%offset+system%ions(itype)%count
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               hessian(ix,ix) = hessian(ix,ix) + 1.0_wp/alpha
               hessian(iy,iy) = hessian(iy,iy) + 1.0_wp/alpha
               hessian(iz,iz) = hessian(iz,iz) + 1.0_wp/alpha
            end do
         end if
      end do

      do i = 1, num_ions
         ix = i
         iy = i + num_ions
         iz = i + num_ions*2
         do j = 1, i
            jx = j
            jy = j + num_ions
            jz = j + num_ions*2
            !xx
            hessian(ix,jx) = hessian(jx,ix)
            !xy
            hessian(iy,jx) = hessian(jy,ix)
            hessian(jx,iy) = hessian(jy,ix)
            hessian(ix,jy) = hessian(jx,iy)
            !xz
            hessian(iz,jx) = hessian(jz,ix)
            hessian(jx,iz) = hessian(jz,ix)
            hessian(ix,jz) = hessian(jx,iz)
            !yy
            hessian(iy,jy) = hessian(jy,iy)
            !yz
            hessian(iz,jy) = hessian(jz,iy)
            hessian(jy,iz) = hessian(jz,iy)
            hessian(iy,jz) = hessian(jy,iz)
            !zz
            hessian(iz,jz) = hessian(jz,iz)
         end do
      end do

   end subroutine compute_hessian

   ! Parallelized routine for computing matrix vector products invloving dipoles
   ! The matrix has to be Symmetric
   subroutine SMatrix_vector_product_dip(system, matrix, vector, matvec_product)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_system_t), intent(in) :: system  !< system parameters
      real(wp),          intent(in) :: vector(:)
      real(wp),          intent(in) :: matrix(:,:)

      ! Parameters Output
      ! -----------------
      real(wp),          intent(out) :: matvec_product(:)

      !Locals
      !---------------
      integer  :: num_ion_types, num_ions
      integer  :: iblock, iblock_offset, istart, iend, jstart, jend, itype, jtype
      integer  :: num_block_diag, num_block_full
      integer  :: count_n, offset_n, count_m, offset_m, count, ierr
      integer  :: i, j, ix, iy, iz, jx, jy, jz
      real(wp) :: matvec_product_ix, matvec_product_iy, matvec_product_iz
      real(wp) :: vector_ix, vector_iy, vector_iz

      num_ion_types = size(system%ions,1)
      num_ions = size(matrix,1)/3

      matvec_product(:) = 0.0_wp
      do itype = 1, num_ion_types
         count_n = system%ions(itype)%count
         offset_n = system%ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = system%ions(jtype)%count
            offset_m = system%ions(jtype)%offset

            ! Number of blocks with full ion2ion interactions
            num_block_full = system%localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = system%localwork%pair_ion2ion_full_iblock_offset(itype, jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               do i = istart, iend
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  matvec_product_ix = 0.0_wp
                  matvec_product_iy = 0.0_wp
                  matvec_product_iz = 0.0_wp
                  vector_ix = vector(ix)
                  vector_iy = vector(iy)
                  vector_iz = vector(iz)
                  do j = jstart, jend
                     jx = j
                     jy = j + num_ions
                     jz = j + num_ions*2
                     matvec_product_ix = matvec_product_ix &
                     + matrix(jx,ix)*vector(jx) &
                     + matrix(jx,iy)*vector(jy) &
                     + matrix(jx,iz)*vector(jz)
                     matvec_product_iy = matvec_product_iy &
                     + matrix(jy,ix)*vector(jx) &
                     + matrix(jy,iy)*vector(jy) &
                     + matrix(jy,iz)*vector(jz)
                     matvec_product_iz = matvec_product_iz &
                     + matrix(jz,ix)*vector(jx) &
                     + matrix(jz,iy)*vector(jy) &
                     + matrix(jz,iz)*vector(jz)

                     matvec_product(jx) = matvec_product(jx) &
                     + matrix(jx,ix)*vector_ix &
                     + matrix(jx,iy)*vector_iy &
                     + matrix(jx,iz)*vector_iz
                     matvec_product(jy) = matvec_product(jy) &
                     + matrix(jy,ix)*vector_ix &
                     + matrix(jy,iy)*vector_iy &
                     + matrix(jy,iz)*vector_iz
                     matvec_product(jz) = matvec_product(jz) &
                     + matrix(jz,ix)*vector_ix &
                     + matrix(jz,iy)*vector_iy &
                     + matrix(jz,iz)*vector_iz
                  end do
                  matvec_product(ix) = matvec_product(ix) + matvec_product_ix
                  matvec_product(iy) = matvec_product(iy) + matvec_product_iy
                  matvec_product(iz) = matvec_product(iz) + matvec_product_iz
               end do
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         num_block_diag = system%localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = system%localwork%pair_ion2ion_diag_iblock_offset(itype)
         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
            offset_n, count_n, istart, iend)
            do i = istart, iend
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               matvec_product_ix = 0.0_wp
               matvec_product_iy = 0.0_wp
               matvec_product_iz = 0.0_wp
               do j = istart, iend
                  jx = j
                  jy = j + num_ions
                  jz = j + num_ions*2
                  matvec_product_ix = matvec_product_ix &
                  + matrix(jx,ix)*vector(jx) &
                  + matrix(jx,iy)*vector(jy) &
                  + matrix(jx,iz)*vector(jz)
                  matvec_product_iy = matvec_product_iy &
                  + matrix(jy,ix)*vector(jx) &
                  + matrix(jy,iy)*vector(jy) &
                  + matrix(jy,iz)*vector(jz)
                  matvec_product_iz = matvec_product_iz &
                  + matrix(jz,ix)*vector(jx) &
                  + matrix(jz,iy)*vector(jy) &
                  + matrix(jz,iz)*vector(jz)
               end do
               matvec_product(ix) = matvec_product(ix) + matvec_product_ix
               matvec_product(iy) = matvec_product(iy) + matvec_product_iy
               matvec_product(iz) = matvec_product(iz) + matvec_product_iz
            end do
         end do

         ! Number of blocks with full ion2ion interactions
         num_block_full = system%localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = system%localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            do i = istart, iend
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               matvec_product_ix = 0.0_wp
               matvec_product_iy = 0.0_wp
               matvec_product_iz = 0.0_wp
               vector_ix = vector(ix)
               vector_iy = vector(iy)
               vector_iz = vector(iz)
               do j = jstart, jend
                  jx = j
                  jy = j + num_ions
                  jz = j + num_ions*2
                  matvec_product_ix = matvec_product_ix &
                  + matrix(jx,ix)*vector(jx) &
                  + matrix(jx,iy)*vector(jy) &
                  + matrix(jx,iz)*vector(jz)
                  matvec_product_iy = matvec_product_iy &
                  + matrix(jy,ix)*vector(jx) &
                  + matrix(jy,iy)*vector(jy) &
                  + matrix(jy,iz)*vector(jz)
                  matvec_product_iz = matvec_product_iz &
                  + matrix(jz,ix)*vector(jx) &
                  + matrix(jz,iy)*vector(jy) &
                  + matrix(jz,iz)*vector(jz)

                  matvec_product(jx) = matvec_product(jx) &
                  + matrix(jx,ix)*vector_ix &
                  + matrix(jx,iy)*vector_iy &
                  + matrix(jx,iz)*vector_iz
                  matvec_product(jy) = matvec_product(jy) &
                  + matrix(jy,ix)*vector_ix &
                  + matrix(jy,iy)*vector_iy &
                  + matrix(jy,iz)*vector_iz
                  matvec_product(jz) = matvec_product(jz) &
                  + matrix(jz,ix)*vector_ix &
                  + matrix(jz,iy)*vector_iy &
                  + matrix(jz,iz)*vector_iz
               end do
               matvec_product(ix) = matvec_product(ix) + matvec_product_ix
               matvec_product(iy) = matvec_product(iy) + matvec_product_iy
               matvec_product(iz) = matvec_product(iz) + matvec_product_iz
            end do
         end do
      end do

#ifndef MW_SERIAL
      count = size(matvec_product,1)
      call MPI_Allreduce(MPI_IN_PLACE, matvec_product, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD,  ierr)
#endif
   end subroutine SMatrix_vector_product_dip

   ! Parallelized routine for computing matrix vector products invloving dipoles
   ! The matrix is General
   subroutine GMatrix_vector_product_dip(system, matrix, vector, matvec_product)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_system_t), intent(in) :: system  !< system parameters
      real(wp),          intent(in) :: vector(:)
      real(wp),          intent(in) :: matrix(:,:)

      ! Parameters Output
      ! -----------------
      real(wp),          intent(out) :: matvec_product(:)

      !Locals
      !---------------
      integer  :: num_ion_types, num_ions
      integer  :: iblock, iblock_offset, istart, iend, jstart, jend, itype, jtype
      integer  :: num_block_diag, num_block_full
      integer  :: count_n, offset_n, count_m, offset_m, count, ierr
      integer  :: i, j, ix, iy, iz, jx, jy, jz
      real(wp) :: matvec_product_ix, matvec_product_iy, matvec_product_iz
      real(wp) :: vector_ix, vector_iy, vector_iz

      num_ion_types = size(system%ions,1)
      num_ions = size(matrix,1)/3

      matvec_product(:) = 0.0_wp
      do itype = 1, num_ion_types
         count_n = system%ions(itype)%count
         offset_n = system%ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = system%ions(jtype)%count
            offset_m = system%ions(jtype)%offset

            ! Number of blocks with full ion2ion interactions
            num_block_full = system%localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = system%localwork%pair_ion2ion_full_iblock_offset(itype, jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               do i = istart, iend
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  matvec_product_ix = 0.0_wp
                  matvec_product_iy = 0.0_wp
                  matvec_product_iz = 0.0_wp
                  vector_ix = vector(ix)
                  vector_iy = vector(iy)
                  vector_iz = vector(iz)
                  do j = jstart, jend
                     jx = j
                     jy = j + num_ions
                     jz = j + num_ions*2
                     matvec_product_ix = matvec_product_ix &
                     + matrix(ix,jx)*vector(jx) &
                     + matrix(ix,jy)*vector(jy) &
                     + matrix(ix,jz)*vector(jz)
                     matvec_product_iy = matvec_product_iy &
                     + matrix(iy,jx)*vector(jx) &
                     + matrix(iy,jy)*vector(jy) &
                     + matrix(iy,jz)*vector(jz)
                     matvec_product_iz = matvec_product_iz &
                     + matrix(iz,jx)*vector(jx) &
                     + matrix(iz,jy)*vector(jy) &
                     + matrix(iz,jz)*vector(jz)

                     matvec_product(jx) = matvec_product(jx) &
                     + matrix(jx,ix)*vector_ix &
                     + matrix(jx,iy)*vector_iy &
                     + matrix(jx,iz)*vector_iz
                     matvec_product(jy) = matvec_product(jy) &
                     + matrix(jy,ix)*vector_ix &
                     + matrix(jy,iy)*vector_iy &
                     + matrix(jy,iz)*vector_iz
                     matvec_product(jz) = matvec_product(2*num_ions+j) &
                     + matrix(jz,ix)*vector_ix &
                     + matrix(jz,iy)*vector_iy &
                     + matrix(jz,iz)*vector_iz
                  end do
                  matvec_product(ix) = matvec_product(ix) + matvec_product_ix
                  matvec_product(iy) = matvec_product(iy) + matvec_product_iy
                  matvec_product(iz) = matvec_product(iz) + matvec_product_iz
               end do
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         num_block_diag = system%localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = system%localwork%pair_ion2ion_diag_iblock_offset(itype)
         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
            offset_n, count_n, istart, iend)
            do i = istart, iend
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               matvec_product_ix = 0.0_wp
               matvec_product_iy = 0.0_wp
               matvec_product_iz = 0.0_wp
               do j = istart, iend
                  jx = j
                  jy = j + num_ions
                  jz = j + num_ions*2
                  matvec_product_ix = matvec_product_ix &
                  + matrix(ix,jx)*vector(jx) &
                  + matrix(ix,jy)*vector(jy) &
                  + matrix(ix,jz)*vector(jz)
                  matvec_product_iy = matvec_product_iy &
                  + matrix(iy,jx)*vector(jx) &
                  + matrix(iy,jy)*vector(jy) &
                  + matrix(iy,jz)*vector(jz)
                  matvec_product_iz = matvec_product_iz &
                  + matrix(iz,jx)*vector(jx) &
                  + matrix(iz,jy)*vector(jy) &
                  + matrix(iz,jz)*vector(jz)
               end do
               matvec_product(ix) = matvec_product(ix) + matvec_product_ix
               matvec_product(iy) = matvec_product(iy) + matvec_product_iy
               matvec_product(iz) = matvec_product(iz) + matvec_product_iz
            end do
         end do

         ! Number of blocks with full ion2ion interactions
         num_block_full = system%localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = system%localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            do i = istart, iend
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               matvec_product_ix = 0.0_wp
               matvec_product_iy = 0.0_wp
               matvec_product_iz = 0.0_wp
               vector_ix = vector(ix)
               vector_iy = vector(iy)
               vector_iz = vector(iz)
               do j = jstart, jend
                  jx = j
                  jy = j + num_ions
                  jz = j + num_ions*2
                  matvec_product_ix = matvec_product_ix &
                  + matrix(ix,jx)*vector(jx) &
                  + matrix(ix,jy)*vector(jy) &
                  + matrix(ix,jz)*vector(jz)
                  matvec_product_iy = matvec_product_iy &
                  + matrix(iy,jx)*vector(jx) &
                  + matrix(iy,jy)*vector(jy) &
                  + matrix(iy,jz)*vector(jz)
                  matvec_product_iz = matvec_product_iz &
                  + matrix(iz,jx)*vector(jx) &
                  + matrix(iz,jy)*vector(jy) &
                  + matrix(iz,jz)*vector(jz)

                  matvec_product(jx) = matvec_product(jx) &
                  + matrix(jx,ix)*vector_ix &
                  + matrix(jx,iy)*vector_iy &
                  + matrix(jx,iz)*vector_iz
                  matvec_product(jy) = matvec_product(jy) &
                  + matrix(jy,ix)*vector_ix &
                  + matrix(jy,iy)*vector_iy &
                  + matrix(jy,iz)*vector_iz
                  matvec_product(jz) = matvec_product(2*num_ions+j) &
                  + matrix(jz,ix)*vector_ix &
                  + matrix(jz,iy)*vector_iy &
                  + matrix(jz,iz)*vector_iz
               end do
               matvec_product(ix) = matvec_product(ix) + matvec_product_ix
               matvec_product(iy) = matvec_product(iy) + matvec_product_iy
               matvec_product(iz) = matvec_product(iz) + matvec_product_iz
            end do
         end do
      end do

#ifndef MW_SERIAL
      count = size(matvec_product,1)
      call MPI_Allreduce(MPI_IN_PLACE, matvec_product, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD,  ierr)
#endif
   end subroutine GMatrix_vector_product_dip

   subroutine compute_jacobi_precond(system, algorithms)
      use MW_coulomb, only: &
      MW_coulomb_diag_gradmumelt_electricfield => diag_gradmumelt_electricfield, &
      MW_coulomb_diag_gradQelec_potential => diag_gradQelec_potential
      implicit none

      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms

      integer :: i, itype, ix, iy, iz
      integer :: n_ions
      real(wp) :: alpha

      n_ions = system%num_ions

      call MW_coulomb_diag_gradmumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%ions, algorithms%cg%jacobi_precond(1:3*n_ions))
      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
               ix = i
               iy = i + n_ions
               iz = i + n_ions*2
               algorithms%cg%jacobi_precond(ix) = algorithms%cg%jacobi_precond(ix) + 1.0_wp/system%ions(itype)%polarizability
               algorithms%cg%jacobi_precond(iy) = algorithms%cg%jacobi_precond(iy) + 1.0_wp/system%ions(itype)%polarizability
               algorithms%cg%jacobi_precond(iz) = algorithms%cg%jacobi_precond(iz) + 1.0_wp/system%ions(itype)%polarizability
            end do
         end if
      end do
   end subroutine compute_jacobi_precond

   !================================================================================
   !> Compute dipoles on electrode
   !!
   !! The dipole is evaluated by minimizing the Coulomb energy of the system
   !!
   !! The energy can be cast into E = Q*AQ - Q*b + c
   !!
   !! where Q  is the vector of charges on the electrodes
   !!       b  is the potential felt by the electrode due to the melt ions
   !!       AQ is the potential felt by the electrode du to other electrode atoms
   !!       c  is the energy due to melt ions interactions
   !!       *  denotes the transpose of a vector/matrix
   !!
   !! By construction A is a matrix symmetric positive definite
   !! The preconditioned conjugate gradient algorithm is used to find a solution to
   !! the system
   !!
   subroutine compute(system, algorithms)
      use MW_cg, only: &
         MW_cg_solve_preconditioned => solve_preconditioned, &
         MW_cg_solve => solve
      use MW_maze, only: &
            MW_maze_update_history => update_history, &
            MW_maze_compute_x0 => compute_x0, &
            MW_maze_solve_invert => solve_invert, &
            MW_maze_solve_shake => solve_shake, &
            MW_maze_solve_block_iterate => solve_block_iterate
      use MW_matrix_inversion, only: &
            MW_matrix_inversion_solve => solve
      use MW_ion, only: MW_ion_t
      use MW_external_field, only: &
            MW_external_field_dipole_polarization => dipole_polarization
      implicit none

      ! Parameters in
      ! -------------
      type(MW_system_t), intent(inout) :: system !< system parameters
      type(MW_algorithms_t), intent(inout) :: algorithms !< cg algorithm parameters

      ! Local
      ! -----
      integer :: num_ions
      integer :: i, ix, iy, iz, itype
      integer :: dipoles_ions_tpdt,dipoles_ions_t,dipoles_ions_tmdt
      real(wp) :: alpha
      real(wp), dimension(3*system%num_ions) :: x
      real(wp), dimension(3*system%num_ions) :: xt, xtmdt


      num_ions = system%num_ions
      dipoles_ions_tpdt = system%dipoles_ions_step(1)
      dipoles_ions_t = system%dipoles_ions_step(2)
      dipoles_ions_tmdt = 0
      if(algorithms%maze%calc_dip) dipoles_ions_tmdt = system%dipoles_ions_step(3)

      call setup_b(system, algorithms)

      if (algorithms%maze%calc_dip) then

         do i=1,num_ions
            ix = i
            iy = i + num_ions
            iz = i + num_ions*2
            x(ix)=system%dipoles_ions(i,1,dipoles_ions_tpdt)
            x(iy)=system%dipoles_ions(i,2,dipoles_ions_tpdt)
            x(iz)=system%dipoles_ions(i,3,dipoles_ions_tpdt)
            xt(ix)=system%dipoles_ions(i,1,dipoles_ions_t)
            xt(iy)=system%dipoles_ions(i,2,dipoles_ions_t)
            xt(iz)=system%dipoles_ions(i,3,dipoles_ions_t)
            xtmdt(ix)=system%dipoles_ions(i,1,dipoles_ions_tmdt)
            xtmdt(iy)=system%dipoles_ions(i,2,dipoles_ions_tmdt)
            xtmdt(iz)=system%dipoles_ions(i,3,dipoles_ions_tmdt)
         end do

         if (.not.algorithms%maze%constant_constr_grad) then
           call MW_maze_update_history(algorithms%maze) !Only updates gradient of constraints
         end if
         call MW_maze_compute_x0(algorithms%maze, system, 1.0_wp, xtmdt, xt, x)
         if (algorithms%maze%invert) then
            call MW_maze_solve_invert(algorithms%maze, system, compute_hessian, GMatrix_vector_product_dip, x)
         else if (algorithms%maze%shake) then
            call MW_maze_solve_shake(algorithms%maze, system, compute_hessian, x)
         else
            call MW_maze_solve_block_iterate(algorithms%maze, system, compute_hessian, x)
         end if

      else if (algorithms%matrix_inversion%calc_dip) then

         do i=1,num_ions
            ix = i
            iy = i + num_ions
            iz = i + num_ions*2
            x(ix)=system%dipoles_ions(i,1,dipoles_ions_tpdt)
            x(iy)=system%dipoles_ions(i,2,dipoles_ions_tpdt)
            x(iz)=system%dipoles_ions(i,3,dipoles_ions_tpdt)
         end do

         call MW_matrix_inversion_solve(algorithms%matrix_inversion, system, compute_hessian, GMatrix_vector_product_dip, x)

      else

         !When using cg the iterations start from the dipoles at previous timestep
         if (system%dipoles_use_predictor) then
            call predictor(system%dipoles_ions_step, system%ions, system%dipoles_ions)
         else
            do itype = 1, system%num_ion_types
               alpha = system%ions(itype)%polarizability
               if (alpha .ne. 0.0_wp) then
                  do i = system%ions(itype)%offset+1, system%ions(itype)%offset + system%ions(itype)%count
                    system%dipoles_ions(i, 1, dipoles_ions_tpdt) = system%dipoles_ions(i, 1, dipoles_ions_t)
                    system%dipoles_ions(i, 2, dipoles_ions_tpdt) = system%dipoles_ions(i, 2, dipoles_ions_t)
                    system%dipoles_ions(i, 3, dipoles_ions_tpdt) = system%dipoles_ions(i, 3, dipoles_ions_t)
                  end do
               end if
            end do
         end if

         do i=1,num_ions
            ix = i
            iy = i + num_ions
            iz = i + num_ions*2
            x(ix)=system%dipoles_ions(i,1,dipoles_ions_tpdt)
            x(iy)=system%dipoles_ions(i,2,dipoles_ions_tpdt)
            x(iz)=system%dipoles_ions(i,3,dipoles_ions_tpdt)
         end do

         call MW_cg_solve_preconditioned(algorithms%cg, system, apply_A, x)
      endif

      !Update ions at t+dt after minimization
      do i=1,num_ions
         ix = i
         iy = i + num_ions
         iz = i + num_ions*2
         system%dipoles_ions(i,1,dipoles_ions_tpdt)=x(ix)
         system%dipoles_ions(i,2,dipoles_ions_tpdt)=x(iy)
         system%dipoles_ions(i,3,dipoles_ions_tpdt)=x(iz)
      end do

      call MW_external_field_dipole_polarization(system%box, system%ions, &
         system%dipoles_ions(:,:,dipoles_ions_tpdt), system%polarization_field(:,:))
   end subroutine compute

   ! ================================================================================
   !> Predictor for ion dipoles
   subroutine predictor(dipoles_ions_step, ions, dipoles_ions)
     implicit none
     ! Parameters
     ! ----------
     integer, intent(in) :: dipoles_ions_step(:)  !< time step index
     type(MW_ion_t), intent(in) :: ions(:) !< ion parameters
     real(wp), intent(inout) :: dipoles_ions(:,:,:) !< atom charges

     ! Local
     ! -----
     integer :: dipole_now, dipole_m1, dipole_m2, dipole_m3, dipole_m4, dipole_m5, dipole_m6
     integer :: num_ion_types
     integer :: itype, i
     real(wp) :: alpha

     real(wp), parameter :: B1 =  22.0_wp /  7.0_wp
     real(wp), parameter :: B2 = -55.0_wp / 14.0_wp
     real(wp), parameter :: B3 =  55.0_wp / 21.0_wp
     real(wp), parameter :: B4 = -22.0_wp / 21.0_wp
     real(wp), parameter :: B5 =   5.0_wp / 21.0_wp
     real(wp), parameter :: B6 =  -1.0_wp / 42.0_wp


     num_ion_types = size(ions,1)

     dipole_now = dipoles_ions_step(1)
     dipole_m1 = dipoles_ions_step(2)
     dipole_m2 = dipoles_ions_step(3)
     dipole_m3 = dipoles_ions_step(4)
     dipole_m4 = dipoles_ions_step(5)
     dipole_m5 = dipoles_ions_step(6)
     dipole_m6 = dipoles_ions_step(7)


     !$acc data &
     !$acc present(ions(:), dipoles_ions(:,:,:))
     !$acc parallel
     !$acc loop
     do itype = 1, num_ion_types
        alpha = ions(itype)%polarizability
        if (alpha .ne. 0.0_wp) then
           !$acc loop
           do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
             dipoles_ions(i, 1, dipole_now) = B1 * dipoles_ions(i, 1, dipole_m1) + B2 * dipoles_ions(i, 1, dipole_m2) &
                  + B3 * dipoles_ions(i, 1, dipole_m3) + B4 * dipoles_ions(i, 1, dipole_m4) + B5 * dipoles_ions(i, 1, dipole_m5) &
                  + B6 * dipoles_ions(i, 1, dipole_m6)
             dipoles_ions(i, 2, dipole_now) = B1 * dipoles_ions(i, 2, dipole_m1) + B2 * dipoles_ions(i, 2, dipole_m2) &
                  + B3 * dipoles_ions(i, 2, dipole_m3) + B4 * dipoles_ions(i, 2, dipole_m4) + B5 * dipoles_ions(i, 2, dipole_m5) &
                  + B6 * dipoles_ions(i, 2, dipole_m6)
             dipoles_ions(i, 3, dipole_now) = B1 * dipoles_ions(i, 3, dipole_m1) + B2 * dipoles_ions(i, 3, dipole_m2) &
                  + B3 * dipoles_ions(i, 3, dipole_m3) + B4 * dipoles_ions(i, 3, dipole_m4) + B5 * dipoles_ions(i, 3, dipole_m5) &
                  + B6 * dipoles_ions(i, 3, dipole_m6)
           end do
           !$acc end loop
        end if
     end do
     !$acc end loop
     !$acc end parallel
     !$acc end data
 end subroutine predictor

   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_ions_dipoles

! Module to compute electrostatic Coulomb potential
module MW_coulomb_self
   implicit none
   private

   ! Public subroutines
   ! ------------------
   !NO PIM
   public :: diag_gradQelec_potential
   public :: gradQelec_potential
   public :: Qelec2Qelec_potential
   public :: melt_efg ! correction to the efg
   public :: energy
   !PIM
   public :: diag_gradmumelt_electricfield
   public :: gradmumelt_electricfield
   public :: mumelt2mumelt_electricfield
   public :: pim_energy

contains

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine diag_gradQelec_potential(localwork, ewald, electrodes, diag_gradQ_V)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: diag_gradQ_V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, i, iatom
      real(wp) :: selffactor
      real(wp) :: etai
      real(wp) :: alpha

      num_elec_types = size(electrodes,1)

      !$acc data &
      !$acc present(electrodes(:), localwork, localwork%count_atoms(:), localwork%offset_atoms(:), diag_gradQ_V(:))

      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      !$acc parallel loop gang private(itype, etai, selffactor, i, iatom)
      do itype = 1, num_elec_types
         etai = electrodes(itype)%eta
         selffactor = (2.0_wp * alpha - sqrt(2.0_wp) * etai ) / sqrt(pi)
         !$acc loop vector
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            diag_gradQ_V(iatom) = diag_gradQ_V(iatom) - selffactor
         end do
         !$acc end loop
      end do
      !$acc end parallel loop
      !$acc end data
   end subroutine diag_gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine gradQelec_potential(localwork, ewald, electrodes, gradQ_V)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: gradQ_V(:,:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, i, iatom
      real(wp) :: selffactor
      real(wp) :: etai
      real(wp) :: alpha

      num_elec_types = size(electrodes,1)


      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      do itype = 1, num_elec_types
         etai = electrodes(itype)%eta
         selffactor = (2.0_wp * alpha - sqrt(2.0_wp) * etai ) / sqrt(pi)
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            gradQ_V(iatom,iatom) = gradQ_V(iatom,iatom) - selffactor
         end do
      end do
   end subroutine gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine Qelec2Qelec_potential(localwork, ewald, electrodes, q_elec, V)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, i, iatom
      real(wp) :: selffactor
      real(wp) :: etai
      real(wp) :: alpha

      num_elec_types = size(electrodes,1)


      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      do itype = 1, num_elec_types
         etai = electrodes(itype)%eta
         selffactor = (2.0_wp*alpha - sqrt(2.0_wp)*etai )/sqrt(pi)
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            V(iatom) = V(iatom) - selffactor*q_elec(iatom)
         end do
      end do
   end subroutine Qelec2Qelec_potential

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   subroutine energy(localwork, ewald, ions, electrodes, q_elec, h)
      use MW_kinds, only: wp
      use MW_constants, only: sqrtpi, sqrt2
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: h       !< Coulomb energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: itype, i, iatom
      real(wp) :: selffactor
      real(wp) :: etai, qi, vi
      real(wp) :: alpha
      real(wp) :: h_ions, h_atoms

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Self interaction correction
      ! ---------------------------
      h_ions = 0.0_wp
      alpha = ewald%alpha
      selffactor = alpha / sqrtpi
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         h_ions = h_ions + localwork%count_ions(itype)*selffactor*qi*qi
      end do

      h_atoms = 0.0_wp
      do itype = 1, num_elec_types
         etai = electrodes(itype)%eta
         vi = electrodes(itype)%V
         selffactor = (alpha - etai/sqrt2)/sqrtpi
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            h_atoms = h_atoms + selffactor*q_elec(iatom)*q_elec(iatom) + q_elec(iatom)*vi
         end do
      end do

      h = -(h_ions + h_atoms)

   end subroutine energy

   !================================================================================
   ! Compute the contibution to the gradient of the electric field from self term
   subroutine diag_gradmumelt_electricfield(localwork, ewald, ions, diag_gradmu_efield)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:)   !< ion types parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: diag_gradmu_efield(:)  !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: itype, i, iion, iionx, iiony, iionz
      real(wp) :: selffactor
      real(wp) :: alpha

      num_ion_types = size(ions,1)
      num_ions = size(diag_gradmu_efield,1)/3

      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      selffactor = 4.0_wp*alpha**3.0_wp/(3.0_wp*sqrt(pi))
      do itype = 1, num_ion_types
         do i = 1, localwork%count_ions(itype)
            iion = localwork%offset_ions(itype) + i
            iionx = iion
            iiony = iion + num_ions
            iionz = iion + num_ions*2
            diag_gradmu_efield(iionx) = diag_gradmu_efield(iionx) - selffactor
            diag_gradmu_efield(iiony) = diag_gradmu_efield(iiony) - selffactor
            diag_gradmu_efield(iionz) = diag_gradmu_efield(iionz) - selffactor
         end do
      end do

   end subroutine diag_gradmumelt_electricfield

   !================================================================================
   ! Compute the contibution to the gradient of the electric field from self term
   subroutine gradmumelt_electricfield(localwork, ewald, ions, gradmu_efield)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:)   !< ion types parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: gradmu_efield(:,:)  !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: itype, i, iion, iionx, iiony, iionz
      real(wp) :: selffactor
      real(wp) :: alpha

      num_ion_types = size(ions,1)
      num_ions = size(gradmu_efield,1)/3

      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      selffactor = 4.0_wp*alpha**3.0_wp/(3.0_wp*sqrt(pi))
      do itype = 1, num_ion_types
         do i = 1, localwork%count_ions(itype)
            iion = localwork%offset_ions(itype) + i
            iionx = iion
            iiony = iion + num_ions
            iionz = iion + num_ions*2
            gradmu_efield(iionx,iionx) = gradmu_efield(iionx,iionx) - selffactor
            gradmu_efield(iiony,iiony) = gradmu_efield(iiony,iiony) - selffactor
            gradmu_efield(iionz,iionz) = gradmu_efield(iionz,iionz) - selffactor
         end do
      end do

   end subroutine gradmumelt_electricfield

   !================================================================================
   ! Compute the contibution to the electric field from self term
   subroutine mumelt2mumelt_electricfield(localwork, ewald, ions, efield, dipoles)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: dipoles(:,:)      !< ions dipoles

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efield(:,:)       !< electric field

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: itype, i, iion
      real(wp) :: selffactor
      real(wp) :: alpha

      num_ion_types = size(ions,1)

      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      selffactor = 4.0_wp*alpha**3.0_wp/(3.0_wp*sqrt(pi))
      do itype = 1, num_ion_types
         do i= 1, localwork%count_ions(itype)
            iion = localwork%offset_ions(itype) + i
            efield(iion,1) = efield(iion,1) + selffactor*dipoles(iion,1)
            efield(iion,2) = efield(iion,2) + selffactor*dipoles(iion,2)
            efield(iion,3) = efield(iion,3) + selffactor*dipoles(iion,3)
         enddo
      end do

   end subroutine mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the contibution to the electric field gradient from self term
   subroutine melt_efg(localwork, ewald, ions, efg)
      use MW_kinds, only: wp
      use MW_constants, only: pi
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald      !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:)    !< ion types parameters
      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efg(:,:)   !< The electric field gradient

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: itype, i, iion
      real(wp) :: selffactor, qi
      real(wp) :: alpha

      num_ion_types = size(ions,1)

      ! Self interaction correction
      ! ---------------------------
      alpha = ewald%alpha
      selffactor = 4.0_wp*alpha**3.0_wp/(3.0_wp*sqrt(pi))
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         if (ions(itype)%dump_efg) then 
            do i = 1, localwork%count_ions(itype)
               iion = localwork%offset_ions(itype) + i
               ! Only the diagonal components have the correction
               ! efg: 1-xx, 2-xy, 3-xz, 4: yy, 5: yz, 6: zz
               efg(iion,1) = efg(iion,1) - selffactor*qi
               efg(iion,4) = efg(iion,4) - selffactor*qi
               efg(iion,6) = efg(iion,6) - selffactor*qi
            enddo
         end if 
      end do

   end subroutine melt_efg

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   ! charge-charge and dipole-dipole terms
   subroutine pim_energy(localwork, ewald, ions, electrodes, q_elec, dipoles, h)
      use MW_kinds, only: wp
      use MW_constants, only: sqrtpi, sqrt2
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)      !< ions dipoles

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: h       !< Self-component of the energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: itype, i, iatom, iion
      real(wp) :: selffactor
      real(wp) :: etai, qi, vi
      real(wp) :: alpha
      real(wp) :: h_ions, h_atoms, h_dipoles

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Self interaction correction
      ! ---------------------------
      h_ions = 0.0_wp
      alpha = ewald%alpha
      selffactor = alpha / sqrtpi
      do itype = 1, num_ion_types
         qi = ions(itype)%charge
         h_ions = h_ions + localwork%count_ions(itype)*selffactor*qi*qi
      end do

      h_atoms = 0.0_wp
      do itype = 1, num_elec_types
         etai = electrodes(itype)%eta
         vi = electrodes(itype)%V
         selffactor = (alpha - etai/sqrt2)/sqrtpi
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            h_atoms = h_atoms + selffactor*q_elec(iatom)*q_elec(iatom) + q_elec(iatom)*vi
         end do
      end do

      h_dipoles = 0.0_wp
      selffactor = 2.0_wp*alpha**3.0_wp/(3.0_wp*sqrtpi)
      do itype = 1, num_ion_types
         do i = 1, localwork%count_ions(itype)
            iion = localwork%offset_ions(itype) + i
            h_dipoles = h_dipoles + selffactor*dipoles(iion,1)*dipoles(iion,1)
            h_dipoles = h_dipoles + selffactor*dipoles(iion,2)*dipoles(iion,2)
            h_dipoles = h_dipoles + selffactor*dipoles(iion,3)*dipoles(iion,3)
         enddo
      end do

      h = -(h_ions + h_atoms + h_dipoles)

   end subroutine pim_energy

end module MW_coulomb_self

! Module to implement NPT runs
!
! Reference
! ---------
! Constant pressure molecular dynamics algorithms
! Glenn K. Martyna, Douglas J. Tobias, Michael L. Klein, 
! J. Chem. Phys. 101 (5), 4177, 1994
!
module MW_barostat
   use MW_kinds, only: wp
   use MW_thermostat, only: MW_thermostat_t
   use MW_ion, only: MW_ion_t
   use MW_constants, only: boltzmann
   use MW_molecule, only: MW_molecule_t
   use MW_box, only: MW_box_t
   implicit none
   private

   ! Public types
   ! ------------
   public :: MW_barostat_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: allocate_velocity_work_array
   public :: void_type
   public :: print_type
   public :: update_history
   public :: initialize
   public :: ions_positions_update
   public :: ions_velocities_update
   public :: setup_masses
   public :: energy

   integer, parameter :: ZETA_NUM_STEPS = 3

   type MW_barostat_t
      real(wp) :: temperature            !< Thermostat temperature
      real(wp) :: externalpressure       !< External/applied pressure
      real(wp) :: ions_th_relaxation_time  !< Thermostat relaxation time
      real(wp) :: b_relaxation_time     !< Barostat relaxation time
      integer  :: max_iteration          !< maximum number of iteration for velocity convergence
      real(wp) :: tolerance              !< tolerance on velocity convergence

      integer :: ions_th_chain_length = 0       !< Number of thermostats in the chain
      integer :: b_th_chain_length = 0        !< Number of thermostats in the chain for the barostat

      real(wp), allocatable :: ions_th_mass(:)        !< Thermostats mass
      real(wp), allocatable :: ions_th_zeta(:,:)      !< Thermostat "position"
      real(wp), allocatable :: ions_th_v_zeta(:,:)    !< Thermostat "velocity"
      real(wp), allocatable :: ions_th_G_zeta(:,:)    !< Thermostat "force"

      real(wp) :: b_W                            !< Barostat mass
      real(wp), allocatable :: b_epsilon(:)      !< Barostat "position"
      real(wp), allocatable :: b_v_epsilon(:)    !< Barostat "velocity"
      real(wp), allocatable :: b_F_epsilon(:)    !< Barostat "force"

      real(wp), allocatable :: b_th_mass(:)        !< Barostat thermostat masses
      real(wp), allocatable :: b_th_zeta(:,:)      !< Barostat thermostat "position"
      real(wp), allocatable :: b_th_v_zeta(:,:)    !< Barostat thermostat "velocity"
      real(wp), allocatable :: b_th_G_zeta(:,:)    !< Barostat thermostat "force"

      ! history pointer
      integer :: zeta_step(ZETA_NUM_STEPS)

      real(wp), allocatable :: velocity_ions_work(:,:,:) !< work array required for velocity iterations
   end type MW_barostat_t

contains

   ! ================================================================================
   ! Define a barostat structure
   subroutine define_type(this, thermostat, externalpressure, &
                   b_relaxation_time, b_th_chain_length)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none

      ! Parameters in
      ! -------------
      type(MW_thermostat_t), intent(in) :: thermostat    !< Thermostat structure
      real(wp), intent(in) :: externalpressure   !< Barostat pressure
      real(wp), intent(in) :: b_relaxation_time !< Barostat relaxation time
      integer,  intent(in) :: b_th_chain_length  !< Number of thermostats in the chain for the barostat

      ! Parameters out
      ! --------------
      type(MW_barostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr, step

!     if (ions_th_chain_length < 1) then
!        call MW_errors_parameter_error("define_type", "barostat.f90", "ions_th_chain_length", ions_th_chain_length)
!     end if

      if (b_th_chain_length < 1) then
         call MW_errors_parameter_error("define_type", "barostat.f90", "b_th_chain_length", b_th_chain_length)
      end if

      this%temperature = thermostat%temperature
      this%externalpressure = externalpressure
      this%ions_th_relaxation_time = thermostat%relaxation_time
      this%b_relaxation_time = b_relaxation_time
      this%max_iteration = thermostat%max_iteration
      this%tolerance = thermostat%tolerance
      this%ions_th_chain_length = thermostat%chain_length
      this%b_th_chain_length = b_th_chain_length

      ! allocate with size chain_length+1 in order to have a more generic formulation
      ! the n+1th thermostat will always have zeta=0, v_zeta=0 and G_zeta=0
      allocate(this%ions_th_zeta(this%ions_th_chain_length+1, ZETA_NUM_STEPS), &
            this%ions_th_v_zeta(this%ions_th_chain_length+1, ZETA_NUM_STEPS), &
            this%ions_th_G_zeta(this%ions_th_chain_length+1, ZETA_NUM_STEPS), &
            this%ions_th_mass(this%ions_th_chain_length+1), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "barostat.f90", ierr)
      end if

      allocate(this%b_epsilon(ZETA_NUM_STEPS), &
            this%b_v_epsilon(ZETA_NUM_STEPS), &
            this%b_F_epsilon(ZETA_NUM_STEPS), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "barostat.f90", ierr)
      end if

      allocate(this%b_th_zeta(b_th_chain_length+1, ZETA_NUM_STEPS), &
            this%b_th_v_zeta(b_th_chain_length+1, ZETA_NUM_STEPS), &
            this%b_th_G_zeta(b_th_chain_length+1, ZETA_NUM_STEPS), &
            this%b_th_mass(b_th_chain_length+1), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "barostat.f90", ierr)
      end if

      this%ions_th_zeta(:,:) = 0.0_wp
      this%ions_th_v_zeta(:,:) = 0.0_wp
      this%ions_th_G_zeta(:,:) = 0.0_wp
      this%ions_th_mass(:) = 0.0_wp

      this%b_epsilon(:) = 0.0_wp
      this%b_v_epsilon(:) = 0.0_wp
      this%b_F_epsilon(:) = 0.0_wp
      this%b_W = 0.0_wp

      this%b_th_zeta(:,:) = 0.0_wp
      this%b_th_v_zeta(:,:) = 0.0_wp
      this%b_th_G_zeta(:,:) = 0.0_wp
      this%b_th_mass(:) = 0.0_wp

      do step = 1, ZETA_NUM_STEPS
         this%zeta_step(step) = step
      end do

   end subroutine define_type

   ! ================================================================================
   !> Allocate velocity work array
   subroutine allocate_velocity_work_array(this, num_ions)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
     implicit none
     ! Parameters
     ! ----------
     type(MW_barostat_t), intent(inout) :: this
     integer, intent(in) :: num_ions !< size of the velocity work array
     ! local
     ! -----
     integer :: ierr

      if (num_ions < 1) then
         call MW_errors_parameter_error("define_type", "barostat.f90", "num_ions", num_ions)
      end if
      allocate(this%velocity_ions_work(num_ions,3,2), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "barostat.f90", ierr)
      end if
      this%velocity_ions_work(:,:,:) = 0.0_wp
    end subroutine allocate_velocity_work_array

   ! ================================================================================
   ! Setup thermostat and barostat masses
   subroutine setup_masses(this, num_dof)
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(inout) :: this
      integer, intent(in) :: num_dof

      ! Local
      ! -----
      real(wp) :: kbt
      real(wp) :: ions_th_relaxation_time_sq
      real(wp) :: b_relaxation_time_sq
      integer :: i

      kbt = boltzmann * this%temperature
      ions_th_relaxation_time_sq = this%ions_th_relaxation_time * this%ions_th_relaxation_time
      b_relaxation_time_sq = this%b_relaxation_time * this%b_relaxation_time

      this%ions_th_mass(1) = num_dof * kbt * ions_th_relaxation_time_sq
      do i = 2, this%ions_th_chain_length
         this%ions_th_mass(i) = kbt * ions_th_relaxation_time_sq
      end do

      this%b_W = (num_dof + 3) * kbt * b_relaxation_time_sq

      do i = 1, this%b_th_chain_length
         this%b_th_mass(i) = kbt * ions_th_relaxation_time_sq     ! Le ions ici n'est pas une erreur 
      end do

   end subroutine setup_masses

   ! ================================================================================
   ! Void a thermostat structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      this%temperature = 0.0_wp
      this%externalpressure = 0.0_wp
      this%ions_th_relaxation_time = 0.0_wp
      this%b_relaxation_time = 0.0_wp
      this%b_W = 0.0_wp
      this%ions_th_chain_length = 0
      this%b_th_chain_length = 0
      this%tolerance = 0.0_wp
      this%zeta_step(:) = 0

      if (allocated(this%velocity_ions_work)) then
         deallocate(this%velocity_ions_work, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "barostat.f90", ierr)
         end if
      end if
      if (allocated(this%ions_th_zeta)) then
         deallocate(this%ions_th_zeta, this%ions_th_v_zeta, &
                    this%ions_th_G_zeta, this%ions_th_mass, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "barostat.f90", ierr)
         end if
      end if
      if (allocated(this%b_th_zeta)) then
         deallocate(this%b_th_zeta, this%b_th_v_zeta, &
                    this%b_th_G_zeta, this%b_th_mass, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "barostat.f90", ierr)
         end if
      end if
      if (allocated(this%b_epsilon)) then
         deallocate(this%b_epsilon, this%b_v_epsilon, this%b_F_epsilon, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "barostat.f90", ierr)
         end if
      end if

   end subroutine void_type

   ! ================================================================================
   ! Print the thermostat structure
   subroutine print_type(this, ounit)
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(in) :: this
      integer, intent(in) :: ounit

      write(ounit, '("|thermostat| temperature:                           ",es12.5)') this%temperature
      write(ounit, '("|thermostat| relaxation time:                       ",es12.5)') &
                                           this%ions_th_relaxation_time
      write(ounit, '("|thermostat| chain length:                          ",i12)') &
                                           this%ions_th_chain_length
      if (allocated(this%ions_th_mass)) then
         write(ounit, '("|thermostat| masses: ",100(es12.5,1x))') this%ions_th_mass(:)
      end if
      write(ounit, '("|barostat| external pressure:                     ",es12.5)') this%externalpressure
      write(ounit, '("|barostat| relaxation time:                       ",es12.5)') this%b_relaxation_time
      write(ounit, '("|barostat| barostat mass: ",(es12.5,1x))') this%b_W
      if (allocated(this%b_th_mass)) then
         write(ounit, '("|barostat| barostat thermostat masses: ",100(es12.5,1x))') this%b_th_mass(:)
      endif
      write(ounit, '("|thermostat/barostat| maximum number of velocity iterations: ",i12)') this%max_iteration
      write(ounit, '("|thermostat/barostat| tolerance on velocities:               ",es12.5)') this%tolerance

   end subroutine print_type

   ! ================================================================================
   !> Cycle history
   subroutine update_history(this)
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: step_now, step

      ! current step data will replace oldest step data
      step_now = this%zeta_step(ZETA_NUM_STEPS)
      do step = ZETA_NUM_STEPS, 2, -1
         this%zeta_step(step) = this%zeta_step(step-1)
      end do
      this%zeta_step(1) = step_now

   end subroutine update_history

   ! ================================================================================
   ! Initialize thermostat position, velocity and force
   subroutine initialize(this, num_dof, ions, velocity_ions_now, volume_now, configurational_pressure)
     implicit none
     ! parameters
     ! ----------
     type(MW_barostat_t), intent(inout) :: this   !< Barostat/thermostat parameters
     integer, intent(in) :: num_dof                 !< number of degree of freedom in the system
     type(MW_ion_t), intent(in) :: ions(:)          !< ion type parameters
     real(wp), intent(in) :: velocity_ions_now(:,:) !< ions velocities
     real(wp), intent(in) :: volume_now             !< volume of the box
     real(wp), intent(in) :: configurational_pressure  !< pressure of the box

     ! Local
     ! -----
     integer :: zeta_now
     integer :: i, itype
     integer :: num_ion_types
     real(wp) :: kbt, mass, vsq, kinetic_energy
     real(wp) :: vx, vy, vz
     real(wp) :: volfactor_now, pressure_now

     call setup_masses(this, num_dof)

     num_ion_types = size(ions,1)
     kbt = boltzmann*this%temperature

     volfactor_now = 1.0_wp / volume_now

     kinetic_energy = 0.0_wp
     do itype = 1, num_ion_types
        mass = ions(itype)%mass
        do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
           vx = velocity_ions_now(i,1)
           vy = velocity_ions_now(i,2)
           vz = velocity_ions_now(i,3)
           vsq = vx*vx + vy*vy + vz*vz
           kinetic_energy = kinetic_energy + mass*vsq
        end do
     end do
     pressure_now = configurational_pressure + kinetic_energy * volfactor_now / 3.0_wp

     zeta_now = this%zeta_step(1)
!    do i = 1, this%chain_length
!       this%zeta(i,zeta_now) = 0.0_wp
!       this%v_zeta(i,zeta_now) = 0.0_wp
!    end do

     ! First thermostat in the chain for ions
     if(this%ions_th_G_zeta(1,zeta_now).eq.0.0_wp) this%ions_th_G_zeta(1,zeta_now) = 1.0_wp/this%ions_th_mass(1) *  &
                               (kinetic_energy - num_dof * kbt)

     ! Chained thermostats for ions
     do i = 2, this%ions_th_chain_length
        if(this%ions_th_G_zeta(i,zeta_now).eq.0.0_wp) this%ions_th_G_zeta(i,zeta_now) = - 1.0_wp/this%ions_th_mass(i) * kbt
     end do

     ! Chained thermostats forthe barostat 
     do i = 1, this%b_th_chain_length
        if(this%b_th_G_zeta(i,zeta_now).eq.0.0_wp) this%b_th_G_zeta(i,zeta_now) = - 1.0_wp/this%b_th_mass(i) * kbt
     end do

     ! Barostat
     if(this%b_F_epsilon(zeta_now).eq.0.0_wp) &
             this%b_F_epsilon(zeta_now) = 3.0_wp * (volume_now * (pressure_now - this%externalpressure) + kinetic_energy / num_dof) 

   end subroutine initialize

   ! ================================================================================
   !> Update ions position
   subroutine ions_positions_update(this, num_dof, dt, ions, &
         velocity_ions_prev, xyz_ions_now, velocity_ions_now, volume_now)
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(inout) :: this           !< barostat/thermostat parameters
      integer, intent(in) :: num_dof                       !< number of degree of freedom in the system
      real(wp), intent(in) :: dt                          !< time step
      type(MW_ion_t), intent(in) :: ions(:)               !< ion_types data
      real(wp), intent(in) :: velocity_ions_prev(:,:)     !< ions velocities at previous time step

      real(wp), intent(inout) :: xyz_ions_now(:,:)        !< ions positions at current time step
      real(wp), intent(inout) :: velocity_ions_now(:,:) !< ions velocities at current time step
      real(wp), intent(inout) :: volume_now             !< volume at current time step

      ! Local
      ! -----
      integer :: i, itype, ichain
      real(wp) :: halfdt, halfdtsq
      real(wp) :: exponentialprefactor
      integer :: zeta_now, zeta_prev
      integer :: num_ion_types

      num_ion_types = size(ions, 1)
      zeta_now = this%zeta_step(1)
      zeta_prev = this%zeta_step(2)

      halfdt = 0.5_wp*dt
      halfdtsq = 0.5_wp*dt*dt


      ! Update positions and velocities with thermostat and barostat "forces" computed at previous time step
      do itype = 1, num_ion_types
         do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count

            velocity_ions_now(i,1) = velocity_ions_now(i,1) - &
                  halfdt * velocity_ions_prev(i,1)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdt * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,1)*this%b_v_epsilon(zeta_prev)
            velocity_ions_now(i,2) = velocity_ions_now(i,2) - &
                  halfdt * velocity_ions_prev(i,2)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdt * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,2)*this%b_v_epsilon(zeta_prev)
            velocity_ions_now(i,3) = velocity_ions_now(i,3) - &
                  halfdt * velocity_ions_prev(i,3)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdt * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,3)*this%b_v_epsilon(zeta_prev)

            xyz_ions_now(i,1) = xyz_ions_now(i,1) - &
                  halfdtsq * velocity_ions_prev(i,1)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdtsq * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,1)*this%b_v_epsilon(zeta_prev)
            xyz_ions_now(i,2) = xyz_ions_now(i,2) - &
                  halfdtsq * velocity_ions_prev(i,2)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdtsq * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,2)*this%b_v_epsilon(zeta_prev)
            xyz_ions_now(i,3) = xyz_ions_now(i,3) - &
                  halfdtsq * velocity_ions_prev(i,3)*this%ions_th_v_zeta(1,zeta_prev) - &
                  halfdtsq * (2.0_wp+3.0_wp/num_dof) * velocity_ions_prev(i,3)*this%b_v_epsilon(zeta_prev)

         end do
      end do

      ! Update ions zetas 
      do ichain = 1, this%ions_th_chain_length
         this%ions_th_zeta(ichain, zeta_now) = this%ions_th_zeta(ichain, zeta_prev) + &
              dt * this%ions_th_v_zeta(ichain, zeta_prev) + &
              halfdtsq * this%ions_th_G_zeta(ichain, zeta_prev)
      end do

      ! Update barostat zetas 
      do ichain = 1, this%b_th_chain_length
         this%b_th_zeta(ichain, zeta_now) = this%b_th_zeta(ichain, zeta_prev) + &
              dt * this%b_th_v_zeta(ichain, zeta_prev) + &
              halfdtsq * this%b_th_G_zeta(ichain, zeta_prev)
      end do
      ! Update epsilon 
      this%b_epsilon(zeta_now) = this%b_epsilon(zeta_prev) + this%b_v_epsilon(zeta_prev) * dt &
                  + (this%b_F_epsilon(zeta_prev) / this%b_W  &
                     - this%b_v_epsilon(zeta_prev) * this%b_th_v_zeta(1,zeta_prev)) * halfdtsq
      ! Update positions and velocities with the new volume
      exponentialprefactor = exp(this%b_epsilon(zeta_now) - this%b_epsilon(zeta_prev))

      do itype = 1, num_ion_types
         do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count

            velocity_ions_now(i,1) = exponentialprefactor * velocity_ions_now(i,1) 
            velocity_ions_now(i,2) = exponentialprefactor * velocity_ions_now(i,2) 
            velocity_ions_now(i,3) = exponentialprefactor * velocity_ions_now(i,3) 

            xyz_ions_now(i,1) = exponentialprefactor * xyz_ions_now(i,1) 
            xyz_ions_now(i,2) = exponentialprefactor * xyz_ions_now(i,2) 
            xyz_ions_now(i,3) = exponentialprefactor * xyz_ions_now(i,3) 

         end do
      end do      

      ! Update volume
      volume_now =  volume_now * exponentialprefactor**3

   end subroutine ions_positions_update

   ! ================================================================================
   !> Update ions position
   subroutine ions_velocities_update(this, num_dof, dt, ions, velocity_ions_now,configurational_pressure,volume_now) 
!             num_pbc, molecule, box, xyz_next,num_molecule_types)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
!     use MW_rattle, only: MW_rattle_constrain_velocities => constrain_velocities
!     use MW_molecule, only: CONSTRAINT_ALGORITHM_RATTLE
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(inout) :: this        !< barostat/thermostat parameters
      integer, intent(in) :: num_dof                      !< number of degrees of freedom
      real(wp), intent(in) :: dt                          !< time step
      type(MW_ion_t), intent(in) :: ions(:)               !< ions parameters
      real(wp), intent(inout) :: velocity_ions_now(:,:) !< ions velocities at current time step
      real(wp), intent(in) :: configurational_pressure    !< configurational contribution to the pressure
      real(wp), intent(in) :: volume_now                 !< volume of the box at current time step
!     integer, intent(in) :: num_pbc
!     type(MW_molecule_t), intent(in) :: molecule(:)
!     type(MW_box_t), intent(in) :: box
!     real(wp), intent(in) :: xyz_next(:,:)
!     integer, intent(in) :: num_molecule_types

      ! Local
      ! -----
      integer :: num_ion_types
!     integer :: max_iteration
      integer :: zeta_now, zeta_prev, zeta_old
      integer :: i, itype, iter, icur, iprev, itmp
      real(wp) :: mass, halfdt
      real(wp) :: th_scalingfactor   
      real(wp) :: kbt, kinetic_energy, vsq
      logical :: converge
      real(wp) :: delta
      real(wp) :: vx, vy, vz
      real(wp) :: pressure_now
      real(wp) :: volfactor_now
!     real(wp) :: tolerance

      num_ion_types = size(ions,1)
      zeta_now = this%zeta_step(1)
      zeta_prev = this%zeta_step(2)
      zeta_old = this%zeta_step(3)

      ! precompute some factors
      kbt = boltzmann*this%temperature
      halfdt = 0.5_wp*dt
      volfactor_now = 1.0_wp / volume_now

      ! Initial guess for ions_th_v_zeta and b_th_v_zeta
      do i = 1, this%ions_th_chain_length
         this%ions_th_v_zeta(i,zeta_now) = this%ions_th_v_zeta(i,zeta_old) + 2.0_wp * dt * this%ions_th_G_zeta(i,zeta_prev)
      end do

      do i = 1, this%b_th_chain_length
         this%b_th_v_zeta(i,zeta_now) = this%b_th_v_zeta(i,zeta_old) + 2.0_wp * dt * this%b_th_G_zeta(i,zeta_prev)
      end do

      ! Initial guess for b_v_epsilon
      this%b_v_epsilon(zeta_now) = this%b_v_epsilon(zeta_old) + 2.0_wp * dt * this%b_F_epsilon(zeta_prev)/this%b_W

      ! Setup work array
      icur = 1
      iprev = 2
      this%velocity_ions_work(:,:,icur) = velocity_ions_now(:,:)

      converge = .false.
      convergenceLoop: do iter = 1, this%max_iteration

         ! swap indices for work arrays
         itmp = icur
         icur = iprev
         iprev = itmp

         th_scalingfactor = 1.0_wp / (1.0_wp + halfdt*(this%ions_th_v_zeta(1,zeta_now) &
                                      + (2.0_wp + 3.0_wp / num_dof)*this%b_v_epsilon(zeta_now)))

         ! Scale velocities
         do itype = 1, num_ion_types
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count

               this%velocity_ions_work(i,1,icur) = th_scalingfactor * velocity_ions_now(i,1)
               this%velocity_ions_work(i,2,icur) = th_scalingfactor * velocity_ions_now(i,2)
               this%velocity_ions_work(i,3,icur) = th_scalingfactor * velocity_ions_now(i,3)

            end do
         end do

!        do itype = 1, num_molecule_types
!           if(molecule(itype)%constraint_algorithm == CONSTRAINT_ALGORITHM_RATTLE) then
!               max_iteration = molecule(itype)%constraint_max_iteration
!               tolerance = molecule(itype)%constraint_tolerance    
!               call MW_rattle_constrain_velocities(num_PBC,molecule(itype), &
!                   box, ions, &
!                    xyz_next(:,:), this%velocity_ions_work(:,:,icur))
!           endif
!        end do

         ! Update thermostat "force"
         kinetic_energy = 0.0_wp
         do itype = 1, num_ion_types
            mass = ions(itype)%mass
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
               vx = this%velocity_ions_work(i, 1, icur)
               vy = this%velocity_ions_work(i, 2, icur)
               vz = this%velocity_ions_work(i, 3, icur)
               vsq = vx*vx + vy*vy + vz*vz
               kinetic_energy = kinetic_energy + mass*vsq
            end do
         end do

         pressure_now = configurational_pressure + kinetic_energy * volfactor_now / 3.0_wp

         ! Chained thermostats for ions update
         ! Implementation feature: ilast=chain_length+1 is a valid index and v_zeta(ilast,:)=0 at all time
         !
         ! First thermostat in the chain
         this%ions_th_G_zeta(1,zeta_now) = 1.0_wp/this%ions_th_mass(1) * (kinetic_energy - num_dof * kbt) - &
               this%ions_th_v_zeta(1, zeta_now)*this%ions_th_v_zeta(2, zeta_now)
         this%ions_th_v_zeta(1,zeta_now) = this%ions_th_v_zeta(1,zeta_prev) + halfdt * (this%ions_th_G_zeta(1,zeta_prev) + &
                                                                                        this%ions_th_G_zeta(1,zeta_now))
         ! Other thermostats
         do i = 2, this%ions_th_chain_length
            this%ions_th_G_zeta(i,zeta_now) = &
                  1.0_wp/this%ions_th_mass(i) * &
                  (this%ions_th_mass(i-1)*this%ions_th_v_zeta(i-1,zeta_now)*this%ions_th_v_zeta(i-1,zeta_now) - kbt) - &
                  this%ions_th_v_zeta(i, zeta_now)*this%ions_th_v_zeta(i+1, zeta_now)
            this%ions_th_v_zeta(i,zeta_now) = this%ions_th_v_zeta(i,zeta_prev) + &
                                              halfdt * (this%ions_th_G_zeta(i,zeta_prev) + this%ions_th_G_zeta(i,zeta_now))
         end do

         ! barostat force and velocity update
!        this%b_F_epsilon(zeta_now) = 3.0_wp * (volume_now * (pressure_now - this%externalpressure) + kinetic_energy / num_dof)
!        this%b_v_epsilon(zeta_now) = this%b_v_epsilon(zeta_prev) + &
!                       halfdt * (this%b_F_epsilon(zeta_prev) / this%b_W - &
!                                 this%b_v_epsilon(zeta_prev)*this%b_th_v_zeta(1,zeta_prev))+ &
!                       halfdt * (this%b_F_epsilon(zeta_now) / this%b_W  &
!                                - this%b_v_epsilon(zeta_now)*this%b_th_v_zeta(1,zeta_now)) 
         this%b_F_epsilon(zeta_now) = 3.0_wp * (volume_now * (pressure_now - this%externalpressure) + kinetic_energy / num_dof) &
                                 - this%b_W * this%b_v_epsilon(zeta_now)*this%b_th_v_zeta(1,zeta_now)
         this%b_v_epsilon(zeta_now) = this%b_v_epsilon(zeta_prev) + &
                        halfdt * (this%b_F_epsilon(zeta_prev) + this%b_F_epsilon(zeta_now)) / this%b_W  



         ! Chained thermostats for barostat update
         ! Implementation feature: ilast=chain_length+1 is a valid index and v_zeta(ilast,:)=0 at all time
         !
         ! First thermostat in the chain
         this%b_th_G_zeta(1,zeta_now) = 1.0_wp/this%b_th_mass(1) * (this%b_W * this%b_v_epsilon(zeta_now)**2 - kbt) - &
               this%b_th_v_zeta(1, zeta_now)*this%b_th_v_zeta(2, zeta_now)
         this%b_th_v_zeta(1,zeta_now) = this%b_th_v_zeta(1,zeta_prev) + halfdt * (this%b_th_G_zeta(1,zeta_prev) + &
                                                                                        this%b_th_G_zeta(1,zeta_now))
         ! Other thermostats
         do i = 2, this%b_th_chain_length
            this%b_th_G_zeta(i,zeta_now) = &
                  1.0_wp/this%b_th_mass(i) * &
                  (this%b_th_mass(i-1)*this%b_th_v_zeta(i-1,zeta_now)*this%b_th_v_zeta(i-1,zeta_now) - kbt) - &
                  this%b_th_v_zeta(i, zeta_now)*this%b_th_v_zeta(i+1, zeta_now)
            this%b_th_v_zeta(i,zeta_now) = this%b_th_v_zeta(i,zeta_prev) + &
                                              halfdt * (this%b_th_G_zeta(i,zeta_prev) + this%b_th_G_zeta(i,zeta_now))
         end do

         ! check for convergence
         delta = 0.0_wp
         do itype = 1, num_ion_types
            mass = ions(itype)%mass
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
               vx = this%velocity_ions_work(i,1,icur) - this%velocity_ions_work(i,1,iprev)
               vy = this%velocity_ions_work(i,2,icur) - this%velocity_ions_work(i,2,iprev)
               vz = this%velocity_ions_work(i,3,icur) - this%velocity_ions_work(i,3,iprev)
               vsq = vx*vx + vy*vy + vz*vz
               delta = delta + mass*vsq
            end do
         end do

         if (delta <= (num_dof*kbt)*this%tolerance) then
            converge = .true.
            exit convergenceLoop
         end if

      end do convergenceLoop
      if (.not. converge) then
         call MW_errors_runtime_error("ions_velocities_update", "barostat.f90", &
               "Velocity thermostating failed to converge")
      end if

      ! Copy back updated velocities
      velocity_ions_now(:,:) = this%velocity_ions_work(:,:,icur)

   end subroutine ions_velocities_update

   ! ================================================================================
   !> Compute the energy of the barostat
   subroutine energy(this, num_dof, volume, h)
      implicit none
      ! Parameters
      ! ----------
      type(MW_barostat_t), intent(in) :: this
      integer, intent(in) :: num_dof
      real(wp), intent(in) :: volume
      real(wp), intent(inout) :: h

      ! Locals
      ! ------
      integer :: zeta_now
      integer :: i
      real(wp) :: ions_th_kinetic_energy, ions_th_potential_energy
      real(wp) :: b_th_kinetic_energy, b_th_potential_energy
      real(wp) :: b_kinetic_energy, b_potential_energy
      real(wp) :: PV
      real(wp) :: kbt

      zeta_now = this%zeta_step(1)
      kbt = boltzmann * this%temperature

      ions_th_kinetic_energy = 0.0_wp
      do i = 1, this%ions_th_chain_length
         ions_th_kinetic_energy = ions_th_kinetic_energy + &
                  0.5_wp * this%ions_th_mass(i) * this%ions_th_v_zeta(i, zeta_now) * this%ions_th_v_zeta(i, zeta_now)
      end do

      ions_th_potential_energy = num_dof * kbt * this%ions_th_zeta(1,zeta_now)
      do i = 2, this%ions_th_chain_length
         ions_th_potential_energy = ions_th_potential_energy + kbt * this%ions_th_zeta(i, zeta_now)
      end do

      b_kinetic_energy = 0.5_wp * this%b_W * this%b_v_epsilon(zeta_now) * this%b_v_epsilon(zeta_now)

      b_potential_energy = kbt * this%b_epsilon(zeta_now)

      b_th_kinetic_energy = 0.0_wp
      do i = 1, this%b_th_chain_length
         b_th_kinetic_energy = b_th_kinetic_energy + &
                  0.5_wp * this%b_th_mass(i) * this%b_th_v_zeta(i, zeta_now) * this%b_th_v_zeta(i, zeta_now)
      end do

      b_th_potential_energy = 0.0_wp
      do i = 1, this%b_th_chain_length
         b_th_potential_energy = b_th_potential_energy + kbt * this%b_th_zeta(i, zeta_now)
      end do

      PV =  this%externalpressure * volume 

      h = ions_th_kinetic_energy + ions_th_potential_energy + &
          b_kinetic_energy + b_potential_energy    + &
          b_th_kinetic_energy + b_th_potential_energy + &
          PV   
   end subroutine energy

end module MW_barostat

module MW_dihedrals
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_timers
   use MW_kinds, only: wp
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_molecule, only: MW_molecule_t
   use MW_box, only: MW_box_t
   use MW_ion, only: MW_ion_t
   implicit none
   private

   public :: forces
   public :: energy
contains

   ! ================================================================================
   !> Compute the forces due to dihedral potential
   subroutine forces(num_pbc, localwork, box, molecules, ions, xyz_ions, force,stress_tensor)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_box_t), intent(in) :: box
      type(MW_molecule_t), intent(in) :: molecules(:)
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(in) :: xyz_ions(:,:)
      real(wp), intent(inout) :: force(:,:)
      real(wp), intent(inout) :: stress_tensor(:,:)
      integer :: ierr,count

      select case(num_pbc)
      case(2)
         call forces_2DPBC(localwork, box, molecules, ions, xyz_ions, force,stress_tensor)
      case(3)
         call forces_3DPBC(localwork, box, molecules, ions, xyz_ions, force,stress_tensor)
      end select
#ifndef MW_SERIAL
      count = size(force,1)*size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)      
#endif
   end subroutine forces

   ! ================================================================================
   !> Compute the forces due to dihedral potential
   subroutine energy(num_pbc, localwork, box, molecules, ions, xyz_ions, h)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_box_t), intent(in) :: box
      type(MW_molecule_t), intent(in) :: molecules(:)
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(in) :: xyz_ions(:,:)
      real(wp), intent(inout) :: h
      integer :: ierr

      select case(num_pbc)
      case(2)
         call energy_2DPBC(localwork, box, molecules, ions, xyz_ions, h)
      case(3)
         call energy_3DPBC(localwork, box, molecules, ions, xyz_ions, h)
      end select
#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM,MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   ! ================================================================================
   include 'dihedrals_2DPBC.inc'
   include 'dihedrals_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
end module MW_dihedrals

! Module defines CG type to store CG algorithm parameters
module MW_cgaim
   use MW_kinds, only: wp, sp
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_cgaim_t

   ! Public subroutines
   ! ------------------
   public :: set_max_iterations
   public :: set_tolerance
   public :: reset_statistics
!  public :: allocate_arrays
   public :: void_type
   public :: print_type
   public :: print_statistics
   public :: solve

   type MW_cgaim_t

      ! Convergence parameters
      integer :: max_iterations !< maximum number of iterations
      real(wp) :: tol           !< tolerance on residual norm
      ! Statistics
      integer  :: last_iteration_count    !< Number of iteration for the last CG
      real(wp) :: last_residual
      real(wp) :: last_residual_tol
      real(sp) :: total_iteration_count   !< Sum of all iteration count

      ! work arrays
!     integer :: n                    !< dimension of the work arrays
!     real(wp), allocatable :: b(:)   !< right hand side
!     real(wp), allocatable :: res(:) !< residual
!     real(wp), allocatable :: p(:)   !< conjugate direction
!     real(wp), allocatable :: Ap(:)  !< A times p
      real(wp), allocatable :: xi(:)  ! gradient

   end type MW_cgaim_t

contains

   ! ================================================================================
   ! Set maximum number of iterations
   subroutine set_max_iterations(this, max_iterations)
      implicit none
      type(MW_cgaim_t), intent(inout) :: this
      integer, intent(in) :: max_iterations
      this%max_iterations = max_iterations
   end subroutine set_max_iterations

   ! ================================================================================
   ! Set tolerance parameter
   subroutine set_tolerance(this, tol)
      implicit none
      type(MW_cgaim_t), intent(inout) :: this
      real(wp), intent(in) :: tol
      this%tol = tol
   end subroutine set_tolerance

   ! ================================================================================
   ! reset statistic counters
   subroutine reset_statistics(this)
      implicit none
      type(MW_cgaim_t), intent(inout) :: this
      this%last_iteration_count = 0
      this%last_residual = 0.0_wp
      this%last_residual_tol = 0.0_wp
      this%total_iteration_count = 0
   end subroutine reset_statistics

   !================================================================================
!  ! Allocate data arrays
!  subroutine allocate_arrays(this, n)
!     use MW_errors, only: MW_errors_allocate_error => allocate_error
!     implicit none

!     ! Parameters inout
!     ! ----------------
!     type(MW_cgaim_t), intent(inout) :: this

!     ! Parameters in
!     ! -------------
!     integer, intent(in) :: n !< size of the data arrays

!     ! Local
!     ! -----
!     integer :: i
!     integer :: ierr

!     this%n = n
!     allocate(this%b(n), this%res(n), this%p(n), this%Ap(n), stat=ierr)
!     if (ierr /= 0) then
!        call MW_errors_allocate_error("define_type", "cg.f90", ierr)
!     end if

!     do i = 1, n
!        this%b(i) = 0.0_wp
!        this%res(i) = 0.0_wp
!        this%p(i) = 0.0_wp
!        this%Ap(i) = 0.0_wp
!     end do

!  end subroutine allocate_arrays

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cgaim_t), intent(inout) :: this

      ! Local
      ! -----
      this%max_iterations = 0
      this%tol = 0.0_wp
      this%last_iteration_count = 0
      this%total_iteration_count = 0.0_sp
      this%last_residual_tol = 0.0_wp
!     this%n = 0

!     if (allocated(this%b)) then
!        deallocate(this%b, this%res, this%p, this%Ap, stat=ierr)
!        if (ierr /= 0) then
!           call MW_errors_deallocate_error("void_type", "cgaim.f90", ierr)
!        end if
!     end if
   end subroutine void_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_type(this, ounit)
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cgaim_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|cgaim| maximum number of iterations: ",i12)') this%max_iterations
      write(ounit, '("|cgaim| Residual error:               ",es12.5)') this%tol
   end subroutine print_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_statistics(this, ounit)
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cgaim_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|cgaim| number of iterations: ",i12)') this%last_iteration_count
      write(ounit, '("|cgaim| Residual difference:        ",es12.5)') this%last_residual
   end subroutine print_statistics

!subroutine solve(system,p,num,itmax,tolaim,ftolaim)
subroutine solve(this,system,p,num)
   use MW_system, only: MW_system_t
   use MW_daim, only: &
         MW_daim_repulsionenergy => repulsionenergy, &
         MW_daim_diffrepulsionenergy => diffrepulsionenergy, &
         MW_daim_selfenergy => selfenergy, &
         MW_daim_diffselfenergy => diffselfenergy
   use MW_kinds, only: wp
   use MW_errors, only: MW_errors_runtime_error => runtime_error
   use MW_stdio, only: MW_stderr

   implicit none

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   type(MW_cgaim_t), intent(inout) :: this
   integer :: num        ! number of ions

   ! Parameters out 
   ! -------------
   real(wp),  intent(inout) :: p(:)

   ! LOCAL 
   ! -------------
   integer :: its,iter,xyz_now
   integer :: itmax     ! max number of iterations
   real(wp) :: tolaim,ftolaim    ! tolerances
   real(wp), dimension(4*num) :: g,hhh,pairxi,selfxi,xi
   real(wp) :: fp,gg,dgg,gam,fret
   real(wp) :: pairenergy,selfenergy
   real(wp), dimension(num) :: locdeltas
   real(wp), dimension(num,3) :: locepsilons
   logical :: cg_converged

   pairenergy=0.d0
   selfenergy=0.d0
   itmax=this%max_iterations
   tolaim=this%tol
   ftolaim=this%tol
   cg_converged=.false.

   xyz_now=system%xyz_ions_step(1)

   locdeltas(1:num)=p(1:num)
   locepsilons(1:num,1)=p(num+1:2*num)
   locepsilons(1:num,2)=p(2*num+1:3*num)
   locepsilons(1:num,3)=p(3*num+1:4*num)

   pairxi=0.d0
   selfxi=0.d0

! I need to implement the derivatives there
   call MW_daim_diffrepulsionenergy(system%num_PBC, system%localwork, system%daim, system%box, &
               system%ions, system%xyz_ions(:,:,xyz_now), &
               system%electrodes, system%xyz_atoms,locdeltas, &
               locepsilons,pairenergy,pairxi)

   call MW_daim_diffselfenergy(system%num_ion_types,system%ions,locdeltas,locepsilons,selfenergy,selfxi)

   fp=pairenergy+selfenergy
   xi=pairxi+selfxi

   g=-xi
   hhh=g
   xi=hhh

   iter=0
   do its=1,itmax
      iter=its
      call linminaim(system,num,tolaim,p,xi,fret)

!     if(2.*abs(fret-fp).le.ftolaim*(abs(fret)+abs(fp)+EPS))then
      if(abs(fret-fp).le.ftolaim)then
         this%last_residual=abs(fret-fp)
         this%last_iteration_count=iter
         cg_converged=.true.
         return
      endif

      locdeltas(1:num)=p(1:num)
      locepsilons(1:num,1)=p(num+1:2*num)
      locepsilons(1:num,2)=p(2*num+1:3*num)
      locepsilons(1:num,3)=p(3*num+1:4*num)

      pairenergy=0.0_wp
      selfenergy=0.0_wp
      pairxi=0.0_wp
      selfxi=0.0_wp
      call MW_daim_diffrepulsionenergy(system%num_PBC, system%localwork, system%daim, &
               system%box, &
               system%ions, system%xyz_ions(:,:,xyz_now), &
               system%electrodes, system%xyz_atoms,locdeltas, &
               locepsilons,pairenergy,pairxi)

      call MW_daim_diffselfenergy(system%num_ion_types,system%ions, &
                locdeltas,locepsilons,selfenergy,selfxi)

      fp=pairenergy+selfenergy
      xi=pairxi+selfxi
      gg=dot_product(g,g)
      dgg=dot_product(xi,g+xi)
      if(gg.eq.0)return
      gam=dgg/gg
      g=-xi
      hhh=g+gam*hhh
      xi=hhh
   enddo
   if(.not.cg_converged)then
      this%last_residual=abs(fret-fp)
      this%last_iteration_count=iter
      call print_statistics(this, MW_stderr)
      call MW_errors_runtime_error("solve","cgaim.f90", "CGaim failed to converge")
   endif
return

end subroutine solve

subroutine linminaim(system,num,tolaim,p,xi,fret)
   use MW_system, only: MW_system_t

   implicit none

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   integer :: num        ! number of ions
   real(wp) :: tolaim    ! tolerances

   ! Parameters out 
   ! -------------
   real(wp),  intent(inout) :: p(:)
   real(wp),  intent(inout) :: xi(:)
   real(wp), intent(out) :: fret

   ! LOCAL 
   ! -------------
   real(wp) :: axx,bxx,xx,xmin !dbrent!,F1DIMAIM
   real(wp), dimension(2) :: resultdbrent  
   real(wp), dimension(4*num) :: pcomaim,xicomaim 
!EXTERNAL F1DIMAIM,DF1DIMAIM

   pcomaim=p
   xicomaim=xi

   axx=0.000_wp
   xx=0.001_wp
   bxx=0.002_wp
   
   call mnbrakaim(system,num,axx,xx,bxx,pcomaim,xicomaim) 
   resultdbrent=dbrent(system,num,axx,xx,bxx,tolaim,pcomaim,xicomaim)
   fret=resultdbrent(1)
   xmin=resultdbrent(2)
   xi=xmin*xi
   p=p+xi

return
end subroutine linminaim

subroutine mnbrakaim(system,num,axx,bxx,cx,pcomaim,xicomaim)
   use MW_system, only: MW_system_t

   implicit none

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   integer, intent(in) :: num
   real(wp), intent(in) :: pcomaim(:)
   real(wp), intent(in) :: xicomaim(:) 
   ! Parameters out 
   ! -------------
   real(wp), intent(inout) :: axx,bxx,cx !F1DIMAIM

   ! LOCAL 
   ! -------------
   real(wp) :: dum,r,qq,u,ulim,fu
   real(wp) :: fa,fb,fc 
   real(wp), parameter :: GOLD=1.618034, GLIMIT=100.0_wp, TINY=1.E-20

   fa=f1dimaim(system,num,pcomaim,xicomaim,axx) 
   fb=f1dimaim(system,num,pcomaim,xicomaim,bxx) 


   if(fb.gt.fa)then
      dum=axx
      axx=bxx
      bxx=dum
      dum=fb
      fb=fa
      fa=dum
   endif
   cx=bxx+GOLD*(bxx-axx)
   fc=f1dimaim(system,num,pcomaim,xicomaim,cx) 
1  if(fb.ge.fc)then
      r=(bxx-axx)*(fb-fc)
      qq=(bxx-cx)*(fb-fa)
      u=bxx-((bxx-cx)*qq-(bxx-axx)*r)/(2.0_wp*sign(max(abs(qq-r),TINY),QQ-R))
      ulim=bxx+GLIMIT*(cx-bxx)
      if((bxx-u)*(u-cx).gt.0.0_wp)then
         fu=f1dimaim(system,num,pcomaim,xicomaim,u)
         if(fu.lt.fc)then
            axx=bxx
            fa=fb
            bxx=u
            fb=fu
            go to 1
         else if(fu.gt.fb)then
            cx=u
            fc=fu
            go to 1
         endif
         u=cx+GOLD*(cx-bxx)
         fu=f1dimaim(system,num,pcomaim,xicomaim,u)
      else if((cx-u)*(u-ulim).gt.0.0_wp)then
         fu=f1dimaim(system,num,pcomaim,xicomaim,u)
         if(fu.lt.fc)then
            bxx=cx
            cx=u
            u=cx+GOLD*(cx-bxx)
            fb=fc
            fc=fu
            fu=f1dimaim(system,num,pcomaim,xicomaim,u)
         endif
      else if((u-ulim)*(ulim-cx).ge.0.0_wp)then
         u=ulim
         fu=f1dimaim(system,num,pcomaim,xicomaim,u)
      else
        u=cx+GOLD*(cx-bxx)
        fu=f1dimaim(system,num,pcomaim,xicomaim,u)
      endif
      axx=bxx
      bxx=cx
      cx=u
      fa=fb
      fb=fc
      fc=fu
      go to 1
   end if
return
end subroutine mnbrakaim

function dbrent(system,num,ax,bx,cx,tol,pcomaim,xicomaim) result(resultdbrent)
   use MW_system, only: MW_system_t

   implicit none

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   integer, intent(in) :: num
   real(wp), intent(in) :: tol
   real(wp), intent(in) :: ax,bx,cx
   real(wp), dimension(4*num), intent(in) :: pcomaim,xicomaim 

   ! Result
   ! -------------
   real(wp),dimension(2) ::resultdbrent 

   ! Local
   ! -------------
   integer :: iter
   real(wp) :: xminloc,tol1,tol2,olde,a,b,d,e,u,v,w,x,d1,d2, &
                       du,dv,dw,dx,fu,fv,fw,fx,u1,u2,xm
   real(wp),dimension(2) :: energyanddiff
!DOUBLE PRECISION :: F,DF
   integer, parameter :: ITMAX=100
   real(wp), parameter :: ZEPS=1.0d-10
   logical ok1,ok2

   a=min(ax,cx)
   b=max(ax,cx)
   v=bx
   w=v
   x=v
   d=0.0_wp
   e=0.0_wp
!  x=f1dimaim(system,num,pcomaim,xicomaim,x)  ! probably merged with the calculation of dx
   energyanddiff=df1dimaim(system,num,pcomaim,xicomaim,x) ! probably get everything together at once
   fx=energyanddiff(1)
   dx=energyanddiff(2)

   fv=fx
   fw=fx
   dv=dx
   dw=dx   

   do iter=1,ITMAX
      xm=0.5_wp*(a+b)
      tol1=tol*abs(x)+ZEPS
      tol2=2.0_wp*tol1
      if(abs(x-xm).le.(tol2-0.5_wp*(b-a))) exit
      if(abs(e).gt.tol1)then
         d1=2.0_wp*(b-a)
         d2=d1
         if(dw.ne.dx) d1=(w-x)*dx/(dx-dw)
         if(dv.ne.dx) d2=(v-x)*dx/(dx-dv)
         u1=x+d1
         u2=x+d2
         ok1=((a-u1)*(u1-b).gt.0.0_wp).and.(dx*d1.le.0.0_wp)
         ok2=((a-u2)*(u2-b).gt.0.0_wp).and.(dx*d2.le.0.0_wp)
         olde=e
         e=d
         if(.not.(ok1.or.ok2))then
            go to 1
         else if(ok1.and.ok2)then
            if(abs(d1).lt.abs(d2))then
               d=d1
            else
               d=d2
            endif
         else if(ok1)then
            d=d1
         else
            d=d2
         endif
         if(abs(d).gt.abs(0.5_wp*olde)) go to 1
         u=x+d
         if((u-a.lt.tol2).or.(b-u.lt.tol2)) d=sign(tol1,xm-x)   
         go to 2
      endif
1     if(dx.ge.0.0_wp)then
         e=a-x
      else
         e=b-x
      endif
      d=0.5_wp*e
2     if(abs(d).ge.tol1)then
         u=x+d
!        fu=f1dimaim(system,num,pcomaim,xicomaim,u)  
      else
         u=x+sign(tol1,d)
!        fu=f1dimaim(system,num,pcomaim,xicomaim,u)  
!        if(fu.gt.fx)exit
      endif
!     fu=f1dimaim(system,num,pcomaim,xicomaim,u)  
!     du=df1dimaim(system,num,pcomaim,xicomaim,u) ! probably get everything together at once
      energyanddiff=df1dimaim(system,num,pcomaim,xicomaim,u) ! probably get everything together at once
      fu=energyanddiff(1)
      du=energyanddiff(2)
      if(abs(d).lt.tol1)then
         if(fu.gt.fx)exit
      endif
      if(fu.le.fx)then
         if(u.ge.x)then
            a=x
         else
            b=x
         endif
         v=w
         fv=fw
         dv=dw
         w=x
         fw=fx
         dw=dx
         x=u
         fx=fu
         dx=du
      else
         if(u.lt.x)then
            a=u
         else
            b=u
         endif
         if((fu.le.fw).or.(w.eq.x))then
            v=w
            fv=fw
            dv=dw
            w=u
            fw=fu
            dw=du
         else if((fu.le.fv).or.(v.eq.x).or.(v.eq.w))then
            v=u
            fv=fu
            dv=du
         endif
      endif
   enddo
   xminloc=x
   resultdbrent(1)=fx
   resultdbrent(2)=xminloc
   return
end function dbrent

function f1dimaim(system,num,pcomaim,xicomaim,xxx) result(energytot)
   use MW_system, only: MW_system_t
   use MW_daim, only: &
         MW_daim_repulsionenergy => repulsionenergy, &
         MW_daim_selfenergy => selfenergy

   implicit none  

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   integer :: num        ! number of ions
   real(wp), intent(in) :: pcomaim(:)
   real(wp), intent(in) :: xicomaim(:) 
   real(wp), intent(in) :: xxx

   ! Result 
   ! -------------
   real(wp) :: energytot

   ! LOCAL 
   ! ------------- 
   integer :: i,itype,iion,offset
   integer :: xyz_now
   real(wp) :: pairenergy,selfenergy
   real(wp), dimension(4*num) :: xt
   real(wp), dimension(num) :: locdeltas
   real(wp), dimension(num,3) :: locepsilons

   xyz_now=system%xyz_ions_step(1)

   xt=0.0_wp

   do itype=1,system%num_ion_types
      if(system%ions(itype)%selfdaimD>0.0_wp)then
         offset=system%ions(itype)%offset
         do i=1,system%ions(itype)%count
            iion=offset+i
            xt(iion)=pcomaim(iion)+xxx*xicomaim(iion) 
            xt(num+iion)=pcomaim(num+iion)+xxx*xicomaim(num+iion) 
            xt(2*num+iion)=pcomaim(2*num+iion)+xxx*xicomaim(2*num+iion) 
            xt(3*num+iion)=pcomaim(3*num+iion)+xxx*xicomaim(3*num+iion) 
         enddo
      endif
   enddo
  
   locdeltas(1:num)=xt(1:num)
   locepsilons(1:num,1)=xt(num+1:2*num)
   locepsilons(1:num,2)=xt(2*num+1:3*num)
   locepsilons(1:num,3)=xt(3*num+1:4*num)

   pairenergy=0.0_wp
   selfenergy=0.0_wp
   call MW_daim_repulsionenergy(system%num_PBC, system%localwork, system%daim, system%box, &
               system%ions, system%xyz_ions(:,:,xyz_now), &
               system%electrodes, system%xyz_atoms,locdeltas, &
               locepsilons,pairenergy)

   call MW_daim_selfenergy(system%num_ion_types,system%ions,locdeltas,locepsilons,selfenergy)

   energytot=pairenergy+selfenergy

return
end function f1dimaim

function df1dimaim(system,num,pcomaim,xicomaim,xxx) result(energyanddiff)
   use MW_system, only: MW_system_t
   use MW_daim, only: &
         MW_daim_diffrepulsionenergy => diffrepulsionenergy, &
         MW_daim_diffselfenergy => diffselfenergy

   implicit none  

   ! Parameters in
   ! -------------
   type(MW_system_t), intent(inout) :: system
   integer :: num        ! number of ions
   real(wp), intent(in) :: pcomaim(:)
   real(wp), intent(in) :: xicomaim(:) 
   real(wp), intent(in) :: xxx

   ! Result 
   ! -------------
   real(wp),dimension(2) :: energyanddiff

   ! LOCAL 
   ! ------------- 
   integer :: i,itype,iion,offset
   integer :: xyz_now
   real(wp) :: pairenergy,selfenergy,energytot
   real(wp), dimension(4*num) :: xt,locxi,pairxi,selfxi
   real(wp), dimension(num) :: locdeltas
   real(wp), dimension(num,3) :: locepsilons

   xyz_now=system%xyz_ions_step(1)

   xt=0.0_wp

   do itype=1,system%num_ion_types
      if(system%ions(itype)%selfdaimD>0.0_wp)then
         offset=system%ions(itype)%offset
         do i=1,system%ions(itype)%count
            iion=offset+i
            xt(iion)=pcomaim(iion)+xxx*xicomaim(iion) 
            xt(num+iion)=pcomaim(num+iion)+xxx*xicomaim(num+iion) 
            xt(2*num+iion)=pcomaim(2*num+iion)+xxx*xicomaim(2*num+iion) 
            xt(3*num+iion)=pcomaim(3*num+iion)+xxx*xicomaim(3*num+iion) 
         enddo
      endif
   enddo
   locdeltas(1:num)=xt(1:num)
   locepsilons(1:num,1)=xt(num+1:2*num)
   locepsilons(1:num,2)=xt(2*num+1:3*num)
   locepsilons(1:num,3)=xt(3*num+1:4*num)

   pairenergy=0.0_wp
   selfenergy=0.0_wp
   pairxi=0.0_wp
   selfxi=0.0_wp
   call MW_daim_diffrepulsionenergy(system%num_PBC, system%localwork, system%daim, system%box, &
               system%ions, system%xyz_ions(:,:,xyz_now), &
               system%electrodes, system%xyz_atoms,locdeltas, &
               locepsilons,pairenergy,pairxi)

   call MW_daim_diffselfenergy(system%num_ion_types,system%ions,locdeltas,locepsilons,selfenergy,selfxi)

   energytot=pairenergy+selfenergy
   energyanddiff(1)=energytot
   locxi=pairxi+selfxi
   energyanddiff(2)=dot_product(locxi,xicomaim)

return
end function df1dimaim
end module MW_cgaim

        ! Module to handle parsing a configuration file
module MW_configuration_line
   implicit none
   private

   ! Public subroutine
   ! -----------------
   public :: get_word
   public :: parse_line
   public :: seek_next_data

   ! Public type
   ! -----------
   public :: MW_configuration_line_t

   integer, parameter, public :: max_word_length = 31             !< maximum number of characters in a word
   integer, parameter, public :: max_line_length = 256           !< maximum number of characters on one line
   integer, parameter :: max_line_words = 60               !< maximum number of words on one line
   character(2), parameter :: comment_char = "!#" !< characters which begin a comment
   character(6), parameter :: whitespace_char = &
        achar(9)  // & !< horizontal tabulation
        achar(10) // & !< Line feed 
        achar(11) // & !< Vertical Tabl
        achar(12) // & !< Form Feed
        achar(13) // & !< Carriage return
        achar(32)      !< space

   interface get_word
      module procedure get_word_as_string
      module procedure get_word_as_int
      module procedure get_word_as_real
      module procedure get_word_as_logical
   end interface get_word

   type MW_configuration_line_t
      character(len=max_line_length) :: line = ''                 !< whole line being read
      integer :: num_words = 0                                    !< number of words on the line
      character(len=max_word_length*max_line_words) :: words = '' !< maximum number of words
   end type MW_configuration_line_t

contains

   ! ================================================================================
   ! Seek next line with data in it
   !
   ! If we reach the end of the file, the subroutine returns an empty configuration line
   subroutine seek_next_data(this, funit, line_num)
      use iso_fortran_env, only: iostat_end
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none

      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(inout) :: this  !< configuration line
      integer, intent(in) :: funit                          !< file unit
      integer, intent(inout) :: line_num                    !< line number in configuration file

      ! Local
      ! -----
      integer :: ierr
      character(256) :: errmsg
      character(max_line_length) :: line

      ! Read configuration file 1 line at a time
      call void(this)
      do while (.true.)
         line_num = line_num + 1
         read(funit, '(a)', iostat=ierr) line
         if (ierr == iostat_end) then
            backspace(funit)
            line_num = line_num - 1
            exit ! End of file
         else if (ierr /= 0) then
            write(errmsg,'("An error occured while reading line ",i4," in configuration file")') &
                  line_num
            call MW_errors_runtime_error("seek_next_data","configuration.f90", errmsg)
         end if
         ! Parse input line
         call parse_line(this, line)

         if (this%num_words > 0) exit
      end do
   end subroutine seek_next_data

   ! ================================================================================
   ! Void a configuration line
   subroutine void(this)
      implicit none
      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(inout) :: this
      ! Local
      ! -----

      this%line = ''
      this%num_words = 0
      this%words = ''

   end subroutine void

   ! ================================================================================
   ! Parse a configuration line
   !
   ! Remove comments from line read in the configuration file and split the line into words
   subroutine parse_line(this, line)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none

      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(inout) :: this
      character(*), intent(in) :: line

      ! locals
      ! ------
      character(max_line_length) :: buffer
      integer :: ichar, icomment, istart, iend
      character(2*max_line_length) :: errmsg
      integer :: word_start, word_end, i
      this%line = line

      ! copy line into buffer
      buffer = adjustl(line)

      ! Remove comments
      icomment = scan(buffer, comment_char)

      if (icomment > 0) then
         do ichar = icomment, max_line_length
            buffer(ichar:ichar) = " "
         end do
      end if

      ! Find word boundaries
      iend = 0
      this%num_words = 0
      do while (iend < max_line_length)

         istart = verify(buffer(iend+1:), whitespace_char)

         ! exit if all characters in buffer(iend+1:) are whitespace characters
         if (istart == 0) then
            exit
         else
            istart = istart + iend
         end if

         iend = scan(buffer(istart:), whitespace_char)
         ! put the next whitespace after the line if there are none in buffer(istart:)
         if (iend == 0) then
            iend = max_line_length+1
         else
            iend = iend + istart - 1
         end if

         ! Check wether we reached the maximum number of words
         if (this%num_words == max_line_words) then
            write(errmsg,'("Too many words in configuration line (max ",i3,")",a1001)') &
                  max_line_words, new_line('A') // line
            call MW_errors_runtime_error("parse_line", "configuration.f90", &
                  errmsg)
         end if

         ! Check wether the word is not too long
         if ((iend-istart) > max_word_length) then
            write(errmsg,'("A word is too long in configuration line (max ",i3,")",a1001)') &
                  max_word_length, new_line('A') // line
            call MW_errors_runtime_error("parse_line", "configuration.f90", &
                  errmsg)
         end if

         ! Store the word between the first non-whitespace character the next whitespace character
         this%num_words = this%num_words+1

         word_start = (this%num_words-1)*max_word_length + 1
         word_end = word_start + iend - istart

         this%words(word_start:word_end) = buffer(istart:iend-1)

         word_start = word_end
         word_end = this%num_words*max_word_length
         do i = word_start, word_end
            this%words(i:i) = " "
         end do

      end do

   end subroutine parse_line

   ! ================================================================================
   ! Get a word as a string
   subroutine get_word_as_string(this, iword, word)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(in)    :: this
      integer,                       intent(in)    :: iword
      character(*),                  intent(inout) :: word

      ! integer
      integer :: word_start, word_end

      if (iword > this%num_words) then
         call MW_errors_parameter_error("get_word_as_string", "configuration.f90", &
               "iword", iword)
      end if

      word_start = (iword-1)*max_word_length + 1
      word_end = word_start + min(max_word_length,len(word)) - 1
      word = this%words(word_start:word_end)

   end subroutine get_word_as_string

   ! ================================================================================
   ! Get a word as a string
   subroutine get_word_as_int(this, iword, word)
      use MW_errors, only: MW_errors_parameter_error => parameter_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(in)    :: this
      integer,                       intent(in)    :: iword
      integer,                       intent(inout) :: word

      ! Local
      ! -----
      integer :: ierr
      character(2*max_line_length) :: errmsg
      integer :: word_start, word_end
      character(max_word_length) :: buffer

      if (iword > this%num_words) then
         call MW_errors_parameter_error("get_word_as_int", "configuration.f90", &
               "iword", iword)
      end if

      word_start = (iword-1)*max_word_length + 1
      word_end = word_start + max_word_length
      buffer = this%words(word_start:word_end)

      read(buffer, *, iostat=ierr) word
      if (ierr /= 0) then
         write(errmsg,'("Failed to read word ",i3," as integer in configuration line",a257)') &
               iword, new_line('A') //  this%line
         call MW_errors_runtime_error("get_word_as_int", "configuration.f90", &
               errmsg)
      end if

   end subroutine get_word_as_int

   ! ================================================================================
   ! Get a word as a real
   subroutine get_word_as_real(this, iword, word)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_parameter_error => parameter_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(in)    :: this
      integer,                       intent(in)    :: iword
      real(wp),                      intent(inout) :: word

      ! Local
      ! -----
      integer :: ierr
      character(2*max_line_length) :: errmsg
      integer :: word_start, word_end
      character(max_word_length) :: buffer

      if (iword > this%num_words) then
         call MW_errors_parameter_error("get_word_as_real", "configuration.f90", &
               "iword", iword)
      end if

      word_start = (iword-1)*max_word_length + 1
      word_end = word_start + max_word_length
      buffer = this%words(word_start:word_end)

      read(buffer,*, iostat=ierr) word
      if (ierr /= 0) then
         write(errmsg,'("Failed to read word ",i3," as real in configuration line",a257)') &
               iword, new_line('A') // this%line
         call MW_errors_runtime_error("get_word_as_real", "configuration.f90", &
               errmsg)
      end if

   end subroutine get_word_as_real

   ! ================================================================================
   ! Get a word as a logical true/false
   subroutine get_word_as_logical(this, iword, word)
      use MW_errors, only: MW_errors_parameter_error => parameter_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_configuration_line_t), intent(in)    :: this
      integer,                       intent(in)    :: iword
      logical,                       intent(inout) :: word

      ! Local
      ! -----
      character(2*max_line_length) :: errmsg
      integer :: word_start, word_end
      character(max_word_length) :: buffer

      if (iword > this%num_words) then
         call MW_errors_parameter_error("get_word_as_real", "configuration.f90", &
               "iword", iword)
      end if

      word_start = (iword-1)*max_word_length + 1
      word_end = word_start + max_word_length
      buffer = to_lower(this%words(word_start:word_end))

      if (buffer == "true") then
         word = .true.
      else if (buffer == "false") then
         word = .false.
      else
         write(errmsg,'("Failed to read word ",i3," as logical in configuration line",a257)') &
               iword, new_line('A') // this%line
         call MW_errors_runtime_error("get_word_as_logical", "configuration.f90", &
               errmsg)
      end if

   end subroutine get_word_as_logical

   function to_lower(strIn) result(strOut)
      ! Adapted from http://www.star.le.ac.uk/~cgp/fortran.html (25 May 2012)
      ! Original author: Clive Page

     implicit none

     character(len=*), intent(in) :: strIn
     character(len=len(strIn)) :: strOut
     integer :: i,j

     do i = 1, len(strIn)
        j = iachar(strIn(i:i))
        if (j>= iachar("A") .and. j<=iachar("Z") ) then
           strOut(i:i) = achar(iachar(strIn(i:i))+32)
        else
           strOut(i:i) = strIn(i:i)
        end if
     end do

  end function to_lower
end module MW_configuration_line

module MW_electrode
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   use MW_constants, only: twopi
   implicit none
   private

   ! public types
   public :: MW_electrode_t

   ! public subroutines
   public :: void_type   ! (this)
   public :: define_type ! (this, n, eta, V)
   public :: print_type ! (this, ounit)
   public :: identify
   public :: set_comz
   integer, parameter :: FORCES_NUM_TERMS = 10      !< number of terms stored for forces
                  !< tot, C_sr_gg, C_sr_pg, C_keq0_gg, C_keq0_pg, C_lr, LJ, FT, Steele, DAIM
   ! Electrode datatype
   type MW_electrode_t
      integer                      :: count = 0    !< number of atoms in this type
      integer                      :: offset = 0   !< offset in atoms data array
      character(PARTICLE_NAME_LEN) :: name = ""    !< Name of this electrode
      real(wp)                     :: eta = 0.0_wp !< charge gaussian width
      real(wp)                     :: charge = 0.0_wp !< charge gaussian runtime value
      real(wp)                     :: V = 0.0_wp   !< potential applied to this electrode
      logical                      :: piston = .false. !< 1 if npt-piston simulation
      real(wp)                     :: piston_pressure = 0.0_wp !< pressure if npt-piston
      real(wp), allocatable        :: force_ions(:,:) !< total force in z direction from ions
      real(wp)                     :: velocity = 0.0_wp !< velocity in z
      real(wp)                     :: mass = 0.0_wp
      real(wp)                     :: comz = 0.0_wp
      real(wp)                     :: comz0 = 0.0_wp
      real(wp)                     :: ltf = 0.0_wp !< Thomas-Fermi length
      real(wp)                     :: voronoi_volume = 0.0_wp !< Voronoi_volume of the electrode atoms
      logical                      :: dump_lammps = .true.    !< does the electrode type need the lammps data to be dumped?
      logical                      :: dump_xyz = .true.       !< does the electrode type need the xyz data to be dumped?
      logical                      :: dump_trajectories = .true. !< does ion need the trajectories data to be dumped?
      logical                      :: dump_pdb = .true.       !< does ion need the pdb data to be dumped?
   end type MW_electrode_t

contains

   !================================================================================
   !> Define an electrode
   !
   subroutine define_type(this, name, n, eta, charge, V, piston, pressure, mass, ltf, voronoi, &
                  dump_lammps, dump_xyz, dump_trajectories, dump_pdb)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_electrode_t), intent(inout) :: this
      character(*), intent(in) :: name !< electrode name
      integer, intent(in) :: n !< number of atoms in this electrode
      real(wp), intent(in) :: eta  !< charge gaussian width
      real(wp), intent(in) :: charge  !< charge gaussian
      real(wp), intent(in) :: V !< potential applied to this electrode
      logical, intent(in) :: piston !< 1 if npt-piston simulation
      real(wp), intent(in) :: pressure !< pressure applied to this electrode
      real(wp), intent(in) :: mass !< total mass of this electrode
      real(wp), intent(in) :: ltf
      real(wp), intent(inout) :: voronoi
      logical,  intent(in), optional :: dump_lammps  ! if the lammps data needs to be dumped
      logical,  intent(in), optional :: dump_xyz     ! if the xyz data needs to be dumped
      logical,  intent(in), optional :: dump_trajectories  ! if the trajectories data needs to be dumped
      logical,  intent(in), optional :: dump_pdb     ! if the pdb data needs to be dumped

      integer :: ierr

      this%count = n
      this%offset = 0
      this%name = name
      this%eta = eta
      this%charge = charge
      this%V = V
      this%piston = piston
      this%piston_pressure = pressure
      allocate(this%force_ions(3, FORCES_NUM_TERMS), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("allocate_data_arrays", "electrode.f90", ierr)
      end if
      this%force_ions(:,:) = 0.0_wp
      this%mass = mass
      this%velocity = 0.0_wp
      this%comz = 0.0_wp
      this%comz0 = 0.0_wp
      this%ltf = ltf
      if (voronoi == 0.0_wp) then
         voronoi = (twopi/eta)**(3./2.)
      endif
      this%voronoi_volume = voronoi

      if (present(dump_lammps)) then
         this%dump_lammps = dump_lammps
      else
         this%dump_lammps = .true.
      end if

      if (present(dump_xyz)) then
         this%dump_xyz = dump_xyz
      else
         this%dump_xyz = .true.
      end if

      if (present(dump_trajectories)) then
         this%dump_trajectories = dump_trajectories
      else
         this%dump_trajectories = .true.
      end if

      if (present(dump_pdb)) then
         this%dump_pdb = dump_pdb
      else
         this%dump_pdb = .true.
      end if


   end subroutine define_type

   !================================================================================
   !> Print an electrode data structure
   subroutine set_comz(this, comz)
      implicit none
      type(MW_electrode_t), intent(inout) :: this
      real(wp), intent(in) :: comz 

      this%comz0 = comz
      this%comz = comz

   end subroutine set_comz

   !================================================================================
   !> Void an electrode data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_electrode_t), intent(inout) :: this
      integer :: ierr

      this%count = 0
      this%offset = 0
      this%name = ""
      this%eta = 0.0_wp
      this%charge = 0.0_wp
      this%V = 0.0_wp
      this%piston = .false.
      this%piston_pressure = 0.0_wp
      if (allocated(this%force_ions)) then
         deallocate(this%force_ions, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("deallocate_data_arrays", "electrode.f90", ierr)
         end if
      end if
      this%mass = 0.0_wp
      this%velocity = 0.0_wp
      this%ltf = 0.0_wp
      this%voronoi_volume = 0.0_wp
      this%dump_lammps = .true.
      this%dump_xyz = .true.
      this%dump_trajectories = .true.
      this%dump_pdb = .true.

   end subroutine void_type

   !================================================================================
   !> Print an electrode data structure
   subroutine print_type(this, ounit)
      implicit none
      type(MW_electrode_t), intent(in) :: this
      integer,              intent(in) :: ounit

      write(ounit, '("|electrode| ",a8,": ",i6," atoms at potential V = ",es12.5," eta = ",es12.5)') &
            this%name, this%count, this%V, this%eta
      if (this%piston) then
         write(ounit, '("|electrode| ",a8,": npt-piston at pressure ",es12.5," mass = ",es12.5)') &
            this%name, this%piston_pressure, this%mass
      end if
   end subroutine print_type

   !================================================================================
   ! Search for an electrode in a list and return the index in the list
   !
   ! The first matching index is returned.
   ! 0 is returned if no match found
   subroutine identify(electrode_name, electrodes, electrode_index)

      character(*),                 intent(in)  :: electrode_name  ! name of electrode to search
      type(MW_electrode_t), dimension(:), intent(in)  :: electrodes      ! list of electrodes
      integer,                      intent(out) :: electrode_index ! index of electrode in the list

      integer :: i

      electrode_index = 0
      do i = 1, size(electrodes,1)
         if (electrode_name == electrodes(i)%name) then
            electrode_index = i
            exit
         end if
      end do
   end subroutine identify

end module MW_electrode

module MW_errors
#ifndef MW_SERIAL
   use mpi
#endif   
   use MW_stdio, only: MW_stdout, MW_stderr

   implicit none
   private

   public :: finalize
   public :: allocate_error
   public :: deallocate_error
   public :: parameter_error
   public :: runtime_error
   public :: runtime_warning
   public :: temperature_warning
   public :: open_error
   public :: close_error
   public :: mpilib_error

   interface parameter_error
      module procedure parameter_error_int
      module procedure parameter_error_char
      module procedure parameter_error_real
      module procedure parameter_error_real1d
      module procedure parameter_error_dp
      module procedure parameter_error_dp1d
      module procedure parameter_error_log
   end interface parameter_error

contains

   !================================================================================
   ! Finalize the program
   !
   subroutine finalize(ierr)
      implicit none
      integer, intent(in) :: ierr
#ifndef MW_SERIAL
      integer :: mpierr
      call MPI_Abort(MPI_COMM_WORLD,ierr,mpierr)
#else
      if (ierr == 0) then
         stop 0
      else
         stop 1
      end if
#endif
   end subroutine finalize

   !================================================================================
   ! Handle allocation errors
   !
   subroutine allocate_error(subroutine_name, file_name, ierr)
      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      integer,          intent(in) :: ierr            ! allocate returned status

      write(MW_stderr, '("[error]...Allocation failed with return status ", i5)') ierr
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine allocate_error

   !================================================================================
   ! Handle deallocation errors
   !
   subroutine deallocate_error(subroutine_name, file_name, ierr)
      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      integer,          intent(in) :: ierr            ! deallocate returned status

      write(MW_stderr, '("[error]...Deallocation failed with return status ", i3)') ierr
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine deallocate_error

   !================================================================================
   ! Handle invalid integer parameter errors
   !
   subroutine parameter_error_int(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      integer,          intent(in) :: parameter_value ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",i6)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_int

   !================================================================================
   ! Handle invalid logical parameter errors
   !
   subroutine parameter_error_log(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      logical,          intent(in) :: parameter_value ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",i6)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_log

   !================================================================================
   ! Handle invalid character parameter errors
   !
   subroutine parameter_error_char(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      character(len=*), intent(in) :: parameter_value ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",a)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_char

   !================================================================================
   ! Handle invalid real parameter errors
   !
   subroutine parameter_error_real(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      real,             intent(in) :: parameter_value ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",es12.5)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_real

   !================================================================================
   ! Handle invalid real 1d array parameter errors
   !
   subroutine parameter_error_real1d(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      real,             intent(in) :: parameter_value(:) ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",1000es12.5)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_real1d

   !================================================================================
   ! Handle invalid real parameter errors
   !
   subroutine parameter_error_dp(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      double precision, intent(in) :: parameter_value ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",es12.5)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_dp

   !================================================================================
   ! Handle invalid real 1d array parameter errors
   !
   subroutine parameter_error_dp1d(subroutine_name, file_name, &
         parameter_name, parameter_value)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: parameter_name  ! name of the invalid parameter
      double precision, intent(in) :: parameter_value(:) ! value of the invalid parameter

      write(MW_stderr, '("[error]...Invalid parameter ",a," with value ",1000es12.5)') &
            parameter_name, parameter_value
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine parameter_error_dp1d


   !================================================================================
   ! Runtime error
   !
   subroutine runtime_error(subroutine_name, file_name, errmsg)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: errmsg          ! simple error message
      print*, "MW_STDERR = ", MW_stderr,MW_stdout 

      write(MW_stderr, '("[error]...",a)') errmsg
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine runtime_error

   !================================================================================
   ! Runtime warning
   !
   subroutine runtime_warning(subroutine_name, file_name, errmsg)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: errmsg          ! simple error message
      print*, "MW_WARNING = ", MW_stderr,MW_stdout 

      write(MW_stderr, '("[warning]...",a)') errmsg
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

   end subroutine runtime_warning

   !================================================================================
   ! Temperature warning
   !
   subroutine temperature_warning(errmsg)

      implicit none

      character(len=*), intent(in) :: errmsg          ! simple error message
      print*, "MW_WARNING = ", MW_stderr,MW_stdout 

      write(MW_stderr, '("[warning]...",a)') errmsg

   end subroutine temperature_warning

   

   !================================================================================
   ! I/O open error
   !
   subroutine open_error(subroutine_name, file_name, path, ierr)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: path            ! path to file failed to open
      integer,          intent(in) :: ierr

      write(MW_stderr, '("[error]...Failed to open file ",a," with return status ",i3)') trim(path), ierr
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine open_error


   !================================================================================
   ! I/O close error
   subroutine close_error(subroutine_name, file_name, funit, ierr)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      integer,          intent(in) :: funit           ! file unit being close
      integer,          intent(in) :: ierr

      write(MW_stderr, '("[error]...Failed to close file unit",i3," with return status ",i3)') funit, ierr
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine close_error

   !================================================================================
   ! Handle mpi call errors
   !
   subroutine mpilib_error(subroutine_name, file_name, &
         mpi_subroutine, ierr)

      implicit none

      character(len=*), intent(in) :: subroutine_name ! name of the calling subroutine
      character(len=*), intent(in) :: file_name       ! file name of the calling subroutine
      character(len=*), intent(in) :: mpi_subroutine  ! name of the mpi subroutine
      integer,          intent(in) :: ierr            ! value returned by the mpi subroutine

      write(MW_stderr, '("[error]...MPI call to ",a," failed with return value ",a)') &
            mpi_subroutine, ierr
      write(MW_stderr, '("          subroutine: ",a)') trim(subroutine_name)
      write(MW_stderr, '("          file: ",a)') trim(file_name)

      call finalize(1)
   end subroutine mpilib_error

end module MW_errors

! Module to compute electrostatic Coulomb potential
module MW_coulomb_keq0
      use MW_kinds, only: wp
      use MW_ewald, only: MW_ewald_t
      use MW_box, only: MW_box_t
      use MW_constants, only: pi
      use MW_electrode, only: MW_electrode_t
      use MW_ion, only: MW_ion_t
      use MW_localwork, only: MW_localwork_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: diag_gradQelec_potential !grad_Q [grad_Q [U^k=0_QQ]]
   public :: gradQelec_potential !grad_Q [grad_Q [U^k=0_QQ]]
   public :: qmelt2Qelec_potential !grad_Q [U^k=0_qQ]
   public :: Qelec2Qelec_potential !grad_Q [U^k=0_QQ]
   public :: melt_forces !-grad_r [(U^k=0_qq) + (U^k=0_QQ) + (U^k=0_qQ)]
   public :: energy !(U^k=0_qq) + (U^k=0_QQ) + (U^k=0_qQ)

contains

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine diag_gradQelec_potential(localwork, ewald, box, &
         electrodes, diag_gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork  !< Localwork work distribution
      type(MW_ewald_t),    intent(in) :: ewald     !< Ewald summation parameters
      type(MW_box_t),      intent(in) :: box       !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: diag_gradQ_V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i
      real(wp) :: volfactor
      real(wp) :: pot_ii
      real(wp) :: sqrpialpha
      integer :: itype, iatom

      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      sqrpialpha = sqrt(pi) / ewald%alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Pair interactions are considered by block of pair_block_size x pair_block_size
      ! Diagonal block have a special treatment
      volfactor = 2.0_wp/box%area(3)
      pot_ii = volfactor*sqrpialpha

      do itype = 1, num_elec_types
         !$acc loop vector
         do i = 1, localwork%count_atoms(itype)
            iatom = localwork%offset_atoms(itype) + i
            diag_gradQ_V(iatom) = diag_gradQ_V(iatom) - pot_ii
         end do
         !$acc end loop
      end do
   end subroutine diag_gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine gradQelec_potential(localwork, ewald, box, &
         electrodes, xyz_atoms, gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork  !< Localwork work distribution
      type(MW_ewald_t),    intent(in) :: ewald     !< Ewald summation parameters
      type(MW_box_t),      intent(in) :: box       !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: gradQ_V(:,:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i, j
      real(wp) :: volfactor
      real(wp) :: zij, pot_ij, zijsq
      real(wp) :: alpha, alphasq, alphaconst, sqrpialpha, alphapi
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend, itype, jtype
      integer :: count_n, offset_n, count_m, offset_m

      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)
      sqrpialpha = sqrt(pi) / alpha
      alphapi = 2.0_wp * alpha / sqrt(pi)

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Pair interactions are considered by block of pair_block_size x pair_block_size
      ! Diagonal block have a special treatment
      volfactor = 2.0_wp/box%area(3)

#ifdef _OPENACC
      ! On GPU it is faster to loop on the whole interaction matrix than only on the half
      ! because coelescent memory access are faster

      !$acc data present(xyz_atoms(:,3), gradQ_V(:,:))
      ! Blocks on the diagonal compute only half of the pair interactions
      istart = 1
      iend = size(gradQ_V,1)
      jstart = 1
      jend = size(gradQ_V,2)
      !$acc parallel loop private(zij, zijsq, pot_ij)
      do i = istart, iend
         !$acc loop 
         do j = jstart, jend
            zij = xyz_atoms(j,3) - xyz_atoms(i,3)
            zijsq = zij*zij
            pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
            !$acc atomic update
            gradQ_V(j,i) = gradQ_V(j,i) - pot_ij
         end do
         !$acc end loop
      end do
      !$acc end parallel loop
      !$acc end data
#else
      ! Blocks on the diagonal compute only half of the pair interactions
      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, itype-1
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,jtype)
            iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               do i = istart, iend
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     gradQ_V(j,i) = gradQ_V(j,i) - pot_ij
                  end do
               end do
            end do
         end do

         num_block_diag = localwork%pair_atom2atom_num_block_diag_local(itype)
         iblock_offset = localwork%pair_atom2atom_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, offset_n, count_n, istart, iend)
            do i = istart, iend
               do j = istart, iend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  gradQ_V(j,i) = gradQ_V(j,i) - pot_ij
               end do
            end do
         end do

         ! Number of blocks with full interactions (below the diagonal
         num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                  istart, iend, jstart, jend)
            do i = istart, iend
               do j = jstart, jend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  gradQ_V(j,i) = gradQ_V(j,i) - pot_ij
               end do
            end do
         end do
      end do
#endif
   end subroutine gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   !DEC$ ATTRIBUTES NOINLINE :: melt2elec_potential
   subroutine qmelt2Qelec_potential(localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_ewald_t), intent(in)    :: ewald    !< Ewald summation parameters
      type(MW_box_t),   intent(in)    :: box      !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      real(wp),                 intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j, itype, jtype
      real(wp) :: qj !< ion charge
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, pot_ij
      real(wp) :: alpha, alphasq, sqrpialpha
      integer :: num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m
      real(wp) :: vi

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha * alpha
      sqrpialpha = sqrt(pi) / alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), V(:))
      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, num_ion_types
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_ion2atom_num_block_full_local(itype,jtype)
            iblock_offset = localwork%pair_ion2atom_full_iblock_offset(itype,jtype)
            qj = ions(jtype)%charge
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               !$acc parallel loop private(zij, zijsq, pot_ij, vi)
               do i = istart, iend
                  vi = 0.0_wp
                  !$acc loop reduction(+:vi)
                  do j = jstart, jend
                     zij = xyz_ions(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     vi = vi + volfactor * qj * pot_ij
                  end do
                  !$acc end loop
                  V(i) = V(i) - vi
               end do
               !$acc end parallel loop
            end do
         end do
      end do
      !$acc end data
   end subroutine qmelt2Qelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   !DEC$ ATTRIBUTES NOINLINE :: elec2elec_potential
   subroutine Qelec2Qelec_potential(localwork, ewald, box, &
         electrodes, xyz_atoms, q_elec, V)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork  !< Localwork work distribution
      type(MW_ewald_t),    intent(in) :: ewald     !< Ewald summation parameters
      type(MW_box_t),      intent(in) :: box       !< Simulation box parameters

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: i, j
      real(wp) :: volfactor, vi_sum
      real(wp) :: zij, pot_ij, zijsq
      real(wp) :: alpha, alphasq, alphaconst, sqrpialpha, alphapi
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend, itype, jtype
      integer :: count_n, offset_n, count_m, offset_m
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha * alpha
      alphaconst = -1.0_wp / (4.0_wp*alphasq)
      sqrpialpha = sqrt(pi) / alpha
      alphapi = 2.0_wp * alpha / sqrt(pi)

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Pair interactions are considered by block of pair_block_size x pair_block_size
      ! Diagonal block have a special treatment
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_atoms(:,3), q_elec(:), V(:))

      ! Blocks on the diagonal compute only half of the pair interactions
      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, itype-1
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,jtype)
            iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               !$acc parallel loop  private(zij, zijsq, pot_ij, vi_sum)
               do i = istart, iend
                  vi_sum = 0.0_wp
                  !$acc loop reduction(+:vi_sum)
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     !$acc atomic update
                     V(j) = V(j) - q_elec(i) * pot_ij
                     vi_sum = vi_sum + q_elec(j) * pot_ij
                  end do
                  !$acc end loop
                  V(i) = V(i) - vi_sum
               end do
               !$acc end parallel loop
            end do
         end do

         num_block_diag = localwork%pair_atom2atom_num_block_diag_local(itype)
         iblock_offset = localwork%pair_atom2atom_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, offset_n, count_n, istart, iend)
            !$acc parallel loop  private(zij, zijsq, pot_ij, vi_sum)
            do i = istart, iend
               vi_sum = 0.0_wp
               !$acc loop reduction(+:vi_sum)
               do j = istart, iend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vi_sum = vi_sum +  q_elec(j) * pot_ij
               end do
               !$acc end loop
               V(i) = V(i) - vi_sum
            end do
            !$acc end loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                  istart, iend, jstart, jend)
            !$acc parallel loop  private(zij, zijsq, pot_ij, vi_sum)
            do i = istart, iend
               vi_sum = 0.0_wp
               !$acc loop reduction(+:vi_sum)
               do j = jstart, jend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = volfactor * (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  !$acc atomic update
                  V(j) = V(j) - q_elec(i) * pot_ij
                  vi_sum = vi_sum +  q_elec(j) * pot_ij
               end do
               !$acc end loop
               V(i) = V(i) - vi_sum
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data
   end subroutine Qelec2Qelec_potential

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   !DEC$ ATTRIBUTES NOINLINE :: melt_forces
   subroutine melt_forces(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, force, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(inout) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge
      logical,              intent(in) :: compute_force !< compute forces on electrodes

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j, itype, jtype
      real(wp) :: qi, qj !< ion charge
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, erf_ij
      real(wp) :: fij, fiz, force_melt2ele, force_ele2ele
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphapi = 2.0_wp * alpha / sqrt(pi)
      sqrpialpha = sqrt(pi) / alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), force(:,3), q_elec(:), &
      !$acc              electrodes, electrodes%force_ions)      

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            qi = ions(itype)%charge
            qj = ions(jtype)%charge
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               !$acc parallel loop  private(zij, zijsq, erf_ij, fij, fiz)
               do i = istart, iend
                  fiz = 0.0_wp
                  !$acc loop reduction(+:fiz)
                  do j = jstart, jend
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     fij = qi * qj * pi * volfactor * erf_ij
                     fiz = fiz + fij
                     !$acc atomic update
                     force(j,3) = force(j,3) + fij
                  end do
                  !$acc end loop
                  force(i,3) = force(i,3) - fiz
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
                  offset_n, count_n, istart, iend)
            !$acc parallel loop private(fiz, zij, zijsq, erf_ij, fij, fiz)
            do i = istart, iend
               fiz = 0.0_wp
               !$acc loop reduction(+:fiz)
               do j = istart, iend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(alpha*zij)
                  fij = qi * qj * pi * volfactor * erf_ij
                  fiz = fiz + fij
               end do
               !$acc end loop
               force(i,3) = force(i,3) - fiz
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                  istart, iend, jstart, jend)

            !$acc parallel loop private(fiz, zij, zijsq, erf_ij, fij, fiz)
            do i = istart, iend
               fiz = 0.0_wp
               !$acc loop reduction(+:fiz)
               do j = jstart, jend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(alpha*zij)
                  fij = qi * qj * pi * volfactor * erf_ij
                  !$acc atomic update
                  force(j,3) = force(j,3) + fij
                  fiz = fiz + fij
               end do
               !$acc end loop
               force(i,3) = force(i,3) - fiz
            end do
            !$acc end parallel loop
         end do

         qi = ions(itype)%charge
         do jtype = 1, num_elec_types
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset
            ! Number of blocks with full atom2ion interactions
            num_block_full = localwork%pair_atom2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_atom2ion_full_iblock_offset(itype, jtype)
            force_melt2ele = 0.0_wp
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               !$acc parallel loop private(zij, zijsq, erf_ij, fij, fiz)
               do i = istart, iend
                  fiz = 0.0_wp
                  !$acc loop reduction(+:fiz)
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     fij = qi * q_elec(j) * pi * volfactor * erf_ij
                     fiz = fiz + fij
                  end do
                  !$acc end loop
                  force(i,3) = force(i,3) - fiz
                  force_melt2ele = force_melt2ele + fiz
               end do
               !$acc end parallel loop
            end do
            electrodes(jtype)%force_ions(3,5) = electrodes(jtype)%force_ions(3,5) + force_melt2ele
         end do
      end do

      ! Elec 2 Elec interactions
      ! ------------------------
      if (compute_force) then
         ! Blocks on the diagonal compute only half of the pair interactions
         do itype = 1, num_elec_types
            count_n = electrodes(itype)%count
            offset_n = electrodes(itype)%offset
            do jtype = 1, itype-1
               count_m =  electrodes(jtype)%count
               offset_m = electrodes(jtype)%offset

               ! Number of blocks with full interactions (below the diagonal
               num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,jtype)
               iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,jtype)

               do iblock = 1, num_block_full
                  call update_other_block_boundaries(iblock_offset+iblock, &
                        offset_n, count_n, offset_m, count_m, istart, iend, jstart, jend)
                  !$acc parallel loop private(zij, zijsq, erf_ij, fij, force_ele2ele)
                  do i = istart, iend
                     force_ele2ele = 0.0_wp
                     !$acc loop reduction(+:force_ele2ele)
                     do j = jstart, jend
                        zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                        zijsq = zij*zij
                        erf_ij = erf(alpha*zij)
                        fij = q_elec(i) * q_elec(j) * pi * volfactor * erf_ij
                        !$acc atomic update
                        electrodes(jtype)%force_ions(3,4) = electrodes(jtype)%force_ions(3,4) + fij
                        force_ele2ele = force_ele2ele + fij
                     end do
                     !$acc end loop
                     electrodes(itype)%force_ions(3,4) = electrodes(itype)%force_ions(3,4) - force_ele2ele
                  end do
                  !$acc end parallel loop
               end do
            end do

            num_block_diag = localwork%pair_atom2atom_num_block_diag_local(itype)
            iblock_offset = localwork%pair_atom2atom_diag_iblock_offset(itype)

            do iblock = 1, num_block_diag
               call update_diag_block_boundaries(iblock+iblock_offset, &
                     offset_n, count_n, istart, iend)
               !$acc parallel loop private(fiz, zij, zijsq, erf_ij, fij, force_ele2ele)
               do i = istart, iend
                  force_ele2ele = 0.0_wp
                  !$acc loop reduction(+:force_ele2ele)
                  do j = istart, iend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     fij = q_elec(i) * q_elec(j) * pi * volfactor * erf_ij
                     force_ele2ele = force_ele2ele + fij
                  end do
                  !$acc end loop
                  electrodes(itype)%force_ions(3,4) = electrodes(itype)%force_ions(3,4) - force_ele2ele
               end do
               !$acc end parallel loop
            end do

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,itype)
            iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,itype)

            do iblock = 1, num_block_full
               call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                     istart, iend, jstart, jend)
               !$acc parallel loop private(fiz, zij, zijsq, erf_ij, fij, force_ele2ele)
               do i = istart, iend
                  force_ele2ele = 0.0_wp
                  !$acc loop reduction(+:force_ele2ele)
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     fij = q_elec(i) * q_elec(j) * pi * volfactor * erf_ij
                     !$acc atomic update
                     electrodes(itype)%force_ions(3,4) = electrodes(itype)%force_ions(3,4) + fij
                     force_ele2ele = force_ele2ele + fij
                  end do
                  !$acc end loop
                  electrodes(itype)%force_ions(3,4) = electrodes(itype)%force_ions(3,4) - force_ele2ele
               end do
               !$acc end parallel loop
            end do
         end do
      end if

      !$acc end data
   end subroutine melt_forces

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   !DEC$ ATTRIBUTES NOINLINE :: energy
   subroutine energy(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h !< Energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j, itype, jtype
      real(wp) :: qi, qj !< ion charge
      real(wp) :: volfactor
      real(wp) :: zij, zijsq
      real(wp) :: pot_ij, vsumzk0
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      alphapi = 2.0_wp * alpha / sqrt(pi)
      sqrpialpha = sqrt(pi) / alpha

      ! Zero energy
      ! ----------------
      h = 0.0_wp
      vsumzk0 = 0.0_wp

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), q_elec(:)) copy(vsumzk0)

      ! Melt -> Melt and Elec -> Melt interactions
      ! ------------------------------------------
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset

            qi = ions(itype)%charge
            qj = ions(jtype)%charge
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock+iblock_offset, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)

               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     vsumzk0 = vsumzk0 + qi * qj * pot_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = istart, iend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + 0.5_wp * qi * qj * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)

         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                  istart, iend, jstart, jend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = jstart, jend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + qi * qj * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do

         qi = ions(itype)%charge
         do jtype = 1, num_elec_types
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_atom2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_atom2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock+iblock_offset, &
                     offset_n, count_n, offset_m, count_m, &
                     istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     vsumzk0 = vsumzk0 + qi * q_elec(j) * pot_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do
      end do

      ! Elec 2 Elec interactions
      ! ------------------------
      ! Blocks on the diagonal compute only half of the pair interactions
      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, itype-1
            count_m =  electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,jtype)
            iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
                     offset_n, count_n, offset_m, count_m, istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     vsumzk0 = vsumzk0 + q_elec(i) * q_elec(j) * pot_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do

         num_block_diag = localwork%pair_atom2atom_num_block_diag_local(itype)
         iblock_offset = localwork%pair_atom2atom_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock+iblock_offset, &
                  offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = istart, iend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + 0.5_wp * q_elec(i) * q_elec(j) * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,itype)

         do iblock = 1, num_block_full

            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
                  istart, iend, jstart, jend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = jstart, jend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + q_elec(i) * q_elec(j) * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data

      ! scale by volume factor
      h = -vsumzk0 * volfactor

   end subroutine energy

   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_coulomb_keq0

! Module defines matrix inversion type to store matrix inversion algorithm parameters
module MW_matrix_inversion
   use MW_timers
   use MW_kinds, only: wp, sp
   use MW_system, only: MW_system_t

   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_matrix_inversion_t

   ! Public subroutines
   ! ------------------
   public :: set_tolerance
   public :: set_charge_neutrality
   public :: set_write_matrix
   public :: reset_statistics
   public :: allocate_arrays
   public :: void_type
   public :: print_type
   public :: print_statistics
   public :: solve

   type MW_matrix_inversion_t

      !Convergence parameters
      real(wp) :: tol           !< tolerance on residual norm

      !Logicals
      logical :: charge_neutrality = .false.
      logical :: constant_matrix = .false.
      logical :: firsttime = .true.
      logical :: write_hessian_matrix = .false.
      logical :: calc_elec = .false.
      logical :: calc_dip = .false.

      !Statistics
      real(wp) :: res_norm         !< residual norm after procedure

      !Work arrays
      integer :: n                  !< dimensions of the work arrays
      real(wp), allocatable :: b(:)    !< Constant vector b
      real(wp), allocatable :: A(:,:)           !< Hessian
      real(wp), allocatable :: Ainv(:,:)          !< Inverse of the Hessian
      real(wp), allocatable :: Ax(:)   !< vector to check the exactness of the solution
      real(wp), allocatable :: q0(:)    !< Constant vector q0

   end type MW_matrix_inversion_t

contains

   ! ================================================================================
   ! Set tolerance parameter
   subroutine set_tolerance(this, tol)
      implicit none
      type(MW_matrix_inversion_t), intent(inout) :: this
      real(wp), intent(in) :: tol
      this%tol = tol
   end subroutine set_tolerance

   ! ================================================================================
   ! Set force neutral
   subroutine set_charge_neutrality(this, charge_neutrality)
      implicit none
      type(MW_matrix_inversion_t), intent(inout) :: this
      logical, intent(in) :: charge_neutrality
      this%charge_neutrality = charge_neutrality
   end subroutine set_charge_neutrality

   ! ================================================================================
   ! Set write_matrix
   subroutine set_write_matrix(this, write_matrix)
      implicit none
      type(MW_matrix_inversion_t), intent(inout) :: this
      logical, intent(in) :: write_matrix
      this%write_hessian_matrix = write_matrix
   end subroutine set_write_matrix

   ! ================================================================================
   ! reset statistic counters
   subroutine reset_statistics(this)
      implicit none
      type(MW_matrix_inversion_t), intent(inout) :: this
   end subroutine reset_statistics

   !================================================================================
   ! Allocate data arrays
   subroutine allocate_arrays(this, n)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_matrix_inversion_t), intent(inout) :: this

      ! Parameters Input
      ! -------------
      integer, intent(in) :: n !< size of the data arrays

      ! Local
      ! -----
      integer :: i, j
      integer :: ierr

      this%n = n
      allocate(this%b(n), this%q0(n), this%A(n,n), this%Ainv(n,n), this%Ax(n), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("allocate_arrays", "matrix_inversion.F90", ierr)
      end if

      do i = 1, this%n
         this%b(i) = 0.0_wp
         this%q0(i) = 0.0_wp
         do j = 1, this%n
            this%A(j,i) = 0.0_wp
            this%Ainv(j,i) = 0.0_wp
         end do
         this%Ax(i) = 0.0_wp
      end do

   end subroutine allocate_arrays

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_matrix_inversion_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      this%tol = 0.0_wp
      this%res_norm = 0.0_wp
      this%n = 0

      if (allocated(this%b)) then
         deallocate(this%b, this%q0, this%A, this%Ainv, this%Ax, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "matrix_inversion.F90", ierr)
         end if
      end if
   end subroutine void_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_type(this, ounit)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_matrix_inversion_t), intent(in) :: this
      integer,            intent(in) :: ounit

      write(ounit, '("|matrix_inversion| Tolerance:               ",es12.5)') this%tol
      if (this%charge_neutrality) then
         write(ounit, '("|matrix_inversion| Force charge neutrality:      ",a3)') "yes"
      else
         write(ounit, '("|matrix_inversion| Force charge neutrality:      ",a3)') " no"
      end if
   end subroutine print_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_statistics(this, ounit)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_matrix_inversion_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|matrix_inversion| Norm of the residual after procedure:        ",es12.5)') this%res_norm
   end subroutine print_statistics

   subroutine get_hessian_inverse(this, system, compute_hessian)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
         MW_errors_close_error => close_error, &
         MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t),  intent(inout) :: system

      integer  :: xyz_now
      integer  :: n
      character(64) :: fname
      logical  :: matrix_data_present

      interface
         subroutine compute_hessian(system, hessian)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: hessian(:,:)
         end subroutine compute_hessian
      end interface

      n = this%n
      xyz_now = system%xyz_ions_step(1)

      fname = "hessian_matrix.inpt"
      INQUIRE(FILE=fname, EXIST=matrix_data_present)
      if(.not. matrix_data_present) then ! The full matrix has to be computed

         call compute_hessian(system, this%A)

         !Inverting matrix (The matrix is symmetric)
         if (.not.(system%elecrun.and.system%pimrun)) then
            call MW_timers_start(TIMER_MINQ_INVMAT)
            call invert_matrix(this%n, this%Ainv, this%A)
            call MW_timers_stop(TIMER_MINQ_INVMAT)
         end if

         if (this%constant_matrix) call write_hessian_matrix(this, system, fname)

         if (system%elecrun.and.system%pimrun) then
            call MW_errors_runtime_error("get_hessian_inverse", "matrix_inversion_f90", &
            "Stopping execution after matrix writing: full matrix inversion method not implemented for dipoles + electrodes")
         end if

      else !then we read the file and fill this%Ainv array

         if (system%elecrun.and.system%pimrun) then
            call MW_errors_runtime_error("get_hessian_inverse", "matrix_inversion_f90", &
            "Stopping execution before matrix reading: full matrix inversion method not implemented for dipoles + electrodes")
         end if

         call read_hessian_matrix(this, system, fname)

      end if

      if (this%write_hessian_matrix) then
         fname = "hessian_matrix.out"
         call write_hessian_matrix_ascii(this, system, fname)
      end if

   end subroutine get_hessian_inverse

   subroutine write_hessian_matrix(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error
      implicit none

      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t),           intent(inout) :: system
      character(64),               intent(in)    :: fname

      integer,                     parameter     :: n_atoms_check = 10

      integer                                    :: funit, ierr

      ! opening file
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
      position="REWIND", form="UNFORMATTED", status="REPLACE", &
      iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", fname, ierr)
      end if

      write(funit) n_atoms_check
      write(funit) system%xyz_atoms(1:n_atoms_check,:)
      write(funit) this%Ainv(:,:)

      ! closing file
      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("MW_matrix_inversion_get_A", "matrix_inversion_f90",&
         funit, ierr)
      end if

   end subroutine write_hessian_matrix

   subroutine read_hessian_matrix(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
            MW_errors_close_error => close_error, &
            MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t),           intent(inout) :: system
      character(64),               intent(in)    :: fname

      integer,                     parameter     :: n_atoms_check = 10
      real(wp),     dimension(n_atoms_check,3)   :: xyz
      real(wp),                    parameter     :: tol = 1e-14

      integer                                    :: j
      integer                                    :: n_atoms_check_read
      integer                                    :: funit, ierr


      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="READ", &
      position="REWIND", form="UNFORMATTED", status="OLD", iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_matrix_inversion_get_A", "matrix_inversion_f90",&
         fname, ierr)
      end if
      read(funit) n_atoms_check_read

      read(funit) xyz
      do j = 1, n_atoms_check

         if (abs(xyz(j,1) - system%xyz_atoms(j,1)) > tol .or. &
               abs(xyz(j,2) - system%xyz_atoms(j,2)) > tol .or. &
               abs(xyz(j,3) - system%xyz_atoms(j,3)) > tol ) then
            call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
                  "Electrode atoms not at the same positions as the ones used to compute the"// &
                  "inverted matrix that should be loaded => not consistent.")
         end if
      end do
      read(funit) this%Ainv
      close(funit, iostat=ierr)

      if (ierr /= 0) then
         call MW_errors_close_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         funit, ierr)
      end if
   end subroutine read_hessian_matrix

   subroutine write_hessian_matrix_ascii(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
            MW_errors_close_error => close_error
      implicit none

      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t),           intent(inout) :: system
      character(64),               intent(in)    :: fname

      integer,                     parameter     :: n_atoms_check = 10

      integer                                    :: j
      integer                                    :: n
      integer                                    :: funit, ierr
      character(64)                              :: matrix_fmt

      n = this%n

      ! opening file
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
      position="REWIND", form="FORMATTED", status="REPLACE", &
      iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", fname, ierr)
      end if

      ! Defining the format string based on the number of constraints
      write (matrix_fmt, '("(", I6, "(es23.15E3,:,1x))")' ) n
      ! writing file
      write(funit, '("# Inverted Matrix for electrode charges used with matrix_inversion_algorithm")')
      write(funit, '("# electrode_position_check")')
      write(funit, '("n_atoms_check",(I3))') n_atoms_check
      do j = 1, n_atoms_check
         write(funit,'(3(es22.15, 1x))') system%xyz_atoms(j,1), system%xyz_atoms(j,2), system%xyz_atoms(j,3)
      end do
      write(funit, '("# matrix")')
      write(funit, '("n ",(I6))') n
      do j = 1, n
         write(funit, matrix_fmt)  this%A(:,j)
      end do
      if (.not.(system%elecrun.and.system%pimrun)) then
         do j = 1, n
            write(funit, matrix_fmt)  this%Ainv(:,j)
         end do
      end if

      ! closing file
      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("MW_matrix_inversion_get_A", "matrix_inversion_f90",&
         funit, ierr)
      end if

   end subroutine write_hessian_matrix_ascii

   subroutine read_hessian_matrix_ascii(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
            MW_errors_close_error => close_error, &
            MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t),           intent(inout) :: system
      character(64),               intent(in)    :: fname

      integer,                     parameter     :: n_atoms_check = 10
      real(wp),                    parameter     :: tol = 1e-14

      integer                                    :: j
      integer                                    :: n
      integer                                    :: n_atoms_check_read
      integer                                    :: funit, ierr
      character(64)                              :: keyword, matrix_fmt
      character(1)                               :: hash_char
      real(wp)                                   :: x_read, y_read, z_read

      n = this%n

      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="READ", &
      position="REWIND", form="FORMATTED", status="OLD", iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_matrix_inversion_get_A", "matrix_inversion_f90",&
         fname, ierr)
      end if
      read(funit, *) hash_char, keyword
      read(funit, *) hash_char, keyword
      if ((keyword /= "electrode_position_check")) then
         call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         "Expecting # electrode_position_check in matrix_inversion_matrix input file")
      end if
      read(funit, *) keyword, n_atoms_check_read
      if ((keyword /= "n_atoms_check")) then
         call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         "Expecting n_atoms_check in matrix_inversion_matrix input file")
      end if
      do j = 1, n_atoms_check
         read(funit,'(3(es22.15, 1x))') x_read, y_read, z_read

         if (abs(x_read - system%xyz_atoms(j,1)) > tol .or. &
               abs(y_read - system%xyz_atoms(j,2)) > tol .or. &
               abs(z_read - system%xyz_atoms(j,3)) > tol ) then
            call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
                  "Electrode atoms not at the same positions as the ones used to compute the"// &
                  "inverted matrix that should be loaded => not consistent.")
         end if
      end do

      read(funit, *) hash_char, keyword
      if ((keyword /= "matrix")) then
         call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         "Expecting # matrix in matrix_inversion_matrix input file")
      end if
      read(funit, *) keyword, n
      if ((keyword /= "n")) then
         call MW_errors_runtime_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         "Expecting # n in matrix_inversion_matrix input file")
      end if
      ! Defining the format string based on the number of constraints
      write (matrix_fmt, '("(", I6, "(es23.15E3,:,1x))")' ) n
      do j = 1, n
         read(funit, matrix_fmt)  this%A(:,j)
      end do
      do j = 1, n
         read(funit, matrix_fmt)  this%Ainv(:,j)
      end do

      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("MW_matrix_inversion_get_A", "matrix_inversion_f90", &
         funit, ierr)
      end if
   end subroutine read_hessian_matrix_ascii

   ! ================================================================================
   subroutine solve(this, system, compute_hessian, matvec_product, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error, &
                           MW_errors_allocate_error => allocate_error, &
                           MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_matrix_inversion_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine compute_hessian(system, hessian)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: hessian(:,:)
         end subroutine compute_hessian
      end interface

      interface
         subroutine matvec_product(system, mat, vec, matvec_prod)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(in) :: system
            real(wp), intent(in) :: mat(:,:)
            real(wp), intent(in) :: vec(:)
            real(wp), intent(out) :: matvec_prod(:)
         end subroutine matvec_product
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals (common)
      !---------------
      integer :: n, ierr, i, j
      real(wp) :: EAinvE, jAinvE, target_charge
      real(wp), allocatable :: AinvE(:), E(:)

      n = this%n

      if ((.not.this%constant_matrix).or.(this%firsttime)) then

         call get_hessian_inverse(this, system, compute_hessian)
         this%firsttime = .false.

         if (this%charge_neutrality) then
            target_charge = - system%total_ions_charge

            allocate(E(n), AinvE(n), stat=ierr)
            if (ierr /= 0) then
               call MW_errors_allocate_error("solve", "matrix_inversion.F90", ierr)
            end if

            E(:) = 1.0_wp

            ! compute S = Ainv - (Ainv * E * Et * Ainv) / (Et * Ainv * E)
            ! and replace it in Ainv
            call matvec_product(system, this%Ainv(:,:), E(:), AinvE(:))

            EAinvE = sum(AinvE(:))

            do j = 1, n
               jAinvE = AinvE(j)
               do i = 1, n
                  this%Ainv(i, j) = this%Ainv(i, j) - AinvE(i) * jAinvE / EAinvE
                  this%q0(i) = AinvE(i) * target_charge / EAinvE
               end do
            end do

            deallocate(E, AinvE, stat=ierr)
            if (ierr /= 0) then
               call MW_errors_deallocate_error("solve", "matrix_inversion.F90", ierr)
            end if

         end if

      end if

      call matvec_product(system, this%Ainv(:,:), this%b(:), x(:))

      if (system%global_charge_neutrality) then
         do i = 1, n
            x(i) = x(i) + this%q0(i)
         end do
      end if

      !call matvec_product(system, this%A(:,:), x(:), this%Ax(:))

      !Checking the residual on the constraint is less than tolerance
      !discr = maxval(dabs(this%Ax - this%b))
      ! write(*,*) discr

      !if (discr.gt.this%tol) then
      !   call MW_errors_runtime_error("solve", "matrix_inversion.F90", &
      !   "matrix inversion failed to satisfy constraints up the given tolerance")
      !end if

   end subroutine solve

   ! ================================================================================
   include 'matrix_inversion.inc'

end module MW_matrix_inversion

! Steele Potential
! -----------------------
!
module MW_steele
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_timers
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_molecule, only: MW_molecule_t
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_steele_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type
   public :: set_rcut
   public :: set_parameters
   public :: melt_forces
   public :: energy

   ! Data structure to handle Steele potentials
   type MW_steele_t
      integer :: num_walls = 0                       ! number of walls
      integer :: num_species = 0                     ! number of species
      real(wp) :: rcut = 0.0_wp                      ! cut-off parameter
      real(wp) :: rcutsq = 0.0_wp                    ! cut-off parameter squared
      real(wp), dimension(:), allocatable :: delta   ! (num_walls) 
      real(wp), dimension(:,:), allocatable :: A ! (num_walls,num_species)
      real(wp), dimension(:,:), allocatable :: B ! (num_walls,num_species)
    end type MW_steele_t

   integer, parameter :: ION_NAME_LEN = 8

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, num_walls, num_species, rcut)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ---------_
      type(MW_steele_t), intent(inout) :: this      !> structure to be defined
      integer, intent(in) :: num_walls, num_species                    !> number of species
      real(wp), intent(in) :: rcut

      ! Local
      ! -----
      integer :: ierr

      call set_rcut(this, rcut)

      if (num_species <= 0) then
         call MW_errors_parameter_error("define_type", "steele.f90",&
               "num_species", num_species)
      end if

      if (num_walls <= 0) then
         call MW_errors_parameter_error("define_type", "steele.f90",&
               "num_walls", num_walls)
      end if

      this%num_species = num_species
      this%num_walls = num_walls

      allocate(this%delta(num_walls), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "steele.f90", ierr)
      this%delta(:) = 0.0_wp

      allocate(this%A(num_walls,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "steele.f90", ierr)
      this%A(:,:) = 0.0_wp

      allocate(this%B(num_walls,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "steele.f90", ierr)
      this%B(:,:) = 0.0_wp

   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_steele_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%delta)) then
         deallocate(this%delta, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "steele.f90", ierr)
         end if
      end if

      if (allocated(this%A)) then
         deallocate(this%A, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "steele.f90", ierr)
         end if
      end if

      if (allocated(this%B)) then
         deallocate(this%B, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "steele.f90", ierr)
         end if
      end if

      this%num_species = 0
      this%num_walls = 0
      this%rcut = 0.0_wp
      this%rcutsq = 0.0_wp

   end subroutine void_type

   ! ================================================================================
   ! set rcut value
   subroutine set_rcut(this, rcut)
      implicit none
      type(MW_steele_t), intent(inout) :: this
      real(wp), intent(in) :: rcut

      this%rcut = rcut
      this%rcutsq = rcut*rcut

   end subroutine set_rcut

   ! ================================================================================
   ! set rcut value
   subroutine set_parameters(this, wallA, typeB, rho_w, eps_wf, sig_wf, delta_w)
      use MW_constants, only: kJpermol2hartree, angstrom2bohr, pi
      implicit none
      type(MW_steele_t), intent(inout) :: this
      integer, intent(in) :: wallA
      integer, intent(in) :: typeB
      real(wp), intent(in) :: eps_wf ! kJ per mol
      real(wp), intent(in) :: rho_w ! angstrom**-3
      real(wp), intent(in) :: sig_wf ! angstrom
      real(wp), intent(in) :: delta_w ! angstrom

      ! Local
      real(wp) :: A, B, eps, sigma, delta, rho

      ! Convert lj_eps from kJ/mol to atomic unit
      eps = kJpermol2hartree * eps_wf
      ! convert lj_sig from Angstrom to atomic unit
      sigma = angstrom2bohr * sig_wf
      delta = angstrom2bohr * delta_w
      rho = rho_w / angstrom2bohr**3

      ! Convert (eps,sig) to (A,B)
      A = 4.0_wp / 5.0_wp * pi * rho * eps * delta * sigma**12
      B = - 2.0_wp * pi * rho * eps * delta * sigma**6

      this%A(wallA,typeB) = A

      this%B(wallA,typeB) = B

      this%delta(wallA) = delta

   end subroutine set_parameters

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, species_names, ounit)
      use MW_kinds, only: PARTICLE_NAME_LEN
      implicit none
      type(MW_steele_t), intent(in) :: this               ! structure to be printed
      character(PARTICLE_NAME_LEN),   intent(in) :: species_names(:)   ! names of the species
      integer,                   intent(in) :: ounit              ! output unit

      integer :: i, j

      write(ounit, '("|steele| cut-off distance: ",es12.5)') this%rcut
      write(ounit, '("|steele| ",8x,1x,8x,1x,"     A      ",1x,"     B      ")')

      do j = 1, this%num_walls
         do i = 1, this%num_species
            write(ounit, '("|steele| ",a8,1x,es12.5,1x,es12.5,1x,es12.5)') &
                  species_names(i), this%A(i,j), this%B(i,j), this%delta(j)
         end do
      end do

   end subroutine print_type

   ! ==============================================================================
   ! Compute Lennard-Jones forces felt by melt ions
   subroutine melt_forces(num_pbc, localwork, steele, box, ions, xyz_ions, &
                    electrodes, xyz_atoms, force, stress_tensor, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_steele_t), intent(in) :: steele      !< Steele potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      type(MW_electrode_t), intent(inout) :: electrodes(:)        !< electrodes parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),       intent(in) :: xyz_atoms(:,:)  !< ions xyz positions
      logical,              intent(in) :: compute_force !< compute_force on electrodes

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:) !< Steele force on ions
      real(wp), intent(inout) :: stress_tensor(:,:) !< Steele force contribution to the stress tensor

      ! Local
      ! -----
      integer :: ierr, count
      integer :: i, num_elec_types

      select case(num_pbc)
      case(2)
            call melt_forces_2DPBC(localwork, steele, box, ions, xyz_ions, &
                    electrodes, xyz_atoms, force, stress_tensor)
      case(3)
            call melt_forces_3DPBC(localwork, steele, box, ions, xyz_ions, &
                    electrodes, xyz_atoms, force, stress_tensor)
      end select
#ifndef MW_SERIAL
      count = size(force,1)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)      

      if (compute_force) then
         num_elec_types = size(electrodes, 1)
         do i = 1, num_elec_types
            call MPI_Allreduce(MPI_IN_PLACE, electrodes(i)%force_ions(:,9), 3, &
                  MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
         end do
      end if
#endif
   end subroutine melt_forces

   ! ==============================================================================
   ! Compute Lennard-Jones potential felt by melt ions
   subroutine energy(num_pbc, localwork, steele, box, ions, xyz_ions, electrodes, xyz_atoms, h)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_steele_t), intent(in) :: steele      !< Steele potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)        !< electrodes parameters
      real(wp),       intent(in) :: xyz_atoms(:,:)  !< atoms xyz positatoms

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to steele interactions

      ! Local
      ! -----
      integer :: ierr

      select case(num_pbc)
      case(2)
            call energy_2DPBC(localwork, steele, box, ions, xyz_ions, electrodes, xyz_atoms, h)
      case(3)
            call energy_3DPBC(localwork, steele, box, ions, xyz_ions, electrodes, xyz_atoms, h)
      end select

#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   ! ================================================================================
   include 'steele_2DPBC.inc'
   include 'steele_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_steele

module MW_four_site_model
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_kinds, only: wp
   use MW_localwork, only: MW_localwork_t
   use MW_molecule, only: MW_molecule_t
   use MW_ion, only: MW_ion_t
   use MW_box, only: MW_box_t
   use MW_parallel, only: MW_COMM_WORLD
   
   ! Public subroutines
   ! ------------------
   public :: compute_fourth_site_position

contains

   ! ========================================================
   subroutine compute_fourth_site_position(num_pbc, molecules, xyz_ions, box, ions)

      implicit none

      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< ions parameters
      real(wp), intent(inout) :: xyz_ions(:,:)  !< ions xyz positions

      select case(num_pbc)
      case(2)
         call compute_fourth_site_position_2DPBC(molecules, xyz_ions, box, ions)
      case(3)
         call compute_fourth_site_position_3DPBC(molecules, xyz_ions, box, ions)
      end select

   end subroutine

  
   ! ================================================================================

   subroutine redistribute_force(num_pbc, localwork, molecules, xyz_ions, forces_ions, box, ions, &
         stress_tensor)
      use Mw_errors, only: MW_errors_allocate_error => allocate_error
      implicit none

      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< ions parameters
      real(wp), intent(inout) :: xyz_ions(:,:)  !< ions xyz positions
      real(wp), intent(inout) :: forces_ions(:,:)  !< ions forces
      real(wp), intent(inout) :: stress_tensor(:,:)  !< stress tensor

      ! Local
      ! -----
      real(wp), allocatable        :: force_to_distribute(:,:)
      integer :: n, ixyz, iion, count, ierr

      n = size(forces_ions, 1)

      allocate(force_to_distribute(n, 3), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("allocate_data_arrays", "four_site_model.f90", ierr)
      end if
      force_to_distribute(:,:) = 0.0_wp

      select case(num_pbc)
      case(2)
         call redistribute_force_2DPBC(localwork, molecules, xyz_ions, forces_ions, box, ions, force_to_distribute, &
               stress_tensor)
      case(3)
         call redistribute_force_3DPBC(localwork, molecules, xyz_ions, forces_ions, box, ions, force_to_distribute, &
               stress_tensor)
      end select

#ifndef MW_SERIAL
      count = 3*n
      call MPI_Allreduce(MPI_IN_PLACE, force_to_distribute, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
      count = 3*3
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif

      do ixyz = 1, 3
         do iion = 1, n
            forces_ions(iion,ixyz) = forces_ions(iion,ixyz) + force_to_distribute(iion,ixyz)  
         end do
      end do

   end subroutine redistribute_force

   ! ================================================================================
   include 'four_site_model_2DPBC.inc'
   include 'four_site_model_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'

end module MW_four_site_model

! Module to manage file unit
module MW_fileunit
   implicit none
   private

   public :: get_new_unit

   integer, parameter :: min_unit = 10

contains

   ! Look for a valid unit to be used in an open statement
   subroutine get_new_unit(newunit)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      integer, intent(out) :: newunit  ! a valid unit number

      logical :: lexist, lopen

      newunit = min_unit
      inquire(unit=newunit, exist=lexist)
      do while (lexist)
         inquire(unit=newunit, opened=lopen)
         if (.not. lopen) exit
         newunit = newunit + 1
         inquire(unit=newunit, exist=lexist)
      end do

      if (.not. lexist) then
         call MW_errors_runtime_error('MW_fileunit_getNewUnit', 'fileunit.f90', &
               "All valid file units have been exhausted...")
      end if

   end subroutine get_new_unit

end module MW_fileunit

!> XFT Potential
!! -------------------
!!
!! V(r_{ij}) = B * exp(-\eta r_{ij}) / r_{ij}^n
!!           + Bx * exp(-\etax r_{ij}^{2})
!!           - \frac{C}{r_{ij}^6} * [1 - (sum_{k=0}^{6} \frac{(damp_dd*r_{ij})^k}{k!})*exp(-damp_dd*r_{ij})]
!!           - \frac{D}{r_{ij}^8} * [1 - (sum_{l=0}^{8} \frac{(damp_dq*r_{ij})^l}{l!})*exp(-damp_dq*r_{ij})]
!!
module MW_xft
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_timers
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_molecule, only: MW_molecule_t
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_xft_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: copy_type
   public :: void_type
   public :: print_type
   public :: set_rcut
   public :: set_parameters
   public :: mixing_rule
   public :: melt_forces
   public :: stress_tensor_tail_correction
   public :: energy
   public :: melt_fix_molecule_forces
   public :: fix_molecule_energy

   ! Data structure to handle XFT potentials
!! V(r_{ij}) = B * exp(-\eta r_{ij}) / r_{ij}^n
!!           + Bx * exp(-\etax r_{ij}^{2})
!!           - \frac{C}{r_{ij}^6} * [1 - (sum_{k=0}^{6} \frac{(damp_dd*r_{ij})^k}{k!})*exp(-damp_dd*r_{ij})]
!!           - \frac{D}{r_{ij}^8} * [1 - (sum_{l=0}^{8} \frac{(damp_dq*r_{ij})^l}{l!})*exp(-damp_dq*r_{ij})]
   type MW_xft_t
      integer :: num_species = 0                            ! number of species
      real(wp) :: rcut = 0.0_wp                             ! cut-off parameter
      real(wp) :: rcutsq = 0.0_wp                           ! cut-off parameter squared
      real(wp), dimension(:,:), allocatable :: eta          ! (num_species,num_species) exponential factor
      real(wp), dimension(:,:), allocatable :: B            ! (num_species,num_species) exponential scaling factor
      real(wp), dimension(:,:), allocatable :: etax         ! (num_species,num_species) exponential factor
      real(wp), dimension(:,:), allocatable :: Bx           ! (num_species,num_species) exponential scaling factor
      integer,  dimension(:,:), allocatable :: n            ! (num_species,num_species) exponent for the repulsive wall 
      real(wp), dimension(:,:), allocatable :: C            ! (num_species,num_species) dipole-dipole van der Waals attractive term
      real(wp), dimension(:,:), allocatable :: D            ! (num_species,num_species) dipole-quadripole van de Waals attractive termp
      real(wp), dimension(:,:), allocatable :: damp_dd      ! (num_species,num_species) dipole-dipole damping factor
      real(wp), dimension(:,:), allocatable :: damp_dq      ! (num_species,num_species) dipole-quadripole damping factor
      logical :: xft_3D_tail_correction = .false.           ! Flag to turn on the dispersion terms tail correction in 3D
   end type MW_xft_t

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, num_species, rcut)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ---------_
      type(MW_xft_t), intent(inout) :: this      !> structure to be defined
      integer, intent(in) :: num_species                    !> number of species
      real(wp), intent(in) :: rcut

      ! Local
      ! -----
      integer :: ierr

      call set_rcut(this, rcut)

      if (num_species <= 0) then
         call MW_errors_parameter_error("define_type", "xft.f90",&
               "num_species", num_species)
      end if

      this%num_species = num_species

      allocate(this%eta(num_species,num_species), &
            this%B(num_species,num_species), &
            this%n(num_species,num_species), &
            this%etax(num_species,num_species), &
            this%Bx(num_species,num_species), &
            this%C(num_species,num_species), &
            this%D(num_species,num_species), &
            this%damp_dd(num_species,num_species), &
            this%damp_dq(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "xft.f90", ierr)
      this%eta(:,:) = 0.0_wp
      this%B(:,:) = 0.0_wp
      this%n(:,:) = 0
      this%etax(:,:) = 0.0_wp
      this%Bx(:,:) = 0.0_wp
      this%C(:,:) = 0.0_wp
      this%D(:,:) = 0.0_wp
      this%damp_dd(:,:) = 0.0_wp
      this%damp_dq(:,:) = 0.0_wp

   end subroutine define_type

   !================================================================================
   subroutine copy_type(this, copy)
      implicit none
      type(MW_xft_t), intent(in) :: this      !> structure to be defined
      type(MW_xft_t), intent(out) :: copy      !> structure to be defined

      ! Local
      ! -----
      integer :: i, j

      call define_type(copy, this%num_species, this%rcut)

      do i=1, copy%num_species
         do j=1, copy%num_species
            copy%eta(i,j) = this%eta(i,j)
            copy%B(i,j) = this%B(i,j)
            copy%n(i,j) = this%n(i,j)
            copy%etax(i,j) = this%etax(i,j)
            copy%Bx(i,j) = this%Bx(i,j)
            copy%C(i,j) = this%C(i,j)
            copy%D(i,j) = this%D(i,j)
            copy%damp_dd(i,j) = this%damp_dd(i,j)
            copy%damp_dq(i,j) = this%damp_dq(i,j)
         end do
      end do

   end subroutine copy_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_xft_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%eta)) then
         deallocate(this%eta, this%B, this%n, this%etax, this%Bx, this%C, this%D, this%damp_dd, this%damp_dq, stat=ierr)
         if (ierr /= 0) &
               call MW_errors_deallocate_error("define_type", "xft.f90", ierr)
      end if

      this%num_species = 0
      this%rcut = 0.0_wp
      this%rcutsq = 0.0_wp
   end subroutine void_type

   ! ================================================================================
   ! set rcut value
   subroutine set_rcut(this, rcut)
      implicit none
      type(MW_xft_t), intent(inout) :: this
      real(wp), intent(in) :: rcut

      this%rcut = rcut
      this%rcutsq = rcut*rcut
   end subroutine set_rcut

   ! ================================================================================
   subroutine set_parameters(this, typeA, typeB, xft_eta, xft_B, xft_n, &
          xft_etax, xft_Bx, xft_C, xft_D, xft_damp_dd, xft_damp_dq)
      implicit none
      type(MW_xft_t), intent(inout) :: this
      integer, intent(in) :: typeA, typeB
      real(wp), intent(in) :: xft_eta, xft_B, xft_C, xft_D, xft_damp_dd, xft_damp_dq
      real(wp), intent(in) :: xft_etax, xft_Bx
      integer, intent(in) :: xft_n

      this%eta(typeA,typeB) = xft_eta
      this%eta(typeB,typeA) = xft_eta

      this%B(typeA,typeB) = xft_B
      this%B(typeB,typeA) = xft_B

      this%n(typeA,typeB) = xft_n
      this%n(typeB,typeA) = xft_n

      this%etax(typeA,typeB) = xft_etax
      this%etax(typeB,typeA) = xft_etax

      this%Bx(typeA,typeB) = xft_Bx
      this%Bx(typeB,typeA) = xft_Bx

      this%C(typeA,typeB) = xft_C
      this%C(typeB,typeA) = xft_C

      this%D(typeA,typeB) = xft_D
      this%D(typeB,typeA) = xft_D

      this%damp_dd(typeA,typeB) = xft_damp_dd
      this%damp_dd(typeB,typeA) = xft_damp_dd

      this%damp_dq(typeA,typeB) = xft_damp_dq
      this%damp_dq(typeB,typeA) = xft_damp_dq

   end subroutine set_parameters

   ! ================================================================================
   ! mixing rule
   subroutine mixing_rule(this)
      use MW_errors, only : MW_errors_runtime_error => runtime_error     
      implicit none
      type(MW_xft_t), intent(inout) :: this

      ! Local
      integer :: itype, jtype
      real(wp) :: eta1, eta2, B1, B2, C1, C2, D1, D2, damp_dd1, damp_dd2, damp_dq1, damp_dq2
      integer :: n1, n2
      real(wp) :: etax1, etax2, BX1, BX2
      character(256) :: errmsg

      do itype = 1, this%num_species
         do jtype = itype+1, this%num_species
            eta1 = this%eta(itype,itype)
            eta2 = this%eta(jtype,jtype)
            B1 = this%B(itype,itype)
            B2 = this%B(jtype,jtype)
            n1 = this%n(itype,itype)
            n2 = this%n(jtype,jtype)
            etax1 = this%etax(itype,itype)
            etax2 = this%etax(jtype,jtype)
            Bx1 = this%Bx(itype,itype)
            Bx2 = this%Bx(jtype,jtype)
            C1 = this%C(itype,itype)
            C2 = this%C(jtype,jtype)
            D1 = this%D(itype,itype)
            D2 = this%D(jtype,jtype)
            damp_dd1 = this%damp_dd(itype,itype)
            damp_dd2 = this%damp_dd(jtype,jtype)
            damp_dq1 = this%damp_dq(itype,itype)
            damp_dq2 = this%damp_dq(jtype,jtype)
            if ((eta1 .ne. 0) .and. (eta2 .ne. 0) .and. (damp_dd1 .ne. 0) .and. (damp_dd2 .ne. 0) &
                  .and. (damp_dq1 .ne. 0) .and. (damp_dq2 .ne. 0) &
                  .and. (etax1 .ne. 0) .and. (etax2 .ne. 0)) then
               this%eta(itype,jtype) = (eta1 + eta2) * eta1 * eta2 /(eta1**2 + eta2**2)
               this%eta(jtype,itype) = (eta1 + eta2) * eta1 * eta2 /(eta1**2 + eta2**2)
               this%B(itype,jtype) = sqrt(B1 * B2)
               this%B(jtype,itype) = sqrt(B1 * B2)
               this%etax(itype,jtype) = (etax1 + etax2) * etax1 * etax2 /(etax1**2 + etax2**2)
               this%etax(jtype,itype) = (etax1 + etax2) * etax1 * etax2 /(etax1**2 + etax2**2)
               this%Bx(itype,jtype) = sqrt(Bx1 * Bx2)
               this%Bx(jtype,itype) = sqrt(Bx1 * Bx2)
               this%C(itype,jtype) = sqrt(C1 * C2)
               this%C(jtype,itype) = sqrt(C1 * C2)
               this%D(itype,jtype) = sqrt(D1 * D2)
               this%D(jtype,itype) = sqrt(D1 * D2)
               this%damp_dd(itype,jtype) = (damp_dd1 + damp_dd2) * damp_dd1 * damp_dd2 /(damp_dd1**2 + damp_dd2**2)
               this%damp_dd(jtype,itype) = (damp_dd1 + damp_dd2) * damp_dd1 * damp_dd2 /(damp_dd1**2 + damp_dd2**2)
               this%damp_dq(itype,jtype) = (damp_dq1 + damp_dq2) * damp_dq1 * damp_dq2 /(damp_dq1**2 + damp_dq2**2)
               this%damp_dq(jtype,itype) = (damp_dq1 + damp_dq2) * damp_dq1 * damp_dq2 /(damp_dq1**2 + damp_dq2**2)
            end if
            if(n1.eq.n2)then
               this%n(itype,jtype) = n1   
               this%n(jtype,itype) = n1
            else
                write(errmsg, '("impossible to mix 2 XFT potentials with different exponent in the repulsion term")')
                call MW_errors_runtime_error("mixing_rule","xft.F90",errmsg)   
            endif   

         end do
      end do

   end subroutine mixing_rule

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, species_names, ounit)
      use MW_kinds, only: PARTICLE_NAME_LEN
      implicit none
      type(MW_xft_t), intent(in) :: this               ! structure to be printed
      character(PARTICLE_NAME_LEN),   intent(in) :: species_names(:)   ! names of the species
      integer,                   intent(in) :: ounit              ! output unit

      integer :: i, j

      write(ounit, '("|xft| cut-off distance: ",es12.5)') this%rcut
      write(ounit, '("|xft| ",8x,1x,8x,1x,"    eta     ",1x,"     B      ",1x, &
            &"n  ",1x,"   etax    ",1x,"     Bx     ",1x, &
            &"     C      ",1x,"     D      ",1x, &
            &"  damp_dd   ",1x,"  damp_dq   ",1x)')

      do j = 1, this%num_species
         do i = j, this%num_species
            write(ounit, '("|xft| ",a8,1x,a8,2(1x,es12.5),1x,i1,7(1x,es12.5))') &
                  species_names(i), species_names(j), this%eta(i,j), this%B(i,j),&
                  this%n(i,j), this%etax(i,j), this%Bx(i,j),&
                  this%C(i,j), this%D(i,j), this%damp_dd(i,j), this%damp_dq(i,j)
         end do
      end do

   end subroutine print_type

   ! ==============================================================================
   ! Compute XFT forces felt by melt ions
   subroutine melt_forces(num_pbc, localwork, xft, box, ions, xyz_ions, &
         electrodes, xyz_elec, force,stress_tensor, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_xft_t), intent(in) :: xft      !< XFT potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(inout) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_elec(:,:)  !< electrode atoms xyz positions
      logical,              intent(in) :: compute_force !< compute force on electrodes

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< XFT force on ions
      real(wp), intent(inout) :: stress_tensor(:,:) !< XFT forces contribution to the stress tensor

      ! Local
      ! -----
      integer :: i, ierr, count, num_elec_types

      select case(num_pbc)
      case (2)
         call melt_forces_2DPBC(localwork, xft, box, ions, xyz_ions, &
               electrodes, xyz_elec, force, stress_tensor)
      case(3)
         call melt_forces_3DPBC(localwork, xft, box, ions, xyz_ions, &
         electrodes, xyz_elec, force, stress_tensor)
      end select
#ifndef MW_SERIAL
      count = size(force,1) * size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)      

      if (compute_force) then
         num_elec_types = size(electrodes, 1)
         do i = 1, num_elec_types
               call MPI_Allreduce(MPI_IN_PLACE, electrodes(i)%force_ions(:,8), 3, &
                     MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
         end do
      end if
#endif
   end subroutine melt_forces

   ! ==============================================================================
   ! Compute tail correction to the stress tensor 
   subroutine stress_tensor_tail_correction(xft, box, ions,tail_correction)
      use MW_constants, only : pi     
      implicit none

      ! Parameters in
      ! -------------
      type(MW_xft_t), intent(in) :: xft      !< XFT potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: tail_correction !< tail correction to the stress tensor

      ! Local
      ! -----
      integer :: itype,jtype,num_ion_types
      integer :: count_n,count_m
      real(wp) :: rcutsq,rcut,C_ij,D_ij

      num_ion_types = size(ions,1)

      rcutsq = xft%rcutsq
      rcut=sqrt(rcutsq)
      tail_correction=0.0_wp
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
!        do jtype =  itype, num_ion_types
         do jtype =  1, num_ion_types
            count_m = ions(jtype)%count
            C_ij = xft%C(itype, jtype)
            D_ij = xft%D(itype, jtype)
            tail_correction=tail_correction- &
                    2.0*pi*count_m*count_n/product(box%length(:))*(C_ij*2.0/(rcut**3.0)+D_ij*(8.0/5.0)/(rcut**5.0))
         end do
      end do

   end subroutine stress_tensor_tail_correction   

   ! ==============================================================================
   ! Compute XFT potential felt by melt ions
   subroutine energy(num_pbc, localwork, xft, box, ions, xyz_ions, &
         electrodes, xyz_atoms, h)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_xft_t), intent(in) :: xft      !< XFT potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to L-J interactions

      ! Local
      ! -----
      integer :: ierr

      select case(num_pbc)
      case (2)
         call energy_2DPBC(localwork, xft, box, ions, xyz_ions, &
         electrodes, xyz_atoms, h)
      case(3)
         call energy_3DPBC(localwork, xft, box, ions, xyz_ions, &
         electrodes, xyz_atoms, h)
      end select
#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   ! ================================================================================
   ! Remove contribution from same molecule particles
   !
   subroutine melt_fix_molecule_forces(num_pbc, localwork, xft, molecules, box, ions, &
         xyz_ions, force,stress_tensor)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_xft_t), intent(in) :: xft      !< XFT potential parameters
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< ions parameters
      real(wp), intent(in) :: xyz_ions(:,:) !< melt particles coordinates
      real(wp), intent(inout) :: force(:,:) !< force on melt particles
      real(wp), intent(inout) :: stress_tensor(:,:) !< stress tensor

      ! Local
      ! -----
      integer :: ierr, count

      select case(num_pbc)
      case (2)
         call melt_fix_molecule_forces_2DPBC(localwork, xft, molecules, box, ions, &
         xyz_ions, force,stress_tensor)
      case(3)
         call melt_fix_molecule_forces_3DPBC(localwork, xft, molecules, box, ions, &
         xyz_ions, force,stress_tensor)
      end select
#ifndef MW_SERIAL
      count = size(force,1) * size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)      
#endif
   end subroutine melt_fix_molecule_forces

   ! ================================================================================
   ! Remove contribution from same molecule particles
   !
   subroutine fix_molecule_energy(num_pbc, localwork, xft, molecules, box, ions, &
         xyz_ions, h)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_xft_t), intent(in) :: xft      !< Fumi-Tosi potential parameters
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< melt particle parameters
      real(wp), intent(in) :: xyz_ions(:,:) !< melt particles coordinates
      real(wp), intent(inout) :: h !< potential on melt particles

      ! Local
      ! -----
      integer :: ierr

      select case(num_pbc)
      case (2)
         call fix_molecule_energy_2DPBC(localwork, xft, molecules, box, ions, &
               xyz_ions, h)
      case(3)
         call fix_molecule_energy_3DPBC(localwork, xft, molecules, box, ions, &
               xyz_ions, h)
      end select
#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_energy

   ! ================================================================================
   ! Function to compute force coeffcient between 2 particles
   !
   ! ft_ij = (dV(r_ij) / dr_ij) * (1/ r_ij)
   pure function force_ij(drnorm2, eta_ij, B_ij, n_ij, etax_ij, Bx_ij, &
                   C_ij, D_ij, damp_dd_ij, damp_dq_ij) result(xft_ij)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in)  :: n_ij
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: eta_ij
      real(wp), intent(in) :: B_ij
      real(wp), intent(in) :: etax_ij
      real(wp), intent(in) :: Bx_ij
      real(wp), intent(in) :: C_ij
      real(wp), intent(in) :: D_ij
      real(wp), intent(in) :: damp_dd_ij
      real(wp), intent(in) :: damp_dq_ij

      ! Result
      ! ------
      real(wp) :: xft_ij

      ! Local
      ! -----

      real(wp) :: drnorm, drnormrec, drnorm2rec, drnorm6rec, drnorm8rec
      real(wp) :: drnormnrec
      real(wp) :: damp_dd_sum, damp_dd_term
      real(wp) :: damp_dq_sum, damp_dq_term
      integer :: k, l
      drnorm = sqrt(drnorm2)
      drnormrec  = 1.0_wp / drnorm
      drnormnrec = drnormrec**n_ij
      drnorm2rec = drnormrec * drnormrec
      drnorm6rec = drnorm2rec * drnorm2rec * drnorm2rec
      drnorm8rec = drnorm2rec * drnorm6rec

      ! damp_dd_sum = sum_{k=0}^{6} (d_{dd}^k r_{ij}^k) / k!
      damp_dd_sum = 1.0_wp
      damp_dd_term = 1.0_wp
      do k = 1, 6
         damp_dd_term = damp_dd_term * (damp_dd_ij * drnorm / real(k,wp)) ! damp_dd_term =  (d_{dd}^k r_{ij}^k) / k!
         damp_dd_sum = damp_dd_sum + damp_dd_term
      end do

      ! damp_dq_sum = sum_{k=0}^{8} (d_{dq}^k r_{ij}^k) / k!
      damp_dq_sum = 1.0_wp
      damp_dq_term = 1.0_wp
      do l = 1, 8
         damp_dq_term = damp_dq_term * (damp_dq_ij * drnorm / real(l,wp)) ! damp_dq_term =  (d_{dq}^k r_{ij}^k) / k!
         damp_dq_sum = damp_dq_sum + damp_dq_term
      end do

      xft_ij = -eta_ij * B_ij * exp(-eta_ij*drnorm)*drnormnrec &
            -  B_ij * exp(-eta_ij*drnorm) * drnormnrec * drnormrec * real(n_ij,wp) &
            -  etax_ij * Bx_ij * 2.0_wp * drnorm * exp(-etax_ij*drnorm2) &            
            + (C_ij * drnorm6rec) * (6.0_wp * drnormrec * (1.0_wp - damp_dd_sum*exp(-damp_dd_ij*drnorm)) &
            - damp_dd_ij * damp_dd_term * exp(-damp_dd_ij * drnorm)) &
            + (D_ij * drnorm8rec) * (8.0_wp * drnormrec * (1.0_wp - damp_dq_sum*exp(-damp_dq_ij*drnorm)) &
            - damp_dq_ij * damp_dq_term * exp(-damp_dq_ij * drnorm))

      xft_ij = xft_ij * drnormrec
   end function force_ij

   ! ================================================================================
   ! Function to compute the potential felt between 2 particles
   !
   ! ft_ij = V(r_ij)
   pure function potential_ij(drnorm2, eta_ij, B_ij, n_ij,  etax_ij, Bx_ij, &
                   C_ij, D_ij, damp_dd_ij, damp_dq_ij) result(xft_ij)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in)  :: n_ij
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: eta_ij
      real(wp), intent(in) :: B_ij
      real(wp), intent(in) :: etax_ij
      real(wp), intent(in) :: Bx_ij
      real(wp), intent(in) :: C_ij
      real(wp), intent(in) :: D_ij
      real(wp), intent(in) :: damp_dd_ij
      real(wp), intent(in) :: damp_dq_ij

      ! Result
      ! ------
      real(wp) :: xft_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnorm2rec, drnorm6rec, drnorm8rec
      real(wp) :: drnormrec, drnormnrec
      real(wp) :: damp_dd_sum, damp_dd_term
      real(wp) :: damp_dq_sum, damp_dq_term
      integer :: k, l

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp / drnorm
      drnormnrec = drnormrec**n_ij
      drnorm2rec = drnormrec*drnormrec      
      drnorm6rec = drnorm2rec * drnorm2rec * drnorm2rec
      drnorm8rec = drnorm2rec * drnorm6rec

      ! damp_dd_sum = sum_{k=0}^{6} (d_{dd}^k r_{ij}^k) / k!
      damp_dd_sum = 1.0_wp
      damp_dd_term = 1.0_wp
      do k = 1, 6
         damp_dd_term = damp_dd_term * (damp_dd_ij * drnorm / real(k,wp)) ! damp_dd_term =  (d_{dd}^k r_{ij}^k) / k!
         damp_dd_sum = damp_dd_sum + damp_dd_term
      end do

      ! damp_dq_sum = sum_{k=0}^{8} (d_{dq}^k r_{ij}^k) / k!
      damp_dq_sum = 1.0_wp
      damp_dq_term = 1.0_wp
      do l = 1, 8
         damp_dq_term = damp_dq_term * (damp_dq_ij * drnorm / real(l,wp)) ! damp_dq_term =  (d_{dq}^k r_{ij}^k) / k!
         damp_dq_sum = damp_dq_sum + damp_dq_term
      end do

      xft_ij = B_ij * exp(-eta_ij * drnorm)*drnormnrec &
            +  Bx_ij * exp(-etax_ij*drnorm2) &            
            - C_ij * drnorm6rec * (1.0_wp - damp_dd_sum*exp(-damp_dd_ij*drnorm)) &
            - D_ij * drnorm8rec * (1.0_wp - damp_dq_sum*exp(-damp_dq_ij*drnorm))
   end function potential_ij

   ! ================================================================================
   include 'xft_2DPBC.inc'
   include 'xft_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_xft

module MW_thomas_fermi
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_constants, only: pi, fourpi
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_thomas_fermi_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type
   public :: kinetic_gradQelec_potential
   public :: kinetic_elec_potential
   public :: kinetic_energy

   ! Data structure to handle Thomas-fermi model
   type MW_thomas_fermi_t
      real(wp) :: ltf = 0.0_wp                                     ! Thomas-fermi length
      real(wp) :: fourpi_ltfsquare = 0.0_wp                        ! 4pi*ltf**2
      real(wp) :: voronoi_volume = 0.0_wp                          ! Voronoi volume of the particle
   end type MW_thomas_fermi_t


contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, ltf, voronoi_volume)
      implicit none
      ! Parameters
      ! ---------_
      type(MW_thomas_fermi_t), intent(inout) :: this      !> structure to be defined
      real(wp), intent(in) :: ltf
      real(wp), intent(in) :: voronoi_volume
      ! Local
      ! -----
      real(wp) :: ltfsquare

      ltfsquare = ltf * ltf
      this%ltf = ltf
      this%fourpi_ltfsquare = fourpi * ltfsquare
      this%voronoi_volume = voronoi_volume


   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      implicit none
      type(MW_thomas_fermi_t), intent(inout) :: this

      this%ltf = 0.0_wp
      this%fourpi_ltfsquare = 0.0_wp
      this%voronoi_volume = 0.0_wp

   end subroutine void_type


   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, ounit)
      implicit none
      type(MW_thomas_fermi_t), intent(in) :: this               ! structure to be printed
      integer,                   intent(in) :: ounit              ! output unit

      write(ounit, '("|electrode|  Thomas-Fermi length ltf = ",es12.5," Voronoi volume = ",es12.5)') &
            this%ltf, this%voronoi_volume

   end subroutine print_type

   ! ================================================================================
   ! Compute the 2nd order contribution of the kinetic energy to the  potential felt by an electrode atom
   subroutine kinetic_gradQelec_potential(thomas_fermi, electrodes, gradQ_V)
     implicit none

     ! Parameters in
     ! -------------
      type(MW_thomas_fermi_t), intent(in) :: thomas_fermi(:)      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: gradQ_V(:,:)

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i
      integer :: count_n, offset_n
      real(wp) :: fourpi_ltfsquarei, voronoii

      num_elec_types = size(electrodes,1)

      do itype = 1, num_elec_types
         if(thomas_fermi(itype)%ltf>0) then
            count_n = electrodes(itype)%count
            offset_n = electrodes(itype)%offset
            fourpi_ltfsquarei = thomas_fermi(itype)%fourpi_ltfsquare
            voronoii = thomas_fermi(itype)%voronoi_volume
            do ielec = 1, count_n
               i = ielec + offset_n
               gradQ_V(i,i) = gradQ_V(i,i) + fourpi_ltfsquarei / voronoii
            end do
         end if
      end do
   end subroutine kinetic_gradQelec_potential


   ! ================================================================================
   ! Compute the 2nd order contribution of the kinetic energy to the  potential felt by an electrode atom
   subroutine kinetic_elec_potential(this, electrodes, q_elec, V)
     implicit none

     ! Parameters in
     ! -------------
      type(MW_thomas_fermi_t), intent(in) :: this(:)      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp), intent(in) :: q_elec(:)
      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: V(:)

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i
      integer :: count_n, offset_n
      real(wp) :: fourpi_ltfsquarei, voronoii

      num_elec_types = size(electrodes,1)

      do itype = 1, num_elec_types
         if(this(itype)%ltf>0) then
            count_n = electrodes(itype)%count
            offset_n = electrodes(itype)%offset
            fourpi_ltfsquarei = this(itype)%fourpi_ltfsquare
            voronoii = this(itype)%voronoi_volume
            do ielec = 1, count_n
               i = ielec + offset_n
               V(i) = fourpi_ltfsquarei * q_elec(i) / voronoii
            end do
         end if
      end do
    end subroutine kinetic_elec_potential


   ! ================================================================================
   ! Compute the kinetic energy of the electron gas
   subroutine kinetic_energy(this, electrodes, q_elec, h)
     implicit none

     ! Parameters in
     ! -------------
      type(MW_thomas_fermi_t), intent(in) :: this(:)      !< Lennard-Jones potential parameters
      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp), intent(in) :: q_elec(:)
      ! Parameter out
      ! -------------
      real(wp), intent(inout) :: h

      ! Local
      ! -----
      integer :: num_elec_types
      integer :: itype, ielec, i
      integer :: count_n, offset_n
      real(wp) :: fourpi_ltfsquarei, voronoii

      num_elec_types = size(electrodes,1)
      h = 0.0_wp

      do itype = 1, num_elec_types
         if(this(itype)%ltf>0) then
            count_n = electrodes(itype)%count
            offset_n = electrodes(itype)%offset
            fourpi_ltfsquarei = this(itype)%fourpi_ltfsquare
            voronoii = this(itype)%voronoi_volume
            do ielec = 1, count_n
               i = ielec + offset_n
               h = h + fourpi_ltfsquarei * 0.5 * q_elec(i)*q_elec(i) / voronoii
            end do
         end if
      end do
    end subroutine kinetic_energy


end module MW_thomas_fermi

! Defines molecules and molecular constraints
module MW_molecule
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   implicit none
   private

   public :: MW_molecule_t

   public :: define_type
   public :: void_type
   public :: print_type
   public :: set_rattle_parameters
   public :: set_linear_parameters
   public :: print_trajectories
   public :: read_parameters
   public :: set_sites_index
   public :: set_index

   type MW_molecule_t
      integer :: n                             !> number of molecules of this type
      character(len=PARTICLE_NAME_LEN) :: name !> name of the molecule
      integer :: index = 0                     !> Index of the molecule

      integer :: num_sites = 0             !> number of sites in the molecule
      integer, allocatable :: sites(:) !> ion types index of each site
      character(len=PARTICLE_NAME_LEN), allocatable :: site_names(:) !> ion types name of each site

      ! Constraints
      integer :: num_constraints = 0 !> Number of constraints
      integer, allocatable :: constrained_sites(:,:) !> Pairs of constrained sites
      real(wp), allocatable :: constrained_dr(:)     !> Constrained distance between pairs of sites

      integer :: constraint_algorithm = 0 !> constraint algorithm id
      integer :: constraint_max_iteration = 0 !> maximum iteration used in constraint algorithm
      real(wp) :: constraint_tolerance = 0.0_wp !> tolerance on constraints

      logical :: linear = .false. !> flag if molecule is linear
      integer, allocatable :: basis_sites(:) !> indices of the two basis sites
      integer, allocatable :: basis_constrained_sites(:,:) !> Pair of constrained basis sites
      real(wp), allocatable :: basis_constrained_dr(:)      !> Constrained distance between pairs of basis sites
      integer, allocatable :: other_sites(:) !> indices of the non-basis sites
      real(wp), allocatable :: other_sites_coordinates(:,:) !> coordinates of the other sites with respect to the basis

      ! intra-molecular potentials
      integer :: num_harmonic_bonds = 0                   ! Number of harmonic bonds
      integer, allocatable :: harmonic_bonds_sites(:,:)   ! Pairs of sites linked by a harmonic bond
      real(wp), allocatable :: harmonic_bonds_strength(:) ! Strength of the harmonic bond
      real(wp), allocatable :: harmonic_bonds_length(:)   ! Length at rest of the harmonic bond

      integer :: num_harmonic_angles = 0                   ! Number of harmonic angles
      integer, allocatable :: harmonic_angles_sites(:,:)   ! Triplet of sites linked by a harmonic angle
      real(wp), allocatable :: harmonic_angles_strength(:) ! Strength of the harmonic bond
      real(wp), allocatable :: harmonic_angles_angle(:)    ! Angle at rest of the harmonic bond

      integer :: num_born_repulsions = 0                   ! Number of born repulsions
      integer, allocatable :: born_repulsions_sites(:,:)   ! Triplet of sites linked by a harmonic angle
      real(wp), allocatable :: born_repulsions_energy(:)   ! Energy of the repulsion at r=0
      real(wp), allocatable :: born_repulsions_eta(:)      ! Inverse length of the born repulsion

      integer :: num_internal_coulomb = 0
      integer, allocatable :: internal_coulomb_sites(:,:)  ! Pairs of sites interacting <ith short range Coulomb
      logical, allocatable :: internal_coulomb_pairs(:,:)  !> flag if site pairs are interacting via short range Coulomb

      integer :: num_dihedrals = 0                   ! Number of dihedrals
      integer, allocatable :: dihedrals_sites(:,:)   ! Quadruplet of sites linked by a dihedral
      real(wp), allocatable :: dihedrals_v1(:) ! Parameters of the dihedral potential
      real(wp), allocatable :: dihedrals_v2(:) ! Parameters of the dihedral potential
      real(wp), allocatable :: dihedrals_v3(:) ! Parameters of the dihedral potential
      real(wp), allocatable :: dihedrals_v4(:) ! Parameters of the dihedral potential

      integer :: num_impropers = 0                   ! Number of impropers
      integer, allocatable :: impropers_sites(:,:)   ! Quadruplet of sites linked by a improper
      real(wp), allocatable :: impropers_v1(:) ! Parameters of the improper potential
      real(wp), allocatable :: impropers_v2(:) ! Parameters of the improper potential
      real(wp), allocatable :: impropers_v3(:) ! Parameters of the improper potential
      real(wp), allocatable :: impropers_v4(:) ! Parameters of the improper potential

      ! Interacting pairs
      logical, allocatable :: interacting_pairs(:,:) !> flag if site pairs are interacting via potentials
      logical, allocatable :: halfinteracting_pairs(:,:) !> flag if site pairs are interacting via potentials

      ! Four-site model
      logical :: fourth_site
      real(wp) :: fourth_distance
      real(wp) :: alpha

   end type MW_molecule_t

   integer, parameter, public :: CONSTRAINT_ALGORITHM_NONE = 0
   integer, parameter, public :: CONSTRAINT_ALGORITHM_RATTLE = 1
   integer, parameter, public :: CONSTRAINT_ALGORITHM_LINEAR = 2

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, name, n, num_sites, num_constraints, num_harmonic_bonds, &
         num_harmonic_angles,num_dihedrals,num_impropers, num_born_repulsions, num_internal_coulomb, &
         fourth_site, fourth_distance)
      use MW_errors, only: MW_errors_allocate_error => allocate_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      ! Passed in/out
      type(MW_molecule_t), intent(inout) :: this

      ! Passed in
      character(len=*), intent(in) :: name       !> name of the molecule
      integer, intent(in) :: n                   !> number of molecules of this type
      integer, intent(in) :: num_sites           !> number of sites in this molecule
      integer, intent(in) :: num_constraints     !> number of constraints in this molecule
      integer, intent(in) :: num_harmonic_bonds  !> number of harmonic bonds
      integer, intent(in) :: num_harmonic_angles !> number of harmonic angles
      integer, intent(in) :: num_born_repulsions !> number of born repulsions
      integer, intent(in) :: num_internal_coulomb
      integer, intent(in) :: num_dihedrals       !> number of dihedrals
      integer, intent(in) :: num_impropers       !> number of impropers
      logical, intent(in) :: fourth_site         !> is there a fourth site?
      real(wp), intent(in) :: fourth_distance    !> distance fourth-third site
      ! Local
      integer :: i, j, ierr

      this%name = name
      this%n = n

      allocate(this%sites(num_sites), this%site_names(num_sites), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90",ierr)
      end if
      this%num_sites = num_sites
      do i = 1, num_sites
         this%sites(i) = 0
         this%site_names(i) = ""
      end do

      this%num_constraints = num_constraints
      allocate(this%constrained_sites(2, num_constraints), this%constrained_dr(num_constraints), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_constraints
         this%constrained_sites(1,i) = 0
         this%constrained_sites(2,i) = 0
         this%constrained_dr(i) = 0.0_wp
      end do

      this%num_harmonic_bonds = num_harmonic_bonds
      allocate(this%harmonic_bonds_sites(2, num_harmonic_bonds), &
            this%harmonic_bonds_strength(num_harmonic_bonds), &
            this%harmonic_bonds_length(num_harmonic_bonds), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_harmonic_bonds
         this%harmonic_bonds_sites(1,i) = 0
         this%harmonic_bonds_sites(2,i) = 0
         this%harmonic_bonds_strength(i) = 0.0_wp
         this%harmonic_bonds_length(i) = 0.0_wp
      end do

      this%num_harmonic_angles = num_harmonic_angles
      allocate(this%harmonic_angles_sites(3, num_harmonic_angles), &
            this%harmonic_angles_strength(num_harmonic_angles), &
            this%harmonic_angles_angle(num_harmonic_angles), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_harmonic_angles
         this%harmonic_angles_sites(1,i) = 0
         this%harmonic_angles_sites(2,i) = 0
         this%harmonic_angles_sites(3,i) = 0
         this%harmonic_angles_strength(i) = 0.0_wp
         this%harmonic_angles_angle(i) = 0.0_wp
      end do

      this%num_born_repulsions = num_born_repulsions
      allocate(this%born_repulsions_sites(2, num_born_repulsions), &
            this%born_repulsions_energy(num_born_repulsions), &
            this%born_repulsions_eta(num_born_repulsions), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_born_repulsions
         this%born_repulsions_sites(1,i) = 0
         this%born_repulsions_sites(2,i) = 0
         this%born_repulsions_energy(i) = 0.0_wp
         this%born_repulsions_eta(i) = 0.0_wp
      enddo

      this%num_internal_coulomb = num_internal_coulomb
      allocate(this%internal_coulomb_sites(2, num_internal_coulomb), &
         this%internal_coulomb_pairs(num_sites,num_sites), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_internal_coulomb
         this%internal_coulomb_sites(1,i) = 0
         this%internal_coulomb_sites(2,i) = 0
      enddo

      do i = 1, num_sites
         do j = 1, num_sites
            this%internal_coulomb_pairs(i,j) = .false.
         end do
      end do

      this%num_dihedrals = num_dihedrals
      allocate(this%dihedrals_sites(4, num_dihedrals), &
            this%dihedrals_v1(num_dihedrals), &
            this%dihedrals_v2(num_dihedrals), &
            this%dihedrals_v3(num_dihedrals), &
            this%dihedrals_v4(num_dihedrals), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_dihedrals
         this%dihedrals_sites(1,i) = 0
         this%dihedrals_sites(2,i) = 0
         this%dihedrals_sites(3,i) = 0
         this%dihedrals_sites(4,i) = 0
         this%dihedrals_v1(i) = 0.0_wp
         this%dihedrals_v2(i) = 0.0_wp
         this%dihedrals_v3(i) = 0.0_wp
         this%dihedrals_v4(i) = 0.0_wp
      end do

      this%num_impropers = num_impropers
      allocate(this%impropers_sites(4, num_impropers), &
            this%impropers_v1(num_impropers), &
            this%impropers_v2(num_impropers), &
            this%impropers_v3(num_impropers), &
            this%impropers_v4(num_impropers), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90", ierr)
      end if
      do i= 1, num_impropers
         this%impropers_sites(1,i) = 0
         this%impropers_sites(2,i) = 0
         this%impropers_sites(3,i) = 0
         this%impropers_sites(4,i) = 0
         this%impropers_v1(i) = 0.0_wp
         this%impropers_v2(i) = 0.0_wp
         this%impropers_v3(i) = 0.0_wp
         this%impropers_v4(i) = 0.0_wp
      end do

      allocate(this%interacting_pairs(num_sites,num_sites), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90",ierr)
      end if
      do i = 1, num_sites
         do j = 1, num_sites
            this%interacting_pairs(i,j) = .true.
         end do
      end do

      allocate(this%halfinteracting_pairs(num_sites,num_sites), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "molecule.f90",ierr)
      end if
      do i = 1, num_sites
         do j = 1, num_sites
            this%halfinteracting_pairs(i,j) = .false.
         end do
      end do

      this%fourth_site = fourth_site
      this%fourth_distance = fourth_distance
      this%alpha = 0.5
      if (fourth_site) then
         if (num_sites /= 4) then
            call MW_errors_runtime_error("define_type", "molecule.f90", "Number of sites for molecule should be 4")
         end if
         this%interacting_pairs(1, 4) = .false.
         this%interacting_pairs(4, 1) = .false.
         this%interacting_pairs(2, 4) = .false.
         this%interacting_pairs(4, 2) = .false.
         this%interacting_pairs(3, 4) = .false.
         this%interacting_pairs(4, 3) = .false.
      end if

   end subroutine define_type

   ! ==============================================================================
   ! Void the data type
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_molecule_t), intent(inout) :: this
      integer :: ierr

      this%name = ""
      this%n = 0

      if (allocated(this%sites)) then
         deallocate(this%sites, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90",ierr)
         end if
      end if
      if (allocated(this%site_names)) then
         deallocate(this%site_names, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90",ierr)
         end if
      end if
      this%num_sites = 0

      if (allocated(this%constrained_sites)) then
         deallocate(this%constrained_sites, this%constrained_dr, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_constraints = 0

      if (allocated(this%harmonic_bonds_sites)) then
         deallocate(this%harmonic_bonds_sites, &
               this%harmonic_bonds_strength, &
               this%harmonic_bonds_length, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_harmonic_bonds = 0

      if (allocated(this%harmonic_angles_sites)) then
         deallocate(this%harmonic_angles_sites, &
               this%harmonic_angles_strength, &
               this%harmonic_angles_angle, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_harmonic_angles = 0

      if (allocated(this%dihedrals_sites)) then
         deallocate(this%dihedrals_sites, &
               this%dihedrals_v1, &
               this%dihedrals_v2, &
               this%dihedrals_v3, &
               this%dihedrals_v4, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_dihedrals = 0

     if (allocated(this%born_repulsions_sites)) then
         deallocate(this%born_repulsions_sites, &
               this%born_repulsions_energy, &
               this%born_repulsions_eta, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_born_repulsions = 0

      if (allocated(this%impropers_sites)) then
         deallocate(this%impropers_sites, &
               this%impropers_v1, &
               this%impropers_v2, &
               this%impropers_v3, &
               this%impropers_v4, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_impropers = 0

     if (allocated(this%internal_coulomb_sites)) then
         deallocate(this%internal_coulomb_sites, &
               this%internal_coulomb_pairs, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "molecule.f90", ierr)
         end if
      end if
      this%num_internal_coulomb = 0

      if (allocated(this%basis_sites)) then
         deallocate(this%basis_sites, this%basis_constrained_sites, &
               this%basis_constrained_dr, this%other_sites, &
               this%other_sites_coordinates, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "this.f90", ierr)
         end if
      end if
      this%linear = .false.

      if (allocated(this%interacting_pairs)) then
         deallocate(this%interacting_pairs, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "this.f90", ierr)
         end if
      end if

      if (allocated(this%halfinteracting_pairs)) then
         deallocate(this%halfinteracting_pairs, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "this.f90", ierr)
         end if
      end if
   end subroutine void_type

   ! ==============================================================================
   ! Prints the data
   subroutine print_type(this, ounit, names)
      implicit none
      type(MW_molecule_t), intent(in) :: this  ! structure to be printed
      integer, intent(in)             :: ounit ! output unit
      character(len=PARTICLE_NAME_LEN), intent(in) :: names(:)

      integer :: i, ia, ib, ic, id

      write(ounit, '("|molecule| ",a8," n = ",i6)') this%name, this%n
      write(ounit, '("|molecule| number of sites           = ", i3)') this%num_sites
      write(ounit, '("|molecule| number of constraints     = ",i3)')  this%num_constraints
      write(ounit, '("|molecule| number of harmonic bonds  = ",i3)')  this%num_harmonic_bonds
      write(ounit, '("|molecule| number of harmonic angles = ",i3)')  this%num_harmonic_angles
!      write(ounit, '("|molecule| number of born repulsions = ",i3)')  this%num_born_repulsions
!      write(ounit, '("|molecule| number of internal Coulomb= ",i3)')  this%num_internal_coulomb
      write(ounit, '("|molecule| number of dihedrals       = ",i3)')  this%num_dihedrals
      write(ounit, '("|molecule| number of impropers       = ",i3)')  this%num_impropers
      write(ounit, '("|molecule| sites:")')
      do i = 1, this%num_sites
         write(ounit, '("|molecule| - ",a8)') names(this%sites(i))
      end do
      if (this%num_constraints > 0) then
         write(ounit, '("|molecule| constraints:")')
!        do i = 1, this%num_constraints
!           ia = this%constrained_sites(1,i)
!           ib = this%constrained_sites(2,i)
!           write(ounit, '("|molecule| - ",a8," ",a8," ", es12.5)') &
!                 names(this%sites(ia)), names(this%sites(ib)), this%constrained_dr(i)
!        end do
         write(ounit, '("|molecule| tolerance     = ", es12.5)') this%constraint_tolerance
         write(ounit, '("|molecule| max iteration = ", i12)') this%constraint_max_iteration

         if (this%linear) then
            write(ounit, '("|molecule| The molecule is linear.")')
            write(ounit, '("|molecule| basis sites: ",4(a8,1x))') &
                  (names(this%sites(this%basis_sites(i))), i=1,size(this%basis_sites,1))
            write(ounit, '("|molecule| basis sites constraints:")')
            do i = 1, size(this%basis_constrained_dr,1)
               ia = this%basis_constrained_sites(1,i)
               ib = this%basis_constrained_sites(2,i)
               write(ounit, '("|molecule| - ",a8," ",a8," ", es12.5)') &
                     names(this%sites(ia)), names(this%sites(ib)), this%basis_constrained_dr(i)
            end do
            write(ounit, '("|molecule| non-basis sites coordinates:")')
            do i = 1, size(this%other_sites,1)
               ia = this%other_sites(i)
               write(ounit,'("|molecule| ",a8," = ",4(es12.5,1x,a8,:," + "))') &
                     names(this%sites(ia)), &
                     (this%other_sites_coordinates(ib,i), names(this%sites(this%basis_sites(ib))), &
                     ib=1,size(this%basis_sites,1))
            end do
         end if
      end if

      if (this%num_harmonic_bonds > 0) then
         write(ounit, '("|molecule| harmonic bonds: U(b) = k*(b-b0)^2")')
         do i = 1, this%num_harmonic_bonds
            ia = this%harmonic_bonds_sites(1,i)
            ib = this%harmonic_bonds_sites(2,i)
            write(ounit, '("|molecule| - ",a8," ",a8," k = ", es12.5," b0 = ",es12.5)') &
                  names(this%sites(ia)), names(this%sites(ib)), &
                  this%harmonic_bonds_strength(i), &
                  this%harmonic_bonds_length(i)
         end do
      end if

      if (this%num_harmonic_angles > 0) then
         write(ounit, '("|molecule| harmonic angles: U(theta) = k*(theta-theta0)^2")')
         do i = 1, this%num_harmonic_angles
            ia = this%harmonic_angles_sites(1,i)
            ib = this%harmonic_angles_sites(2,i)
            ic = this%harmonic_angles_sites(3,i)
            write(ounit, '("|molecule| - ",a8," ",a8," ",a8," k = ", es12.5," theta0 = ",es12.5)') &
                  names(this%sites(ia)), names(this%sites(ib)), names(this%sites(ic)), &
                  this%harmonic_angles_strength(i), &
                  this%harmonic_angles_angle(i)
         end do
      end if

      if (this%num_dihedrals > 0) then
         write(ounit, '("|molecule| dihedrals: U(phi) = 0.5*(v1(1+cos_phi)+v2(1-cos_2phi)'//&
               '+v3(1+cos_3phi)+v4*(1-cos_4phi))")')
         do i = 1, this%num_dihedrals
            ia = this%dihedrals_sites(1,i)
            ib = this%dihedrals_sites(2,i)
            ic = this%dihedrals_sites(3,i)
            id = this%dihedrals_sites(4,i)
            write(ounit, '("|molecule| - ",a8," ",a8," ",a8," ",a8," v1 = ", es12.5,'//&
                  '" v2 = ",es12.5," v3 = ",es12.5," v4 = ",es12.5)') &
                  names(this%sites(ia)), names(this%sites(ib)), names(this%sites(ic)),&
                  names(this%sites(id)), this%dihedrals_v1(i), this%dihedrals_v2(i), &
                  this%dihedrals_v3(i), this%dihedrals_v4(i)
         end do
      end if

      if (this%num_born_repulsions > 0) then
         write(ounit, '("|molecule| born repulsions: U(b) = k*exp(-b*eta)")')
         do i = 1, this%num_born_repulsions
            ia = this%born_repulsions_sites(1,i)
            ib = this%born_repulsions_sites(2,i)
            write(ounit, '("|molecule| - ",a8," ",a8," k = ", es12.5," eta = ",es12.5)') &
                  names(this%sites(ia)), names(this%sites(ib)), &
                  this%born_repulsions_energy(i), &
                  this%born_repulsions_eta(i)
         end do
      end if

      if (this%num_internal_coulomb > 0) then
         write(ounit, '("|molecule| internal Coulomb: U(b) = qi*qj/b")')
         do i = 1, this%num_internal_coulomb
            ia = this%internal_coulomb_sites(1,i)
            ib = this%internal_coulomb_sites(2,i)
            write(ounit, '("|molecule| - ",a8," ",a8)') &
                  names(this%sites(ia)), names(this%sites(ib))
         end do
      end if

      if (this%num_impropers > 0) then
         write(ounit, '("|molecule| impropers: U(phi) = 0.5*(v1(1+cos_phi)+v2(1-cos_2phi)+'//&
               'v3(1+cos_3phi)+v4*(1-cos_4phi))")')
         do i = 1, this%num_impropers
            ia = this%impropers_sites(1,i)
            ib = this%impropers_sites(2,i)
            ic = this%impropers_sites(3,i)
            id = this%impropers_sites(4,i)
            write(ounit, '("|molecule| - ",a8," ",a8," ",a8," ",a8," v1 = ", es12.5," v2 = ",'//&
                  'es12.5," v3 = ",es12.5," v4 = ",es12.5)') &
                  names(this%sites(ia)), names(this%sites(ib)), names(this%sites(ic)), &
                  names(this%sites(id)), this%impropers_v1(i), this%impropers_v2(i), &
                  this%impropers_v3(i), this%impropers_v4(i)
         end do
      end if

      if (this%fourth_site) then
         write(ounit, '("|molecule| fourth_site atom")')
         write(ounit, '("|molecule| WARNING site order should be 1:O 2:H 3:H 4:M")')
      end if

   end subroutine print_type

   ! ================================================================================
   subroutine set_rattle_parameters(this, tolerance, max_iteration)
      use MW_kinds, only: wp
      ! Parameters
      ! ----------
      type(MW_molecule_t), intent(inout) :: this
      real(wp), intent(in) :: tolerance
      integer, intent(in) :: max_iteration

      this%constraint_algorithm = CONSTRAINT_ALGORITHM_RATTLE
      this%constraint_max_iteration = max_iteration
      this%constraint_tolerance = tolerance
   end subroutine set_rattle_parameters

   ! ========================================================================
   ! Define the parameters for a linear molecule
   subroutine set_linear_parameters(molecule, siteA, siteB)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      ! Passed in
      ! ---------
      type(MW_molecule_t), intent(inout) :: molecule
      integer, intent(in) :: siteA
      integer, intent(in) :: siteB

      ! Local
      ! -----
      integer :: num_basis, num_other, num_basis_pairs
      integer :: i, iA, iB
      integer :: siteC
      real(wp) :: bond_lengths(3,3)
      integer :: ierr
      if (molecule%num_sites /= 3) then
         call MW_errors_runtime_error("define_type", "linear_molecule.f90", &
               "Linear molecule must have 3 atoms exactly.")
      end if
      if (molecule%num_constraints /= 3) then
         call MW_errors_runtime_error("define_type", "linear_molecule.f90", &
               "Linear molecule must have 3 constraints exactly.")
      end if

      num_basis = 2
      num_other = 1
      num_basis_pairs = 1
      allocate(molecule%basis_sites(num_basis), &
            molecule%basis_constrained_sites(2,num_basis_pairs), &
            molecule%basis_constrained_dr(num_basis_pairs), &
            molecule%other_sites(num_other), &
            molecule%other_sites_coordinates(num_basis,num_other), stat=ierr)


      bond_lengths(:,:) = 0.0_wp
      do i = 1, molecule%num_constraints
         iA = molecule%constrained_sites(1,i)
         iB = molecule%constrained_sites(2,i)
         bond_lengths(iA,iB) = molecule%constrained_dr(i)
         bond_lengths(iB,iA) = molecule%constrained_dr(i)
      end do

      if (siteA < siteB) then
         molecule%basis_sites(1) = siteA
         molecule%basis_sites(2) = siteB
      else
         molecule%basis_sites(1) = siteB
         molecule%basis_sites(2) = siteA
      end if

      molecule%basis_constrained_sites(1,1) = siteA
      molecule%basis_constrained_sites(2,1) = siteB
      molecule%basis_constrained_dr(1) = bond_lengths(siteA, siteB)

      do siteC = 1, 3
         if ((siteC /= siteA) .and. (siteC /= siteB)) exit
      end do
      molecule%other_sites(1) = siteC

      select case (siteC)
      case (1)
         ! C-A-B
         molecule%other_sites_coordinates(1,1) = +bond_lengths(siteC,siteB) / bond_lengths(siteA, siteB)
         molecule%other_sites_coordinates(2,1) = -bond_lengths(siteC,siteA) / bond_lengths(siteA, siteB)
      case (2)
         ! A-C-B
         molecule%other_sites_coordinates(1,1) = bond_lengths(siteC,siteB) / bond_lengths(siteA, siteB)
         molecule%other_sites_coordinates(2,1) = bond_lengths(siteC,siteA) / bond_lengths(siteA, siteB)
      case (3)
         ! A-B-C
         molecule%other_sites_coordinates(1,1) = -bond_lengths(siteC,siteB) / bond_lengths(siteA, siteB)
         molecule%other_sites_coordinates(2,1) = +bond_lengths(siteC,siteA) / bond_lengths(siteA, siteB)
      end select

      molecule%linear = .true.
      molecule%constraint_algorithm = CONSTRAINT_ALGORITHM_LINEAR
   end subroutine set_linear_parameters


   ! ==============================================================================
   ! Prints the positions of the molecule sites
   subroutine print_trajectories(this, ounit, ions, offset_ions, xyz_ions, velocity_ions)
      use MW_kinds, only: wp
      use MW_ion, only: MW_ion_t
      implicit none
      type(MW_molecule_t), intent(in) :: this  ! structure to be printed
      integer, intent(in)             :: ounit ! output unit
      type(MW_ion_t), intent(in) :: ions(:)
      integer, intent(in) :: offset_ions(:)
      real(wp), intent(in) :: xyz_ions(:,:)
      real(wp), intent(in) :: velocity_ions(:,:)

      integer :: imol, isite, itype,iion

      do imol = 1, this%n
         do isite = 1, this%num_sites
            itype = this%sites(isite)
            iion = offset_ions(itype) + imol
            write(ounit,'("(",i5,")",a8,6(1x,es23.15))') imol, ions(itype)%name, &
                  xyz_ions(iion,1), xyz_ions(iion,2), xyz_ions(iion,3), &
                  velocity_ions(iion,1), velocity_ions(iion,2), velocity_ions(iion,3)
         end do
      end do
   end subroutine print_trajectories

   ! ================================================================================
   !> Set the index of the molecule
   subroutine set_index(this, index)
      implicit none
      type(MW_molecule_t), intent(inout) :: this
      integer, intent(in) :: index
      this%index = index
   end subroutine set_index

   ! ================================================================================
   !> Set the species type index for the molecule
   !!
   !! Map the molecule to the site species index
   !! Map the site species to the molecule
   !! Set molecule count from site species count
   subroutine set_sites_index(this, species)
      use MW_species, only: MW_species_t, &
            MW_species_identify => identify, &
            MW_species_set_molecule => set_molecule
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_molecule_t), intent(inout) :: this
      type(MW_species_t),  intent(inout) :: species(:) !< array of species

      ! Local
      ! -----
      integer :: isite
      integer :: species_index
      character(256) :: errmsg

      do isite = 1, this%num_sites
         call MW_species_identify(this%site_names(isite), species, species_index)
         if (species_index > 0) then
            this%sites(isite) = species_index
            call MW_species_set_molecule(species(species_index), this%name, this%index)
            if (this%n /= species(species_index)%count) then
               write(errmsg,'("In molecule ",a8," invalid count for species,",a8,", got ",'//&
                     'i5," expected ", i5)') this%name, this%site_names(isite), &
                     species(species_index)%count, this%n
               call MW_errors_runtime_error("set_species","electrode_parameters.f90", &
                     errmsg)
            end if
         else
            write(errmsg,'("Unknown species name,",a8,", for molecule ",a8)') &
                  this%site_names(isite), this%name
            call MW_errors_runtime_error("set_species","electrode_parameters.f90", &
                  errmsg)
         end if
      end do
   end subroutine set_sites_index

   ! ================================================================================
   ! Read molecule type parameters
   !
   !   molecule_type *block*
   !     name *string*
   !     count *int*
   !     sites *string* [*string* ...]
   !
   !     constraint *string* *string* *real*
   !     [constraint *string* *string* *real*
   !         ...]
   !     [constraints_algorithm *string* *parameters depend on algorithm name*]
   !
   !     harmonic_bond *string* *string* *real* *real*
   subroutine read_parameters(this, funit, line_num)
      use MW_configuration_line, only: MW_configuration_line_t, &
            MW_configuration_line_seek_next_data => seek_next_data, &
            MW_configuration_line_get_word => get_word, &
            max_word_length
      use MW_kinds, only: wp, PARTICLE_NAME_LEN
      use MW_errors, only: MW_errors_runtime_error => runtime_error, &
            MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_molecule_t), intent(inout) :: this
      integer, intent(in) :: funit
      integer, intent(inout) :: line_num

      ! Local
      ! -----
      integer :: ierr
      character(256) :: errmsg
      type(MW_configuration_line_t) :: config_line
      character(max_word_length) :: keyword
      character(len=PARTICLE_NAME_LEN) :: name
      integer :: count
      integer :: num_sites, num_constraints, num_harmonic_bonds, num_harmonic_angles,&
            num_dihedrals, num_impropers, num_born_repulsions, num_internal_coulomb
      character(len=PARTICLE_NAME_LEN), allocatable :: site_names(:)
      character(len=PARTICLE_NAME_LEN) :: siteA, siteB, siteC, siteD
      integer :: name_defined, count_defined, sites_defined, constraints_defined, &
            algorithm_defined, harmonic_bonds_defined, harmonic_angles_defined, &
            dihedrals_defined, impropers_defined, born_repulsions_defined, &
            internal_coulomb_defined, fourth_site_defined
      character(max_word_length) :: algorithm
      integer :: max_iteration
      real(wp) :: tolerance
      integer :: isiteA, isiteB, isiteC,isiteD, iconstraint, ibond, iangle, isite, idihedral,&
            iimproper, iborn, iintcoul
      real(wp) :: dr, strength, length, v1, v2, v3, v4, fourth_distance
      integer :: last_line
      integer :: basis_siteA, basis_siteB
      logical :: fourth_site

      ! Void data structure
      call void_type(this)

      ! Set default values
      name = "****"
      count = 0
      num_sites = 0
      num_constraints = 0
      num_harmonic_bonds = 0
      num_harmonic_angles = 0
      num_born_repulsions = 0
      num_internal_coulomb = 0
      num_dihedrals = 0
      num_impropers = 0
      algorithm = "rattle"
      max_iteration = 100
      tolerance = 1.0e-6_wp
      fourth_site = .false.
      fourth_distance = 0.0_wp

      ! Flag each section as undefined (line number will be stored)
      name_defined = 0
      count_defined = 0
      sites_defined = 0
      constraints_defined = 0
      algorithm_defined = 0
      harmonic_bonds_defined = 0
      harmonic_angles_defined = 0
      born_repulsions_defined = 0
      internal_coulomb_defined = 0
      dihedrals_defined = 0
      impropers_defined = 0
      fourth_site_defined = 0

      call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      keywordLoop: do while(config_line%num_words > 0)

         ! Look for keyword and read corresponding value
         call MW_configuration_line_get_word(config_line, 1, keyword)

         select case(keyword)

         case("name")
            if (name_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |name|. First definition at line ",i4,".")') &
                     line_num, name_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            name_defined = line_num

            ! Read name parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for name parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, name)

         case("count")
            if (count_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |count|. First definition at line ",i4,".")') &
                     line_num, count_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            count_defined = line_num

            ! Read count parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for count parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, count)

         case("sites")
            if (sites_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |sites|. First definition at line ",i4,".")') &
                     line_num, sites_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            sites_defined = line_num

            ! Read sites parameters
            num_sites = config_line%num_words - 1
            allocate(site_names(num_sites), stat=ierr)
            if (ierr /= 0) then
               call MW_errors_allocate_error("read_molecule_type_parameters", "configuration.f90", ierr)
            end if
            do isite = 1, num_sites
               call MW_configuration_line_get_word(config_line, isite+1, site_names(isite))
            end do

         case("fourth_site")
            if (fourth_site_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |fourth_site|. First definition at line ",i4,".")') &
                     line_num, fourth_site_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            fourth_site_defined = line_num

            ! Read fourth_site parameters
            if (config_line%num_words /= 2) then
               write(errmsg,'("Invalid format for fourth_site parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            fourth_site = .true.
            call MW_configuration_line_get_word(config_line, 2, fourth_distance)

         case("constraint")
            if (constraints_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |constraints|. First definition at line ",i4,".")') &
                     line_num, constraints_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            constraints_defined = line_num

            num_constraints = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "constraint")
               num_constraints = num_constraints + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "constraint"
            backspace(funit)
            line_num = line_num - 1

         case("constraints_algorithm")
            if (algorithm_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |constraints_algorithm|. First definition at line ",i4,".")') &
                     line_num, algorithm_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            algorithm_defined = line_num

            ! Read name parameters
            if (config_line%num_words < 2) then
               write(errmsg,'("Invalid format for algorithm parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            call MW_configuration_line_get_word(config_line, 2, algorithm)

            select case (algorithm)
            case ("rattle")
               if (config_line%num_words /= 4) then
                  write(errmsg,'("Invalid format for algotithm parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                        errmsg)
               end if
               call MW_configuration_line_get_word(config_line, 3, tolerance)
               call MW_configuration_line_get_word(config_line, 4, max_iteration)
            case("linear")
               if (config_line%num_words /= 4) then
                  write(errmsg,'("Invalid format for algotithm parameters at line ",i4)') line_num
                  call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                        errmsg)
               end if
               call MW_configuration_line_get_word(config_line, 3, siteA)
               basis_siteA = 0
               do isite = 1, num_sites
                  if (siteA == site_names(isite)) then
                     basis_siteA = isite
                     exit
                  end if
               end do
               if (basis_siteA == 0) then
                  write(errmsg,'("Invalid site ",a," in linear basis specification for molecule parameters at line ",i4)') &
                        siteA, line_num
                  call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                        errmsg)
               end if

               call MW_configuration_line_get_word(config_line, 4, siteB)
               basis_siteB = 0
               do isite = 1, num_sites
                  if (siteB == site_names(isite)) then
                     basis_siteB = isite
                     exit
                  end if
               end do
               if (basis_siteB == 0) then
                  write(errmsg,'("Invalid site ",a," in linear basis specification for molecule parameters at line ",i4)') &
                        siteB, line_num
                  call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                        errmsg)
               end if

            case default
               write(errmsg,'("Invalid algorithm keyword at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end select

         case("harmonic_bond")
            if (harmonic_bonds_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |harmonic_bond|. First definition at line ",i4,".")') &
                     line_num, harmonic_bonds_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            harmonic_bonds_defined = line_num

            num_harmonic_bonds = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "harmonic_bond")
               num_harmonic_bonds = num_harmonic_bonds + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "constraint"
            backspace(funit)
            line_num = line_num - 1

         case("harmonic_angle")
            if (harmonic_angles_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |harmonic_angle|. First definition at line ",i4,".")') &
                     line_num, harmonic_angles_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            harmonic_angles_defined = line_num

            num_harmonic_angles = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "harmonic_angle")
               num_harmonic_angles = num_harmonic_angles + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "constraint"
            backspace(funit)
            line_num = line_num - 1

         case("born_repulsion")
            if (born_repulsions_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |born_repulsion|. First definition at line ",i4,".")') &
                     line_num, born_repulsions_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            born_repulsions_defined = line_num

            num_born_repulsions = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "born_repulsion")
               num_born_repulsions = num_born_repulsions + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "born_repulsion"
            backspace(funit)
            line_num = line_num - 1

         case("internal_coulomb")
            if (internal_coulomb_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |internal_coulomb|. First definition at line ",i4,".")') &
                     line_num, internal_coulomb_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            internal_coulomb_defined = line_num

            num_internal_coulomb = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "internal_coulomb")
               num_internal_coulomb = num_internal_coulomb + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "internal_coulomb"
            backspace(funit)
            line_num = line_num - 1

         case("dihedral")
            if (dihedrals_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |dihedrals|. First definition at line ",i4,".")') &
                     line_num, dihedrals_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            dihedrals_defined = line_num

            num_dihedrals = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "dihedral")
               num_dihedrals = num_dihedrals + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "constraint"
            backspace(funit)
            line_num = line_num - 1

         case("improper")
            if (impropers_defined > 0) then
               write(errmsg,'("At line ",i4,", redefinition of |impropers|. First definition at line ",i4,".")') &
                     line_num, impropers_defined
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", errmsg)
            end if
            impropers_defined = line_num

            num_impropers = 1
            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            do while (keyword == "improper")
               num_impropers = num_impropers + 1
               call MW_configuration_line_seek_next_data(config_line, funit, line_num)
               call MW_configuration_line_get_word(config_line, 1, keyword)
            end do
            ! backspace just before 1st keyword which is not "constraint"
            backspace(funit)
            line_num = line_num - 1

         case default
            ! Keyword not expected in molecule section assume end of box section
            ! Backspace to previous line and give hand back to parent box
            backspace(funit)
            line_num = line_num - 1
            exit keywordLoop

         end select

         call MW_configuration_line_seek_next_data(config_line, funit, line_num)
      end do keywordLoop
      last_line = line_num

      ! Define data structure
      call define_type(this, name, count, num_sites, num_constraints, &
            num_harmonic_bonds, num_harmonic_angles, num_dihedrals, num_impropers, &
            num_born_repulsions, num_internal_coulomb, fourth_site, fourth_distance)

      ! Setup sites
      do isite = 1, num_sites
         this%site_names(isite) = site_names(isite)
      end do

      if (num_constraints > 0) then

         ! Backspace to 1st constraint
         do while (line_num >= constraints_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of constraints section.")
            end if
            line_num = line_num-1
         end do
      
         ! Read constraints
         do iconstraint = 1, num_constraints

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "constraint") then
               write(errmsg,'("Expected |constraint| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 4) then
               write(errmsg,'("Invalid constraint specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site in constraint
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%constrained_sites(1,iconstraint) = isite
                  exit
               end if
            end do
            if (this%constrained_sites(1,iconstraint) == 0) then
               write(errmsg,'("Invalid site ",a," in constraint specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site in constraint
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%constrained_sites(2,iconstraint) = isite
                  exit
               end if
            end do
            if (this%constrained_sites(2,iconstraint) == 0) then
               write(errmsg,'("Unknown ion type ",a," in constraint specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 4, dr)
            this%constrained_dr(iconstraint) = dr

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%constrained_sites(1,iconstraint)
            isiteB = this%constrained_sites(2,iconstraint)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_harmonic_bonds > 0) then
         ! Backspace to 1st harmonic bond definition
         do while (line_num >= harmonic_bonds_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of harmonic bonds section.")
            end if
            line_num = line_num-1
         end do

         ! Read bonds
         do ibond = 1, num_harmonic_bonds

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "harmonic_bond") then
               write(errmsg,'("Expected |harmonic_bond| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 5) then
               write(errmsg,'("Invalid harmonic bond specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site in constraint
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%harmonic_bonds_sites(1,ibond) = isite
                  exit
               end if
            end do
            if (this%harmonic_bonds_sites(1,ibond) == 0) then
               write(errmsg,'("Invalid site ",a," in harmonic bond specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site in constraint
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%harmonic_bonds_sites(2,ibond) = isite
                  exit
               end if
            end do
            if (this%harmonic_bonds_sites(2,ibond) == 0) then
               write(errmsg,'("Unknown ion type ",a," in harmonic bond specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 4, strength)
            this%harmonic_bonds_strength(ibond) = strength

            call MW_configuration_line_get_word(config_line, 5, length)
            this%harmonic_bonds_length(ibond) = length

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%harmonic_bonds_sites(1,ibond)
            isiteB = this%harmonic_bonds_sites(2,ibond)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_harmonic_angles > 0) then
         ! Backspace to 1st harmonic bond definition
         do while (line_num >= harmonic_angles_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of harmonic angles section.")
            end if
            line_num = line_num-1
         end do

         ! Read constraints
         do iangle = 1, num_harmonic_angles

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "harmonic_angle") then
               write(errmsg,'("Expected |harmonic_angle| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 6) then
               write(errmsg,'("Invalid harmonic angle specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site in constraint
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%harmonic_angles_sites(1,iangle) = isite
                  exit
               end if
            end do
            if (this%harmonic_angles_sites(1,iangle) == 0) then
               write(errmsg,'("Invalid site ",a," in harmonic angle specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site in constraint
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%harmonic_angles_sites(2,iangle) = isite
                  exit
               end if
            end do
            if (this%harmonic_angles_sites(2,iangle) == 0) then
               write(errmsg,'("Unknown ion type ",a," in harmonic angle specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 3rd site in constraint
            call MW_configuration_line_get_word(config_line, 4, siteC)
            do isite = 1, num_sites
               if (siteC == site_names(isite)) then
                  this%harmonic_angles_sites(3,iangle) = isite
                  exit
               end if
            end do
            if (this%harmonic_angles_sites(3,iangle) == 0) then
               write(errmsg,'("Unknown ion type ",a," in harmonic angle specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 5, strength)
            this%harmonic_angles_strength(iangle) = strength

            call MW_configuration_line_get_word(config_line, 6, length)
            this%harmonic_angles_angle(iangle) = length

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%harmonic_angles_sites(1,iangle)
            isiteB = this%harmonic_angles_sites(2,iangle)
            isitec = this%harmonic_angles_sites(3,iangle)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.
            this%interacting_pairs(isiteA,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteA) = .false.
            this%interacting_pairs(isiteB,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteB) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_dihedrals > 0) then
         ! Backspace to 1st dihedral definition
         do while (line_num >= dihedrals_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of dihedrals section.")
            end if
            line_num = line_num-1
         end do
         do idihedral = 1, num_dihedrals

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "dihedral") then
               write(errmsg,'("Expected |dihedral| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 9) then
               write(errmsg,'("Invalid dihedral specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site in constraint
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%dihedrals_sites(1,idihedral) = isite
                  exit
               end if
            end do
            if (this%dihedrals_sites(1,idihedral) == 0) then
               write(errmsg,'("Invalid site ",a," in dihedral specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site in constraint
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%dihedrals_sites(2,idihedral) = isite
                  exit
               end if
            end do
            if (this%dihedrals_sites(2,idihedral) == 0) then
               write(errmsg,'("Invalid site ",a," in dihedral specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 3rd site in constraint
            call MW_configuration_line_get_word(config_line, 4, siteC)
            do isite = 1, num_sites
               if (siteC == site_names(isite)) then
                  this%dihedrals_sites(3,idihedral) = isite
                  exit
               end if
            end do
            if (this%dihedrals_sites(3,idihedral) == 0) then
               write(errmsg,'("Invalid site ",a," in dihedral specification for molecule parameters at line ",i4)') &
                     siteC, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 4th site in constraint
            call MW_configuration_line_get_word(config_line, 5, siteD)
            do isite = 1, num_sites
               if (siteD == site_names(isite)) then
                  this%dihedrals_sites(4,idihedral) = isite
                  exit
               end if
            end do
            if (this%dihedrals_sites(4,idihedral) == 0) then
               write(errmsg,'("Invalid site ",a," in dihedral specification for molecule parameters at line ",i4)') &
                     siteD, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 6, v1)
            this%dihedrals_v1(idihedral) = v1

            call MW_configuration_line_get_word(config_line, 7, v2)
            this%dihedrals_v2(idihedral) = v2

            call MW_configuration_line_get_word(config_line, 8, v3)
            this%dihedrals_v3(idihedral) = v3

            call MW_configuration_line_get_word(config_line, 9, v4)
            this%dihedrals_v4(idihedral) = v4

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%dihedrals_sites(1,idihedral)
            isiteB = this%dihedrals_sites(2,idihedral)
            isiteC = this%dihedrals_sites(3,idihedral)
            isiteD = this%dihedrals_sites(4,idihedral)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.
            this%interacting_pairs(isiteA,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteA) = .false.
            if(this%interacting_pairs(isiteA,isiteD))this%halfinteracting_pairs(isiteA,isiteD) = .true.
            if(this%interacting_pairs(isiteD,isiteA))this%halfinteracting_pairs(isiteD,isiteA) = .true.
            this%interacting_pairs(isiteB,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteD) = .false.
            this%interacting_pairs(isiteD,isiteB) = .false.
            this%interacting_pairs(isiteC,isiteD) = .false.
            this%interacting_pairs(isiteD,isiteC) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_impropers > 0) then
         ! Backspace to 1st improper definition
         do while (line_num >= impropers_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of impropers section.")
            end if
            line_num = line_num-1
         end do

         ! Read constraints
         do iimproper = 1, num_impropers

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "improper") then
               write(errmsg,'("Expected |improper| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 9) then
               write(errmsg,'("Invalid improper specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site in constraint
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%impropers_sites(1,iimproper) = isite
                  exit
               end if
            end do
            if (this%impropers_sites(1,iimproper) == 0) then
               write(errmsg,'("Invalid site ",a," in improper specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site in constraint
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%impropers_sites(2,iimproper) = isite
                  exit
               end if
            end do
            if (this%impropers_sites(2,iimproper) == 0) then
               write(errmsg,'("Invalid site ",a," in improper specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 3rd site in constraint
            call MW_configuration_line_get_word(config_line, 4, siteC)
            do isite = 1, num_sites
               if (siteC == site_names(isite)) then
                  this%impropers_sites(3,iimproper) = isite
                  exit
               end if
            end do
            if (this%impropers_sites(3,iimproper) == 0) then
               write(errmsg,'("Invalid site ",a," in improper specification for molecule parameters at line ",i4)') &
                     siteC, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 4th site in constraint
            call MW_configuration_line_get_word(config_line, 5, siteD)
            do isite = 1, num_sites
               if (siteD == site_names(isite)) then
                  this%impropers_sites(4,iimproper) = isite
                  exit
               end if
            end do
            if (this%impropers_sites(4,iimproper) == 0) then
               write(errmsg,'("Invalid site ",a," in improper specification for molecule parameters at line ",i4)') &
                     siteD, line_num
               call MW_errors_runtime_error("read_molecules_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 6, v1)
            this%impropers_v1(iimproper) = v1

            call MW_configuration_line_get_word(config_line, 7, v2)
            this%impropers_v2(iimproper) = v2

            call MW_configuration_line_get_word(config_line, 8, v3)
            this%impropers_v3(iimproper) = v3

            call MW_configuration_line_get_word(config_line, 9, v4)
            this%impropers_v4(iimproper) = v4

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%impropers_sites(1,iimproper)
            isiteB = this%impropers_sites(2,iimproper)
            isiteC = this%impropers_sites(3,iimproper)
            isiteD = this%impropers_sites(4,iimproper)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.
            this%interacting_pairs(isiteA,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteA) = .false.
            this%interacting_pairs(isiteA,isiteD) = .false.
            this%interacting_pairs(isiteD,isiteA) = .false.
            this%interacting_pairs(isiteB,isiteC) = .false.
            this%interacting_pairs(isiteC,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteD) = .false.
            this%interacting_pairs(isiteD,isiteB) = .false.
            this%interacting_pairs(isiteC,isiteD) = .false.
            this%interacting_pairs(isiteD,isiteC) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_born_repulsions > 0) then
         ! Backspace to 1st harmonic bond definition
         do while (line_num >= born_repulsions_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of born repulsions section.")
            end if
            line_num = line_num-1
         end do

         ! Read constraints
         do iborn = 1, num_born_repulsions

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "born_repulsion") then
               write(errmsg,'("Expected |born_repulsion| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 5) then
               write(errmsg,'("Invalid born repulsion specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 1st site
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%born_repulsions_sites(1, iborn) = isite
                  exit
               end if
            end do

            if (this%born_repulsions_sites(1,iborn) == 0) then
               write(errmsg,'("Invalid site ",a," in born_repulsion specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%born_repulsions_sites(2,iborn) = isite
                  exit
               end if
            end do
            if (this%born_repulsions_sites(2,iborn) == 0) then
               write(errmsg,'("Unknown ion type ",a," in born repulsion specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify constrained distance
            call MW_configuration_line_get_word(config_line, 4, strength)
            this%born_repulsions_energy(iborn) = strength

            call MW_configuration_line_get_word(config_line, 5, length)
            this%born_repulsions_eta(iborn) = length

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%born_repulsions_sites(1,iborn)
            isiteB = this%born_repulsions_sites(2,iborn)
            this%interacting_pairs(isiteA,isiteB) = .false.
            this%interacting_pairs(isiteB,isiteA) = .false.

         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      if (num_internal_coulomb > 0) then
         ! Backspace to 1st harmonic bond definition
         do while (line_num >= internal_coulomb_defined)
            backspace(funit, iostat=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("read_molecule_type_parameters", "configuration.f90", &
                     "An error while backspace back to beginning of internal coulomb section.")
            end if
            line_num = line_num-1
         end do

         ! Read constraints
         do iintcoul = 1, num_internal_coulomb

            call MW_configuration_line_seek_next_data(config_line, funit, line_num)
            call MW_configuration_line_get_word(config_line, 1, keyword)
            if (keyword /= "internal_coulomb") then
               write(errmsg,'("Expected |internal_coulomb| keyword for molecule parameters at line ",i4)') line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if
            if (config_line%num_words /= 3) then
               write(errmsg,'("Invalid internal coulomb specification for molecule parameters at line ",i4)') &
                     line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if


            ! Identify 1st site
            call MW_configuration_line_get_word(config_line, 2, siteA)
            do isite = 1, num_sites
               if (siteA == site_names(isite)) then
                  this%internal_coulomb_sites(1,iintcoul) = isite
                  exit
               end if
            end do
            if (this%internal_coulomb_sites(1,iintcoul) == 0) then
               write(errmsg,'("Invalid site ",a," in internal coulomb specification for molecule parameters at line ",i4)') &
                     siteA, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Identify 2nd site
            call MW_configuration_line_get_word(config_line, 3, siteB)
            do isite = 1, num_sites
               if (siteB == site_names(isite)) then
                  this%internal_coulomb_sites(2,iintcoul) = isite
                  exit
               end if
            end do
            if (this%internal_coulomb_sites(2,iintcoul) == 0) then
               write(errmsg,'("Unknown ion type ",a," in internal coulomb specification for molecule parameters at line ",i4)') &
                     siteB, line_num
               call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
                     errmsg)
            end if

            ! Pairs involved in a constraint do not interact via short range potentials
            isiteA = this%internal_coulomb_sites(1,iintcoul)
            isiteB = this%internal_coulomb_sites(2,iintcoul)
            this%internal_coulomb_pairs(isiteA,isiteB) = .true.
            this%internal_coulomb_pairs(isiteB,isiteA) = .true.
         end do

         ! Go back to end of molecule type definition
         do while (line_num < last_line)
            read(funit, *)
            line_num = line_num+1
         end do
      end if

      ! Define algorithm parameters
      select case (algorithm)
      case("rattle")
         call set_rattle_parameters(this, tolerance, max_iteration)
      case("linear")
         call set_linear_parameters(this, basis_siteA, basis_siteB)
      case default
         write(errmsg,'("Unknown constraint algorithm ",a," at line ",i4)') &
               algorithm, algorithm_defined
         call MW_errors_runtime_error("read_molecule_type_parameters","configuration.f90", &
               errmsg)
      end select

      if (allocated(site_names)) deallocate(site_names)

   end subroutine read_parameters

end module MW_molecule

! Rattle
! ------
!
! Rattle: A "Velocity" Version of the Shake Algorithm for Molecular Dynamics Calculation
! Hans C. Andersen
! Journal of Computationanl Physics 52, 24-34, (1983)
!
! RATTLE is an algorithm for integrating the equations of motion in
! molecular dynamics calculations for molecular models with internal
! constraints. RATTLE calculates the positions and velocities at the
! next time step from the positions and celocities at the present time
! step, without requiring information about earlier history. It is
! based on the Verlet algorithm and retains the simplicity of using
! Cartesian coordinates for each of the atoms to describe the
! configuration of a molecule with internal constraints.
!
! Algorithm
!
! r(t+h) = r(t) + h*v(t) + h^2 * [ F(r(t)) + g_rr(t) ] / 2
! v(t+h) = v(t) + h* [ F(r(t)) + g_rr(t) + F(r(t+h)) + g_rv(t) ] / 2
!
! where g_rr and g_rv represent two separate approximations for the
! forces associated with the constraints such that both the positions
! and the velocities satisfy the constraints.
module MW_rattle
   use MW_timers
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t, &
         MW_box_fix_outliers => fix_outliers
   use MW_ion, only: MW_ion_t
   use MW_molecule, only: MW_molecule_t
   implicit none
   private


   ! Public type
   ! -----------
   public :: MW_rattle_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type
   public :: constrain_positions
   public :: constrain_velocities

   type MW_rattle_t
      integer :: max_iterations !< maximum iteration in rattle
      real(wp) :: tolerance     !< tolerance on constraints

      ! statistics
      integer :: max_positions_iterations_count = 0
      integer :: max_velocities_iterations_count = 0
   end type MW_rattle_t

contains

   ! ========================================================================
   ! Define the data structure
   subroutine define_type(this, max_iterations, tolerance)
      implicit none
      ! Passed in
      ! ---------
      type(MW_rattle_t), intent(inout) :: this
      integer, intent(in) :: max_iterations
      real(wp) ,intent(in) :: tolerance

      this%max_iterations = max_iterations
      this%tolerance = tolerance

      this%max_positions_iterations_count = 0
      this%max_velocities_iterations_count = 0

   end subroutine define_type

   ! ========================================================================
   ! Void the data structure
   subroutine void_type(this)
      implicit none
      ! Passed in
      ! ---------
      type(MW_rattle_t), intent(inout) :: this

      this%max_iterations = 0
      this%tolerance = 0

      this%max_positions_iterations_count = 0
      this%max_velocities_iterations_count = 0

   end subroutine void_type

   ! ===========================================================================
   ! Print info about the data structure
   subroutine print_type(this, ounit)
      implicit none
      type(MW_rattle_t), intent(in) :: this
      integer, intent(in) :: ounit

      write(ounit, '("|rattle| maximum number of iterations:         ", i12)') this%max_iterations
      write(ounit, '("|rattle| tolerance on constraints realisation: ", es12.5)') this%tolerance
   end subroutine print_type

   ! ===========================================================================
   ! Rattle algorithm part 1 - Update positions
   subroutine constrain_positions(num_pbc, molecule, dt, box, ions, &
         xyz_now, xyz_next, velocity_next,stress_tensor)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in) :: num_pbc
      type(MW_molecule_t), intent(in) :: molecule
      real(wp), intent(in) :: dt ! time step
      type(MW_box_t), intent(in) :: box ! simulation box
      type(MW_ion_t), intent(in)      :: ions(:)

      real(wp), intent(in) :: xyz_now(:,:)       ! coordinates at t

      ! Passed in/out
      ! -------------
      real(wp), intent(inout) :: xyz_next(:,:) !< coodinates at t+dt
      real(wp), intent(inout) :: velocity_next(:,:) !< velocities at t+dt
      real(wp), intent(inout) :: stress_tensor(:,:) ! contribution of constraint force to stress


      select case(num_pbc)
      case(2)
         call constrain_positions_2DPBC(molecule, dt, box, ions, &
         xyz_now, xyz_next, velocity_next,stress_tensor)
      case(3)
         call constrain_positions_3DPBC(molecule, dt, box, ions, &
         xyz_now, xyz_next, velocity_next,stress_tensor)
      end select

   end subroutine constrain_positions

   ! ===========================================================================
   ! Rattle algorithm part 2 - Update velocities
   subroutine constrain_velocities(num_pbc, molecule, box, ions, &
         xyz_next, velocity_next)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in) :: num_pbc
      type(MW_box_t), intent(in) :: box

      type(MW_molecule_t), intent(in) :: molecule
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(in) :: xyz_next(:,:) ! coordinates at t + dt

      ! Passed out
      ! ----------
      real(wp), intent(inout) :: velocity_next(:,:)   ! coordinates at t+dt

      select case(num_pbc)
      case(2)
         call constrain_velocities_2DPBC(molecule, box, ions, &
         xyz_next, velocity_next)
      case(3)
         call constrain_velocities_3DPBC(molecule, box, ions, &
         xyz_next, velocity_next)
      end select

   end subroutine constrain_velocities

   ! ================================================================================
   include 'rattle_2DPBC.inc'
   include 'rattle_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'

end module MW_rattle

! Defines the simulation box which is the unit cell of the system
!
! A box is orthorombic and is defined by its 3 lengths
! The box defined in this module has 2D periodic boundary conditions in x and y
module MW_box
   use MW_kinds, only: wp
   implicit none
   private

   ! public types
   public :: MW_box_t

   ! public subroutine
   public :: define_type
   public :: void_type
   public :: print_type
   public :: update_type
   public :: minimum_image_distance_2DPBC
   public :: minimum_image_distance_3DPBC
   public :: minimum_image_displacement_2DPBC
   public :: minimum_image_displacement_3DPBC
   public :: fix_outliers
   public :: unwrap
   !   public :: minimum_image_displacement_int
   !   public :: minimum_image_distance_int

   ! Box datatype
   type MW_box_t
      real(wp) :: length(3)      !< length of each side of the box
      real(wp) :: volume         !< volume of the box
      real(wp) :: area(3)        !< (|bxc|,|cxa|,|axb|)
      real(wp) :: height(3)      !< Perpendicular width
   end type MW_box_t

contains

   !================================================================================
   !> Define a box from 3 lengths
   !
   subroutine define_type(this, a, b, c)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(inout) :: this

      real(wp), intent(in) :: a !> 1st dimension vector length
      real(wp), intent(in) :: b !> 2nd dimension vector length
      real(wp), intent(in) :: c !> 3rd dimension vector length

      ! Lengths (must be non-zero)
      ! --------------------------
      this%length(1) = a
      if (this%length(1) <= 0.0) then
         call MW_errors_parameter_error("define_type", "box.f90",&
               "length(a)", this%length(1))
      end if

      this%length(2) = b
      if (this%length(2) <= 0.0) then
         call MW_errors_parameter_error("define_type", "box.f90",&
               "length(b)", this%length(2))
      end if

      this%length(3) = c
      if (this%length(3) <= 0.0) then
         call MW_errors_parameter_error("define_type", "box.f90",&
               "length(c)", this%length(3))
      end if

      ! Volume (must be > 0)
      ! ------
      ! V = |a|x|b|x|c|
      this%volume = this%length(1) * this%length(2) * this%length(3)
      ! The 3 vectors may not be coplanar and must be properly oriented
      if (this%volume <= 0.0) then
         call MW_errors_parameter_error("define_type", "box.f90",&
               "volume", this%volume)
      end if

      ! Areas (must be > 0)
      ! -------------------
      ! A(b,c) = | b x c |
      this%area(1) = this%length(2) * this%length(3)

      ! A(c,a) = | c x a |
      this%area(2) = this%length(3) * this%length(1)

      ! A(a,b) = | a x b |
      this%area(3) = this%length(1) * this%length(2)

      ! Perpendicular widths
      ! --------------------
      this%height(1) = this%length(1)
      this%height(2) = this%length(2)
      this%height(3) = this%length(3)

   end subroutine define_type

   !================================================================================
   !> Void the data structure
   subroutine void_type(this)
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(inout) :: this

      this%length(:)     = 0.0_wp
      this%volume        = 0.0_wp
      this%area(:)       = 0.0_wp
      this%height(:)     = 0.0_wp
   end subroutine void_type

   !================================================================================
   !> Print the data structure
   subroutine print_type(this, ounit)
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(in) :: this
      integer,        intent(in) :: ounit

      write(ounit, '("|box| edge length :       ",3(1x,es12.5))') this%length
      write(ounit, '("|box| side area:          ",3(1x,es12.5))') this%area
      write(ounit, '("|box| side height:        ",3(1x,es12.5))') this%height
      write(ounit, '("|box| volume:             ",1(1x,es12.5))') this%volume

   end subroutine print_type

   !================================================================================
   !> update box parameters during NPT runs
   !
   subroutine update_type(this, volume_factor)
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(inout) :: this

      real(wp), intent(in) :: volume_factor   !> Variation of the volume during the step


      ! Local
      real(wp) :: length_factor

      length_factor = volume_factor**(1.0/3.0)

      this%length(1) = this%length(1) * length_factor
      this%length(2) = this%length(2) * length_factor
      this%length(3) = this%length(3) * length_factor

      ! Areas (must be > 0)
      ! -------------------
      ! A(b,c) = | b x c |
      this%area(1) = this%length(2) * this%length(3)

      ! A(c,a) = | c x a |
      this%area(2) = this%length(3) * this%length(1)

      ! A(a,b) = | a x b |
      this%area(3) = this%length(1) * this%length(2)

      ! Perpendicular widths
      ! --------------------
      this%height(1) = this%length(1)
      this%height(2) = this%length(2)
      this%height(3) = this%length(3)

   end subroutine update_type
   

   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_displacement_2DPBC.inc'
   !================================================================================
   include 'minimum_image_distance_3DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'

   !================================================================================
   !> Make sure xyz coordinates are inside the box, update xyz if necessary
   !!
   !! 0 <= x < box%length(1)
   !! 0 <= y < box%length(2)
   !! 0 <= z < box%length(3)
   pure subroutine fix_outliers(this, numPBC, x, y, z)
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(in) :: this    !< structure
      integer, intent(in) :: numPBC         !< Number of periodic boundary conditions
      real(wp), intent(inout) :: x, y, z      !< xyz atom position

      select case (numPBC)
      case (1)
         x = x - this%length(1)*floor(x/this%length(1))
      case (2)
         x = x - this%length(1)*floor(x/this%length(1))
         y = y - this%length(2)*floor(y/this%length(2))
      case (3)
         x = x - this%length(1)*floor(x/this%length(1))
         y = y - this%length(2)*floor(y/this%length(2))
         z = z - this%length(3)*floor(z/this%length(3))
      case default
         continue
      end select

   end subroutine fix_outliers

   !================================================================================
   !> Unwrap xyz coordinates of a mobile ion.
   !!
   !! Implements Eq. (3) in J. Chem. Phys. 153, 021101 (2020); https://doi.org/10.1063/5.0008316
   !! The equations below are suitable for both NVT and NPT simulations:
   !! 
   !! xu(t) = xw(t) - floor([xw(t) - xu(t-1)]/Lx(t) + 0.5)*Lx(t)
   !! yu(t) = yw(t) - floor([yw(t) - yu(t-1)]/Ly(t) + 0.5)*Ly(t)
   !! zu(t) = zw(t) - floor([zw(t) - zu(t-1)]/Lz(t) + 0.5)*Lz(t)
   pure subroutine unwrap(this, numPBC, &
                          xu, yu, zu, xu_prev, yu_prev, zu_prev, xw, yw, zw)
      implicit none
      ! Parameters
      ! ----------
      type(MW_box_t), intent(in) :: this    !< structure
      integer, intent(in) :: numPBC         !< Number of periodic boundary conditions
      real(wp), intent(inout) :: xu, yu, zu !< unwrapped xyz ion position at the current time step
      real(wp), intent(in) :: xu_prev, yu_prev, zu_prev !< unwrapped xyz ion position at the previous time step
      real(wp), intent(in) :: xw, yw, zw !< wrapped xyz ion position at the current time step

      select case (numPBC)
      case (1)
         xu = xw - this%length(1)*floor((xw - xu_prev)/this%length(1) + 0.5_wp)
      case (2)
         xu = xw - this%length(1)*floor((xw - xu_prev)/this%length(1) + 0.5_wp)
         yu = yw - this%length(2)*floor((yw - yu_prev)/this%length(2) + 0.5_wp)
      case (3)
         xu = xw - this%length(1)*floor((xw - xu_prev)/this%length(1) + 0.5_wp)
         yu = yw - this%length(2)*floor((yw - yu_prev)/this%length(2) + 0.5_wp)
         zu = zw - this%length(3)*floor((zw - zu_prev)/this%length(3) + 0.5_wp)
      case default
         continue
      end select

   end subroutine unwrap

end module MW_box

module MW_species_parameters
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   private

   integer, parameter, public :: SPECIES_NAME_LENGTH = PARTICLE_NAME_LEN !< maximum name length for a species type
   ! Species charge type
   ! -------------------
   integer, parameter, public :: CHARGE_TYPE_NEUTRAL = 0   !< neutral species
   integer, parameter, public :: CHARGE_TYPE_POINT = 1     !< species with a point-charge distribution
   integer, parameter, public :: CHARGE_TYPE_GAUSSIAN = 2  !< species with a gaussian-charge distribution
end module MW_species_parameters

! Module defines CG type to store CG algorithm parameters
module MW_cg
   use MW_kinds, only: wp, sp
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_cg_t

   ! Public subroutines
   ! ------------------
   public :: set_max_iterations
   public :: set_tolerance
   public :: set_charge_neutrality
   public :: set_preconditioner
   public :: reset_statistics
   public :: allocate_arrays
   public :: void_type
   public :: print_type
   public :: print_statistics
   public :: solve
   public :: solve_preconditioned

   type MW_cg_t

      ! Convergence parameters
      integer :: max_iterations !< maximum number of iterations
      real(wp) :: tol           !< tolerance on residual norm
      logical :: charge_neutrality = .false.
      logical :: preconditioned = .false.
      logical :: prec_jacobi = .false.

      ! Statistics
      integer  :: last_iteration_count    !< Number of iteration for the last CG
      real(wp) :: last_residual
      real(wp) :: last_residual_tol
      real(sp) :: total_iteration_count   !< Sum of all iteration count

      ! work arrays
      integer :: n                    !< dimension of the work arrays
      real(wp), allocatable :: b(:)   !< right hand side
      real(wp), allocatable :: res(:) !< residual
      real(wp), allocatable :: p(:)   !< projection of res on the hyperplan <Q>=cst (only for charge neutrality)
      real(wp), allocatable :: d(:)   !< conjugate direction
      real(wp), allocatable :: Ad(:)  !< A times d
      real(wp), allocatable :: jacobi_precond(:) !< Jacobi preconditioner
      real(wp), allocatable :: precond(:,:) !< General preconditioner
      real(wp), allocatable :: Minvp(:)  !< M^-1 times res

   end type MW_cg_t

contains

   ! ================================================================================
   ! Set maximum number of iterations
   subroutine set_max_iterations(this, max_iterations)
      implicit none
      type(MW_cg_t), intent(inout) :: this
      integer, intent(in) :: max_iterations
      this%max_iterations = max_iterations
   end subroutine set_max_iterations

   ! ================================================================================
   ! Set tolerance parameter
   subroutine set_tolerance(this, tol)
      implicit none
      type(MW_cg_t), intent(inout) :: this
      real(wp), intent(in) :: tol
      this%tol = tol
   end subroutine set_tolerance

   ! ================================================================================
   ! Set force neutral
   subroutine set_charge_neutrality(this, charge_neutrality)
      implicit none
      type(MW_cg_t), intent(inout) :: this
      logical, intent(in) :: charge_neutrality
      this%charge_neutrality = charge_neutrality
   end subroutine set_charge_neutrality

   ! ================================================================================
   ! Set force neutral
   subroutine set_preconditioner(this, preconditioned, preconditioner)
      use MW_configuration_line, only: max_word_length
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      type(MW_cg_t),              intent(inout) :: this
      logical,                    intent(in)    :: preconditioned
      character(max_word_length), intent(in)    :: preconditioner
      this%preconditioned = preconditioned
      select case (preconditioner)
      case ("jacobi")
         this%prec_jacobi = .true.
      case default
         call MW_errors_runtime_error("set preconditioner", "cg.f90", &
               "Invalid preconditioner for conjugate gradient method")
      end select
   end subroutine set_preconditioner

   ! ================================================================================
   ! reset statistic counters
   subroutine reset_statistics(this)
      implicit none
      type(MW_cg_t), intent(inout) :: this
      this%last_iteration_count = 0
      this%last_residual = 0.0_wp
      this%last_residual_tol = 0.0_wp
      this%total_iteration_count = 0
   end subroutine reset_statistics

   !================================================================================
   ! Allocate data arrays
   subroutine allocate_arrays(this, n)
      use MW_errors, only: MW_errors_allocate_error => allocate_error
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cg_t), intent(inout) :: this

      ! Parameters in
      ! -------------
      integer, intent(in) :: n !< size of the data arrays

      ! Local
      ! -----
      integer :: i, j
      integer :: ierr

      this%n = n
      allocate(this%b(n), this%res(n), this%p(n), this%d(n), this%Ad(n), this%Minvp(n), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "cg.f90", ierr)
      end if

      do i = 1, n
         this%b(i) = 0.0_wp
         this%res(i) = 0.0_wp
         this%p(i) = 0.0_wp
         this%d(i) = 0.0_wp
         this%Ad(i) = 0.0_wp
         this%Minvp(i) = 0.0_wp
      end do

      if (this%preconditioned) then
         if (this%prec_jacobi) then
            allocate(this%jacobi_precond(n), stat=ierr)
            do i = 1, n
               this%jacobi_precond(i) = 1.0_wp
            end do
         else
            allocate(this%precond(n, n), stat=ierr)
            do i = 1, n
               this%precond(i,i) = 1.0_wp
               do j = 1, i-1
                  this%precond(i,j) = 0.0_wp
                  this%precond(j,i) = 0.0_wp
               end do
            end do

         end if
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "cg.f90", ierr)
         end if
      end if

   end subroutine allocate_arrays

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cg_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      this%max_iterations = 0
      this%tol = 0.0_wp
      this%last_iteration_count = 0
      this%total_iteration_count = 0.0_sp
      this%last_residual_tol = 0.0_wp
      this%n = 0

      if (allocated(this%b)) then
         deallocate(this%b, this%res, this%p, this%d, this%Ad, this%Minvp, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "cg.f90", ierr)
         end if
      end if
      if (this%preconditioned) then
         if (allocated(this%jacobi_precond)) then
            deallocate(this%jacobi_precond, stat=ierr)
         else
            deallocate(this%precond, stat=ierr)
         end if
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "cg.f90", ierr)
         end if
      end if
   end subroutine void_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_type(this, ounit)
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cg_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|cg| maximum number of iterations: ",i12)') this%max_iterations
      write(ounit, '("|cg| Residual error:               ",es12.5)') this%tol
      if (this%charge_neutrality) then
         write(ounit, '("|cg| Force charge neutrality:      ",a3)') "yes"
      else
         write(ounit, '("|cg| Force charge neutrality:      ",a3)') " no"
      end if
      if (this%preconditioned) then
         write(ounit, '("|cg| Preconditioned:      ",a3)') "yes"
      else
         write(ounit, '("|cg| Preconditioned:      ",a3)') " no"
      end if
   end subroutine print_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_statistics(this, ounit)
      implicit none

      ! Parameters inout
      ! ----------------
      type(MW_cg_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|cg| number of iterations: ",i12)') this%last_iteration_count
      write(ounit, '("|cg| Residual norm:        ",es12.5)') this%last_residual
      write(ounit, '("|cg| Residual target:      ",es12.5)') this%last_residual_tol
   end subroutine print_statistics

   ! ================================================================================
   !! Solve the equation Ax = b, with preconditioner M
   !!
   !! Algorithm
   !! ----------
   !! r_0 = b - Ax_0
   !! z_0 = M^{-1}r_0
   !! p_0 = z_0
   !!
   !! do iter = 1, max_iter
   !!
   !!   alpha_i = (r_i* x z_i) / (p_i* x Ap_i)
   !!   x_{i+1} = x_{i} + alpha_i x p_i
   !!   r_{i+1} = r_{i} - alpha_i x Ap_i
   !!   if (|r_{i+1}| < tol) exit loop
   !!   z_{i+1} = M^{-1}r_{i+1}
   !!   beta_i = (z_{i+1}* x r_{i+1}) / (z_{i}* x r_{i})
   !!   p_{i+1} = z_{i+1} + beta_{i} x p_i
   !!
   !! end do
   !! Adaptation to the constraint of charge neutrality implemented from the paper of Shariff (1995)
   subroutine solve(this, system, apply_A, x)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_t
      use MW_stdio, only: MW_stderr
      implicit none
      ! Parameters
      ! ----------
      type(MW_cg_t), intent(inout) :: this !> cg algorithm parameters
      type(MW_system_t), intent(inout) :: system !> system parameters

      !> Interface for apply_A routine
      !> Computes y = Ax
      interface
         subroutine apply_A(system, x, y)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(in) :: x(:)
            real(wp), intent(out) :: y(:)
         end subroutine apply_A
      end interface

      real(wp), intent(inout) :: x(:) !< Initial guess (in) and solution (out)

      ! Locals
      ! ------
      integer :: num, num_ions, num_atoms !< size of the solution vector
      integer :: i, iter
      real(wp) :: gammaold, gammanew, rsnew !< scalar to store residual norm
      real(wp) :: alpha, beta, dAd, dp  !< CG coefficients
      real(wp) :: res_norm, res_tol
      logical :: cg_converged
      real(wp) :: average_res, total_res

      num = size(x, 1)
      num_ions = system%num_ions
      num_atoms = system%num_atoms
      ! Setup tolerance on residual norm
      ! stopping criteria: |r_k| < tol * |b| where tol is a user input parameter
      res_tol = this%tol * sqrt(real(num,wp))

      ! Compute Ax0
      call apply_A(system, x, this%Ad)

      ! Setup initial residual
      do i = 1, num
         this%res(i) = this%b(i) - this%Ad(i)
      end do

      ! p0 = z0

      if (system%electrode_charge_neutrality) then
         ! projection of the gradient on the hypersurface <Q>=cst
         total_res = 0.0_wp
         if (system%pimrun) then
            do i = 3*num_ions+1, num
               total_res = total_res + this%res(i)
            end do
            average_res = total_res / real(num_atoms,wp)
            do i = 1, 3*num_ions
               this%p(i) = this%res(i)
            end do
            do i = 3*num_ions+1, num
               this%p(i) = this%res(i) - average_res
            end do
         else
            do i = 1, num
               total_res = total_res + this%res(i)
            end do
            average_res = total_res / real(num,wp)
            do i = 1, num
               this%p(i) = this%res(i) - average_res
            end do
         end if
      else
         do i = 1, num
            this%p(i) = this%res(i)
         end do
      endif


      do i = 1, num
         this%d(i) = this%p(i)
      end do

      rsnew=0.0_wp
      do i = 1, num
         rsnew = rsnew + this%d(i)*this%d(i)
      end do
      res_norm = sqrt(rsnew)
      gammanew=0.0_wp
      do i = 1, num
         gammanew = gammanew + this%p(i)*this%p(i)
      end do


      ! Begin CG iterations
      cg_converged = .false.
      do iter = 1, this%max_iterations

         call apply_A(system, this%d, this%Ad)

         dAd=0.0_wp
         do i = 1, num
            dAd = dAd + this%d(i)*this%Ad(i)
         end do
         dp=0.0_wp
         do i = 1, num
            dp = dp + this%d(i)*this%p(i)
         end do
         alpha = dp / dAd
         do i = 1, num
            x(i) = x(i) + alpha * this%d(i)
         end do
         gammaold = gammanew

         ! Avoid residual drift by recomputing it as res=b-Ax as suggested in Gingrich master's thesis
         if (mod(iter,50) == 0) then
            call apply_A(system, x, this%Ad)
            do i = 1, num
               this%res(i) = this%b(i) - this%Ad(i)
            end do
         else
            do i = 1, num
               this%res(i) = this%res(i) - alpha * this%Ad(i)
            end do
         endif

         if (system%electrode_charge_neutrality) then
            ! projection of the gradient on the hypersurface <Q>=cst
            total_res = 0.0_wp
            if (system%pimrun) then
               do i = 3*num_ions+1, num
                  total_res = total_res + this%res(i)
               end do
               average_res = total_res / real(num_atoms,wp)
               do i = 1, 3*num_ions
                  this%p(i) = this%res(i)
               end do
               do i = 3*num_ions+1, num
                  this%p(i) = this%res(i) - average_res
               end do
            else
               do i = 1, num
                  total_res = total_res + this%res(i)
               end do
               average_res = total_res / real(num,wp)
               do i = 1, num
                  this%p(i) = this%res(i) - average_res
               end do
            end if
         else
            do i = 1, num
               this%p(i) = this%res(i)
            end do
         endif

         gammanew=0.0_wp
         do i = 1, num
            gammanew = gammanew + this%p(i)*this%p(i)
         end do
         ! Setup for next iteration
         beta = gammanew / gammaold
         do i = 1, num
            this%d(i) = this%p(i) + beta * this%d(i)
         end do

         rsnew=0.0_wp
         do i = 1, num
            rsnew = rsnew + this%d(i)*this%d(i)
         end do

         res_norm = sqrt(rsnew)

         if (res_norm < res_tol) then
            this%last_iteration_count = iter
            this%total_iteration_count = this%total_iteration_count + iter
            this%last_residual = res_norm
            this%last_residual_tol = res_tol
            cg_converged = .true.
            exit
         end if

      end do

      if (.not. cg_converged) then
         this%last_iteration_count = iter
         this%last_residual = res_norm
         this%last_residual_tol = res_tol
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "cg.f90", "CG failed to converge")
      end if
   end subroutine solve

   subroutine apply_diagMinv(x, diagM, y)
      implicit none
      ! Parameters Input/Output
      ! ----------
      real(wp), intent(in) :: x(:)
      real(wp), intent(in) :: diagM(:)
      real(wp), intent(out) :: y(:)

      integer :: i, n

      n = size(x)
      do i = 1, n
         y(i) = 1.0_wp/diagM(i)*x(i)
      end do

   end subroutine apply_diagMinv

   subroutine apply_Minv(x, Minv, y)
      implicit none
      ! Parameters Input/Output
      ! ----------
      real(wp), intent(in) :: x(:)
      real(wp), intent(in) :: Minv(:,:)
      real(wp), intent(out) :: y(:)

      integer :: i, j, n

      !TO BE PARALLELIZED
      n = size(x)
      do j = 1, n
         do i = 1, n
            y(i) = y(i) + Minv(i, j)*x(i)
         end do
      end do

   end subroutine apply_Minv

   subroutine solve_preconditioned(this, system, apply_A, x)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_system, only: MW_system_t
      use MW_ion, only: MW_ion_t
      use MW_stdio, only: MW_stderr
      implicit none
      ! Parameters
      ! ----------
      type(MW_cg_t), intent(inout) :: this !> cg algorithm parameters
      type(MW_system_t), intent(inout) :: system !> system parameters

      !> Interface for apply_A routine
      !> Computes y = Ax
      interface
         subroutine apply_A(system, x, y)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            use MW_ion, only: MW_ion_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(in) :: x(:)
            real(wp), intent(out) :: y(:)
         end subroutine apply_A
      end interface

      real(wp), intent(inout) :: x(:) !< Initial guess (in) and solution (out)

      ! Locals
      ! ------
      integer :: num, num_ions, num_atoms !< size of the solution vector
      integer :: iter
      real(wp) :: gammaold, gammanew, rsnew !< scalar to store residual norm
      real(wp) :: alpha, beta, dAd  !< CG coefficients
      real(wp) :: res_norm, res_tol
      logical :: cg_converged
      real(wp) :: average_res, total_res

      num = this%n
      num_ions = system%num_ions
      num_atoms = system%num_atoms

      res_tol = this%tol * sqrt(real(num,wp))

      call apply_A(system, x, this%Ad)

      ! Setup initial residual
      this%res(1:num) = this%b(1:num) - this%Ad(1:num)

      if (system%electrode_charge_neutrality) then
         ! projection of the gradient on the hypersurface <Q>=cst
         !$acc kernels
         if (system%pimrun) then
            total_res = sum(this%res(3*num_ions+1:3*num_ions+num_atoms))
            average_res = total_res / real(num_atoms,wp)
            this%p(1:3*num_ions) = this%res(1:3*num_ions)
            this%p(3*num_ions+1:3*num_ions+num_atoms) = this%res(3*num_ions+1:3*num_ions+num_atoms) - average_res
         else
            total_res = sum(this%res(1:num))
            average_res = total_res / real(num,wp)
            this%p(1:num) = this%res(1:num) - average_res
         end if
         !$acc end kernels
      else
         !$acc kernels
         this%p(1:num) = this%res(1:num)
         !$acc end kernels
      endif

      if (this%preconditioned) then
         if (this%prec_jacobi) then
            call apply_diagMinv(this%p, this%jacobi_precond, this%Minvp)
         else
            call apply_Minv(this%p, this%precond, this%Minvp)
         end if
         this%d(1:num) = this%Minvp(1:num)
      else
         this%Minvp(1:num) = this%p(1:num)
         this%d(1:num) = this%Minvp(1:num)
      end if

      rsnew = sum(this%p(1:num)*this%p(1:num))
      res_norm = sqrt(rsnew)

      gammanew = sum(this%p(1:num)*this%Minvp(1:num))

      cg_converged = .false.
      do iter = 1, this%max_iterations

         call apply_A(system, this%d, this%Ad)

         dAd = sum(this%d(1:num)*this%Ad(1:num))
         alpha = gammanew / dAd
         x(1:num) = x(1:num) + alpha*this%d(1:num)

         if (mod(iter,50) == 0) then
            call apply_A(system, x, this%Ad)
            this%res(1:num) = this%b(1:num) - this%Ad(1:num)
         else
            this%res(1:num) = this%res(1:num) - alpha * this%Ad(1:num)
         endif

         if (system%electrode_charge_neutrality) then
            ! projection of the gradient on the hypersurface <Q>=cst
            !$acc kernels
            if (system%pimrun) then
               total_res = sum(this%res(3*num_ions+1:3*num_ions+num_atoms))
               average_res = total_res / real(num_atoms,wp)
               this%p(1:3*num_ions) = this%res(1:3*num_ions)
               this%p(3*num_ions+1:3*num_ions+num_atoms) = this%res(3*num_ions+1:3*num_ions+num_atoms) - average_res
            else
               total_res = sum(this%res(1:num))
               average_res = total_res / real(num,wp)
               this%p(1:num) = this%res(1:num) - average_res
            end if
            !$acc end kernels
         else
            !$acc kernels
            this%p(1:num) = this%res(1:num)
            !$acc end kernels
         endif

         if (this%preconditioned) then
            if (this%prec_jacobi) then
               call apply_diagMinv(this%p, this%jacobi_precond, this%Minvp)
            else
               call apply_Minv(this%p, this%precond, this%Minvp)
            end if
         else
            this%Minvp(1:num) = this%p(1:num)
         end if

         gammaold = gammanew
         gammanew = sum(this%p(1:num)*this%Minvp(1:num))

         beta = gammanew / gammaold
         this%d(1:num) = this%Minvp(1:num) + beta*this%d(1:num)

         rsnew = sum(this%p(1:num)*this%p(1:num))
         res_norm = sqrt(rsnew)

         if (res_norm < res_tol) then

            this%last_iteration_count = iter
            this%total_iteration_count = this%total_iteration_count + iter
            this%last_residual = res_norm
            this%last_residual_tol = res_tol
            cg_converged = .true.
            exit
         end if
      end do

      if (.not. cg_converged) then

         this%last_iteration_count = iter
         this%last_residual = res_norm
         this%last_residual_tol = res_tol
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "cg.f90", "CG failed to converge")
      end if
   end subroutine solve_preconditioned

end module MW_cg

! Module defines MaZe type to store MaZe algorithm parameters
module MW_maze
   use MW_timers
   use MW_kinds, only: wp, sp
   use MW_system, only: MW_system_t

   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_maze_t

   ! Public subroutines
   ! ------------------
   public :: set_max_iterations
   public :: set_tolerance
   public :: set_blocks_number
   public :: set_charge_neutrality
   public :: set_write_matrix
   public :: set_sor_param
   public :: reset_statistics
   public :: set_dimensionality
   public :: select_algorithm
   public :: allocate_arrays
   public :: void_type
   public :: setup_history
   public :: update_history
   public :: print_type
   public :: print_statistics
   public :: compute_x0
   public :: solve_invert
   public :: solve_shake
   public :: solve_block_iterate
   public :: solve_CG_store
   public :: solve_CG_nostore

   integer, parameter :: CONSTR_GRAD_NUM_STEPS = 2    !< number of steps stored for gradient of the constraints

   type MW_maze_t

      !Convergence parameters
      integer :: max_iterations !< maximum number of iterations
      real(wp) :: tol           !< tolerance on constraints norm

      !Statistics
      integer  :: last_iteration_count    !< Number of iteration for the last MaZe
      real(wp) :: last_max_constr         !< Maximum constraint for last iteration
      real(sp) :: total_iteration_count   !< Sum of all iteration count

      !Logicals (common or shared)
      logical :: calc_elec = .false.
      logical :: calc_dip = .false.
      logical :: charge_neutrality = .false.
      logical :: constant_constr_grad = .false.
      logical :: firsttime = .true.
      logical :: write_shake_matrix = .false.

      !Type variables (common)
      integer :: n_constr, n_var                  !< dimensions of the work arrays
      real(wp)              :: sor_param          !< successive over relaxation parameter
      real(wp), allocatable :: const_constr(:)    !< Constant part of constraint
      real(wp), allocatable :: ggamma(:)          !< MaZe Lagrange Multipliers
      real(wp), allocatable :: constr_grad(:,:,:) !< Gradient of the constraints

      !History Pointers
      integer :: constr_grad_step(CONSTR_GRAD_NUM_STEPS)

      !Logicals (switches btwn algorithms)
      logical :: shake = .false.
      logical :: invert = .false.
      logical :: block_iterate = .false.
      logical :: CG_store_prec = .false.
      logical :: CG_store_noprec = .false.
      logical :: CG_nostore = .false.

      !Type variables (shake)
      real(wp), allocatable :: denom(:)           !< denominator (constraint gradient dependent)

      !Type variables (block invert and invert)
      integer :: n_blocks = 0, n_red, n_test          !< dimensions of the work arrays for block shake
      real(wp) :: uscale
      real(wp), allocatable :: block_ggamma(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: Aredinv(:,:,:)     !< Matrix to invert in block shake
      real(wp), allocatable :: constr(:)          !< Non-constant part of constraint
      real(wp), allocatable :: fconstr(:)         !< Constraint forces
      real(wp), allocatable :: Ainv(:,:)          !< Matrix to invert

      !Type variables (CG)
      real(wp), allocatable :: Aggamma(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: Ap(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: res(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: p(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: eta(:)    !< MaZe Lagrange Multipliers for block shake
      real(wp), allocatable :: jacobi_precond(:)

   end type MW_maze_t

contains

   ! ================================================================================
   ! Set maximum number of iterations
   subroutine set_max_iterations(this, max_iterations)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      integer, intent(in) :: max_iterations
      this%max_iterations = max_iterations
   end subroutine set_max_iterations

   ! ================================================================================
   ! Set tolerance parameter
   subroutine set_tolerance(this, tol)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      real(wp), intent(in) :: tol
      this%tol = tol
   end subroutine set_tolerance

   ! ================================================================================
   ! Set number of blocks
   subroutine set_blocks_number(this, n_blocks)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      integer, intent(in) :: n_blocks
      this%n_blocks = n_blocks
   end subroutine set_blocks_number

   ! ================================================================================
   ! Set force neutral
   subroutine set_charge_neutrality(this, charge_neutrality, uscale)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      logical, intent(in) :: charge_neutrality
      real(wp), intent(in) :: uscale
      this%charge_neutrality = charge_neutrality
      this%uscale = uscale
   end subroutine set_charge_neutrality

   ! ================================================================================
   ! Set write_matrix
   subroutine set_write_matrix(this, write_matrix)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      logical, intent(in) :: write_matrix
      this%write_shake_matrix = write_matrix
   end subroutine set_write_matrix

   ! ================================================================================
   ! Set successive over relaxation parameter
   subroutine set_sor_param(this, sor_param)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      real(wp), intent(in) :: sor_param
      this%sor_param = sor_param
   end subroutine set_sor_param

   ! ================================================================================
   ! reset statistic counters
   subroutine reset_statistics(this)
      implicit none
      type(MW_maze_t), intent(inout) :: this
      this%last_iteration_count = 0
      this%last_max_constr = 0.0_wp
      this%total_iteration_count = 0
   end subroutine reset_statistics

   ! ================================================================================
   ! Set dimensionality
   subroutine set_dimensionality(this, n)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      type(MW_maze_t), intent(inout) :: this
      integer, intent(in) :: n

      this%n_var = n
      if (this%charge_neutrality.and.this%calc_elec) then
         this%n_constr = this%n_var+1
      else
         this%n_constr = this%n_var
      end if

      if ((this%n_blocks .gt. this%n_constr) .or. (this%n_blocks .lt. -3)) then
         call MW_errors_runtime_error("set_dimensionality", "maze.f90", "Unacceptable number of blocks.")
      end if

      if (this%n_blocks .gt. 0) then
         this%n_red = int(this%n_constr/this%n_blocks)
         this%n_test = mod(this%n_constr, this%n_blocks)
      else
         this%n_red = this%n_constr
         this%n_test = 0
      end if

      if (this%n_test /= 0) then
         call MW_errors_runtime_error("set_dimensionality", "maze.f90", "Number of blocks does not divide number of "// &
               "constraints exactly. Function not yet implemented.")
      end if

   end subroutine set_dimensionality

   ! ================================================================================
   ! Select algorithm for constraint enforcement
   subroutine select_algorithm(this, maze_algorithm, maze_cg_store, maze_cg_prec, n_blocks)
      use MW_configuration_line, only: max_word_length
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none

      integer                   , intent(in) :: n_blocks
      character(max_word_length), intent(in) :: maze_algorithm
      character(max_word_length), intent(in) :: maze_cg_store
      character(max_word_length), intent(in) :: maze_cg_prec

      type(MW_maze_t), intent(inout) :: this

      select case (maze_algorithm)
      case ("inversion")
         this%invert = .true.
      case ("iterative_shake")
         if (n_blocks > 0) then
            call set_blocks_number(this, n_blocks)
            this%block_iterate = .true.
         else
            this%shake = .true.
         end if
      case ("iterative_cg")
         if (maze_cg_store.eq."store") then
            if (maze_cg_prec.eq."preconditioned") then
               this%CG_store_prec = .true.
            else
               this%CG_store_noprec = .true.
            end if
         else
            this%CG_nostore = .true.
         end if
      case default
         call MW_errors_runtime_error("select_algorithm", "mlshake.f90", &
               "Invalid algorithm for mlshake method.")
      end select

   end subroutine select_algorithm

   !================================================================================
   ! Allocate data arrays
   subroutine allocate_arrays(this)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_runtime_error => runtime_error
      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_maze_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: n_var, n_constr, n_steps, n_blocks, n_red
      integer :: ierr

      n_var = this%n_var
      n_constr = this%n_constr
      n_steps = CONSTR_GRAD_NUM_STEPS
      n_blocks = this%n_blocks
      n_red = this%n_red

      if (this%CG_nostore) then
         allocate(this%const_constr(n_constr), this%ggamma(n_constr), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
      else
         allocate(this%const_constr(n_constr), this%ggamma(n_constr), this%constr_grad(n_constr, n_constr, n_steps), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%constr_grad(:,:,:) = 0.0_wp
      end if

      this%const_constr(:) = 0.0_wp
      this%ggamma(:) = 0.0_wp

      if (this%shake) then

         allocate(this%denom(n_constr), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%denom(:) = 0.0_wp

      else if (this%block_iterate) then

         allocate(this%constr(n_red), this%block_ggamma(n_red), this%Aredinv(n_red, n_red, n_blocks), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%constr(:) = 0.0_wp
         this%block_ggamma = 0.0_wp
         this%Aredinv(:,:,:) = 0.0_wp

      else if (this%invert) then

         allocate(this%constr(n_constr), this%fconstr(n_constr), this%Ainv(n_constr, n_constr), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%constr(:) = 0.0_wp
         this%fconstr(:) = 0.0_wp
         this%Ainv(:,:) = 0.0_wp

      else if (this%CG_store_prec.or.this%CG_store_noprec) then

         allocate(this%constr(n_constr), this%fconstr(n_constr), this%Ainv(n_constr,n_constr), this%Aggamma(n_constr), &
               this%Ap(n_constr), this%res(n_constr), this%p(n_constr), this%eta(n_constr), this%jacobi_precond(n_constr), &
               stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%constr(:) = 0.0_wp
         this%fconstr(:) = 0.0_wp
         this%Ainv(:,:) = 0.0_wp
         this%Aggamma(:) = 0.0_wp
         this%Ap(:) = 0.0_wp
         this%res(:) = 0.0_wp
         this%p(:) = 0.0_wp
         this%eta(:) = 0.0_wp
         this%jacobi_precond(:) = 1.0_wp

      else if (this%CG_nostore) then

         allocate(this%constr(n_constr), this%fconstr(n_constr), this%Aggamma(n_constr), this%Ap(n_constr), this%res(n_constr), &
               this%p(n_constr), stat=ierr)
         if (ierr /= 0) then
            call MW_errors_allocate_error("define_type", "maze.f90", ierr)
         end if
         this%constr(:) = 0.0_wp
         this%fconstr(:) = 0.0_wp
         this%Aggamma(:) = 0.0_wp
         this%Ap(:) = 0.0_wp
         this%res(:) = 0.0_wp
         this%p(:) = 0.0_wp

      end if

   end subroutine allocate_arrays

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_maze_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      this%max_iterations = 0
      this%tol = 0.0_wp
      this%last_iteration_count = 0
      this%total_iteration_count = 0.0_sp
      this%last_max_constr = 0.0_wp
      this%n_constr = 0
      this%n_var = 0

      if (allocated(this%const_constr)) then

         if (this%CG_nostore) then
            deallocate(this%const_constr, this%ggamma, stat=ierr)
         else
            deallocate(this%const_constr, this%ggamma, this%constr_grad, stat=ierr)
         end if

         if (this%shake) then

            if (allocated(this%denom)) deallocate(this%denom, stat=ierr)

         else if (this%block_iterate) then

            if (allocated(this%constr)) deallocate(this%constr, this%Aredinv, this%block_ggamma, stat=ierr)

         else if (this%invert) then

            if (allocated(this%constr)) deallocate(this%constr, this%fconstr, this%Ainv, stat=ierr)

         else if (this%CG_store_prec.or.this%CG_store_noprec) then

            if (allocated(this%constr)) deallocate(this%constr, this%fconstr, this%Ainv, this%Aggamma, this%Ap, this%res, this%p, &
                  this%jacobi_precond, stat=ierr)

         else if (this%CG_nostore) then

            if (allocated(this%constr)) deallocate(this%constr, this%fconstr, this%Aggamma, this%Ap, this%res, this%p, stat=ierr)

         end if

         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "maze.f90", ierr)
         end if

      end if

   end subroutine void_type

   subroutine setup_history(this)

      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_maze_t), intent(inout) :: this

      !Locals
      !------
      integer:: i

      do i = 1, CONSTR_GRAD_NUM_STEPS
         this%constr_grad_step(i) = i
      end do

   end subroutine setup_history

   subroutine update_history(this)

      implicit none

      ! Parameters Input/Output
      ! ----------------
      type(MW_maze_t), intent(inout) :: this

      !Locals
      !------
      integer:: step, step_now

      step_now = this%constr_grad_step(CONSTR_GRAD_NUM_STEPS)
      do step = CONSTR_GRAD_NUM_STEPS, 2, -1
         this%constr_grad_step(step) = this%constr_grad_step(step-1)
      end do
      this%constr_grad_step(1) = step_now

   end subroutine update_history

   !================================================================================
   ! Print the data structure parameters
   subroutine print_type(this, ounit)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_maze_t), intent(in) :: this
      integer,            intent(in) :: ounit

      write(ounit, '("|maze| maximum number of iterations: ",i12)') this%max_iterations
      write(ounit, '("|maze| Tolerance:               ",es12.5)') this%tol
      if (this%charge_neutrality) then
         write(ounit, '("|maze| Force charge neutrality:      ",a3)') "yes"
      else
         write(ounit, '("|maze| Force charge neutrality:      ",a3)') " no"
      end if
   end subroutine print_type

   !================================================================================
   ! Print the data structure parameters
   subroutine print_statistics(this, ounit)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_maze_t), intent(in) :: this
      integer,       intent(in) :: ounit

      write(ounit, '("|maze| number of iterations: ",i12)') this%last_iteration_count
      write(ounit, '("|maze| Maximum of the constraints:        ",es12.5)') this%last_max_constr
   end subroutine print_statistics

   ! ================================================================================
   !Compute starting vector
   subroutine compute_x0(this, system, alpha, x_tmdt, x_t, x_0)
      implicit none

      !Parameters Input
      !----------------
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: x_t(:), x_tmdt(:)
      type(MW_system_t),  intent(inout) :: system

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this

      !Parameters Output
      !-----------------
      real(wp), intent(out) :: x_0(:)

      !Locals
      integer :: i, k
      integer :: n_var, n_constr
      integer :: prev, chi_tpdt=0, chi_t=0, chi_tmdt=0
      real(wp) :: init_fconstr_i = 0.0_wp

      n_constr = this%n_constr
      n_var = this%n_var
      prev = this%constr_grad_step(2)

      if (this%charge_neutrality) then
         chi_tpdt = system%potential_shift_step(1)
         chi_t    = system%potential_shift_step(2)
         chi_tmdt = system%potential_shift_step(3)
      end if

      if(this%invert.or.this%CG_nostore) then
         do i = 1, n_var
            x_0(i) = x_t(i) + (x_t(i) - x_tmdt(i))*alpha
         end do
         if (this%charge_neutrality) then
            system%chi(chi_tpdt) = 2*system%chi(chi_t) - system%chi(chi_tmdt)
         end if
      else
         do i = 1, n_var
            init_fconstr_i = 0.0_wp
            do k = 1, n_constr
               init_fconstr_i = init_fconstr_i + this%ggamma(k)*this%constr_grad(k,i,prev)
            end do
            x_0(i) = x_t(i) + (x_t(i) - x_tmdt(i))*alpha + init_fconstr_i
         end do
      end if

   end subroutine compute_x0

   subroutine get_shake_matrix(this, system, compute_constr_gradient, mode)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error, &
      MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t),  intent(inout) :: system

      interface
         subroutine compute_constr_gradient(system, constr_grad)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: constr_grad(:,:)
         end subroutine compute_constr_gradient
      end interface

      character(len=*), intent(in) :: mode

      integer       :: n_constr, n_var
      integer       :: constr_grad_now, constr_grad_prev
      character(64) :: fname
      logical       :: matrix_data_present

      n_var = this%n_var
      n_constr = this%n_constr
      constr_grad_now = this%constr_grad_step(1)
      constr_grad_prev = this%constr_grad_step(2)

      call  compute_constr_gradient(system, this%constr_grad(1:n_var, 1:n_var, constr_grad_now))
      if (this%charge_neutrality) then
         this%constr_grad(1:n_var , n_constr, constr_grad_now) = 1.0_wp
         this%constr_grad(n_constr,  1:n_var, constr_grad_now) = this%uscale
         this%constr_grad(n_constr, n_constr, constr_grad_now) = 0.0_wp
      end if

      !Gradient is constant during simulation. Setting same values for t and tpdt.
      if (this%firsttime) then
         this%constr_grad(:,:,constr_grad_prev) = this%constr_grad(:,:,constr_grad_now)
         this%firsttime=.false.
      end if

      fname = "maze_matrix.inpt"
      INQUIRE(FILE=fname, EXIST=matrix_data_present)
      if(.not. matrix_data_present) then ! The full matrix has to be computed

         select case (mode)
            case ("symmetric")
               call compute_shake_matrix(this, constr_grad_prev, constr_grad_prev)
               if (this%CG_store_prec) call compute_jacobi_preconditioner(this)
            case ("invert")
               call compute_shake_matrix(this, constr_grad_now, constr_grad_prev)

               !Inverting matrix (The matrix is symmetric)
               call MW_timers_start(TIMER_MINQ_INVMAT)
               call invert_matrix(this%n_constr, this%Ainv(1:n_constr,1:n_constr))
               call MW_timers_stop(TIMER_MINQ_INVMAT)
            case default
               call MW_errors_runtime_error("get_shake_matrix", "maze.f90", &
                     "Invalid mode for getting shake matrix")
         end select

         if (this%constant_constr_grad) then
            if (mode .eq. "symmetric") then
               call write_shake_matrix_ascii(this, system, fname, mode)
            else if (mode .eq. "invert") then
               call write_shake_matrix(this, system, fname)
            end if
         end if

      else !then we read the file and fill this%Ainv array

         if (mode .eq. "symmetric") then
            call read_shake_matrix_ascii(this, system, fname, mode)
            if (this%CG_store_prec) call compute_jacobi_preconditioner(this)
         else if (mode .eq. "invert") then
            call read_shake_matrix(this, system, fname)
         end if

      end if

      if (this%write_shake_matrix) then
         fname = "maze_matrix.out"
         call write_shake_matrix_ascii(this, system, fname, mode)
      end if

   end subroutine get_shake_matrix

   subroutine compute_shake_matrix(this, constr_grad_t_jk, constr_grad_t_jh)
      implicit none

      type(MW_maze_t), intent(inout) :: this
      integer, intent(in) :: constr_grad_t_jk, constr_grad_t_jh

      integer  :: j, h, k, n_constr, n_var
      real(wp) :: A_kh

      n_constr = this%n_constr
      n_var = this%n_var

      !$acc parallel loop private(A_kh)
      do h = 1, n_constr
         do k = 1, n_constr
            A_kh = 0.0_wp
            !$acc loop reduction(+:A_kh)
            do j = 1, n_constr
               A_kh = A_kh + this%constr_grad(j,k,constr_grad_t_jk)*this%constr_grad(j,h,constr_grad_t_jh)
            end do
            !$acc end loop
            this%Ainv(k,h) = A_kh
         end do
      end do
      !$acc end parallel loop

   end subroutine compute_shake_matrix

   subroutine compute_jacobi_preconditioner(this)
      implicit none

      type(MW_maze_t), intent(inout) :: this

      integer :: h

      do h = 1, this%n_constr
         this%jacobi_precond(h) = 1.0_wp/this%Ainv(h,h)
      end do

   end subroutine compute_jacobi_preconditioner

   subroutine write_shake_matrix(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error
      implicit none

      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t),  intent(inout) :: system
      character(64),      intent(in)    :: fname

      integer,            parameter     :: n_atoms_check = 10

      integer                           :: n_constr
      integer                           :: funit, ierr

      n_constr = this%n_constr

      ! opening file
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
      position="REWIND", form="UNFORMATTED", status="REPLACE", &
      iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("write_shake_matrix", "maze.f90", fname, ierr)
      end if

      write(funit) n_atoms_check
      write(funit) system%xyz_atoms(1:n_atoms_check,:)
      write(funit) this%Ainv(:,:)

      ! closing file
      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("write_shake_matrix", "maze.f90",&
         funit, ierr)
      end if

   end subroutine write_shake_matrix

   subroutine read_shake_matrix(this, system, fname)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error, &
      MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_maze_t),         intent(inout) :: this
      type(MW_system_t),       intent(inout) :: system
      character(64),           intent(in)    :: fname

      integer,                 parameter     :: n_atoms_check = 10
      real(wp),   dimension(n_atoms_check,3) :: xyz
      real(wp),                parameter     :: tol = 1e-14

      integer                                :: j
      integer                                :: n_constr
      integer                                :: n_atoms_check_read
      integer                                :: funit, ierr

      n_constr = this%n_constr

      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="READ", &
      position="REWIND", form="UNFORMATTED", status="OLD", iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("read_shake_matrix", "maze.f90",&
         fname, ierr)
      end if
      read(funit) n_atoms_check_read

      read(funit) xyz
      do j = 1, n_atoms_check

         if (abs(xyz(j,1) - system%xyz_atoms(j,1)) > tol .or. &
               abs(xyz(j,2) - system%xyz_atoms(j,2)) > tol .or. &
               abs(xyz(j,3) - system%xyz_atoms(j,3)) > tol ) then
            call MW_errors_runtime_error("read_shake_matrix", "maze.f90", &
                  "Electrode atoms not at the same positions as the ones used to compute the"// &
                  "inverted matrix that should be loaded => not consistent.")
         end if
      end do
      read(funit) this%Ainv
      close(funit, iostat=ierr)

      if (ierr /= 0) then
         call MW_errors_close_error("read_shake_matrix", "maze.f90", &
         funit, ierr)
      end if
   end subroutine read_shake_matrix

   subroutine write_shake_matrix_ascii(this, system, fname, mode)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error
      implicit none

      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t),  intent(inout) :: system
      character(64),      intent(in)    :: fname
      character(len=*),   intent(in)    :: mode

      integer,            parameter     :: n_atoms_check = 10

      integer                           :: j
      integer                           :: n_constr
      integer                           :: funit, ierr
      character(64)                     :: matrix_fmt

      n_constr = this%n_constr

      ! opening file
      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="WRITE", &
      position="REWIND", form="FORMATTED", status="REPLACE", &
      iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_maze_compute_gradient", "maze.f90", fname, ierr)
      end if

      ! Defining the format string based on the number of constraints
      write (matrix_fmt, '("(", I6, "(es30.20E3,:,1x))")' ) n_constr
      ! writing file
      write(funit, '("# Matrix for electrode charges used with maze algorithm")')
      write(funit, '("# electrode_position_check")')
      write(funit, '("n_atoms_check",(I3))') n_atoms_check
      do j = 1, n_atoms_check
         write(funit,'(3(es29.20, 1x))') system%xyz_atoms(j,1), system%xyz_atoms(j,2), system%xyz_atoms(j,3)
      end do
      write(funit, '("# maze_matrix")')
      write(funit, '("# ",(a10))') mode
      write(funit, '("n_constr ",(I6))') n_constr
      do j = 1, n_constr
         write(funit, matrix_fmt) this%Ainv(:,j)
      end do

      ! closing file
      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("MW_maze_compute_gradient", "maze.f90",&
         funit, ierr)
      end if

   end subroutine write_shake_matrix_ascii

   subroutine read_shake_matrix_ascii(this, system, fname, mode)
      use MW_fileunit, only: MW_fileunit_get_new_unit => get_new_unit
      use MW_errors, only: MW_errors_open_error => open_error, &
      MW_errors_close_error => close_error, &
      MW_errors_runtime_error => runtime_error
      implicit none

      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t),  intent(inout) :: system
      character(64),      intent(in)    :: fname
      character(len=*),   intent(in)    :: mode

      integer,            parameter     :: n_atoms_check = 10
      real(wp),           parameter     :: tol = 1e-14

      integer                           :: j
      integer                           :: n_constr
      integer                           :: n_atoms_check_read
      integer                           :: funit, ierr
      character(64)                     :: keyword, matrix_fmt
      character(1)                      :: hash_char
      real(wp)                          :: x_read, y_read, z_read

      n_constr = this%n_constr

      call MW_fileunit_get_new_unit(funit)
      open(unit=funit, file=fname, access="SEQUENTIAL", action="READ", &
            position="REWIND", form="FORMATTED", status="OLD", iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_open_error("MW_maze_compute_gradient", "maze.f90",&
               fname, ierr)
      end if
      read(funit, *) hash_char, keyword
      read(funit, *) hash_char, keyword
      if ((keyword /= "electrode_position_check")) then
         call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
               "Expecting # electrode_position_check in maze_matrix input file")
      end if
      read(funit, *) keyword, n_atoms_check_read
      if ((keyword /= "n_atoms_check")) then
         call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
               "Expecting n_atoms_check in maze_matrix input file")
      end if
      do j = 1, n_atoms_check
         read(funit,'(3(es29.20, 1x))') x_read, y_read, z_read

         if (abs(x_read - system%xyz_atoms(j,1)) > tol .or. &
               abs(y_read - system%xyz_atoms(j,2)) > tol .or. &
               abs(z_read - system%xyz_atoms(j,3)) > tol ) then
            call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
                  "Electrode atoms not at the same positions as the ones used to compute the"// &
                  "inverted matrix that should be loaded => not consistent.")
         end if
      end do

      read(funit, *) hash_char, keyword
      if ((keyword /= "maze_matrix")) then
         call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
               "Expecting # maze_matrix in maze_matrix input file")
      end if
      read(funit, *) hash_char, keyword
      if ((keyword /= mode)) then
         call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
               "Expecting # "//mode//" in maze_matrix input file")
      end if
      read(funit, *) keyword, n_constr
      if ((keyword /= "n_constr")) then
         call MW_errors_runtime_error("MW_maze_compute_gradient", "maze.f90", &
               "Expecting # n_constr in maze_matrix input file")
      end if
      ! Defining the format string based on the number of constraints
      write (matrix_fmt, '("(", I6, "(es30.20E3,:,1x))")' ) n_constr
      do j= 1, n_constr
         read(funit, matrix_fmt)  this%Ainv(:,j)
      end do

      close(funit, iostat=ierr)
      if (ierr /= 0) then
         call MW_errors_close_error("MW_maze_compute_gradient", "maze.f90", &
         funit, ierr)
      end if
   end subroutine read_shake_matrix_ascii

   subroutine solve_invert(this, system, compute_constr_gradient, matvec_product, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_stdio, only: MW_stderr
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine compute_constr_gradient(system, constr_grad)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: constr_grad(:,:)
         end subroutine compute_constr_gradient
      end interface

      interface
         subroutine matvec_product(system, mat, vec, matvec_prod)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(in) :: system
            real(wp), intent(in) :: mat(:,:)
            real(wp), intent(in) :: vec(:)
            real(wp), intent(out) :: matvec_prod(:)
         end subroutine matvec_product
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals
      !------
      integer  :: n_var, n_constr
      integer  :: prev, now, chi_new=0
      real(wp) :: discr

      n_var = this%n_var
      n_constr = this%n_constr
      now = this%constr_grad_step(1)
      prev = this%constr_grad_step(2)
      if (this%charge_neutrality) chi_new = system%potential_shift_step(1)

      if ((.not.this%constant_constr_grad).or.(this%firsttime)) then
         call get_shake_matrix(this, system, compute_constr_gradient, "invert")
         this%firsttime = .false.
      end if

      !Computing constraints sigma_old
      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)
      if (this%charge_neutrality) then
         this%constr(1:n_var) = this%constr(1:n_var) + system%chi(chi_new)
         this%constr(n_constr) = sum(x(1:n_var)) - this%const_constr(n_constr)
      end if

      !Computing Lagrange multipliers for system without additional constraint
      call matvec_product(system, this%Ainv(1:n_var,1:n_var), -this%constr(1:n_var), this%ggamma(1:n_var))
      if (this%charge_neutrality) then
         this%ggamma(1:n_var) = this%ggamma(1:n_var) -this%constr(n_constr)*this%Ainv(n_constr,1:n_var)
         this%ggamma(n_constr) = -sum(this%Ainv(n_constr,1:n_constr)*this%constr(1:n_constr))
      end if

      !Computing constraint forces
      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,prev), this%ggamma(1:n_var), this%fconstr(1:n_var))
      if (this%charge_neutrality) then
         this%fconstr(1:n_var) = this%fconstr(1:n_var) + this%ggamma(n_constr)
         this%fconstr(n_constr) = this%uscale*this%uscale*sum(this%ggamma(1:n_var))
      end if

      !Updating MaZe variables
      x(1:n_var) = x(1:n_var) + this%fconstr(1:n_var)
      if (this%charge_neutrality) system%chi(chi_new) = system%chi(chi_new) + this%fconstr(n_constr)

      !Computing constraints with updated variables
      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)

      if (this%charge_neutrality) then
         this%constr(1:n_var) = this%constr(1:n_var) + system%chi(chi_new)
         this%constr(n_constr) = sum(x(1:n_var)) - this%const_constr(n_constr)
      end if

      !Checking the residual on the constraint is less than tolerance
      discr = maxval(dabs(this%constr(1:n_constr)))

      !write(*,*)this%constr(1),this%constr(n_constr-1),this%constr(n_constr),discr,(discr.eq.dabs(this%constr(n_constr))),"#M-shake"

      if (discr.lt.this%tol) then
         this%last_max_constr = discr
      else
         this%last_max_constr = discr
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "maze.f90", &
         "M-SHAKE failed to satisfy constraints up the given tolerance")
      end if

   end subroutine solve_invert

   subroutine solve_shake(this, system, compute_constr_gradient, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_stdio, only: MW_stderr
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine compute_constr_gradient(system, constr_grad)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: constr_grad(:,:)
         end subroutine compute_constr_gradient
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals (common)
      !---------------
      logical  :: maze_converged
      integer  :: j, k
      integer  :: n_var, n_constr
      integer  :: prev, now
      integer  :: discr_k
      real(wp) :: discr

      integer  :: iter
      real(wp) :: gam_k, denom_k, constr_k

      n_var = this%n_var
      n_constr = this%n_constr
      now = this%constr_grad_step(1)
      prev = this%constr_grad_step(2)

      !If dipoles need to be computed, denominator is calculated at each timestep
      if ((.not.this%constant_constr_grad).or.(this%firsttime)) then

         call  compute_constr_gradient(system, this%constr_grad(1:n_var, 1:n_var, now))
         if (this%charge_neutrality) this%constr_grad(:, n_constr, now) = 1.0_wp

         !Gradient is constant during simulation. Setting same values for t and tpdt.
         if (this%firsttime) then
            this%constr_grad(:,:,prev) = this%constr_grad(:,:,now)
            this%firsttime=.false.
         end if

         this%denom(:) = 0.0_wp
         do k = 1, n_constr
            denom_k = 0.0_wp
            do j = 1, k-1
               denom_k       = denom_k       + this%constr_grad(j,k,prev)*this%constr_grad(j,k,now)
               this%denom(j) = this%denom(j) + this%constr_grad(j,k,prev)*this%constr_grad(j,k,now)
            end do
            this%denom(k) = denom_k + this%constr_grad(k,k,prev)*this%constr_grad(k,k,now)
         end do
      end if

      this%ggamma = 0.0_wp

      !Starting iterative procedure
      maze_converged = .false.
      constr_k = 0.0_wp
      do iter = 1, this%max_iterations

         discr   = 0.0_wp
         discr_k = -1

         do k = 1, n_constr !Looping over constraints

            !Computing sigma_k
            if (k.le.n_var) then
               !Computing constraints for maze
               constr_k = this%const_constr(k)
               do j = 1, n_var
                  constr_k = constr_k + this%constr_grad(j,k,now)*x(j)
               end do
            else
               !Computing additional constraint
               constr_k = 0.0_wp
               do j = 1, n_var
                  constr_k = constr_k + x(j)
               end do
            end if

            !Checking if greater than tolerance
            if (dabs(constr_k).gt.this%tol) then
               if (dabs(constr_k).gt.discr) then

                  discr = dabs(constr_k)
                  discr_k = k
               endif

               !Computing part of Lagrange multiplier
               gam_k = -this%sor_param*constr_k/this%denom(k)
               this%ggamma(k) = this%ggamma(k) + gam_k

               !Updating MaZe variables
               do j = 1, n_var
                  x(j) = x(j) + gam_k*this%constr_grad(j,k,prev)
               end do

            end if

         end do !End looping over constraints

         ! write(*,*)iter,discr,discr_k,"#shake"

         !Checking the residual on the constraint is less than tolerance
         if (discr.eq.0.0_wp) then
            this%last_iteration_count = iter
            this%total_iteration_count = this%total_iteration_count + iter
            do k = 1, n_constr
               if (k.le.n_var) then
                  constr_k = this%const_constr(k)
                  do j = 1, n_var
                     constr_k = constr_k + this%constr_grad(j, k, now)*x(j)
                  end do
               else
                  constr_k = 0.0_wp
                  do j = 1, n_var
                     constr_k = constr_k + x(j)
                  end do
               end if
               if (dabs(constr_k).gt.discr) discr = dabs(constr_k)
            end do
            this%last_max_constr = discr
            maze_converged = .true.
            exit
         end if

      end do !End of iterative procedure

      if (.not.maze_converged) then
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         discr = 0.0_wp
         do k = 1, n_constr
            if (k.le.n_var) then
               constr_k = this%const_constr(k)
               do j = 1, n_var
                  constr_k = constr_k + this%constr_grad(j, k, now)*x(j)
               end do
            else
               constr_k = 0.0_wp
               do j = 1, n_var
                  constr_k = constr_k + x(j)
               end do
            end if
            if (dabs(constr_k).gt.discr) discr = dabs(constr_k)
         end do
         this%last_max_constr = discr
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "maze.f90", "MaZe failed to converge")
      end if

   end subroutine solve_shake

   subroutine solve_block_iterate(this, system, compute_constr_gradient, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_stdio, only: MW_stderr
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine compute_constr_gradient(system, constr_grad)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: constr_grad(:,:)
         end subroutine compute_constr_gradient
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals (common)
      !---------------
      logical  :: mlbshake_converged
      integer  :: j, k, kk, h, hh, iblock, iter
      integer  :: n_var, n_red, n_blocks
      integer  :: prev, now
      integer  :: discr_k
      real(wp) :: discr
      real(wp) :: gam_kk, constr_kk, x_j

      n_var = this%n_var
      n_red = this%n_red
      n_blocks = this%n_blocks
      now = this%constr_grad_step(1)
      prev = this%constr_grad_step(2)

      !If dipoles need to be computed, denominator is calculated at each timestep
      if ((.not.this%constant_constr_grad).or.(this%firsttime)) then

         call  compute_constr_gradient(system, this%constr_grad(:,:, now))

         !Gradient is constant during simulation. Setting same values for t and tpdt.
         if (this%firsttime) then
            this%constr_grad(:, :, prev) = this%constr_grad(:, :, now)
            this%firsttime=.false.
         end if

         do iblock = 1, n_blocks
            hh = 1
            do h = (iblock-1)*n_red+1, (iblock)*n_red
               kk = 1
               do k = (iblock-1)*n_red+1, (iblock)*n_red
                  this%Aredinv(kk, hh, iblock) = 0.0_wp
                  do j = 1, n_var
                     this%Aredinv(kk, hh, iblock) = this%Aredinv(kk, hh, iblock) + &
                           this%constr_grad(j, h, now)*this%constr_grad(j, k, prev) !Inverted order of k and h for efficiency reasons.
                  end do
                  kk = kk + 1
               end do
               hh = hh + 1
            end do

            call invert_matrix(this%n_red, this%Aredinv(:,:,iblock))

         end do
      end if

      this%ggamma(:) = 0.0_wp

      mlbshake_converged = .false.
      do iter = 1, this%max_iterations !Loop over iterations

         discr = 0.0_wp
         discr_k = -1

         do iblock = 1, n_blocks !Loop over blocks

            kk = 1
            do k = (iblock-1)*n_red+1, (iblock)*n_red !Loop over constraints inside block

               constr_kk = this%const_constr(k)
               do j = 1, n_var
                  constr_kk = constr_kk + this%constr_grad(j, k, now)*x(j)
               end do

               if (discr .lt. dabs(constr_kk)) then
                  discr = dabs(constr_kk)
                  discr_k = k
               end if

               this%constr(kk) = constr_kk
               kk = kk + 1
            end do

            if (discr .gt. this%tol) then !If maximum constraint inside block is greater than tolerance than solve reduced system

               kk = 1
               do k = (iblock-1)*n_red+1, (iblock)*n_red !Computing lagrange multipliers for reduced system

                  gam_kk = 0.0_wp

                  hh = 1
                  do h = (iblock-1)*n_red+1, (iblock)*n_red
                     gam_kk = gam_kk - this%Aredinv(hh, kk, iblock)*this%constr(hh) !A_hk is in fact A_kh
                     hh = hh + 1
                  end do
                  gam_kk = this%sor_param*gam_kk
                  this%ggamma(k) = this%ggamma(k) + gam_kk
                  this%block_ggamma(kk) = gam_kk

                  kk = kk + 1
               end do

               do j = 1, n_var !Computing new "coordinates" for reduced system

                  x_j = x(j)

                  kk = 1
                  do k = (iblock-1)*n_red+1, (iblock)*n_red

                     x_j = x_j + this%block_ggamma(kk)*this%constr_grad(k, j, prev)

                     kk = kk + 1
                  end do
                  x(j) = x_j

               end do

            end if

         end do !End loop over blocks

         ! write(*,*) iter, discr, "#B-shake"

         if (discr.lt.this%tol) then
            this%last_iteration_count = iter
            this%total_iteration_count = this%total_iteration_count + iter
            discr = 0.0_wp
            do k = 1, n_var
               constr_kk = this%const_constr(k)
               do j = 1, n_var
                  constr_kk = constr_kk + this%constr_grad(j, k, now)*x(j)
               end do
               if ((constr_kk).gt.discr) discr = dabs(constr_kk)
            end do
            this%last_max_constr = discr
            mlbshake_converged = .true.
            exit
         end if

      end do !End of iterative loop

      if (.not.mlbshake_converged) then
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         discr = 0.0_wp
         do k = 1, n_var
            constr_kk = this%const_constr(k)
            do j = 1, n_var
               constr_kk = constr_kk + this%constr_grad(j, k, now)*x(j)
            end do
            if (dabs(constr_kk).gt.discr) discr = dabs(constr_kk)
         end do
         this%last_max_constr = discr
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "maze.f90", "MaZe failed to converge")
      end if

   end subroutine solve_block_iterate

   subroutine solve_CG_store(this, system, compute_constr_gradient, matvec_product, inner_product, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_stdio, only: MW_stderr
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine compute_constr_gradient(system, constr_grad)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(out) :: constr_grad(:,:)
         end subroutine compute_constr_gradient
      end interface

      interface
         subroutine matvec_product(system, mat, vec, matvec_prod)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(in) :: system
            real(wp), intent(in) :: mat(:,:)
            real(wp), intent(in) :: vec(:)
            real(wp), intent(out) :: matvec_prod(:)
         end subroutine matvec_product
      end interface

      interface
         subroutine inner_product(system, vec_v, vec_w, inner_prod)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(in) :: system
            real(wp), intent(in) :: vec_v(:)
            real(wp), intent(in) :: vec_w(:)
            real(wp), intent(out) :: inner_prod
         end subroutine inner_product
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals (common)
      !---------------
      integer  :: n_constr, n_var
      integer  :: iter = 0
      integer  :: prev, now
      real(wp) :: discr, res_norm
      real(wp) :: res_dot_eta_new, res_dot_eta_old, pAp
      real(wp) :: alpha, beta

      n_var = this%n_var
      n_constr = this%n_constr
      now = this%constr_grad_step(1)
      prev = this%constr_grad_step(2)

      if ((.not.this%constant_constr_grad).or.(this%firsttime)) then

         call get_shake_matrix(this, system, compute_constr_gradient, "symmetric")
         this%firsttime = .false.
      end if

      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)
      if (this%charge_neutrality) this%constr(n_constr) = sum(x)

      discr = maxval(abs(this%constr))

      call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%ggamma(1:n_var), this%Aggamma(1:n_var))
      if (this%charge_neutrality) this%Aggamma(n_constr) = 1.0_wp !TO BE IMPLEMENTED

      this%res(:) = this%Aggamma(:) + this%constr(:)
      this%eta(:) = this%jacobi_precond(:)*this%res(:)
      this%p(:)   = -this%eta(:)

      call inner_product(system, this%res(1:n_var), this%eta(1:n_var), res_dot_eta_old)
      if (this%charge_neutrality) res_dot_eta_old = res_dot_eta_old + 1.0_wp !TO BE IMPLEMENTED
      res_norm = maxval(abs(this%res))

      if (res_norm.gt.this%tol) then

         do iter = 1, this%max_iterations

            call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%p(1:n_var), this%Ap(1:n_var))
            if (this%charge_neutrality) this%Ap(n_constr) = 1.0_wp !TO BE IMPLEMENTED
            call inner_product(system, this%p(1:n_var), this%Ap(1:n_var), pAp)
            if (this%charge_neutrality) pAp = pAp + 1.0_wp !TO BE IMPLEMENTED
            alpha = res_dot_eta_old/pAp

            this%ggamma(:) = this%ggamma(:) + alpha*this%p(:)

            if (mod(iter, 100) .eq. 0) then
               call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%ggamma(1:n_var), this%Aggamma(1:n_var))
               if (this%charge_neutrality) this%Aggamma(n_constr) = 1.0_wp !TO BE IMPLEMENTED
               this%res(:) = this%Aggamma(:) + this%constr(:)
            else
               this%res(:) = this%res(:) + alpha*this%Ap(:)
            end if

            this%eta(:) = this%jacobi_precond(:)*this%res(:)

            call inner_product(system, this%res(1:n_var), this%eta(1:n_var), res_dot_eta_new)
            if (this%charge_neutrality) res_dot_eta_new = res_dot_eta_new + 1.0_wp !TO BE IMPLEMENTED
            res_norm = maxval(abs(this%res))

            ! write(*,*) iter, res_norm, "#CG-shake-store"

            if (res_norm.lt.this%tol) exit

            beta = res_dot_eta_new/res_dot_eta_old
            res_dot_eta_old = res_dot_eta_new

            this%p(:) = -this%eta(:) + beta*this%p(:)

         end do

      end if

      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,prev), this%ggamma(1:n_var), this%fconstr(1:n_var))
      if (this%charge_neutrality) this%fconstr(:) = this%fconstr(:) + this%constr_grad(:,n_constr,prev)*this%ggamma(n_constr)

      x(:) = x(:) + this%fconstr(:)

      call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)
      if (this%charge_neutrality) this%constr(n_constr) = sum(x)

      discr = maxval(abs(this%constr))

      ! write(*,*) !discr, "#CG-shake-store discr"

      if (discr.lt.this%tol) then
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         this%last_max_constr = discr
      else
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         this%last_max_constr = discr
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "maze.f90", "MaZe failed to converge")
      end if

   end subroutine solve_CG_store

   subroutine solve_CG_nostore(this, system, apply_constr_gradient, inner_product, x)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      use MW_stdio, only: MW_stderr
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_maze_t), intent(inout) :: this
      type(MW_system_t), intent(inout) :: system  !< electrode parameters

      interface
         subroutine apply_constr_gradient(system, x, y)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(inout) :: system
            real(wp), intent(in) :: x(:)
            real(wp), intent(out) :: y(:)
         end subroutine apply_constr_gradient
      end interface

      interface
         subroutine inner_product(system, vec_v, vec_w, inner_prod)
            use MW_kinds, only: wp
            use MW_system, only: MW_system_t
            implicit none
            type(MW_system_t), intent(in) :: system
            real(wp), intent(in) :: vec_v(:)
            real(wp), intent(in) :: vec_w(:)
            real(wp), intent(out) :: inner_prod
         end subroutine inner_product
      end interface

      real(wp), intent(inout) :: x(:)

      !Locals (common)
      !---------------
      integer  :: n_constr, n_var
      integer  :: iter = 0
      integer  :: prev, now
      real(wp) :: discr, res_norm
      real(wp) :: res_dot_res_new, res_dot_res_old, pAp
      real(wp) :: alpha, beta

      n_var = this%n_var
      n_constr = this%n_constr
      now = this%constr_grad_step(1)
      prev = this%constr_grad_step(2)

      call apply_constr_gradient(system, x, this%constr(1:n_var))
      ! call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)
      if (this%charge_neutrality) this%constr(n_constr) = sum(x)

      discr = maxval(abs(this%constr))

      call apply_constr_gradient(system, this%ggamma(1:n_var), this%Aggamma(1:n_var))
      call apply_constr_gradient(system, this%Aggamma(1:n_var), this%Aggamma(1:n_var))
      ! call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%ggamma(1:n_var), this%Aggamma(1:n_var))
      if (this%charge_neutrality) this%Aggamma(n_constr) = 1.0_wp !TO BE IMPLEMENTED

      this%res(:) = this%Aggamma(:) + this%constr(:)
      this%p(:)   = -this%res(:)

      call inner_product(system, this%res(1:n_var), this%res(1:n_var), res_dot_res_old)
      if (this%charge_neutrality) res_dot_res_old = res_dot_res_old + 1.0_wp !TO BE IMPLEMENTED
      res_norm = maxval(abs(this%res))

      if (res_norm.gt.this%tol) then

         do iter = 1, this%max_iterations

            call apply_constr_gradient(system, this%p(1:n_var), this%Ap(1:n_var))
            call apply_constr_gradient(system, this%Ap(1:n_var), this%Ap(1:n_var))
            ! call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%p(1:n_var), this%Ap(1:n_var))
            if (this%charge_neutrality) this%Ap(n_constr) = 1.0_wp !TO BE IMPLEMENTED
            call inner_product(system, this%p(1:n_var), this%Ap(1:n_var), pAp)
            if (this%charge_neutrality) pAp = pAp + 1.0_wp !TO BE IMPLEMENTED
            alpha = res_dot_res_old/pAp

            this%ggamma(:) = this%ggamma(:) + alpha*this%p(:)

            if (mod(iter, 100) .eq. 0) then
               call apply_constr_gradient(system, this%ggamma(1:n_var), this%Aggamma(1:n_var))
               call apply_constr_gradient(system, this%Aggamma(1:n_var), this%Aggamma(1:n_var))
               ! call matvec_product(system, this%Ainv(1:n_var,1:n_var), this%ggamma(1:n_var), this%Aggamma(1:n_var))
               if (this%charge_neutrality) this%Aggamma(n_constr) = 1.0_wp !TO BE IMPLEMENTED
               this%res(:) = this%Aggamma(:) + this%constr(:)
            else
               this%res(:) = this%res(:) + alpha*this%Ap(:)
            end if

            call inner_product(system, this%res(1:n_var), this%res(1:n_var), res_dot_res_new)
            if (this%charge_neutrality) res_dot_res_new = res_dot_res_new + 1.0_wp !TO BE IMPLEMENTED
            res_norm = maxval(abs(this%res))

            ! write(*,*) iter, res_norm, "#CG-shake-nostore"

            if (res_norm.lt.this%tol) exit

            beta = res_dot_res_new/res_dot_res_old
            res_dot_res_old = res_dot_res_new

            this%p(:) = -this%res(:) + beta*this%p(:)

         end do

      end if

      call apply_constr_gradient(system, this%ggamma(1:n_var), this%fconstr(1:n_var))
      ! call matvec_product(system, this%constr_grad(1:n_var,1:n_var,prev), this%ggamma(1:n_var), this%fconstr(1:n_var))
      if (this%charge_neutrality) this%fconstr(:) = this%fconstr(:) + this%constr_grad(:,n_constr,prev)*this%ggamma(n_constr)

      x(:) = x(:) + this%fconstr(:)

      call apply_constr_gradient(system, x(1:n_var), this%constr(1:n_var))
      ! call matvec_product(system, this%constr_grad(1:n_var,1:n_var,now), x(1:n_var), this%constr(1:n_var))
      this%constr(1:n_var) = this%const_constr(1:n_var) + this%constr(1:n_var)
      if (this%charge_neutrality) this%constr(n_constr) = sum(x)

      discr = maxval(abs(this%constr))

      ! write(*,*) !discr, "#CG-shake-nostore discr"

      if (discr.lt.this%tol) then
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         this%last_max_constr = discr
      else
         this%last_iteration_count = iter
         this%total_iteration_count = this%total_iteration_count + iter
         this%last_max_constr = discr
         call print_statistics(this, MW_stderr)
         call MW_errors_runtime_error("solve", "maze.f90", "MaZe failed to converge")
      end if

   end subroutine solve_CG_nostore

   ! ================================================================================
   include 'matrix_inversion.inc'

end module MW_maze

! Manage timing routine
module MW_timers

   implicit none
   private

   ! subroutine
   public :: MW_timers_initialize
   public :: MW_timers_start
   public :: MW_timers_pause
   public :: MW_timers_resume
   public :: MW_timers_stop
   public :: MW_timers_print
   public :: MW_timers_lastElapsedTime

   integer, parameter, public :: TIMER_TOTAL = 1

   ! Main
   integer, parameter :: NUM_TIMER_MAIN = 3
   integer, parameter :: OFFSET_TIMER_MAIN = 1
   integer, parameter, public :: TIMER_INITIALIZATION = OFFSET_TIMER_MAIN + 1
   integer, parameter, public :: TIMER_SETUP = OFFSET_TIMER_MAIN + 2
   integer, parameter, public :: TIMER_MAIN_LOOP = OFFSET_TIMER_MAIN + 3

   character(32), parameter :: TIMERS_DESCRIPTIONS_MAIN(NUM_TIMER_MAIN) = [ &
         "initialization:                 ", &
         "setup:                          ", &
         "main loop:                      "]

   ! Coulomb Melt-Elec Potential
   integer, parameter :: NUM_TIMER_COULOMB_MELTELEC = 3
   integer, parameter :: OFFSET_TIMER_COULOMB_MELTELEC = 4
   integer, parameter, public :: TIMER_COULOMB_MELTELEC_LR = OFFSET_TIMER_COULOMB_MELTELEC + 1
   integer, parameter, public :: TIMER_COULOMB_MELTELEC_KEQ0 = OFFSET_TIMER_COULOMB_MELTELEC + 2
   integer, parameter, public :: TIMER_COULOMB_MELTELEC_SR = OFFSET_TIMER_COULOMB_MELTELEC + 3

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELTELEC(NUM_TIMER_COULOMB_MELTELEC) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     "]

   ! Coulomb Elec-Elec Potential
   integer, parameter :: NUM_TIMER_COULOMB_ELECELEC = 4
   integer, parameter :: OFFSET_TIMER_COULOMB_ELECELEC = 7
   integer, parameter, public :: TIMER_COULOMB_ELECELEC_LR = OFFSET_TIMER_COULOMB_ELECELEC + 1
   integer, parameter, public :: TIMER_COULOMB_ELECELEC_KEQ0 = OFFSET_TIMER_COULOMB_ELECELEC + 2
   integer, parameter, public :: TIMER_COULOMB_ELECELEC_SR = OFFSET_TIMER_COULOMB_ELECELEC + 3
   integer, parameter, public :: TIMER_COULOMB_ELECELEC_SELF = OFFSET_TIMER_COULOMB_ELECELEC + 4

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_ELECELEC(NUM_TIMER_COULOMB_ELECELEC) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "self                            "]

   ! Coulomb GradQ of the Elec-Elec Potential
   integer, parameter :: NUM_TIMER_COULOMB_GRADQ_ELECELEC = 4
   integer, parameter :: OFFSET_TIMER_COULOMB_GRADQ_ELECELEC = 11
   integer, parameter, public :: TIMER_COULOMB_GRADQ_ELECELEC_LR = OFFSET_TIMER_COULOMB_GRADQ_ELECELEC + 1
   integer, parameter, public :: TIMER_COULOMB_GRADQ_ELECELEC_KEQ0 = OFFSET_TIMER_COULOMB_GRADQ_ELECELEC + 2
   integer, parameter, public :: TIMER_COULOMB_GRADQ_ELECELEC_SR = OFFSET_TIMER_COULOMB_GRADQ_ELECELEC + 3
   integer, parameter, public :: TIMER_COULOMB_GRADQ_ELECELEC_SELF = OFFSET_TIMER_COULOMB_GRADQ_ELECELEC + 4

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_GRADQ_ELECELEC(NUM_TIMER_COULOMB_GRADQ_ELECELEC) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "self                            "]

   ! Coulomb Forces on melt particules
   integer, parameter :: NUM_TIMER_COULOMB_MELT_FORCES = 4
   integer, parameter :: OFFSET_TIMER_COULOMB_MELT_FORCES = 15
   integer, parameter, public :: TIMER_COULOMB_MELT_FORCES_LR = OFFSET_TIMER_COULOMB_MELT_FORCES + 1
   integer, parameter, public :: TIMER_COULOMB_MELT_FORCES_KEQ0 = OFFSET_TIMER_COULOMB_MELT_FORCES + 2
   integer, parameter, public :: TIMER_COULOMB_MELT_FORCES_SR = OFFSET_TIMER_COULOMB_MELT_FORCES + 3
   integer, parameter, public :: TIMER_COULOMB_MELT_FORCES_MOL = OFFSET_TIMER_COULOMB_MELT_FORCES + 4

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELT_FORCES(NUM_TIMER_COULOMB_MELT_FORCES) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "intramolecular                  "]

   ! Coulomb Potential on Melt particules
   integer, parameter :: NUM_TIMER_COULOMB_MELT_POTENTIAL = 5
   integer, parameter :: OFFSET_TIMER_COULOMB_MELT_POTENTIAL = 19
   integer, parameter, public :: TIMER_COULOMB_MELT_POTENTIAL_LR = OFFSET_TIMER_COULOMB_MELT_POTENTIAL + 1
   integer, parameter, public :: TIMER_COULOMB_MELT_POTENTIAL_KEQ0 = OFFSET_TIMER_COULOMB_MELT_POTENTIAL + 2
   integer, parameter, public :: TIMER_COULOMB_MELT_POTENTIAL_SR = OFFSET_TIMER_COULOMB_MELT_POTENTIAL + 3
   integer, parameter, public :: TIMER_COULOMB_MELT_POTENTIAL_MOL = OFFSET_TIMER_COULOMB_MELT_POTENTIAL + 4
   integer, parameter, public :: TIMER_COULOMB_MELT_POTENTIAL_SELF = OFFSET_TIMER_COULOMB_MELT_POTENTIAL + 5

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELT_POTENTIAL(NUM_TIMER_COULOMB_MELT_POTENTIAL) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "intramolecular                  ", &
         "self                            "]

   ! Electric field due to charges on melt particules
   integer, parameter :: NUM_TIMER_COULOMB_MELT_ELECQ = 4
   integer, parameter :: OFFSET_TIMER_COULOMB_MELT_ELECQ = 24
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECQ_LR = OFFSET_TIMER_COULOMB_MELT_ELECQ + 1
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECQ_KEQ0 = OFFSET_TIMER_COULOMB_MELT_ELECQ + 2
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECQ_SR = OFFSET_TIMER_COULOMB_MELT_ELECQ + 3
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECQ_MOL = OFFSET_TIMER_COULOMB_MELT_ELECQ + 4

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELT_ELECQ(NUM_TIMER_COULOMB_MELT_ELECQ) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "intramolecular                  "] 

   ! Electric field due to dipoles on Melt particules
   integer, parameter :: NUM_TIMER_COULOMB_MELT_ELECMU = 5
   integer, parameter :: OFFSET_TIMER_COULOMB_MELT_ELECMU = 28
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECMU_LR = OFFSET_TIMER_COULOMB_MELT_ELECMU + 1
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECMU_KEQ0 = OFFSET_TIMER_COULOMB_MELT_ELECMU + 2
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECMU_SR = OFFSET_TIMER_COULOMB_MELT_ELECMU + 3
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECMU_MOL = OFFSET_TIMER_COULOMB_MELT_ELECMU + 4
   integer, parameter, public :: TIMER_COULOMB_MELT_ELECMU_SELF = OFFSET_TIMER_COULOMB_MELT_ELECMU + 5

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELT_ELECMU(NUM_TIMER_COULOMB_MELT_ELECMU) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "intramolecular                  ", &
         "self                            "]

   ! Gradmu of the electric field on Melt particules
   integer, parameter :: NUM_TIMER_COULOMB_MELT_GRADMU_ELEC = 4
   integer, parameter :: OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC = 33
   integer, parameter, public :: TIMER_COULOMB_MELT_GRADMU_ELEC_LR = OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC + 1
   integer, parameter, public :: TIMER_COULOMB_MELT_GRADMU_ELEC_KEQ0 = OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC + 2
   integer, parameter, public :: TIMER_COULOMB_MELT_GRADMU_ELEC_SR = OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC + 3
   integer, parameter, public :: TIMER_COULOMB_MELT_GRADMU_ELEC_SELF = OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC + 4

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_MELT_GRADMU_ELEC(NUM_TIMER_COULOMB_MELT_GRADMU_ELEC) = [ &
         "long range                      ", &
         "k==0                            ", &
         "short range                     ", &
         "self                            "]

   ! Rattle
   integer, parameter :: NUM_TIMER_RATTLE = 2
   integer, parameter :: OFFSET_TIMER_RATTLE = 37
   integer, parameter, public :: TIMER_RATTLE_POSITIONS = OFFSET_TIMER_RATTLE + 1
   integer, parameter, public :: TIMER_RATTLE_VELOCITIES = OFFSET_TIMER_RATTLE + 2

   character(32), parameter :: TIMERS_DESCRIPTIONS_RATTLE(NUM_TIMER_RATTLE) = [ &
         "positions                       ", &
         "velocities                      "]

   ! Van der Waals (=LJ, FT, XFT, DAIM, Steele)
   integer, parameter :: NUM_TIMER_VAN_DER_WAALS = 2
   integer, parameter :: OFFSET_TIMER_VAN_DER_WAALS = 39
   integer, parameter, public :: TIMER_VAN_DER_WAALS_MELT_FORCES = OFFSET_TIMER_VAN_DER_WAALS + 1
   integer, parameter, public :: TIMER_VAN_DER_WAALS_MELT_POTENTIAL = OFFSET_TIMER_VAN_DER_WAALS + 2

   character(32), parameter :: TIMERS_DESCRIPTIONS_VAN_DER_WAALS(NUM_TIMER_VAN_DER_WAALS) = [ &
         "vdW  forces                     ", &
         "vdW  potential                  "]

   ! INTRAMOLECULAR
   integer, parameter :: NUM_TIMER_INTRA = 2
   integer, parameter :: OFFSET_TIMER_INTRA = 41
   integer, parameter, public :: TIMER_INTRA_MELT_FORCES = OFFSET_TIMER_INTRA + 1
   integer, parameter, public :: TIMER_INTRA_MELT_POTENTIAL = OFFSET_TIMER_INTRA + 2

   character(32), parameter :: TIMERS_DESCRIPTIONS_INTRA(NUM_TIMER_INTRA) = [ &
         "Intramolecular  forces         ", &
         "Intramolecular potential       "]

   ! Minimizer (charges)
   integer, parameter :: NUM_TIMER_MINQ = 3
   integer, parameter :: OFFSET_TIMER_MINQ = 43
   integer, parameter, public :: TIMER_MINQ = OFFSET_TIMER_MINQ + 1
   integer, parameter, public :: TIMER_MINQ_INVMAT = OFFSET_TIMER_MINQ + 2
   integer, parameter, public :: TIMER_MINQ_MATVEC = OFFSET_TIMER_MINQ + 3

   character(32), parameter :: TIMERS_DESCRIPTIONS_MINQ(NUM_TIMER_MINQ) = [ &
         "Electrode charge computation   ", &
         "Inversion of the matrix        ", &
         "One matrix-vector product      "]

   ! Minimizer (dipoles)
   integer, parameter :: NUM_TIMER_MINMU = 3
   integer, parameter :: OFFSET_TIMER_MINMU = 46
   integer, parameter, public :: TIMER_MINMU = OFFSET_TIMER_MINMU + 1
   integer, parameter, public :: TIMER_MINMU_INVMAT = OFFSET_TIMER_MINMU + 2
   integer, parameter, public :: TIMER_MINMU_MATVEC = OFFSET_TIMER_MINMU + 3

   character(32), parameter :: TIMERS_DESCRIPTIONS_MINMU(NUM_TIMER_MINMU) = [ &
         "Melt dipoles computation       ", &
         "Inversion of the matrix        ", &
         "One matrix-vector product      "]

   ! Minimizer (AIM radius and dipoles)
   integer, parameter :: NUM_TIMER_MINAIM = 1
   integer, parameter :: OFFSET_TIMER_MINAIM = 49 
   integer, parameter, public :: TIMER_MINAIM = OFFSET_TIMER_MINAIM + 1

   character(32), parameter :: TIMERS_DESCRIPTIONS_MINAIM(NUM_TIMER_MINAIM) = [ &
         "AIM DOFs computation            "]

   ! Diagnostics
   integer, parameter :: NUM_TIMER_DIAG = 2
   integer, parameter :: OFFSET_TIMER_DIAG = 50
   integer, parameter, public :: TIMER_DIAG_COMPUTE = OFFSET_TIMER_DIAG + 1
   integer, parameter, public :: TIMER_DIAG_IO = OFFSET_TIMER_DIAG + 2

   character(32), parameter :: TIMERS_DESCRIPTIONS_DIAG(NUM_TIMER_DIAG) = [ &
         "diagnostics computations        ", &
         "IO                              "]

   ! Measured but not printed timers
   integer, parameter :: NUM_TIMER_MISC = 1
   integer, parameter :: OFFSET_TIMER_MISC = 52
   integer, parameter, public :: TIMER_STEP = OFFSET_TIMER_MISC + 1

   ! Electric field gradient on melt particles
   integer, parameter :: NUM_TIMER_COULOMB_EFG_MELT = 3
   integer, parameter :: OFFSET_TIMER_COULOMB_EFG_MELT = 53
   integer, parameter, public :: TIMER_COULOMB_EFG_MELT_LR = OFFSET_TIMER_COULOMB_EFG_MELT + 1
   integer, parameter, public :: TIMER_COULOMB_EFG_MELT_SR = OFFSET_TIMER_COULOMB_EFG_MELT + 2
   integer, parameter, public :: TIMER_COULOMB_EFG_MELT_SELF = OFFSET_TIMER_COULOMB_EFG_MELT + 3

   character(32), parameter :: TIMERS_DESCRIPTIONS_COULOMB_TIMER_COULOMB_EFG_MELT(NUM_TIMER_COULOMB_EFG_MELT) = [ &
         "long range                      ", &
         "short range                     ", &
         "self                            "]

   integer, parameter :: MAX_TIMER_TYPES = 56
   real,    save :: TIMERS_START(MAX_TIMER_TYPES)
   real,    save :: TIMERS_STOP(MAX_TIMER_TYPES)
   real,    save :: TIMERS_LAST(MAX_TIMER_TYPES)
   real,    save :: TIMERS_CUMUL(MAX_TIMER_TYPES)
   integer, save :: TIMERS_COUNT(MAX_TIMER_TYPES)

contains

   !================================================================================
   ! Initialize the timers
   subroutine MW_timers_initialize()
      TIMERS_START(:) = 0.0
      TIMERS_STOP(:) = 0.0
      TIMERS_LAST(:) = 0.0
      TIMERS_CUMUL(:) = 0.0
      TIMERS_COUNT(:) = 0
   end subroutine MW_timers_initialize

   !================================================================================
   ! Start a specific timer
   subroutine MW_timers_start(timer)
      integer, intent(in) :: timer

      call cpu_time(TIMERS_START(timer))
      TIMERS_STOP(timer) = 0.0
      TIMERS_COUNT(timer) = TIMERS_COUNT(timer) + 1
   end subroutine MW_timers_start

   !================================================================================
   ! Resume a specific timer
   subroutine MW_timers_resume(timer)
      integer, intent(in) :: timer

      call cpu_time(TIMERS_START(timer))
      TIMERS_STOP(timer) = 0.0
   end subroutine MW_timers_resume

   !================================================================================
   ! Stop a specific timer
   subroutine MW_timers_stop(timer)
      integer, intent(in) :: timer
      real :: time

      call cpu_time(TIMERS_STOP(timer))

      time = TIMERS_STOP(timer) - TIMERS_START(timer)
      TIMERS_LAST(timer) = time
      TIMERS_CUMUL(timer) = TIMERS_CUMUL(timer) + time

   end subroutine MW_timers_stop

   !================================================================================
   ! Pause a specific timer
   subroutine MW_timers_pause(timer)
      integer, intent(in) :: timer
      real :: time

      call cpu_time(TIMERS_STOP(timer))

      time = TIMERS_STOP(timer) - TIMERS_START(timer)
      TIMERS_LAST(timer) = time
      TIMERS_CUMUL(timer) = TIMERS_CUMUL(timer) + time

   end subroutine MW_timers_pause

   !================================================================================
   ! Print timer results to ounit
   subroutine MW_timers_print(ounit)
      integer, intent(in) :: ounit ! output unit

      integer :: i, timer
      real :: avg, cumul, total


      write(ounit, *)

      total = MW_timers_cumulatedElapsedTime(TIMER_TOTAL)
      write(ounit,'("Total elapsed time: ",es12.5," seconds.")') total
      write(ounit,*)
 
      ! Breakdown header
      write(ounit,'("Elapsed Times breakdown:")')
      write(ounit,'("========================")')
      write(ounit,'(2x,32x,a12,1x,a12,1x,a12)') &
            " average (s)","  cumul. (s)","fraction (%)"

      ! Categories break down
      do i = 1, NUM_TIMER_MAIN
         timer = i + OFFSET_TIMER_MAIN
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_MAIN(i), avg, cumul, 100.0*(cumul/total)
      end do

      ! Computing the non covered part of the code by the timers
      cumul = 0.0
      do i = 5, 52
         if((i.ne.44).and.(i.ne.47))then ! ugly but avoids double counting
            cumul = cumul + MW_timers_cumulatedElapsedTime(i)
         endif
      end do
         write(ounit,'(2x,a44,1x,es12.5,1x,f12.2)') &
               "Time breakdown                     ----     ", cumul, 100.0*(cumul/total)
         write(ounit,'(2x,a44,1x,es12.5,1x,f12.2)') &
               "=> Time NOT in breakdown           ----     ", total - cumul, 100.0*(1.0 - cumul/total)

      write(ounit,*)
      write(ounit,'("Ions->Atoms Coulomb potential")')
      write(ounit,'("-----------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELTELEC
         timer = i + OFFSET_TIMER_COULOMB_MELTELEC
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELTELEC(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Atoms->Atoms Coulomb potential")')
      write(ounit,'("------------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_ELECELEC
         timer = i + OFFSET_TIMER_COULOMB_ELECELEC
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_ELECELEC(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Atoms->Atoms Coulomb grad Q of the potential")')
      write(ounit,'("--------------------------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_GRADQ_ELECELEC
         timer = i + OFFSET_TIMER_COULOMB_GRADQ_ELECELEC
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_GRADQ_ELECELEC(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb forces")')
      write(ounit,'("-------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELT_FORCES
         timer = i + OFFSET_TIMER_COULOMB_MELT_FORCES
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELT_FORCES(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb potential")')
      write(ounit,'("----------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELT_POTENTIAL
         timer = i + OFFSET_TIMER_COULOMB_MELT_POTENTIAL
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELT_POTENTIAL(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb electric field (due to charges)")')
      write(ounit,'("--------------------------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELT_ELECQ
         timer = i + OFFSET_TIMER_COULOMB_MELT_ELECQ
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELT_ELECQ(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb electric field (due to dipoles)")')
      write(ounit,'("---------------------------------------- ---")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELT_ELECMU
         timer = i + OFFSET_TIMER_COULOMB_MELT_ELECMU
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELT_ELECMU(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb electric field gradient (due to charges and dipoles)")')
      write(ounit,'("---------------------------------------- ---")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_EFG_MELT
         timer = i + OFFSET_TIMER_COULOMB_EFG_MELT
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_TIMER_COULOMB_EFG_MELT(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Ions Coulomb gradient mu of the electric field")')
      write(ounit,'("----------------------------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_COULOMB_MELT_GRADMU_ELEC
         timer = i + OFFSET_TIMER_COULOMB_MELT_GRADMU_ELEC
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_COULOMB_MELT_GRADMU_ELEC(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Rattle")')
      write(ounit,'("------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_RATTLE
         timer = i + OFFSET_TIMER_RATTLE
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_RATTLE(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("van der Waals")')
      write(ounit,'("-------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_VAN_DER_WAALS
         timer = i + OFFSET_TIMER_VAN_DER_WAALS
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_VAN_DER_WAALS(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Intramolecular")')
      write(ounit,'("--------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_INTRA
         timer = i + OFFSET_TIMER_INTRA
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_INTRA(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Additional degrees of freedom computation")')
      write(ounit,'("-----------------------------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_MINQ
         timer = i + OFFSET_TIMER_MINQ
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_MINQ(i), avg, cumul, 100.0*(cumul/total)
      end do

!     write(ounit,*)
!     write(ounit,'("Dipoles computation")')
!     write(ounit,'("-------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_MINMU
         timer = i + OFFSET_TIMER_MINMU
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_MINMU(i), avg, cumul, 100.0*(cumul/total)
      end do

!     write(ounit,*)
!     write(ounit,'("AIM DOFs computation")')
!     write(ounit,'("--------------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_MINAIM
         timer = i + OFFSET_TIMER_MINAIM
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_MINAIM(i), avg, cumul, 100.0*(cumul/total)
      end do

      write(ounit,*)
      write(ounit,'("Diagnostics")')
      write(ounit,'("-------------")')
      ! Categories break down
      do i = 1,  NUM_TIMER_DIAG
         timer = i + OFFSET_TIMER_DIAG
         avg = MW_timers_averagedElapsedTime(timer)
         cumul = MW_timers_cumulatedElapsedTime(timer)
         write(ounit,'(2x,a32,es12.5,1x,es12.5,1x,f12.2)') &
               TIMERS_DESCRIPTIONS_DIAG(i), avg, cumul, 100.0*(cumul/total)
      end do

      ! blank line below
      write(ounit,*)
   end subroutine MW_timers_print

   !================================================================================
   ! Get last elapsed time for a given timer
   real function MW_timers_lastElapsedTime(timer)
      integer, intent(in) :: timer
      MW_timers_lastElapsedTime = TIMERS_LAST(timer)
   end function MW_timers_lastElapsedTime


   !================================================================================
   ! Get cumulated elapsed time for a given timer
   real function MW_timers_cumulatedElapsedTime(timer)
      integer, intent(in) :: timer
      MW_timers_CumulatedElapsedTime = TIMERS_CUMUL(timer)
   end function MW_timers_cumulatedElapsedTime

   !================================================================================
   ! Get averaged elapsed time for a given timer
   real function MW_timers_averagedElapsedTime(timer)
      integer, intent(in) :: timer
      if (TIMERS_COUNT(timer) > 0) then
         MW_timers_AveragedElapsedTime = TIMERS_CUMUL(timer) / real(TIMERS_COUNT(timer))
      else
         MW_timers_AveragedElapsedTime = 0.0
      end if
   end function MW_timers_averagedElapsedTime

end module MW_timers

!> Module handling velocities transformation
module MW_velocity
   use MW_kinds, only: wp
   use MW_constants, only: boltzmann
   use MW_ion, only: MW_ion_t
   use MW_random, only: &
         MW_random_normal_random_number => normal_random_number
   use MW_molecule, only: MW_molecule_t
   use MW_errors, only: MW_errors_parameter_error => parameter_error

   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: initialize
   public :: rescale
   public :: com_velocity_compute
   public :: com_velocity_reset

   integer, parameter, public :: RESCALE_METHOD_NONE = 0
   integer, parameter, public :: RESCALE_METHOD_GLOBAL = 1
   integer, parameter, public :: RESCALE_METHOD_SPECIES = 2
   integer, parameter, public :: RESCALE_METHOD_MOLECULES_GLOBAL = 3
   integer, parameter, public :: RESCALE_METHOD_MOLECULES_INDEPENDENT = 4

contains

   ! ================================================================================
   !> Compute the center of mass velocity
   !!
   !! $v_com = \frac{\sum_i^N m_i v_i}{\sum_i^N m_i}$
   subroutine com_velocity_compute(ions, ions_vx, ions_vy, ions_vz, &
         com_vx, com_vy, com_vz, com_ke)
      implicit none
      ! Parameters
      ! ----------
      type(MW_ion_t), intent(in) :: ions(:)   !< ions parameters
      real(wp), intent(in) :: ions_vx(:)      !< ions velocity in x
      real(wp), intent(in) :: ions_vy(:)      !< ions velocity in y
      real(wp), intent(in) :: ions_vz(:)      !< ions velocity in z
      real(wp), intent(out) :: com_vx         !< com velocity in x
      real(wp), intent(out) :: com_vy         !< com velocity in y
      real(wp), intent(out) :: com_vz         !< com velocity in z
      real(wp), intent(out) :: com_ke         !< kinetic energy of the com

      ! Local
      ! -----
      integer :: num_ion_types, itype, iion, i
      real(wp) :: mi, mass_total
      real(wp) :: com_px, com_py, com_pz

      com_px = 0.0_wp
      com_py = 0.0_wp
      com_pz = 0.0_wp
      mass_total = 0.0_wp

      num_ion_types = size(ions,1)
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            mi = ions(itype)%mass
            do i = 1, ions(itype)%count
               iion = i + ions(itype)%offset
               com_px = com_px + mi * ions_vx(iion)
               com_py = com_py + mi * ions_vy(iion)
               com_pz = com_pz + mi * ions_vz(iion)
               mass_total = mass_total + mi
            end do
         end if
      end do

      com_ke = 0.5_wp * (com_px*com_px + com_py*com_py + com_pz*com_pz) / mass_total

      com_vx = com_px / mass_total
      com_vy = com_py / mass_total
      com_vz = com_pz / mass_total

   end subroutine com_velocity_compute

   ! ================================================================================
   ! Set the center of mass velocity to 0
   subroutine com_velocity_reset(com_vx, com_vy, com_vz, &
         ions, ions_vx, ions_vy, ions_vz)
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in)        :: com_vx    ! com velocity in x
      real(wp), intent(in)        :: com_vy    ! com velocity in y
      real(wp), intent(in)        :: com_vz    ! com velocity in z
      type(MW_ion_t), intent(in) :: ions(:)   !< ions parameters
      real(wp), intent(inout) :: ions_vx(:)      !< ions velocity in x
      real(wp), intent(inout) :: ions_vy(:)      !< ions velocity in y
      real(wp), intent(inout) :: ions_vz(:)      !< ions velocity in z

      ! Local
      ! -----
      integer :: num_ion_types, itype, iion, i

      num_ion_types = size(ions,1)
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            do i = 1, ions(itype)%count
               iion = i + ions(itype)%offset
               ions_vx(iion) = ions_vx(iion) - com_vx
               ions_vy(iion) = ions_vy(iion) - com_vy
               ions_vz(iion) = ions_vz(iion) - com_vz
            end do
         end if
      end do
   end subroutine com_velocity_reset

   ! ================================================================================
   ! Initialize particule velocities with random normal distribution
   subroutine initialize(temperature, num_dof, ions, velocity_ions)
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: temperature
      integer, intent(in) :: num_dof
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(inout) :: velocity_ions(:,:)

      ! Locals
      ! ------
      integer :: itype, iion, ixyz
      integer :: num_ion_types
      real(wp) :: harvest
      real(wp) :: sigma
      real(wp) :: kt

      num_ion_types = size(ions, 1)
      kt = boltzmann * temperature
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            sigma = sqrt(kt / ions(itype)%mass)
            do iion = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
               do ixyz = 1, 3
                  call MW_random_normal_random_number(harvest)
                  velocity_ions(iion,ixyz) = harvest * sigma
               end do
            end do
         end if
      end do
      call global_scaling(temperature, num_dof, ions, velocity_ions)
   end subroutine initialize

   ! ================================================================================
   ! Rescale particule velocities
   subroutine rescale(method, temperature, num_dof, molecules, ions, velocity_ions)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: method                 !< Rescale method to apply
      real(wp), intent(in) :: temperature           !< Target temperature
      integer, intent(in) :: num_dof                !< Number of degrees of freedom
      type(MW_molecule_t), intent(in) :: molecules(:)         !< molecules parameters
      type(MW_ion_t), intent(in) :: ions(:)         !< ions parameters
      real(wp), intent(inout) :: velocity_ions(:,:) !< ions velocities

      select case(method)
      case(RESCALE_METHOD_NONE)
         continue
      case(RESCALE_METHOD_GLOBAL)
         call global_scaling(temperature, num_dof, ions,  velocity_ions)
      case(RESCALE_METHOD_SPECIES)
         call species_scaling(temperature, num_dof, ions, velocity_ions)
      case(RESCALE_METHOD_MOLECULES_GLOBAL)
         call molecules_global_scaling(temperature, num_dof, molecules, ions, velocity_ions)
      case(RESCALE_METHOD_MOLECULES_INDEPENDENT)
         call molecules_independent_scaling(temperature, num_dof, molecules, ions, velocity_ions)
      case default
         call MW_errors_parameter_error("rescale", "velocity.f90", "method", method)
      end select
   end subroutine rescale

   ! ================================================================================
   ! Rescale all particules velocities by the same amount
   !
   ! The center of mass for all particles has its velocity set to 0
   ! The same scaling factor is applied to all particle velocities
   subroutine global_scaling(temperature, num_dof, ions, velocity_ions)
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: temperature           !< Target temperature
      integer, intent(in) :: num_dof                !< Number of degrees of freedom
      type(MW_ion_t), intent(in) :: ions(:)         !< ions parameters
      real(wp), intent(inout) :: velocity_ions(:,:) !< ions velocities
      ! Local
      ! -----
      integer ::iion, ixyz
      integer :: num_ion_types, itype
      real(wp) :: mi, visq, ke_total
      real(wp) :: temperature_system, scale
      real(wp) :: com_vx, com_vy, com_vz, com_ke

      call com_velocity_compute(ions, &
            velocity_ions(:,1), velocity_ions(:,2), velocity_ions(:,3), &
            com_vx, com_vy, com_vz, com_ke)

      call com_velocity_reset(com_vx, com_vy, com_vz, &
            ions, velocity_ions(:,1), velocity_ions(:,2), velocity_ions(:,3))

      ! Compute kinetic energy of the system and actual temperature of the system
      ke_total = 0.0_wp
      num_ion_types = size(ions,1)
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            mi = ions(itype)%mass
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               visq = 0.0_wp
               do ixyz = 1, 3
                  visq = visq + velocity_ions(iion,ixyz) * velocity_ions(iion,ixyz)
               end do
               ke_total = ke_total + 0.5_wp * mi * visq
            end do
         end if
      end do

      ! ke = num_dof*k*T/2
      temperature_system = 2.0_wp * ke_total / (real(num_dof,wp) * boltzmann)
      scale = sqrt(temperature/temperature_system)

      ! Rescale velocities
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = scale * velocity_ions(iion, ixyz)
               end do
            end do
         end if
      end do

   end subroutine global_scaling

   ! ================================================================================
   ! Rescale particules velocities by species
   !
   ! The centers of mass for each species group have their velocities set to 0.
   ! The scaling factor is applied on per species group basis.
   subroutine species_scaling(temperature, num_dof, ions, velocity_ions)
      use MW_kinds, only: wp
      use MW_constants, only: boltzmann
      use MW_ion, only: MW_ion_t
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: temperature           !< Target temperature
      integer, intent(in) :: num_dof                !< Number of degrees of freedom in the system
      type(MW_ion_t), intent(in) :: ions(:)         !< ions parameters
      real(wp), intent(inout) :: velocity_ions(:,:) !< ions velocities
      ! Local
      ! -----
      integer :: iion, ixyz
      integer :: num_ion_types, itype
      real(wp) :: mi, visq, vsq_total, ke_total
      real(wp) :: velocity_com(3)
      real(wp) :: temperature_species, scale
      integer :: num_mobile_ions, num_ions_species, num_dof_species
      real(wp) :: dof_scaled

      num_ion_types = size(ions,1)

      num_mobile_ions = 0
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            num_mobile_ions = num_mobile_ions + ions(itype)%count
         end if
      end do

      do itype = 1, num_ion_types

         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then

            ! Compute center of mass velocity for each ion species
            velocity_com(:) = 0.0_wp
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_com(ixyz) = velocity_com(ixyz) + velocity_ions(iion,ixyz)
               end do
            end do

            ! Subtract velocity_com from all ions
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = velocity_ions(iion,ixyz) - velocity_com(ixyz)
               end do
            end do

            ! Compute kinetic energy of the system and actual temperature of the system
            vsq_total = 0.0_wp
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               visq = 0.0_wp
               do ixyz = 1, 3
                  visq = visq + velocity_ions(iion,ixyz) * velocity_ions(iion,ixyz)
               end do
               vsq_total = vsq_total + visq
            end do
            mi = ions(itype)%mass
            ke_total = 0.5_wp * mi * vsq_total

            ! ke = num_dof*k*T/2
            num_ions_species = ions(itype)%count
            num_dof_species = 3 * num_ions_species
            dof_scaled = real(num_dof,wp) * (real(num_dof_species, wp) / real(3*num_mobile_ions, wp))
            temperature_species = 2.0_wp * ke_total / (dof_scaled * boltzmann)
            scale = sqrt(temperature/temperature_species)

            ! Rescale velocities
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = scale * velocity_ions(iion, ixyz)
               end do
            end do
         end if

      end do

   end subroutine species_scaling

   ! ================================================================================
   ! Rescale particules velocities by species
   ! The centers of mass for each molecule group have their velocities set to 0.
   ! The centers of mass for each species (not in a molecule) group have their velocities set to 0.
   ! The same scaling factor is applied to all particles
   subroutine molecules_global_scaling(temperature, num_dof, molecules, ions, velocity_ions)
      use MW_kinds, only: wp
      use MW_constants, only: boltzmann
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error
      use MW_ion, only: MW_ion_t
      use MW_molecule, only: MW_molecule_t
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: temperature             !< Target temperature
      integer, intent(in) :: num_dof                  !< Number of degrees of freedom in the system
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_ion_t), intent(in) :: ions(:)           !< ions parameters
      real(wp), intent(inout) :: velocity_ions(:,:)   !< ions velocities
      ! Local
      ! -----
      integer :: iion, ixyz
      integer :: num_ion_types, itype
      integer :: num_molecules, imol, isite
      real(wp) :: mi, visq, ke_total
      real(wp) :: velocity_com(3)
      real(wp) :: mass_total, temperature_species, scale
      logical :: in_molecule

      num_ion_types = size(ions,1)
      num_molecules = size(molecules,1)

      ! Loop through molecules
      ! Zero center of mass velocity for each molecule types
      do imol = 1, num_molecules

         mass_total = 0.0_wp
         velocity_com(:) = 0.0_wp
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            mi = ions(itype)%mass
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_com(ixyz) = velocity_com(ixyz) + mi * velocity_ions(iion,ixyz)
               end do
               mass_total = mass_total + mi
            end do
         end do

         do ixyz = 1, 3
            velocity_com(ixyz) = velocity_com(ixyz) / mass_total
         end do

         ! 0 COM velocity for this molecule
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = velocity_ions(iion,ixyz) - velocity_com(ixyz)
               end do
            end do
         end do
      end do

      ! Zero center of mass velocity for each ion species which are not in a molecule
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            in_molecule = .false.
            InMoleculeSearchLoop: do imol = 1, num_molecules
               do isite = 1, molecules(imol)%num_sites
                  if (itype == molecules(imol)%sites(isite)) then
                     in_molecule = .true.
                     exit InMoleculeSearchLoop
                  end if
               end do
            end do InMoleculeSearchLoop
            if (.not. in_molecule) then
               velocity_com(:) = 0.0_wp
               do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
                  do ixyz = 1, 3
                     velocity_com(ixyz) = velocity_com(ixyz) + velocity_ions(iion,ixyz)
                  end do
               end do

               ! Subtract velocity_com from all ions
               do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
                  do ixyz = 1, 3
                     velocity_ions(iion,ixyz) = velocity_ions(iion,ixyz) - velocity_com(ixyz)
                  end do
               end do
            end if
         end if
      end do

      ! Compute kinetic energy of the system and actual temperature of the system
      ke_total = 0.0_wp
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            mi = ions(itype)%mass
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               visq = 0.0_wp
               do ixyz = 1, 3
                  visq = visq + velocity_ions(iion,ixyz) * velocity_ions(iion,ixyz)
               end do
               ke_total = ke_total + 0.5_wp * mi * visq
            end do
         end if
      end do

      ! ke = num_dof*k*T/2
      temperature_species = 2.0_wp * ke_total / (real(num_dof,wp) * boltzmann)
      scale = sqrt(temperature/temperature_species)

      ! Rescale velocities
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = scale * velocity_ions(iion, ixyz)
               end do
            end do
         end if
      end do

   end subroutine molecules_global_scaling

   ! ================================================================================
   ! Rescale particules velocities by species
   ! The centers of mass for each molecule group have their velocities set to 0.
   ! The centers of mass for each species (not in a molecule) group have their velocities set to 0.
   ! Independent scaling factor is applied to each molecule type and independent particule type
   subroutine molecules_independent_scaling(temperature, num_dof, molecules, ions, velocity_ions)
      use MW_kinds, only: wp
      use MW_constants, only: boltzmann
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_deallocate_error => deallocate_error
      use MW_ion, only: MW_ion_t
      use MW_molecule, only: MW_molecule_t
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(in) :: temperature             !< Target temperature
      integer, intent(in) :: num_dof                  !< Number of degrees of freedom in the system
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_ion_t), intent(in) :: ions(:)           !< ions parameters
      real(wp), intent(inout) :: velocity_ions(:,:)   !< ions velocities
      ! Local
      ! -----
      integer :: iion, ixyz
      integer :: num_ion_types, itype
      integer :: num_molecules, imol, isite
      real(wp) :: mi, visq, ke_total
      real(wp) :: velocity_com(3)
      real(wp) :: mass_total, temperature_species, scale
      logical :: in_molecule
      integer :: num_mobile_ions, num_ions_species, num_dof_species
      real(wp) :: dof_scaled


      num_ion_types = size(ions,1)
      num_molecules = size(molecules,1)

      num_mobile_ions = 0
      do itype = 1, num_ion_types
         if (ions(itype)%mobile .and. (.not. ions(itype)%is_fourth_site)) then
            num_mobile_ions = num_mobile_ions + ions(itype)%count
         end if
      end do

      ! Loop through molecules
      ! Zero center of mass velocity for each molecule types
      do imol = 1, num_molecules

         mass_total = 0.0_wp
         velocity_com(:) = 0.0_wp
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            mi = ions(itype)%mass
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_com(ixyz) = velocity_com(ixyz) + mi * velocity_ions(iion,ixyz)
               end do
               mass_total = mass_total + mi
            end do
         end do

         do ixyz = 1, 3
            velocity_com(ixyz) = velocity_com(ixyz) / mass_total
         end do

         ! 0 COM velocity for this molecule
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = velocity_ions(iion,ixyz) - velocity_com(ixyz)
               end do
            end do
         end do

         ! Compute kinetic energy of the sub-system for this molecule
         ! and actual temperature of the system
         ke_total = 0.0_wp
         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            mi = ions(itype)%mass
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               visq = 0.0_wp
               do ixyz = 1, 3
                  visq = visq + velocity_ions(iion,ixyz) * velocity_ions(iion,ixyz)
               end do
               ke_total = ke_total + 0.5_wp * mi * visq
            end do
         end do

         num_ions_species = molecules(imol)%num_sites * molecules(imol)%n
         num_dof_species = 3 * num_ions_species - molecules(imol)%num_constraints
         dof_scaled = real(num_dof,wp) * (real(num_dof_species,wp) / real(3*num_mobile_ions,wp))
         temperature_species = 2.0_wp * ke_total / (dof_scaled * boltzmann)
         scale = sqrt(temperature/temperature_species)

         do isite = 1, molecules(imol)%num_sites
            itype = molecules(imol)%sites(isite)
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = scale * velocity_ions(iion, ixyz)
               end do
            end do
         end do
      end do


      ! Zero center of mass velocity and scale temperature for each
      ! ion species which are not in a molecule
      do itype = 1, num_ion_types
         in_molecule = .false.
         InMoleculeSearchLoop: do imol = 1, num_molecules
            do isite = 1, molecules(imol)%num_sites
               if (itype == molecules(imol)%sites(isite)) then
                  in_molecule = .true.
                  exit InMoleculeSearchLoop
               end if
            end do
         end do InMoleculeSearchLoop
         if (.not. in_molecule) then
            velocity_com(:) = 0.0_wp
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_com(ixyz) = velocity_com(ixyz) + velocity_ions(iion,ixyz)
               end do
            end do

            ! Subtract velocity_com from all ions
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = velocity_ions(iion,ixyz) - velocity_com(ixyz)
               end do
            end do

            ! Compute kinetic energy for this species
            mi = ions(itype)%mass
            ke_total = 0.0_wp
            do iion = ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               visq = 0.0_wp
               do ixyz = 1, 3
                  visq = visq + velocity_ions(iion,ixyz) * velocity_ions(iion,ixyz)
               end do
               ke_total = ke_total + 0.5_wp * mi * visq
            end do

            num_ions_species = ions(itype)%count
            num_dof_species = 3 * num_ions_species
            dof_scaled = real(num_dof,wp) * (real(num_dof_species,wp) / real(3*num_mobile_ions,wp))
            temperature_species = 2.0_wp * ke_total / (dof_scaled * boltzmann)
            scale = sqrt(temperature/temperature_species)

            ! Rescale velocities
            do iion = 1, ions(itype)%offset+1, ions(itype)%offset+ions(itype)%count
               do ixyz = 1, 3
                  velocity_ions(iion,ixyz) = scale * velocity_ions(iion, ixyz)
               end do
            end do

         end if
      end do

   end subroutine molecules_independent_scaling


end module MW_velocity

!> Ion-dipole damping potential
!! -------------------
!!
!!
module MW_damping
   use MW_kinds, only: wp
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_damping_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type

   type MW_damping_t
      integer :: num_species = 0                            ! number of species
      real(wp), dimension(:,:), allocatable :: b            ! (num_species,num_species) inverse of range of the damping
      integer, dimension(:,:), allocatable :: order         ! (num_species,num_species) order of the Tang-Toennies function
      real(wp), dimension(:,:), allocatable :: c            ! (num_species,num_species) intensity of the damping
   end type MW_damping_t

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, num_species)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ---------_
      type(MW_damping_t), intent(inout) :: this      !> structure to be defined
      integer, intent(in) :: num_species                    !> number of species

      ! Local
      ! -----
      integer :: ierr

      if (num_species <= 0) then
         call MW_errors_parameter_error("define_type", "damping.f90",&
               "num_species", num_species)
      end if

      this%num_species = num_species

      allocate(this%b(num_species,num_species), &
            this%order(num_species,num_species), &
            this%c(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "damping.f90", ierr)
      this%b(:,:) = 0.0_wp
      this%order(:,:) = 0
      this%c(:,:) = 0.0_wp

   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_damping_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%b)) then
         deallocate(this%b, this%order, this%c, stat=ierr)
         if (ierr /= 0) &
               call MW_errors_deallocate_error("define_type", "damping.f90", ierr)
      end if

      this%num_species = 0
   end subroutine void_type


   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, species_names, ounit)
      use MW_kinds, only: PARTICLE_NAME_LEN
      implicit none
      type(MW_damping_t), intent(in) :: this               ! structure to be printed
      character(PARTICLE_NAME_LEN),   intent(in) :: species_names(:)   ! names of the species
      integer,                   intent(in) :: ounit              ! output unit

      integer :: i, j

      write(ounit, '("|damping| ",8x,1x,8x,1x,"    b       ",1x," order ", &
            &"     c      ")')

      do j = 1, this%num_species
         do i = 1, this%num_species
            write(ounit, '("|damping| ",a8,1x,a8,1x,es12.5,1x,i1,1x,es12.5)') &
                  species_names(i), species_names(j), this%b(i,j), this%order(i,j),&
                  this%c(i,j)
         end do
      end do

   end subroutine print_type

end module MW_damping

! Module to compute short range electrostatic potential
module MW_coulomb_sr
   use MW_kinds, only: wp
   use MW_errors, only: MW_errors_allocate_error => allocate_error
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_damping, only: MW_damping_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   use MW_constants, only: sqrtpi
   use MW_multipole_tensors, only: MW_multipole_tensors_tij_ab => tij_ab 
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: gradQelec_potential !grad_Q [grad_Q [U^sr_QQ]]
   public :: qmelt2Qelec_potential !grad_Q [U^sr_qQ]
   public :: Qelec2Qelec_potential !grad_Q [U^sr_QQ]
   public :: melt_efg !-grad_r grad_r [(U^sr_qq)] 
   public :: melt_forces !-grad_r [(U^sr_qq) + (U^sr_QQ) + (U^sr_qQ)]
   public :: energy !(U^sr_qq) + (U^sr_QQ) + (U^sr_qQ)
   public :: setup_sr_interaction

contains

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine gradQelec_potential(num_PBC, localwork, ewald, box, &
      electrodes, xyz_atoms, gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: gradQ_V(:,:)       !< Coulomb potential

      select case (num_PBC)
      case(2)
         call gradQelec_potential_2DPBC(localwork, ewald, box, &
         electrodes, xyz_atoms, gradQ_V)
      case(3)
         call gradQelec_potential_3DPBC(localwork, ewald, box, &
         electrodes, xyz_atoms, gradQ_V)
      end select
   end subroutine gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   subroutine qmelt2Qelec_potential(num_PBC, localwork, ewald, box, &
      ions, xyz_ions, electrodes, xyz_atoms, V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: V(:)       !< Coulomb potential

      select case (num_PBC)
      case(2)
         call qmelt2Qelec_potential_2DPBC(localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, V)
      case(3)
         call qmelt2Qelec_potential_3DPBC(localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, V)
      end select
   end subroutine qmelt2Qelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine Qelec2Qelec_potential(num_PBC, localwork, ewald, box, &
      electrodes, xyz_atoms, q_elec, V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_ewald_t),     intent(in)    :: ewald     !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: V(:)       !< Coulomb potential

      select case (num_PBC)
      case(2)
         call Qelec2Qelec_potential_2DPBC(localwork, ewald, box, &
         electrodes, xyz_atoms, q_elec, V)
      case(3)
         call Qelec2Qelec_potential_3DPBC(localwork, ewald, box, &
         electrodes, xyz_atoms, q_elec, V)
      end select
   end subroutine Qelec2Qelec_potential

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
                   electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      integer,              intent(in)    :: type_ions(:)    !< Ion types
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(inout) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      integer,              intent(in)    :: type_electrode_atoms(:) !< Electrode atoms types      
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      logical,              intent(in)    :: compute_force

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: force(:,:) !< Coulomb force on ions
      real(wp),             intent(inout) :: stress_tensor(:,:) !< Coulomb force contribution to the stress tensor

      select case (num_PBC)
      case(2)
              call melt_forces_2DPBC(localwork, ewald, box, ions, xyz_ions, type_ions, &
                      electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor,compute_force)
      case(3)
              call melt_forces_3DPBC(localwork, ewald, box, ions, xyz_ions, type_ions, &
                      electrodes, xyz_atoms, type_electrode_atoms, q_elec, force,stress_tensor,compute_force)
      end select

   end subroutine melt_forces

   !==========================================================================================
   ! Compute the electric field gradient felt by melt ions due to point charges of melt ions.
   subroutine melt_efg(num_PBC, localwork, ewald, box, ions, xyz_ions, efg)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork      !< local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: efg(:,:) !< the EFG on ions

      select case (num_PBC)
      case(2)
         call melt_efg_2DPBC(localwork, ewald, box, ions, xyz_ions, efg)
      case(3)
         call melt_efg_3DPBC(localwork, ewald, box, ions, xyz_ions, efg)
      end select

   end subroutine melt_efg

   !================================================================================
   ! Compute the Energy due to Coulomb interactions
   subroutine energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, h)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: h !< Coulomb energy

      select case (num_PBC)
      case(2)
         call energy_2DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h)
      case(3)
         call energy_3DPBC(localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h)
      end select
   end subroutine energy

   ! ==========================================================================================
   ! Determine if short-range coulomb interaction should be taken into account between 2 particle types
   !
   ! By default short-range coulomb interaction is taken into account
   ! For fixed particles, short-range coulomb interaction is not taken
   ! into account between 2 particle types if the minimum distance
   ! between 2 particles of the distinct sets is greater than the
   ! specified cut-off (rcut)
   subroutine setup_sr_interaction(num_PBC, ewald, ions, electrodes, &
      xyz_ions, xyz_atoms, box)
      implicit none
      ! Parameters
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_ion_t),       intent(in)    :: ions(:)             !< ions parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:) !< electrode parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)             !< ions xyz coordinates
      real(wp),             intent(in)    :: xyz_atoms(:,:)            !< atoms xyz coordinates
      type(MW_box_t),       intent(in)    :: box                 !< box parameters
      type(MW_ewald_t),     intent(inout) :: ewald           !< Coulomb ewald structure

      select case(num_PBC)
      case(2)
         call setup_sr_interaction_2DPBC(ewald, ions, electrodes, &
         xyz_ions, xyz_atoms, box)
      case(3)
         call setup_sr_interaction_3DPBC(ewald, ions, electrodes, &
         xyz_ions, xyz_atoms, box)
      end select
   end subroutine setup_sr_interaction

   !Functions=============================

   function force_elec2melt_ij(drnorm2, alpha, alphasq, &
      alphapi, eta, etasq, etapi, qi, Q_j) &
      result(fijqq)
      implicit none
      !$acc routine seq      

      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: alpha
      real(wp), intent(in) :: alphasq
      real(wp), intent(in) :: alphapi
      real(wp), intent(in) :: eta
      real(wp), intent(in) :: etasq
      real(wp), intent(in) :: etapi
      real(wp), intent(in) :: qi
      real(wp), intent(in) :: Q_j

      ! Result
      ! ------
      real(wp) :: fijqq

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec, drnorm2rec
      real(wp) :: erfc_alpha,exp_alpha
      real(wp) :: erfc_eta,exp_eta

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp/drnorm
      drnorm2rec = drnormrec*drnormrec

      ! Change erfc to 1-erf because of underflows
      erfc_alpha = erfc(alpha*drnorm)*drnormrec
      exp_alpha = exp(-alphasq*drnorm2)*alphapi
      erfc_eta = erfc(eta*drnorm)*drnormrec
      exp_eta = exp(-etasq*drnorm2)*etapi

      fijqq = qi*Q_j*drnorm2rec*((erfc_alpha + exp_alpha) - (erfc_eta + exp_eta))

   end function force_elec2melt_ij

   ! ================================================================================
   include 'coulomb_sr_2DPBC.inc'
   include 'coulomb_sr_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_coulomb_sr

! Module to store constants
module MW_constants

   use MW_kinds, only: wp
   implicit none
   private

   ! Numbers
   real(wp), parameter, public :: pi = 3.14159265358979323_wp
   real(wp), parameter, public :: twopi = 2.0_wp*pi
   real(wp), parameter, public :: fourpi = 4.0_wp * pi
   real(wp), parameter, public :: eightpi_inv = 1.0_wp / (8.0_wp * pi)
   real(wp), parameter, public :: sqrtpi = 1.7724538509055160249_wp
   real(wp), parameter, public :: sqrt2 = sqrt(2.0_wp)

   ! Physics constant
   real(wp), parameter, public :: boltzmann_si = 1.38064852e-23_wp  !> J/K
   real(wp), parameter, public :: avogadro_si = 6.022140857e+23_wp  !> (1/mol)
   real(wp), parameter, public :: hartree_si = 4.359744650e-18_wp   !> hartree energy in J
   real(wp), parameter, public :: bohr_si = 0.52917721067e-10_wp    !> bohr radius in m
   real(wp), parameter, public :: me_si = 9.10938356e-31_wp         !> electron mass in kg

   ! Unit conversion
   ! ---------------
   !   units               SI           au           MD (Gromacs)
   !   length              m            a0           nm
   !   mass                kg           me           u
   !   time                s            hbar.Eh-1    ps
   !   charge              C            e            e
   !   temperature         K            Eh.kb-1      K
   !   energy              J            Eh           kJ.mol-1
   !   force               N (kg.m.s-2) Eh.a0-1      kJ.mol-1.nm-1
   !   pressure            Pa           Eh.a0-3      bar
   !   stress tensor       Pa           Eh.a0-3         
   !   velocity            m.s-1        a0.Eh.hbar-1 nm.ps-1
   !   dipole moment       C.m          e.a0         e.nm
   !   electric potential  V            Eh.e-1       kJ.mol-1.e-1
   !   electric field      V.m-1        Eh.e-1.a0-1  kJ.mol-1.e-1.nm-1

   real(wp), parameter, public :: boltzmann = boltzmann_si / hartree_si  !> hartree / K
   real(wp), parameter, public :: bohr2angstrom = 0.52917721067_wp
   real(wp), parameter, public :: angstrom2bohr = 1.0_wp / bohr2angstrom
   real(wp), parameter, public :: kJpermol2hartree = 1.0e+3_wp / (hartree_si*avogadro_si)
   real(wp), parameter, public :: hartree2kJpermol = hartree_si * avogadro_si * 1.0e-3_wp
   real(wp), parameter, public :: amu2me = 1.0e-3_wp / (avogadro_si*me_si)
   real(wp), parameter, public :: me2amu = 1.0e+3_wp * (avogadro_si*me_si)
   real(wp), parameter, public :: au2ps = 2.41888425E-5

#ifdef MW_CI
   ! Optimization constants for continuous integration checks
   integer, parameter, public :: cache_line_size = 8     !< size of a cache line (in number of real(wp))
   integer, parameter, public :: pair_block_size = 8   !< size of a block for pair interactions
   integer, parameter, public :: block_vector_size = 1024 !< size of a vector used for cache-blocking loops
! This will have to be uncommented when we switch to real GPUs
#elif _OPENACC
  ! Optimization constants for GPUs
   integer, parameter, public :: cache_line_size = 8       !< size of a cache line (in number of real(wp))
   integer, parameter, public :: pair_block_size = 32768    !< size of a block for pair interactions
   integer, parameter, public :: block_vector_size = 32768  !< size of a vector used for cache-blocking loops
#else
   ! Optimization constants for CPUs
   integer, parameter, public :: cache_line_size = 8     !< size of a cache line (in number of real(wp))
   integer, parameter, public :: pair_block_size = 128   !< size of a block for pair interactions
   integer, parameter, public :: block_vector_size = 1024 !< size of a vector used for cache-blocking loops
#endif
end module MW_constants

! Interface to the MPI module
module MW_parallel
#ifndef MW_SERIAL
      use mpi
      use MW_errors, only: MW_errors_mpilib_error => mpilib_error
#endif
#ifdef _OPENACC
   use openacc
#endif
   implicit none
   private

   ! public types
   public :: MW_parallel_t

   ! public subroutines
   public :: initialize
   public :: initialize_python
   public :: finalize
   public :: define_type
   public :: void_type
   public :: print_type

   ! A data structure to hold comm, rank and group for a process
   type MW_parallel_t
      integer :: comm   ! Parallel communicator
      integer :: comm_rank   ! Parallel rank of the process on this communicator
      integer :: size   ! Size of the parallel communicator
   end type MW_parallel_t

   integer, public, save :: MW_COMM_WORLD = 0

contains
   !================================================================================
   ! Initialize MPI and set MW_COMM_WORLD communicator
   subroutine initialize_python(comm)
      implicit none
      integer, intent(in) :: comm
#ifndef MW_SERIAL
      MW_COMM_WORLD = comm
#else
      integer, intent(in) :: comm
      MW_COMM_WORLD = 0
#endif
   end subroutine initialize_python

   !================================================================================
   ! Initialize MPI and set MW_COMM_WORLD communicator
   subroutine initialize()
      implicit none
#ifndef MW_SERIAL
      integer :: ierr
      call MPI_Init(ierr)
      if (ierr /= MPI_SUCCESS) then
         call MW_errors_mpilib_error("initialize", "parallel.f90", "MPI_Init", ierr)
      end if
      MW_COMM_WORLD = MPI_COMM_WORLD
#else
      MW_COMM_WORLD = 0
#endif
   end subroutine initialize


   !================================================================================
   ! Finalize MPI and free MW_COMM_WORLD communicator
   subroutine finalize()
      implicit none
#ifndef MW_SERIAL
      integer :: ierr
      call MPI_Finalize(ierr)
      if (ierr /= MPI_SUCCESS) then
         call MW_errors_mpilib_error("finalize", "parallel.f90", "MPI_Finalize", ierr)
      end if
#else
      continue
#endif
   end subroutine finalize

   !================================================================================
   ! Define a parallel data structure
   subroutine define_type(this, comm)
      implicit none
      type(MW_parallel_t), intent(inout) :: this
      integer, intent(in) :: comm
#ifndef MW_SERIAL
      integer :: ierr
      integer :: rank
      integer :: size
#endif
#ifdef _OPENACC
      integer(acc_device_kind) :: devicetype
      integer :: num_devices, devicenum
#endif
#ifndef MW_SERIAL
      call MPI_Comm_size(comm, size, ierr)
      if (ierr /= MPI_SUCCESS) then
         call MW_errors_mpilib_error("define_type", "parallel.f90", "MPI_Comm_size", ierr)
      end if

      call MPI_Comm_rank(comm, rank, ierr)
      if (ierr /= MPI_SUCCESS) then
         call MW_errors_mpilib_error("define_type", "parallel.f90", "MPI_Comm_rank", ierr)
      end if

      this%comm = comm
      this%comm_rank = rank
      this%size = size
#else
      this%comm = comm
      this%comm_rank = 0
      this%size = 1
#endif
#ifdef _OPENACC
      devicetype = acc_get_device_type() ! hopefully this is the GPUs
      num_devices = acc_get_num_devices(devicetype)
      devicenum = mod(this%comm_rank, num_devices)
      call acc_set_device_num(devicenum, devicetype)
      call acc_init(devicetype)
#endif

   end subroutine define_type

   !================================================================================
   ! Void a parallel data structure
   subroutine void_type(this)
      implicit none
      type(MW_parallel_t), intent(inout) :: this

      this%comm = 0
      this%comm_rank = 0
      this%size = 0

   end subroutine void_type

   ! ================================================================================
   ! Print parallel comm characteristics
   subroutine print_type(this, ounit)
      implicit none
      type(MW_parallel_t), intent(in) :: this
      integer, intent(in) :: ounit

      write(ounit, *)
      write(ounit, '("Parallel setup")')
      write(ounit, '("==============")')
      write(ounit, *)
      write(ounit, '("MPI communicator id:   ",i8)') this%comm
      write(ounit, '("MPI communicator size: ",i8)') this%size
      write(ounit, '("MPI rank:              ",i8)') this%comm_rank

   end subroutine print_type
end module MW_parallel

!> Module to generate random numbers
module MW_random
   use MW_kinds, only: wp
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: seed
   public :: uniform_random_number
   public :: normal_random_number

   integer, save :: ix1, ix2, ix3
   real(wp), save :: field(100) !< field of random numbers

   integer, parameter :: m1=259200, ia1=7141, ic1=54773
   integer, parameter :: m2=134456, ia2=8121, ic2=28411
   integer, parameter :: m3=243000, ia3=4561, ic3=51349
   real(wp), parameter :: rm1 = 1.0_wp / real(m1,wp)
   real(wp), parameter :: rm2 = 1.0_wp / real(m2,wp)

contains

   ! ========================================================================
   !> Seed the pseudorandom number generator
   subroutine seed()
      implicit none
      integer :: j
      ix1=mod(ic1+1,m1)
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ix1,m2)
      ix1=mod(ia1*ix1+ic1,m1)
      ix3=mod(ix1,m3)
      do j=1,97
         ix1=mod(ia1*ix1+ic1,m1)
         ix2=mod(ia2*ix2+ic2,m2)
         field(j)=(real(ix1,wp) + real(ix2,wp)*rm2)*rm1
      end do
   end subroutine seed

   ! ========================================================================
   !> Generate a uniformly distributed pseudorandom number with real values
   !! in the interval (0,1).
   subroutine uniform_random_number(harvest)
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(out) :: harvest
      integer :: j

      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)

      j=1+(97*ix3)/m3
      harvest = field(j)
      field(j) = (real(ix1,wp) + real(ix2,wp) * rm2) * rm1

   end subroutine uniform_random_number

   ! ========================================================================
   !> Generate a normally distributed pseudorandom number with zero mean and
   !! unit variance
   subroutine normal_random_number(harvest)
      implicit none
      ! Parameters
      ! ----------
      real(wp), intent(out) :: harvest

      ! locals
      ! ------
      real(wp) :: x, xj, r, rsq
      integer :: j

      real(wp), parameter :: a1 = 3.949846138_wp
      real(wp), parameter :: a3 = 0.252408784_wp
      real(wp), parameter :: a5 = 0.076542912_wp
      real(wp), parameter :: a7 = 0.008355968_wp
      real(wp), parameter :: a9 = 0.029899776_wp

      x = 0.0_wp
      do j=1,12
         call uniform_random_number(xj)
         x = x + xj
      enddo

      r = (x - 6.0_wp) / 4.0_wp
      rsq=r*r
      harvest = ((((a9*rsq+a7)*rsq+a5)*rsq+a3)*rsq+a1)*r

   end subroutine normal_random_number

end module MW_random

! Module to implement thermostatting routine for constant temperature runs
!
! Reference
! ---------
! Nose-Hoover chains: The canonical ensemble via continuous dynamics
! Glenn K. Martyna, Michael L. Klein, Marck Tuckerman
! J. Chem. Phys. 97 (4), 15 August 1992
!
module MW_thermostat
   use MW_kinds, only: wp
   use MW_ion, only: MW_ion_t
   use MW_constants, only: boltzmann
   implicit none
   private

   ! Public types
   ! ------------
   public :: MW_thermostat_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: allocate_velocity_work_array
   public :: void_type
   public :: print_type
   public :: update_history
   public :: initialize
   public :: ions_positions_update
   public :: ions_velocities_update
   public :: setup_masses
   public :: energy

   integer, parameter :: ZETA_NUM_STEPS = 3

   type MW_thermostat_t
      real(wp) :: temperature            !< Thermostat temperature
      real(wp) :: relaxation_time        !< Relaxation time
      integer  :: max_iteration          !< maximum number of iteration for velocity convergence
      real(wp) :: tolerance              !< tolerance on velocity convergence

      integer :: chain_length = 0        !< Number of thermostats in the chain

      real(wp), allocatable :: mass(:)        !< Thermostats mass
      real(wp), allocatable :: zeta(:,:)      !< Thermostat "position"
      real(wp), allocatable :: v_zeta(:,:)    !< Thermostat "velocity"
      real(wp), allocatable :: G_zeta(:,:)    !< Thermostat "force"

      ! history pointer
      integer :: zeta_step(ZETA_NUM_STEPS)

      real(wp), allocatable :: velocity_ions_work(:,:,:) !< work array required for velocity iterations
   end type MW_thermostat_t

contains

   ! ================================================================================
   ! Define a thermostat structure
   subroutine define_type(this, temperature, relaxation_time, &
         max_iteration, tolerance, chain_length)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none

      ! Parameters in
      ! -------------
      real(wp), intent(in) :: temperature      !< Thermostat temperature
      real(wp), intent(in) :: relaxation_time  !< Relaxation time
      integer,  intent(in) :: max_iteration    !< maximum number of iteration for velocity convergence
      real(wp), intent(in) :: tolerance        !< tolerance on velocity convergence
      integer,  intent(in) :: chain_length  !< Number of thermostats in the chain

      ! Parameters out
      ! --------------
      type(MW_thermostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr, step

      if (chain_length < 1) then
         call MW_errors_parameter_error("define_type", "thermostat.f90", "chain_length", chain_length)
      end if

      this%temperature = temperature
      this%relaxation_time = relaxation_time
      this%max_iteration = max_iteration
      this%tolerance = tolerance
      this%chain_length = chain_length

      ! allocate with size chain_length+1 in order to have a more generic formulation
      ! the n+1th thermostat will always have zeta=0, v_zeta=0 and G_zeta=0
      allocate(this%zeta(chain_length+1, ZETA_NUM_STEPS), &
            this%v_zeta(chain_length+1, ZETA_NUM_STEPS), &
            this%G_zeta(chain_length+1, ZETA_NUM_STEPS), &
            this%mass(chain_length+1), &
            stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "thermostat.f90", ierr)
      end if

      this%zeta(:,:) = 0.0_wp
      this%v_zeta(:,:) = 0.0_wp
      this%G_zeta(:,:) = 0.0_wp
      this%mass(:) = 0.0_wp

      do step = 1, ZETA_NUM_STEPS
         this%zeta_step(step) = step
      end do

   end subroutine define_type

   ! ================================================================================
   !> Allocate velocity work array
   subroutine allocate_velocity_work_array(this, num_ions)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
     implicit none
     ! Parameters
     ! ----------
     type(MW_thermostat_t), intent(inout) :: this
     integer, intent(in) :: num_ions !< size of the velocity work array
     ! local
     ! -----
     integer :: ierr

      if (num_ions < 1) then
         call MW_errors_parameter_error("define_type", "thermostat.f90", "num_ions", num_ions)
      end if
      allocate(this%velocity_ions_work(num_ions,3,2), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("define_type", "thermostat.f90", ierr)
      end if
      this%velocity_ions_work(:,:,:) = 0.0_wp
    end subroutine allocate_velocity_work_array

   ! ================================================================================
   ! Setup thermostat masses
   subroutine setup_masses(this, num_dof)
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(inout) :: this
      integer, intent(in) :: num_dof

      ! Local
      ! -----
      real(wp) :: kbt
      real(wp) :: relaxation_time_sq
      integer :: i

      kbt = boltzmann * this%temperature
      relaxation_time_sq = this%relaxation_time * this%relaxation_time

      this%mass(1) = num_dof * kbt * relaxation_time_sq
      do i = 2, this%chain_length
         this%mass(i) = kbt * relaxation_time_sq
      end do
   end subroutine setup_masses

   ! ================================================================================
   ! Void a thermostat structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: ierr

      this%temperature = 0.0_wp
      this%relaxation_time = 0.0_wp
      this%chain_length = 0
      this%tolerance = 0.0_wp
      this%zeta_step(:) = 0

      if (allocated(this%velocity_ions_work)) then
         deallocate(this%velocity_ions_work, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "thermostat.f90", ierr)
         end if
      end if
      if (allocated(this%zeta)) then
         deallocate(this%zeta, this%v_zeta, this%G_zeta, this%mass, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("define_type", "thermostat.f90", ierr)
         end if
      end if

   end subroutine void_type

   ! ================================================================================
   ! Void a thermostat structure
   subroutine print_type(this, ounit)
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(in) :: this
      integer, intent(in) :: ounit

      write(ounit, '("|thermostat| temperature:                           ",es12.5)') this%temperature
      write(ounit, '("|thermostat| relaxation time:                       ",es12.5)') this%relaxation_time
      write(ounit, '("|thermostat| chain length:                          ",i12)') this%chain_length
      write(ounit, '("|thermostat| maximum number of velocity iterations: ",i12)') this%max_iteration
      write(ounit, '("|thermostat| tolerance on velocities:               ",es12.5)') this%tolerance
      if (allocated(this%mass)) then
         write(ounit, '("|thermostat| masses: ",100(es12.5,1x))') this%mass(:)
      end if

   end subroutine print_type

   ! ================================================================================
   !> Cycle history
   subroutine update_history(this)
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(inout) :: this

      ! Local
      ! -----
      integer :: step_now, step

      ! current step data will replace oldest step data
      step_now = this%zeta_step(ZETA_NUM_STEPS)
      do step = ZETA_NUM_STEPS, 2, -1
         this%zeta_step(step) = this%zeta_step(step-1)
      end do
      this%zeta_step(1) = step_now

   end subroutine update_history

   ! ================================================================================
   ! Initialize thermostat position, velocity and force
   subroutine initialize(this, num_dof, ions, velocity_ions_now)
     implicit none
     ! parameters
     ! ----------
     type(MW_thermostat_t), intent(inout) :: this   !< Thermostat parameters
     integer, intent(in) :: num_dof                 !< number of degree of freedom in the system
     type(MW_ion_t), intent(in) :: ions(:)          !< ion type parameters
     real(wp), intent(in) :: velocity_ions_now(:,:) !< ions velocities

     ! Local
     ! -----
     integer :: zeta_now
     integer :: i, itype
     integer :: num_ion_types
     real(wp) :: kbt, mass, vsq, kinetic_energy
     real(wp) :: vx, vy, vz

     call setup_masses(this, num_dof)

     num_ion_types = size(ions,1)
     kbt = boltzmann*this%temperature

     kinetic_energy = 0.0_wp
     do itype = 1, num_ion_types
        mass = ions(itype)%mass
        do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
           vx = velocity_ions_now(i,1)
           vy = velocity_ions_now(i,2)
           vz = velocity_ions_now(i,3)
           vsq = vx*vx + vy*vy + vz*vz
           kinetic_energy = kinetic_energy + mass*vsq
        end do
     end do

     zeta_now = this%zeta_step(1)
!    do i = 1, this%chain_length
!       this%zeta(i,zeta_now) = 0.0_wp
!       this%v_zeta(i,zeta_now) = 0.0_wp
!    end do

     ! First thermostat in the chain
     if(this%G_zeta(1,zeta_now).eq.0.0_wp) this%G_zeta(1,zeta_now) = 1.0_wp/this%mass(1) * (kinetic_energy - num_dof*kbt)

     ! Chained thermostats
     do i = 2, this%chain_length
        if(this%G_zeta(i,zeta_now).eq.0.0_wp) this%G_zeta(i,zeta_now) = - 1.0_wp/this%mass(i) * kbt
     end do

   end subroutine initialize

   ! ================================================================================
   !> Update ions position
   subroutine ions_positions_update(this, dt, ions, &
         velocity_ions_prev, xyz_ions_now, velocity_ions_now)
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(inout) :: this           !< thermostat parameters
      real(wp), intent(in) :: dt                          !< time step
      type(MW_ion_t), intent(in) :: ions(:)               !< ion_types data
      real(wp), intent(in) :: velocity_ions_prev(:,:)     !< ions velocities at previous time step

      real(wp), intent(inout) :: xyz_ions_now(:,:)        !< ions positions at current time step
      real(wp), intent(inout) :: velocity_ions_now(:,:) !< ions velocities at current time step

      ! Local
      ! -----
      integer :: i, itype, ichain
      real(wp) :: halfdt, halfdtsq
      integer :: zeta_now, zeta_prev
      integer :: num_ion_types

      num_ion_types = size(ions, 1)
      zeta_now = this%zeta_step(1)
      zeta_prev = this%zeta_step(2)

      ! Update positions and velocities with thermostat "forces" computed at previous time step
      halfdt = 0.5_wp*dt
      halfdtsq = 0.5_wp*dt*dt
      do itype = 1, num_ion_types
         do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count

            velocity_ions_now(i,1) = velocity_ions_now(i,1) - &
                  halfdt * velocity_ions_prev(i,1)*this%v_zeta(1,zeta_prev)
            velocity_ions_now(i,2) = velocity_ions_now(i,2) - &
                  halfdt * velocity_ions_prev(i,2)*this%v_zeta(1,zeta_prev)
            velocity_ions_now(i,3) = velocity_ions_now(i,3) - &
                  halfdt * velocity_ions_prev(i,3)*this%v_zeta(1,zeta_prev)

            xyz_ions_now(i,1) = xyz_ions_now(i,1) - &
                  halfdtsq * velocity_ions_prev(i,1)*this%v_zeta(1,zeta_prev)
            xyz_ions_now(i,2) = xyz_ions_now(i,2) - &
                  halfdtsq * velocity_ions_prev(i,2)*this%v_zeta(1,zeta_prev)
            xyz_ions_now(i,3) = xyz_ions_now(i,3) - &
                  halfdtsq * velocity_ions_prev(i,3)*this%v_zeta(1,zeta_prev)

         end do
      end do

      do ichain = 1, this%chain_length
         this%zeta(ichain, zeta_now) = this%zeta(ichain, zeta_prev) + &
              dt * this%v_zeta(ichain, zeta_prev) + &
              halfdtsq * this%G_zeta(ichain, zeta_prev)
      end do

   end subroutine ions_positions_update

   ! ================================================================================
   !> Update ions position
   subroutine ions_velocities_update(this, num_dof, dt, ions, velocity_ions_now)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(inout) :: this        !< thermostat parameters
      integer, intent(in) :: num_dof                      !< number of degrees of freedom
      real(wp), intent(in) :: dt                          !< time step
      type(MW_ion_t), intent(in) :: ions(:)               !< ions parameters
      real(wp), intent(inout) :: velocity_ions_now(:,:) !< ions velocities at current time step

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: zeta_now, zeta_prev, zeta_old
      integer :: i, itype, iter, icur, iprev, itmp
      real(wp) :: mass, halfdt
      real(wp) :: scalingfactor
      real(wp) :: kbt, kinetic_energy, vsq
      logical :: converge
      real(wp) :: delta
      real(wp) :: vx, vy, vz

      num_ion_types = size(ions,1)
      zeta_now = this%zeta_step(1)
      zeta_prev = this%zeta_step(2)
      zeta_old = this%zeta_step(3)

      ! precompute some factors
      kbt = boltzmann*this%temperature
      halfdt = 0.5_wp*dt

      ! Initial guess for v_zeta
      do i = 1, this%chain_length
         this%v_zeta(i,zeta_now) = this%v_zeta(i,zeta_old) + 2.0_wp * dt * this%G_zeta(i,zeta_prev)
      end do

      ! Setup work array
      icur = 1
      iprev = 2
      this%velocity_ions_work(:,:,icur) = velocity_ions_now(:,:)

      converge = .false.
      convergenceLoop: do iter = 1, this%max_iteration

         ! swap indices for work arrays
         itmp = icur
         icur = iprev
         iprev = itmp

         scalingfactor = 1.0_wp / (1.0_wp + halfdt*this%v_zeta(1,zeta_now))

         ! Scale velocities
         do itype = 1, num_ion_types
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count

               this%velocity_ions_work(i,1,icur) = scalingfactor * velocity_ions_now(i,1)
               this%velocity_ions_work(i,2,icur) = scalingfactor * velocity_ions_now(i,2)
               this%velocity_ions_work(i,3,icur) = scalingfactor * velocity_ions_now(i,3)

            end do
         end do

         ! Update thermostat "force"
         kinetic_energy = 0.0_wp
         do itype = 1, num_ion_types
            mass = ions(itype)%mass
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
               vx = this%velocity_ions_work(i, 1, icur)
               vy = this%velocity_ions_work(i, 2, icur)
               vz = this%velocity_ions_work(i, 3, icur)
               vsq = vx*vx + vy*vy + vz*vz
               kinetic_energy = kinetic_energy + mass*vsq
            end do
         end do


         ! Chained thermostats update
         ! Implementation feature: ilast=chain_length+1 is a valid index and v_zeta(ilast,:)=0 at all time
         !
         ! First thermostat in the chain
         this%G_zeta(1,zeta_now) = 1.0_wp/this%mass(1) * (kinetic_energy - num_dof*kbt) - &
               this%v_zeta(1, zeta_now)*this%v_zeta(2, zeta_now)
         this%v_zeta(1,zeta_now) = this%v_zeta(1,zeta_prev) + halfdt * (this%G_zeta(1,zeta_prev) + this%G_zeta(1,zeta_now))
         ! Other thermostats
         do i = 2, this%chain_length
            this%G_zeta(i,zeta_now) = &
                  1.0_wp/this%mass(i) * (this%mass(i-1)*this%v_zeta(i-1,zeta_now)*this%v_zeta(i-1,zeta_now) - kbt) - &
                  this%v_zeta(i, zeta_now)*this%v_zeta(i+1, zeta_now)
            this%v_zeta(i,zeta_now) = this%v_zeta(i,zeta_prev) + halfdt * (this%G_zeta(i,zeta_prev) + this%G_zeta(i,zeta_now))
         end do

         ! check for convergence
         delta = 0.0_wp
         do itype = 1, num_ion_types
            mass = ions(itype)%mass
            do i = ions(itype)%offset+1, ions(itype)%offset + ions(itype)%count
               vx = this%velocity_ions_work(i,1,icur) - this%velocity_ions_work(i,1,iprev)
               vy = this%velocity_ions_work(i,2,icur) - this%velocity_ions_work(i,2,iprev)
               vz = this%velocity_ions_work(i,3,icur) - this%velocity_ions_work(i,3,iprev)
               vsq = vx*vx + vy*vy + vz*vz
               delta = delta + mass*vsq
            end do
         end do

         if (delta <= (num_dof*kbt)*this%tolerance) then
            converge = .true.
            exit convergenceLoop
         end if

      end do convergenceLoop
      if (.not. converge) then
         call MW_errors_runtime_error("ions_velocities_update", "thermostat.f90", &
               "Velocity thermostating failed to converge")
      end if

      ! Copy back updated velocities
      velocity_ions_now(:,:) = this%velocity_ions_work(:,:,icur)

   end subroutine ions_velocities_update

   ! ================================================================================
   !> Compute the energy of the thermostat
   subroutine energy(this, num_dof, h)
      implicit none
      ! Parameters
      ! ----------
      type(MW_thermostat_t), intent(in) :: this
      integer, intent(in) :: num_dof
      real(wp), intent(inout) :: h

      ! Locals
      ! ------
      integer :: zeta_now
      integer :: i
      real(wp) :: kinetic_energy, potential_energy
      real(wp) :: kbt

      zeta_now = this%zeta_step(1)
      kinetic_energy = 0.0_wp
      do i = 1, this%chain_length
         kinetic_energy = kinetic_energy + 0.5_wp * this%mass(i) * this%v_zeta(i, zeta_now) * this%v_zeta(i, zeta_now)
      end do

      kbt = boltzmann * this%temperature
      potential_energy = num_dof * kbt * this%zeta(1,zeta_now)
      do i = 2, this%chain_length
         potential_energy = potential_energy + kbt * this%zeta(i, zeta_now)
      end do

      h = kinetic_energy + potential_energy
   end subroutine energy

end module MW_thermostat

!> Quaim Potential
!! -------------------
!!
!! V(r_{ij}) = B1 * exp(-\eta1 r_{ij})+B2 * exp(-\eta2 \rho_{ij})+B3 * exp(-\eta3 \rho_{ij})
!!           - \frac{C}{r_{ij}^6} * [1 - (sum_{k=0}^{6} \frac{(damp_dd*r_{ij})^k}{k!})*exp(-damp_dd*r_{ij})]
!!           - \frac{D}{r_{ij}^8} * [1 - (sum_{l=0}^{8} \frac{(damp_dq*r_{ij})^l}{l!})*exp(-damp_dq*r_{ij})]
!!
module MW_daim
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_timers
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_molecule, only: MW_molecule_t
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_daim_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: void_type
   public :: print_type
   public :: set_rcut
   public :: melt_forces
   public :: stress_tensor_tail_correction
   public :: energy
   public :: selfenergy
   public :: diffselfenergy
   public :: repulsionenergy
   public :: diffrepulsionenergy
!  public :: melt_fix_molecule_forces
!  public :: fix_molecule_energy

   ! Data structure to handle daim potentials
   type MW_daim_t
      integer :: num_species = 0                            ! number of species
      real(wp) :: rcut = 0.0_wp                             ! cut-off parameter
      real(wp) :: rcutsq = 0.0_wp                           ! cut-off parameter squared
      real(wp), dimension(:,:), allocatable :: eta1          ! (num_species,num_species) exponential factor
      real(wp), dimension(:,:), allocatable :: eta2          ! (num_species,num_species) exponential factor
      real(wp), dimension(:,:), allocatable :: eta3          ! (num_species,num_species) exponential factor
      real(wp), dimension(:,:), allocatable :: B1            ! (num_species,num_species) exponential scaling factor
      real(wp), dimension(:,:), allocatable :: B2            ! (num_species,num_species) exponential scaling factor
      real(wp), dimension(:,:), allocatable :: B3            ! (num_species,num_species) exponential scaling factor
      real(wp), dimension(:,:), allocatable :: C            ! (num_species,num_species) dipole-dipole van der Waals attractive term
      real(wp), dimension(:,:), allocatable :: D            ! (num_species,num_species) dipole-quadripole van de Waals attractive termp
      real(wp), dimension(:,:), allocatable :: damp_dd      ! (num_species,num_species) dipole-dipole damping factor
      real(wp), dimension(:,:), allocatable :: damp_dq      ! (num_species,num_species) dipole-quadripole damping factor
      logical :: daim_3D_tail_correction = .false.           ! Flag to turn on the dispersion terms tail correction in 3D
   end type MW_daim_t

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, num_species, rcut)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ---------_
      type(MW_daim_t), intent(inout) :: this      !> structure to be defined
      integer, intent(in) :: num_species                    !> number of species
      real(wp), intent(in) :: rcut

      ! Local
      ! -----
      integer :: ierr

      call set_rcut(this, rcut)

      if (num_species <= 0) then
         call MW_errors_parameter_error("define_type", "daim.f90",&
               "num_species", num_species)
      end if

      this%num_species = num_species

      allocate(this%eta1(num_species,num_species), &
            this%eta2(num_species,num_species), &
            this%eta3(num_species,num_species), &
            this%B1(num_species,num_species), &
            this%B2(num_species,num_species), &
            this%B3(num_species,num_species), &
            this%C(num_species,num_species), &
            this%D(num_species,num_species), &
            this%damp_dd(num_species,num_species), &
            this%damp_dq(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "daim.f90", ierr)
      this%eta1(:,:) = 0.0_wp
      this%eta2(:,:) = 0.0_wp
      this%eta3(:,:) = 0.0_wp
      this%B1(:,:) = 0.0_wp
      this%B2(:,:) = 0.0_wp
      this%B3(:,:) = 0.0_wp
      this%C(:,:) = 0.0_wp
      this%D(:,:) = 0.0_wp
      this%damp_dd(:,:) = 0.0_wp
      this%damp_dq(:,:) = 0.0_wp

   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_daim_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%eta1)) then
         deallocate(this%eta1, this%eta2, this%eta3, this%B1, &
            this%B2, this%B3, this%C, this%D, this%damp_dd, this%damp_dq, stat=ierr)
         if (ierr /= 0) &
               call MW_errors_deallocate_error("define_type", "daim.f90", ierr)
      end if

      this%num_species = 0
      this%rcut = 0.0_wp
      this%rcutsq = 0.0_wp
   end subroutine void_type

   ! ================================================================================
   ! set rcut value
   subroutine set_rcut(this, rcut)
      implicit none
      type(MW_daim_t), intent(inout) :: this
      real(wp), intent(in) :: rcut

      this%rcut = rcut
      this%rcutsq = rcut*rcut
   end subroutine set_rcut

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, species_names, ounit)
      use MW_kinds, only: PARTICLE_NAME_LEN
      implicit none
      type(MW_daim_t), intent(in) :: this               ! structure to be printed
      character(PARTICLE_NAME_LEN),   intent(in) :: species_names(:)   ! names of the species
      integer,                   intent(in) :: ounit              ! output unit

      integer :: i, j

      write(ounit, '("|daim| cut-off distance: ",es12.5)') this%rcut
      write(ounit, '("|daim| ",8x,1x,8x,1x,"    eta1     ",1x,"    eta2     ",1x,'// &
            '"    eta3     ",1x,"     B1     ",1x,"     B2     ",1x,"     B3     ",1x,'// &
            '"     C      ",1x,"     D      ",1x,"  damp_dd   ",1x,"  damp_dq   ",1x)')

      do j = 1, this%num_species
         do i = j, this%num_species
            write(ounit, '("|daim| ",a8,1x,a8,10(1x,es12.5))') &
                  species_names(i), species_names(j), this%eta1(i,j),this%eta2(i,j), &
                  this%eta3(i,j), this%B1(i,j),this%B2(i,j),this%B3(i,j),&
                  this%C(i,j), this%D(i,j), this%damp_dd(i,j), this%damp_dq(i,j)
         end do
      end do

   end subroutine print_type

   ! ==============================================================================
   ! Compute daim forces felt by melt ions
   subroutine melt_forces(num_pbc, localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_elec, force,stress_tensor, delta, epsilon, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_daim_t), intent(in) :: daim      !< daim potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(inout) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_elec(:,:)  !< electrode atoms xyz positions
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions
      logical,              intent(in) :: compute_force !< compute_force on electrodes

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< DAIM force on ions
      real(wp), intent(inout) :: stress_tensor(:,:) !< DAIM force contribution to the stress tensor

      ! Local
      ! -----
      integer :: ierr, count, i, num_elec_types

      select case(num_pbc)
      case (2)
         call melt_forces_2DPBC(localwork, daim, box, ions, xyz_ions, &
               electrodes, xyz_elec, force,stress_tensor, delta, epsilon)
      case(3)
         call melt_forces_3DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_elec, force,stress_tensor, delta, epsilon)
      end select
#ifndef MW_SERIAL
      count = size(force,1) * size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)     

      if (compute_force) then
         num_elec_types = size(electrodes, 1)
         do i = 1, num_elec_types
            call MPI_Allreduce(MPI_IN_PLACE, electrodes(i)%force_ions(:,10), 3, &
                  MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
         end do
      end if
#endif
   end subroutine melt_forces


   ! ==============================================================================
   ! Compute tail correction to the stress tensor 
   subroutine stress_tensor_tail_correction(daim, box, ions,tail_correction)
      use MW_constants, only : pi     
      implicit none

      ! Parameters in
      ! -------------
      type(MW_daim_t), intent(in) :: daim      !< Fumi-Tosi potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: tail_correction !< tail correction to the stress tensor

      ! Local
      ! -----
      integer :: itype,jtype,num_ion_types
      integer :: count_n,count_m
      real(wp) :: rcutsq,rcut,C_ij,D_ij

      num_ion_types = size(ions,1)

      rcutsq = daim%rcutsq
      rcut=sqrt(rcutsq)
      tail_correction=0.0_wp
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
!        do jtype =  itype, num_ion_types
         do jtype =  1, num_ion_types
            count_m = ions(jtype)%count
            C_ij = daim%C(itype, jtype)
            D_ij = daim%D(itype, jtype)
            tail_correction=tail_correction- &
                    2.0*pi*count_m*count_n/product(box%length(:))*(C_ij*2.0/(rcut**3.0)+D_ij*(8.0/5.0)/(rcut**5.0))
         end do
      end do

   end subroutine stress_tensor_tail_correction   

   ! ==============================================================================
   ! Compute Quaim potential felt by melt ions
   subroutine energy(num_pbc, localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_daim_t), intent(in) :: daim      !< daim potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to L-J interactions

      ! Local
      ! -----
      integer :: ierr

      select case(num_pbc)
      case (2)
         call energy_2DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      case(3)
         call energy_3DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      end select
#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   !================================================================================
   subroutine selfenergy(num_ion_types,ions,delta,epsilon,selfenergydaim)
      use MW_kinds, only: wp
      use MW_ion, only: MW_ion_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      integer, intent(in) :: num_ion_types
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions

      real(wp), intent(inout) :: selfenergydaim

      ! Local
      ! -----
      integer :: iion, itype, i, offset
      real(wp) :: daimD,daimbeta,daimzeta,epsilonsq

      selfenergydaim = 0.0_wp
      do itype = 1, num_ion_types
         if (ions(itype)%selfdaimD>0.0_wp) then
            daimD=ions(itype)%selfdaimD
            daimbeta=ions(itype)%selfdaimbeta
            daimzeta=ions(itype)%selfdaimzeta
            offset = ions(itype)%offset
            do i = 1, ions(itype)%count
               iion = offset + i
               selfenergydaim = selfenergydaim  &
                  +daimD*(dexp(-daimbeta*delta(iion))+dexp(daimbeta*delta(iion)))
               epsilonsq=epsilon(iion,1)**2.0_wp+ epsilon(iion,2)**2.0_wp+epsilon(iion,3)**2.0_wp
               selfenergydaim = selfenergydaim  &
                  +dexp(daimzeta*daimzeta*epsilonsq)-1.0_wp   !  selfeps**2 in pimaim?
            end do
         end if
      end do

   end subroutine selfenergy


   !================================================================================
   subroutine diffselfenergy(num_ion_types,ions,delta,epsilon,selfenergydaim,xi)
      use MW_kinds, only: wp
      use MW_ion, only: MW_ion_t
      implicit none
      ! Parameters
      ! ----------
      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      integer, intent(in) :: num_ion_types
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions

      real(wp), intent(inout) :: selfenergydaim
      real(wp), intent(inout) :: xi(:)       !< Derivative of the energy w.r.t. the d.o.f.

      ! Local
      ! -----
      integer :: iion, itype, i, offset,num
      real(wp) :: daimD,daimbeta,daimzeta,epsilonsq,daimzeta2

      selfenergydaim = 0.0_wp
      xi=0.0_wp
      num=ions(num_ion_types)%offset+ions(num_ion_types)%count
      do itype = 1, num_ion_types
         if (ions(itype)%selfdaimD>0.0_wp) then
            daimD=ions(itype)%selfdaimD
            daimbeta=ions(itype)%selfdaimbeta
            daimzeta=ions(itype)%selfdaimzeta
            daimzeta2=daimzeta*daimzeta
            offset = ions(itype)%offset
            do i = 1, ions(itype)%count
               iion = offset + i
               selfenergydaim = selfenergydaim  &
                  +daimD*(dexp(-daimbeta*delta(iion))+dexp(daimbeta*delta(iion)))
               epsilonsq=epsilon(iion,1)**2.0_wp+ epsilon(iion,2)**2.0_wp+epsilon(iion,3)**2.0_wp
               selfenergydaim = selfenergydaim  &
                  +dexp(daimzeta2*epsilonsq)-1.0_wp   !  selfeps**2 in pimaim?
               xi(iion)=daimD*daimbeta*(-dexp(-daimbeta*delta(iion))+dexp(daimbeta*delta(iion)))
               xi(num+iion)=2.0_wp*epsilon(iion,1)*daimzeta2*dexp(daimzeta2*epsilonsq)
               xi(2*num+iion)=2.0_wp*epsilon(iion,2)*daimzeta2*dexp(daimzeta2*epsilonsq)
               xi(3*num+iion)=2.0_wp*epsilon(iion,3)*daimzeta2*dexp(daimzeta2*epsilonsq)
            end do
         end if
      end do

   end subroutine diffselfenergy

   ! ==============================================================================
   ! Compute daim potential felt by melt ions
   subroutine repulsionenergy(num_pbc, localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_daim_t), intent(in) :: daim      !< daim potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to L-J interactions
!     real(wp), intent(inout) :: xi(:)       !< Derivative of the energy w.r.t. the d.o.f.

      ! Local
      ! -----
      integer :: ierr!, count

      select case(num_pbc)
      case (2)
         call repulsionenergy_2DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      case(3)
         call repulsionenergy_3DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h)
      end select
#ifndef MW_SERIAL
!     count=size(xi,1)
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
!     call MPI_Allreduce(MPI_IN_PLACE, xi, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine repulsionenergy

   ! ==============================================================================
   ! Compute daim potential felt by melt ions
   subroutine diffrepulsionenergy(num_pbc, localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h,xi)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_daim_t), intent(in) :: daim      !< daim potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp), intent(in) :: delta(:) !< Deltas of ions
      real(wp), intent(in) :: epsilon(:,:) !< Epsilons of ions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h       !< Potential energy due to L-J interactions
      real(wp), intent(inout) :: xi(:)       !< Derivative of the energy w.r.t. the d.o.f.

      ! Local
      ! -----
      integer :: ierr,count

      h=0.0_wp
      xi=0.0_wp
      select case(num_pbc)
      case (2)
         call diffrepulsionenergy_2DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h,xi)
      case(3)
         call diffrepulsionenergy_3DPBC(localwork, daim, box, ions, xyz_ions, &
         electrodes, xyz_atoms,delta,epsilon, h,xi)
      end select
#ifndef MW_SERIAL
      count=size(xi,1)
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
      call MPI_Allreduce(MPI_IN_PLACE, xi, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine diffrepulsionenergy



   ! ================================================================================
   ! Function to compute force coeffcient between 2 particles
   !
   ! ft_ij = (dV(r_ij) / dr_ij) * (1/ r_ij)
   function force_ij(dx,dy,dz,drnorm2,deltai,deltaj,epsilonix,epsiloniy,epsiloniz,&
            epsilonjx,epsilonjy,epsilonjz,eta1_ij, eta2_ij, eta3_ij, &
            B1_ij, B2_ij, B3_ij, C_ij, D_ij, damp_dd_ij, damp_dq_ij) result(ft_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: dx,dy,dz,drnorm2
      real(wp), intent(in) :: deltai,deltaj
      real(wp), intent(in) :: epsilonix,epsiloniy,epsiloniz
      real(wp), intent(in) :: epsilonjx,epsilonjy,epsilonjz
!     real(wp), intent(in) :: kappaixx,kappaiyy,kappaizz
!     real(wp), intent(in) :: kappaixy,kappaixz,kappaiyz
!     real(wp), intent(in) :: kappajxx,kappajyy,kappajzz
!     real(wp), intent(in) :: kappajxy,kappajxz,kappajyz
      real(wp), intent(in) :: eta1_ij
      real(wp), intent(in) :: eta2_ij
      real(wp), intent(in) :: eta3_ij
      real(wp), intent(in) :: B1_ij
      real(wp), intent(in) :: B2_ij
      real(wp), intent(in) :: B3_ij
      real(wp), intent(in) :: C_ij
      real(wp), intent(in) :: D_ij
      real(wp), intent(in) :: damp_dd_ij
      real(wp), intent(in) :: damp_dq_ij

      ! Result
      ! ------
      real(wp), dimension(3) :: ft_ij

      ! Local
      ! -----

      real(wp) :: drnorm, drnormrec, drnorm2rec,drnorm4rec,drnorm6rec,drnorm8rec
      real(wp) :: rho,repsiloni,repsilonj
!     real(wp) :: rho,repsiloni,repsilonj,rkappai,rkappaj
      real(wp) :: sgam,sgam2x,sgam2y,sgam2z
!     real(wp) :: sgam,sgam2x,sgam2xx,sgam2y,sgam2yy,sgam2z,sgam2zz
!     real(wp) :: txx,tyy,tzz,txy,txz,tyz
      real(wp) :: damp_dd_sum, damp_dd_term
      real(wp) :: damp_dq_sum, damp_dq_term
      integer :: k, l
      drnorm = sqrt(drnorm2)
      drnormrec  = 1.0_wp / drnorm
      drnorm2rec = 1.0_wp / drnorm2
      drnorm4rec = drnorm2rec * drnorm2rec
      drnorm6rec = drnorm2rec * drnorm4rec 
      drnorm8rec = drnorm2rec * drnorm6rec

      ! damp_dd_sum = sum_{k=0}^{6} (d_{dd}^k r_{ij}^k) / k!
      damp_dd_sum = 1.0_wp
      damp_dd_term = 1.0_wp
      do k = 1, 6
         damp_dd_term = damp_dd_term * (damp_dd_ij * drnorm / real(k,wp)) ! damp_dd_term =  (d_{dd}^k r_{ij}^k) / k!
         damp_dd_sum = damp_dd_sum + damp_dd_term
      end do

      ! damp_dq_sum = sum_{k=0}^{8} (d_{dq}^k r_{ij}^k) / k!
      damp_dq_sum = 1.0_wp
      damp_dq_term = 1.0_wp
      do l = 1, 8
         damp_dq_term = damp_dq_term * (damp_dq_ij * drnorm / real(l,wp)) ! damp_dq_term =  (d_{dq}^k r_{ij}^k) / k!
         damp_dq_sum = damp_dq_sum + damp_dq_term
      end do

      ft_ij =  (C_ij * drnorm6rec) * (6.0_wp * drnorm2rec * (1.0_wp - damp_dd_sum*exp(-damp_dd_ij*drnorm)) &
            - damp_dd_ij * damp_dd_term * drnormrec* exp(-damp_dd_ij * drnorm)) &
            + (D_ij * drnorm8rec) * (8.0_wp * drnorm2rec * (1.0_wp - damp_dq_sum*exp(-damp_dq_ij*drnorm)) &
            - damp_dq_ij * damp_dq_term * drnormrec* exp(-damp_dq_ij * drnorm))

      ft_ij=ft_ij-eta1_ij*B1_ij*exp(-eta1_ij*drnorm)*drnormrec
      ft_ij(1)=ft_ij(1)*dx
      ft_ij(2)=ft_ij(2)*dy
      ft_ij(3)=ft_ij(3)*dz

!     txx=3.0_wp*dx*dx*drnorm2rec-1.0_wp
!     tyy=3.0_wp*dy*dy*drnorm2rec-1.0_wp
!     tzz=3.0_wp*dz*dz*drnorm2rec-1.0_wp
!     txy=3.0_wp*dx*dy*drnorm2rec
!     txz=3.0_wp*dx*dz*drnorm2rec
!     tyz=3.0_wp*dy*dz*drnorm2rec
!     rkappai=kappaixx*txx+kappaiyy*tyy+kappaizz*tzz+ &
!             2.0_wp*(kappaixy*txy+kappaixz*txz+kappaiyz*tyz)
!     rkappaj=kappajxx*txx+kappajyy*tyy+kappajzz*tzz+ &
!             2.0_wp*(kappajxy*txy+kappajxz*txz+kappajyz*tyz)
!     rho=drnorm-deltai-deltaj-repsiloni-repsilonj-rkappai-rkappaj
      repsiloni=drnormrec*(-epsilonix*dx-epsiloniy*dy-epsiloniz*dz)
      repsilonj=drnormrec*(-epsilonjx*dx-epsilonjy*dy-epsilonjz*dz)
      rho=drnorm-deltai-deltaj-repsiloni+repsilonj

      sgam=eta2_ij*B2_ij*exp(-eta2_ij*rho)  +  eta3_ij*B3_ij*exp(-eta3_ij*rho)

      sgam2x=drnormrec*(epsilonix-epsilonjx)+dx*drnorm2rec*(repsiloni-repsilonj)
      sgam2y=drnormrec*(epsiloniy-epsilonjy)+dy*drnorm2rec*(repsiloni-repsilonj)
      sgam2z=drnormrec*(epsiloniz-epsilonjz)+dz*drnorm2rec*(repsiloni-repsilonj)

      ft_ij(1)=ft_ij(1)-sgam*(dx*drnormrec+sgam2x)
      ft_ij(2)=ft_ij(2)-sgam*(dy*drnormrec+sgam2y)
      ft_ij(3)=ft_ij(3)-sgam*(dz*drnormrec+sgam2z)
      
   end function force_ij

   ! ================================================================================
   ! Function to compute the potential felt between 2 particles
   !
   ! ft_ij = V(r_ij)
   function potential_ij(dx,dy,dz,drnorm2,deltai,deltaj,epsilonix,epsiloniy,epsiloniz,&
            epsilonjx,epsilonjy,epsilonjz,eta1_ij, eta2_ij, eta3_ij, &
            B1_ij, B2_ij, B3_ij, C_ij, D_ij, damp_dd_ij, damp_dq_ij) result(ft_ij)
      implicit none
      !$acc routine seq
      ! Passed in
      ! ---------
      real(wp), intent(in) :: dx,dy,dz,drnorm2
      real(wp), intent(in) :: deltai,deltaj
      real(wp), intent(in) :: epsilonix,epsiloniy,epsiloniz
      real(wp), intent(in) :: epsilonjx,epsilonjy,epsilonjz
      real(wp), intent(in) :: eta1_ij
      real(wp), intent(in) :: eta2_ij
      real(wp), intent(in) :: eta3_ij
      real(wp), intent(in) :: B1_ij
      real(wp), intent(in) :: B2_ij
      real(wp), intent(in) :: B3_ij
      real(wp), intent(in) :: C_ij
      real(wp), intent(in) :: D_ij
      real(wp), intent(in) :: damp_dd_ij
      real(wp), intent(in) :: damp_dq_ij

      ! Result
      ! ------
      real(wp) :: ft_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec,drnorm2rec, drnorm6rec, drnorm8rec
      real(wp) :: rho,repsiloni,repsilonj
      real(wp) :: damp_dd_sum, damp_dd_term
      real(wp) :: damp_dq_sum, damp_dq_term
      integer :: k, l

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp / drnorm
      drnorm2rec = 1.0_wp / drnorm2
      drnorm6rec = drnorm2rec * drnorm2rec * drnorm2rec
      drnorm8rec = drnorm2rec * drnorm6rec

      ! damp_dd_sum = sum_{k=0}^{6} (d_{dd}^k r_{ij}^k) / k!
      damp_dd_sum = 1.0_wp
      damp_dd_term = 1.0_wp
      do k = 1, 6
         damp_dd_term = damp_dd_term * (damp_dd_ij * drnorm / real(k,wp)) ! damp_dd_term =  (d_{dd}^k r_{ij}^k) / k!
         damp_dd_sum = damp_dd_sum + damp_dd_term
      end do

      ! damp_dq_sum = sum_{k=0}^{8} (d_{dq}^k r_{ij}^k) / k!
      damp_dq_sum = 1.0_wp
      damp_dq_term = 1.0_wp
      do l = 1, 8
         damp_dq_term = damp_dq_term * (damp_dq_ij * drnorm / real(l,wp)) ! damp_dq_term =  (d_{dq}^k r_{ij}^k) / k!
         damp_dq_sum = damp_dq_sum + damp_dq_term
      end do

      repsiloni=drnormrec*(-epsilonix*dx-epsiloniy*dy-epsiloniz*dz)
      repsilonj=drnormrec*(-epsilonjx*dx-epsilonjy*dy-epsilonjz*dz)
      rho=drnorm-deltai-deltaj-repsiloni+repsilonj

      ft_ij = B1_ij * exp(-eta1_ij * drnorm) &
            + B2_ij * exp(-eta2_ij * rho) &
            + B3_ij * exp(-eta3_ij * rho) &
            - C_ij * drnorm6rec * (1.0_wp - damp_dd_sum*exp(-damp_dd_ij*drnorm)) &
            - D_ij * drnorm8rec * (1.0_wp - damp_dq_sum*exp(-damp_dq_ij*drnorm))
   end function potential_ij

   ! ================================================================================
   ! Function to compute the repulsive potential felt between 2 particles
   !
   ! ft_ij = V(r_ij)
   function reppotential_ij(dx,dy,dz,drnorm2,deltai,deltaj,epsilonix,epsiloniy,epsiloniz,&
            epsilonjx,epsilonjy,epsilonjz, eta2_ij, eta3_ij, &
             B2_ij, B3_ij) result(ft_ij)
      implicit none
      !$acc routine seq
      ! Passed in
      ! ---------
      real(wp), intent(in) :: dx,dy,dz,drnorm2
      real(wp), intent(in) :: deltai,deltaj
      real(wp), intent(in) :: epsilonix,epsiloniy,epsiloniz
      real(wp), intent(in) :: epsilonjx,epsilonjy,epsilonjz
      real(wp), intent(in) :: eta2_ij
      real(wp), intent(in) :: eta3_ij
      real(wp), intent(in) :: B2_ij
      real(wp), intent(in) :: B3_ij

      ! Result
      ! ------
      real(wp) :: ft_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec
      real(wp) :: rho,repsiloni,repsilonj

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp /drnorm

      repsiloni=drnormrec*(-epsilonix*dx-epsiloniy*dy-epsiloniz*dz)
      repsilonj=drnormrec*(-epsilonjx*dx-epsilonjy*dy-epsilonjz*dz)
      rho=drnorm-deltai-deltaj-repsiloni+repsilonj

      ft_ij =  B2_ij * exp(-eta2_ij * rho) &
            + B3_ij * exp(-eta3_ij * rho) 
   end function reppotential_ij

   ! ================================================================================
   ! Function to compute the repulsive potential felt between 2 particles and its 
   ! derivative w.r.t. the deltas and the epsilons
   !
   ! ft_ij = V(r_ij)
   function diffreppotential_ij(dx,dy,dz,drnorm2,deltai,deltaj,epsilonix,epsiloniy,epsiloniz,&
            epsilonjx,epsilonjy,epsilonjz, eta2_ij, eta3_ij, &
             B2_ij, B3_ij) result(ft_ij)
      implicit none
      !$acc routine seq
      ! Passed in
      ! ---------
      real(wp), intent(in) :: dx,dy,dz,drnorm2
      real(wp), intent(in) :: deltai,deltaj
      real(wp), intent(in) :: epsilonix,epsiloniy,epsiloniz
      real(wp), intent(in) :: epsilonjx,epsilonjy,epsilonjz
      real(wp), intent(in) :: eta2_ij
      real(wp), intent(in) :: eta3_ij
      real(wp), intent(in) :: B2_ij
      real(wp), intent(in) :: B3_ij

      ! Result
      ! ------
      real(wp),dimension(5) :: ft_ij

      ! Local
      ! -----
      real(wp) :: drnorm, drnormrec
      real(wp) :: rho,repsiloni,repsilonj
      real(wp) :: exprho2,exprho3

      drnorm = sqrt(drnorm2)
      drnormrec = 1.0_wp /drnorm

      repsiloni=drnormrec*(-epsilonix*dx-epsiloniy*dy-epsiloniz*dz)
      repsilonj=drnormrec*(-epsilonjx*dx-epsilonjy*dy-epsilonjz*dz)
      rho=drnorm-deltai-deltaj-repsiloni+repsilonj

      exprho2=B2_ij*exp(-eta2_ij*rho)
      exprho3=B3_ij*exp(-eta3_ij*rho)

      ft_ij(1)=eta2_ij*exprho2+eta3_ij*exprho3
      ft_ij(2)=ft_ij(1)*dx*drnormrec
      ft_ij(3)=ft_ij(1)*dy*drnormrec
      ft_ij(4)=ft_ij(1)*dz*drnormrec
      ft_ij(5) =  exprho2+exprho3 
   end function diffreppotential_ij



   ! ================================================================================
   include 'daim_2DPBC.inc'
   include 'daim_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_daim

! Lennard-Jones Potential
! -----------------------
!
! Proposed by Sir John Edward Lennard-Jones, the Lennard-Jones
! potential describes the potential energy of interaction between two
! non-bonding atoms or molecules based on their distance of
! separation. The potential equation accounts for the difference
! between attractive forces (dipole-dipole, dipole-induced dipole, and
! London interactions) and repulsive forces.
!
! The Lennard-Jones model consists of two 'parts'; a steep repulsive
! term, and smoother attractive term, representing the London dispersion
! forces. Apart from being an important model in itself, the
! Lennard-Jones potential frequently forms one of 'building blocks' of
! many force fields. It is worth mentioning that the 12-6 Lennard-Jones
! model is not the most faithful representation of the potential energy
! surface, but rather its use is widespread due to its computational
! expediency.The Lennard-Jones Potential is given by the following
! equation:
!
!   V(r) = 4 * epsilon * [(sigma/r)^12 - (sigma/r)^6]
!
! or
!
!   V(r) = A/(r^12) - B/(r^6)
!
! where:
!
!   * V is the intermolecular potential between the two atoms or
!       molecules.
!   * epsilon is the well depth and a measure of how strongly the two
!             particles attract each other
!   * sigma is the distance at which the intermolecular potential
!           between the two particles is zero. sigma gives a
!           measurement of how close two nonbonding particles can get
!           and is thus referred to as the van der Waals radius. It is
!           equal to one-half of the internuclear distance between
!           nonbonding particles.
!   * r is the distance of separation between both particles (measured
!       from the center of one particle to the center of the other
!       particle).
!   * A = 4*epsilon*(sigma^12), B = 4*epsilon*(sigma^6)
!
! Reference
! ---------
!
! John Edward Lennard-Jones "On the Determination of Molecular
! Fields. I. From the Variation of the Viscosity of a Gas with
! Temperature", Proceedings of the Royal Society of London. Series A,
! Containing Papers of a Mathematical and Physical Character 106
! pp. 441-462 (1924)
!
! John Edward Lennard-Jones "On the Determination of Molecular
! Fields. II. From the Equation of State of a Gas", Proceedings of the
! Royal Society of London. Series A, Containing Papers of a Mathematical
! and Physical Character 106 pp. 463-477 (1924)

!
module MW_lennard_jones
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_timers
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_molecule, only: MW_molecule_t
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_lennard_jones_t

   ! Public subroutines
   ! ------------------
   public :: define_type
   public :: copy_type
   public :: void_type
   public :: print_type
   public :: set_rcut
   public :: set_parameters
   public :: lorentz_berthelot_mixing_rule
   public :: melt_forces
   public :: stress_tensor_tail_correction
   public :: energy
   public :: melt_fix_molecule_forces
   public :: fix_molecule_energy

   ! Data structure to handle Lennard-Jones potentials
   ! V(r) = A/(r^12) - B/(r^6)
   type MW_lennard_jones_t
      integer :: num_species = 0                    ! number of species
      real(wp) :: rcut = 0.0_wp                     ! cut-off parameter
      real(wp) :: rcutsq = 0.0_wp                     ! cut-off parameter squared
      real(wp), dimension(:,:), allocatable :: A    ! (num_species,num_species)
      real(wp), dimension(:,:), allocatable :: B    ! (num_species,num_species)
      real(wp), dimension(:,:), allocatable :: shift ! (num_species,num_species)
      real(wp), dimension(:,:), allocatable :: alpha ! (num_species,num_species)
      logical :: lj_3D_tail_correction = .false.         !< flag to turn on the LJ flat tail correction in 3D
    end type MW_lennard_jones_t

   integer, parameter :: ION_NAME_LEN = 8

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, num_species, rcut)
      use MW_errors, only: &
            MW_errors_allocate_error => allocate_error, &
            MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ---------_
      type(MW_lennard_jones_t), intent(inout) :: this      !> structure to be defined
      integer, intent(in) :: num_species                    !> number of species
      real(wp), intent(in) :: rcut

      ! Local
      ! -----
      integer :: ierr

      call set_rcut(this, rcut)

      if (num_species <= 0) then
         call MW_errors_parameter_error("define_type", "lennard_jones.f90",&
               "num_species", num_species)
      end if

      this%num_species = num_species

      allocate(this%A(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "lennard_jones.f90", ierr)
      this%A(:,:) = 0.0_wp

      allocate(this%B(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "lennard_jones.f90", ierr)
      this%B(:,:) = 0.0_wp

      allocate(this%shift(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "lennard_jones.f90", ierr)
      this%shift(:,:) = 0.0_wp

      allocate(this%alpha(num_species,num_species), stat=ierr)
      if (ierr /= 0) &
            call MW_errors_allocate_error("define_type", "lennard_jones.f90", ierr)
      this%alpha(:,:) = 0.0_wp

   end subroutine define_type

   !================================================================================
   subroutine copy_type(this, copy)
      implicit none

      type(MW_lennard_jones_t), intent(in) :: this
      type(MW_lennard_jones_t), intent(out) :: copy

      ! Local
      ! -----
      integer :: i, j

      call define_type(copy, this%num_species, this%rcut)

      do i=1, copy%num_species
         do j=1, copy%num_species
            copy%A(i,j) = this%A(i,j)
            copy%B(i,j) = this%B(i,j)
            copy%shift(i,j) = this%shift(i,j)
            copy%alpha(i,j) = this%alpha(i,j)
         end do
      end do

   end subroutine copy_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      use MW_errors, only: MW_errors_deallocate_error => deallocate_error
      implicit none
      type(MW_lennard_jones_t), intent(inout) :: this

      integer :: ierr

      if (allocated(this%B)) then
         deallocate(this%B, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "lennard_jones.f90", ierr)
         end if
      end if

      if (allocated(this%A)) then
         deallocate(this%A, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "lennard_jones.f90", ierr)
         end if
      end if

      if (allocated(this%shift)) then
         deallocate(this%shift, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "lennard_jones.f90", ierr)
         end if
      end if

      if (allocated(this%alpha)) then
         deallocate(this%alpha, stat=ierr)
         if (ierr /= 0) then
            call MW_errors_deallocate_error("void_type", "lennard_jones.f90", ierr)
         end if
      end if

      this%num_species = 0
      this%rcut = 0.0_wp
      this%rcutsq = 0.0_wp
   end subroutine void_type

   ! ================================================================================
   ! set rcut value
   subroutine set_rcut(this, rcut)
      implicit none
      type(MW_lennard_jones_t), intent(inout) :: this
      real(wp), intent(in) :: rcut

      this%rcut = rcut
      this%rcutsq = rcut*rcut
   end subroutine set_rcut

   ! ================================================================================
   ! set rcut value
   subroutine set_parameters(this, typeA, typeB, lj_eps, lj_sig)
      use MW_constants, only: kJpermol2hartree, angstrom2bohr
      implicit none
      type(MW_lennard_jones_t), intent(inout) :: this
      integer, intent(in) :: typeA
      integer, intent(in) :: typeB
      real(wp), intent(in) :: lj_eps ! kJ per mol
      real(wp), intent(in) :: lj_sig ! angstrom

      ! Local
      real(wp) :: lj_A, lj_B, lj_epsilon, lj_sigma

      ! Convert lj_eps from kJ/mol to atomic unit
      lj_epsilon = kJpermol2hartree * lj_eps
      ! convert lj_sig from Angstrom to atomic unit
      lj_sigma = angstrom2bohr * lj_sig

      ! Convert (eps,sig) to (A,B)
      lj_A = 4.0_wp * lj_epsilon * lj_sigma**12
      lj_B = 4.0_wp * lj_epsilon * lj_sigma**6

      this%A(typeA,typeB) = lj_A
      this%A(typeB,typeA) = lj_A

      this%B(typeA,typeB) = lj_B
      this%B(typeB,typeA) = lj_B

      this%shift(typeA,typeB) = lj_sigma**6
      this%shift(typeB,typeA) = lj_sigma**6

   end subroutine set_parameters

   ! ================================================================================
   ! set rcut value
   subroutine lorentz_berthelot_mixing_rule(this)
      implicit none
      type(MW_lennard_jones_t), intent(inout) :: this

      ! Local
      integer :: itype, jtype
      real(wp) :: lj_sig1, lj_sig2, lj_eps1, lj_eps2

      do itype = 1, this%num_species
         do jtype = itype+1, this%num_species
            if (this%A(itype,itype)>0 .and. this%A(jtype,jtype)>0) then
               lj_sig1 = this%shift(itype,itype)**(1.0_wp/6.0_wp)
               lj_sig2 = this%shift(jtype,jtype)**(1.0_wp/6.0_wp)
               lj_eps1 = this%B(itype,itype)*this%B(itype,itype) / this%A(itype,itype) / 4.0_wp
               lj_eps2 = this%B(jtype,jtype)*this%B(jtype,jtype) / this%A(jtype,jtype) / 4.0_wp
               this%A(itype,jtype) = 4.0_wp * sqrt(lj_eps1 * lj_eps2) * ((lj_sig1 + lj_sig2)/2.0_wp)**12
               this%A(jtype,itype) = 4.0_wp * sqrt(lj_eps1 * lj_eps2) * ((lj_sig1 + lj_sig2)/2.0_wp)**12
               this%B(itype,jtype) = 4.0_wp * sqrt(lj_eps1 * lj_eps2) * ((lj_sig1 + lj_sig2)/2.0_wp)**6
               this%B(jtype,itype) = 4.0_wp * sqrt(lj_eps1 * lj_eps2) * ((lj_sig1 + lj_sig2)/2.0_wp)**6
               this%shift(itype,jtype) = ((lj_sig1+lj_sig2)/2.0_wp)**6
               this%shift(jtype,itype) = ((lj_sig1+lj_sig2)/2.0_wp)**6
            end if
         end do
      end do

   end subroutine lorentz_berthelot_mixing_rule

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, species_names, ounit)
      use MW_kinds, only: PARTICLE_NAME_LEN
      implicit none
      type(MW_lennard_jones_t), intent(in) :: this               ! structure to be printed
      character(PARTICLE_NAME_LEN),   intent(in) :: species_names(:)   ! names of the species
      integer,                   intent(in) :: ounit              ! output unit

      integer :: i, j

      write(ounit, '("|lennard-jones| cut-off distance: ",es12.5)') this%rcut
      write(ounit, '("|lennard-jones| ",8x,1x,8x,1x,"     A      ",1x,"     B      ")')

      do j = 1, this%num_species
         do i = j, this%num_species
            write(ounit, '("|lennard-jones| ",a8,1x,a8,1x,es12.5,1x,es12.5)') &
                  species_names(i), species_names(j), this%A(i,j), this%B(i,j)
         end do
      end do

   end subroutine print_type

   ! ==============================================================================
   ! Compute Lennard-Jones forces felt by melt ions
   subroutine melt_forces(num_pbc, localwork, lj, box, ions, xyz_ions, type_ions, &
         electrodes, xyz_elec, force, stress_tensor,  compute_force, soft)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc                !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_lennard_jones_t), intent(in) :: lj    !< Lennard-Jones potential parameters
      type(MW_box_t),   intent(in) :: box           !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)         !< Ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)   !< Ions xyz positions
      integer,        intent(in) :: type_ions(:)    !< Ion types

      type(MW_electrode_t), intent(inout) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_elec(:,:)  !< electrode atoms xyz positions
      logical,              intent(in) :: compute_force !< compute_force on electrodes
      logical,             intent(in) :: soft

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< LJ force on ions
      real(wp), intent(inout) :: stress_tensor(:,:) !< LJ stress

      ! Local
      ! -----
      integer :: ierr, i
      integer :: count, num_elec_types
      select case(num_pbc)
      case(2)
         if (soft) then
            call melt_forces_soft_core_2DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_elec, force, stress_tensor)
         else
            call melt_forces_2DPBC(localwork, lj, box, ions, xyz_ions, type_ions, &
                  electrodes, xyz_elec, force, stress_tensor)
         end if
      case(3)
         if (soft) then
            call melt_forces_soft_core_3DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_elec, force, stress_tensor)
         else
            call melt_forces_3DPBC(localwork, lj, box, ions, xyz_ions, type_ions, &
                  electrodes, xyz_elec, force, stress_tensor)
         end if
      end select
#ifndef MW_SERIAL
      count = size(force,1)*size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)


      if (compute_force) then
         num_elec_types = size(electrodes, 1)
         do i = 1, num_elec_types
            call MPI_Allreduce(MPI_IN_PLACE, electrodes(i)%force_ions(:,7), 3, &
                  MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
         end do
      end if
#endif
   end subroutine melt_forces

   ! ==============================================================================
   ! Compute tail correction to the stress tensor 
   subroutine stress_tensor_tail_correction(lj, box, ions,tail_correction)
      use MW_constants, only : pi     
      implicit none

      ! Parameters in
      ! -------------
      type(MW_lennard_jones_t), intent(in) :: lj      !< Lennard-Jones potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: tail_correction !< tail correction to the stress tensor

      ! Local
      ! -----
      integer :: itype,jtype,num_ion_types
      integer :: count_n,count_m
      real(wp) :: rcutsq,rcut,A_ij,B_ij

      num_ion_types = size(ions,1)

      rcutsq = lj%rcutsq
      rcut=sqrt(rcutsq)
      tail_correction=0.0_wp
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
!        do jtype =  itype, num_ion_types
         do jtype =  1, num_ion_types
            count_m = ions(jtype)%count
            A_ij = lj%A(itype, jtype)
            B_ij = lj%B(itype, jtype)
            !Analytical LJ 3D correction from Frenkel Smit book,
            tail_correction=tail_correction- &
                    2.0*pi*count_m*count_n/product(box%length(:))*(-4.0*A_ij/(3.0*rcut**9.0)+B_ij*2.0/(rcut**3.0))
         end do
      end do

   end subroutine stress_tensor_tail_correction        

   ! ==============================================================================
   ! Compute Lennard-Jones potential felt by melt ions
   subroutine energy(num_pbc, localwork, lj, box, ions, xyz_ions, &
         electrodes, xyz_atoms, h, soft)
      implicit none

      ! Parameters in
      ! -------------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_lennard_jones_t), intent(in) :: lj      !< Lennard-Jones potential parameters
      type(MW_box_t),   intent(in) :: box     !< Simulation box parameters

      type(MW_ion_t), intent(in) :: ions(:)        !< ions parameters
      real(wp),       intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      type(MW_electrode_t), intent(in) :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      logical,             intent(in) :: soft

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h(:)       !< Potential energy due to L-J interactions

      ! Local
      ! -----
      integer :: ierr, count

      select case(num_pbc)
      case(2)
         if (soft) then
            call energy_soft_core_2DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_atoms, h)
         else
            call energy_2DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_atoms, h)
         end if
      case(3)
         if (soft) then
            call energy_soft_core_3DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_atoms, h)
         else
            call energy_3DPBC(localwork, lj, box, ions, xyz_ions, &
                  electrodes, xyz_atoms, h)
         end if
      end select

#ifndef MW_SERIAL
      count = size(h,1)
      call MPI_Allreduce(MPI_IN_PLACE, h, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   ! ================================================================================
   ! Remove contribution from same molecule particles
   !
   subroutine melt_fix_molecule_forces(num_pbc, localwork, lj, molecules, box, ions, &
         xyz_ions, force, stress_tensor, soft)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_lennard_jones_t), intent(in) :: lj      !< Lennard-Jones potential parameters
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< ions parameters
      real(wp), intent(in) :: xyz_ions(:,:) !< melt particles coordinates
      real(wp), intent(inout) :: force(:,:) !< force on melt particles
      real(wp), intent(inout) :: stress_tensor(:,:) !< stress tensor contribution
      logical,             intent(in) :: soft

      ! Local
      ! -----
      integer :: ierr
      integer :: count
      select case(num_pbc)
      case(2)
         if (soft) then
            call melt_fix_molecule_forces_soft_core_2DPBC(localwork, lj, molecules, box, ions, &
                  xyz_ions, force, stress_tensor)
         else
            call melt_fix_molecule_forces_2DPBC(localwork, lj, molecules, box, ions, &
                  xyz_ions, force, stress_tensor)
         end if
      case(3)
         if (soft) then
            call melt_fix_molecule_forces_soft_core_3DPBC(localwork, lj, molecules, box, ions, &
                  xyz_ions, force, stress_tensor)
         else
            call melt_fix_molecule_forces_3DPBC(localwork, lj, molecules, box, ions, &
                  xyz_ions, force, stress_tensor)
         end if
      end select
#ifndef MW_SERIAL
      count = size(force,1)*size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)      ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine melt_fix_molecule_forces

   ! ================================================================================
   ! Remove contribution from same molecule particles
   !
   subroutine fix_molecule_energy(num_pbc, localwork, lj, molecules, box, ions, &
         xyz_ions, h, soft)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: num_pbc !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in) :: localwork
      type(MW_lennard_jones_t), intent(in) :: lj      !< Lennard-Jones potential parameters
      type(MW_molecule_t), intent(in) :: molecules(:) !< molecules parameters
      type(MW_box_t), intent(in) :: box !< box parameters
      type(MW_ion_t), intent(in) :: ions(:) !< melt particle parameters
      real(wp), intent(in) :: xyz_ions(:,:) !< melt particles coordinates
      real(wp), intent(inout) :: h(:) !< potential on melt particles
      logical,             intent(in) :: soft

      ! Local
      ! -----
      integer :: ierr, count

      select case(num_pbc)
      case(2)
         if (soft) then
            call fix_molecule_energy_soft_core_2DPBC(localwork, lj, molecules, box, ions, &
               xyz_ions, h)
         else
            call fix_molecule_energy_2DPBC(localwork, lj, molecules, box, ions, &
               xyz_ions, h)
         end if
      case(3)
         if (soft) then
            call fix_molecule_energy_soft_core_3DPBC(localwork, lj, molecules, box, ions, &
               xyz_ions, h)
         else
            call fix_molecule_energy_3DPBC(localwork, lj, molecules, box, ions, &
               xyz_ions, h)
         end if
      end select

#ifndef MW_SERIAL
      count = size(h,1)
      call MPI_Allreduce(MPI_IN_PLACE, h, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_energy

   ! ================================================================================
   ! Function to compute force coeffcient between 2 particles
   !
   ! lj_ij = (dV(r_ij) / dr_ij) * (1/ r_ij)
   function force_ij(drnorm2, A_ij, B_ij) result(lj_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: A_ij
      real(wp), intent(in) :: B_ij

      ! Result
      ! ------
      real(wp) :: lj_ij

      ! Local
      ! -----

      real(wp) :: drnorm2rec, drnorm6rec, drnorm8rec

      drnorm2rec = 1.0_wp / drnorm2
      drnorm6rec = drnorm2rec * drnorm2rec * drnorm2rec
      drnorm8rec = drnorm2rec * drnorm6rec
      lj_ij = (-12.0_wp*A_ij*drnorm6rec + 6.0_wp*B_ij)*drnorm8rec
   end function force_ij

   ! ================================================================================
   ! Function to compute the potential felt between 2 particles
   !
   ! lj_ij = V(r_ij) - V(r_cut)
   function potential_ij(drnorm2, A_ij, B_ij) result(lj_ij)
      implicit none
      ! Passed in
      ! ---------
      real(wp), intent(in) :: drnorm2
      real(wp), intent(in) :: A_ij
      real(wp), intent(in) :: B_ij

      ! Result
      ! ------
      real(wp) :: lj_ij

      ! Local
      ! -----
      real(wp) :: drnorm2rec, drnorm6rec, drnorm12rec

      drnorm2rec = 1.0_wp / drnorm2
      drnorm6rec = drnorm2rec * drnorm2rec * drnorm2rec
      drnorm12rec = drnorm6rec * drnorm6rec

      lj_ij = A_ij * drnorm12rec - B_ij * drnorm6rec
   end function potential_ij

   ! ================================================================================
   include 'lennard_jones_2DPBC.inc'
   include 'lennard_jones_3DPBC.inc'
   include 'lennard_jones_soft_core_2DPBC.inc'
   include 'lennard_jones_soft_core_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'
   ! ================================================================================
   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_lennard_jones

module MW_multipole_tensors
   use MW_kinds, only: wp 
   implicit none 
   private

   ! Public functions
   ! ----------------------
   public :: tij
   public :: tij_a
   public :: tij_ab
   public :: tij_abc

contains 

! ===============================================================================================
! Compute the modified multipolar tensors of rank 0 (scalar).
subroutine tij(drnorm2, dx, dy, dz, alpha, alphasq, alphapi, t)
   implicit none

   ! Passed in
   ! ---------
   real(wp), intent(in) :: drnorm2
   real(wp), intent(in) :: dx,dy,dz
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: alphasq ! alpha*alpha
   real(wp), intent(in) :: alphapi ! 2.0_wp*alpha/sqrtpi

   ! Result
   ! ------
   real(wp), intent(inout) :: t

   ! Local
   ! -----
   real(wp) :: drnorm

   drnorm = sqrt(drnorm2)
   t = erfc(alpha*drnorm)/drnorm

end subroutine tij

! ===============================================================================================
! Compute the modified multipolar tensors of rank 1 (dimension 1x3).
subroutine tij_a(drnorm2, dx, dy, dz, alpha, alphasq, alphapi, tij) 
   implicit none

   ! Passed in
   ! ---------
   real(wp), intent(in) :: drnorm2
   real(wp), intent(in) :: dx,dy,dz
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: alphasq ! alpha*alpha
   real(wp), intent(in) :: alphapi ! 2.0_wp*alpha/sqrtpi

   ! Result
   ! ----------
   real(wp), dimension(3), intent(inout) :: tij

   ! Local
   ! ----------
   real(wp), dimension(3) :: dr ! dr = dri - drj
   real(wp) :: drnorm, drnormrec, drnorm2rec
   real(wp) :: erfc_alpha, exp_alpha
   real(wp) :: drnorm3rec_scr

   dr(1) = -dx ! dx = dxj - dxi
   dr(2) = -dy ! dy = dyj - dyi
   dr(3) = -dz ! dz = dzj - dzi

   drnorm = sqrt(drnorm2)
   drnormrec = 1.0_wp/drnorm
   drnorm2rec = drnormrec*drnormrec
   erfc_alpha = erfc(alpha*drnorm)*drnormrec
   exp_alpha = exp(-alphasq*drnorm2)*alphapi

   drnorm3rec_scr = (erfc_alpha + exp_alpha)*drnorm2rec

   tij = -dr*drnorm3rec_scr
   
end subroutine tij_a

! ===============================================================================================
! Compute the modified multipolar tensors of rank 2 (6 independent components).
subroutine tij_ab(drnorm2, dx, dy, dz, alpha, alphasq, alphapi, tij)
   implicit none

   ! Passed in
   ! ---------
   real(wp), intent(in) :: drnorm2
   real(wp), intent(in) :: dx,dy,dz
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: alphasq ! alpha*alpha
   real(wp), intent(in) :: alphapi ! 2.0_wp*alpha/sqrtpi

   ! Result
   ! ----------
   real(wp), dimension(3,3), intent(inout) :: tij ! six independent components

   ! Local
   ! ----------
   real(wp), dimension(3) :: dr ! dr = dri - drj
   integer :: a, b
   real(wp) :: drnorm, drnormrec, drnorm2rec
   real(wp) :: erfc_alpha, exp_alpha
   real(wp) :: drnorm3rec_scr, drnorm5rec_scr

   dr(1) = -dx ! dx = dxj - dxi
   dr(2) = -dy ! dy = dyj - dyi
   dr(3) = -dz ! dz = dzj - dzi

   drnorm = sqrt(drnorm2)
   drnormrec = 1.0_wp/drnorm
   drnorm2rec = drnormrec*drnormrec
   erfc_alpha = erfc(alpha*drnorm)*drnormrec
   exp_alpha = exp(-alphasq*drnorm2)*alphapi

   drnorm3rec_scr = (erfc_alpha + exp_alpha)*drnorm2rec
   drnorm5rec_scr = (drnorm3rec_scr + 2.0_wp*alphasq*exp_alpha/3.0_wp)*drnorm2rec

   do b = 1, 3
      do a = 1, 3
         tij(a, b) = 3.0_wp*dr(a)*dr(b)*drnorm5rec_scr 
         if (a == b) tij(a, b) = tij(a, b) - drnorm3rec_scr
      end do
   end do
   
end subroutine tij_ab

! ===============================================================================================
! Compute the modified multipolar tensors of rank 3 (10 independent components).
subroutine tij_abc(drnorm2, dx, dy, dz, alpha, alphasq, alphapi, tij)
   implicit none

   ! Passed in
   ! ---------
   real(wp), intent(in) :: drnorm2
   real(wp), intent(in) :: dx,dy,dz
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: alphasq ! alpha*alpha
   real(wp), intent(in) :: alphapi ! 2.0_wp*alpha/sqrtpi

   ! Result
   ! ----------
   real(wp), dimension(3,3,3), intent(inout) :: tij ! 10 independent components

   ! Local
   ! ----------
   real(wp), dimension(3) :: dr ! dr = dri - drj
   integer :: a, b, c
   real(wp) :: drnorm, drnormrec, drnorm2rec
   real(wp) :: erfc_alpha, exp_alpha, tmp
   real(wp) :: drnorm3rec_scr, drnorm5rec_scr, drnorm7rec_scr

   dr(1) = -dx ! dx = dxj - dxi
   dr(2) = -dy ! dy = dyj - dyi
   dr(3) = -dz ! dz = dzj - dzi

   drnorm = sqrt(drnorm2)
   drnormrec = 1.0_wp/drnorm
   drnorm2rec = drnormrec*drnormrec
   erfc_alpha = erfc(alpha*drnorm)*drnormrec
   exp_alpha = exp(-alphasq*drnorm2)*alphapi

   drnorm3rec_scr = (erfc_alpha + exp_alpha)*drnorm2rec
   drnorm5rec_scr = (drnorm3rec_scr + 2.0_wp*alphasq*exp_alpha/3.0_wp)*drnorm2rec
   drnorm7rec_scr = (drnorm5rec_scr + 4.0_wp*alphasq*alphasq*exp_alpha/15.0_wp)*drnorm2rec

   do c = 1, 3
      do b = 1, 3
         do a = 1, 3
            tij(a, b, c) = -15.0_wp*dr(a)*dr(b)*dr(c)*drnorm7rec_scr
            tmp = 3.0_wp*drnorm5rec_scr
            if (a == b) tij(a, b, c) = tij(a, b, c) + tmp*dr(c)
            if (a == c) tij(a, b, c) = tij(a, b, c) + tmp*dr(b)
            if (b == c) tij(a, b, c) = tij(a, b, c) + tmp*dr(a)
         end do
      end do
   end do

end subroutine tij_abc

end module MW_multipole_tensors

program metalwalls
   ! Metal Walls main program
   use MW_parallel, only: MW_parallel_t
   use MW_system, only: MW_system_t
   use MW_algorithms, only: MW_algorithms_t
   use MW_tools, only : MW_tools_initialize => initialize, &
         MW_tools_start_parallel => start_parallel, &
         MW_tools_setup => setup, &
         MW_tools_run_step => run_step, &
         MW_tools_finalize => finalize, &
         MW_tools_finalize_parallel => finalize_parallel

   implicit none

   type(MW_parallel_t) :: parallel
   type(MW_system_t) :: system
   type(MW_algorithms_t) :: algorithms
   logical :: do_output
   integer :: step_output_frequency, istep=0

   call MW_tools_start_parallel(parallel)
   call MW_tools_initialize(system, parallel, algorithms, do_output)
   call MW_tools_setup(system, parallel, algorithms, do_output, step_output_frequency)
   call MW_tools_run_step(system, parallel, algorithms, istep, system%num_steps, &
         do_output, step_output_frequency, .True., .True.)
   call MW_tools_finalize(system, parallel, algorithms)
   call MW_tools_finalize_parallel()


end program metalwalls

#ifdef MW_USE_PLUMED   
module MW_plumed
  
   use MW_kinds, only : wp
   use MW_constants, only: hartree2kJpermol, boltzmann, me2amu, bohr2angstrom, au2ps
   use MW_parallel, only: MW_COMM_WORLD
   use MW_stdio, only: MW_stdout, &
         MW_stdio_set_stdout => set_stdout

   implicit none

   ! private
   public :: init
   public :: calc
   public :: terminate

   ! A data structure to hold plumed related variable
   real(wp)    :: htmp(3,3), dummyvir(3,3)

   ! Add a couple of variables for plumed
   integer     :: total_atoms, plumed_version
   real(wp), dimension(:), allocatable :: massofions
   logical     :: plumedstart = .false.

contains

   subroutine init(temp, plumed_file, num_ions, num_atoms, num_ion_types, dt, ions)
      use MW_ion, only: MW_ion_t

      implicit none

      ! Parameters
      ! ----------
      real(wp), intent(in) :: temp, dt
      integer, intent(in) :: num_ions, num_atoms, num_ion_types
      character(50), intent(in) :: plumed_file
      type(MW_ion_t), intent(in), allocatable :: ions(:)

      ! Local
      ! -----
      character(50) :: plumedout = "plumed.out"
      integer :: itype, iion

      ! Initialized plumed
      call plumed_f_gcreate()
      call plumed_f_gcmd("getApiVersion"//char(0), plumed_version)
      if (plumed_version > 1) then
         call plumed_f_gcmd("setKbT"//char(0), boltzmann * temp)
      else
         print*, 'kT is not set properly and automatically in plumed,'//&
               ' you can probably set it in the plumed input file'//&
               ', please check it carefully'
      end if
      !set double precision
      call plumed_f_gcmd("setRealPrecision"//char(0), 8) 
      !set plumed units 
      total_atoms = num_ions + num_atoms !all the atoms in the MD run i.e solution + electrode
      call plumed_f_gcmd("setMDEnergyUnits"//char(0), hartree2kJpermol)
      call plumed_f_gcmd("setMDLengthUnits"//char(0), bohr2angstrom * 0.1_wp)
      call plumed_f_gcmd("setMDTimeUnits"//char(0), au2ps)
      call plumed_f_gcmd("setPlumedDat"//char(0), trim(adjustl(plumed_file))//char(0))
      call plumed_f_gcmd("setNatoms"//char(0), num_ions)
      call plumed_f_gcmd("setMDEngine"//char(0),"metalwalls")  ! I really have no clue of what is the point to do that
      call plumed_f_gcmd("setTimestep"//char(0), dt)!  system%dt
      call plumed_f_gcmd("setMPIFComm"//char(0), MW_COMM_WORLD)
      call plumed_f_gcmd("setLogFile"//char(0), trim(adjustl(plumedout))//char(0))
      call plumed_f_gcmd("init"//char(0), 0)

      allocate(massofions(num_ions))
      do itype = 1, num_ion_types
         do iion = ions(itype)%offset + 1, ions(itype)%offset + ions(itype)%count
            massofions(iion) = ions(itype)%mass * me2amu
         end do
      end do

      plumedstart = .true. !start to request plumed to do stuff, especially to avoind crashed when calling ener.f90 previous plumed initialisation 
   end subroutine init

!===============================================================================================
 
   subroutine calc(istep, forces_ions, xyz_ions, box, energy)

      use MW_lookup_table, only: MW_lut_t, &
            MW_lookup_table_lut_set => lut_set
      use MW_box, only: MW_box_t
      
      implicit none
 
      ! Parameters
      ! ----------
      integer, intent(in) :: istep
      real(wp), intent(in) :: xyz_ions(:,:)
      real(wp), intent(inout) :: forces_ions(:,:)
      type(MW_box_t), intent(in) :: box
      type(MW_lut_t), intent(inout) :: energy

      ! Local
      ! -----
      real(wp) :: bias
 
      if (plumedstart) then
         call plumed_f_gcmd("setStep"//char(0), istep)
         call plumed_f_gcmd("setPositionsX"//char(0), xyz_ions(:,1))
         call plumed_f_gcmd("setPositionsY"//char(0), xyz_ions(:,2))
         call plumed_f_gcmd("setPositionsZ"//char(0), xyz_ions(:,3))
         call plumed_f_gcmd("setMasses"//char(0),massofions(:))
         !call plumed_f_gcmd("setCharges"//char(0),system%xyz_ions(:,1,xyz_now))
         ! TODO energy refactoring for plumed required because energy array does not exist anymore
         !call plumed_f_gcmd("setEnergy"//char(0),system%energy(1))
         call plumed_f_gcmd("setForcesX"//char(0), forces_ions(:,1))
         call plumed_f_gcmd("setForcesY"//char(0), forces_ions(:,2))
         call plumed_f_gcmd("setForcesZ"//char(0), forces_ions(:,3))
         call plumed_f_gcmd("setVirial"//char(0), dummyvir) !I am not confident at all on the fact that is pint2 is the virial
         htmp = 0.0_wp
         htmp(1,1) = box%length(1)
         htmp(2,2) = box%length(2)
         htmp(3,3) = box%length(3)
         call plumed_f_gcmd("setBox"//char(0), htmp)
         call plumed_f_gcmd("calc"//char(0), 0)
         call plumed_f_gcmd("getBias"//char(0), bias)
         call MW_lookup_table_lut_set(energy, "Plumed_bias", bias)
      end if
 
   end subroutine calc
 
!===============================================================================================
 
   subroutine terminate()
      implicit none
      
      call plumed_f_gfinalize()
      deallocate(massofions)

   end subroutine terminate
 
end module
#endif

! Define an ion data structure
module MW_ion
   use MW_kinds, only: wp, PARTICLE_NAME_LEN
   implicit none
   private

   ! public types
   public :: MW_ion_t

   ! public subroutines
   public :: define_type
   public :: void_type
   public :: print_type
   public :: identify
   public :: get_mass
   public :: copy
   public :: set_mobility

   ! Ion datatype
   type MW_ion_t
      integer                          :: count = 0               !< number of ions of this type
      integer                          :: offset = 0              !< Offset in ions data arrays
      character(len=PARTICLE_NAME_LEN) :: name = ""               !< name
      real(wp)                         :: charge = 0.0_wp         !< electric charge
      real(wp)                         :: polarizability = 0.0_wp !< polarizability
      real(wp)                         :: selfdaimD = 0.0_wp      !< deformability 1
      real(wp)                         :: selfdaimbeta = 0.0_wp   !< deformability 2
      real(wp)                         :: selfdaimzeta = 0.0_wp   !< deformability 3
      real(wp)                         :: mass = 0.0_wp           !< mass in amu
      logical                          :: mobile = .true.         !< does ion move or not?
      logical                          :: is_fourth_site = .false.         !< is the ion the fourth site of a (water) model?
      logical                          :: dump_efg = .false.      !< does ion need the efg to be dumped?
      logical                          :: dump_lammps = .true.    !< does ion need the lammps data to be dumped?
      logical                          :: dump_xyz = .true.       !< does ion need the xyz data to be dumped?
      logical                          :: dump_trajectories = .true. !< does ion need the trajectories data to be dumped?
      logical                          :: dump_pdb = .true.       !< does ion need the pdb data to be dumped?
   end type MW_ion_t

contains

   !================================================================================
   ! Define the data structure
   subroutine define_type(this, name, n, charge, polarizability, selfdaimD, selfdaimbeta,selfdaimzeta,  mass, mobile, &
         is_fourth_site, dump_efg, dump_lammps, dump_xyz, dump_trajectories, dump_pdb)
      use MW_kinds, only: wp
      implicit none
      type(MW_ion_t),   intent(inout) :: this         ! structure to be defined

      character(len=*), intent(in) :: name            ! name of the ion
      integer,          intent(in) :: n               ! number of ions of this type
      real(wp),         intent(in) :: charge          ! electric charge
      real(wp),         intent(in) :: polarizability  ! polarizability
      real(wp),         intent(in) :: selfdaimD       ! deformability
      real(wp),         intent(in) :: selfdaimbeta    ! deformability
      real(wp),         intent(in) :: selfdaimzeta    ! deformability
      real(wp),         intent(in) :: mass            ! mass (in amu)
      logical,          intent(in) :: mobile          ! mobility
      logical,          intent(in) :: is_fourth_site  ! flag if fourth site
      logical,          intent(in), optional :: dump_efg     ! if the efg needs to be dumped
      logical,          intent(in), optional :: dump_lammps  ! if the lammps data needs to be dumped
      logical,          intent(in), optional :: dump_xyz     ! if the xyz data needs to be dumped
      logical,          intent(in), optional :: dump_trajectories  ! if the trajectories data needs to be dumped
      logical,          intent(in), optional :: dump_pdb     ! if the pdb data needs to be dumped

      this%name           = name
      this%count          = n
      this%offset         = 0
      this%charge         = charge
      this%polarizability = polarizability
      this%selfdaimD      = selfdaimD 
      this%selfdaimbeta   = selfdaimbeta
      this%selfdaimzeta   = selfdaimzeta
      this%mass           = mass
      this%mobile         = mobile
      this%is_fourth_site = is_fourth_site

      if (present(dump_efg)) then
         this%dump_efg = dump_efg
      else
         this%dump_efg = .false.
      end if

      if (present(dump_lammps)) then
         this%dump_lammps = dump_lammps
      else
         this%dump_lammps = .true.
      end if

      if (present(dump_xyz)) then
         this%dump_xyz = dump_xyz
      else
         this%dump_xyz = .true.
      end if

      if (present(dump_trajectories)) then
         this%dump_trajectories = dump_trajectories
      else
         this%dump_trajectories = .true.
      end if

      if (present(dump_pdb)) then
         this%dump_pdb = dump_pdb
      else
         this%dump_pdb = .true.
      end if

   end subroutine define_type

   !================================================================================
   ! Void the data structure
   subroutine void_type(this)
      implicit none
      type(MW_ion_t), intent(inout) :: this

      this%name           = ""
      this%count          = 0
      this%offset         = 0
      this%charge         = 0.0_wp
      this%polarizability = 0.0_wp
      this%selfdaimD      = 0.0_wp
      this%selfdaimbeta   = 0.0_wp
      this%selfdaimzeta   = 0.0_wp
      this%mass           = 0.0_wp
      this%mobile         = .true.
      this%is_fourth_site = .false.
      this%dump_efg       = .false.
      this%dump_lammps    = .true.
      this%dump_xyz       = .true.
      this%dump_trajectories = .true.
      this%dump_pdb       = .true.
   end subroutine void_type

   !================================================================================
   ! Print the data structure to ounit
   subroutine print_type(this, ounit)
      implicit none
      type(MW_ion_t), intent(in) :: this          ! structure to be printed
      integer,        intent(in) :: ounit         ! output unit

      if (this%mobile) then
         write(ounit,'("|ion| ",a8,": ",i8," mobile ions with q = ",es12.5," alpha = ",'//&
               'es12.5," m = ",es12.5," and deformabilities",3es12.5)') &
               this%name, this%count, this%charge, this%polarizability, this%mass,&
               this%selfdaimD,this%selfdaimbeta,this%selfdaimzeta
      else
         write(ounit,'("|ion| ",a8,": ",i8," fixed  ions with q = ",es12.5," alpha = ",'//&
               'es12.5," m = ",es12.5," and deformabilities",3es12.5)') &
               this%name, this%count, this%charge, this%polarizability, this%mass,&
               this%selfdaimD,this%selfdaimbeta,this%selfdaimzeta
      end if

   end subroutine print_type

   !================================================================================
   ! copy the src data structure into dest
   subroutine copy(dest, src)
      implicit none
      type(MW_ion_t), intent(inout) :: dest !> destination data structure
      type(MW_ion_t), intent(in)    :: src  !> source data structure

      dest%name   = src%name
      dest%count  = src%count
      dest%offset = src%offset
      dest%charge = src%charge
      dest%polarizability = src%polarizability
      dest%selfdaimD = src%selfdaimD
      dest%selfdaimbeta = src%selfdaimbeta
      dest%selfdaimzeta = src%selfdaimzeta
      dest%mass   = src%mass
      dest%mobile = src%mobile
      dest%is_fourth_site = src%is_fourth_site
      dest%dump_efg = src%dump_efg
      dest%dump_lammps = src%dump_lammps
      dest%dump_xyz = src%dump_xyz
      dest%dump_trajectories = src%dump_trajectories
      dest%dump_pdb = src%dump_pdb
   end subroutine copy

   !================================================================================
   ! Search for an ion in a list and return the index in the list
   !
   ! The first matching index is returned.
   ! 0 is returned if no match found
   subroutine identify(ion_name, ions, ion_index)
      implicit none
      character(*),                 intent(in)  :: ion_name  ! name of ion to search
      type(MW_ion_t), dimension(:), intent(in)  :: ions      ! list of ions
      integer,                      intent(out) :: ion_index ! index of ion in the list

      integer :: i

      ion_index = 0
      do i = 1, size(ions,1)
         if (ion_name == ions(i)%name) then
            ion_index = i
            exit
         end if
      end do
   end subroutine identify

   !================================================================================
   ! Returns the mass of an ion in a list identified by its name
   !
   subroutine get_mass(ion_name, ions, ion_mass)
      use MW_kinds, only: wp
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      character(*),                 intent(in)  :: ion_name ! name of ion to search for
      type(MW_ion_t), dimension(:), intent(in)  :: ions     ! list of ions
      real(wp),                     intent(out) :: ion_mass ! mass of the ion

      integer :: ion_index

      ion_mass = 0.0_wp
      call identify(ion_name, ions, ion_index)
      if (ion_index <= 0) then
         call  MW_errors_parameter_error("MW_ion_getmass", "ions.f90", &
               "ion_name", ion_name)
      end if
      ion_mass = ions(ion_index)%mass

   end subroutine get_mass

   !================================================================================
   ! Returns the mobile character of an ion
   !
   subroutine set_mobility(this, mobile)
      implicit none
      type(MW_ion_t), intent(inout) :: this     ! ion
      logical,        intent(in)    :: mobile   ! can this ion move?
      this%mobile = mobile
   end subroutine set_mobility


end module MW_ion

! Handle command line argument parsing
module MW_command
   implicit none
   private

   public :: MW_command_t
   public :: setup_parser
   public :: parse
   public :: get_option

   public :: ARGUMENT_VALUE_LEN

   integer, parameter :: LONG_OPTION_LEN = 32
   integer, parameter :: OPTION_VALUE_LEN = 64
   integer, parameter :: ARGUMENT_VALUE_LEN = 512
   integer, parameter :: OPTION_ACTION_LEN = 11

   character(OPTION_ACTION_LEN), parameter :: OPTION_ACTION_STORE       = "store"
   character(OPTION_ACTION_LEN), parameter :: OPTION_ACTION_STORE_TRUE  = "store_true"
   character(OPTION_ACTION_LEN), parameter :: OPTION_ACTION_COUNT       = "count"

   type MW_command_t

      ! options
      integer :: num_options
      character(1),                allocatable  :: shortn(:)       ! short options names
      character(LONG_OPTION_LEN),  allocatable  :: longn(:)        ! long options names
      character(OPTION_ACTION_LEN), allocatable :: actions(:)     ! options actions
      integer,                      allocatable :: counts(:)      ! count the number of appearance
      character(OPTION_VALUE_LEN), allocatable  :: values(:)       ! parsed option values
      logical,                     allocatable  :: values_stored(:) ! flag if value was set

      ! positional arguments
      integer :: num_arguments
      character(ARGUMENT_VALUE_LEN), allocatable :: arguments(:) ! parsed positional argument

      ! show help
      procedure(MW_command_help), pointer, nopass :: show_help => NULL()
   end type MW_command_t

   interface get_option
      module procedure get_option_log
      module procedure get_option_int
      module procedure get_option_char
      module procedure get_option_real
      module procedure get_option_double
   end interface get_option

contains

   !================================================================================
   ! Setup the command line parser for Metalwalls
   !
   ! -h, --help     show this help message and exit
   ! -v, --version  show program's version number and exit
   subroutine setup_parser(this)
      implicit none
      type(MW_command_t), intent(inout) :: this

      integer :: num_options = 5
      integer :: num_arguments = 0

      call set_num_options(this, num_options)

      ! Option definitions
      ! call add_option(this, short_opt, long_opt, action_opt, default_val)
      ! -h, --help     show this help message and exit
      call add_option(this, "h", "help", OPTION_ACTION_STORE_TRUE)
      ! -v, --version  show program's version number and exit
      call add_option(this, "v", "version", OPTION_ACTION_STORE_TRUE)
      ! -i, --input    set path to input file
      call add_option(this, "i", "input", OPTION_ACTION_STORE, "runtime.inpt")
      ! -d, --data    set path to data input file
      call add_option(this, "d", "data", OPTION_ACTION_STORE, "data.inpt")
      ! --output-rank set which ranks do output
      call add_option(this, long_opt="output-rank", action_opt=OPTION_ACTION_STORE, default_val="root")

      if (num_arguments > 0) call set_num_arguments(this, num_arguments)
      this%show_help => MW_command_help

   end subroutine setup_parser

   !================================================================================
   ! Print help message to ounit
   subroutine MW_command_help(ounit)
      implicit none
      ! Parameters
      ! ----------
      integer, intent(in) :: ounit

      write(ounit,'("Usage: metalwalls [options]")')
      write(ounit,*)
      write(ounit,'("Mandatory arguments to long options are mandatory for short options too.")')
      write(ounit,'("Options:")')
      write(ounit,'("  -h, --help                 show this message and exit")')
!      write(ounit,'("  -i, --input=FILE           set FILE as runtime input file")')
      write(ounit,'("  -v, --version              show program''s version number and exit")')
      write(ounit,'("      --output-rank=VALUE    enables output on some of the ranks")')
      write(ounit,'("                             possible VALUE are:")')
      write(ounit,'("                               root     - only rank 0 performs output (default)")')
      write(ounit,'("                               all      - all mpi processes perform output")')
      write(ounit,'("                               r1[,r2]* - comma separated list of rank ids which perform output")')

   end subroutine MW_command_help

   !================================================================================
   ! Set the number of options to be stored in the parser
   subroutine set_num_options(this, num_options)
      use MW_errors, only: MW_errors_parameter_error => parameter_error, &
            MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_command_t), intent(inout) :: this
      integer,            intent(in)  :: num_options

      integer :: ierr
      integer :: i

      if (num_options <= 0) then
         call MW_errors_parameter_error("set_num_options", "command.f90", &
               "num_options", num_options)
      end if

      allocate(this%shortn(num_options), this%longn(num_options), &
            this%actions(num_options), this%counts(num_options), &
            this%values(num_options), this%values_stored(num_options), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("set_num_options", "command.f90", ierr)
      end if

      this%num_options = 0
      do i = 1, num_options
         this%shortn(i)         = ""
         this%longn(i)          = ""
         this%actions(i)       = ""
         this%counts(i)        = 0
         this%values(i)        = ""
         this%values_stored(i) = .false.
      end do

   end subroutine set_num_options

   !================================================================================
   ! Set the number of potisional arguments to be stored in the parser
   subroutine set_num_arguments(this, num_arguments)
      use MW_errors, only: MW_errors_parameter_error => parameter_error, &
            MW_errors_allocate_error => allocate_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_command_t), intent(inout) :: this
      integer,                   intent(in)  :: num_arguments

      integer :: ierr
      integer :: i

      if (num_arguments <= 0) then
         call MW_errors_parameter_error("set_num_options", "command.f90", &
               "num_arguments", num_arguments)
      end if

      allocate(this%arguments(num_arguments), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("set_num_arguments", "command.f90", ierr)
      end if

      this%num_arguments = 0
      do i = 1, num_arguments
         this%arguments(i) = ""
      end do

   end subroutine set_num_arguments

   !================================================================================
   ! Add an option to the parser
   subroutine add_option(this, short_opt, long_opt, action_opt, default_val)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      ! Parameters
      ! ----------
      type(MW_command_t), intent(inout) :: this
      character(*),              intent(in), optional :: short_opt   ! option short name
      character(*),              intent(in), optional :: long_opt    ! option long  name
      character(*),              intent(in), optional :: action_opt  ! option action
      character(*),              intent(in), optional :: default_val ! default value

      character(1) :: short
      character(LONG_OPTION_LEN) :: long
      character(OPTION_ACTION_LEN) :: action
      character(OPTION_VALUE_LEN) :: val
      integer :: i

      short = ""
      if (present(short_opt)) then
         ! short_opt must be only 1 character
         if (len_trim(adjustl(short_opt)) /= 1) then
            call MW_errors_parameter_error("add_option", "command.f90", &
                  "short_opt", short_opt)
         end if
         short = adjustl(short_opt)
      end if

      long  = ""
      if (present(long_opt)) then
         ! long_opt must be more than 1 character
         if (len_trim(adjustl(long_opt)) < 2) then
            call MW_errors_parameter_error("add_option", "command.f90", &
                  "long_opt", long_opt)
         end if
         long = long_opt
      end if

      action = OPTION_ACTION_STORE
      if (present(action_opt)) action = action_opt

      val = ""
      if (present(default_val)) val = default_val

      ! Check that at least one of the two option is provided...
      if ((short == "") .and. (long == "")) then
         call MW_errors_parameter_error("add_option", "command.f90", &
               "short_opt, long_opt", short_opt // ", " // long_opt)
      end if

      ! Check that there is enough space to store this options
      if (this%num_options >= size(this%shortn)) then
         call MW_errors_parameter_error("add_option", "command.f90", &
               "num_options", this%num_options)
      end if

      ! Add the option in the list
      this%num_options = this%num_options + 1
      i = this%num_options
      this%shortn(i)   = short
      this%longn(i)    = long
      this%actions(i) = action
      this%counts(i)  = 0
      this%values(i)  = val
      this%values_stored(i) = .false.

   end subroutine add_option

   !================================================================================
   ! Parse the command line
   !
   ! useful intrinsic functions/subroutines
   !
   ! command_argument_count(), inquiry function
   !   The result is the number of command arguments used to invoke the execution
   !   of the program containing the reference to this function. If the processor
   !   does not support command arguments, the result is zero. If the processor
   !   has a concept of command name, the count does not include the command name.
   !
   ! get_command({command, length, status}), subroutine
   !   Obtain the entire command initiating the program
   !
   ! get_command_argument(number{, value, length, status}), subroutine
   !   Obtain a specified command argument
   !
   subroutine parse(this, arg_string_in)
      use MW_errors, only: MW_errors_allocate_error => allocate_error, &
            MW_errors_runtime_error => runtime_error
      implicit none
      type(MW_command_t), intent(inout) :: this
      character(len=*), intent(in), optional :: arg_string_in(0:)
      integer :: ierr
      integer :: i
      integer :: arg_len, max_len
      integer :: arg_count
      logical :: positional_argument

      character(ARGUMENT_VALUE_LEN), allocatable :: arg_string(:)

      if (present(arg_string_in)) then
         arg_count = ubound(arg_string_in,1)
         max_len = len(arg_string_in(0))
      else
         arg_count = command_argument_count()
         ! Determine argument maximum length
         max_len = 0
         do i = 0, arg_count
            call get_command_argument(i, length=arg_len)
            if (max_len < arg_len) max_len = arg_len
         end do
      end if

      ! Allocate array to store command line arguments
      allocate(arg_string(0:arg_count), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("parse", "command.f90", ierr)
      end if

      if (present(arg_string_in)) then
         do i = 0, arg_count
            arg_string(i) = arg_string_in(i)
         end do
      else
         ! Read command line arguments
         do i = 0, arg_count
            call get_command_argument(i,value=arg_string(i), status=ierr)
            if (ierr /= 0) then
               call MW_errors_runtime_error("parse", "command.f90", &
                     "Failed to retrieve command line arguments")
            end if
         end do
      end if

      ! Parse the command lines
      i = 1
      do while (i <= arg_count)

         arg_len = len_trim(arg_string(i))
         if (arg_string(i)(1:2) == "--") then
            call parse_long_option(this, arg_string(i)(3:arg_len))
         else if (arg_string(i)(1:1) == "-") then
            call parse_short_option(this, arg_string(i)(2:arg_len))
         else
            !  it is either the value of the preceding option or a positional argument
            positional_argument = .true.

            ! Check if last option read needs a value
            if (this%num_options > 0) then
               if ((this%actions(this%num_options) == OPTION_ACTION_STORE) .and. &
                     (.not. this%values_stored(this%num_options))) then
                  this%values(i) = arg_string(i)(1:arg_len)
                  positional_argument = .false.
               end if
            end if

            if (positional_argument) then
               if (this%num_arguments >= size(this%arguments)) then
                  call MW_errors_runtime_error("parse", "command.f90", &
                        "Too many positional arguments on command line.")
               end if
               this%num_arguments = this%num_arguments + 1
               this%arguments(this%num_arguments) = arg_string(i)
            end if
         end if

         i = i + 1
      end do

   end subroutine parse

   !================================================================================
   ! Parse a long option on the command line
   !
   ! Long option format is
   ! --long-option [VALUE]
   ! --long-option[=VALUE]
   !
   subroutine parse_long_option(this, opt_string)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none

      type(MW_command_t), intent(inout) :: this
      character(*),              intent(in)    :: opt_string

      character(LONG_OPTION_LEN) :: opt_name
      character(OPTION_VALUE_LEN) :: opt_value

      integer :: i
      integer :: iequal
      logical :: found_it

      ! Check if '=' is in the string
      iequal = index(opt_string, "=")
      if (iequal > 0) then
         opt_name = opt_string(:iequal-1)
         opt_value = opt_string(iequal+1:)
      else
         opt_name = opt_string
         opt_value = ""
      end if

      ! Look for option string
      found_it = .false.
      do i = 1, this%num_options
         if (opt_name == this%longn(i)) then
            found_it = .true.
            this%counts(i) = this%counts(i) + 1
            if (this%actions(i) == OPTION_ACTION_STORE) then
               if (iequal > 0) then
                  this%values(i) = opt_value
                  this%values_stored(i) = .true.
               else
                  this%values_stored(i) = .false.
               end if
            end if
            exit
         end if
      end do

      if (.not. found_it) then
         call MW_errors_parameter_error("parse_long_option", "command.f90", &
               "opt_string", opt_string)
      end if

   end subroutine parse_long_option

   !================================================================================
   ! Parse a long option on the command line
   !
   ! short option format is
   ! -a[b..][cVALUE]
   subroutine parse_short_option(this, opt_string)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type(MW_command_t), intent(inout) :: this
      character(*),              intent(in)    :: opt_string

      character(1)                :: opt_name

      integer :: i, ichar
      logical :: found_it

      ichar = 1
      do while (ichar <= len(opt_string))
         opt_name = opt_string(ichar:ichar)

         ! Look for option string
         found_it = .false.
         do i = 1, this%num_options
            if (opt_name == this%shortn(i)) then
               found_it = .true.
               this%counts(i) = this%counts(i) + 1
               if (this%actions(i) == OPTION_ACTION_STORE) then
                  if (ichar < len(opt_string)) then
                     this%values(i) = opt_string(ichar+1:)
                     this%values_stored(i) = .true.
                     ichar = len(opt_string) + 1
                  else
                     this%values_stored(i) = .false.
                  end if
               end if
               exit
            end if
         end do

         if (.not. found_it) then
            call MW_errors_parameter_error("parse_short_option", "command.f90", &
                  "opt_string", opt_string)
         end if

         ichar = ichar + 1
      end do
   end subroutine parse_short_option

   !================================================================================
   ! Check wether an option was present on the command line or not
   subroutine get_option_log(this, name, value_log)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type (MW_command_t), intent(in)  :: this
      character(*),               intent(in)  :: name
      logical,                    intent(out) :: value_log

      integer :: i
      logical :: found_it

      value_log = .false.

      ! look for option name
      found_it = .false.
      if (len(name) == 1) then
         ! look for option string in short
         do i = 1, this%num_options
            if (name == this%shortn(i)) then
               found_it = .true.
               if (this%counts(i) > 0) value_log = .true.
               exit
            end if
         end do
      else
         ! look for option string in long
         do i = 1, this%num_options
            if (name == this%longn(i)) then
               found_it = .true.
               if (this%counts(i) > 0) value_log = .true.
               exit
            end if
         end do
      end if

      if (.not. found_it) then
         call MW_errors_parameter_error("get_option_log", "command.f90", &
               "name", name)
      end if

   end subroutine get_option_log

   !================================================================================
   ! Return the value stored by an option as an int
   subroutine get_option_int(this, name, value_int)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type (MW_command_t), intent(in)  :: this
      character(*),               intent(in)  :: name
      integer,                    intent(out) :: value_int

      integer :: i
      logical :: found_it

      value_int = 0

      ! look for option name
      found_it = .false.
      if (len(name) == 1) then
         ! look for option string in short
         do i = 1, this%num_options
            if (name == this%shortn(i)) then
               found_it = .true.
               if (this%actions(i) == OPTION_ACTION_STORE) then
                  read(this%values(i),'(i64)') value_int
               else if (this%actions(i) == OPTION_ACTION_COUNT) then
                  value_int = this%counts(i)
               end if
               exit
            end if
         end do
      else
         ! look for option string in long
         do i = 1, this%num_options
            if (name == this%longn(i)) then
               found_it = .true.
               if (this%actions(i) == OPTION_ACTION_STORE) then
                  read(this%values(i),*) value_int
               else if (this%actions(i) == OPTION_ACTION_COUNT) then
                  value_int = this%counts(i)
               end if
               exit
            end if
         end do
      end if

      if (.not. found_it) then
         call MW_errors_parameter_error("get_option_int", "command.f90", &
               "name", name)
      end if

   end subroutine get_option_int

   !================================================================================
   ! Return the value stored by an option as a character string
   subroutine get_option_char(this, name, value_char)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type (MW_command_t), intent(in)  :: this
      character(*),               intent(in)  :: name
      character(*),               intent(out) :: value_char

      integer :: i
      logical :: found_it

      value_char = ""

      ! look for option name
      found_it = .false.
      if (len(name) == 1) then
         ! look for option string in short
         do i = 1, this%num_options
            if (name == this%shortn(i)) then
               found_it = .true.
               value_char = this%values(i)
               exit
            end if
         end do
      else
         ! look for option string in long
         do i = 1, this%num_options
            if (name == this%longn(i)) then
               found_it = .true.
               value_char = this%values(i)
               exit
            end if
         end do
      end if

      if (.not. found_it) then
         call MW_errors_parameter_error("get_option_char", "command.f90", &
               "name", name)
      end if

   end subroutine get_option_char


   !================================================================================
   ! Return the value stored by an option as a real number
   subroutine get_option_real(this, name, value_real)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type (MW_command_t), intent(in)  :: this
      character(*),               intent(in)  :: name
      real,                       intent(out) :: value_real

      integer :: i
      logical :: found_it

      value_real = 0.0

      ! look for option name
      found_it = .false.
      if (len(name) == 1) then
         ! look for option string in short
         do i = 1, this%num_options
            if (name == this%shortn(i)) then
               found_it = .true.
               read(this%values(i),*) value_real
               exit
            end if
         end do
      else
         ! look for option string in long
         do i = 1, this%num_options
            if (name == this%longn(i)) then
               found_it = .true.
               read(this%values(i),*) value_real
               exit
            end if
         end do
      end if

      if (.not. found_it) then
         call MW_errors_parameter_error("get_option_real", "command.f90", &
               "name", name)
      end if

   end subroutine get_option_real

   !================================================================================
   ! Return the value stored by an option as a double precision number
   subroutine get_option_double(this, name, value_double)
      use MW_errors, only: MW_errors_parameter_error => parameter_error
      implicit none
      type (MW_command_t), intent(in)  :: this
      character(*),               intent(in)  :: name
      double precision,           intent(out) :: value_double

      integer :: i
      logical :: found_it

      value_double = 0.0

      ! look for option name
      found_it = .false.
      if (len(name) == 1) then
         ! look for option string in short
         do i = 1, this%num_options
            if (name == this%shortn(i)) then
               found_it = .true.
               read(this%values(i),*) value_double
               exit
            end if
         end do
      else
         ! look for option string in long
         do i = 1, this%num_options
            if (name == this%longn(i)) then
               found_it = .true.
               read(this%values(i),*) value_double
               exit
            end if
         end do
      end if

      if (.not. found_it) then
         call MW_errors_parameter_error("get_option_double", "command.f90", &
               "name", name)
      end if

   end subroutine get_option_double

end module MW_command

!! Module to handle constraints in linear molecules
!!
!! Reference
module MW_linear_molecule
   use MW_kinds, only: wp
   use MW_box, only: MW_box_t
   use MW_ion, only: MW_ion_t
   use MW_molecule, only: MW_molecule_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: constrain_positions
   public :: constrain_velocities

contains

   ! ===========================================================================
   ! Linear_Molecule algorithm part 1 - Update positions
   subroutine constrain_positions(num_pbc, molecule, dt, box, ions, &
         xyz_now, forces_now, xyz_next, velocity_next)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in) :: num_pbc
      type(MW_molecule_t), intent(in) :: molecule
      real(wp), intent(in) :: dt ! time step
      type(MW_box_t), intent(in) :: box ! simulation box
      type(MW_ion_t), intent(in)      :: ions(:)

      real(wp), intent(in) :: xyz_now(:,:)       ! coordinates at t
      real(wp), intent(in) :: forces_now(:,:)       ! coordinates at t

      ! Passed in/out
      ! -------------
      real(wp), intent(inout) :: xyz_next(:,:) !< coodinates at t+dt
      real(wp), intent(inout) :: velocity_next(:,:) !< velocities at t+dt

      select case(num_pbc)
      case(2)
         call constrain_positions_2DPBC(molecule, dt, box, ions, &
         xyz_now, forces_now, xyz_next, velocity_next)
      case(3)
         call constrain_positions_3DPBC(molecule, dt, box, ions, &
         xyz_now, forces_now, xyz_next, velocity_next)
      end select

   end subroutine constrain_positions

   ! ===========================================================================
   ! Linear_Molecule algorithm part 2 - Update velocities
   subroutine constrain_velocities(num_pbc, molecule, dt, box, ions, &
         xyz_next, forces_next, velocity_next)
      implicit none
      ! Passed in
      ! ---------
      integer, intent(in) :: num_pbc
      type(MW_molecule_t), intent(in) :: molecule
      real(wp), intent(in) :: dt !< time step
      type(MW_box_t), intent(in) :: box
      type(MW_ion_t), intent(in) :: ions(:)
      real(wp), intent(in) :: xyz_next(:,:) ! coordinates at t + dt
      real(wp), intent(in) :: forces_next(:,:) ! forces at t + dt

      ! Passed out
      ! ----------
      real(wp), intent(inout) :: velocity_next(:,:)   ! coordinates at t+dt


      select case(num_pbc)
      case(2)
         call constrain_velocities_2DPBC(molecule, dt, box, ions, &
         xyz_next, forces_next, velocity_next)
      case(3)
         call constrain_velocities_3DPBC(molecule, dt, box, ions, &
         xyz_next, forces_next, velocity_next)
      end select

   end subroutine constrain_velocities

   ! ================================================================================
   include 'linear_molecule_2DPBC.inc'
   include 'linear_molecule_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'

end module MW_linear_molecule

module MW_dipoles_and_electrodes
   use MW_stdio
   use MW_kinds, only: wp
   use MW_algorithms, only: MW_algorithms_t
   use MW_cg, only: MW_cg_t
   use MW_system, only: MW_system_t
   use MW_ion, only: MW_ion_t
   use MW_electrode, only: MW_electrode_t
   use MW_external_field, only: MW_external_field_t, &
      FIELD_TYPE_ELECTRIC, FIELD_TYPE_DISPLACEMENT

   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: compute_jacobi_precond
   public :: compute

contains

   !================================================================================
   ! Evaluate b, the potential on electrode atoms due to melt ions
   subroutine setup_b(system, algorithms)
      use MW_coulomb, only: &
         MW_coulomb_qmelt2Qelec_potential => qmelt2Qelec_potential ,&
         MW_coulomb_Qelec2mumelt_electricfield => Qelec2mumelt_electricfield ,&
         MW_coulomb_qmelt2mumelt_electricfield => qmelt2mumelt_electricfield ,&
         MW_coulomb_fix_molecule_qmelt2mumelt_electricfield => fix_molecule_qmelt2mumelt_electricfield
      use MW_external_field, only: &
         MW_external_field_field2mumelt_electricfieldb => field2mumelt_electricfieldb, &
         MW_external_field_Efield_elec_potential => Efield_elec_potential, &
         MW_external_field_Dfield_elec_potentialb => Dfield_elec_potentialb
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms

      ! Locals
      ! ------
      integer :: num_ions, num_atoms
      integer :: xyz_now, dipoles_now, q_atoms_now
      integer :: i, itype, ix, iy, iz, ei
      real(wp) :: alpha
      real(wp), dimension(system%num_ions,3) :: efield, efield2, efield3, efield4
      real(wp) :: Vi
      real(wp), dimension(system%num_atoms,4) :: pot_atoms
      real(wp), dimension(system%num_atoms) :: pot_field

      num_ions = system%num_ions
      num_atoms = system%num_atoms
      xyz_now = system%xyz_ions_step(1)
      dipoles_now = system%dipoles_ions_step(1)
      q_atoms_now = system%q_atoms_step(1)

      efield=0.0_wp
      call MW_coulomb_qmelt2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
              system%ions, system%xyz_ions(:,:,xyz_now), system%type_ions(:), efield, system%tt)

      efield2=0.0_wp
      if(system%num_molecule_types > 0) then
         call MW_coulomb_fix_molecule_qmelt2mumelt_electricfield(system%num_PBC, system%localwork, &
            system%molecules, system%box, system%ions, system%xyz_ions(:,:,xyz_now), efield2, system%tt)
      endif

      efield3=0.0_wp
      if (system%electrode_constant_charge) then
         call MW_coulomb_Qelec2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
            system%ions, system%xyz_ions(:,:,xyz_now), system%electrodes, system%xyz_atoms, &
            system%q_atoms(:,q_atoms_now), system%type_electrode_atoms(:), efield3)
      endif

      efield4=0.0_wp
      if (system%field%field_type > 0) then
         call MW_external_field_field2mumelt_electricfieldb(system%field, system%ions,&
            system%polarization_field, efield4)
      endif

      efield=efield+efield2+efield3+efield4
      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            if(algorithms%maze%calc_dip) then
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%maze%const_constr(ix) = -efield(i,1)
                  algorithms%maze%const_constr(iy) = -efield(i,2)
                  algorithms%maze%const_constr(iz) = -efield(i,3)
               end do
            else if (algorithms%matrix_inversion%calc_dip) then
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%matrix_inversion%b(ix) = efield(i,1)
                  algorithms%matrix_inversion%b(iy) = efield(i,2)
                  algorithms%matrix_inversion%b(iz) = efield(i,3)
               end do
            else
               do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
                  ix = i
                  iy = i + num_ions
                  iz = i + num_ions*2
                  algorithms%cg%b(ix) = efield(i,1)
                  algorithms%cg%b(iy) = efield(i,2)
                  algorithms%cg%b(iz) = efield(i,3)
               end do
            end if
         end if
      end do

      if (.not.system%electrode_constant_charge) then
         pot_atoms(:,:)=0.0_wp
         call MW_coulomb_qmelt2Qelec_potential(system%num_PBC, system%localwork, &
                 system%ewald, system%box, system%ions, system%xyz_ions(:,:,xyz_now), system%type_ions, &
            system%electrodes, system%xyz_atoms, pot_atoms)

         pot_field=0.0_wp
         if (system%field%field_type == FIELD_TYPE_ELECTRIC) then
            call MW_external_field_Efield_elec_potential(system%field, &
               system%electrodes, system%xyz_atoms, pot_field)
         else if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
            call MW_external_field_Dfield_elec_potentialb(system%field, &
               system%electrodes, system%xyz_atoms, system%polarization_field, pot_field)
         endif

         do ei = 1, system%num_elec                ! loop over each electrode wall
            Vi = system%electrodes(ei)%V           ! potential applied on the electrode
            if (algorithms%maze%calc_elec) then
               do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
                  algorithms%maze%const_constr(3*num_ions + i) = (-Vi + &
                     (pot_atoms(i,1) + pot_atoms(i,2) + pot_atoms(i,3) + pot_field(i)))
               end do
            else if (algorithms%matrix_inversion%calc_elec) then
               do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
                  algorithms%matrix_inversion%b(3*num_ions + i) = Vi - &
                     (pot_atoms(i,1) + pot_atoms(i,2) + pot_atoms(i,3) + pot_field(i))
               end do
            else
               do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
                  algorithms%cg%b(3*num_ions + i) = Vi - &
                     (pot_atoms(i,1) + pot_atoms(i,2) + pot_atoms(i,3) + pot_field(i))
               end do
            end if
            if (system%electrode_charge_neutrality.and.algorithms%maze%calc_elec) then
               if (abs(system%total_ions_charge) > 1.0e-12_wp .and. system%global_charge_neutrality) then
                  algorithms%maze%const_constr(3*num_ions + num_atoms + 1) = -system%total_ions_charge
               else
                  algorithms%maze%const_constr(3*num_ions + num_atoms + 1) = 0.0_wp
               end if
            end if
         end do

      end if
   end subroutine setup_b

   !================================================================================
   ! Compute A*x, the potential on electrode atoms due to electrode atoms
   !
   subroutine apply_A(system, x, y)
      use MW_coulomb, only: &
         MW_coulomb_mumelt2Qelec_potential => mumelt2Qelec_potential, &
         MW_coulomb_Qelec2Qelec_potential => Qelec2Qelec_potential, &
         MW_coulomb_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
         MW_coulomb_Qelec2mumelt_electricfield => Qelec2mumelt_electricfield, &
         MW_coulomb_fix_molecule_mumelt2mumelt_electricfield => fix_molecule_mumelt2mumelt_electricfield
      use MW_external_field, only: &
         MW_external_field_field2mumelt_electricfieldA => field2mumelt_electricfieldA, &
         MW_external_field_Dfield_elec_potentialA => Dfield_elec_potentialA
      use MW_thomas_fermi, only: &
         MW_thomas_fermi_kinetic_elec_potential => kinetic_elec_potential
      implicit none
      ! Parameters
      ! ----------
      type(MW_system_t), intent(inout) :: system
      real(wp), intent(in) :: x(:)
      real(wp), intent(out) :: y(:)

      ! Locals
      ! ------
      integer :: num_ions, num_atoms
      integer :: i, itype, ix, iy, iz
      integer :: xyz_now, q_atoms_now
      real(wp) :: alpha
      real(wp), dimension(system%num_ions,3) :: efield, efield2, efield3, efield4
      real(wp), dimension(system%num_ions,3) :: dipoles
      real(wp), dimension(system%num_atoms,4) :: pot_atoms, pot_atoms2
      real(wp), dimension(system%num_atoms) :: q_atoms, pot_field, pot_quantum

      num_ions = system%num_ions
      num_atoms = system%num_atoms
      q_atoms_now = system%q_atoms_step(1)
      xyz_now = system%xyz_ions_step(1)

      do i=1,num_ions
         ix = i
         iy = i + num_ions
         iz = i + num_ions*2
         dipoles(i,1) = x(ix)
         dipoles(i,2) = x(iy)
         dipoles(i,3) = x(iz)
      end do
      if (.not.system%electrode_constant_charge) then
         do i=1,num_atoms
            q_atoms(i) = x(3*num_ions+i)
         end do
      end if

      efield=0.0_wp
      call MW_coulomb_mumelt2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%ions, system%xyz_ions(:,:,xyz_now), efield, dipoles)

      efield2=0.0_wp
      if(system%num_molecule_types > 0) then
         call MW_coulomb_fix_molecule_mumelt2mumelt_electricfield(system%num_PBC, system%localwork, &
            system%molecules, system%box, system%ions, system%xyz_ions(:,:,xyz_now), efield2, dipoles)
      end if

      efield3=0.0_wp
      if (.not.system%electrode_constant_charge) then
         call MW_coulomb_Qelec2mumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
            system%ions, system%xyz_ions(:,:,xyz_now), system%electrodes, system%xyz_atoms, &
            q_atoms, system%type_electrode_atoms(:), efield3)
      end if

      efield4=0.0_wp
      if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
         call MW_external_field_field2mumelt_electricfieldA(system%box, system%field, system%electrodes, &
            system%xyz_atoms, q_atoms, system%ions, dipoles, system%polarization_field, efield4)
      end if

      efield=efield+efield2+efield3+efield4
      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
               ix = i
               iy = i + num_ions
               iz = i + num_ions*2
               y(ix) = -efield(i,1) + dipoles(i,1)/alpha
               y(iy) = -efield(i,2) + dipoles(i,2)/alpha
               y(iz) = -efield(i,3) + dipoles(i,3)/alpha
            end do
         end if
      end do

      if (.not.system%electrode_constant_charge) then
         pot_atoms=0.0_wp
         call MW_coulomb_mumelt2Qelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
               system%ions, system%xyz_ions(:,:,xyz_now), system%electrodes, system%xyz_atoms, dipoles, &
               system%type_electrode_atoms, pot_atoms)

         pot_atoms2=0.0_wp
         call MW_coulomb_Qelec2Qelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
               system%electrodes, system%xyz_atoms, q_atoms, pot_atoms2)

         pot_field=0.0_wp
         ! Compute the contribution due to the external electric displacement
         if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
            call MW_external_field_Dfield_elec_potentialA(system%box, system%field, &
                  system%electrodes, system%xyz_atoms, q_atoms, system%polarization_field, pot_field)
         endif

         ! TO DO: What about Thomas-Fermi?
         !   Compute the quantum corrections to A * x in the Thomas-Fermi framework
         pot_quantum=0.0_wp
         call MW_thomas_fermi_kinetic_elec_potential(system%thomas_fermi, &
            system%electrodes, q_atoms, pot_quantum)

         pot_atoms=pot_atoms+pot_atoms2
         do i = 1, num_atoms
            y(3*num_ions+i) = (pot_atoms(i,1) + pot_atoms(i,2) &
               +pot_atoms(i,3) + pot_atoms(i,4) + pot_field(i) + pot_quantum(i))
         end do
      end if   
   end subroutine apply_A

   subroutine compute_hessian(system, hessian)
      use MW_coulomb, only: &
         MW_coulomb_gradmumelt_electricfield => gradmumelt_electricfield, &
         MW_coulomb_fix_molecule_gradmumelt_electricfield => fix_molecule_gradmumelt_electricfield, &
         MW_coulomb_gradQelec_electricfield => gradQelec_electricfield, &
         MW_coulomb_gradQelec_potential => gradQelec_potential
      use MW_errors, only: &
         MW_errors_allocate_error => allocate_error
      use MW_external_field, only: &
         MW_external_field_Dfield_gradQelec_potential => Dfield_gradQelec_potential
      use MW_thomas_fermi, only: &
         MW_thomas_fermi_kinetic_gradQelec_potential => kinetic_gradQelec_potential
      implicit none

      ! Parameters Input/Output
      ! -----------------------
      type(MW_system_t),  intent(inout) :: system
      real(wp), intent(out) :: hessian(:,:)

      !Locals
      !------
      integer  :: num_ions, num_atoms
      integer  :: xyz_now, q_atoms_now
      integer  :: i, itype, j, ix, iy, iz, jx, jy, jz
      real(wp), allocatable :: dip_fix_mol_hessian(:,:)
      integer :: ierr

      allocate(dip_fix_mol_hessian(3*system%num_ions,3*system%num_ions), stat=ierr)
      if (ierr /= 0) then
         call MW_errors_allocate_error("compute_hessian", "matrix_inversion.F90", ierr)
      end if

      num_ions = system%num_ions
      num_atoms = system%num_atoms
      xyz_now = system%xyz_ions_step(1)
      q_atoms_now = system%q_atoms_step(1)

      call MW_coulomb_gradmumelt_electricfield(system%num_PBC, system%localwork, system%ewald, &
      system%box, system%ions, system%xyz_ions(:,:,xyz_now), hessian(1:3*num_ions,1:3*num_ions))
      dip_fix_mol_hessian(:,:) = 0.0_wp
      if(system%num_molecule_types > 0) then
         call MW_coulomb_fix_molecule_gradmumelt_electricfield(system%num_PBC, system%localwork, &
         system%molecules, system%box, &
         system%ions, system%xyz_ions(:,:,xyz_now), dip_fix_mol_hessian(:,:))
      endif
      hessian(1:3*num_ions,1:3*num_ions) = hessian(1:3*num_ions,1:3*num_ions) + dip_fix_mol_hessian(:,:)
      ! Computing polarization energy term in gradient of constraints for dipoles
      ! Not included in MW_coulomb_melt_gradmu_electricfield
      do itype = 1, size(system%ions,1)
         do i = system%ions(itype)%offset+1, system%ions(itype)%offset+system%ions(itype)%count
            ix = i
            iy = i + num_ions
            iz = i + num_ions*2
            hessian(ix,ix) = hessian(ix,ix) + 1.0_wp/system%ions(itype)%polarizability
            hessian(iy,iy) = hessian(iy,iy) + 1.0_wp/system%ions(itype)%polarizability
            hessian(iz,iz) = hessian(iz,iz) + 1.0_wp/system%ions(itype)%polarizability
         end do
      end do

      do i = 1, num_ions
         ix = i
         iy = i + num_ions
         iz = i + num_ions*2
         do j = 1, i
            jx = j
            jy = j + num_ions
            jz = j + num_ions*2
            !xx
            hessian(ix,jx) = hessian(jx,ix)
            !xy
            hessian(iy,jx) = hessian(jy,ix)
            hessian(jx,iy) = hessian(jy,ix)
            hessian(ix,jy) = hessian(jx,iy)
            !xz
            hessian(iz,jx) = hessian(jz,ix)
            hessian(jx,iz) = hessian(jz,ix)
            hessian(ix,jz) = hessian(jx,iz)
            !yy
            hessian(iy,jy) = hessian(jy,iy)
            !yz
            hessian(iz,jy) = hessian(jz,iy)
            hessian(jy,iz) = hessian(jz,iy)
            hessian(iy,jz) = hessian(jy,iz)
            !zz
            hessian(iz,jz) = hessian(jz,iz)
         end do
      end do

      call MW_coulomb_gradQelec_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%ions, system%xyz_ions(:,:,xyz_now), system%electrodes, system%xyz_atoms, &
         hessian(1:3*num_ions,3*num_ions+1:3*num_ions+num_atoms))

      do i = 1, num_atoms
         do j = 1, num_ions

            jx = j
            jy = j + num_ions
            jz = j + num_ions*2

            hessian(3*num_ions+i,jx) = hessian(jx,3*num_ions+i)
            hessian(3*num_ions+i,jy) = hessian(jy,3*num_ions+i)
            hessian(3*num_ions+i,jz) = hessian(jz,3*num_ions+i)

         end do
      end do

      call MW_coulomb_gradQelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%electrodes, system%xyz_atoms, hessian(3*num_ions+1:3*num_ions+num_atoms,3*num_ions+1:3*num_ions+num_atoms))

     ! Compute the contribution due to the external electric displacement
     if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
         call MW_external_field_Dfield_gradQelec_potential(system%box, system%field, &
             system%electrodes, system%xyz_atoms, system%q_atoms(:, system%q_atoms_step(1)), system%polarization_field, &
             hessian(3*num_ions+1:3*num_ions+num_atoms,3*num_ions+1:3*num_ions+num_atoms))
     endif

     call MW_thomas_fermi_kinetic_gradQelec_potential(system%thomas_fermi, &
          system%electrodes, hessian(3*num_ions+1:3*num_ions+num_atoms,3*num_ions+1:3*num_ions+num_atoms))

     do i = 1, num_atoms
         do j = 1, i-1
            hessian(3*num_ions+i,3*num_ions+j) = hessian(3*num_ions+j,3*num_ions+i)
         end do
     end do

   end subroutine compute_hessian

   ! Parallelized routine for computing matrix vector products invloving dipoles and electrodes together
   ! The matrix has to be Symmetric
   ! To be implemented
   subroutine SMatrix_vector_product_dipelec(system, matrix, vector, matvec_product)
      implicit none

      ! Parameters Input
      ! ----------------
      type(MW_system_t), intent(in) :: system  !< system parameters
      real(wp),          intent(in) :: vector(:)
      real(wp),          intent(in) :: matrix(:,:)

      ! Parameters Output
      ! -----------------
      real(wp),          intent(out) :: matvec_product(:)

   end subroutine SMatrix_vector_product_dipelec

   subroutine compute_jacobi_precond(system, algorithms)
      use MW_coulomb, only: &
      MW_coulomb_diag_gradmumelt_electricfield => diag_gradmumelt_electricfield, &
      MW_coulomb_diag_gradQelec_potential => diag_gradQelec_potential
      implicit none

      type(MW_system_t), intent(inout) :: system
      type(MW_algorithms_t), intent(inout) :: algorithms

      integer :: i, itype, ix, iy, iz
      integer :: n_ions, n_atoms
      real(wp) :: alpha

      n_ions = system%num_ions
      n_atoms = system%num_atoms

      call MW_coulomb_diag_gradmumelt_electricfield(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%ions, algorithms%cg%jacobi_precond(1:3*n_ions))
      do itype = 1,size(system%ions,1)
         alpha = system%ions(itype)%polarizability
         if (alpha .ne. 0.0_wp) then
            do i=system%ions(itype)%offset+1,system%ions(itype)%offset+system%ions(itype)%count
               ix = i
               iy = i + n_ions
               iz = i + n_ions*2
               algorithms%cg%jacobi_precond(ix) = algorithms%cg%jacobi_precond(ix) + 1.0_wp/system%ions(itype)%polarizability
               algorithms%cg%jacobi_precond(iy) = algorithms%cg%jacobi_precond(iy) + 1.0_wp/system%ions(itype)%polarizability
               algorithms%cg%jacobi_precond(iz) = algorithms%cg%jacobi_precond(iz) + 1.0_wp/system%ions(itype)%polarizability
            end do
         end if
      end do

      if (.not.system%electrode_constant_charge) then
         call MW_coulomb_diag_gradQelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
            system%electrodes, algorithms%cg%jacobi_precond(3*n_ions+1:3*n_ions+n_atoms))
      end if

   end subroutine compute_jacobi_precond

   !================================================================================
   !> Compute charges on electrode
   !!
   !! The charge is evaluated by minimizing the Coulomb energy of the system
   !!
   !! The energy can be cast into E = Q*AQ - Q*b + c
   !!
   !! where Q  is the vector of charges on the electrodes
   !!       b  is the potential felt by the electrode due to the melt ions
   !!       AQ is the potential felt by the electrode du to other electrode atoms
   !!       c  is the energy due to melt ions interactions
   !!       *  denotes the transpose of a vector/matrix
   !!
   !! By construction A is a matrix symmetric positive definite
   !! The preconditioned conjugate gradient algorithm is used to find a solution to
   !! the system
   !!
   subroutine compute(system, algorithms)
      use MW_ions_dipoles, only: &
         MW_ions_dipoles_predictor => predictor
      use MW_electrode_charge, only: &
         MW_electrode_charge_predictor => predictor
      use MW_cg, only: &
         MW_cg_solve_preconditioned => solve_preconditioned, &
         MW_cg_solve => solve
      use MW_maze, only: &
         MW_maze_compute_x0 => compute_x0, &
         MW_maze_update_history => update_history, &
         MW_maze_solve_invert => solve_invert, &
         MW_maze_solve_block_iterate => solve_block_iterate, &
         MW_maze_solve_CG_store => solve_CG_store, &
         MW_maze_solve_CG_nostore => solve_CG_nostore, &
         MW_maze_solve_shake => solve_shake
      use MW_matrix_inversion, only: &
         MW_matrix_inversion_solve => solve
      use MW_external_field, only: &
         MW_external_field_elec_polarization => elec_polarization, &
         MW_external_field_dipole_polarization => dipole_polarization
      implicit none

      ! Parameters in
      ! -------------
      type(MW_system_t), intent(inout) :: system !< system parameters
      type(MW_algorithms_t), intent(inout) :: algorithms !< cg algorithm parameters

      ! Local
      ! -----
      integer :: i, itype
      integer :: num_ions, num_atoms
      integer :: q_atoms_tmdt, q_atoms_t, q_atoms_tpdt
      integer :: dipoles_ions_tpdt, dipoles_ions_t, dipoles_ions_tmdt
      real(wp) :: total_charges, average_charges, alpha
      real(wp), dimension(3*system%num_ions+system%num_atoms) :: x
      real(wp), dimension(3*system%num_ions+system%num_atoms) :: xt, xtmdt

      num_ions = system%num_ions
      num_atoms = system%num_atoms

      dipoles_ions_tpdt = system%dipoles_ions_step(1)
      dipoles_ions_t = system%dipoles_ions_step(2)
      dipoles_ions_tmdt = system%dipoles_ions_step(3)

      q_atoms_tpdt = system%q_atoms_step(1)
      q_atoms_t = system%q_atoms_step(2)
      q_atoms_tmdt = system%q_atoms_step(3)

      if (algorithms%constant_charge) then

         ! Dipoles and charges are set equal to previous step (no predictor available for dipoles yet).
         if (system%dipoles_use_predictor) then
            call MW_ions_dipoles_predictor(system%dipoles_ions_step, system%ions, system%dipoles_ions)
            do itype = 1, system%num_elec
               do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                  system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
               end do
            end do
         else
            do itype = 1, system%num_ion_types
               alpha = system%ions(itype)%polarizability
               if (alpha .ne. 0.0_wp) then
                  do i = system%ions(itype)%offset+1, system%ions(itype)%offset + system%ions(itype)%count
                    system%dipoles_ions(i, 1, dipoles_ions_tpdt) = system%dipoles_ions(i, 1, dipoles_ions_t)
                    system%dipoles_ions(i, 2, dipoles_ions_tpdt) = system%dipoles_ions(i, 2, dipoles_ions_t)
                    system%dipoles_ions(i, 3, dipoles_ions_tpdt) = system%dipoles_ions(i, 3, dipoles_ions_t)
                  end do
               end if
            end do
            do itype = 1, system%num_elec
               do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                  system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
               end do
            end do
         end if

         x(           1:1*num_ions)=system%dipoles_ions(:,1,dipoles_ions_tpdt)
         x(  num_ions+1:2*num_ions)=system%dipoles_ions(:,2,dipoles_ions_tpdt)
         x(2*num_ions+1:3*num_ions)=system%dipoles_ions(:,3,dipoles_ions_tpdt)

         x(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(:,q_atoms_tpdt)

         ! The conjugate gradient algorithm is executed on dipoles [x(1:3*num_ions)] only.
         call setup_b(system, algorithms)
         call MW_cg_solve_preconditioned(algorithms%cg, system, apply_A, x(1:3*num_ions))

      else

         if (algorithms%maze%calc_dip .and. algorithms%maze%calc_elec) then

            x(           1:1*num_ions)=system%dipoles_ions(:,1,dipoles_ions_tpdt)
            x(  num_ions+1:2*num_ions)=system%dipoles_ions(:,2,dipoles_ions_tpdt)
            x(2*num_ions+1:3*num_ions)=system%dipoles_ions(:,3,dipoles_ions_tpdt)
            xt(           1:1*num_ions)=system%dipoles_ions(:,1,dipoles_ions_t)
            xt(  num_ions+1:2*num_ions)=system%dipoles_ions(:,2,dipoles_ions_t)
            xt(2*num_ions+1:3*num_ions)=system%dipoles_ions(:,3,dipoles_ions_t)
            xtmdt(           1:1*num_ions)=system%dipoles_ions(:,1,dipoles_ions_tmdt)
            xtmdt(  num_ions+1:2*num_ions)=system%dipoles_ions(:,2,dipoles_ions_tmdt)
            xtmdt(2*num_ions+1:3*num_ions)=system%dipoles_ions(:,3,dipoles_ions_tmdt)

            x(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(:,q_atoms_tpdt)
            xt(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(:,q_atoms_t)
            xtmdt(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(:,q_atoms_tmdt)

!            call setup_b(system, algorithms)
!            if ((.not.algorithms%maze%constant_constr_grad).or.(.not.algorithms%maze%CG_nostore)) then
!               call MW_maze_update_history(algorithms%maze) !Only updates gradient of constraints
!            end if
!            call MW_maze_compute_x0(algorithms%maze, 1.0_wp,&
!                 system%q_atoms(:, q_atoms_tmdt), system%q_atoms(:, q_atoms_t), system%q_atoms(:, q_atoms_tpdt))
!            if (algorithms%maze%invert) then
!               call MW_maze_solve_invert(algorithms%maze, system, &
!                    compute_hessian, SMatrix_vector_product_elec, system%q_atoms(:, q_atoms_tpdt))
!            else if (algorithms%maze%shake) then
!               call MW_maze_solve_shake(algorithms%maze, system, &
!                    compute_hessian, system%q_atoms(:, q_atoms_tpdt))
!            else if (algorithms%maze%block_iterate) then
!               call MW_maze_solve_block_iterate(algorithms%maze, system, &
!                    compute_hessian, system%q_atoms(:, q_atoms_tpdt))
!            else if (algorithms%maze%CG_store_prec.or.algorithms%maze%CG_store_noprec) then
!               call MW_maze_solve_CG_store(algorithms%maze, system, &
!                    compute_hessian, SMatrix_vector_product_elec, &
!                    vector_vector_inner_product_elec, system%q_atoms(:, q_atoms_tpdt))
!            else if (algorithms%maze%CG_nostore) then
!               call MW_maze_solve_CG_nostore(algorithms%maze, system, &
!                    apply_A, vector_vector_inner_product_elec, system%q_atoms(:, q_atoms_tpdt))
!            end if
         else if (algorithms%matrix_inversion%calc_dip .and. algorithms%matrix_inversion%calc_elec) then

            x(           1:1*num_ions)=system%dipoles_ions(1:num_ions,1,dipoles_ions_tpdt)
            x(  num_ions+1:2*num_ions)=system%dipoles_ions(1:num_ions,2,dipoles_ions_tpdt)
            x(2*num_ions+1:3*num_ions)=system%dipoles_ions(1:num_ions,3,dipoles_ions_tpdt)

            x(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(1:num_atoms,q_atoms_tpdt)

            call setup_b(system, algorithms)
            call MW_matrix_inversion_solve(algorithms%matrix_inversion, system, compute_hessian, SMatrix_vector_product_dipelec, x)

            system%dipoles_ions(1:num_ions,1,dipoles_ions_tpdt) = x(           1:1*num_ions)
            system%dipoles_ions(1:num_ions,2,dipoles_ions_tpdt) = x(  num_ions+1:2*num_ions)
            system%dipoles_ions(1:num_ions,3,dipoles_ions_tpdt) = x(2*num_ions+1:3*num_ions)

            system%q_atoms(1:num_atoms, q_atoms_tpdt) = x(3*num_ions+1:3*num_ions+num_atoms)

            ! update the contribution of the electrode to the polarization
            call MW_external_field_elec_polarization(system%box, system%electrodes(:), system%xyz_atoms(:,:), &
               system%q_atoms(:, q_atoms_tpdt), system%polarization_field(:,:))
            call MW_external_field_dipole_polarization(system%box, system%ions, &
               system%dipoles_ions(:,:,dipoles_ions_tpdt), system%polarization_field(:,:))

         else

            if (system%dipoles_use_predictor .and. system%electrode_use_predictor) then
               call MW_ions_dipoles_predictor(system%dipoles_ions_step, system%ions, system%dipoles_ions)
               call MW_electrode_charge_predictor(system%q_atoms_step, system%electrodes, system%q_atoms)
            else if (system%dipoles_use_predictor) then
               call MW_ions_dipoles_predictor(system%dipoles_ions_step, system%ions, system%dipoles_ions)
               do itype = 1, system%num_elec
                  do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                     system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
                  end do
               end do
            else if (system%electrode_use_predictor) then
               do itype = 1, system%num_ion_types
                  alpha = system%ions(itype)%polarizability
                  if (alpha .ne. 0.0_wp) then
                     do i = system%ions(itype)%offset+1, system%ions(itype)%offset + system%ions(itype)%count
                       system%dipoles_ions(i, 1, dipoles_ions_tpdt) = system%dipoles_ions(i, 1, dipoles_ions_t)
                       system%dipoles_ions(i, 2, dipoles_ions_tpdt) = system%dipoles_ions(i, 2, dipoles_ions_t)
                       system%dipoles_ions(i, 3, dipoles_ions_tpdt) = system%dipoles_ions(i, 3, dipoles_ions_t)
                     end do
                  end if
               end do
               call MW_electrode_charge_predictor(system%q_atoms_step, system%electrodes, system%q_atoms)
            else
               do itype = 1, system%num_ion_types
                  alpha = system%ions(itype)%polarizability
                  if (alpha .ne. 0.0_wp) then
                     do i = system%ions(itype)%offset+1, system%ions(itype)%offset + system%ions(itype)%count
                       system%dipoles_ions(i, 1, dipoles_ions_tpdt) = system%dipoles_ions(i, 1, dipoles_ions_t)
                       system%dipoles_ions(i, 2, dipoles_ions_tpdt) = system%dipoles_ions(i, 2, dipoles_ions_t)
                       system%dipoles_ions(i, 3, dipoles_ions_tpdt) = system%dipoles_ions(i, 3, dipoles_ions_t)
                     end do
                  end if
               end do
               do itype = 1, system%num_elec
                  do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                     system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
                  end do
               end do
            end if
            x(           1:1*num_ions)=system%dipoles_ions(1:num_ions,1,dipoles_ions_tpdt)
            x(  num_ions+1:2*num_ions)=system%dipoles_ions(1:num_ions,2,dipoles_ions_tpdt)
            x(2*num_ions+1:3*num_ions)=system%dipoles_ions(1:num_ions,3,dipoles_ions_tpdt)

            x(3*num_ions+1:3*num_ions+num_atoms)=system%q_atoms(1:num_atoms,q_atoms_tpdt)

            ! Enforce charge neutrality constraint on initial vector
            if (system%electrode_charge_neutrality) then
               total_charges = sum(x(3*num_ions+1:3*num_ions+num_atoms))
               average_charges = total_charges / real(num_atoms,wp)
               if (system%global_charge_neutrality) then
                  average_charges = average_charges + system%total_ions_charge / real(system%num_atoms,wp)
               end if
               x(3*num_ions+1:3*num_ions+num_atoms) = x(3*num_ions+1:3*num_ions+num_atoms) - average_charges
            end if

            call setup_b(system, algorithms)
            call MW_cg_solve_preconditioned(algorithms%cg, system, apply_A, x)

            ! compute \chi = V_i - \frac{\partial U_{es}}{\partial q_i}
            ! cg%b stores V_i - \frac{\partial U_{es}}{\partial q_i} for melt->elec interactions
            ! apply_A(system, system%q_atoms(:, q_atoms_now), cg%Ad) computes \frac{\partial U_{es}}{\partial q_i} for elec<->elec interactions
            ! chi(:) is stored in cg%Ad(:)
            if (system%electrode_charge_neutrality) then
               call apply_A(system, x, algorithms%cg%Ad)
               system%chi = sum(algorithms%cg%b(3*num_ions+1:3*num_ions+num_atoms) &
                     - algorithms%cg%Ad(3*num_ions+1:3*num_ions+num_atoms)) / real(num_atoms,wp)
            end if
         end if
      end if

      system%dipoles_ions(1:num_ions,1,dipoles_ions_tpdt) = x(           1:1*num_ions)
      system%dipoles_ions(1:num_ions,2,dipoles_ions_tpdt) = x(  num_ions+1:2*num_ions)
      system%dipoles_ions(1:num_ions,3,dipoles_ions_tpdt) = x(2*num_ions+1:3*num_ions)

      system%q_atoms(1:num_atoms, q_atoms_tpdt) = x(3*num_ions+1:3*num_ions+num_atoms)

      ! update the contribution of the electrode to the polarization
      call MW_external_field_elec_polarization(system%box, system%electrodes(:), system%xyz_atoms(:,:), &
         system%q_atoms(:, q_atoms_tpdt), system%polarization_field(:,:))
      call MW_external_field_dipole_polarization(system%box, system%ions, &
         system%dipoles_ions(:,:,dipoles_ions_tpdt), system%polarization_field(:,:))

   end subroutine compute

end module MW_dipoles_and_electrodes

! Module to compute electrostatic Coulomb potential
module MW_coulomb
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_timers
   use MW_kinds, only: wp
   use MW_localwork, only: MW_localwork_t
   use MW_parallel, only: MW_COMM_WORLD
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_damping, only: MW_damping_t
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_molecule, only: MW_molecule_t
   use MW_coulomb_lr, only: &
        MW_coulomb_lr_diag_gradQelec_potential => diag_gradQelec_potential, &
        MW_coulomb_lr_gradQelec_potential => gradQelec_potential, &
        MW_coulomb_lr_qmelt2Qelec_potential => qmelt2Qelec_potential, &
        MW_coulomb_lr_Qelec2Qelec_potential => Qelec2Qelec_potential, &
        MW_coulomb_lr_melt_efg => melt_efg, &
        MW_coulomb_lr_melt_forces => melt_forces, &
        MW_coulomb_lr_energy => energy
   use MW_coulomb_lr_pim, only: &
        MW_coulomb_lr_pim_gradQelec_electricfield => gradQelec_electricfield, &
        MW_coulomb_lr_pim_diag_gradmumelt_electricfield => diag_gradmumelt_electricfield, &
        MW_coulomb_lr_pim_gradmumelt_electricfield => gradmumelt_electricfield, &
        MW_coulomb_lr_pim_mumelt2Qelec_potential => mumelt2Qelec_potential, &
        MW_coulomb_lr_pim_qmelt2mumelt_electricfield => qmelt2mumelt_electricfield, &
        MW_coulomb_lr_pim_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
        MW_coulomb_lr_pim_Qelec2mumelt_electricfield => Qelec2mumelt_electricfield, &
        MW_coulomb_lr_pim_melt_efg => melt_efg, &
        MW_coulomb_lr_pim_melt_forces => melt_forces, &
        MW_coulomb_lr_pim_energy => energy
   use MW_coulomb_keq0, only: &
        MW_coulomb_keq0_diag_gradQelec_potential => diag_gradQelec_potential, &
        MW_coulomb_keq0_gradQelec_potential => gradQelec_potential, &
        MW_coulomb_keq0_qmelt2Qelec_potential => qmelt2Qelec_potential, &
        MW_coulomb_keq0_Qelec2Qelec_potential => Qelec2Qelec_potential, &
        MW_coulomb_keq0_melt_forces => melt_forces, &
        MW_coulomb_keq0_energy => energy
   use MW_coulomb_keq0_pim, only: &
        MW_coulomb_keq0_pim_gradQelec_electricfield => gradQelec_electricfield, &
        MW_coulomb_keq0_pim_diag_gradmumelt_electricfield => diag_gradmumelt_electricfield, &
        MW_coulomb_keq0_pim_gradmumelt_electricfield => gradmumelt_electricfield, &
        MW_coulomb_keq0_pim_mumelt2Qelec_potential => mumelt2Qelec_potential, &
        MW_coulomb_keq0_pim_qmelt2mumelt_electricfield => qmelt2mumelt_electricfield, &
        MW_coulomb_keq0_pim_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
        MW_coulomb_keq0_pim_Qelec2mumelt_electricfield => Qelec2mumelt_electricfield, &
        MW_coulomb_keq0_pim_melt_forces => melt_forces, &
        MW_coulomb_keq0_pim_energy => energy
   use MW_coulomb_sr, only: &
        MW_coulomb_sr_gradQelec_potential => gradQelec_potential, &
        MW_coulomb_sr_qmelt2Qelec_potential => qmelt2Qelec_potential, &
        MW_coulomb_sr_Qelec2Qelec_potential => Qelec2Qelec_potential, &
        MW_coulomb_sr_melt_efg => melt_efg, &
        MW_coulomb_sr_melt_forces => melt_forces, &
        MW_coulomb_sr_energy => energy
   use MW_coulomb_sr_pim, only: &
        MW_coulomb_sr_pim_gradQelec_electricfield => gradQelec_electricfield, &
        MW_coulomb_sr_pim_gradmumelt_electricfield => gradmumelt_electricfield, &
        MW_coulomb_sr_pim_mumelt2Qelec_potential => mumelt2Qelec_potential, &
        MW_coulomb_sr_pim_qmelt2mumelt_electricfield => qmelt2mumelt_electricfield, &
        MW_coulomb_sr_pim_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
        MW_coulomb_sr_pim_Qelec2mumelt_electricfield => Qelec2mumelt_electricfield, &
        MW_coulomb_sr_pim_melt_efg => melt_efg, &
        MW_coulomb_sr_pim_melt_forces => melt_forces, &
        MW_coulomb_sr_pim_energy => energy
   use MW_coulomb_self, only: &
        MW_coulomb_self_diag_gradQelec_potential => diag_gradQelec_potential, &
        MW_coulomb_self_gradQelec_potential => gradQelec_potential, &
        MW_coulomb_self_Qelec2Qelec_potential => Qelec2Qelec_potential, &
        MW_coulomb_self_melt_efg => melt_efg, &
        MW_coulomb_self_energy => energy, &
        MW_coulomb_self_diag_gradmumelt_electricfield => diag_gradmumelt_electricfield, &
        MW_coulomb_self_gradmumelt_electricfield => gradmumelt_electricfield, &
        MW_coulomb_self_mumelt2mumelt_electricfield => mumelt2mumelt_electricfield, &
        MW_coulomb_self_pim_energy => pim_energy

   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: diag_gradQelec_potential !diag[grad_Q [grad_Q [U_QQ]]]
   public :: gradQelec_potential !grad_Q [grad_Q [U_QQ]]
   public :: gradQelec_electricfield !grad_Q [grad_mu [U_muQ]]
   public :: diag_gradmumelt_electricfield !diag[grad_mu [grad_mu [U_mumu]]]
   public :: gradmumelt_electricfield !grad_mu [grad_mu [U_mumu]]
   public :: fix_molecule_gradmumelt_electricfield
   public :: qmelt2Qelec_potential !grad_Q [U_qQ]
   public :: mumelt2Qelec_potential !grad_Q [U_muQ]
   public :: Qelec2Qelec_potential !grad_Q [U_QQ]
   public :: qmelt2mumelt_electricfield !-grad_mu [U_qmu]
   public :: mumelt2mumelt_electricfield !-grad_mu [U_mumu]
   public :: Qelec2mumelt_electricfield !-grad_mu [U_muQ]
   public :: fix_molecule_qmelt2mumelt_electricfield
   public :: fix_molecule_mumelt2mumelt_electricfield
   public :: melt_forces !if (pimrun) then -grad_r [(U_qq + U_qmu + U_mumu) + (U_QQ) + (U_qQ + U_muQ)] else -grad_r [(U_qq) + (U_QQ) + (U_qQ)]
   public :: fix_molecule_melt_forces
   public :: energy ! if(pimrun) then (U_qq + U_qmu + U_mumu) + (U_QQ) + (U_qQ + U_muQ) else (U_qq) + (U_QQ) + (U_qQ)
   public :: fix_molecule_energy
   public :: melt_efg

contains

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine diag_gradQelec_potential(num_PBC, localwork, ewald, box, &
        electrodes, diag_gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: diag_gradQ_V(:)       !< Charge gradient of Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count

      ! Initiliaze potential to 0
      ! -------------------------
      !$acc data present(diag_gradQ_V(:))
      !$acc kernels
      diag_gradQ_V(:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_LR)
         call MW_coulomb_lr_diag_gradQelec_potential(localwork, ewald, box, &
              electrodes, diag_gradQ_V)
         ! call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_KEQ0)
         call MW_coulomb_keq0_diag_gradQelec_potential(localwork, ewald, box, &
              electrodes, diag_gradQ_V)
         ! call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_KEQ0)

         ! Self interaction correction
         ! ---------------------------
         ! call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
         call MW_coulomb_self_diag_gradQelec_potential(localwork, ewald, &
              electrodes, diag_gradQ_V)
         ! call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SELF)

      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_LR)
         call MW_coulomb_lr_diag_gradQelec_potential(localwork, ewald, box, &
              electrodes, diag_gradQ_V)
         ! call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_LR)

         ! Self interaction correction
         ! ---------------------------
         ! call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
         call MW_coulomb_self_diag_gradQelec_potential(localwork, ewald, &
              electrodes, diag_gradQ_V)
         ! call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
      end select
#ifndef MW_SERIAL
      count = size(diag_gradQ_V,1)
      call MPI_Allreduce(MPI_IN_PLACE, diag_gradQ_V, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine diag_gradQelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine gradQelec_potential(num_PBC, localwork, ewald, box, &
          electrodes, xyz_atoms, gradQ_V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: gradQ_V(:,:)       !< Charge gradient of Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count, num_elecs

      num_elecs = size(xyz_atoms,1)
      ! Initiliaze potential to 0
      ! -------------------------
      !$acc data present(gradQ_V(:,:))
      !$acc kernels
      gradQ_V(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_LR)
         call MW_coulomb_lr_gradQelec_potential(localwork, ewald, box, &
              electrodes, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_KEQ0)
         call MW_coulomb_keq0_gradQelec_potential(localwork, ewald, box, &
              electrodes, xyz_atoms, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SR)
         call MW_coulomb_sr_gradQelec_potential(num_PBC, localwork, ewald, box, &
              electrodes, xyz_atoms, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SR)

         ! Self interaction correction
         ! ---------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
         call MW_coulomb_self_gradQelec_potential(localwork, ewald, &
              electrodes, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SELF)

      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_LR)
         call MW_coulomb_lr_gradQelec_potential(localwork, ewald, box, &
              electrodes, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SR)
         call MW_coulomb_sr_gradQelec_potential(num_PBC, localwork, ewald, box, &
              electrodes, xyz_atoms, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SR)

         ! Self interaction correction
         ! ---------------------------
         call MW_timers_start(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
         call MW_coulomb_self_gradQelec_potential(localwork, ewald, &
              electrodes, gradQ_V)
         call MW_timers_stop(TIMER_COULOMB_GRADQ_ELECELEC_SELF)
      end select
#ifndef MW_SERIAL
      count = size(gradQ_V,1) * size(gradQ_V,2)
      call MPI_Allreduce(MPI_IN_PLACE, gradQ_V(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine gradQelec_potential

   subroutine gradQelec_electricfield(num_PBC, localwork, ewald, box, &
        ions, xyz_ions, electrodes, xyz_atoms, gradQ_efield)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary condition
      type(MW_localwork_t), intent(in)    :: localwork !< Local work assignment
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: gradQ_efield(:,:)   !< Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count

      ! Initiliaze gradient to 0
      ! -------------------------
      !$acc data present(gradQ_efield(:,:))
      !$acc kernels
      gradQ_efield(:,:) = 0.0_wp
      !$acc end kernels

      select case(num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         !call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_pim_gradQelec_electricfield(localwork, ewald, box,&
              electrodes, gradQ_efield)

         !call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Long range contribution from k=0 mode (only with 2D PBC)
         ! -------------------------------------
         !call MW_timers_start(TIMER_COULOMB_MELTELEC_KEQ0)
         call MW_coulomb_keq0_pim_gradQelec_electricfield(localwork, ewald, box,&
              ions, xyz_ions, electrodes, xyz_atoms, gradQ_efield)
         !call MW_timers_stop(TIMER_COULOMB_MELTELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         !call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_pim_gradQelec_electricfield(num_PBC, localwork, ewald, box,&
              ions, xyz_ions, electrodes, xyz_atoms, gradQ_efield)
         !call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)

      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         !call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_pim_gradQelec_electricfield(localwork, ewald, box,&
              electrodes, gradQ_efield)
         !call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Short range contribution
         ! ------------------------
         !call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_pim_gradQelec_electricfield(num_PBC, localwork, ewald, box,&
              ions, xyz_ions, electrodes, xyz_atoms, gradQ_efield)
         !call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)
      end select

#ifndef MW_SERIAL
      count = size(gradQ_efield,1)*size(gradQ_efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, gradQ_efield(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data

   end subroutine gradQelec_electricfield

   !================================================================================
   ! Compute the gradient of the electric field for each ion in the melt with respect
   ! to variations of other dipoles in the melt
   subroutine diag_gradmumelt_electricfield(num_PBC, localwork, ewald, box, ions, &
         diag_gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters

      ! Parameters Output
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: diag_gradmu_efield(:) !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero gradient
      ! ---------------------------------
      !$acc data present(diag_gradmu_efield(:))
      !$acc kernels
      diag_gradmu_efield(:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)
         call MW_coulomb_lr_pim_diag_gradmumelt_electricfield(localwork,ewald,box,ions,&
              diag_gradmu_efield)
         ! call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_KEQ0)
         call MW_coulomb_keq0_pim_diag_gradmumelt_electricfield(localwork,ewald,box,ions,&
              diag_gradmu_efield)
         ! call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_KEQ0)

         ! Self contribution
         ! ------------------------
         ! call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
         call MW_coulomb_self_diag_gradmumelt_electricfield(localwork,ewald,ions,diag_gradmu_efield)
         ! call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)

      case (3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         ! call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)
         call MW_coulomb_lr_pim_diag_gradmumelt_electricfield(localwork,ewald,box,ions,&
              diag_gradmu_efield)
         ! call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)

         ! Self contribution
         ! ------------------------
         ! call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
         call MW_coulomb_self_diag_gradmumelt_electricfield(localwork,ewald,ions,diag_gradmu_efield)
         ! call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
      end select
#ifndef MW_SERIAL
      count = size(diag_gradmu_efield,1)
      call MPI_Allreduce(MPI_IN_PLACE, diag_gradmu_efield, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine diag_gradmumelt_electricfield

   !================================================================================
   ! Compute the gradient of the electric field for each ion in the melt with respect
   ! to variations of other dipoles in the melt
   subroutine gradmumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions

      ! Parameters Output
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: gradmu_efield(:,:) !< matrix containing the
      !< gradient of the field

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero forces on ions
      ! ---------------------------------
      !$acc data present(gradmu_efield(:,:))
      !$acc kernels
      gradmu_efield(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)
         call MW_coulomb_lr_pim_gradmumelt_electricfield(localwork,ewald,box,ions,&
              gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_KEQ0)
         call MW_coulomb_keq0_pim_gradmumelt_electricfield(localwork,ewald,box,ions,xyz_ions,&
              gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SR)
         call MW_coulomb_sr_pim_gradmumelt_electricfield(num_PBC,localwork,ewald,box,ions,xyz_ions,&
              gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SR)

         ! Self contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
         call MW_coulomb_self_gradmumelt_electricfield(localwork,ewald,ions,gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)

      case (3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)
         call MW_coulomb_lr_pim_gradmumelt_electricfield(localwork,ewald,box,ions,&
              gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SR)
         call MW_coulomb_sr_pim_gradmumelt_electricfield(num_PBC,localwork,ewald,box,ions,xyz_ions,&
              gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SR)

         ! Self contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
         call MW_coulomb_self_gradmumelt_electricfield(localwork,ewald,ions,gradmu_efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_GRADMU_ELEC_SELF)
      end select
#ifndef MW_SERIAL
      count = size(gradmu_efield,1) * size(gradmu_efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, gradmu_efield, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine gradmumelt_electricfield

   !================================================================================
   ! Compute of the electric field gradient for certain ions in the melt
   subroutine melt_efg(num_PBC, localwork, ewald, box, ions, xyz_ions, pimrun, dipoles, efg_ions)
      use MW_errors, only: MW_errors_runtime_error => runtime_error
      implicit none

      ! Parameters Input
      ! -------------
      integer,              intent(in)    :: num_PBC        !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork      !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)   !< ions dipoles
      logical,              intent(in)    :: pimrun         !< run with the polarizable ion model

      ! Parameters Output
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: efg_ions(:,:)  !< matrix containing the efg

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero efg on ions
      ! ---------------------------------
      !$acc data present(efg_ions(:,:))
      !$acc kernels
      efg_ions(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! 2D PBC are not working yet
         call MW_errors_runtime_error("melt_efg", "coulomb.F90", &
           "EFG computation is not yet supported for 2D PBC.")
      case (3)
        if (pimrun) then
          ! Long range contribution is computed in reciprocal space
          ! --------------------------------------------------------
          call MW_timers_start(TIMER_COULOMB_EFG_MELT_LR)
          call MW_coulomb_lr_pim_melt_efg(localwork, ewald, box, ions, dipoles, efg_ions)
          call MW_timers_stop(TIMER_COULOMB_EFG_MELT_LR)

          ! Short range contribution
          ! ------------------------
          call MW_timers_start(TIMER_COULOMB_EFG_MELT_SR)
          call MW_coulomb_sr_pim_melt_efg(num_PBC, localwork, ewald, box, ions, xyz_ions, dipoles, efg_ions)
          call MW_timers_stop(TIMER_COULOMB_EFG_MELT_SR)
        else
          ! Long range contribution is computed in reciprocal space
          ! --------------------------------------------------------
          call MW_timers_start(TIMER_COULOMB_EFG_MELT_LR)
          call MW_coulomb_lr_melt_efg(localwork, ewald, box, ions, efg_ions)
          call MW_timers_stop(TIMER_COULOMB_EFG_MELT_LR)

          ! Short range contribution
          ! ------------------------
          call MW_timers_start(TIMER_COULOMB_EFG_MELT_SR)
          call MW_coulomb_sr_melt_efg(num_PBC, localwork, ewald, box, ions, xyz_ions, efg_ions)
          call MW_timers_stop(TIMER_COULOMB_EFG_MELT_SR)
        end if

        ! Self term contribution
        ! ----------------------
        call MW_timers_start(TIMER_COULOMB_EFG_MELT_SELF)
        call MW_coulomb_self_melt_efg(localwork, ewald, ions, efg_ions)
        call MW_timers_stop(TIMER_COULOMB_EFG_MELT_SELF)
      end select

#ifndef MW_SERIAL
      count = size(efg_ions,1) * size(efg_ions,2)
      call MPI_Allreduce(MPI_IN_PLACE, efg_ions(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine melt_efg

   ! =====================================================================================================
   ! Remove contribution from same molecule particles to the gradient of the electric field due to dipoles
   subroutine fix_molecule_gradmumelt_electricfield(num_PBC, localwork, molecules, box, &
         ions, xyz_ions, gradmu_efield)
      implicit none
      ! Parameters in
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork
      type(MW_molecule_t),  intent(in)    :: molecules(:) !< molecules parameters
      type(MW_box_t),       intent(in)    :: box !< box parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: xyz_ions(:,:) !< melt particles coordinates

      ! Parameters out
      ! ----------
      real(wp),             intent(inout) :: gradmu_efield(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: count, ierr

      select case(num_PBC)
      case(2)
         call fix_molecule_gradmumelt_electricfield_2DPBC(localwork, molecules, box, &
              ions, xyz_ions, gradmu_efield)
      case(3)
         call fix_molecule_gradmumelt_electricfield_3DPBC(localwork, molecules, box, &
              ions, xyz_ions, gradmu_efield)
      end select
#ifndef MW_SERIAL
      count = size(gradmu_efield,1) * size(gradmu_efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, gradmu_efield(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_gradmumelt_electricfield

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   subroutine qmelt2Qelec_potential(num_PBC, localwork, ewald, box, &
         ions, xyz_ions, type_ions, electrodes, xyz_atoms, V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary condition
      type(MW_localwork_t), intent(in)    :: localwork !< Local work assignment
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      integer,              intent(in)    :: type_ions(:)  !< ion types

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: V(:,:)   !< Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count

      ! Initialize potential to 0
      ! -------------------------
      !$acc data present(V(:,:))
      !$acc kernels
      V(:,:) = 0.0_wp
      !$acc end kernels

      select case(num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_qmelt2Qelec_potential(localwork, ewald, box,&
                 ions, electrodes, V(:,1),type_ions)
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Long range contribution from k=0 mode (only with 2D PBC)
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_KEQ0)
         call MW_coulomb_keq0_qmelt2Qelec_potential(localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, V(:,2))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_qmelt2Qelec_potential(num_PBC, localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)
      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_qmelt2Qelec_potential(localwork, ewald, box,&
                 ions, electrodes, V(:,1),type_ions)
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_qmelt2Qelec_potential(num_PBC, localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)
      end select

#ifndef MW_SERIAL
      count = size(V,1)*3
      call MPI_Allreduce(MPI_IN_PLACE, V(:,1:3), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine qmelt2Qelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   subroutine mumelt2Qelec_potential(num_PBC, localwork, ewald, box, &
         ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V) !TANG-TONNIES COULD BE NECESSARY
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary condition
      type(MW_localwork_t), intent(in)    :: localwork !< Local work assignment
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)  !< ions dipoles
      integer,              intent(in)    :: type_electrode_atoms(:)

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: V(:,:)   !< Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count

      ! Initialize potential to 0
      ! -------------------------
      !$acc data present(V(:,:))
      !$acc kernels
      V(:,:) = 0.0_wp
      !$acc end kernels

      select case(num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_pim_mumelt2Qelec_potential(localwork, ewald, box,&
         ions, electrodes, dipoles, V(:,1))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Long range contribution from k=0 mode (only with 2D PBC)
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_KEQ0)
         call MW_coulomb_keq0_pim_mumelt2Qelec_potential(localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, dipoles(:,3), V(:,2))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_pim_mumelt2Qelec_potential(num_PBC, localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)
      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_LR)
         call MW_coulomb_lr_pim_mumelt2Qelec_potential(localwork, ewald, box,&
         ions, electrodes, dipoles, V(:,1))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELTELEC_SR)
         call MW_coulomb_sr_pim_mumelt2Qelec_potential(num_PBC, localwork, ewald, box,&
         ions, xyz_ions, electrodes, xyz_atoms, dipoles, type_electrode_atoms, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_MELTELEC_SR)
      end select

#ifndef MW_SERIAL
      count = size(V,1)*3
      call MPI_Allreduce(MPI_IN_PLACE, V(:,1:3), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine mumelt2Qelec_potential

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all electrode atoms
   subroutine Qelec2Qelec_potential(num_PBC, localwork, ewald, box, &
         electrodes, xyz_atoms, q_elec, V)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork  !< Localwork work distribution
      type(MW_box_t),       intent(in)    :: box       !< Simulation box parameters
      type(MW_electrode_t), intent(in)    :: electrodes(:)  !< electrode parameters
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< Electrode atoms positions

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald     !< Ewald summation parameters
      real(wp),             intent(inout) :: V(:,:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: ierr, count

      ! Initialize potential to 0
      ! -------------------------
      !$acc data present(V(:,:))
      !$acc kernels
      V(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)
      case(2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_LR)
         call MW_coulomb_lr_Qelec2Qelec_potential(localwork, ewald, box, &
              electrodes, q_elec, V(:,1))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_KEQ0)
         call MW_coulomb_keq0_Qelec2Qelec_potential(localwork, ewald, box, &
              electrodes, xyz_atoms, q_elec, V(:,2))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_SR)
         call MW_coulomb_sr_Qelec2Qelec_potential(num_PBC, localwork, ewald, box, &
              electrodes, xyz_atoms, q_elec, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_SR)

         ! Self interaction correction
         ! ---------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_SELF)
         call MW_coulomb_self_Qelec2Qelec_potential(localwork, ewald, &
              electrodes, q_elec, V(:,4))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_SELF)

      case(3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_LR)
         call MW_coulomb_lr_Qelec2Qelec_potential(localwork, ewald, box, &
              electrodes, q_elec, V(:,1))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_SR)
         call MW_coulomb_sr_Qelec2Qelec_potential(num_PBC, localwork, ewald, box, &
              electrodes, xyz_atoms, q_elec, V(:,3))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_SR)

         ! Self interaction correction
         ! ---------------------------
         call MW_timers_start(TIMER_COULOMB_ELECELEC_SELF)
         call MW_coulomb_self_Qelec2Qelec_potential(localwork, ewald, &
              electrodes, q_elec, V(:,4))
         call MW_timers_stop(TIMER_COULOMB_ELECELEC_SELF)
      end select
#ifndef MW_SERIAL
      count = size(V,1) * 4
      call MPI_Allreduce(MPI_IN_PLACE, V(:,1:4), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine Qelec2Qelec_potential

   !================================================================================
   ! Compute the Electric fields felt by each melt ions due to other melt charges
   subroutine qmelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         type_ions, efield, tt)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      integer,              intent(in)    :: type_ions(:)
      type(MW_damping_t),   intent(in)    :: tt            !< damping parameters

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero electric fields on ions
      ! ---------------------------------
      !$acc data present(efield(:,:))
      !$acc kernels
      efield(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_LR)
         call MW_coulomb_lr_pim_qmelt2mumelt_electricfield(localwork, ewald, box, ions, &
              efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_KEQ0)
         call MW_coulomb_keq0_pim_qmelt2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
              efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_SR)
         call MW_coulomb_sr_pim_qmelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 type_ions, efield, tt)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_SR)

      case (3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_LR)
         call MW_coulomb_lr_pim_qmelt2mumelt_electricfield(localwork, ewald, box, ions, &
              efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_SR)
         call MW_coulomb_sr_pim_qmelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 type_ions, efield, tt)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_SR)
      end select
#ifndef MW_SERIAL
      count = size(efield,1) * size(efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, efield, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine qmelt2mumelt_electricfield

   !================================================================================
   ! Compute the Electric fields felt by each melt ions due to other melt dipoles
   subroutine mumelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         efield, dipoles)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),             intent(in)    :: dipoles(:,:)  !< ions dipoles

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Electric field on ions

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero electric fields on ions
      ! ---------------------------------
      !$acc data present(efield(:,:))
      !$acc kernels
      efield(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_LR)
         call MW_coulomb_lr_pim_mumelt2mumelt_electricfield(localwork, ewald, box, ions, &
              efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_KEQ0)
         call MW_coulomb_keq0_pim_mumelt2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
              efield, dipoles(:,3))
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_KEQ0)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_SR)
         call MW_coulomb_sr_pim_mumelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
              efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_SR)

         ! Self contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_SELF)
         call MW_coulomb_self_mumelt2mumelt_electricfield(localwork, ewald, ions, efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_SELF)
      case (3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_LR)
         call MW_coulomb_lr_pim_mumelt2mumelt_electricfield(localwork, ewald, box, ions, &
              efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_SR)
         call MW_coulomb_sr_pim_mumelt2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
              efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_SR)

         ! Self contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_SELF)
         call MW_coulomb_self_mumelt2mumelt_electricfield(localwork, ewald, ions, efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_SELF)
      end select
#ifndef MW_SERIAL
      count = size(efield,1) * size(efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, efield, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the Electric fields felt by each melt ions due to other melt charges
   subroutine Qelec2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      integer,              intent(in)    :: type_electrode_atoms(:)

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero electric fields on ions
      ! ---------------------------------
      !$acc data present(efield(:,:))
      !$acc kernels
      efield(:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_LR)
         call MW_coulomb_lr_pim_Qelec2mumelt_electricfield(localwork, ewald, box, ions, &
              electrodes, q_elec, efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_LR)

         ! Long range contribution from k=0 mode
         ! -------------------------------------
         !DEBUG
         !Deactivating this convergence to the "full" problem can be reached, at least for one iteration
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_KEQ0)
         call MW_coulomb_keq0_pim_Qelec2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
              electrodes, xyz_atoms, q_elec, efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_KEQ0)
         !END DEBUG

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_SR)
         call MW_coulomb_sr_pim_Qelec2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
              electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_SR)
      case (3)
         ! Long range contribution is computed in reciprocal space
         ! -------------------------------------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_LR)
         call MW_coulomb_lr_pim_Qelec2mumelt_electricfield(localwork, ewald, box, ions, &
              electrodes, q_elec, efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_LR)

         ! Short range contribution
         ! ------------------------
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_SR)
         call MW_coulomb_sr_pim_Qelec2mumelt_electricfield(num_PBC, localwork, ewald, box, ions, xyz_ions, &
              electrodes, xyz_atoms, q_elec, type_electrode_atoms, efield)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_SR)
      end select
#ifndef MW_SERIAL
      count = size(efield,1) * size(efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, efield, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
      !$acc end data
   end subroutine Qelec2mumelt_electricfield

   ! =====================================================================================
   ! Remove contribution from same molecule particles to the electric field due to charges
   subroutine fix_molecule_qmelt2mumelt_electricfield(num_PBC, localwork, molecules, box, &
         ions, xyz_ions, efield, tt)
      implicit none
      ! Parameters in
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork
      type(MW_molecule_t),  intent(in)    :: molecules(:) !< molecules parameters
      type(MW_box_t),       intent(in)    :: box !< box parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: xyz_ions(:,:) !< melt particles coordinates
      type(MW_damping_t),   intent(in)    :: tt   ! Damping parameters

      ! Parameters out
      ! ----------
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: count, ierr

      select case(num_PBC)
      case(2)
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_MOL)
         call fix_molecule_qmelt2mumelt_electricfield_2DPBC(localwork, molecules, box, &
              ions, xyz_ions, efield, tt)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_MOL)
      case(3)
         call MW_timers_start(TIMER_COULOMB_MELT_ELECQ_MOL)
         call fix_molecule_qmelt2mumelt_electricfield_3DPBC(localwork, molecules, box, &
              ions, xyz_ions, efield, tt)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECQ_MOL)
      end select
#ifndef MW_SERIAL
      count = size(efield,1) * size(efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, efield(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_qmelt2mumelt_electricfield

   ! =====================================================================================
   ! Remove contribution from same molecule particles to the electric field due to dipoles
   subroutine fix_molecule_mumelt2mumelt_electricfield(num_PBC, localwork, molecules, box, &
         ions, xyz_ions, efield, dipoles)
      implicit none
      ! Parameters in
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork
      type(MW_molecule_t),  intent(in)    :: molecules(:) !< molecules parameters
      type(MW_box_t),       intent(in)    :: box !< box parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: xyz_ions(:,:) !< melt particles coordinates
      real(wp),             intent(in)    :: dipoles(:,:)   !< ions dipoles

      ! Parameters out
      ! ----------
      real(wp),             intent(inout) :: efield(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: count, ierr

      select case(num_PBC)
      case(2)
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_MOL)
         call fix_molecule_mumelt2mumelt_electricfield_2DPBC(localwork, molecules, box, &
              ions, xyz_ions, efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_MOL)
      case(3)
         call MW_timers_start(TIMER_COULOMB_MELT_ELECMU_MOL)
         call fix_molecule_mumelt2mumelt_electricfield_3DPBC(localwork, molecules, box, &
              ions, xyz_ions, efield, dipoles)
         call MW_timers_stop(TIMER_COULOMB_MELT_ELECMU_MOL)
      end select
#ifndef MW_SERIAL
      count = size(efield,1) * size(efield,2)
      call MPI_Allreduce(MPI_IN_PLACE, efield(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
         electrodes, xyz_atoms, type_electrode_atoms, q_elec, force, stress_tensor, pimrun, dipoles, tt, compute_force)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC         !< Number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_box_t),       intent(in)    :: box             !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)         !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)   !< ions xyz positions
      integer,              intent(in)    :: type_ions(:)    !< Ion types
      type(MW_electrode_t), intent(inout) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      integer,              intent(in)    :: type_electrode_atoms(:) !< Electrode atoms types
      real(wp),             intent(in)    :: q_elec(:)       !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)    !< ions dipoles
      logical,              intent(in)    :: pimrun !< run with the polarizable ion model
      type(MW_damping_t),   intent(in)    :: tt   ! Damping parameters
      logical,              intent(in)    :: compute_force !< compute force on electrodes

      ! Parameters out
      ! --------------
      type(MW_ewald_t),     intent(inout) :: ewald          !< Ewald summation parameters
      real(wp),             intent(inout) :: force(:,:,:) !< Coulomb force on ions
      real(wp),             intent(inout) :: stress_tensor(:,:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: i, ierr, count, num_elec_types

      ! Zero forces on ions
      ! ---------------------------------
      !$acc data present(force(:,:,:))
      !$acc kernels
      force(:,:,:) = 0.0_wp
      !$acc end kernels

      select case (num_PBC)

      case (2)

         if(pimrun)then
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_LR)
            call MW_coulomb_lr_pim_melt_forces(localwork, ewald, box, ions, &
                 electrodes, q_elec, force(:,:,1),stress_tensor(:,:,1),dipoles)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_LR)

            ! Long range contribution from k=0 mode
            ! -------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_KEQ0)
            call MW_coulomb_keq0_pim_melt_forces(localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, force(:,:,2),dipoles(:,3))
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_KEQ0)

            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_SR)
            call MW_coulomb_sr_pim_melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
                 electrodes, xyz_atoms, type_electrode_atoms, q_elec, force(:,:,3), stress_tensor(:,:,3), &
                 dipoles,tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_SR)
         else
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_LR)
            call MW_coulomb_lr_melt_forces(localwork, ewald, box, ions, &
                 electrodes, q_elec, force(:,:,1),stress_tensor(:,:,1), compute_force)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_LR)

            ! Long range contribution from k=0 mode
            ! Not doing the stress tensor here
            ! -------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_KEQ0)
            call MW_coulomb_keq0_melt_forces(localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, force(:,:,2), compute_force)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_KEQ0)

            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_SR)
            call MW_coulomb_sr_melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
                    electrodes, xyz_atoms, type_electrode_atoms, q_elec, force(:,:,3), &
                 stress_tensor(:,:,3), compute_force)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_SR)
         endif

      case (3)

         if(pimrun)then
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_LR)
            call MW_coulomb_lr_pim_melt_forces(localwork, ewald, box, ions, &
                 electrodes, q_elec, force(:,:,1),stress_tensor(:,:,1),dipoles)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_LR)
            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_SR)
            call MW_coulomb_sr_pim_melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
                 electrodes, xyz_atoms, type_electrode_atoms, q_elec, force(:,:,3),stress_tensor(:,:,3),dipoles,tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_SR)
         else
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_LR)
            call MW_coulomb_lr_melt_forces(localwork, ewald, box, ions, &
                 electrodes, q_elec, force(:,:,1), stress_tensor(:,:,1), compute_force)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_LR)
            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_SR)
            call MW_coulomb_sr_melt_forces(num_PBC, localwork, ewald, box, ions, xyz_ions, type_ions, &
                    electrodes, xyz_atoms, type_electrode_atoms, q_elec, force(:,:,3), stress_tensor(:,:,3), compute_force)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_SR)
         endif

      end select
#ifndef MW_SERIAL
      count = size(force,1) * size(force,2) * 3
      call MPI_Allreduce(MPI_IN_PLACE, force(:,:,1:3), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)*3      ! this should always be 27
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      if (compute_force) then
         num_elec_types = size(electrodes,1)
         do i = 1, num_elec_types
            call MPI_Allreduce(MPI_IN_PLACE, electrodes(i)%force_ions(:,2:6), 15, MPI_DOUBLE_PRECISION, MPI_SUM, &
                  MW_COMM_WORLD, ierr)
        end do
      end if
#endif
      !$acc end data
   end subroutine melt_forces

   ! =======================================================================================
   ! Remove contribution from same molecule particles to the forces on particles in the melt
   subroutine fix_molecule_melt_forces(num_PBC, localwork, molecules, box, &
         ions, xyz_ions, force,stress_tensor, pimrun, dipoles, tt)
      implicit none
      ! Parameters in
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork
      type(MW_molecule_t),  intent(in)    :: molecules(:) !< molecules parameters
      type(MW_box_t),       intent(in)    :: box !< box parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: xyz_ions(:,:) !< melt particles coordinates
      real(wp),             intent(in)    :: dipoles(:,:)  !< ions dipoles
      logical,              intent(in)    :: pimrun !< run with the polarizable ion model
      type(MW_damping_t),   intent(in)    :: tt   ! Damping parameters

      ! Parameters out
      ! ----------
      real(wp),             intent(inout) :: force(:,:) !< force on melt particles
      real(wp),             intent(inout) :: stress_tensor(:,:) !< force on melt particles

      ! Local
      ! -----
      integer :: count, ierr

      select case(num_PBC)
      case(2)
         if(.not.pimrun)then
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_MOL)
            call fix_molecule_melt_forces_2DPBC(localwork, molecules, box, &
                 ions, xyz_ions, force,stress_tensor)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_MOL)
         else
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_MOL)
            call fix_molecule_pim_melt_forces_2DPBC(localwork, molecules, box, &
                 ions, xyz_ions, force,stress_tensor,dipoles,tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_MOL)
         endif
      case(3)
         if(.not.pimrun)then
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_MOL)
            call fix_molecule_melt_forces_3DPBC(localwork, molecules, box, &
                 ions, xyz_ions, force,stress_tensor)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_MOL)
         else
            call MW_timers_start(TIMER_COULOMB_MELT_FORCES_MOL)
            call fix_molecule_pim_melt_forces_3DPBC(localwork, molecules, box, &
                 ions, xyz_ions, force,stress_tensor,dipoles,tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_FORCES_MOL)
         endif
      end select
#ifndef MW_SERIAL
      count = size(force,1) * size(force,2)
      call MPI_Allreduce(MPI_IN_PLACE, force(:,:), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)

      count = size(stress_tensor,1)*size(stress_tensor,2)        ! this should always be 9
      call MPI_Allreduce(MPI_IN_PLACE, stress_tensor, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_melt_forces

   !================================================================================
   ! Compute the Energy due to Coulomb interactions
   subroutine energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
         electrodes, xyz_atoms, q_elec, h, pimrun, dipoles, tt)
      implicit none

      ! Parameters in
      ! -------------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in)    :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in)    :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in)    :: ions(:)        !< ions parameters
      real(wp),             intent(in)    :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in)    :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in)    :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in)    :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in)    :: dipoles(:,:)  !< ions dipoles
      logical,              intent(in)    :: pimrun !< run with the polarizable ion model
      type(MW_damping_t),   intent(in)    :: tt   ! Damping parameters

      ! Parameters out
      ! --------------
      real(wp),             intent(inout) :: h(:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: ierr, count

      ! Zero energy
      ! ----------------
      h(:) = 0.0_wp

      select case (num_PBC)
      case (2)
         if(pimrun)then
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_LR)
            call MW_coulomb_lr_pim_energy(localwork, ewald, box, ions, &
                 electrodes, q_elec, h(1), dipoles)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_LR)

            ! Long range contribution from k=0 mode
            ! -------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_KEQ0)
            call MW_coulomb_keq0_pim_energy(localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(2), dipoles(:,3))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_KEQ0)

            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SR)
            call MW_coulomb_sr_pim_energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(3), dipoles, tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SR)

            ! Self contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SELF)
            call MW_coulomb_self_pim_energy(localwork, ewald, ions,  electrodes, q_elec, dipoles, h(4))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SELF)

         else
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_LR)
            call MW_coulomb_lr_energy(localwork, ewald, box, ions, &
                 electrodes, q_elec, h(1))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_LR)

            ! Long range contribution from k=0 mode
            ! -------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_KEQ0)
            call MW_coulomb_keq0_energy(localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(2))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_KEQ0)

            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SR)
            call MW_coulomb_sr_energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(3))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SR)

            ! Self contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SELF)
            call MW_coulomb_self_energy(localwork, ewald, ions, electrodes, q_elec, h(4))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SELF)
         endif

      case (3)
         if(pimrun)then
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_LR)
            call MW_coulomb_lr_pim_energy(localwork, ewald, box, ions, &
                 electrodes, q_elec, h(1),dipoles)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_LR)
            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SR)
            call MW_coulomb_sr_pim_energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(3),dipoles,tt)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SR)
            ! Self contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SELF)
            call MW_coulomb_self_pim_energy(localwork, ewald, ions,  electrodes, q_elec,dipoles, h(4))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SELF)
         else
            ! Long range contribution is computed in reciprocal space
            ! -------------------------------------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_LR)
            call MW_coulomb_lr_energy(localwork, ewald, box, ions, &
                 electrodes, q_elec, h(1))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_LR)
            ! Short range contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SR)
            call MW_coulomb_sr_energy(num_PBC, localwork, ewald, box, ions, xyz_ions, &
                 electrodes, xyz_atoms, q_elec, h(3))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SR)
            ! Self contribution
            ! ------------------------
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_SELF)
            call MW_coulomb_self_energy(localwork, ewald, ions, electrodes, q_elec, h(4))
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_SELF)
         endif

      end select
#ifndef MW_SERIAL
      count = 4
      call MPI_Allreduce(MPI_IN_PLACE, h(1:4), count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine energy

   ! ================================================================================
   ! Remove contribution from same molecule particles
   !
   subroutine fix_molecule_energy(num_PBC, localwork, molecules, box, &
         ions, xyz_ions,pimrun, dipoles, tt, h)
      implicit none
      ! Parameters in
      ! ----------
      integer,              intent(in)    :: num_PBC !< number of periodic boundary conditions
      type(MW_localwork_t), intent(in)    :: localwork
      type(MW_molecule_t),  intent(in)    :: molecules(:) !< molecules parameters
      type(MW_box_t),       intent(in)    :: box !< box parameters
      type(MW_ion_t),       intent(in)    :: ions(:) !< ion types parameters
      real(wp),             intent(in)    :: xyz_ions(:,:) !< melt particles coordinates
      real(wp),             intent(in)    :: dipoles(:,:)  !< ions dipoles
      logical,              intent(in)    :: pimrun !< run with the polarizable ion model
      type(MW_damping_t),   intent(in)    :: tt   ! Damping parameters

      ! Parameters out
      ! ----------
      real(wp),             intent(inout) :: h !< energy on melt particles

      ! Local
      ! -----
      integer :: ierr

      select case(num_PBC)
      case(2)
         if(.not.pimrun)then
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_MOL)
            call fix_molecule_energy_2DPBC(localwork, molecules, box, &
                 ions, xyz_ions, h)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_MOL)
         else
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_MOL)
            call fix_molecule_pim_energy_2DPBC(localwork, molecules, box, &
                 ions, xyz_ions, dipoles, tt, h)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_MOL)
         endif
      case(3)
         if(.not.pimrun)then
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_MOL)
            call fix_molecule_energy_3DPBC(localwork, molecules, box, &
                 ions, xyz_ions, h)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_MOL)
         else
            call MW_timers_start(TIMER_COULOMB_MELT_POTENTIAL_MOL)
            call fix_molecule_pim_energy_3DPBC(localwork, molecules, box, &
                 ions, xyz_ions, dipoles, tt, h)
            call MW_timers_stop(TIMER_COULOMB_MELT_POTENTIAL_MOL)
         endif
      end select
#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, h, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
   end subroutine fix_molecule_energy

   ! ================================================================================
   include 'coulomb_fix_molecule_2DPBC.inc'
   include 'coulomb_fix_molecule_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_displacement_2DPBC.inc'
   include 'minimum_image_displacement_3DPBC.inc'
   ! ================================================================================
   include 'minimum_image_distance_2DPBC.inc'
   include 'minimum_image_distance_3DPBC.inc'

end module MW_coulomb

! Module to compute electrostatic Coulomb potential
module MW_coulomb_keq0_pim
   use MW_kinds, only: wp
   use MW_ewald, only: MW_ewald_t
   use MW_box, only: MW_box_t
   use MW_constants, only: pi
   use MW_electrode, only: MW_electrode_t
   use MW_ion, only: MW_ion_t
   use MW_localwork, only: MW_localwork_t
   implicit none
   private

   ! Public subroutines
   ! ------------------
   public :: gradQelec_electricfield !grad_Q [grad_mu [U^k=0_muQ]]
   public :: diag_gradmumelt_electricfield !diag[grad_mu [grad_mu [U^k=0_mumu]]]
   public :: gradmumelt_electricfield !grad_mu [grad_mu [U^k=0_mumu]]
   public :: mumelt2Qelec_potential !grad_Q [U^k=0_muQ]
   public :: qmelt2mumelt_electricfield !-grad_mu [U^k=0_qmu]
   public :: mumelt2mumelt_electricfield !-grad_mu [U^k=0_mumu]
   public :: Qelec2mumelt_electricfield !-grad_mu [U^k=0_muQ]
   public :: melt_forces !-grad_r [(U^k=0_qq + U^k=0_qmu + U^k=0_mumu) + (U^k=0_QQ) + (U^k=0_qQ + U^k=0_muQ)]
   public :: energy !(U^k=0_qq + U^k=0_qmu + U^k=0_mumu) + (U^k=0_QQ) + (U^k=0_qQ + U^k=0_muQ)

contains

   subroutine gradQelec_electricfield(localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, gradQ_efield)
      implicit none
      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: gradQ_efield(:,:) !< Electric field

      ! Local
      ! -----
      integer :: num_ions, num_ion_types, num_elec_types
      integer :: i, j, jz, itype, jtype
      real(wp) :: volfactor
      real(wp) :: zij, erf_ij
      real(wp) :: alpha
      integer :: num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ions = size(gradQ_efield,1)/3
      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), gradQ_efield(:,:))

      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, num_ion_types
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            ! Number of blocks with full atom2ion interactions
            num_block_full = localwork%pair_ion2atom_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2atom_full_iblock_offset(itype, jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) private(jz, zij, erf_ij)
               do i = istart, iend
                  do j = jstart, jend
                     jz = j + num_ions*2
                     zij = xyz_atoms(i,3) - xyz_ions(j,3)
                     erf_ij = erf(alpha*zij)
                     !$acc atomic update
                     gradQ_efield(jz,i) = gradQ_efield(jz,i) + volfactor*pi*erf_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do
      end do
      !$acc end data

   end subroutine gradQelec_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   ! dipoles
   subroutine diag_gradmumelt_electricfield(localwork, ewald, box, ions, &
      diag_gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork      !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters

      ! Parameters Input/Output
      ! --------------
      real(wp), intent(inout) :: diag_gradmu_efield(:)      !< matrix containing the
      !< gradient of the field
      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: itype, i, iion, iionz
      real(wp) :: volfactor, alpha, sqrpi, elecz_ii

      num_ion_types = size(ions,1)
      num_ions = size(diag_gradmu_efield,1)/3

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      sqrpi = sqrt(pi)
      volfactor = 2.0_wp/box%area(3)
      elecz_ii = 2.0_wp*volfactor*alpha*sqrpi

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      do itype = 1, num_ion_types
         do i = 1, localwork%count_ions(itype)
            iion = localwork%offset_ions(itype) + i
            iionz = iion + num_ions*2
            diag_gradmu_efield(iionz) = diag_gradmu_efield(iionz) + elecz_ii
         end do
      end do

   end subroutine diag_gradmumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   ! dipoles
   subroutine gradmumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
      gradmu_efield)
      implicit none

      ! Parameters Input
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork      !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      ! Parameters Input/Output
      ! --------------
      real(wp), intent(inout) :: gradmu_efield(:,:)      !< matrix containing the
      !< gradient of the field
      ! Local
      ! -----
      integer :: num_ion_types, num_ions
      integer :: i, j, itype, jtype, iz, jz
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, exp_ij
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha,sqrpi
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_ions = size(gradmu_efield,1)/3

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      sqrpi=sqrt(pi)
      alphapi = 2.0_wp * alpha / sqrpi
      sqrpialpha = sqrpi / alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), gradmu_efield(:,:))

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) private(iz, jz, zij, zijsq, exp_ij)
               do i = istart, iend
                  do j = jstart, jend
                     iz = i + num_ions*2
                     jz = j + num_ions*2
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     exp_ij = exp(-zijsq*alphasq)
                     !$acc atomic update
                     gradmu_efield(jz,iz) = gradmu_efield(jz,iz) + &
                     2.0_wp*volfactor*alpha*sqrpi*exp_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
            offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) private(iz, jz, zij, zijsq, exp_ij)
            do i = istart, iend
               do j = istart, iend
                  iz = i + num_ions*2
                  jz = j + num_ions*2
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  exp_ij = exp(-zijsq*alphasq)
                  !$acc atomic update
                  gradmu_efield(jz,iz) = gradmu_efield(jz,iz) + &
                  2.0_wp*volfactor*alpha*sqrpi*exp_ij
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            !$acc parallel loop collapse(2) private(iz, jz, zij, zijsq, exp_ij)
            do i = istart, iend
               do j = jstart, jend
                  iz = i + num_ions*2
                  jz = j + num_ions*2
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  exp_ij = exp(-zijsq*alphasq)
                  !$acc atomic update
                  gradmu_efield(jz,iz) = gradmu_efield(jz,iz) + &
                  2.0_wp*volfactor*alpha*sqrpi*exp_ij
               end do
            end do
            !$acc end parallel loop
         end do

      end do
      !$acc end data
   end subroutine gradmumelt_electricfield

   !================================================================================
   ! Compute the Coulomb potential felt by each electrode atoms due to all melt ions
   subroutine mumelt2Qelec_potential(localwork, ewald, box, &
      ions, xyz_ions, electrodes, xyz_atoms, dipolez, V)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald    !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box      !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: dipolez(:)      !< z-component of the dipole

      ! Parameters out
      ! --------------
      real(wp),                 intent(inout) :: V(:)       !< Coulomb potential

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: num_ions, num_elec_atoms
      integer :: i, j 
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, erf_ij
      real(wp) :: alpha
      real(wp) :: vi

      integer :: num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)
      num_ions = 0
      if (num_ion_types > 0) then
         num_ions = ions(num_ion_types)%offset+ions(num_ion_types)%count
      end if
      num_elec_atoms = 0
      if (num_elec_types > 0) then
         num_elec_atoms = electrodes(num_elec_types)%offset+electrodes(num_elec_types)%count
      end if

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      count_m = num_ions
      offset_m = 0
   
      count_n = num_elec_atoms
      offset_n = 0

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), dipolez(:), V(:))

      ! Number of blocks with full interactions (below the diagonal
      num_block_full = localwork%pair_ion2atom_num_block_full_local_ms
      iblock_offset = localwork%pair_ion2atom_full_iblock_offset_ms
      do iblock = 1, num_block_full
         call update_other_block_boundaries(iblock_offset+iblock, &
         offset_n, count_n, offset_m, count_m, &
         istart, iend, jstart, jend)
         !$acc parallel loop private(zij, zijsq, erf_ij, vi)
         do i = istart, iend
            vi = 0.0_wp
            !$acc loop reduction(+:vi)
            do j = jstart, jend
               zij = xyz_atoms(i,3) - xyz_ions(j,3)
               zijsq = zij*zij
               erf_ij = erf(zij*alpha)
               vi = vi + volfactor*pi*erf_ij*dipolez(j)
            end do
            !$acc end loop
            V(i) = V(i) + vi
         end do
         !$acc end parallel loop
      end do
      !$acc end data
   end subroutine mumelt2Qelec_potential

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   ! charges
   subroutine qmelt2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
      efield)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),      intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),        intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),        intent(in) :: ions(:)        !< ions parameters
      real(wp),              intent(in) :: xyz_ions(:,:)  !< ions xyz positions

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: efield(:,:) !< Electric field

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: i, j, itype, jtype
      real(wp) :: qi, qj !< ion charge
      real(wp) :: volfactor
      real(wp) :: zij,  erf_ij
      real(wp) :: alpha
      real(wp) :: eiz

      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), efield(:,:))

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            qj = ions(jtype)%charge
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop private(zij, erf_ij, eiz)
               do i = istart, iend
                  eiz = 0.0_wp
                  !$acc loop reduction(+:eiz)
                  do j = jstart, jend
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     erf_ij = erf(alpha*zij)
                     eiz = eiz + volfactor*pi*erf_ij*qj
                     !$acc atomic update
                     efield(j,3) = efield(j,3) + volfactor*pi*erf_ij*qi
                  end do
                  !$acc end loop
                  efield(i,3) = efield(i,3) - eiz
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
            offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) private(zij, erf_ij)
            do i = istart, iend
               do j = istart, iend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  erf_ij = erf(alpha*zij)
                  !$acc atomic update
                  efield(j,3) = efield(j,3) + volfactor*pi*erf_ij*qi
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            !$acc parallel loop private(zij, erf_ij, eiz)
            do i = istart, iend
               eiz = 0.0_wp
               !$acc loop reduction(+:eiz)
               do j = jstart, jend
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  erf_ij = erf(alpha*zij)
                  eiz = eiz + volfactor*pi*erf_ij*qj
                  !$acc atomic update
                  efield(j,3) = efield(j,3) + volfactor*pi*erf_ij*qi
               end do
               !$acc end loop
               efield(i,3) = efield(i,3) - eiz
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data
   end subroutine qmelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   ! dipoles
   subroutine mumelt2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
      efield, dipolez)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      real(wp),             intent(in) :: dipolez(:)      !< z-component of the dipole

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: efield(:,:) !< Electric field on ions

      ! Local
      ! -----
      integer :: num_ion_types
      integer :: i, j, itype
      real(wp) :: muiz,mujz
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, exp_ij
      real(wp) :: eiz
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha,sqrpi
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n
       
      integer :: num_ions

      num_ion_types = size(ions,1)
      num_ions = 0
      do itype = 1,num_ion_types
         num_ions = num_ions + ions(itype)%count
      enddo
      count_n = num_ions
      offset_n = 0

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      sqrpi=sqrt(pi)
      alphapi = 2.0_wp * alpha / sqrpi
      sqrpialpha = sqrpi / alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), dipolez(:), efield(:,:))

      ! Blocks on the diagonal compute only half of the pair interactions
      num_block_diag = localwork%pair_ion2ion_num_block_diag_local_ms
      iblock_offset = localwork%pair_ion2ion_diag_iblock_offset_ms

      do iblock = 1, num_block_diag
         call update_diag_block_boundaries(iblock_offset+iblock, &
         offset_n, count_n, istart, iend)
         !$acc parallel loop collapse(2) private(muiz, mujz, zij, zijsq, exp_ij)
         do i = istart, iend
            do j = istart, iend
               muiz = dipolez(i)
               mujz = dipolez(j)
               zij = xyz_ions(j,3) - xyz_ions(i,3)
               zijsq = zij*zij
               exp_ij = exp(-zijsq*alphasq)
               !$acc atomic update
               efield(j,3) = efield(j,3) - 2.0_wp*volfactor*alpha*sqrpi*exp_ij*muiz
            end do
         end do
         !$acc end parallel loop
      end do

      ! Number of blocks with full interactions (below the diagonal
      num_block_full = localwork%pair_ion2ion_num_block_full_local_ms
      iblock_offset = localwork%pair_ion2ion_full_iblock_offset_ms
      do iblock = 1, num_block_full
         call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
         istart, iend, jstart, jend)
         !$acc parallel loop private(muiz, mujz, zij, zijsq, exp_ij, eiz)
         do i = istart, iend
            muiz = dipolez(i)
            eiz = 0.0_wp
            !$acc loop reduction(+:eiz)
            do j = jstart, jend
               mujz = dipolez(j)
               zij = xyz_ions(j,3) - xyz_ions(i,3)
               zijsq = zij*zij
               exp_ij = exp(-zijsq*alphasq)
               eiz = eiz - 2.0_wp*volfactor*alpha*sqrpi*exp_ij*mujz
               !$acc atomic update
               efield(j,3) = efield(j,3) - 2.0_wp*volfactor*alpha*sqrpi*exp_ij*muiz
            end do
            !$acc end loop
            efield(i,3) = efield(i,3) + eiz
         end do
         !$acc end parallel loop
      end do
      !$acc end data
   end subroutine mumelt2mumelt_electricfield

   !================================================================================
   ! Compute the electric fields felt by each melt ions due to other melt ions
   ! charges
   subroutine Qelec2mumelt_electricfield(localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, efield)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: efield(:,:) !< Electric field

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j
      real(wp) :: volfactor
      real(wp) :: zij, erf_ij, eiz
      real(wp) :: alpha
      integer :: num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m
      integer  :: num_ions, num_elec_atoms

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)
      num_ions = 0
      if (num_ion_types > 0) then
         num_ions = ions(num_ion_types)%offset+ions(num_ion_types)%count
      end if
      num_elec_atoms = 0
      if (num_elec_types > 0) then
         num_elec_atoms = electrodes(num_elec_types)%offset+electrodes(num_elec_types)%count
      end if

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), q_elec(:), efield(:,:))

      count_m = num_elec_atoms
      offset_m = 0
   
      count_n = num_ions
      offset_n = 0
   
      ! Number of blocks with full interactions (below the diagonal
      num_block_full = localwork%pair_ion2atom_num_block_full_local_ms
      iblock_offset = localwork%pair_ion2atom_full_iblock_offset_ms
      do iblock = 1, num_block_full
         call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)

         !$acc parallel loop private(zij, erf_ij, eiz)
         do i = istart, iend
            eiz = 0.0_wp
            !$acc loop reduction(+:eiz)
            do j = jstart, jend
               zij = xyz_atoms(j,3) - xyz_ions(i,3)
               erf_ij = erf(alpha*zij)
               eiz = eiz - volfactor*pi*erf_ij*q_elec(j)
            end do
            !$acc end loop
            !$acc atomic update
            efield(i,3) = efield(i,3) + eiz
         end do
         !$acc end parallel loop
      end do
      !$acc end data
   end subroutine Qelec2mumelt_electricfield

   !================================================================================
   ! Compute the Coulomb forces felt by each melt ions due to other melt ions
   subroutine melt_forces(localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, force, dipolez)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t),  intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in) :: dipolez(:)      !< z-component of the dipole

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: force(:,:) !< Coulomb force on ions

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j, itype, jtype
      real(wp) :: qi, qj !< ion charge
      real(wp) :: Q_j    !< electrode charge
      real(wp) :: muiz, mujz
      real(wp) :: volfactor
      real(wp) :: zij, zijsq, erf_ij,exp_ij
      real(wp) :: fij, fiz
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha,sqrpi
      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      sqrpi = sqrt(pi)
      alphapi = 2.0_wp * alpha / sqrpi
      sqrpialpha = sqrpi / alpha

      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), q_elec(:), dipolez(:), force(:,:))

      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            qi = ions(itype)%charge
            qj = ions(jtype)%charge
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, fij, fiz)
               do i = istart, iend
                  fiz = 0.0_wp
                  muiz = dipolez(i)
                  !$acc loop reduction(+:fiz)
                  do j = jstart, jend
                     mujz = dipolez(j)
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     exp_ij = exp(-zijsq*alphasq)
                     fij = qi * qj * pi * volfactor * erf_ij   &
                     -2.0_wp*volfactor*exp_ij*sqrpi*alpha*(qj*muiz - qi*mujz)  &
                     +4.0_wp*volfactor*zij*alphasq*alpha*sqrpi*muiz*mujz*exp_ij
                     fiz = fiz + fij
                     !$acc atomic update
                     force(j,3) = force(j,3) + fij
                  end do
                  !$acc end loop
                  !$acc atomic update
                  force(i,3) = force(i,3) - fiz
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, &
            offset_n, count_n, istart, iend)
            !$acc parallel loop private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, fij, fiz)
            do i = istart, iend
               fiz = 0.0_wp
               muiz = dipolez(i)
               !$acc loop reduction(+:fiz)
               do j = istart, iend
                  mujz = dipolez(j)
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(alpha*zij)
                  exp_ij = exp(-zijsq*alphasq)
                  fij = qi * qj * pi * volfactor * erf_ij  &
                  -2.0_wp*volfactor*exp_ij*sqrpi*alpha*(qj*muiz - qi*mujz) &
                  +4.0_wp*volfactor*zij*alphasq*alpha*sqrpi*muiz*mujz*exp_ij
                  fiz = fiz + fij
               end do
               !$acc end loop
               !$acc atomic update
               force(i,3) = force(i,3) - fiz
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)
         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            !$acc parallel loop private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, fij, fiz)
            do i = istart, iend
               fiz = 0.0_wp
               muiz = dipolez(i)
               !$acc loop reduction(+:fiz)
               do j = jstart, jend
                  mujz = dipolez(j)
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(alpha*zij)
                  exp_ij = exp(-zijsq*alphasq)
                  fij = qi * qj * pi * volfactor * erf_ij &
                        -2.0_wp*volfactor*exp_ij*sqrpi*alpha*(qj*muiz - qi*mujz) &
                        +4.0_wp*volfactor*zij*alphasq*alpha*sqrpi*muiz*mujz*exp_ij
                  fiz = fiz + fij
                  !$acc atomic update
                  force(j,3) = force(j,3) + fij
               end do
               !$acc end loop
               !$acc atomic update
               force(i,3) = force(i,3) - fiz
            end do
            !$acc end parallel loop
         end do

         qi = ions(itype)%charge
         do jtype = 1, num_elec_types
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset
            ! Number of blocks with full atom2ion interactions
            num_block_full = localwork%pair_atom2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_atom2ion_full_iblock_offset(itype, jtype)
            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop private(muiz, Q_j, zij, zijsq, erf_ij, exp_ij, fij, fiz)
               do i = istart, iend
                  fiz = 0.0_wp
                  muiz = dipolez(i)
                  !$acc loop reduction(+:fiz)
                  do j = jstart, jend
                     Q_j = q_elec(j)
                     zij = xyz_atoms(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(alpha*zij)
                     exp_ij = exp(-zijsq*alphasq)
                     fij = volfactor*pi*erf_ij*qi*Q_j - 2.0_wp*volfactor*exp_ij*sqrpi*alpha*muiz*Q_j
                     fiz = fiz + fij
                  end do
                  !$acc end loop
                  !$acc atomic update
                  force(i,3) = force(i,3) - fiz
               end do
               !$acc end parallel loop
            end do
         end do
      end do
      !$acc end data
   end subroutine melt_forces

   !================================================================================
   ! Compute the contibution to the energy from long-range Coulomb interaction
   subroutine energy(localwork, ewald, box, ions, xyz_ions, &
      electrodes, xyz_atoms, q_elec, h, dipolez)
      implicit none

      ! Parameters in
      ! -------------
      type(MW_localwork_t), intent(in) :: localwork       !< Local work assignment
      type(MW_ewald_t),     intent(in) :: ewald          !< Ewald summation parameters
      type(MW_box_t),       intent(in) :: box            !< Simulation box parameters
      type(MW_ion_t),       intent(in) :: ions(:)        !< ions parameters
      real(wp),             intent(in) :: xyz_ions(:,:)  !< ions xyz positions
      type(MW_electrode_t), intent(in) :: electrodes(:)   !< electrode parameters
      real(wp),             intent(in) :: xyz_atoms(:,:)  !< electrode atoms xyz positions
      real(wp),             intent(in) :: q_elec(:)      !< Electrode atoms charge
      real(wp),             intent(in) :: dipolez(:)      !< z-component of the dipole

      ! Parameters out
      ! --------------
      real(wp), intent(inout) :: h !< Energy

      ! Local
      ! -----
      integer :: num_ion_types, num_elec_types
      integer :: i, j, itype, jtype
      real(wp) :: qi, qj !< ion charge
      real(wp) :: Q_j !< electrode charge
      real(wp) :: muiz, mujz
      real(wp) :: volfactor
      real(wp) :: zij, zijsq
      real(wp) :: erf_ij,exp_ij
      real(wp) :: pot_ij, vsumzk0
      real(wp) :: alpha, alphasq, alphapi, sqrpialpha,sqrpi

      integer :: num_block_diag, num_block_full
      integer :: iblock, iblock_offset, istart, iend, jstart, jend
      integer :: count_n, offset_n, count_m, offset_m

      num_ion_types = size(ions,1)
      num_elec_types = size(electrodes,1)

      ! Precompute some factors
      ! -----------------------
      alpha = ewald%alpha
      alphasq = alpha*alpha
      sqrpi = sqrt(pi)
      alphapi = 2.0_wp*alpha/sqrpi
      sqrpialpha = sqrpi/alpha

      ! Zero energy
      ! ----------------
      h = 0.0_wp
      vsumzk0 = 0.0_wp
      ! Long range contribution from k=0 mode
      ! -------------------------------------
      ! Normalization
      volfactor = 2.0_wp/box%area(3)

      !$acc data present(xyz_ions(:,3), xyz_atoms(:,3), dipolez(:), q_elec(:)) copy(vsumzk0)

      ! Melt -> Melt and Elec -> Melt interactions
      ! ------------------------------------------
      do itype = 1, num_ion_types
         count_n = ions(itype)%count
         offset_n = ions(itype)%offset
         qi = ions(itype)%charge
         do jtype = 1, itype - 1
            count_m = ions(jtype)%count
            offset_m = ions(jtype)%offset
            qj = ions(jtype)%charge
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_ion2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock+iblock_offset, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)

               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     muiz = dipolez(i)
                     mujz = dipolez(j)
                     zij = xyz_ions(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(zij*alpha)
                     exp_ij = exp(-zijsq*alphasq)
                     pot_ij = (sqrpialpha*exp_ij + pi*zij*erf_ij)
                     ! The minus sign for qmu term arises from the different definition of zij
                     ! w.r.t. Pounds PhD (erf is an impair function)
                     vsumzk0 = vsumzk0 + qi * qj * pot_ij &
                     -pi*(qj*muiz - qi*mujz)*erf_ij   &
                     -2.0_wp*muiz*mujz*alpha*sqrpi*exp_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do

         ! Blocks on the diagonal compute only half of the pair interactions
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_diag = localwork%pair_ion2ion_num_block_diag_local(itype)
         iblock_offset = localwork%pair_ion2ion_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock_offset+iblock, offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, pot_ij)
            do i = istart, iend
               do j = istart, iend
                  muiz = dipolez(i)
                  mujz = dipolez(j)
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(zij*alpha)
                  exp_ij = exp(-zijsq*alphasq)
                  pot_ij = (sqrpialpha*exp_ij + pi*zij*erf_ij)
                  ! The minus sign for qmu term arises from the different definition of zij
                  ! w.r.t. Pounds PhD (erf is an impair function)
                  vsumzk0 = vsumzk0 + 0.5_wp*(qi * qj * pot_ij &
                  -pi*(qj*muiz - qi*mujz)*erf_ij   &
                  -2.0_wp*muiz*mujz*alpha*sqrpi*exp_ij)
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         qi = ions(itype)%charge
         qj = ions(itype)%charge
         num_block_full = localwork%pair_ion2ion_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_ion2ion_full_iblock_offset(itype,itype)

         do iblock = 1, num_block_full
            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(muiz, mujz, zij, zijsq, erf_ij, exp_ij, pot_ij)
            do i = istart, iend
               do j = jstart, jend
                  muiz = dipolez(i)
                  mujz = dipolez(j)
                  zij = xyz_ions(j,3) - xyz_ions(i,3)
                  zijsq = zij*zij
                  erf_ij = erf(zij*alpha)
                  exp_ij = exp(-zijsq*alphasq)
                  pot_ij = (sqrpialpha*exp_ij + pi*zij*erf_ij)
                  ! The minus sign for qmu term arises from the different definition of zij
                  ! w.r.t. Pounds PhD (erf is an impair function)
                  vsumzk0 = vsumzk0 + qi * qj * pot_ij &
                        -pi*(qj*muiz - qi*mujz)*erf_ij   &
                        -2.0_wp*muiz*mujz*alpha*sqrpi*exp_ij
               end do
            end do
            !$acc end parallel loop
         end do

         !qi -> point charge (melt)
         !muiz -> z-component of dipoles (melt)
         !Q_j -> integrated gaussian charge (walls)
         qi = ions(itype)%charge
         do jtype = 1, num_elec_types
            count_m = electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset
            ! Number of blocks with full ion2ion interactions
            num_block_full = localwork%pair_atom2ion_num_block_full_local(itype, jtype)
            iblock_offset = localwork%pair_atom2ion_full_iblock_offset(itype, jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock+iblock_offset, &
               offset_n, count_n, offset_m, count_m, &
               istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(muiz, Q_j, zij, zijsq, erf_ij, exp_ij, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     muiz = dipolez(i)
                     Q_j = q_elec(j)
                     zij = xyz_atoms(j,3) - xyz_ions(i,3)
                     zijsq = zij*zij
                     erf_ij = erf(zij*alpha)
                     exp_ij = exp(-zijsq*alphasq)
                     pot_ij = (sqrpialpha*exp_ij + pi*zij*erf_ij)
                     vsumzk0 = vsumzk0 + qi*Q_j*pot_ij &
                           -pi*Q_j*muiz*erf_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do
      end do

      ! Elec 2 Elec interactions
      ! ------------------------
      ! Blocks on the diagonal compute only half of the pair interactions
      do itype = 1, num_elec_types
         count_n = electrodes(itype)%count
         offset_n = electrodes(itype)%offset
         do jtype = 1, itype-1
            count_m =  electrodes(jtype)%count
            offset_m = electrodes(jtype)%offset

            ! Number of blocks with full interactions (below the diagonal
            num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,jtype)
            iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,jtype)

            do iblock = 1, num_block_full
               call update_other_block_boundaries(iblock_offset+iblock, &
               offset_n, count_n, offset_m, count_m, istart, iend, jstart, jend)
               !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
               do i = istart, iend
                  do j = jstart, jend
                     zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                     zijsq = zij*zij
                     pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                     vsumzk0 = vsumzk0 + q_elec(i) * q_elec(j) * pot_ij
                  end do
               end do
               !$acc end parallel loop
            end do
         end do

         num_block_diag = localwork%pair_atom2atom_num_block_diag_local(itype)
         iblock_offset = localwork%pair_atom2atom_diag_iblock_offset(itype)

         do iblock = 1, num_block_diag
            call update_diag_block_boundaries(iblock+iblock_offset, &
            offset_n, count_n, istart, iend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = istart, iend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + 0.5_wp * q_elec(i) * q_elec(j) * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do

         ! Number of blocks with full interactions (below the diagonal
         num_block_full = localwork%pair_atom2atom_num_block_full_local(itype,itype)
         iblock_offset = localwork%pair_atom2atom_full_iblock_offset(itype,itype)

         do iblock = 1, num_block_full

            call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
            istart, iend, jstart, jend)
            !$acc parallel loop collapse(2) reduction(+:vsumzk0) private(zij, zijsq, pot_ij)
            do i = istart, iend
               do j = jstart, jend
                  zij = xyz_atoms(j,3) - xyz_atoms(i,3)
                  zijsq = zij*zij
                  pot_ij = (sqrpialpha*exp(-zijsq*alphasq) + pi*zij*erf(zij*alpha))
                  vsumzk0 = vsumzk0 + q_elec(i) * q_elec(j) * pot_ij
               end do
            end do
            !$acc end parallel loop
         end do
      end do
      !$acc end data

      ! scale by volume factor
      h = -vsumzk0 * volfactor

   end subroutine energy

   include 'update_diag_block_boundaries.inc'
   include 'update_tri_block_boundaries.inc'
   include 'update_other_block_boundaries.inc'

end module MW_coulomb_keq0_pim

module MW_kinds
   ! Define kinds parameters for use throughout the code

   ! This modules defines four real kinds parameters (real4, real8,
   ! real10, real16), five integer kinds parameters (int1, int2, int4, int8, int16)
   !

   ! GNU Fortran compiler 4.8.4
   ! --------------------------

   ! kind  | digits | radix | range | huge
   ! ------+--------+-------+-------+-----
   ! int1  |      7 |     2 |     2 | 2^7   - 1 = 127
   ! int2  |     15 |     2 |     4 | 2^15  - 1 = 32767
   ! int4  |     31 |     2 |     9 | 2^31  - 1 = 2147483647
   ! int8  |     63 |     2 |    18 | 2^63  - 1 = 9223372036854775807
   ! int16 |    127 |     2 |    38 | 2^127 - 1 = 170141183460469231731687303715884105727 = 1.7e38

   ! kind  | dig | rad | range | prec |  max |  min |   epsilon   |     huge    |    tiny     |
   !       |     |     |       |      |  exp |  exp |             |             |             |
   ! ------+-----+-----+-------+------+-----+-----+-------------+-------------+-------------+-
   ! real4 |  24 |   2 |    37 |    6 |  128 | -125 | 1.19209E-07 | 3.40282E+38 | 1.17549E-38 |
   ! real8 |  53 |   2 |   307 |   15 | 1024 |-1021 | 2.22044E-16 | 1.79769E+308| 2.2250E-308 |
   ! real10|  64 |   2 |  4931 |   18 | 16384|-16381| 1.08420E-19 | 1.1893E+4932| 3.362E-4932 |
   ! real16| 113 |   2 |  4931 |   33 | 16384|-16381| 1.92592E-34 | 1.1897E+4932| 3.362E-4932 |

   ! See at the end of this file for a complete description of the
   ! integer and real representation model in Fortran.

   use iso_fortran_env, only: output_unit

   implicit none
   private

   public :: real4, real8  ! real kind parameters
   public :: sp, dp, wp        ! real kind parameters alias

#ifdef MW_use_real16
   public :: real16, qd  ! real kind parameters and alias
#endif
#ifdef MW_use_real10
   public :: real10, ep  ! real kind parameters and alias
#endif

   public :: int1, int2, int4, int8        ! integer kind parameters
#ifdef MW_USE_INT16
   public :: int16 ! integer kind parameters
#endif
   public :: kinds_inquire                 ! subroutine to print out number model parameters
   public :: PARTICLE_NAME_LEN


   ! real kind parameters
   integer, parameter :: real4 = selected_real_kind(p=6)
   integer, parameter :: real8 = selected_real_kind(p=15)
#ifdef MW_use_real10
   integer, parameter :: real10 = selected_real_kind(p=18)
#endif
#ifdef MW_use_real16
   integer, parameter :: real16 = selected_real_kind(p=33)
#endif
   ! real kind parameters alias
   integer, parameter :: sp = real4  ! 32 bits  single precision (equivalent to real default)
   integer, parameter :: dp = real8  ! 64 bits  double precision (equivalent to double precision)
#ifdef MW_use_real10
   integer, parameter :: ep = real10 ! 80 bits  extended precision
#endif
#ifdef MW_use_real16
   integer, parameter :: qd = real16 ! 128 bits quadruple precision
#endif
   ! integer kind parameters
   integer, parameter :: int1 = selected_int_kind(r=2)
   integer, parameter :: int2 = selected_int_kind(r=4)
   integer, parameter :: int4 = selected_int_kind(r=9)
   integer, parameter :: int8 = selected_int_kind(r=18)
#ifdef MW_USE_INT16
   integer, parameter :: int16 = selected_int_kind(r=38)
#endif

   ! working kind parameters
   integer, parameter :: wp = dp

   ! format specification to show real values with full precision
   character(len=8), parameter :: real4_fmt = "es12.5e2"
   character(len=9), parameter :: real8_fmt = "es22.14e3"
#ifdef MW_use_real10
   character(len=9), parameter :: real10_fmt = "es26.17e4"
#endif
#ifdef MW_use_real16
   character(len=9), parameter :: real16_fmt = "es41.32e4"
#endif

   ! format specification to show integer values with full precision
   character(len=2), parameter :: int1_fmt = "i4"
   character(len=2), parameter :: int2_fmt = "i5"
   character(len=3), parameter :: int4_fmt = "i10"
   character(len=3), parameter :: int8_fmt = "i19"
#ifdef MW_USE_INT16
   character(len=3), parameter :: int16_fmt = "i39"
#endif

   ! generic interface to kinds_inquire subroutines
   interface kinds_inquire
      module procedure kinds_inquire_real4
      module procedure kinds_inquire_real8
#ifdef MW_use_real10
      module procedure kinds_inquire_real10
#endif
#ifdef MW_use_real16
      module procedure kinds_inquire_real16
#endif
      module procedure kinds_inquire_int1
      module procedure kinds_inquire_int2
      module procedure kinds_inquire_int4
      module procedure kinds_inquire_int8
#ifdef MW_USE_INT16
      module procedure kinds_inquire_int16
#endif
   end interface kinds_inquire

   ! character length
   integer, parameter :: PARTICLE_NAME_LEN = 8

contains

   subroutine kinds_inquire_real4(x, funit)
      real(kind=real4),  intent(in) :: x
      integer, optional, intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for real(kind=real4):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  precision(x)   = ", i9)') precision(x)
      write(ounit,'("  maxexponent(x) = ", i9)') maxexponent(x)
      write(ounit,'("  minexponent(x) = ", i9)') minexponent(x)
      write(ounit,'("  epsilon(x)     = ",'// real4_fmt //')') epsilon(x)
      write(ounit,'("  huge(x)        = ",'// real4_fmt //')') huge(x)
      write(ounit,'("  tiny(x)        = ",'// real4_fmt //')') tiny(x)
      write(ounit,*)

   end subroutine kinds_inquire_real4

   subroutine kinds_inquire_real8(x, funit)
      real(kind=real8), intent(in) :: x
      integer, optional, intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for real(kind=real8):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  precision(x)   = ", i9)') precision(x)
      write(ounit,'("  maxexponent(x) = ", i9)') maxexponent(x)
      write(ounit,'("  minexponent(x) = ", i9)') minexponent(x)
      write(ounit,'("  epsilon(x)     = ",'// real8_fmt //')') epsilon(x)
      write(ounit,'("  huge(x)        = ",'// real8_fmt //')') huge(x)
      write(ounit,'("  tiny(x)        = ",'// real8_fmt //')') tiny(x)
      write(ounit,*)

   end subroutine kinds_inquire_real8

#ifdef MW_USE_real10
   subroutine kinds_inquire_real10(x, funit)
      real(kind=real10), intent(in) :: x
      integer, optional, intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for real(kind=real10):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  precision(x)   = ", i9)') precision(x)
      write(ounit,'("  maxexponent(x) = ", i9)') maxexponent(x)
      write(ounit,'("  minexponent(x) = ", i9)') minexponent(x)
      write(ounit,'("  epsilon(x)     = ",'// real10_fmt //')') epsilon(x)
      write(ounit,'("  huge(x)        = ",'// real10_fmt //')') huge(x)
      write(ounit,'("  tiny(x)        = ",'// real10_fmt //')') tiny(x)
      write(ounit,*)

   end subroutine kinds_inquire_real10
#endif
#ifdef MW_use_real16
   subroutine kinds_inquire_real16(x, funit)
      real(kind=real16), intent(in) :: x
      integer, optional, intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for real(kind=real16):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  precision(x)   = ", i9)') precision(x)
      write(ounit,'("  maxexponent(x) = ", i9)') maxexponent(x)
      write(ounit,'("  minexponent(x) = ", i9)') minexponent(x)
      write(ounit,'("  epsilon(x)     = ",'// real16_fmt //')') epsilon(x)
      write(ounit,'("  huge(x)        = ",'// real16_fmt //')') huge(x)
      write(ounit,'("  tiny(x)        = ",'// real16_fmt //')') tiny(x)
      write(ounit,*)

   end subroutine kinds_inquire_real16
#endif

   subroutine kinds_inquire_int1(x, funit)
      integer(kind=int1), intent(in) :: x
      integer, optional,  intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for integer(kind=int1):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  huge(x)        = ",'// int1_fmt //')') huge(x)
      write(ounit,*)

   end subroutine kinds_inquire_int1

   subroutine kinds_inquire_int2(x, funit)
      integer(kind=int2), intent(in) :: x
      integer, optional,  intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for integer(kind=int2):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  huge(x)        = ",'// int2_fmt //')') huge(x)
      write(ounit,*)

   end subroutine kinds_inquire_int2

   subroutine kinds_inquire_int4(x, funit)
      integer(kind=int4), intent(in) :: x
      integer, optional,  intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for integer(kind=int4):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  huge(x)        = ",'// int4_fmt //')') huge(x)
      write(ounit,*)

   end subroutine kinds_inquire_int4

   subroutine kinds_inquire_int8(x, funit)
      integer(kind=int8), intent(in) :: x
      integer, optional,  intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for integer(kind=int8):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  huge(x)        = ",'// int8_fmt //')') huge(x)
      write(ounit,*)

   end subroutine kinds_inquire_int8

#ifdef MW_USE_INT16
   subroutine kinds_inquire_int16(x, funit)
      integer(kind=int16), intent(in) :: x
      integer, optional,   intent(in) :: funit

      integer :: ounit

      if (present(funit)) then
         ounit = funit
      else
         ounit = output_unit
      end if

      write(ounit,'("Model parameters for integer(kind=int16):")')
      write(ounit,'("  digits(x)      = ", i9)') digits(x)
      write(ounit,'("  radix(x)       = ", i9)') radix(x)
      write(ounit,'("  range(x)       = ", i9)') range(x)
      write(ounit,'("  huge(x)        = ",'// int16_fmt //')') huge(x)
      write(ounit,*)

   end subroutine kinds_inquire_int16
#endif
end module MW_kinds


! "The Fortran 2003 Handbook
! The Complete Syntax, Features and Procedures"
! Jeanne C. Adams, Walter S. Brainerd, Richard A. Hendrickson, Richard
! E. Maine, Jeanne T. Martin, Brian T. Smith
! Springer
! DOI: 10.1007/978-1-84628-746-6
!
! Representation Models
! =====================

! Some of the intrinsic functions compute values related to how data
! is represented.  These values are based upon and determined by the
! underlying *representation model*.  There are three such models :
! the *bit model*, the *integer number system model*, and the *real
! number system model*.

! These models, and the corresponding functions, return values related
! to the models, allowing development of robust and portable code.
! For example, by obtaining information about the spacing of real
! numbers, the convergence of a numerical algorithm can be controlled
! so that maximum accuracy may be achieved while attaining
! convergence.

! In a given implementation the model parameters are chosen to match
! the implementation as closely as possible, but an exact match is not
! required and the model does not impose any particular arithmetic on
! the implementation.

! The Integer Number System Model
! -------------------------------

! The integer number system is modeled by
!
! i = s * sum_{k=0}^{q-1}(w_k * r^k)
!
! where
!
!   i   is the integer value
!   s   is the sign (+1 or -1)
!   r   is the base and is an integer greater than 1
!   q   is the number of digits and is an integer greater than 0
!   w_k is the kth digit and is an integer in [0,r[
!
! A common model for processors that use 4 bytes for integers is: q=31
! and r=2.

! The Real Number System Model
! ----------------------------

! The real number system is modeled by
!
! x = s * b^e * sum_{k=1}^{p}(f_k * b^{-k})
!
! where
!
!   x   is the real value
!   s   is the sign (+1 or -1)
!   b   is the base (real radix) and is an integer greater than 1
!   e   is an integer between some minimum and maximum value
!   p   is the number of mantissa digits and is an integer greater than 1
!   f_k is the kth digit and is an integer in [0,b[
!          but f_1 may be zero only if e and all the f_k are zero

! One common implementation is the IEEE binary floating-point standard
! which has single precision model numbers with:

!   b = 2
!   p = 24
!   -125 <= e <= 128

! This IEEE standard does not represent f_1, which is presumed to be
! 1. Thus, the mantissa, including its sign, can be represented in 24
! bits. The exponent, including its sign, takes 8 bits, for a total of
! 32 bits in the single precision representation.  What normally would
! be an exponent value of -127 or -126 is not included in the exponent
! range; rather, IEEE uses these cases to identify the real value zero
! (the one case in which f_1 is 0), out-of-range values (infinites),
! or NaNs (not a number, illegal values). It should be noted that the
! specific model described above where b=2, p=24, e_max=128 and
! e_min=-125 is not the specific model used in the Fortran 2003
! standard where b=2, p=24, e_min=-126 and e_max=127.

! The numeric inquiry and manipulation functions return information
! about the real number system model pertaining to an
! implementation. The IEEE intrinsic module procedures permit a more
! precise manipulation of floating-point values that are of IEEE
! (arithmetic type). On the other hand, the numeric computation and
! manipulation intrinsic functions assume or in some cases specify
! that the results are processor dependent when the result value would
! exceed the range of floating-point representable values.

module MW_lookup_table
   use MW_kinds, only: wp
   implicit none
   private

   ! Public type
   ! -----------
   public :: MW_lut_t

   ! Public subroutines
   ! ------------------
   public :: lut_init
   public :: lut_void
   public :: lut_push
   public :: lut_push_energies
   public :: lut_get
   public :: lut_check
   public :: lut_set
   public :: lut_set_all
   public :: lut_print
   public :: CHARLENGTH

   integer,               parameter   :: CHARLENGTH = 128

   type MW_lut_t
     character(CHARLENGTH), allocatable :: keys(:)
     real(wp),              allocatable :: values(:)
     integer                            :: lut_index
   end type MW_lut_t

contains

   subroutine lut_init(this, nb_items)
      type(MW_lut_t), intent(inout) :: this
      integer, intent(in)  :: nb_items
      integer              :: status
      allocate(this%keys(nb_items), stat=status)
      allocate(this%values(nb_items), stat=status)
      this%lut_index = 0 
   end subroutine lut_init
 
   subroutine lut_void(this)
      type(MW_lut_t), intent(inout) :: this
      integer              :: status
      deallocate(this%keys, stat=status)
      deallocate(this%values, stat=status)
      this%lut_index = -1 
   end subroutine lut_void
 
   subroutine lut_push(this, key, value)
      type(MW_lut_t), intent(inout) :: this
      character(*), intent(in)      :: key
      real(wp)        , intent(in)  :: value
      
      this%lut_index = this%lut_index + 1
      if(this%lut_index > Size(this%keys, 1)) call print_error("Error: table is already full")
      
      this%keys(this%lut_index) = key
      this%values(this%lut_index) = value
   end subroutine lut_push
 
   subroutine lut_push_energies(this, value)
      type(MW_lut_t), intent(inout) :: this
      real(wp)        , intent(in)  :: value
      call lut_push(this, "Hamiltonian", value) ! previously energy(1)
      call lut_push(this, "Kinetic", value)      ! previously energy(2)
      call lut_push(this, "Potential", value)      ! previously energy(3)
      call lut_push(this, "Coulomb", value)      ! previously energy(4)
      call lut_push(this, "Intramolecular", value)      ! previously energy(5)
      call lut_push(this, "van_der_Waals", value)      ! previously energy(6)
      call lut_push(this, "Total", value)      ! previously energy(7)
      call lut_push(this, "Thermostat", value)      ! previously energy(8)
      call lut_push(this, "Barostat", value)      ! 
      call lut_push(this, "Coulomb_lr", value)      ! previously energy(9)
      call lut_push(this, "Coulomb_keq0", value)      ! previously energy(10)
      call lut_push(this, "Coulomb_sr", value)      ! previously energy(11)
      call lut_push(this, "Coulomb_self", value)      ! previously energy(12)
      call lut_push(this, "Coulomb_molecule", value)      ! previously energy(13)
      call lut_push(this, "Harmonic_bond", value)      ! previously energy(14)
      call lut_push(this, "Harmonic_angle", value)      ! previously energy(15)
      call lut_push(this, "Dihedrals", value)      ! previously energy(16)
      call lut_push(this, "Fumi-Tosi", value)      ! previously energy(17)
      call lut_push(this, "Fumi-Tosi_molecule", value)      ! previously energy(18)
      call lut_push(this, "XFT", value)      ! previously energy(17)
      call lut_push(this, "XFT_molecule", value)      ! previously energy(18)
      call lut_push(this, "Lennard-Jones", value)      ! previously energy(19)
      call lut_push(this, "Lennard-Jones_cutoff", value)      ! previously energy(20)
      call lut_push(this, "DAIM", value)      ! previously energy(21)
      call lut_push(this, "DAIM_self", value)      ! previously energy(22)
      call lut_push(this, "Piston_work", value)      ! previously energy(23)
      call lut_push(this, "Plumed_bias", value) 
      call lut_push(this, "Thomas_Fermi", value) 
      call lut_push(this, "External_field", value) 
      call lut_push(this, "Steele", value) 
   end subroutine lut_push_energies
 
   subroutine lut_set(this, key, value)
      type(MW_lut_t), intent(inout) :: this
      character(*), intent(in)     :: key
      real(wp)        , intent(in)     :: value
      integer                      :: local_index
      logical                      :: found
      
      found = .FALSE. 
      if(this%lut_index .lt. Size(this%keys, 1)) call print_error("Error: the table is not yet full") 
      
      do local_index = 1,Size(this%keys,1)
        if(trim(this%keys(local_index)) == trim(key)) THEN 
          this%values(local_index) = value
          found = .TRUE.
        endif
      enddo 
      
      if(.NOT.found) call print_error("Unknown key "//key)
   end subroutine lut_set
 
   subroutine lut_set_all(this, value)
      type(MW_lut_t), intent(inout) :: this
      real(wp)     , intent(in)     :: value
      integer                      :: local_index
      
      do local_index = 1,Size(this%keys,1)
          this%values(local_index) = value
      enddo 
   end subroutine lut_set_all
 
   function lut_get(this, key) result(value)
      type(MW_lut_t), intent(in) :: this
      character(*), intent(in)   :: key
      real(wp)                   :: value
      integer                    :: local_index
      logical                    :: found
      
      found = .FALSE. 
      if(this%lut_index .lt. Size(this%keys, 1)) call print_error("Error: the table is not yet full") 
      
      do local_index = 1,Size(this%keys,1)
        if(trim(this%keys(local_index)) == trim(key)) THEN 
          value = this%values(local_index)
          found = .TRUE.
        endif
      enddo 
      
      if(.NOT.found) call print_error("Unknown key "//key)
   end function lut_get
 
   subroutine lut_check(this, key, found)
      type(MW_lut_t), intent(in) :: this
      character(*), intent(in)   :: key
      integer                    :: local_index
      logical                    :: found
      
      found = .FALSE. 
      if(this%lut_index .lt. Size(this%keys, 1)) call print_error("Error: the table is not yet full") 
      
      do local_index = 1,Size(this%keys,1)
        if(trim(this%keys(local_index)) == trim(key)) THEN 
          found = .TRUE.
        endif
      enddo 
      
   end subroutine lut_check
 
   subroutine lut_print(this)
      type(MW_lut_t), intent(in) :: this
      integer  :: local_index 
      
      print*, "Contents of the luttable:"
      do local_index = 1,Size(this%keys,1)
        print*, trim(this%keys(local_index)), " = ", this%values(local_index)
      enddo
   end subroutine lut_print
 
   subroutine print_error(text)
      character(*) :: text
      print*, text
      STOP
   end subroutine print_error
end module MW_lookup_table

module MW_electrode_charge
#ifndef MW_SERIAL
   use MPI
#endif
   use MW_parallel, only: MW_COMM_WORLD
   use MW_stdio
   use MW_timers
   use MW_kinds, only: wp
   use MW_algorithms, only: MW_algorithms_t
   use MW_cg, only: MW_cg_t
   use MW_system, only: MW_system_t
   use MW_electrode, only: MW_electrode_t
   use MW_external_field, only: MW_external_field_t, &
        FIELD_TYPE_ELECTRIC, FIELD_TYPE_DISPLACEMENT
   use MW_thomas_fermi, only: MW_thomas_fermi_t
   use MW_ion, only: MW_ion_t

  implicit none
  private

  ! Public subroutines
  ! ------------------
  public :: compute_jacobi_precond
  public :: compute
  public :: predictor

contains

  !================================================================================
  ! Evaluate b, the potential on electrode atoms due to melt ions
  subroutine setup_b(system, algorithms)
    use MW_coulomb, only: &
         MW_coulomb_qmelt2Qelec_potential => qmelt2Qelec_potential
     use MW_external_field, only: &
         MW_external_field_Efield_elec_potential => Efield_elec_potential, &
         MW_external_field_Dfield_elec_potentialb => Dfield_elec_potentialb
    implicit none
    ! Parameters
    ! ----------
    type(MW_system_t), intent(inout) :: system
    type(MW_algorithms_t), intent(inout) :: algorithms

    ! Locals
    ! ------
    integer :: xyz_now
    integer :: ei, i
    real(wp) :: Vi

    !$acc data &
    !$acc present(system, system%electrodes(:), system%coulomb_potential_atoms(:,:), &
    !$acc         algorithms, algorithms%cg, algorithms%cg%b(:), &
    !$acc        algorithms%matrix_inversion, &
    !$acc        algorithms%matrix_inversion%b(:),algorithms%matrix_inversion%A(:,:), &
    !$acc        algorithms%matrix_inversion%Ainv(:,:),algorithms%matrix_inversion%Ax(:), &
    !$acc        algorithms%matrix_inversion%q0(:))    

    xyz_now = system%xyz_ions_step(1)

    call MW_coulomb_qmelt2Qelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
            system%ions, system%xyz_ions(:,:,xyz_now), system%type_ions, &
            system%electrodes, system%xyz_atoms, system%coulomb_potential_atoms)

    if (system%field%field_type == FIELD_TYPE_ELECTRIC) then
       call MW_external_field_Efield_elec_potential(system%field, &
            system%electrodes, system%xyz_atoms, system%external_field_potential_atoms(:,FIELD_TYPE_ELECTRIC,1))
    else if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
       call MW_external_field_Dfield_elec_potentialb(system%field, &
            system%electrodes, system%xyz_atoms, system%polarization_field, &
            system%external_field_potential_atoms(:,FIELD_TYPE_DISPLACEMENT,1))
    endif

    do ei = 1, system%num_elec                ! loop over each electrode wall
       Vi = system%electrodes(ei)%V           ! potential applied on the electrode
       if (algorithms%maze%calc_elec) then
          !$acc parallel
          !$acc loop
          do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
             algorithms%maze%const_constr(i) = (-Vi + &
                  (system%coulomb_potential_atoms(i,1) + &
                   system%coulomb_potential_atoms(i,2) + &
                   system%coulomb_potential_atoms(i,3) + &
                   system%external_field_potential_atoms(i, FIELD_TYPE_ELECTRIC,1)+ &
                   system%external_field_potential_atoms(i, FIELD_TYPE_DISPLACEMENT,1)))
          end do
          !$acc end loop
          !$acc end parallel
       else if (algorithms%matrix_inversion%calc_elec) then
          !$acc parallel
          !$acc loop
          do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
             algorithms%matrix_inversion%b(i) = Vi - &
                  (system%coulomb_potential_atoms(i,1) + &
                   system%coulomb_potential_atoms(i,2) + &
                   system%coulomb_potential_atoms(i,3) + &
                   system%external_field_potential_atoms(i, FIELD_TYPE_ELECTRIC,1)+ &
                   system%external_field_potential_atoms(i, FIELD_TYPE_DISPLACEMENT,1))
          end do
          !$acc end loop
          !$acc end parallel
       else
          !$acc parallel
          !$acc loop
          do i = system%electrodes(ei)%offset+1, system%electrodes(ei)%offset + system%electrodes(ei)%count
             algorithms%cg%b(i) = Vi - &
                  (system%coulomb_potential_atoms(i,1) + &
                   system%coulomb_potential_atoms(i,2) + &
                   system%coulomb_potential_atoms(i,3) + &
                   system%external_field_potential_atoms(i, FIELD_TYPE_ELECTRIC,1)+ &
                   system%external_field_potential_atoms(i, FIELD_TYPE_DISPLACEMENT,1))
          end do
          !$acc end loop
          !$acc end parallel
       end if
       if (system%electrode_charge_neutrality.and.algorithms%maze%calc_elec) then
          if (abs(system%total_ions_charge) > 1.0e-12_wp .and. system%global_charge_neutrality) then
             algorithms%maze%const_constr(system%num_atoms+1) = -system%total_ions_charge
          else
             algorithms%maze%const_constr(system%num_atoms+1) = 0.0_wp
          end if
       end if
    end do
    !$acc end data
  end subroutine setup_b

  !================================================================================
  ! Compute A*x, the potential on electrode atoms due to electrode atoms
  !
  subroutine apply_A(system, x, y)
    use MW_coulomb, only: &
         MW_coulomb_Qelec2Qelec_potential => Qelec2Qelec_potential
    use MW_external_field, only: &
         MW_external_field_Dfield_elec_potentialA => Dfield_elec_potentialA, &
         MW_external_field_elec_polarization => elec_polarization
    use MW_thomas_fermi, only: &
        MW_thomas_fermi_kinetic_elec_potential => kinetic_elec_potential
    implicit none
    ! Parameters
    ! ----------
    type(MW_system_t), intent(inout) :: system
    real(wp), intent(in) :: x(:)
    real(wp), intent(out) :: y(:)

    ! Locals
    ! ------
    integer :: i


    !$acc data &
    !$acc present(y, system, system%coulomb_potential_atoms)

    call MW_coulomb_Qelec2Qelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%electrodes, system%xyz_atoms, x, system%coulomb_potential_atoms)

    ! Compute the contribution due to the external electric displacement
    if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
       call MW_external_field_Dfield_elec_potentialA(system%box, system%field, &
            system%electrodes, system%xyz_atoms, x, system%polarization_field, &
            system%external_field_potential_atoms(:,FIELD_TYPE_DISPLACEMENT,2))
    endif
    ! Compute the quantum corrections to A * x in the Thomas-Fermi framework
    call MW_thomas_fermi_kinetic_elec_potential(system%thomas_fermi, &
         system%electrodes, x, system%quantum_potential_atoms(:,1))

    !$acc parallel loop
    do i = 1, system%num_atoms
       y(i) = (system%coulomb_potential_atoms(i,1) + &
            system%coulomb_potential_atoms(i,2) + &
            system%coulomb_potential_atoms(i,3) + &
            system%coulomb_potential_atoms(i,4) + &
            system%external_field_potential_atoms(i, FIELD_TYPE_DISPLACEMENT,2) + &
            system%quantum_potential_atoms(i,1))
    end do
    !$acc end parallel loop
    !$acc end data
  end subroutine apply_A

  subroutine compute_hessian(system, hessian)
     use MW_coulomb, only: &
         MW_coulomb_gradQelec_potential => gradQelec_potential
     use MW_errors, only: &
         MW_errors_allocate_error => allocate_error
     use MW_external_field, only: &
         MW_external_field_Dfield_gradQelec_potential => Dfield_gradQelec_potential
     use MW_thomas_fermi, only: &
         MW_thomas_fermi_kinetic_gradQelec_potential => kinetic_gradQelec_potential
     implicit none

     ! Parameters Input/Output
     ! -----------------------
     type(MW_system_t),  intent(inout) :: system
     real(wp), intent(out) :: hessian(:,:)

     !Locals
     !------
     integer  :: num_atoms
     integer  :: i, j

     num_atoms = system%num_atoms

     call MW_coulomb_gradQelec_potential(system%num_PBC,system%localwork,system%ewald,system%box, &
     system%electrodes, system%xyz_atoms, hessian(:,:))

     ! Compute the contribution due to the external electric displacement
     if (system%field%field_type == FIELD_TYPE_DISPLACEMENT) then
        call MW_external_field_Dfield_gradQelec_potential(system%box, system%field, &
             system%electrodes, system%xyz_atoms, system%q_atoms(:, system%q_atoms_step(1)), system%polarization_field, &
             hessian(:,:))
     endif

     call MW_thomas_fermi_kinetic_gradQelec_potential(system%thomas_fermi, &
          system%electrodes, hessian(:,:))

     do i = 1, num_atoms
        do j = 1, i-1
           hessian(i,j) = hessian(j,i)
        end do
     end do


  end subroutine compute_hessian

  ! Parallelized routine for computing matrix vector products invloving electrodes
  ! The matrix has to be Symmetric
  subroutine SMatrix_vector_product_elec(system, matrix, vector, matvec_product)

     implicit none

     ! Parameters Input
     ! ----------------
     type(MW_system_t), intent(in) :: system  !< system parameters
     real(wp),          intent(in) :: vector(:)
     real(wp),          intent(in) :: matrix(:,:)

     ! Parameters Output
     ! -----------------
     real(wp),          intent(out) :: matvec_product(:)

     !Locals
     !---------------
     integer  :: num_elec_types
     integer  :: iblock, iblock_offset, istart, iend, jstart, jend, itype, jtype
     integer  :: num_block_diag, num_block_full
     integer  :: count_n, offset_n, count_m, offset_m, count, ierr
     integer  :: i, j
     real(wp) :: matvec_product_i, vector_i

     call MW_timers_start(TIMER_MINQ_MATVEC)

     num_elec_types = size(system%electrodes,1)


     !$acc data present(matrix(:,:),vector(:),matvec_product(:))

     !$acc kernels
     matvec_product(:) = 0.0_wp
     !$acc end kernels
     ! Different kinds of electrodes - begin
     do itype = 1, num_elec_types
        count_n = system%electrodes(itype)%count
        offset_n = system%electrodes(itype)%offset
        do jtype = 1, itype-1
           count_m = system%electrodes(jtype)%count
           offset_m = system%electrodes(jtype)%offset

           ! Number of blocks with full interactions (below the diagonal)
           num_block_full = system%localwork%pair_atom2atom_num_block_full_local(itype,jtype)
           iblock_offset = system%localwork%pair_atom2atom_full_iblock_offset(itype,jtype)

           do iblock = 1, num_block_full
              call update_other_block_boundaries(iblock_offset+iblock, &
              offset_n, count_n, offset_m, count_m, &
              istart, iend, jstart, jend)
              !$acc parallel loop private(matvec_product_i,vector_i)
              do i = istart, iend
                 matvec_product_i = 0.0_wp
                 vector_i = vector(i)
                 !$acc loop reduction(+:matvec_product_i)
                 do j = jstart, jend
                    matvec_product_i = matvec_product_i + matrix(j,i)*vector(j)
                    !$acc atomic update
                    matvec_product(j) = matvec_product(j) + matrix(j,i)*vector_i
                 end do
                 !$acc end loop
                 matvec_product(i) = matvec_product(i) + matvec_product_i
              end do
              !$acc end parallel loop
           end do
        end do
        ! Different kinds of electrodes - end

        ! Same kind of electrodes - begin
        ! Blocks on the diagonal compute only half of the pair interactions
        num_block_diag = system%localwork%pair_atom2atom_num_block_diag_local(itype)
        iblock_offset = system%localwork%pair_atom2atom_diag_iblock_offset(itype)
        do iblock = 1, num_block_diag
           call update_diag_block_boundaries(iblock_offset+iblock, offset_n, count_n, istart,  iend)
           !$acc parallel loop private(matvec_product_i)
           do i = istart, iend
              matvec_product_i = 0.0_wp
              !$acc loop reduction(+:matvec_product_i)
              do j = istart, iend
                 matvec_product_i = matvec_product_i + matrix(j,i)*vector(j)
              end do
              !$acc end loop
              matvec_product(i) = matvec_product(i) + matvec_product_i
           end do
           !$acc end parallel loop
        end do

        ! Number of blocks with full interactions (below the diagonal)
        num_block_full = system%localwork%pair_atom2atom_num_block_full_local(itype,itype)
        iblock_offset = system%localwork%pair_atom2atom_full_iblock_offset(itype,itype)
        do iblock = 1, num_block_full
           call update_tri_block_boundaries(iblock_offset+iblock, offset_n, count_n, &
           istart, iend, jstart, jend)
           !$acc parallel loop private(matvec_product_i,vector_i)
           do i = istart, iend
              matvec_product_i = 0.0_wp
              vector_i = vector(i)
              !$acc loop reduction(+:matvec_product_i)
              do j = jstart, jend
                 matvec_product_i = matvec_product_i + matrix(j,i)*vector(j)
                 !$acc atomic update
                 matvec_product(j) = matvec_product(j) + matrix(j,i)*vector_i
              end do
              !$acc end loop
              matvec_product(i) = matvec_product(i) + matvec_product_i
           end do
           !$acc end parallel loop
        end do

     end do
     ! Same kind of electrodes - end

     !$acc update device(matvec_product(:))
     !$acc end data


#ifndef MW_SERIAL
     count = size(matvec_product,1)
     call MPI_Allreduce(MPI_IN_PLACE, matvec_product, count, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD,  ierr)
#endif
     call MW_timers_stop(TIMER_MINQ_MATVEC)

  end subroutine SMatrix_vector_product_elec

  subroutine vector_vector_inner_product_elec(system, vector_v, vector_w, inner_prod)
     implicit none

     ! Parameters Input
     ! ----------------
     type(MW_system_t), intent(in) :: system  !< system parameters
     real(wp),          intent(in) :: vector_v(:)
     real(wp),          intent(in) :: vector_w(:)

     ! Parameters Output
     ! -----------------
     real(wp),          intent(out) :: inner_prod

     !Locals
     !---------------
     integer  :: itype, i, iatom
     integer  :: num_elec_types
     integer  :: ierr

     inner_prod = 0.0_wp
     num_elec_types = size(system%electrodes, 1)

     do itype = 1, num_elec_types
        do i = 1, system%localwork%count_atoms(itype)
           iatom = system%localwork%offset_atoms(itype) + i
           inner_prod = inner_prod + vector_v(iatom)*vector_w(iatom)
        end do
     end do

#ifndef MW_SERIAL
      call MPI_Allreduce(MPI_IN_PLACE, inner_prod, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MW_COMM_WORLD, ierr)
#endif
  end subroutine vector_vector_inner_product_elec

  subroutine compute_jacobi_precond(system, algorithms)
     use MW_coulomb, only: &
     MW_coulomb_diag_gradQelec_potential => diag_gradQelec_potential
     implicit none

     type(MW_system_t), intent(inout) :: system
     type(MW_algorithms_t), intent(inout) :: algorithms

     integer :: n_atoms

     n_atoms = system%num_atoms

     call MW_coulomb_diag_gradQelec_potential(system%num_PBC, system%localwork, system%ewald, system%box, &
         system%electrodes, algorithms%cg%jacobi_precond(:))
  end subroutine compute_jacobi_precond

  !================================================================================
  !> Compute charges on electrode
  !!
  !! The charge is evaluated by minimizing the Coulomb energy of the system
  !!
  !! The energy can be cast into E = Q*AQ - Q*b + c
  !!
  !! where Q  is the vector of charges on the electrodes
  !!       b  is the potential felt by the electrode due to the melt ions
  !!       AQ is the potential felt by the electrode du to other electrode atoms
  !!       c  is the energy due to melt ions interactions
  !!       *  denotes the transpose of a vector/matrix
  !!
  !! By construction A is a matrix symmetric positive definite
  !! The preconditioned conjugate gradient algorithm is used to find a solution to
  !! the system
  !!
  subroutine compute(system, algorithms)
    use MW_cg, only: &
         MW_cg_solve_preconditioned => solve_preconditioned, &
         MW_cg_solve => solve
    use MW_maze, only: &
         MW_maze_compute_x0 => compute_x0, &
         MW_maze_update_history => update_history, &
         MW_maze_solve_invert => solve_invert, &
         MW_maze_solve_block_iterate => solve_block_iterate, &
         MW_maze_solve_CG_store => solve_CG_store, &
         MW_maze_solve_CG_nostore => solve_CG_nostore, &
         MW_maze_solve_shake => solve_shake
   use MW_matrix_inversion, only: &
        MW_matrix_inversion_solve => solve
    use MW_external_field, only: &
         MW_external_field_elec_polarization => elec_polarization
    implicit none

    ! Parameters in
    ! -------------
    type(mW_system_t), intent(inout) :: system !< system parameters
    !     type(mW_ion_t), intent(inout) :: ions(:)
    type(MW_algorithms_t), intent(inout) :: algorithms !< cg algorithm parameters

    ! Local
    ! -----
    integer :: i, itype
    integer :: q_atoms_tmdt, q_atoms_t, q_atoms_tpdt
    real(wp) :: total_charges, average_charges

    !$acc data &
    !$acc present (system, system%electrodes(:), system%q_atoms(:,:), &
    !$acc          algorithms, algorithms%cg, algorithms%cg%b, algorithms%cg%Ad)

    q_atoms_tpdt = system%q_atoms_step(1)
    q_atoms_t = system%q_atoms_step(2)
    if (algorithms%maze%calc_elec) q_atoms_tmdt = system%q_atoms_step(3)

    if (algorithms%constant_charge) then
       !$acc parallel
       !$acc loop     
       do itype = 1, system%num_elec
          !$acc loop     
          do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
             system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
          end do
          !$acc end loop
       end do
       !$acc end loop
       !$acc end parallel
    else

       if (algorithms%maze%calc_elec) then

          call setup_b(system, algorithms)
          if ((.not.algorithms%maze%constant_constr_grad).or.(.not.algorithms%maze%CG_nostore)) then
             call MW_maze_update_history(algorithms%maze) !Only updates gradient of constraints
          end if
          call MW_maze_compute_x0(algorithms%maze, system, 1.0_wp,&
               system%q_atoms(:, q_atoms_tmdt), system%q_atoms(:, q_atoms_t), system%q_atoms(:, q_atoms_tpdt))
          if (algorithms%maze%invert) then
             call MW_maze_solve_invert(algorithms%maze, system, &
                  compute_hessian, SMatrix_vector_product_elec, system%q_atoms(:, q_atoms_tpdt))
          else if (algorithms%maze%shake) then
             call MW_maze_solve_shake(algorithms%maze, system, &
                  compute_hessian, system%q_atoms(:, q_atoms_tpdt))
          else if (algorithms%maze%block_iterate) then
             call MW_maze_solve_block_iterate(algorithms%maze, system, &
                  compute_hessian, system%q_atoms(:, q_atoms_tpdt))
          else if (algorithms%maze%CG_store_prec.or.algorithms%maze%CG_store_noprec) then
             call MW_maze_solve_CG_store(algorithms%maze, system, &
                  compute_hessian, SMatrix_vector_product_elec, &
                  vector_vector_inner_product_elec, system%q_atoms(:, q_atoms_tpdt))
          else if (algorithms%maze%CG_nostore) then
             call MW_maze_solve_CG_nostore(algorithms%maze, system, &
                  apply_A, vector_vector_inner_product_elec, system%q_atoms(:, q_atoms_tpdt))
          end if
       else if (algorithms%matrix_inversion%calc_elec) then

          call setup_b(system, algorithms)
          call MW_matrix_inversion_solve(algorithms%matrix_inversion, system, compute_hessian, SMatrix_vector_product_elec,&
               system%q_atoms(:, q_atoms_tpdt))

       else

          if (system%electrode_use_predictor) then
             call predictor(system%q_atoms_step, system%electrodes, system%q_atoms)
          else
             ! Initialize with previous step value
             do itype = 1, system%num_elec
                do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                   system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_t)
                end do
             end do
          end if

          ! Enforce charge neutrality constraint on initial vector
          if (system%electrode_charge_neutrality) then
             !$acc kernels     
             total_charges = sum(system%q_atoms(:, q_atoms_tpdt))
             !$acc end kernels     
             average_charges = total_charges / real(system%num_atoms,wp)
             if (system%global_charge_neutrality) then
                average_charges = average_charges + system%total_ions_charge / real(system%num_atoms,wp)
             end if
             do itype = 1, system%num_elec
                do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                   system%q_atoms(i, q_atoms_tpdt) = system%q_atoms(i, q_atoms_tpdt) - average_charges
                end do
             end do
          end if

          call setup_b(system, algorithms)
          ! call MW_cg_solve(algorithms%cg, system, apply_A, system%q_atoms(:, q_atoms_tpdt))
          call MW_cg_solve_preconditioned(algorithms%cg, system, apply_A, system%q_atoms(:, q_atoms_tpdt))

          ! compute \ki = V_i - \frac{\partial U_{es}}{\partial q_i}
          ! cg%b stores V_i - \frac{\partial U_{es}}{\partial q_i} for melt->elec interactions
          ! apply_A(system, system%q_atoms(:, q_atoms_now), cg%Ad) computes \frac{\partial U_{es}}{\partial q_i} for elec<->elec interactions
          ! ki(:) is stored in cg%Ad(:)
          if (system%electrode_charge_neutrality) then
             call apply_A(system, system%q_atoms(:, q_atoms_tpdt), algorithms%cg%Ad)
             system%chi(q_atoms_tpdt) = 0.0_wp
             do itype = 1, system%num_elec
                do i = system%electrodes(itype)%offset+1, system%electrodes(itype)%offset + system%electrodes(itype)%count
                   system%chi(q_atoms_tpdt) = system%chi(q_atoms_tpdt) + algorithms%cg%b(i) - algorithms%cg%Ad(i)
                end do
             end do
             system%chi(q_atoms_tpdt) = system%chi(q_atoms_tpdt) / real(system%num_atoms,wp)
          end if
       end if
    end if

    ! update the contribution of the electrode to the polarization
    call MW_external_field_elec_polarization(system%box, system%electrodes(:), system%xyz_atoms(:,:), &
          system%q_atoms(:, q_atoms_tpdt), system%polarization_field(:,:))

   !$acc update self(system%q_atoms(:, q_atoms_tpdt))
   !$acc end data

  end subroutine compute

  ! ================================================================================
  !> Predictor for wall atoms charges
  subroutine predictor(q_atoms_step, electrodes, q_atoms)
    implicit none
    ! Parameters
    ! ----------
    integer, intent(in) :: q_atoms_step(:)  !< time step index
    type(MW_electrode_t), intent(in) :: electrodes(:) !< electrode parameters
    real(wp), intent(inout) :: q_atoms(:,:) !< atom charges

    ! Local
    ! -----
    integer :: q_now, q_m1, q_m2, q_m3, q_m4, q_m5, q_m6
    integer :: num_atom_types
    integer :: itype, i

    real(wp), parameter :: B1 =  22.0_wp /  7.0_wp
    real(wp), parameter :: B2 = -55.0_wp / 14.0_wp
    real(wp), parameter :: B3 =  55.0_wp / 21.0_wp
    real(wp), parameter :: B4 = -22.0_wp / 21.0_wp
    real(wp), parameter :: B5 =   5.0_wp / 21.0_wp
    real(wp), parameter :: B6 =  -1.0_wp / 42.0_wp

    num_atom_types = size(electrodes,1)

    q_now = q_atoms_step(1)
    q_m1 = q_atoms_step(2)
    q_m2 = q_atoms_step(3)
    q_m3 = q_atoms_step(4)
    q_m4 = q_atoms_step(5)
    q_m5 = q_atoms_step(6)
    q_m6 = q_atoms_step(7)

    do itype = 1, num_atom_types
       do i = electrodes(itype)%offset+1, electrodes(itype)%offset + electrodes(itype)%count
          q_atoms(i, q_now) = B1 * q_atoms(i, q_m1) + B2 * q_atoms(i, q_m2) + B3 * q_atoms(i, q_m3) &
               + B4 * q_atoms(i, q_m4) + B5 * q_atoms(i, q_m5) + B6 * q_atoms(i, q_m6)
       end do
    end do

  end subroutine predictor

  ! ================================================================================
  include 'update_diag_block_boundaries.inc'
  include 'update_tri_block_boundaries.inc'
  include 'update_other_block_boundaries.inc'

end module MW_electrode_charge

module MW_version

   implicit none
   private

   public :: MW_version_print

contains

   !===============================================================================
   ! Print code version number and compilation info to ounit
   subroutine MW_version_print(ounit)
#ifndef MW_SERIAL
      use MPI
#endif
      implicit none

      integer, intent(in) :: ounit                ! output unit

      integer :: comp_major, comp_minor, comp_patch

#include "version_git_info.inc"

      ! Compiler information
#if defined(__GFORTRAN__)
      comp_major    = __GNUC__
      comp_minor    = __GNUC_MINOR__
      comp_patch    = __GNUC_PATCHLEVEL__
      write(ounit, '("Compiled with GNU Fortran ",i1,".",i1,".",i1," on ",a12," at ",a10)') &
            __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__,                                       &
            __DATE__, __TIME__

#elif defined(__INTEL_COMPILER)
      comp_major    = __INTEL_COMPILER / 100
      comp_minor    = (__INTEL_COMPILER - 100 * comp_major) / 10
      comp_patch    = __INTEL_COMPILER - 100 * comp_major - 10 * comp_minor
      write(ounit, '("Compiled with Intel Fortran ",i2,".",i2,".",i2," on ",a12," at ",a10)') &
            comp_major, comp_minor, comp_patch,                                                     &
            __DATE__, __TIME__
#elif defined(__PGI)
      write(ounit, '("Compiled with PGI Fortran compiler on ",a12," at ",a10)') &
            __DATE__, __TIME__
#else
      write(ounit, '("Compiled with ?????? on ",a12," at ",a10)') &
            __DATE__, __TIME__
#endif
#ifndef MW_SERIAL
      write(ounit, '("MPI library version ",i1,".",i1)') MPI_VERSION, MPI_SUBVERSION
#endif

#include "version_compilation_flags.inc"
#include "version_module_list.inc"

   end subroutine MW_version_print

end module MW_version

#!/bin/bash

# temps CPU a ajuster au calcul
#PBS -l walltime=48:00:00
# memoire a ajuster au calcul
##PBS -l vmem=1gb
# nb procs a ajuster au calcul, voir OMP_NUM_THREADS plus bas
#PBS -l nodes=1:ppn=44
# a changer, nom du job (qstat)
#PBS -N   tfsi_1V_298
#Request that regular output and terminal output go to the same file
#PBS -j oe
#  Request that your login shell variables be available to the job
#PBS -V

# Load the good modules
module load Libraries/impi/2019 Libraries/mkl/2019 Core/Intel/2019

export OMPI_MCA_btl_base_warn_component_unused=0
#export OMPI_MCA_rmaps_base_oversubscribe=1

# Pour savoir sur quel noeud on est
echo "Job lance sur: $HOSTNAME"
echo "StartDir : $PBS_O_WORKDIR"
#echo "(sinon par defaut ceut ete $HOMEDIR)"

# A changer, Startdir = ou sont les fichiers, par defaut HOMEDIR
StartDir=$PBS_O_WORKDIR

# Ne pas modifier, SCRATCHDIR = espace temporaire (local au noeud et a vider apres le calcul)
#SCRATCHDIR=/scratch/$USER/$PBS_JOBID

# Copy everything from submission directory here
SCRATCHDIR=/scratch/$USER/$PBS_JOBID
/bin/mkdir $SCRATCHDIR
/bin/cp -rf $StartDir/* $SCRATCHDIR
cd $SCRATCHDIR

ulimit -s unlimited
date
mpirun /home/bacon/mw_binary/mw_master_27-05-20
date

/bin/cp -r $SCRATCHDIR/* $StartDir
/bin/rm -rf $SCRATCHDIR
exit

#! /usr/local/bin/bash
# Sed script to efficiently swap indices order for cos/sin arrays
# It can be useful to test the efficiency of some data layout against another one
SRC_DIR=../src/
TEST_DIR=${SRC_DIR}/tests/

ARRAYS="cossin_kx_ions cossin_ky_ions cossin_kz_ions cossin_kx_elec cossin_ky_elec cossin_kz_elec"
SRC_FILES="coulomb.f90 ewald.f90"
TEST_FILES="test_ewald.f90"

for f in ${SRC_FILES}
do
    cp ${SRC_DIR}/${f} tmp1
    for a in ${ARRAYS}
    do
        sed "s/${a}(\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\)/${a}(\2,\3,\1/g" < tmp1 > tmp2
        mv tmp2 tmp1
    done
    mv tmp1 ${f}
done

for f in ${TEST_FILES}
do
    cp ${TEST_DIR}/${f} tmp1
    for a in ${ARRAYS}
    do
        sed "s/${a}(\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][:%0-9a-zA-Z_]*\)/${a}(\2,\3,\1/g" < tmp1 > tmp2
        mv tmp2 tmp1
    done
    mv tmp1 ${f}
done

CWD=$PWD
ref_dir=/ccc/work/cont003/mds/haefemat/runs/blue-energy/prod/2018-12-12/tuning_loop_block_size/template

#for BLOCK in 8 16 32 64 128
for BLOCK in 128 256 512 1024 2048 4096 8192
do
  echo "Treating Block $BLOCK"
  mkdir block$BLOCK
  cd block$BLOCK
  export BLOCK
  for NODE in 1 2
  do
    mkdir node$NODE
    cd node$NODE
    ln $ref_dir/runtime.inpt .
    ln $ref_dir/data.inpt .
    export NODE
    TASK=$(( NODE * 48 )) envsubst < $ref_dir/job.template > job
    ccc_msub job > job_id
    cd ..
  done
  cd ..
done

module purge
# Loading python loads also the correct intel compiler and MPI lib
module load python3/3.7.2
module load lapack
module load plumed

# f90wrap has to be installed and the bin dir that contains it has to be added to the PATH env variable
export PATH=$PATH:$HOME/.local/bin

# This imposes to issue the source command from mw2 directory: 
# cd path/to/mw2
# source computer/irene/set_env.sh
export PYTHONPATH=$PYTHONPATH:$PWD/build/python

#! /usr/local/bin/bash
# Sed script to efficiently swap indices order for some vectors
# It can be useful to test the efficiency of some data layout against another one
SRC_DIR=../src
#TEST_DIR=${SRC_DIR}/tests/

# Swap index of dimensions with index of particle
ARRAYS="xyz_elec xyz_ions force velocity_ions forces_ions xyz_now xyz_next velocity_next forces forces_ref xyz_atoms"
#ARRAYS="xyz_atoms"
#SRC_FILES="coulomb.f90 lennard_jones.f90 system.f90 ewald.f90 rattle.f90"
#TEST_FILES="test_rattle.f90 test_coulomb.f90 test_ewald.f90"
for f in ${SRC_DIR}/*
do
    cp ${SRC_DIR}/${f} tmp1
    for a in ${ARRAYS}
    do
        sed -e "s/${a}(\([:0-9a-zA-Z_][%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][%0-9a-zA-Z_]*\)/${a}(\2,\1/g" \
            -e "s/size(${a},1)/size(${a},2)/g" \
            -e "s/size(${a},2)/size(${a},1)/g" \
            < tmp1 > tmp2
        mv tmp2 tmp1
    done
    mv tmp1 ${f}
done

# for f in ${TEST_FILES}
# do
#     cp ${TEST_DIR}/${f} tmp1
#     for a in ${ARRAYS}
#     do
#         sed "s/${a}(\([:0-9a-zA-Z_][%0-9a-zA-Z_]*\),\([:0-9a-zA-Z_][%0-9a-zA-Z_]*\)/${a}(\2,\1/g" < tmp1 > tmp2
#         mv tmp2 tmp1
#     done
#     mv tmp1 ${f}
# done

if [ $# -ne 1 ] 
then
   echo 'Specify desired environment: gnu, intel2018 or intel2019'
elif [ $1 = 'gnu' ]
then
   # Gnu
   module load Core/Gnu/6.3.0 Libraries/openmpi/2.1.2/Intel/2018-x86_64 Libraries/lapack/lapack-3.8.0/Gnu/6.3.0-x86_64
elif [ $1 = 'intel2018' ]
then
   # Intel 2018 + Plumed
   module load Core/Intel/2018 Core/Gnu/6.3.0 Libraries/impi/2018 Libraries/mkl/2018 Libraries/plumed/Intel/2.5.1/2018
elif [ $1 = 'intel2019' ]
then
   # Intel 2019 + Plumed + Python
   module load Core/Intel/2019 Core/Gnu/6.3.0 Libraries/impi/2019 Libraries/mkl/2019 Libraries/plumed/Intel/2.5.1/2019 Libraries/IntelPython/2019
else
   echo "Error: $1 environment not recognized, please specify the desired environment: gnu, intel2018 or intel2019"
fi

export OMPI_MCA_btl_base_warn_component_unused=0

CWD=$PWD


for BLOCK in 128 256 512 1024 2048 4096 8192
do
  cd block$BLOCK
  echo "Treating dir block$BLOCK"
  echo "#Node   Time(s)" > res.out
  for NODE in 1 2 
  do
    t=`cat node$NODE/run.out | grep "Total elapsed time:" | tr -s " " | cut -d ' ' -f 4`
    echo $NODE $t >> res.out
  done
  python ~/dev/mw2/scripts/platform_eval/compute_scalability.py
  cat scaling
  cd ..
done

# Ad hoc modifications
# Rename subroutines that have the same name in different modules
# Rename short_bn and long_bn to short and long for command otherwise the names do not correspond to the .o files... not sure why this happens
for module in `ls -1 src/*f90 src/*F90 | sed -e 's/\.f90//' | sed -e 's/\.F90//' | sed -e 's/src\///'`
do
   echo "Modifying module $module"
   sed -i -e "s/subroutine f90wrap_void_type/subroutine f90wrap_${module}_void_type/g" f90wrap_${module}.f90 
   sed -i -e "s/subroutine f90wrap_define_type/subroutine f90wrap_${module}_define_type/g" f90wrap_${module}.f90       
   sed -i -e "s/subroutine f90wrap_copy_type/subroutine f90wrap_${module}_copy_type/g" f90wrap_${module}.f90           
   sed -i -e "s/subroutine f90wrap_print_type/subroutine f90wrap_${module}_print_type/g" f90wrap_${module}.f90         
   sed -i -e "s/subroutine f90wrap_initialize/subroutine f90wrap_${module}_initialize/g" f90wrap_${module}.f90         
   sed -i -e "s/subroutine f90wrap_compute/subroutine f90wrap_${module}_compute/g" f90wrap_${module}.f90         
   sed -i -e "s/subroutine f90wrap_finalize/subroutine f90wrap_${module}_finalize/g" f90wrap_${module}.f90             
   sed -i -e "s/subroutine f90wrap_set_rcut/subroutine f90wrap_${module}_set_rcut/g" f90wrap_${module}.f90             
   sed -i -e "s/subroutine f90wrap_set_parameters/subroutine f90wrap_${module}_set_parameters/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_force_neutral/subroutine f90wrap_${module}_set_force_neutral/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_max_iterations/subroutine f90wrap_${module}_set_max_iterations/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_tolerance/subroutine f90wrap_${module}_set_tolerance/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_setup_history/subroutine f90wrap_${module}_setup_history/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_update_history/subroutine f90wrap_${module}_update_history/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_print_statistics/subroutine f90wrap_${module}_print_statistics/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_reset_statistics/subroutine f90wrap_${module}_reset_statistics/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_allocate_arrays/subroutine f90wrap_${module}_allocate_arrays/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_energy/subroutine f90wrap_${module}_energy/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_index/subroutine f90wrap_${module}_set_index/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_read_parameters/subroutine f90wrap_${module}_read_parameters/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_write_matrix/subroutine f90wrap_${module}_set_write_matrix/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_set_charge_neutrality/subroutine f90wrap_${module}_set_charge_neutrality/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_mixing_rule/subroutine f90wrap_${module}_mixing_rule/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_allocate_velocity_work_array/subroutine f90wrap_${module}_allocate_velocity_work_array/g" f90wrap_${module}.f90
   sed -i -e "s/subroutine f90wrap_setup_masses/subroutine f90wrap_${module}_setup_masses/g" f90wrap_${module}.f90
#   sed -i -e "s/short_bn/short/g" f90wrap_${module}.f90
#   sed -i -e "s/short_bn/short/g" metalwalls.py
#   sed -i -e "s/long_bn/long/g" f90wrap_${module}.f90
#   sed -i -e "s/long_bn/long/g" metalwalls.py
#   sed -i -e "s/rank_bn/rank/g" f90wrap_${module}.f90
#   sed -i -e "s/rank_bn/rank/g" metalwalls.py
#   sed -i -e "s/size_bn/size/g" f90wrap_${module}.f90
#   sed -i -e "s/size_bn/size/g" metalwalls.py
   sed -i -e "s/character(1024), intent(in), dimension(n0) :: species_names/character(8), intent(in), dimension(n0) :: species_names/g" f90wrap_${module}.f90
   sed -i -e "s/character(1024), intent(in), dimension(n0) :: names/character(8), intent(in), dimension(n0) :: names/g" f90wrap_${module}.f90
   sed -i -e "s/character(1024), intent(in), dimension(n0) :: energies_to_dump/character(128), intent(in), dimension(n0) :: energies_to_dump/g" f90wrap_${module}.f90
   class=`echo -e $module | sed -r "s/_/ /g;s/\<./\U&/g;s/ /_/g"` 
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_void_type/_metalwalls.f90wrap_${module}_void_type/" metalwalls.py           
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_define_type/_metalwalls.f90wrap_${module}_define_type/" metalwalls.py       
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_copy_type/_metalwalls.f90wrap_${module}_copy_type/" metalwalls.py           
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_print_type/_metalwalls.f90wrap_${module}_print_type/" metalwalls.py         
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_initialize/_metalwalls.f90wrap_${module}_initialize/" metalwalls.py         
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_compute/_metalwalls.f90wrap_${module}_compute/" metalwalls.py         
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_finalize/_metalwalls.f90wrap_${module}_finalize/" metalwalls.py             
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_rcut/_metalwalls.f90wrap_${module}_set_rcut/" metalwalls.py             
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_parameters/_metalwalls.f90wrap_${module}_set_parameters/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_force_neutral/_metalwalls.f90wrap_${module}_set_force_neutral/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_max_iterations/_metalwalls.f90wrap_${module}_set_max_iterations/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_tolerance/_metalwalls.f90wrap_${module}_set_tolerance/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_setup_history/_metalwalls.f90wrap_${module}_setup_history/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_update_history/_metalwalls.f90wrap_${module}_update_history/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_print_statistics/_metalwalls.f90wrap_${module}_print_statistics/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_reset_statistics/_metalwalls.f90wrap_${module}_reset_statistics/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_allocate_arrays/_metalwalls.f90wrap_${module}_allocate_arrays/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_energy/_metalwalls.f90wrap_${module}_energy/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_index/_metalwalls.f90wrap_${module}_set_index/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_read_parameters/_metalwalls.f90wrap_${module}_read_parameters/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_write_matrix/_metalwalls.f90wrap_${module}_set_write_matrix/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_set_charge_neutrality/_metalwalls.f90wrap_${module}_set_charge_neutrality/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_mixing_rule/_metalwalls.f90wrap_${module}_mixing_rule/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_allocate_velocity_work_array/_metalwalls.f90wrap_${module}_allocate_velocity_work_array/" metalwalls.py
   sed -i -e "/^class Mw_${class}(/,/^mw_${module} = Mw_${class}()/ s/_metalwalls.f90wrap_setup_masses/_metalwalls.f90wrap_${module}_setup_masses/" metalwalls.py
done
# Specific corrections due to preprocessing 
#sed -i '0,/end subroutine f90wrap_mw_constants__get__cache_line_size/! {/f90wrap_mw_constants__get__cache_line_size/,/f90wrap_mw_constants__get__cache_line_size/d}' f90wrap_constants.f90
#sed -i '0,/end subroutine f90wrap_mw_constants__get__pair_block_size/! {/f90wrap_mw_constants__get__pair_block_size/,/f90wrap_mw_constants__get__pair_block_size/d}' f90wrap_constants.f90
#sed -i '0,/end subroutine f90wrap_mw_constants__get__block_vector_size/! {/f90wrap_mw_constants__get__block_vector_size/,/f90wrap_mw_constants__get__block_vector_size/d}' f90wrap_constants.f90
#sed -i '0,/subroutine \&/! s/subroutine \&//' f90wrap_constants.f90
# Modify f90wrap_kinds.f90 because of preprocessor flags
#sed -i '/f90wrap_kinds_inquire_real16(/i #ifdef MW_use_real16' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_real16$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_qd(/i #ifdef MW_use_real16' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_qd$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_real10(/i #ifdef MW_use_real10' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_real10$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_ep(/i #ifdef MW_use_real10' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_ep$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_int16(/i #ifdef MW_use_INT16' f90wrap_kinds.f90
#sed -i '/f90wrap_kinds_inquire_int16$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__real16(/i #ifdef MW_use_real16' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__real16$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__qd(/i #ifdef MW_use_real16' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__qd$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__real10(/i #ifdef MW_use_real10' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__real10$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__ep(/i #ifdef MW_use_real10' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__ep$/a #endif' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__int16(/i #ifdef MW_use_INT16' f90wrap_kinds.f90
#sed -i '/f90wrap_mw_kinds__get__int16$/a #endif' f90wrap_kinds.f90

#/bin/bash
# Generate fortran statements to write the output of the git information

echo '! Automatically generated file with output from git commands output' > ${1}
echo 'write(ounit,'"'"'("MetalWalls release ",a)'"'"') "'${2}'"' >> ${1}
echo 'write(ounit, *)' >> ${1}

#/bin/bash
# Generate fortran statements to write the output of the module list command
# The --terse option to module command make appear each module name on its own line
OLD_IFS=${IFS}

echo "! Automatically generated file with script gen_module_list.sh" > ${1}

# Check wether module command is available
if [ $(command -v module) ]
then

    # Test whether we should use "module --terse list" or "module list --terse"
    module --terse list &> /dev/null
    if [ $? -eq 0 ]
    then
	module_option="--terse list"
    else
	module list --terse &> /dev/null
	if [ $? -eq 0 ]
	then
	    module_option="list --terse"
	else
	    module_option="list"
	fi
    fi

    echo "module option = ${module_option}"
    echo "! output from \`module ${module_option}\`" > ${1}
    echo 'write(ounit, *)' >> ${1}
    module ${module_option} &> module.list.tmp
    #module list --terse &> module.list.tmp
    IFS=$'\n'
    for line in $(cat module.list.tmp)
    do
        echo 'write(ounit, '"'"'(a)'"'"') "'${line}'"' >> ${1}
    done
    rm module.list.tmp
else
    echo 'write(ounit, *)' >> ${1}
    echo 'write(ounit, *) "module command is not available"' >> ${1}
fi
IFS=${OLD_IFS}

#!/bin/bash
#PBS -q alpha
#PBS -l select=1:ncpus=32
#PBS -l walltime=0:10:00
#PBS -N your_job_name
#PBS -j oe

# load modules
module purge
module load intel/intel-compilers-18.2/18.2
module load intel/intel-cmkl-18.2/18.2
module load intel/intel-mpi/2018.2

#move to PBS_O_WORKDIR
cd "$PBS_O_WORKDIR"
echo `pwd`

# Define scratch space scratchalpha
SCRATCH="/scratchalpha/$USER/job-$PBS_JOBID"
rm -rf "$SCRATCH"
mkdir "$SCRATCH"
cd "$SCRATCH"
echo `pwd`

# Copy some input files to $SCRATCH directory
cp "$PBS_O_WORKDIR"/your_input .
 
# Execute your program
mpirun -n 32 /path/to/mw/executable

# Move to PBS_O_WORKDIR and copy output
cd "$PBS_O_WORKDIR"
cp "$SCRATCH"/your_output  .
rm -rf "$SCRATCH"

exit 0

# Git essential command lines #

## Getting some help ##

`git help <verb>` get the manpage help for the `git <verb>` command.

## Customize your Git environment ##

Use `git config` to customize your Git environment.

### Set up your identity ###

git config --global user.name = "John Doe"
git config --global user.email = "johndoe@example.com"

### Set up your editor ###

git config --global core.editor vi
git config --global core.pager less

## Checking status ##

`git status`    gives output to determine which files are in which states
`git status -s` gives a simplified git status output

`git diff`          shows diff log between local and staged area
`git diff --staged` shows diff log between staged area and last commit

`git log`                                 lists the commits in reverse chronological order (most
     					  recent first)
`git log -p -2`                           lists the last 2 commits with diff following each entry
`git log --stat`                          lists the commits with statistics (list of modified files,
                                          number of lines added/removed in those files) following
					  each entry.
`git log --pretty=format:"%h %s" --graph` lists commits history with abbreviated commit hash (%h)
                                          and commit subject (%s) on one line with a nice little
					  ASCII graph showing branch and merge history

## Committing changes ##

`git commit`                       launches editor to fill commit messages (empty message will abort
                                   commit)
`git commit -m "commit message"`   commits with in-line commit message
`git commit -a`                    add all tracked and modified files to the commit, skipping
                                   staging step
`git commit --amend`               amend previous commit (add newly staged file and modify commit message)

## Removing files ##

`git rm FILE`          stops tracking FILE and removes it from the working tree
`git rm --cached FILE` stops tracking FILE but keeps it in the working tree

# Working with remotes #

`git remote -v` shows remotes shortnames and addresses
`git remote show <name>` shows more information about remote <name>
`git remote add <name> <url>` adds a remote named <name> for the repository at <url>
`git remote rename <oldname> <newname>` rename a remote named <oldname> to <newname>
`git remote remove <name>` removes a remote named <name>

`git fetch <name>` Fetch branches and/or tags from the remote repository named <name>
`git push <repository> <refspec>` Updates remote refs using local refs
